/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 38 "./bvl_bcomp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "abl.h"
#include "bdd.h"
#include "abe.h"

#include "bvl_utype.h"
#include "bvl_util.h"
#include "bvl_byacc.h"
#include "bvl_bedef.h"
#include "bvl_bspec.h"

extern  int   yylex     ( );
extern  void  yyerror   ( );


#line 92 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    tok_AND = 258,                 /* tok_AND  */
    PRAGMA = 259,                  /* PRAGMA  */
    _BEGIN = 260,                  /* _BEGIN  */
    _END = 261,                    /* _END  */
    _EQSym = 262,                  /* _EQSym  */
    _EXIT = 263,                   /* _EXIT  */
    _FILE = 264,                   /* _FILE  */
    _GESym = 265,                  /* _GESym  */
    _GTSym = 266,                  /* _GTSym  */
    _IN = 267,                     /* _IN  */
    _INOUT = 268,                  /* _INOUT  */
    _LABEL = 269,                  /* _LABEL  */
    _LESym = 270,                  /* _LESym  */
    _LINKAGE = 271,                /* _LINKAGE  */
    _LTSym = 272,                  /* _LTSym  */
    _NAND = 273,                   /* _NAND  */
    _NESym = 274,                  /* _NESym  */
    _NEXT = 275,                   /* _NEXT  */
    _NOR = 276,                    /* _NOR  */
    _NOT = 277,                    /* _NOT  */
    tok_NULL = 278,                /* tok_NULL  */
    _OR = 279,                     /* _OR  */
    _OUT = 280,                    /* _OUT  */
    _XOR = 281,                    /* _XOR  */
    ABS = 282,                     /* ABS  */
    ACCESS = 283,                  /* ACCESS  */
    AFTER = 284,                   /* AFTER  */
    ALIAS = 285,                   /* ALIAS  */
    ALL = 286,                     /* ALL  */
    ARCHITECTURE = 287,            /* ARCHITECTURE  */
    ARRAY = 288,                   /* ARRAY  */
    ASSERT = 289,                  /* ASSERT  */
    ATTRIBUTE = 290,               /* ATTRIBUTE  */
    AbstractLit = 291,             /* AbstractLit  */
    Ampersand = 292,               /* Ampersand  */
    Apostrophe = 293,              /* Apostrophe  */
    Arrow = 294,                   /* Arrow  */
    BIT = 295,                     /* BIT  */
    BIT_VECTOR = 296,              /* BIT_VECTOR  */
    _BLOCK = 297,                  /* _BLOCK  */
    BODY = 298,                    /* BODY  */
    BUFFER = 299,                  /* BUFFER  */
    BUS = 300,                     /* BUS  */
    Bar = 301,                     /* Bar  */
    BasedInt = 302,                /* BasedInt  */
    BasedReal = 303,               /* BasedReal  */
    BitStringLit = 304,            /* BitStringLit  */
    Box = 305,                     /* Box  */
    CASE = 306,                    /* CASE  */
    COMPONENT = 307,               /* COMPONENT  */
    CONFIGURATION = 308,           /* CONFIGURATION  */
    CONSTANT = 309,                /* CONSTANT  */
    CharacterLit = 310,            /* CharacterLit  */
    Colon = 311,                   /* Colon  */
    Comma = 312,                   /* Comma  */
    DISCONNECT = 313,              /* DISCONNECT  */
    DOWNTO = 314,                  /* DOWNTO  */
    DecimalInt = 315,              /* DecimalInt  */
    DecimalReal = 316,             /* DecimalReal  */
    Dot = 317,                     /* Dot  */
    DoubleStar = 318,              /* DoubleStar  */
    ELSE = 319,                    /* ELSE  */
    ELSIF = 320,                   /* ELSIF  */
    ENTITY = 321,                  /* ENTITY  */
    ERROR = 322,                   /* ERROR  */
    FOR = 323,                     /* FOR  */
    FUNCTION = 324,                /* FUNCTION  */
    GENERATE = 325,                /* GENERATE  */
    GENERIC = 326,                 /* GENERIC  */
    GUARDED = 327,                 /* GUARDED  */
    IF = 328,                      /* IF  */
    IS = 329,                      /* IS  */
    Identifier = 330,              /* Identifier  */
    LIBRARY = 331,                 /* LIBRARY  */
    LOOP = 332,                    /* LOOP  */
    LeftParen = 333,               /* LeftParen  */
    MAP = 334,                     /* MAP  */
    MOD = 335,                     /* MOD  */
    MUX_BIT = 336,                 /* MUX_BIT  */
    MUX_VECTOR = 337,              /* MUX_VECTOR  */
    Minus = 338,                   /* Minus  */
    NATURAL = 339,                 /* NATURAL  */
    NATURAL_VECTOR = 340,          /* NATURAL_VECTOR  */
    NEW = 341,                     /* NEW  */
    OF = 342,                      /* OF  */
    ON = 343,                      /* ON  */
    OPEN = 344,                    /* OPEN  */
    OTHERS = 345,                  /* OTHERS  */
    _PACKAGE = 346,                /* _PACKAGE  */
    PORT = 347,                    /* PORT  */
    PROCEDURE = 348,               /* PROCEDURE  */
    PROCESS = 349,                 /* PROCESS  */
    Plus = 350,                    /* Plus  */
    _PS = 351,                     /* _PS  */
    _NS = 352,                     /* _NS  */
    _US = 353,                     /* _US  */
    _MS = 354,                     /* _MS  */
    RANGE = 355,                   /* RANGE  */
    RECORD = 356,                  /* RECORD  */
    REG_BIT = 357,                 /* REG_BIT  */
    REG_VECTOR = 358,              /* REG_VECTOR  */
    REGISTER = 359,                /* REGISTER  */
    REM = 360,                     /* REM  */
    REPORT = 361,                  /* REPORT  */
    RETURN = 362,                  /* RETURN  */
    RightParen = 363,              /* RightParen  */
    SELECT = 364,                  /* SELECT  */
    SEVERITY = 365,                /* SEVERITY  */
    SIGNAL = 366,                  /* SIGNAL  */
    _STABLE = 367,                 /* _STABLE  */
    SUBTYPE = 368,                 /* SUBTYPE  */
    Semicolon = 369,               /* Semicolon  */
    Slash = 370,                   /* Slash  */
    Star = 371,                    /* Star  */
    StringLit = 372,               /* StringLit  */
    THEN = 373,                    /* THEN  */
    TO = 374,                      /* TO  */
    TRANSPORT = 375,               /* TRANSPORT  */
    _TYPE = 376,                   /* _TYPE  */
    UNITS = 377,                   /* UNITS  */
    UNTIL = 378,                   /* UNTIL  */
    USE = 379,                     /* USE  */
    VARIABLE = 380,                /* VARIABLE  */
    VarAsgn = 381,                 /* VarAsgn  */
    WAIT = 382,                    /* WAIT  */
    WARNING = 383,                 /* WARNING  */
    WHEN = 384,                    /* WHEN  */
    WHILE = 385,                   /* WHILE  */
    WITH = 386,                    /* WITH  */
    WOR_BIT = 387,                 /* WOR_BIT  */
    WOR_VECTOR = 388               /* WOR_VECTOR  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define tok_AND 258
#define PRAGMA 259
#define _BEGIN 260
#define _END 261
#define _EQSym 262
#define _EXIT 263
#define _FILE 264
#define _GESym 265
#define _GTSym 266
#define _IN 267
#define _INOUT 268
#define _LABEL 269
#define _LESym 270
#define _LINKAGE 271
#define _LTSym 272
#define _NAND 273
#define _NESym 274
#define _NEXT 275
#define _NOR 276
#define _NOT 277
#define tok_NULL 278
#define _OR 279
#define _OUT 280
#define _XOR 281
#define ABS 282
#define ACCESS 283
#define AFTER 284
#define ALIAS 285
#define ALL 286
#define ARCHITECTURE 287
#define ARRAY 288
#define ASSERT 289
#define ATTRIBUTE 290
#define AbstractLit 291
#define Ampersand 292
#define Apostrophe 293
#define Arrow 294
#define BIT 295
#define BIT_VECTOR 296
#define _BLOCK 297
#define BODY 298
#define BUFFER 299
#define BUS 300
#define Bar 301
#define BasedInt 302
#define BasedReal 303
#define BitStringLit 304
#define Box 305
#define CASE 306
#define COMPONENT 307
#define CONFIGURATION 308
#define CONSTANT 309
#define CharacterLit 310
#define Colon 311
#define Comma 312
#define DISCONNECT 313
#define DOWNTO 314
#define DecimalInt 315
#define DecimalReal 316
#define Dot 317
#define DoubleStar 318
#define ELSE 319
#define ELSIF 320
#define ENTITY 321
#define ERROR 322
#define FOR 323
#define FUNCTION 324
#define GENERATE 325
#define GENERIC 326
#define GUARDED 327
#define IF 328
#define IS 329
#define Identifier 330
#define LIBRARY 331
#define LOOP 332
#define LeftParen 333
#define MAP 334
#define MOD 335
#define MUX_BIT 336
#define MUX_VECTOR 337
#define Minus 338
#define NATURAL 339
#define NATURAL_VECTOR 340
#define NEW 341
#define OF 342
#define ON 343
#define OPEN 344
#define OTHERS 345
#define _PACKAGE 346
#define PORT 347
#define PROCEDURE 348
#define PROCESS 349
#define Plus 350
#define _PS 351
#define _NS 352
#define _US 353
#define _MS 354
#define RANGE 355
#define RECORD 356
#define REG_BIT 357
#define REG_VECTOR 358
#define REGISTER 359
#define REM 360
#define REPORT 361
#define RETURN 362
#define RightParen 363
#define SELECT 364
#define SEVERITY 365
#define SIGNAL 366
#define _STABLE 367
#define SUBTYPE 368
#define Semicolon 369
#define Slash 370
#define Star 371
#define StringLit 372
#define THEN 373
#define TO 374
#define TRANSPORT 375
#define _TYPE 376
#define UNITS 377
#define UNTIL 378
#define USE 379
#define VARIABLE 380
#define VarAsgn 381
#define WAIT 382
#define WARNING 383
#define WHEN 384
#define WHILE 385
#define WITH 386
#define WOR_BIT 387
#define WOR_VECTOR 388

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 59 "./bvl_bcomp_y.y"

	long		 valu;
	char		*text;
        bvl_ablstr       list;
	bvl_name	 name;
        struct g_type dble;
	

#line 420 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tok_AND = 3,                    /* tok_AND  */
  YYSYMBOL_PRAGMA = 4,                     /* PRAGMA  */
  YYSYMBOL__BEGIN = 5,                     /* _BEGIN  */
  YYSYMBOL__END = 6,                       /* _END  */
  YYSYMBOL__EQSym = 7,                     /* _EQSym  */
  YYSYMBOL__EXIT = 8,                      /* _EXIT  */
  YYSYMBOL__FILE = 9,                      /* _FILE  */
  YYSYMBOL__GESym = 10,                    /* _GESym  */
  YYSYMBOL__GTSym = 11,                    /* _GTSym  */
  YYSYMBOL__IN = 12,                       /* _IN  */
  YYSYMBOL__INOUT = 13,                    /* _INOUT  */
  YYSYMBOL__LABEL = 14,                    /* _LABEL  */
  YYSYMBOL__LESym = 15,                    /* _LESym  */
  YYSYMBOL__LINKAGE = 16,                  /* _LINKAGE  */
  YYSYMBOL__LTSym = 17,                    /* _LTSym  */
  YYSYMBOL__NAND = 18,                     /* _NAND  */
  YYSYMBOL__NESym = 19,                    /* _NESym  */
  YYSYMBOL__NEXT = 20,                     /* _NEXT  */
  YYSYMBOL__NOR = 21,                      /* _NOR  */
  YYSYMBOL__NOT = 22,                      /* _NOT  */
  YYSYMBOL_tok_NULL = 23,                  /* tok_NULL  */
  YYSYMBOL__OR = 24,                       /* _OR  */
  YYSYMBOL__OUT = 25,                      /* _OUT  */
  YYSYMBOL__XOR = 26,                      /* _XOR  */
  YYSYMBOL_ABS = 27,                       /* ABS  */
  YYSYMBOL_ACCESS = 28,                    /* ACCESS  */
  YYSYMBOL_AFTER = 29,                     /* AFTER  */
  YYSYMBOL_ALIAS = 30,                     /* ALIAS  */
  YYSYMBOL_ALL = 31,                       /* ALL  */
  YYSYMBOL_ARCHITECTURE = 32,              /* ARCHITECTURE  */
  YYSYMBOL_ARRAY = 33,                     /* ARRAY  */
  YYSYMBOL_ASSERT = 34,                    /* ASSERT  */
  YYSYMBOL_ATTRIBUTE = 35,                 /* ATTRIBUTE  */
  YYSYMBOL_AbstractLit = 36,               /* AbstractLit  */
  YYSYMBOL_Ampersand = 37,                 /* Ampersand  */
  YYSYMBOL_Apostrophe = 38,                /* Apostrophe  */
  YYSYMBOL_Arrow = 39,                     /* Arrow  */
  YYSYMBOL_BIT = 40,                       /* BIT  */
  YYSYMBOL_BIT_VECTOR = 41,                /* BIT_VECTOR  */
  YYSYMBOL__BLOCK = 42,                    /* _BLOCK  */
  YYSYMBOL_BODY = 43,                      /* BODY  */
  YYSYMBOL_BUFFER = 44,                    /* BUFFER  */
  YYSYMBOL_BUS = 45,                       /* BUS  */
  YYSYMBOL_Bar = 46,                       /* Bar  */
  YYSYMBOL_BasedInt = 47,                  /* BasedInt  */
  YYSYMBOL_BasedReal = 48,                 /* BasedReal  */
  YYSYMBOL_BitStringLit = 49,              /* BitStringLit  */
  YYSYMBOL_Box = 50,                       /* Box  */
  YYSYMBOL_CASE = 51,                      /* CASE  */
  YYSYMBOL_COMPONENT = 52,                 /* COMPONENT  */
  YYSYMBOL_CONFIGURATION = 53,             /* CONFIGURATION  */
  YYSYMBOL_CONSTANT = 54,                  /* CONSTANT  */
  YYSYMBOL_CharacterLit = 55,              /* CharacterLit  */
  YYSYMBOL_Colon = 56,                     /* Colon  */
  YYSYMBOL_Comma = 57,                     /* Comma  */
  YYSYMBOL_DISCONNECT = 58,                /* DISCONNECT  */
  YYSYMBOL_DOWNTO = 59,                    /* DOWNTO  */
  YYSYMBOL_DecimalInt = 60,                /* DecimalInt  */
  YYSYMBOL_DecimalReal = 61,               /* DecimalReal  */
  YYSYMBOL_Dot = 62,                       /* Dot  */
  YYSYMBOL_DoubleStar = 63,                /* DoubleStar  */
  YYSYMBOL_ELSE = 64,                      /* ELSE  */
  YYSYMBOL_ELSIF = 65,                     /* ELSIF  */
  YYSYMBOL_ENTITY = 66,                    /* ENTITY  */
  YYSYMBOL_ERROR = 67,                     /* ERROR  */
  YYSYMBOL_FOR = 68,                       /* FOR  */
  YYSYMBOL_FUNCTION = 69,                  /* FUNCTION  */
  YYSYMBOL_GENERATE = 70,                  /* GENERATE  */
  YYSYMBOL_GENERIC = 71,                   /* GENERIC  */
  YYSYMBOL_GUARDED = 72,                   /* GUARDED  */
  YYSYMBOL_IF = 73,                        /* IF  */
  YYSYMBOL_IS = 74,                        /* IS  */
  YYSYMBOL_Identifier = 75,                /* Identifier  */
  YYSYMBOL_LIBRARY = 76,                   /* LIBRARY  */
  YYSYMBOL_LOOP = 77,                      /* LOOP  */
  YYSYMBOL_LeftParen = 78,                 /* LeftParen  */
  YYSYMBOL_MAP = 79,                       /* MAP  */
  YYSYMBOL_MOD = 80,                       /* MOD  */
  YYSYMBOL_MUX_BIT = 81,                   /* MUX_BIT  */
  YYSYMBOL_MUX_VECTOR = 82,                /* MUX_VECTOR  */
  YYSYMBOL_Minus = 83,                     /* Minus  */
  YYSYMBOL_NATURAL = 84,                   /* NATURAL  */
  YYSYMBOL_NATURAL_VECTOR = 85,            /* NATURAL_VECTOR  */
  YYSYMBOL_NEW = 86,                       /* NEW  */
  YYSYMBOL_OF = 87,                        /* OF  */
  YYSYMBOL_ON = 88,                        /* ON  */
  YYSYMBOL_OPEN = 89,                      /* OPEN  */
  YYSYMBOL_OTHERS = 90,                    /* OTHERS  */
  YYSYMBOL__PACKAGE = 91,                  /* _PACKAGE  */
  YYSYMBOL_PORT = 92,                      /* PORT  */
  YYSYMBOL_PROCEDURE = 93,                 /* PROCEDURE  */
  YYSYMBOL_PROCESS = 94,                   /* PROCESS  */
  YYSYMBOL_Plus = 95,                      /* Plus  */
  YYSYMBOL__PS = 96,                       /* _PS  */
  YYSYMBOL__NS = 97,                       /* _NS  */
  YYSYMBOL__US = 98,                       /* _US  */
  YYSYMBOL__MS = 99,                       /* _MS  */
  YYSYMBOL_RANGE = 100,                    /* RANGE  */
  YYSYMBOL_RECORD = 101,                   /* RECORD  */
  YYSYMBOL_REG_BIT = 102,                  /* REG_BIT  */
  YYSYMBOL_REG_VECTOR = 103,               /* REG_VECTOR  */
  YYSYMBOL_REGISTER = 104,                 /* REGISTER  */
  YYSYMBOL_REM = 105,                      /* REM  */
  YYSYMBOL_REPORT = 106,                   /* REPORT  */
  YYSYMBOL_RETURN = 107,                   /* RETURN  */
  YYSYMBOL_RightParen = 108,               /* RightParen  */
  YYSYMBOL_SELECT = 109,                   /* SELECT  */
  YYSYMBOL_SEVERITY = 110,                 /* SEVERITY  */
  YYSYMBOL_SIGNAL = 111,                   /* SIGNAL  */
  YYSYMBOL__STABLE = 112,                  /* _STABLE  */
  YYSYMBOL_SUBTYPE = 113,                  /* SUBTYPE  */
  YYSYMBOL_Semicolon = 114,                /* Semicolon  */
  YYSYMBOL_Slash = 115,                    /* Slash  */
  YYSYMBOL_Star = 116,                     /* Star  */
  YYSYMBOL_StringLit = 117,                /* StringLit  */
  YYSYMBOL_THEN = 118,                     /* THEN  */
  YYSYMBOL_TO = 119,                       /* TO  */
  YYSYMBOL_TRANSPORT = 120,                /* TRANSPORT  */
  YYSYMBOL__TYPE = 121,                    /* _TYPE  */
  YYSYMBOL_UNITS = 122,                    /* UNITS  */
  YYSYMBOL_UNTIL = 123,                    /* UNTIL  */
  YYSYMBOL_USE = 124,                      /* USE  */
  YYSYMBOL_VARIABLE = 125,                 /* VARIABLE  */
  YYSYMBOL_VarAsgn = 126,                  /* VarAsgn  */
  YYSYMBOL_WAIT = 127,                     /* WAIT  */
  YYSYMBOL_WARNING = 128,                  /* WARNING  */
  YYSYMBOL_WHEN = 129,                     /* WHEN  */
  YYSYMBOL_WHILE = 130,                    /* WHILE  */
  YYSYMBOL_WITH = 131,                     /* WITH  */
  YYSYMBOL_WOR_BIT = 132,                  /* WOR_BIT  */
  YYSYMBOL_WOR_VECTOR = 133,               /* WOR_VECTOR  */
  YYSYMBOL_YYACCEPT = 134,                 /* $accept  */
  YYSYMBOL_design_file = 135,              /* design_file  */
  YYSYMBOL_136_1 = 136,                    /* $@1  */
  YYSYMBOL_entity_declaration = 137,       /* entity_declaration  */
  YYSYMBOL_138_2 = 138,                    /* $@2  */
  YYSYMBOL_139_generic_clause_ = 139,      /* .generic_clause.  */
  YYSYMBOL_generic_clause = 140,           /* generic_clause  */
  YYSYMBOL_formal_generic_list = 141,      /* formal_generic_list  */
  YYSYMBOL_142_formal_generic_element_ = 142, /* ...formal_generic_element..  */
  YYSYMBOL_formal_generic_element = 143,   /* formal_generic_element  */
  YYSYMBOL_generic_VarAsgn__expression = 144, /* generic_VarAsgn__expression  */
  YYSYMBOL_generic_expression = 145,       /* generic_expression  */
  YYSYMBOL_generic_aggregate = 146,        /* generic_aggregate  */
  YYSYMBOL_147_3 = 147,                    /* $@3  */
  YYSYMBOL_148_generic_element_association_ = 148, /* ...generic_element_association..  */
  YYSYMBOL_generic_element_association = 149, /* generic_element_association  */
  YYSYMBOL_150_constraint_ = 150,          /* .constraint.  */
  YYSYMBOL_constraint = 151,               /* constraint  */
  YYSYMBOL_range = 152,                    /* range  */
  YYSYMBOL_direction = 153,                /* direction  */
  YYSYMBOL_154_port_clause_ = 154,         /* .port_clause.  */
  YYSYMBOL_port_clause = 155,              /* port_clause  */
  YYSYMBOL_formal_port_list = 156,         /* formal_port_list  */
  YYSYMBOL_157_formal_port_element_ = 157, /* ...formal_port_element..  */
  YYSYMBOL_formal_port_element = 158,      /* formal_port_element  */
  YYSYMBOL_159_SIGNAL_ = 159,              /* .SIGNAL.  */
  YYSYMBOL_160_mode_ = 160,                /* .mode.  */
  YYSYMBOL_architecture_body = 161,        /* architecture_body  */
  YYSYMBOL_162_4 = 162,                    /* $@4  */
  YYSYMBOL_architecture_declarative_part = 163, /* architecture_declarative_part  */
  YYSYMBOL_164_block_declarative_item_ = 164, /* ..block_declarative_item..  */
  YYSYMBOL_block_declarative_item = 165,   /* block_declarative_item  */
  YYSYMBOL_pragma_declaration = 166,       /* pragma_declaration  */
  YYSYMBOL_constant_declaration = 167,     /* constant_declaration  */
  YYSYMBOL_constant_VarAsgn__expression = 168, /* constant_VarAsgn__expression  */
  YYSYMBOL_signal_declaration = 169,       /* signal_declaration  */
  YYSYMBOL_170_signal_kind_ = 170,         /* .signal_kind.  */
  YYSYMBOL_architecture_statement_part = 171, /* architecture_statement_part  */
  YYSYMBOL_172_concurrent_statement_ = 172, /* ..concurrent_statement..  */
  YYSYMBOL_concurrent_statement = 173,     /* concurrent_statement  */
  YYSYMBOL_block_statement = 174,          /* block_statement  */
  YYSYMBOL_175_5 = 175,                    /* $@5  */
  YYSYMBOL_set_of_statements = 176,        /* set_of_statements  */
  YYSYMBOL_concurrent_assertion_statement = 177, /* concurrent_assertion_statement  */
  YYSYMBOL_concurrent_signal_assignment_statement = 178, /* concurrent_signal_assignment_statement  */
  YYSYMBOL_unlabeled_concurrent_assertion_statement = 179, /* unlabeled_concurrent_assertion_statement  */
  YYSYMBOL_assertion_statement = 180,      /* assertion_statement  */
  YYSYMBOL_unlabeled_conditional_signal_assignment = 181, /* unlabeled_conditional_signal_assignment  */
  YYSYMBOL_182_waveform__WHEN__condition__ELSE_ = 182, /* ..waveform__WHEN__condition__ELSE..  */
  YYSYMBOL_unlabeled_selected_signal_assignment = 183, /* unlabeled_selected_signal_assignment  */
  YYSYMBOL_184_6 = 184,                    /* $@6  */
  YYSYMBOL_185_waveform__WHEN__choices_ = 185, /* ...waveform__WHEN__choices..  */
  YYSYMBOL_waveform__WHEN__choices = 186,  /* waveform__WHEN__choices  */
  YYSYMBOL_waveform = 187,                 /* waveform  */
  YYSYMBOL_waveform_element = 188,         /* waveform_element  */
  YYSYMBOL_189_AFTER__delay_expression_ = 189, /* .AFTER__delay_expression.  */
  YYSYMBOL_delay_expression = 190,         /* delay_expression  */
  YYSYMBOL_191_time_unit_ = 191,           /* .time_unit.  */
  YYSYMBOL_choices = 192,                  /* choices  */
  YYSYMBOL_193_7 = 193,                    /* $@7  */
  YYSYMBOL_194_Bar__choice_ = 194,         /* ..Bar__choice..  */
  YYSYMBOL_choice = 195,                   /* choice  */
  YYSYMBOL_196_REPORT__expression_ = 196,  /* .REPORT__expression.  */
  YYSYMBOL_197_SEVERITY__expression_ = 197, /* .SEVERITY__expression.  */
  YYSYMBOL_report__message = 198,          /* report__message  */
  YYSYMBOL_severity__message = 199,        /* severity__message  */
  YYSYMBOL_expression = 200,               /* expression  */
  YYSYMBOL_201_relation_AND__relation_ = 201, /* relation..AND__relation..  */
  YYSYMBOL_202_relation_OR__relation_ = 202, /* relation..OR__relation..  */
  YYSYMBOL_203_relation_NAND_NOR__relation_ = 203, /* relation.NAND_NOR__relation.  */
  YYSYMBOL_204_relation_XOR__relation_ = 204, /* relation..XOR__relation..  */
  YYSYMBOL_relation = 205,                 /* relation  */
  YYSYMBOL_simple_expression = 206,        /* simple_expression  */
  YYSYMBOL_207_sign_term_add_op__term_ = 207, /* .sign.term..add_op__term..  */
  YYSYMBOL_term = 208,                     /* term  */
  YYSYMBOL_factor = 209,                   /* factor  */
  YYSYMBOL_primary = 210,                  /* primary  */
  YYSYMBOL_relational_operator = 211,      /* relational_operator  */
  YYSYMBOL_literal = 212,                  /* literal  */
  YYSYMBOL_aggregate = 213,                /* aggregate  */
  YYSYMBOL_name = 214,                     /* name  */
  YYSYMBOL_indexed_name = 215,             /* indexed_name  */
  YYSYMBOL_slice_name = 216,               /* slice_name  */
  YYSYMBOL_attribute_name = 217,           /* attribute_name  */
  YYSYMBOL_attribute_designator = 218,     /* attribute_designator  */
  YYSYMBOL_type_mark = 219,                /* type_mark  */
  YYSYMBOL_identifier_list = 220,          /* identifier_list  */
  YYSYMBOL_221_8 = 221,                    /* $@8  */
  YYSYMBOL_222_identifier_ = 222,          /* ...identifier..  */
  YYSYMBOL_223_label_ = 223,               /* .label.  */
  YYSYMBOL_224_guard_expression_ = 224,    /* .guard_expression.  */
  YYSYMBOL_guard_expression = 225,         /* guard_expression  */
  YYSYMBOL_226_GUARDED_ = 226,             /* .GUARDED.  */
  YYSYMBOL_227_simple_name_ = 227,         /* .simple_name.  */
  YYSYMBOL_simple_name = 228,              /* simple_name  */
  YYSYMBOL_target = 229,                   /* target  */
  YYSYMBOL_a_label = 230,                  /* a_label  */
  YYSYMBOL_label = 231,                    /* label  */
  YYSYMBOL_abstractlit = 232,              /* abstractlit  */
  YYSYMBOL_RightParen_ERR = 233,           /* RightParen_ERR  */
  YYSYMBOL_Semicolon_ERR = 234,            /* Semicolon_ERR  */
  YYSYMBOL_END_ERR = 235                   /* END_ERR  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   240

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  134
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  102
/* YYNRULES -- Number of rules.  */
#define YYNRULES  180
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  287

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   388


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   261,   261,   261,   358,   355,   371,   379,   380,   388,
     393,   400,   405,   406,   412,   435,   451,   456,   464,   470,
     468,   482,   483,   496,   502,   507,   512,   519,   537,   539,
     544,   545,   549,   554,   561,   566,   567,   573,   611,   628,
     629,   634,   635,   637,   639,   649,   644,   663,   669,   673,
     674,   679,   680,   681,   682,   688,   702,   723,   729,   771,
     772,   774,   779,   783,   784,   789,   790,   791,   792,   802,
     798,   824,   828,   838,   842,   849,   850,   857,   861,   865,
     880,  1130,  1131,  1154,  1152,  1390,  1391,  1398,  1413,  1418,
    1427,  1428,  1434,  1441,  1442,  1444,  1446,  1448,  1454,  1453,
    1460,  1461,  1472,  1474,  1476,  1548,  1549,  1556,  1557,  1563,
    1568,  1570,  1575,  1577,  1579,  1581,  1586,  1590,  1597,  1601,
    1608,  1610,  1614,  1622,  1626,  1633,  1635,  1642,  1647,  1649,
    1657,  1662,  1664,  1670,  1676,  1678,  1773,  1775,  1780,  1782,
    1784,  1789,  1796,  1802,  1804,  1806,  1811,  1823,  1841,  1905,
    1909,  1911,  1913,  1915,  1917,  1919,  1921,  1923,  1925,  1927,
    1933,  1932,  1938,  1939,  1947,  1948,  1954,  1955,  1960,  1968,
    1969,  1975,  1976,  1981,  1986,  1991,  2000,  2005,  2010,  2015,
    2020
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "tok_AND", "PRAGMA",
  "_BEGIN", "_END", "_EQSym", "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN",
  "_INOUT", "_LABEL", "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_NESym",
  "_NEXT", "_NOR", "_NOT", "tok_NULL", "_OR", "_OUT", "_XOR", "ABS",
  "ACCESS", "AFTER", "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT",
  "ATTRIBUTE", "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BIT",
  "BIT_VECTOR", "_BLOCK", "BODY", "BUFFER", "BUS", "Bar", "BasedInt",
  "BasedReal", "BitStringLit", "Box", "CASE", "COMPONENT", "CONFIGURATION",
  "CONSTANT", "CharacterLit", "Colon", "Comma", "DISCONNECT", "DOWNTO",
  "DecimalInt", "DecimalReal", "Dot", "DoubleStar", "ELSE", "ELSIF",
  "ENTITY", "ERROR", "FOR", "FUNCTION", "GENERATE", "GENERIC", "GUARDED",
  "IF", "IS", "Identifier", "LIBRARY", "LOOP", "LeftParen", "MAP", "MOD",
  "MUX_BIT", "MUX_VECTOR", "Minus", "NATURAL", "NATURAL_VECTOR", "NEW",
  "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE", "PROCESS",
  "Plus", "_PS", "_NS", "_US", "_MS", "RANGE", "RECORD", "REG_BIT",
  "REG_VECTOR", "REGISTER", "REM", "REPORT", "RETURN", "RightParen",
  "SELECT", "SEVERITY", "SIGNAL", "_STABLE", "SUBTYPE", "Semicolon",
  "Slash", "Star", "StringLit", "THEN", "TO", "TRANSPORT", "_TYPE",
  "UNITS", "UNTIL", "USE", "VARIABLE", "VarAsgn", "WAIT", "WARNING",
  "WHEN", "WHILE", "WITH", "WOR_BIT", "WOR_VECTOR", "$accept",
  "design_file", "$@1", "entity_declaration", "$@2", ".generic_clause.",
  "generic_clause", "formal_generic_list", "...formal_generic_element..",
  "formal_generic_element", "generic_VarAsgn__expression",
  "generic_expression", "generic_aggregate", "$@3",
  "...generic_element_association..", "generic_element_association",
  ".constraint.", "constraint", "range", "direction", ".port_clause.",
  "port_clause", "formal_port_list", "...formal_port_element..",
  "formal_port_element", ".SIGNAL.", ".mode.", "architecture_body", "$@4",
  "architecture_declarative_part", "..block_declarative_item..",
  "block_declarative_item", "pragma_declaration", "constant_declaration",
  "constant_VarAsgn__expression", "signal_declaration", ".signal_kind.",
  "architecture_statement_part", "..concurrent_statement..",
  "concurrent_statement", "block_statement", "$@5", "set_of_statements",
  "concurrent_assertion_statement",
  "concurrent_signal_assignment_statement",
  "unlabeled_concurrent_assertion_statement", "assertion_statement",
  "unlabeled_conditional_signal_assignment",
  "..waveform__WHEN__condition__ELSE..",
  "unlabeled_selected_signal_assignment", "$@6",
  "...waveform__WHEN__choices..", "waveform__WHEN__choices", "waveform",
  "waveform_element", ".AFTER__delay_expression.", "delay_expression",
  ".time_unit.", "choices", "$@7", "..Bar__choice..", "choice",
  ".REPORT__expression.", ".SEVERITY__expression.", "report__message",
  "severity__message", "expression", "relation..AND__relation..",
  "relation..OR__relation..", "relation.NAND_NOR__relation.",
  "relation..XOR__relation..", "relation", "simple_expression",
  ".sign.term..add_op__term..", "term", "factor", "primary",
  "relational_operator", "literal", "aggregate", "name", "indexed_name",
  "slice_name", "attribute_name", "attribute_designator", "type_mark",
  "identifier_list", "$@8", "...identifier..", ".label.",
  ".guard_expression.", "guard_expression", ".GUARDED.", ".simple_name.",
  "simple_name", "target", "a_label", "label", "abstractlit",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-177)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-177)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -177,    53,    -7,  -177,    25,    28,  -177,  -177,   -17,    26,
    -177,  -177,  -177,   -25,    -8,    20,     5,   -26,  -177,    31,
     -41,    36,    21,   102,  -177,  -177,  -177,  -177,  -177,    39,
       8,  -177,   -41,     4,  -177,    20,  -177,  -177,    63,  -177,
     -41,   -41,  -177,  -177,  -177,     8,  -177,    39,   -41,  -177,
     116,    16,  -177,   -10,  -177,    36,   -41,   -41,    75,  -177,
    -177,   -41,  -177,    61,    39,  -177,  -177,  -177,  -177,    82,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,
      64,  -177,  -177,     4,   112,   102,    12,  -177,    89,    90,
      72,   113,    34,  -177,  -177,  -177,  -177,  -177,   -10,    20,
     -41,   -11,    96,   -11,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,     2,   139,   -27,   106,
     -10,   -10,  -177,  -177,     8,    -9,     6,  -177,    64,   -41,
    -177,     3,  -177,  -177,   -11,  -177,    57,   161,   142,  -177,
     141,   114,   134,   132,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,    58,   113,    99,    94,  -177,  -177,  -177,  -177,    64,
      64,  -177,  -177,  -177,   113,   113,  -177,  -177,  -177,   -13,
    -177,  -177,    65,    62,    67,   -11,   -11,   -11,   -11,   -11,
     -11,   -11,   -11,  -177,  -177,   -11,   -11,    66,  -177,  -177,
     -23,  -177,  -177,   -11,   169,  -177,    52,   -13,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,   -39,   -41,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,    20,
     113,  -177,   -11,     8,  -177,    -4,   -41,   -41,  -177,  -177,
    -177,  -177,  -177,   165,     8,    -3,  -177,   153,  -177,  -177,
    -177,  -177,  -177,    -1,    99,  -177,   -11,  -177,   113,  -177,
      13,   102,   113,  -177,   -11,   119,  -177,    60,   144,  -177,
    -177,    55,  -177,  -177,  -177,  -177,  -177,  -177,   115,    -2,
     -14,  -177,   -41,  -177,   -11,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,   143,   -14,  -177
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     1,     0,     0,     6,   173,     0,     0,
       3,     4,    47,     0,     7,     0,     0,    30,     8,     0,
       0,     0,     0,     0,    31,    45,   179,    10,    15,     0,
       0,    12,     0,     0,   180,   171,    49,   160,     0,   178,
       0,    11,    33,    38,    40,     0,    35,     0,     0,   172,
       0,     0,   162,     0,     9,     0,     0,    34,     0,     5,
      63,     0,    55,     0,     0,    50,    52,    53,    51,   161,
     150,   153,   152,   155,   158,   159,   156,   157,   151,   154,
      24,    13,    32,     0,    41,     0,     0,    54,     0,     0,
       0,     0,     0,    25,    36,    42,    44,    43,     0,   171,
       0,     0,   173,     0,    64,    65,    66,    67,    73,    78,
      75,    77,   174,   143,   144,   145,   142,     0,     0,     0,
       0,     0,   163,   177,     0,     0,     0,    14,    24,     0,
      68,     0,   140,   138,     0,   139,   105,   112,   113,   114,
     115,   120,   125,   127,   128,   130,   131,   133,   134,   135,
      83,     0,     0,   169,   166,    72,    74,    76,   175,    24,
      24,    26,    29,    28,     0,     0,    16,    18,    17,    59,
      46,   132,     0,     0,   107,     0,     0,     0,     0,     0,
       0,     0,     0,   136,   137,     0,     0,     0,   149,   148,
       0,   170,    81,     0,     0,   167,     0,    59,    27,    19,
      23,    61,    60,    37,   141,   109,   106,     0,     0,   117,
     119,   124,   116,   121,   122,   118,   123,   126,   129,     0,
       0,   146,     0,     0,    69,     0,     0,     0,    21,   110,
     111,   108,    79,     0,     0,     0,    88,    90,   168,    63,
      57,    56,    58,     0,   169,   147,     0,    80,     0,    89,
       0,     0,     0,    20,     0,     0,    91,    93,     0,    22,
      85,     0,    82,    94,    95,    96,    97,    92,   164,     0,
       0,   176,     0,   165,     0,    84,   103,    87,    98,   102,
     104,    70,    86,   100,    99,     0,   101
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,   133,
    -177,  -177,  -177,  -177,  -177,   -65,   -30,  -177,  -177,     1,
    -177,  -177,  -177,  -177,   110,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,     0,  -177,   -43,  -177,
    -177,  -177,  -177,  -177,  -177,    80,  -177,    81,  -177,    84,
    -177,  -177,   -62,    -6,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,   -72,  -177,  -177,  -177,  -177,   -91,  -177,  -177,  -177,
    -177,    29,    32,  -177,    33,  -177,    83,  -177,  -176,  -177,
     -85,  -177,  -177,  -177,  -177,    30,    22,  -177,  -177,  -177,
    -177,  -177,   -29,   121,    19,     7,  -177,   -50,   -87,   -42,
     -32,   -83
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     5,    14,    17,    18,    30,    41,    31,
     127,   166,   167,   228,   243,   199,    92,    93,   124,   164,
      23,    24,    45,    57,    46,    47,    98,    10,    36,    50,
      51,    65,    66,    67,   226,    68,   203,    85,    86,   104,
     105,   239,   251,   106,   107,   108,   109,   110,   222,   111,
     187,   269,   260,   261,   236,   249,   256,   267,   277,   283,
     284,   278,   174,   208,   206,   231,   237,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   185,   147,   148,
     149,   113,   114,   115,   189,    80,    38,    52,    69,   272,
     194,   195,   192,    48,   116,   117,   118,   119,   200,    40,
      27,    35
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      42,   112,    99,    56,   125,    43,    20,   101,    54,    55,
     136,   131,   150,   100,   100,   154,    59,    61,   -62,   -71,
      62,   -48,    32,     8,    82,    83,     6,    12,   229,    87,
      70,    71,   201,   112,    19,   132,   162,    28,   132,   168,
     151,   133,   123,   172,   133,   132,   101,   101,     7,   240,
     162,   133,   132,     3,    49,   274,   252,    11,   133,     4,
       9,     7,    15,    16,     7,   190,    22,   134,   130,    58,
      63,    72,    73,    26,    74,    75,   276,   198,     7,   -39,
     152,   134,   161,    21,   165,    39,    89,   102,   102,   230,
      29,   202,    76,    77,   279,     7,   163,   170,   169,    33,
       7,    13,   223,   135,   103,    25,   135,    39,    34,   279,
     163,    26,    26,   135,    37,    44,    39,   178,    49,    53,
     135,    60,    78,    79,    95,    96,   246,    64,   128,   196,
     197,    84,   179,   234,   112,   180,    88,    97,   181,    90,
     182,   183,    91,   103,   103,   120,   121,   122,   221,   123,
     159,   160,  -176,   184,   153,   255,   263,   264,   265,   266,
     126,   257,   158,   173,   175,   112,   176,   177,   258,   186,
     188,   191,   193,   204,   224,   219,   232,   207,   225,   205,
     244,   238,   248,   262,   270,   280,   268,   259,    81,   285,
     271,   220,   245,    94,   241,   242,   250,   227,   155,   156,
     280,   253,   157,   247,   209,   210,   211,   212,   213,   214,
     215,   216,   282,   286,   171,   254,   235,   217,   273,   218,
     129,     0,     0,     0,     0,     0,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   275,     0,     0,
     281
};

static const yytype_int16 yycheck[] =
{
      32,    86,    85,    45,    91,     1,     1,    34,    40,    41,
     101,    22,   103,     1,     1,    42,    48,     1,     6,     6,
       4,     5,     1,     4,    56,    57,     1,     1,    67,    61,
      40,    41,    45,   118,    15,    49,    59,     1,    49,   126,
      38,    55,    36,   134,    55,    49,    34,    34,    75,   225,
      59,    55,    49,     0,    35,    57,    57,    74,    55,    66,
      32,    75,    87,    71,    75,   152,    92,    78,   100,    47,
      54,    81,    82,   114,    84,    85,    90,   164,    75,    75,
      78,    78,   124,    78,    78,   108,    64,    75,    75,   128,
      54,   104,   102,   103,   270,    75,   119,   129,   128,    78,
      75,    75,   193,   117,   131,    74,   117,   108,     6,   285,
     119,   114,   114,   117,    75,   111,   108,     3,    99,    56,
     117,     5,   132,   133,    12,    13,   129,   111,    98,   159,
     160,    56,    18,   220,   219,    21,    75,    25,    24,    57,
      26,     7,    78,   131,   131,    56,    56,    75,   190,    36,
     120,   121,    56,    19,    15,   246,    96,    97,    98,    99,
     126,   248,    56,   106,     3,   250,    24,    26,   251,    37,
     112,    72,    78,   108,     5,   109,   208,   110,   126,   117,
      15,   223,    29,    64,   129,   270,    42,   252,    55,    46,
      75,   190,   234,    83,   226,   227,   239,   197,   118,   118,
     285,   243,   118,   235,   175,   176,   177,   178,   179,   180,
     181,   182,   274,   285,   131,   244,   222,   185,   268,   186,
      99,    -1,    -1,    -1,    -1,    -1,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,    -1,    -1,
     272
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   135,   136,     0,    66,   137,     1,    75,   228,    32,
     161,    74,     1,    75,   138,    87,    71,   139,   140,   228,
       1,    78,    92,   154,   155,    74,   114,   234,     1,    54,
     141,   143,     1,    78,     6,   235,   162,    75,   220,   108,
     233,   142,   234,     1,   111,   156,   158,   159,   227,   228,
     163,   164,   221,    56,   234,   234,   233,   157,   220,   234,
       5,     1,     4,    54,   111,   165,   166,   167,   169,   222,
      40,    41,    81,    82,    84,    85,   102,   103,   132,   133,
     219,   143,   234,   234,    56,   171,   172,   234,    75,   220,
      57,    78,   150,   151,   158,    12,    13,    25,   160,   235,
       1,    34,    75,   131,   173,   174,   177,   178,   179,   180,
     181,   183,   214,   215,   216,   217,   228,   229,   230,   231,
      56,    56,    75,    36,   152,   232,   126,   144,   219,   227,
     234,    22,    49,    55,    78,   117,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   212,   213,   214,
     200,    38,    78,    15,    42,   179,   181,   183,    56,   219,
     219,   233,    59,   119,   153,    78,   145,   146,   232,   150,
     234,   210,   200,   106,   196,     3,    24,    26,     3,    18,
      21,    24,    26,     7,    19,   211,    37,   184,   112,   218,
     232,    72,   226,    78,   224,   225,   150,   150,   232,   149,
     232,    45,   104,   170,   108,   117,   198,   110,   197,   205,
     205,   205,   205,   205,   205,   205,   205,   206,   208,   109,
     153,   233,   182,   200,     5,   126,   168,   170,   147,    67,
     128,   199,   234,   229,   232,   187,   188,   200,   233,   175,
     212,   234,   234,   148,    15,   233,   129,   234,    29,   189,
     172,   176,    57,   233,   226,   200,   190,   232,   235,   149,
     186,   187,    64,    96,    97,    98,    99,   191,    42,   185,
     129,    75,   223,   231,    57,   234,    90,   192,   195,   212,
     214,   234,   186,   193,   194,    46,   195
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   134,   136,   135,   138,   137,   137,   139,   139,   140,
     140,   141,   142,   142,   143,   143,   144,   145,   145,   147,
     146,   148,   148,   149,   150,   150,   151,   152,   153,   153,
     154,   154,   155,   155,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   160,   160,   162,   161,   161,   163,   164,
     164,   165,   165,   165,   165,   166,   167,   168,   169,   170,
     170,   170,   171,   172,   172,   173,   173,   173,   173,   175,
     174,   176,   177,   177,   178,   178,   178,   178,   179,   180,
     181,   182,   182,   184,   183,   185,   185,   186,   187,   188,
     189,   189,   190,   191,   191,   191,   191,   191,   193,   192,
     194,   194,   195,   195,   195,   196,   196,   197,   197,   198,
     199,   199,   200,   200,   200,   200,   201,   201,   202,   202,
     203,   203,   203,   204,   204,   205,   205,   206,   207,   207,
     208,   209,   209,   210,   210,   210,   211,   211,   212,   212,
     212,   213,   214,   214,   214,   214,   215,   216,   217,   218,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     221,   220,   222,   222,   223,   223,   224,   224,   225,   226,
     226,   227,   227,   228,   229,   230,   231,   232,   233,   234,
     235
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     9,     2,     0,     1,     5,
       3,     2,     0,     3,     6,     1,     2,     1,     1,     0,
       5,     0,     3,     1,     0,     1,     3,     3,     1,     1,
       0,     1,     5,     3,     2,     0,     3,     7,     1,     0,
       1,     0,     1,     1,     1,     0,    12,     2,     1,     0,
       2,     1,     1,     1,     2,     1,     7,     2,     7,     0,
       1,     1,     1,     0,     2,     1,     1,     1,     2,     0,
      10,     1,     2,     1,     2,     1,     2,     1,     1,     5,
       6,     0,     5,     0,    10,     0,     3,     3,     1,     2,
       0,     2,     2,     0,     1,     1,     1,     1,     0,     3,
       0,     3,     1,     1,     1,     0,     2,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     1,     1,     3,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     4,     6,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     0,     3,     0,     1,     0,     1,     3,     0,
       1,     0,     1,     1,     1,     2,     1,     1,     1,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 261 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*    Initializations					*/
		/*      - erroneous description presumed !		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = NULL;
		BVL_GRDLST = NULL;
		BVL_CNDLST = NULL;
		BVL_VALLST = NULL;
		BVL_ERRFLG = 0;

		dic                = beh_initab ();
		BVL_BEFPNT         = beh_addbefig (BVL_HEDFIG,NULL);
		BVL_BEFPNT->ERRFLG = 1;
		BVL_HEDFIG         = BVL_BEFPNT;
		}
#line 1906 "y.tab.c"
    break;

  case 3: /* design_file: $@1 entity_declaration architecture_body  */
#line 280 "./bvl_bcomp_y.y"
                {
		struct beout *beout_pnt;
		struct beaux *beaux_pnt;
		struct bebus *bebus_pnt;
		struct bereg *bereg_pnt;
		struct berin *berin_pnt;
		struct beaux *beaux_pred;
		struct berin *berin_pred;

		/* ###----------------------------------------------### */
		/*    Checking that each output have at least one driver*/
		/* ###----------------------------------------------### */

		beout_pnt = BVL_BEFPNT->BEOUT;
		while (beout_pnt != NULL)
		  {
		  if (beout_pnt->ABL == NULL)
		    bvl_error (40, beout_pnt->NAME);
		  beout_pnt = beout_pnt->NEXT;
		  }

		beaux_pnt = BVL_BEFPNT->BEAUX;
      beaux_pred=NULL;
		while (beaux_pnt != NULL)
		  {
        if (beaux_pnt->ABL == NULL)
        {
          fprintf (stderr,"`%s` Warning %d line %ld :",BVL_CURFIL,40,BVL_LINNUM);
          fprintf (stderr,"signal `%s` never assigned\n",beaux_pnt->NAME);
          
          /*removing signal*/
          if ( beaux_pred ) beaux_pred->NEXT = beaux_pnt->NEXT;
          else BVL_BEFPNT->BEAUX = beaux_pnt->NEXT;

          /*removing other ref to signal*/
          berin_pred = NULL;
          for ( berin_pnt = BVL_BEFPNT->BERIN; berin_pnt; berin_pnt = berin_pnt->NEXT )
          {
             if ( berin_pnt->NAME == beaux_pnt->NAME )
             {
                 if ( berin_pred ) berin_pred->NEXT = berin_pnt->NEXT;
                 else BVL_BEFPNT->BERIN = berin_pnt->NEXT;
                 break;
             }
             berin_pred = berin_pnt;
          }
        }
        else beaux_pred = beaux_pnt;
		  beaux_pnt = beaux_pnt->NEXT;
		  }

		bebus_pnt = BVL_BEFPNT->BEBUS;
		while (bebus_pnt != NULL)
		  {
		  if (bebus_pnt->BIABL == NULL)
		    bvl_error (40, bebus_pnt->NAME);
		  bebus_pnt = bebus_pnt->NEXT;
		  }

		bereg_pnt = BVL_BEFPNT->BEREG;
		while (bereg_pnt != NULL)
		  {
		  if (bereg_pnt->BIABL == NULL)
		    bvl_error (40,bereg_pnt->NAME);
		  bereg_pnt = bereg_pnt->NEXT;
		  }

		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->ERRFLG = 0;

		beh_fretab (dic);
		}
#line 1983 "y.tab.c"
    break;

  case 4: /* $@2: %empty  */
#line 358 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->NAME = (yyvsp[-1].text);
		BVL_MODNAM       = (yyvsp[-1].text);
		}
#line 1992 "y.tab.c"
    break;

  case 5: /* entity_declaration: ENTITY simple_name IS $@2 .generic_clause. .port_clause. END_ERR .simple_name. Semicolon_ERR  */
#line 367 "./bvl_bcomp_y.y"
                {
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-7].text)))
		  bvl_error (1,(yyvsp[-1].text));
		}
#line 2001 "y.tab.c"
    break;

  case 6: /* entity_declaration: ENTITY error  */
#line 373 "./bvl_bcomp_y.y"
                {
		bvl_error (2,NULL);
		}
#line 2009 "y.tab.c"
    break;

  case 8: /* .generic_clause.: generic_clause  */
#line 381 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->BEGEN = BVL_GENPNT;
		BVL_GENPNT = NULL;
		}
#line 2018 "y.tab.c"
    break;

  case 10: /* generic_clause: GENERIC error Semicolon_ERR  */
#line 396 "./bvl_bcomp_y.y"
                { bvl_error (74,NULL); }
#line 2024 "y.tab.c"
    break;

  case 14: /* formal_generic_element: CONSTANT identifier_list Colon type_mark .constraint. generic_VarAsgn__expression  */
#line 418 "./bvl_bcomp_y.y"
                {
		char *type;

		if ((yyvsp[-1].name).FLAG == (yyvsp[-2].dble).FLAG)
		  {
		  BVL_NM1LST = reverse (BVL_NM1LST);
		  type = namealloc ("natural");
		  BVL_GENPNT = bvl_addgen (BVL_GENPNT,BVL_INTLST,BVL_NM1LST,
		                           type,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
		  }
		else
		  bvl_error (33,NULL);
		freechain (BVL_NM1LST);
		freechain (BVL_INTLST);
		BVL_NM1LST = NULL;
		BVL_INTLST = NULL;
		}
#line 2046 "y.tab.c"
    break;

  case 15: /* formal_generic_element: error  */
#line 436 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  yychar = yylex ();
		while ((yychar != Semicolon) && (yychar != 0));
		yyerrok;
		bvl_error (75,NULL);
		}
#line 2063 "y.tab.c"
    break;

  case 17: /* generic_expression: abstractlit  */
#line 457 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2075 "y.tab.c"
    break;

  case 19: /* $@3: %empty  */
#line 470 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2087 "y.tab.c"
    break;

  case 22: /* ...generic_element_association..: ...generic_element_association.. Comma generic_element_association  */
#line 486 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (yyvsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST,(void *)ptlong);
		}
#line 2099 "y.tab.c"
    break;

  case 23: /* generic_element_association: abstractlit  */
#line 497 "./bvl_bcomp_y.y"
                {(yyval.valu) = (yyvsp[0].valu);}
#line 2105 "y.tab.c"
    break;

  case 24: /* .constraint.: %empty  */
#line 502 "./bvl_bcomp_y.y"
                {
		(yyval.name).FLAG  = 'S';
		(yyval.name).LEFT  = -1;
		(yyval.name).RIGHT = -1;
		}
#line 2115 "y.tab.c"
    break;

  case 25: /* .constraint.: constraint  */
#line 508 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 2121 "y.tab.c"
    break;

  case 26: /* constraint: LeftParen range RightParen_ERR  */
#line 515 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[-1].name); }
#line 2127 "y.tab.c"
    break;

  case 27: /* range: abstractlit direction abstractlit  */
#line 522 "./bvl_bcomp_y.y"
                {
		(yyval.name).FLAG  = 'A';
		(yyval.name).LEFT  = (yyvsp[-2].valu);
		(yyval.name).RIGHT = (yyvsp[0].valu);

		if ((((yyvsp[-2].valu) > (yyvsp[0].valu)) && ((yyvsp[-1].valu) == BVL_UPTDFN)) ||
		    (((yyvsp[-2].valu) < (yyvsp[0].valu)) && ((yyvsp[-1].valu) == BVL_DWTDFN)) ||
		    (((yyvsp[-2].valu) < 0 ) || ((yyvsp[-1].valu) < 0 )))
		  {
		  bvl_error (32,NULL);
		  }
		}
#line 2144 "y.tab.c"
    break;

  case 28: /* direction: TO  */
#line 538 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_UPTDFN; }
#line 2150 "y.tab.c"
    break;

  case 29: /* direction: DOWNTO  */
#line 540 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_DWTDFN; }
#line 2156 "y.tab.c"
    break;

  case 33: /* port_clause: PORT error Semicolon_ERR  */
#line 557 "./bvl_bcomp_y.y"
                { bvl_error (3,NULL); }
#line 2162 "y.tab.c"
    break;

  case 37: /* formal_port_element: .SIGNAL. identifier_list Colon .mode. type_mark .constraint. .signal_kind.  */
#line 580 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each port, create the apropriate set of	*/
		/* structures (berin, bepor, beout, bebus)		*/
		/* ###----------------------------------------------### */

		chkdcl ('P', (yyvsp[-3].valu), (yyvsp[-2].dble).VALU, (yyvsp[-2].dble).FLAG, (yyvsp[0].valu), (yyvsp[-1].name).FLAG, &sigconf);

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic,signame,BVL_MODNAM,BVL_SIGDFN) != 0)
		    bvl_error (4,signame);

		  pnt = addstr (BVL_BEFPNT,'P',(yyvsp[-3].valu),(yyvsp[-2].dble).VALU,(yyvsp[-2].dble).FLAG,signame,
		                (yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);

		  beh_addtab (dic,signame,BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMNDFN,(yyvsp[-1].name).LEFT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMXDFN,(yyvsp[-1].name).RIGHT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_PNTDFN,(long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		}
#line 2198 "y.tab.c"
    break;

  case 38: /* formal_port_element: error  */
#line 612 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  yychar = yylex ();
		while ((yychar != Semicolon) && (yychar != 0));
		yyerrok;

		bvl_error (6,NULL);
		}
#line 2216 "y.tab.c"
    break;

  case 41: /* .mode.: %empty  */
#line 634 "./bvl_bcomp_y.y"
                { (yyval.valu) = _IN; }
#line 2222 "y.tab.c"
    break;

  case 42: /* .mode.: _IN  */
#line 636 "./bvl_bcomp_y.y"
                { (yyval.valu) = _IN; }
#line 2228 "y.tab.c"
    break;

  case 43: /* .mode.: _OUT  */
#line 638 "./bvl_bcomp_y.y"
                { (yyval.valu) = _OUT; }
#line 2234 "y.tab.c"
    break;

  case 44: /* .mode.: _INOUT  */
#line 640 "./bvl_bcomp_y.y"
                { (yyval.valu) = _INOUT; }
#line 2240 "y.tab.c"
    break;

  case 45: /* $@4: %empty  */
#line 649 "./bvl_bcomp_y.y"
                {
		if ((yyvsp[-1].text) != BVL_MODNAM)
		  bvl_error (1,(yyvsp[-1].text));
		}
#line 2249 "y.tab.c"
    break;

  case 46: /* architecture_body: ARCHITECTURE Identifier OF simple_name IS $@4 architecture_declarative_part _BEGIN architecture_statement_part END_ERR .simple_name. Semicolon_ERR  */
#line 659 "./bvl_bcomp_y.y"
                {
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-10].text)))
		  bvl_error (7,(yyvsp[-1].text));
		}
#line 2258 "y.tab.c"
    break;

  case 47: /* architecture_body: ARCHITECTURE error  */
#line 665 "./bvl_bcomp_y.y"
                { bvl_error (8,NULL); }
#line 2264 "y.tab.c"
    break;

  case 54: /* block_declarative_item: error Semicolon_ERR  */
#line 684 "./bvl_bcomp_y.y"
                { bvl_error (9,NULL); }
#line 2270 "y.tab.c"
    break;

  case 55: /* pragma_declaration: PRAGMA  */
#line 689 "./bvl_bcomp_y.y"
           {
             char pragma[30];
             char type  [100];
             char name  [100];

             sscanf((char *)(yyvsp[0].valu),"-- %s %s %s", pragma,type,name);

             BVL_BEFPNT->BEPGM = beh_addbepgm(BVL_BEFPNT->BEPGM,
                                              type,name,(void *)0);
           }
#line 2285 "y.tab.c"
    break;

  case 56: /* constant_declaration: CONSTANT Identifier Colon type_mark .constraint. constant_VarAsgn__expression Semicolon_ERR  */
#line 709 "./bvl_bcomp_y.y"
                {
		long sigconf;
		
		if (chkdcl ('C',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,0,(yyvsp[-2].name).FLAG,&sigconf) == 0)
		  {
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_WMNDFN,(yyvsp[-2].name).LEFT);
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_WMXDFN,(yyvsp[-2].name).RIGHT);
		  beh_addtab (dic,(yyvsp[-5].text),BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,(yyvsp[-5].text),NULL,BVL_PNTDFN,(yyvsp[-1].text));
		  }
		}
#line 2301 "y.tab.c"
    break;

  case 57: /* constant_VarAsgn__expression: VarAsgn literal  */
#line 725 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 2307 "y.tab.c"
    break;

  case 58: /* signal_declaration: SIGNAL identifier_list Colon type_mark .constraint. .signal_kind. Semicolon_ERR  */
#line 736 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

        /*errflg =*/ chkdcl ('S',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,(yyvsp[-1].valu),(yyvsp[-2].name).FLAG,&sigconf);

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each signal, create the apropriate set of	*/
		/* structures (berin, bereg, beaux, bebux)		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic,signame,BVL_MODNAM,BVL_SIGDFN) != 0)
		    bvl_error (10,signame);

		  pnt = addstr (BVL_BEFPNT,'S',0,(yyvsp[-3].dble).VALU,(yyvsp[-3].dble).FLAG,signame,
		                (yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);

		  beh_addtab (dic,signame,BVL_MODNAM,BVL_SIGDFN,sigconf);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMNDFN,(yyvsp[-2].name).LEFT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_WMXDFN,(yyvsp[-2].name).RIGHT);
		  beh_addtab (dic,signame,BVL_MODNAM,BVL_PNTDFN,(long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST,BVL_NM1LST);
		  }
		}
#line 2343 "y.tab.c"
    break;

  case 59: /* .signal_kind.: %empty  */
#line 771 "./bvl_bcomp_y.y"
                { (yyval.valu) = 0; }
#line 2349 "y.tab.c"
    break;

  case 60: /* .signal_kind.: REGISTER  */
#line 773 "./bvl_bcomp_y.y"
                { (yyval.valu) = REGISTER; }
#line 2355 "y.tab.c"
    break;

  case 61: /* .signal_kind.: BUS  */
#line 775 "./bvl_bcomp_y.y"
                { (yyval.valu) = BUS; }
#line 2361 "y.tab.c"
    break;

  case 68: /* concurrent_statement: error Semicolon_ERR  */
#line 794 "./bvl_bcomp_y.y"
                { bvl_error (18,NULL); }
#line 2367 "y.tab.c"
    break;

  case 69: /* $@5: %empty  */
#line 802 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-3].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-3].text));

		beh_addtab (dic,(yyvsp[-3].text),BVL_MODNAM,BVL_LBLDFN,1);
		if ((yyvsp[-1].text) != NULL)
		  BVL_GRDLST = addchain (BVL_GRDLST,(char *)(yyvsp[-1].text));
		}
#line 2380 "y.tab.c"
    break;

  case 70: /* block_statement: a_label _BLOCK .guard_expression. _BEGIN $@5 set_of_statements END_ERR _BLOCK .label. Semicolon_ERR  */
#line 815 "./bvl_bcomp_y.y"
                {
		if ((yyvsp[-7].text) != NULL)
		  BVL_GRDLST = delchain (BVL_GRDLST,BVL_GRDLST);
		if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-9].text)))
		  bvl_error (20,(yyvsp[-1].text));
		}
#line 2391 "y.tab.c"
    break;

  case 72: /* concurrent_assertion_statement: a_label unlabeled_concurrent_assertion_statement  */
#line 830 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));

		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->BEMSG->LABEL = (yyvsp[-1].text);
		}
#line 2404 "y.tab.c"
    break;

  case 74: /* concurrent_signal_assignment_statement: a_label unlabeled_conditional_signal_assignment  */
#line 844 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));
		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		}
#line 2414 "y.tab.c"
    break;

  case 76: /* concurrent_signal_assignment_statement: a_label unlabeled_selected_signal_assignment  */
#line 852 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN) != 0)
		  bvl_error (19,(yyvsp[-1].text));
		beh_addtab (dic,(yyvsp[-1].text),BVL_MODNAM,BVL_LBLDFN,1);
		}
#line 2424 "y.tab.c"
    break;

  case 79: /* assertion_statement: ASSERT expression .REPORT__expression. .SEVERITY__expression. Semicolon_ERR  */
#line 870 "./bvl_bcomp_y.y"
                {
		if (BVL_ERRFLG == 0)
		  {
		  BVL_BEFPNT->BEMSG = beh_addbemsg(BVL_BEFPNT->BEMSG,NULL,(yyvsp[-1].valu),
		                                   (yyvsp[-2].text),(yyvsp[-3].list).LIST_ABL->DATA,NULL);
		  }
		}
#line 2436 "y.tab.c"
    break;

  case 80: /* unlabeled_conditional_signal_assignment: target _LESym .GUARDED. ..waveform__WHEN__condition__ELSE.. waveform Semicolon_ERR  */
#line 886 "./bvl_bcomp_y.y"
                {
		long             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt;
		struct bvl_expr expr0;
		struct bvl_expr expr1;
		struct bvl_expr expr2;
		struct bvl_expr expr3;
		struct bvl_expr expr4;
		struct bvl_expr expr5;
		struct bvl_expr expr6;
		long             rev_flg = 0;
		long             left_bnd;
		long             right_bnd;
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             sig_width;
		long             sig_conf;

		expr4 = (yyvsp[-1].list);

		while (BVL_CNDLST != NULL)
		  {
		  expr5 = *((bvl_ablstr *) BVL_CNDLST->DATA);
		  expr6 = *((bvl_ablstr *) BVL_VALLST->DATA);

		  expr0 = bvl_cpyablstr (expr5);
		  expr1 = bvl_crtabl (ABL_NOT , expr5, BVL_EMPSTR,-1,-1);
		  expr5 = expr0;
		  expr2 = bvl_crtabl (ANDM, expr4, expr1     ,-1,-1);
		  expr3 = bvl_crtabl (ANDM, expr6, expr5     ,-1,-1);
		  expr4 = bvl_crtabl (ABL_OR  , expr2, expr3     ,-1,-1);

		  BVL_CNDLST = delchain (BVL_CNDLST,BVL_CNDLST);
		  BVL_VALLST = delchain (BVL_VALLST,BVL_VALLST);
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMXDFN);
		sig_conf  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_SIGDFN);

		left  = (yyvsp[-5].name).LEFT;
		right = (yyvsp[-5].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr4.WIDTH)
		  bvl_error (35,(yyvsp[-5].name).NAME);

		if (rev_flg == 1)
		  expr4.LIST_ABL = reverse (expr4.LIST_ABL);

		abl_pnt = expr4.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21,(yyvsp[-5].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beout_pnt = (struct beout *)
		                 beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39,beout_pnt->NAME);
		          else
		            beout_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebus_pnt = (struct bebus *)
		                 beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL,NULL);
		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39,beaux_pnt->NAME);
		          else
		            beaux_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL,NULL);
		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL,NULL);
		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17,(yyvsp[-5].name).NAME);
		    break;
		  }
		}
#line 2682 "y.tab.c"
    break;

  case 82: /* ..waveform__WHEN__condition__ELSE..: ..waveform__WHEN__condition__ELSE.. waveform WHEN expression ELSE  */
#line 1136 "./bvl_bcomp_y.y"
                {
		struct bvl_expr *expr_pnt;

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (yyvsp[-1].list).WIDTH;
		expr_pnt->LIST_ABL = (yyvsp[-1].list).LIST_ABL;
		BVL_CNDLST         = addchain (BVL_CNDLST,(char *) expr_pnt);

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (yyvsp[-3].list).WIDTH;
		expr_pnt->LIST_ABL = (yyvsp[-3].list).LIST_ABL;
		BVL_VALLST         = addchain (BVL_VALLST,(char *) expr_pnt);
		}
#line 2700 "y.tab.c"
    break;

  case 83: /* $@6: %empty  */
#line 1154 "./bvl_bcomp_y.y"
                {
		BVL_SLCEXP = (yyvsp[0].list);
		BVL_BDDPNT = NULL;
		}
#line 2709 "y.tab.c"
    break;

  case 84: /* unlabeled_selected_signal_assignment: WITH expression $@6 SELECT target _LESym .GUARDED. waveform__WHEN__choices ...waveform__WHEN__choices.. Semicolon_ERR  */
#line 1165 "./bvl_bcomp_y.y"
                {
		long             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt;
		struct bvl_expr expr1;
		long             rev_flg = 0;
		long             left_bnd;
		long             right_bnd;
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             sig_width;
		long             sig_conf;

		expr1 = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[-1].list),-1,-1);
		if (BVL_BDDPNT != getlogbddnodeone())
		  bvl_error (25,NULL);
		left_bnd  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_WMXDFN);
		sig_conf  = beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_SIGDFN);

		left  = (yyvsp[-5].name).LEFT;
		right = (yyvsp[-5].name).RIGHT;
		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[-5].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr1.WIDTH)
		  bvl_error (35,(yyvsp[-5].name).NAME);

		if (rev_flg == 1)
		  expr1.LIST_ABL = reverse (expr1.LIST_ABL);

		abl_pnt = expr1.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21,(yyvsp[-5].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beout_pnt = (struct beout *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39,beout_pnt->NAME);
		          else
		            beout_pnt->ABL = (struct chain *)abl_pnt->DATA;
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebus_pnt = (struct bebus *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL,NULL);
		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((yyvsp[-3].valu) == BVL_GRDDFN)
		      bvl_error (22,(yyvsp[-5].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39,beaux_pnt->NAME);
		          else
		           {
		            beaux_pnt->ABL = (struct chain *)abl_pnt->DATA;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL,NULL);
		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((yyvsp[-3].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23,(yyvsp[-5].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(yyvsp[-5].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL,NULL);
		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             dupablexpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          abl_pnt           = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17,(yyvsp[-5].name).NAME);
		    break;
		  }
		}
#line 2935 "y.tab.c"
    break;

  case 85: /* ...waveform__WHEN__choices..: %empty  */
#line 1390 "./bvl_bcomp_y.y"
                { (yyval.list) = BVL_EMPSTR; }
#line 2941 "y.tab.c"
    break;

  case 86: /* ...waveform__WHEN__choices..: ...waveform__WHEN__choices.. Comma waveform__WHEN__choices  */
#line 1394 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR,(yyvsp[-2].list),(yyvsp[0].list),-1,-1); }
#line 2947 "y.tab.c"
    break;

  case 87: /* waveform__WHEN__choices: waveform WHEN choices  */
#line 1401 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;

		bvl_select (&expr1,BVL_NM1LST,&BVL_BDDPNT,BVL_SLCEXP);
		freechain (BVL_NM1LST);
		BVL_NM1LST = NULL;

		(yyval.list) = bvl_crtabl (ANDM,(yyvsp[-2].list),expr1,-1,-1);
		}
#line 2961 "y.tab.c"
    break;

  case 88: /* waveform: waveform_element  */
#line 1414 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2967 "y.tab.c"
    break;

  case 89: /* waveform_element: expression .AFTER__delay_expression.  */
#line 1420 "./bvl_bcomp_y.y"
                {
		(yyval.list)      = (yyvsp[-1].list);
		}
#line 2975 "y.tab.c"
    break;

  case 90: /* .AFTER__delay_expression.: %empty  */
#line 1427 "./bvl_bcomp_y.y"
                {}
#line 2981 "y.tab.c"
    break;

  case 91: /* .AFTER__delay_expression.: AFTER delay_expression  */
#line 1430 "./bvl_bcomp_y.y"
                {}
#line 2987 "y.tab.c"
    break;

  case 92: /* delay_expression: abstractlit .time_unit.  */
#line 1436 "./bvl_bcomp_y.y"
                {}
#line 2993 "y.tab.c"
    break;

  case 93: /* .time_unit.: %empty  */
#line 1441 "./bvl_bcomp_y.y"
                {}
#line 2999 "y.tab.c"
    break;

  case 94: /* .time_unit.: _PS  */
#line 1443 "./bvl_bcomp_y.y"
                {}
#line 3005 "y.tab.c"
    break;

  case 95: /* .time_unit.: _NS  */
#line 1445 "./bvl_bcomp_y.y"
                {}
#line 3011 "y.tab.c"
    break;

  case 96: /* .time_unit.: _US  */
#line 1447 "./bvl_bcomp_y.y"
                {}
#line 3017 "y.tab.c"
    break;

  case 97: /* .time_unit.: _MS  */
#line 1449 "./bvl_bcomp_y.y"
                {}
#line 3023 "y.tab.c"
    break;

  case 98: /* $@7: %empty  */
#line 1454 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (NULL ,(yyvsp[0].text)); }
#line 3029 "y.tab.c"
    break;

  case 99: /* choices: choice $@7 ..Bar__choice..  */
#line 1456 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3035 "y.tab.c"
    break;

  case 101: /* ..Bar__choice..: ..Bar__choice.. Bar choice  */
#line 1464 "./bvl_bcomp_y.y"
                {
        if (!strncmp((yyvsp[0].text),"others",7))
		  bvl_error (30,NULL);
		BVL_NM1LST = addchain (BVL_NM1LST ,(yyvsp[0].text));
		}
#line 3045 "y.tab.c"
    break;

  case 102: /* choice: literal  */
#line 1473 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3051 "y.tab.c"
    break;

  case 103: /* choice: OTHERS  */
#line 1475 "./bvl_bcomp_y.y"
                { (yyval.text) = "others"; }
#line 3057 "y.tab.c"
    break;

  case 104: /* choice: name  */
#line 1477 "./bvl_bcomp_y.y"
                {
		char           *val;
		char            val2[256];
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             left_bnd;
		long             right_bnd;
		long             sig_conf;

		strcpy (val2,"B\"");
		sig_conf = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_SIGDFN);
		val      = (char *) beh_chktab (dic,(yyvsp[0].name).NAME,NULL,BVL_PNTDFN);
		if (sig_conf == 0)
		  bvl_error (17,(yyvsp[0].name).NAME);
		else
		  {
		  if (sig_conf != BVL_CSTDFN)
		    bvl_error (76,(yyvsp[0].name).NAME);
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMXDFN);

		left  = (yyvsp[0].name).LEFT;
		right = (yyvsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound = left - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = left - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound = right - left_bnd;
		    out_bound = left - left_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = right - right_bnd;
		    out_bound = left - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }

		bvl_tobin (&val2[2],val,in_bound,out_bound);
		strcat (val2,"\"");
		(yyval.text) = namealloc (val2);
		}
#line 3129 "y.tab.c"
    break;

  case 105: /* .REPORT__expression.: %empty  */
#line 1548 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3135 "y.tab.c"
    break;

  case 106: /* .REPORT__expression.: REPORT report__message  */
#line 1551 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3141 "y.tab.c"
    break;

  case 107: /* .SEVERITY__expression.: %empty  */
#line 1556 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'E'; }
#line 3147 "y.tab.c"
    break;

  case 108: /* .SEVERITY__expression.: SEVERITY severity__message  */
#line 1559 "./bvl_bcomp_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3153 "y.tab.c"
    break;

  case 109: /* report__message: StringLit  */
#line 1564 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3159 "y.tab.c"
    break;

  case 110: /* severity__message: ERROR  */
#line 1569 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'E'; }
#line 3165 "y.tab.c"
    break;

  case 111: /* severity__message: WARNING  */
#line 1571 "./bvl_bcomp_y.y"
                { (yyval.valu) = 'W'; }
#line 3171 "y.tab.c"
    break;

  case 112: /* expression: relation..AND__relation..  */
#line 1576 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3177 "y.tab.c"
    break;

  case 113: /* expression: relation..OR__relation..  */
#line 1578 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3183 "y.tab.c"
    break;

  case 114: /* expression: relation.NAND_NOR__relation.  */
#line 1580 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3189 "y.tab.c"
    break;

  case 115: /* expression: relation..XOR__relation..  */
#line 1582 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3195 "y.tab.c"
    break;

  case 116: /* relation..AND__relation..: relation tok_AND relation  */
#line 1589 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3201 "y.tab.c"
    break;

  case 117: /* relation..AND__relation..: relation..AND__relation.. tok_AND relation  */
#line 1593 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3207 "y.tab.c"
    break;

  case 118: /* relation..OR__relation..: relation _OR relation  */
#line 1600 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3213 "y.tab.c"
    break;

  case 119: /* relation..OR__relation..: relation..OR__relation.. _OR relation  */
#line 1604 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3219 "y.tab.c"
    break;

  case 120: /* relation.NAND_NOR__relation.: relation  */
#line 1609 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3225 "y.tab.c"
    break;

  case 121: /* relation.NAND_NOR__relation.: relation _NAND relation  */
#line 1613 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NAND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3231 "y.tab.c"
    break;

  case 122: /* relation.NAND_NOR__relation.: relation _NOR relation  */
#line 1617 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3237 "y.tab.c"
    break;

  case 123: /* relation..XOR__relation..: relation _XOR relation  */
#line 1625 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3243 "y.tab.c"
    break;

  case 124: /* relation..XOR__relation..: relation..XOR__relation.. _XOR relation  */
#line 1629 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3249 "y.tab.c"
    break;

  case 125: /* relation: simple_expression  */
#line 1634 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3255 "y.tab.c"
    break;

  case 126: /* relation: simple_expression relational_operator simple_expression  */
#line 1638 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl ((yyvsp[-1].valu) ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1); }
#line 3261 "y.tab.c"
    break;

  case 127: /* simple_expression: .sign.term..add_op__term..  */
#line 1643 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3267 "y.tab.c"
    break;

  case 128: /* .sign.term..add_op__term..: term  */
#line 1648 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3273 "y.tab.c"
    break;

  case 129: /* .sign.term..add_op__term..: .sign.term..add_op__term.. Ampersand term  */
#line 1652 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (CONC,(yyvsp[-2].list),(yyvsp[0].list),-1,-1); }
#line 3279 "y.tab.c"
    break;

  case 130: /* term: factor  */
#line 1658 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3285 "y.tab.c"
    break;

  case 131: /* factor: primary  */
#line 1663 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3291 "y.tab.c"
    break;

  case 132: /* factor: _NOT primary  */
#line 1666 "./bvl_bcomp_y.y"
                { (yyval.list) = bvl_crtabl (ABL_NOT,(yyvsp[0].list),BVL_EMPSTR,-1,-1); }
#line 3297 "y.tab.c"
    break;

  case 133: /* primary: literal  */
#line 1671 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		expr1.IDENT = (yyvsp[0].text);
		(yyval.list) = bvl_crtabl (NOPS,expr1,BVL_EMPSTR,-1,-1);
		}
#line 3307 "y.tab.c"
    break;

  case 134: /* primary: aggregate  */
#line 1677 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 3313 "y.tab.c"
    break;

  case 135: /* primary: name  */
#line 1679 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		long             left;
		long             right;
		long             left_bnd;
		long             right_bnd;
		long             in_bound;
		long             out_bound;
		long             sig_conf;

		sig_conf = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		  case (BVL_CSTDFN):
		    break;
		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    bvl_error (26,(yyvsp[0].name).NAME);
		    break;
		  default :
		    bvl_error (17,(yyvsp[0].name).NAME);
		    break;
		  }

		left_bnd  = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMNDFN);
		right_bnd = beh_chktab (dic,(yyvsp[0].name).NAME,BVL_MODNAM,BVL_WMXDFN);

		left  = (yyvsp[0].name).LEFT;
		right = (yyvsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - left_bnd;
		    out_bound = left  - left_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36,(yyvsp[0].name).NAME);
		    }
		  }

		if (sig_conf != BVL_CSTDFN)
		  {
		  expr1.IDENT = (yyvsp[0].name).NAME;
		  if((yyvsp[0].name).FLAG == 'X')
			{
		  	expr1 = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,left,right);
		  	(yyval.list) = bvl_crtabl (ABL_STABLE,expr1,BVL_EMPSTR,left,right);
			}
		  else 
		  	(yyval.list) = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,left,right);
		  }
		else
		  {
		  expr1.IDENT = (char *)beh_chktab(dic,(yyvsp[0].name).NAME,NULL,BVL_PNTDFN);
		  (yyval.list) = bvl_crtabl (NOPS,expr1,BVL_EMPSTR,in_bound,out_bound);
		  }
		}
#line 3409 "y.tab.c"
    break;

  case 136: /* relational_operator: _EQSym  */
#line 1774 "./bvl_bcomp_y.y"
                { (yyval.valu) = EQ; }
#line 3415 "y.tab.c"
    break;

  case 137: /* relational_operator: _NESym  */
#line 1776 "./bvl_bcomp_y.y"
                { (yyval.valu) = NE; }
#line 3421 "y.tab.c"
    break;

  case 138: /* literal: CharacterLit  */
#line 1781 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3427 "y.tab.c"
    break;

  case 139: /* literal: StringLit  */
#line 1783 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3433 "y.tab.c"
    break;

  case 140: /* literal: BitStringLit  */
#line 1785 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3439 "y.tab.c"
    break;

  case 141: /* aggregate: LeftParen expression RightParen  */
#line 1792 "./bvl_bcomp_y.y"
                { (yyval.list) = (yyvsp[-1].list); }
#line 3445 "y.tab.c"
    break;

  case 142: /* name: simple_name  */
#line 1797 "./bvl_bcomp_y.y"
                {
		(yyval.name).NAME  = (yyvsp[0].text);
		(yyval.name).LEFT  = beh_chktab (dic,(yyvsp[0].text),BVL_MODNAM,BVL_WMNDFN);
		(yyval.name).RIGHT = beh_chktab (dic,(yyvsp[0].text),BVL_MODNAM,BVL_WMXDFN);
		}
#line 3455 "y.tab.c"
    break;

  case 143: /* name: indexed_name  */
#line 1803 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3461 "y.tab.c"
    break;

  case 144: /* name: slice_name  */
#line 1805 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3467 "y.tab.c"
    break;

  case 145: /* name: attribute_name  */
#line 1807 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3473 "y.tab.c"
    break;

  case 146: /* indexed_name: simple_name LeftParen abstractlit RightParen_ERR  */
#line 1815 "./bvl_bcomp_y.y"
                {
		(yyval.name).NAME  = (yyvsp[-3].text);
		(yyval.name).LEFT  = (yyvsp[-1].valu);
		(yyval.name).RIGHT = (yyvsp[-1].valu);
		}
#line 3483 "y.tab.c"
    break;

  case 147: /* slice_name: simple_name LeftParen abstractlit direction abstractlit RightParen_ERR  */
#line 1829 "./bvl_bcomp_y.y"
                {
		if ((((yyvsp[-1].valu) > (yyvsp[-3].valu)) && ((yyvsp[-2].valu) != BVL_UPTDFN)) ||
		    (((yyvsp[-1].valu) < (yyvsp[-3].valu)) && ((yyvsp[-2].valu) != BVL_DWTDFN)))
		  bvl_error (32,(yyvsp[-5].text));

		(yyval.name).NAME  = (yyvsp[-5].text);
		(yyval.name).LEFT  = (yyvsp[-3].valu);
		(yyval.name).RIGHT = (yyvsp[-1].valu);
		}
#line 3497 "y.tab.c"
    break;

  case 148: /* attribute_name: simple_name Apostrophe attribute_designator  */
#line 1844 "./bvl_bcomp_y.y"
                {
		char             extname[100];
		char            *lclname;
		long              sig_conf;
		struct bvl_expr  expr1;
		struct bvl_expr  expr2;
		struct chain    *ptabl;

		sig_conf = beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		    break;
		  default :
		    bvl_error (79,(yyvsp[-2].text));
		  }

		if (beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_WMNDFN) != -1)
		  bvl_error (79,(yyvsp[-2].text));

		sprintf (extname,"%s'delayed",(yyvsp[-2].text));
		lclname = namealloc (extname);

		if (BVL_ERRFLG == 0)
		  {
		  if (beh_chktab (dic,(yyvsp[-2].text),BVL_MODNAM,BVL_STBDFN) == 0)
		    {
		    expr1.IDENT = (yyvsp[-2].text);
		    expr1.WIDTH  = 1;
		    expr2 = bvl_crtabl (NOPI,expr1,BVL_EMPSTR,-1,-1);
		    ptabl = expr2.LIST_ABL->DATA;

		    if (BVL_AUXMOD == 1)
		      BVL_BEFPNT->BERIN=beh_addberin(BVL_BEFPNT->BERIN,lclname);

		    BVL_BEFPNT->BEDLY = beh_addbeaux(BVL_BEFPNT->BEDLY,lclname,
		                                     ptabl,NULL);
		    beh_addtab (dic,(yyvsp[-2].text)     ,BVL_MODNAM,BVL_STBDFN,1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_WMNDFN,-1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_WMXDFN,-1);
		    beh_addtab (dic,lclname,BVL_MODNAM,BVL_SIGDFN,
		                (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN));
		    }
		  }
		BVL_BEFPNT->TYPE |= BEH_STABLE;
		(yyval.name).NAME = (yyvsp[-2].text);
		(yyval.name).LEFT = -1;
		(yyval.name).RIGHT = -1;
		(yyval.name).FLAG  = 'X';

		}
#line 3560 "y.tab.c"
    break;

  case 150: /* type_mark: BIT  */
#line 1910 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = BIT; (yyval.dble).FLAG = 'S'; }
#line 3566 "y.tab.c"
    break;

  case 151: /* type_mark: WOR_BIT  */
#line 1912 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = WOR_BIT; (yyval.dble).FLAG = 'S'; }
#line 3572 "y.tab.c"
    break;

  case 152: /* type_mark: MUX_BIT  */
#line 1914 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = MUX_BIT; (yyval.dble).FLAG = 'S'; }
#line 3578 "y.tab.c"
    break;

  case 153: /* type_mark: BIT_VECTOR  */
#line 1916 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = BIT; (yyval.dble).FLAG = 'A'; }
#line 3584 "y.tab.c"
    break;

  case 154: /* type_mark: WOR_VECTOR  */
#line 1918 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = WOR_BIT; (yyval.dble).FLAG = 'A'; }
#line 3590 "y.tab.c"
    break;

  case 155: /* type_mark: MUX_VECTOR  */
#line 1920 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = MUX_BIT; (yyval.dble).FLAG = 'A'; }
#line 3596 "y.tab.c"
    break;

  case 156: /* type_mark: REG_BIT  */
#line 1922 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = REG_BIT; (yyval.dble).FLAG = 'S'; }
#line 3602 "y.tab.c"
    break;

  case 157: /* type_mark: REG_VECTOR  */
#line 1924 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = REG_BIT; (yyval.dble).FLAG = 'A'; }
#line 3608 "y.tab.c"
    break;

  case 158: /* type_mark: NATURAL  */
#line 1926 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = NATURAL; (yyval.dble).FLAG = 'S'; }
#line 3614 "y.tab.c"
    break;

  case 159: /* type_mark: NATURAL_VECTOR  */
#line 1928 "./bvl_bcomp_y.y"
                { (yyval.dble).VALU = NATURAL; (yyval.dble).FLAG = 'A'; }
#line 3620 "y.tab.c"
    break;

  case 160: /* $@8: %empty  */
#line 1933 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST,(yyvsp[0].text)); }
#line 3626 "y.tab.c"
    break;

  case 163: /* ...identifier..: ...identifier.. Comma Identifier  */
#line 1942 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST,(yyvsp[0].text)); }
#line 3632 "y.tab.c"
    break;

  case 164: /* .label.: %empty  */
#line 1947 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3638 "y.tab.c"
    break;

  case 165: /* .label.: label  */
#line 1949 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3644 "y.tab.c"
    break;

  case 166: /* .guard_expression.: %empty  */
#line 1954 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3650 "y.tab.c"
    break;

  case 167: /* .guard_expression.: guard_expression  */
#line 1956 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3656 "y.tab.c"
    break;

  case 168: /* guard_expression: LeftParen expression RightParen_ERR  */
#line 1963 "./bvl_bcomp_y.y"
                { (yyval.text) = (char *)(yyvsp[-1].list).LIST_ABL->DATA; }
#line 3662 "y.tab.c"
    break;

  case 169: /* .GUARDED.: %empty  */
#line 1968 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_UNGDFN ; }
#line 3668 "y.tab.c"
    break;

  case 170: /* .GUARDED.: GUARDED  */
#line 1970 "./bvl_bcomp_y.y"
                { (yyval.valu) = BVL_GRDDFN; }
#line 3674 "y.tab.c"
    break;

  case 171: /* .simple_name.: %empty  */
#line 1975 "./bvl_bcomp_y.y"
                { (yyval.text) = NULL; }
#line 3680 "y.tab.c"
    break;

  case 172: /* .simple_name.: simple_name  */
#line 1977 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3686 "y.tab.c"
    break;

  case 173: /* simple_name: Identifier  */
#line 1982 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3692 "y.tab.c"
    break;

  case 174: /* target: name  */
#line 1987 "./bvl_bcomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 3698 "y.tab.c"
    break;

  case 175: /* a_label: label Colon  */
#line 1993 "./bvl_bcomp_y.y"
                {
		BVL_LBLNAM = (yyvsp[-1].text);
		(yyval.text) = (yyvsp[-1].text);
		}
#line 3707 "y.tab.c"
    break;

  case 176: /* label: Identifier  */
#line 2001 "./bvl_bcomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3713 "y.tab.c"
    break;

  case 177: /* abstractlit: AbstractLit  */
#line 2006 "./bvl_bcomp_y.y"
                { (yyval.valu) = atoi ((yyvsp[0].text)); }
#line 3719 "y.tab.c"
    break;

  case 178: /* RightParen_ERR: RightParen  */
#line 2011 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3725 "y.tab.c"
    break;

  case 179: /* Semicolon_ERR: Semicolon  */
#line 2016 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3731 "y.tab.c"
    break;

  case 180: /* END_ERR: _END  */
#line 2021 "./bvl_bcomp_y.y"
                { yyerrok; }
#line 3737 "y.tab.c"
    break;


#line 3741 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2023 "./bvl_bcomp_y.y"


void *addstr (

struct befig *ptfig,
char          object,
long           mode,
long           type,
char          flag,
char         *name,
short         left,
short         right )

  {
  void  *pnt    = NULL;
  char   porflg = 0;
  char   rinflg = 0;
  char   outflg = 0;
  char   busflg = 0;
  char   auxflg = 0;
  char   buxflg = 0;
  char   regflg = 0;
  char   lclmod = 0;
  char   lcltyp = 0;
  char   extname[100];
  short  i;
  short  inc = 1;

  switch (object)
    {
    case 'P':

	/* ###------------------------------------------------------### */
	/*   if object is a port ...					*/
	/* ###------------------------------------------------------### */

      porflg = 1;
      switch (mode)
        {
        case _IN:
          lclmod = 'I'; lcltyp = 'B'; rinflg = 1; break;
        case _OUT:
          switch (type)
            {
            case BIT:
              lclmod = 'O'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'Z'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'Z'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        case _INOUT:
          rinflg = 1;
          switch (type)
            {
            case BIT:
              lclmod = 'B'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'T'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'T'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        }
      break;

    case 'S':

	/* ###------------------------------------------------------### */
	/*   if object is a signal ...					*/
	/* ###------------------------------------------------------### */

      switch (type)
        {
        case BIT:
          lcltyp = 'B'; rinflg = BVL_AUXMOD; auxflg = 1; break;
        case REG_BIT:
          rinflg = 1; regflg = 1; break;
        case MUX_BIT:
          lcltyp = 'M'; rinflg = 1; buxflg = 1; break;
        case WOR_BIT:
          lcltyp = 'W'; rinflg = 1; buxflg = 1; break;
        }
      break;
    }

  if (flag == 'S')
    {
	/* ###------------------------------------------------------### */
	/*   if object is a scalar ...					*/
	/* ###------------------------------------------------------### */

    if (porflg == 1)
      ptfig->BEPOR = beh_addbepor (ptfig->BEPOR,name,lclmod,lcltyp);
    if (rinflg == 1)
      ptfig->BERIN = beh_addberin (ptfig->BERIN,name);
    if (outflg == 1)
      ptfig->BEOUT = beh_addbeout (ptfig->BEOUT,name,NULL,NULL);
    if (busflg == 1)
      ptfig->BEBUS = beh_addbebus (ptfig->BEBUS,name,NULL,NULL,lcltyp);
    if (auxflg == 1)
      ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX,name,NULL,NULL);
    if (buxflg == 1)
      ptfig->BEBUX = beh_addbebux (ptfig->BEBUX,name,NULL,NULL,lcltyp);
    if (regflg == 1)
      ptfig->BEREG = beh_addbereg (ptfig->BEREG,name,NULL,NULL);

    }
  else
    {
	/* ###------------------------------------------------------### */
	/*   if object is an array ...					*/
	/* ###------------------------------------------------------### */

    if (left >= right)
      inc = -1;

    for (i=left ; i!=(right+inc) ; i+=inc)
      {
      sprintf (extname,"%s %d",name,i);

      if (porflg == 1)
        ptfig->BEPOR = beh_addbepor (ptfig->BEPOR,extname,lclmod,lcltyp);
      if (rinflg == 1)
        ptfig->BERIN = beh_addberin (ptfig->BERIN,extname);
      if (outflg == 1)
        ptfig->BEOUT = beh_addbeout (ptfig->BEOUT,extname,NULL,NULL);
      if (busflg == 1)
        ptfig->BEBUS = beh_addbebus (ptfig->BEBUS,extname,NULL,NULL,lcltyp);
      if (auxflg == 1)
        ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX,extname,NULL,NULL);
      if (buxflg == 1)
        ptfig->BEBUX = beh_addbebux (ptfig->BEBUX,extname,NULL,NULL,lcltyp);
      if (regflg == 1)
        ptfig->BEREG = beh_addbereg (ptfig->BEREG,extname,NULL,NULL);
      }
    }

  if (outflg == 1)
    pnt = (void *) ptfig->BEOUT;
  if (busflg == 1)
    pnt = (void *) ptfig->BEBUS;
  if (auxflg == 1)
    pnt = (void *) ptfig->BEAUX;
  if (buxflg == 1)
    pnt = (void *) ptfig->BEBUX;
  if (regflg == 1)
    pnt = (void *) ptfig->BEREG;

  return (pnt);
  }

static long 
chkdcl (
char object,
long  mode,
long  type,
char flag,
long  kind,
char constraint,
long  *conf  )

  {
  long errflg = 0;
  long lclcnf = 0;

  if (flag != constraint)
    {
    errflg = 1;
    bvl_error (33,NULL);
    }
  else
    {
    switch (object)
      {
      case 'P':
	/* ###------------------------------------------------------### */
	/*    If object is a port :					*/
	/*       - if type is bit, no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:

            lclcnf += BVL_BITDFN + BVL_NORDFN;
            switch (mode)
              {
              case _IN :
                lclcnf += BVL_ICNDFN; break;
              case _OUT:
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != 0)
              errflg = 1;
            break;

          case MUX_BIT:

            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case WOR_BIT:

            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case REG_BIT:
          case NATURAL:

            errflg = 1;
            break;
          }
        if (errflg == 1)
          bvl_error (5,NULL);
        break;

      case 'G':
	/* ###------------------------------------------------------### */
	/*    If object is a generic :					*/
	/*       - only natural type is allowed				*/
	/* ###------------------------------------------------------### */

        if ((type != NATURAL) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (77,NULL);
          }
        break;

      case 'S':
	/* ###------------------------------------------------------### */
	/*    If object is a signal :					*/
	/*       - no mode can be specified				*/
	/*       - if type is bit no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - if type is reg_bit, register kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:
            lclcnf += BVL_BITDFN + BVL_NORDFN;
            if ((mode != 0) || (kind != 0))
              errflg = 1;
            break;
          case MUX_BIT:
            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case WOR_BIT:
            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case REG_BIT:
            lclcnf += BVL_RBIDFN + BVL_REGDFN;
            if ((mode != 0) || (kind != REGISTER))
              errflg = 1;
            break;
          case NATURAL:
            errflg = 1; break;
          }

        if (mode != 0)
          errflg = 1;

        if (errflg == 1)
          bvl_error (11,NULL);
        break;

      case 'C':
	/* ###------------------------------------------------------### */
	/*    If object is a constant :					*/
	/*       - only bit type without any other indication is legal	*/
	/* ###------------------------------------------------------### */

        lclcnf += BVL_CSTDFN;
        if ((type != BIT) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (78,NULL);
          }
        break;
      }
    }

  *conf = lclcnf ;
  return (errflg);
  }
