/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with CTL_Y__ or ctp_y__.  They are
   private implementation details that can be changed or removed.  */

#ifndef CTL_Y__CTL_Y__Y_TAB_H_INCLUDED
# define CTL_Y__CTL_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef CTL_Y_DEBUG
# define CTL_Y_DEBUG 0
#endif
#if CTL_Y_DEBUG
extern int ctp_y_debug;
#endif

/* Token kinds.  */
#ifndef CTL_Y_TOKENTYPE
# define CTL_Y_TOKENTYPE
  enum ctp_y_tokentype
  {
    CTL_Y_EMPTY = -2,
    CTL_Y_EOF = 0,                     /* "end of file"  */
    CTL_Y_error = 256,                 /* error  */
    CTL_Y_UNDEF = 257,                 /* "invalid token"  */
    _AF = 258,                     /* _AF  */
    _AG = 259,                     /* _AG  */
    _AX = 260,                     /* _AX  */
    _AU = 261,                     /* _AU  */
    _EF = 262,                     /* _EF  */
    _EG = 263,                     /* _EG  */
    _EX = 264,                     /* _EX  */
    _EU = 265,                     /* _EU  */
    Imply = 266,                   /* Imply  */
    Equiv = 267,                   /* Equiv  */
    tok_AND = 268,                 /* tok_AND  */
    _BEGIN = 269,                  /* _BEGIN  */
    _END = 270,                    /* _END  */
    _EQSym = 271,                  /* _EQSym  */
    _EXIT = 272,                   /* _EXIT  */
    _FILE = 273,                   /* _FILE  */
    _GESym = 274,                  /* _GESym  */
    _GTSym = 275,                  /* _GTSym  */
    _IN = 276,                     /* _IN  */
    _INOUT = 277,                  /* _INOUT  */
    _LABEL = 278,                  /* _LABEL  */
    _LESym = 279,                  /* _LESym  */
    _LINKAGE = 280,                /* _LINKAGE  */
    _LTSym = 281,                  /* _LTSym  */
    _NAND = 282,                   /* _NAND  */
    _IFT = 283,                    /* _IFT  */
    _NXOR = 284,                   /* _NXOR  */
    _NESym = 285,                  /* _NESym  */
    _NEXT = 286,                   /* _NEXT  */
    _NOR = 287,                    /* _NOR  */
    _NOT = 288,                    /* _NOT  */
    _OR = 289,                     /* _OR  */
    _OUT = 290,                    /* _OUT  */
    _XOR = 291,                    /* _XOR  */
    ABS = 292,                     /* ABS  */
    ACCESS = 293,                  /* ACCESS  */
    AFTER = 294,                   /* AFTER  */
    ALIAS = 295,                   /* ALIAS  */
    ALL = 296,                     /* ALL  */
    ARCHITECTURE = 297,            /* ARCHITECTURE  */
    ARRAY = 298,                   /* ARRAY  */
    ASSERT = 299,                  /* ASSERT  */
    ATTRIBUTE = 300,               /* ATTRIBUTE  */
    AbstractLit = 301,             /* AbstractLit  */
    Ampersand = 302,               /* Ampersand  */
    Apostrophe = 303,              /* Apostrophe  */
    Arrow = 304,                   /* Arrow  */
    BLOCK = 305,                   /* BLOCK  */
    BODY = 306,                    /* BODY  */
    BUS = 307,                     /* BUS  */
    _BUFFER = 308,                 /* _BUFFER  */
    Bar = 309,                     /* Bar  */
    BasedInt = 310,                /* BasedInt  */
    BasedReal = 311,               /* BasedReal  */
    BitStringLit = 312,            /* BitStringLit  */
    _TRUE = 313,                   /* _TRUE  */
    _FALSE = 314,                  /* _FALSE  */
    Box = 315,                     /* Box  */
    CASE = 316,                    /* CASE  */
    COMPONENT = 317,               /* COMPONENT  */
    CONFIGURATION = 318,           /* CONFIGURATION  */
    _DEFINE = 319,                 /* _DEFINE  */
    _ASSUME = 320,                 /* _ASSUME  */
    _INITIAL = 321,                /* _INITIAL  */
    _RESET_COND = 322,             /* _RESET_COND  */
    CharacterLit = 323,            /* CharacterLit  */
    Colon = 324,                   /* Colon  */
    Comma = 325,                   /* Comma  */
    DISCONNECT = 326,              /* DISCONNECT  */
    DOWNTO = 327,                  /* DOWNTO  */
    DecimalInt = 328,              /* DecimalInt  */
    DecimalReal = 329,             /* DecimalReal  */
    Dot = 330,                     /* Dot  */
    DoubleStar = 331,              /* DoubleStar  */
    ELSE = 332,                    /* ELSE  */
    ELSIF = 333,                   /* ELSIF  */
    _ENTITY = 334,                 /* _ENTITY  */
    ERROR = 335,                   /* ERROR  */
    _EVENT = 336,                  /* _EVENT  */
    _LEFT = 337,                   /* _LEFT  */
    _LENGTH = 338,                 /* _LENGTH  */
    _RIGHT = 339,                  /* _RIGHT  */
    _HIGH = 340,                   /* _HIGH  */
    _LOW = 341,                    /* _LOW  */
    FOR = 342,                     /* FOR  */
    FUNCTION = 343,                /* FUNCTION  */
    GENERATE = 344,                /* GENERATE  */
    GENERIC = 345,                 /* GENERIC  */
    GUARDED = 346,                 /* GUARDED  */
    IF = 347,                      /* IF  */
    IS = 348,                      /* IS  */
    _NS = 349,                     /* _NS  */
    _PS = 350,                     /* _PS  */
    _FS = 351,                     /* _FS  */
    _MS = 352,                     /* _MS  */
    Identifier = 353,              /* Identifier  */
    _LIBRARY = 354,                /* _LIBRARY  */
    LOOP = 355,                    /* LOOP  */
    LeftParen = 356,               /* LeftParen  */
    MAP = 357,                     /* MAP  */
    MOD = 358,                     /* MOD  */
    Minus = 359,                   /* Minus  */
    NEW = 360,                     /* NEW  */
    OF = 361,                      /* OF  */
    ON = 362,                      /* ON  */
    OPEN = 363,                    /* OPEN  */
    OTHERS = 364,                  /* OTHERS  */
    _PACKAGE = 365,                /* _PACKAGE  */
    PORT = 366,                    /* PORT  */
    PROCEDURE = 367,               /* PROCEDURE  */
    PROCESS = 368,                 /* PROCESS  */
    Plus = 369,                    /* Plus  */
    _RANGE = 370,                  /* _RANGE  */
    _REV_RANGE = 371,              /* _REV_RANGE  */
    RECORD = 372,                  /* RECORD  */
    REGISTER = 373,                /* REGISTER  */
    REM = 374,                     /* REM  */
    REPORT = 375,                  /* REPORT  */
    _RETURN = 376,                 /* _RETURN  */
    RightParen = 377,              /* RightParen  */
    SELECT = 378,                  /* SELECT  */
    SEVERITY = 379,                /* SEVERITY  */
    SIGNAL = 380,                  /* SIGNAL  */
    _STABLE = 381,                 /* _STABLE  */
    SUBTYPE = 382,                 /* SUBTYPE  */
    Semicolon = 383,               /* Semicolon  */
    Slash = 384,                   /* Slash  */
    Star = 385,                    /* Star  */
    StringLit = 386,               /* StringLit  */
    THEN = 387,                    /* THEN  */
    TO = 388,                      /* TO  */
    TRANSPORT = 389,               /* TRANSPORT  */
    _TYPE = 390,                   /* _TYPE  */
    UNITS = 391,                   /* UNITS  */
    UNTIL = 392,                   /* UNTIL  */
    USE = 393,                     /* USE  */
    _VARIABLE = 394,               /* _VARIABLE  */
    VarAsgn = 395,                 /* VarAsgn  */
    WAIT = 396,                    /* WAIT  */
    WARNING = 397,                 /* WARNING  */
    WHEN = 398,                    /* WHEN  */
    WHILE = 399,                   /* WHILE  */
    WITH = 400                     /* WITH  */
  };
  typedef enum ctp_y_tokentype ctp_y_token_kind_t;
#endif
/* Token kinds.  */
#define CTL_Y_EMPTY -2
#define CTL_Y_EOF 0
#define CTL_Y_error 256
#define CTL_Y_UNDEF 257
#define _AF 258
#define _AG 259
#define _AX 260
#define _AU 261
#define _EF 262
#define _EG 263
#define _EX 264
#define _EU 265
#define Imply 266
#define Equiv 267
#define tok_AND 268
#define _BEGIN 269
#define _END 270
#define _EQSym 271
#define _EXIT 272
#define _FILE 273
#define _GESym 274
#define _GTSym 275
#define _IN 276
#define _INOUT 277
#define _LABEL 278
#define _LESym 279
#define _LINKAGE 280
#define _LTSym 281
#define _NAND 282
#define _IFT 283
#define _NXOR 284
#define _NESym 285
#define _NEXT 286
#define _NOR 287
#define _NOT 288
#define _OR 289
#define _OUT 290
#define _XOR 291
#define ABS 292
#define ACCESS 293
#define AFTER 294
#define ALIAS 295
#define ALL 296
#define ARCHITECTURE 297
#define ARRAY 298
#define ASSERT 299
#define ATTRIBUTE 300
#define AbstractLit 301
#define Ampersand 302
#define Apostrophe 303
#define Arrow 304
#define BLOCK 305
#define BODY 306
#define BUS 307
#define _BUFFER 308
#define Bar 309
#define BasedInt 310
#define BasedReal 311
#define BitStringLit 312
#define _TRUE 313
#define _FALSE 314
#define Box 315
#define CASE 316
#define COMPONENT 317
#define CONFIGURATION 318
#define _DEFINE 319
#define _ASSUME 320
#define _INITIAL 321
#define _RESET_COND 322
#define CharacterLit 323
#define Colon 324
#define Comma 325
#define DISCONNECT 326
#define DOWNTO 327
#define DecimalInt 328
#define DecimalReal 329
#define Dot 330
#define DoubleStar 331
#define ELSE 332
#define ELSIF 333
#define _ENTITY 334
#define ERROR 335
#define _EVENT 336
#define _LEFT 337
#define _LENGTH 338
#define _RIGHT 339
#define _HIGH 340
#define _LOW 341
#define FOR 342
#define FUNCTION 343
#define GENERATE 344
#define GENERIC 345
#define GUARDED 346
#define IF 347
#define IS 348
#define _NS 349
#define _PS 350
#define _FS 351
#define _MS 352
#define Identifier 353
#define _LIBRARY 354
#define LOOP 355
#define LeftParen 356
#define MAP 357
#define MOD 358
#define Minus 359
#define NEW 360
#define OF 361
#define ON 362
#define OPEN 363
#define OTHERS 364
#define _PACKAGE 365
#define PORT 366
#define PROCEDURE 367
#define PROCESS 368
#define Plus 369
#define _RANGE 370
#define _REV_RANGE 371
#define RECORD 372
#define REGISTER 373
#define REM 374
#define REPORT 375
#define _RETURN 376
#define RightParen 377
#define SELECT 378
#define SEVERITY 379
#define SIGNAL 380
#define _STABLE 381
#define SUBTYPE 382
#define Semicolon 383
#define Slash 384
#define Star 385
#define StringLit 386
#define THEN 387
#define TO 388
#define TRANSPORT 389
#define _TYPE 390
#define UNITS 391
#define UNTIL 392
#define USE 393
#define _VARIABLE 394
#define VarAsgn 395
#define WAIT 396
#define WARNING 397
#define WHEN 398
#define WHILE 399
#define WITH 400

/* Value type.  */
#if ! defined CTL_Y_STYPE && ! defined CTL_Y_STYPE_IS_DECLARED
union CTL_Y_STYPE
{
#line 65 "./ctp_y.y"

          long          valu;
          char         *text;
          chain_list   *pcha;
          ctp_name      name;
          ctp_vexstr    list;
          ctltype_list  type;
       

#line 367 "y.tab.h"

};
typedef union CTL_Y_STYPE CTL_Y_STYPE;
# define CTL_Y_STYPE_IS_TRIVIAL 1
# define CTL_Y_STYPE_IS_DECLARED 1
#endif


extern CTL_Y_STYPE ctp_y_lval;


int ctp_y_parse (void);


#endif /* !CTL_Y__CTL_Y__Y_TAB_H_INCLUDED  */
