/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 33 "./ctp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "vex.h"
#include "ctl.h"

#include "ctp_utype.h"
#include "ctp_bedef.h"
#include "ctp_bspec.h"
#include "ctp_byacc.h"

#if 1
# define my_fprintf fprintf( stdout, "%s.%d:", autbasename(__FILE__,NULL), __LINE__ ); fprintf
# define my_ctp_error(N,V) \
   do { fprintf( stderr, "%s.%d:", autbasename(__FILE__,NULL), __LINE__); ctp_error(N,V); } while(0)
#else
# define my_fprintf   fprintf
# define my_ctp_error ctp_error
#endif

extern int   ctp_y_lex   (void);
extern void  ctp_y_error (char*);

#ifdef CTP_DEBUG
#define YYDEBUG 1
#endif


#line 103 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    _AF = 258,                     /* _AF  */
    _AG = 259,                     /* _AG  */
    _AX = 260,                     /* _AX  */
    _AU = 261,                     /* _AU  */
    _EF = 262,                     /* _EF  */
    _EG = 263,                     /* _EG  */
    _EX = 264,                     /* _EX  */
    _EU = 265,                     /* _EU  */
    Imply = 266,                   /* Imply  */
    Equiv = 267,                   /* Equiv  */
    tok_AND = 268,                 /* tok_AND  */
    _BEGIN = 269,                  /* _BEGIN  */
    _END = 270,                    /* _END  */
    _EQSym = 271,                  /* _EQSym  */
    _EXIT = 272,                   /* _EXIT  */
    _FILE = 273,                   /* _FILE  */
    _GESym = 274,                  /* _GESym  */
    _GTSym = 275,                  /* _GTSym  */
    _IN = 276,                     /* _IN  */
    _INOUT = 277,                  /* _INOUT  */
    _LABEL = 278,                  /* _LABEL  */
    _LESym = 279,                  /* _LESym  */
    _LINKAGE = 280,                /* _LINKAGE  */
    _LTSym = 281,                  /* _LTSym  */
    _NAND = 282,                   /* _NAND  */
    _IFT = 283,                    /* _IFT  */
    _NXOR = 284,                   /* _NXOR  */
    _NESym = 285,                  /* _NESym  */
    _NEXT = 286,                   /* _NEXT  */
    _NOR = 287,                    /* _NOR  */
    _NOT = 288,                    /* _NOT  */
    _OR = 289,                     /* _OR  */
    _OUT = 290,                    /* _OUT  */
    _XOR = 291,                    /* _XOR  */
    ABS = 292,                     /* ABS  */
    ACCESS = 293,                  /* ACCESS  */
    AFTER = 294,                   /* AFTER  */
    ALIAS = 295,                   /* ALIAS  */
    ALL = 296,                     /* ALL  */
    ARCHITECTURE = 297,            /* ARCHITECTURE  */
    ARRAY = 298,                   /* ARRAY  */
    ASSERT = 299,                  /* ASSERT  */
    ATTRIBUTE = 300,               /* ATTRIBUTE  */
    AbstractLit = 301,             /* AbstractLit  */
    Ampersand = 302,               /* Ampersand  */
    Apostrophe = 303,              /* Apostrophe  */
    Arrow = 304,                   /* Arrow  */
    BLOCK = 305,                   /* BLOCK  */
    BODY = 306,                    /* BODY  */
    BUS = 307,                     /* BUS  */
    _BUFFER = 308,                 /* _BUFFER  */
    Bar = 309,                     /* Bar  */
    BasedInt = 310,                /* BasedInt  */
    BasedReal = 311,               /* BasedReal  */
    BitStringLit = 312,            /* BitStringLit  */
    _TRUE = 313,                   /* _TRUE  */
    _FALSE = 314,                  /* _FALSE  */
    Box = 315,                     /* Box  */
    CASE = 316,                    /* CASE  */
    COMPONENT = 317,               /* COMPONENT  */
    CONFIGURATION = 318,           /* CONFIGURATION  */
    _DEFINE = 319,                 /* _DEFINE  */
    _ASSUME = 320,                 /* _ASSUME  */
    _INITIAL = 321,                /* _INITIAL  */
    _RESET_COND = 322,             /* _RESET_COND  */
    CharacterLit = 323,            /* CharacterLit  */
    Colon = 324,                   /* Colon  */
    Comma = 325,                   /* Comma  */
    DISCONNECT = 326,              /* DISCONNECT  */
    DOWNTO = 327,                  /* DOWNTO  */
    DecimalInt = 328,              /* DecimalInt  */
    DecimalReal = 329,             /* DecimalReal  */
    Dot = 330,                     /* Dot  */
    DoubleStar = 331,              /* DoubleStar  */
    ELSE = 332,                    /* ELSE  */
    ELSIF = 333,                   /* ELSIF  */
    _ENTITY = 334,                 /* _ENTITY  */
    ERROR = 335,                   /* ERROR  */
    _EVENT = 336,                  /* _EVENT  */
    _LEFT = 337,                   /* _LEFT  */
    _LENGTH = 338,                 /* _LENGTH  */
    _RIGHT = 339,                  /* _RIGHT  */
    _HIGH = 340,                   /* _HIGH  */
    _LOW = 341,                    /* _LOW  */
    FOR = 342,                     /* FOR  */
    FUNCTION = 343,                /* FUNCTION  */
    GENERATE = 344,                /* GENERATE  */
    GENERIC = 345,                 /* GENERIC  */
    GUARDED = 346,                 /* GUARDED  */
    IF = 347,                      /* IF  */
    IS = 348,                      /* IS  */
    _NS = 349,                     /* _NS  */
    _PS = 350,                     /* _PS  */
    _FS = 351,                     /* _FS  */
    _MS = 352,                     /* _MS  */
    Identifier = 353,              /* Identifier  */
    _LIBRARY = 354,                /* _LIBRARY  */
    LOOP = 355,                    /* LOOP  */
    LeftParen = 356,               /* LeftParen  */
    MAP = 357,                     /* MAP  */
    MOD = 358,                     /* MOD  */
    Minus = 359,                   /* Minus  */
    NEW = 360,                     /* NEW  */
    OF = 361,                      /* OF  */
    ON = 362,                      /* ON  */
    OPEN = 363,                    /* OPEN  */
    OTHERS = 364,                  /* OTHERS  */
    _PACKAGE = 365,                /* _PACKAGE  */
    PORT = 366,                    /* PORT  */
    PROCEDURE = 367,               /* PROCEDURE  */
    PROCESS = 368,                 /* PROCESS  */
    Plus = 369,                    /* Plus  */
    _RANGE = 370,                  /* _RANGE  */
    _REV_RANGE = 371,              /* _REV_RANGE  */
    RECORD = 372,                  /* RECORD  */
    REGISTER = 373,                /* REGISTER  */
    REM = 374,                     /* REM  */
    REPORT = 375,                  /* REPORT  */
    _RETURN = 376,                 /* _RETURN  */
    RightParen = 377,              /* RightParen  */
    SELECT = 378,                  /* SELECT  */
    SEVERITY = 379,                /* SEVERITY  */
    SIGNAL = 380,                  /* SIGNAL  */
    _STABLE = 381,                 /* _STABLE  */
    SUBTYPE = 382,                 /* SUBTYPE  */
    Semicolon = 383,               /* Semicolon  */
    Slash = 384,                   /* Slash  */
    Star = 385,                    /* Star  */
    StringLit = 386,               /* StringLit  */
    THEN = 387,                    /* THEN  */
    TO = 388,                      /* TO  */
    TRANSPORT = 389,               /* TRANSPORT  */
    _TYPE = 390,                   /* _TYPE  */
    UNITS = 391,                   /* UNITS  */
    UNTIL = 392,                   /* UNTIL  */
    USE = 393,                     /* USE  */
    _VARIABLE = 394,               /* _VARIABLE  */
    VarAsgn = 395,                 /* VarAsgn  */
    WAIT = 396,                    /* WAIT  */
    WARNING = 397,                 /* WARNING  */
    WHEN = 398,                    /* WHEN  */
    WHILE = 399,                   /* WHILE  */
    WITH = 400                     /* WITH  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define _AF 258
#define _AG 259
#define _AX 260
#define _AU 261
#define _EF 262
#define _EG 263
#define _EX 264
#define _EU 265
#define Imply 266
#define Equiv 267
#define tok_AND 268
#define _BEGIN 269
#define _END 270
#define _EQSym 271
#define _EXIT 272
#define _FILE 273
#define _GESym 274
#define _GTSym 275
#define _IN 276
#define _INOUT 277
#define _LABEL 278
#define _LESym 279
#define _LINKAGE 280
#define _LTSym 281
#define _NAND 282
#define _IFT 283
#define _NXOR 284
#define _NESym 285
#define _NEXT 286
#define _NOR 287
#define _NOT 288
#define _OR 289
#define _OUT 290
#define _XOR 291
#define ABS 292
#define ACCESS 293
#define AFTER 294
#define ALIAS 295
#define ALL 296
#define ARCHITECTURE 297
#define ARRAY 298
#define ASSERT 299
#define ATTRIBUTE 300
#define AbstractLit 301
#define Ampersand 302
#define Apostrophe 303
#define Arrow 304
#define BLOCK 305
#define BODY 306
#define BUS 307
#define _BUFFER 308
#define Bar 309
#define BasedInt 310
#define BasedReal 311
#define BitStringLit 312
#define _TRUE 313
#define _FALSE 314
#define Box 315
#define CASE 316
#define COMPONENT 317
#define CONFIGURATION 318
#define _DEFINE 319
#define _ASSUME 320
#define _INITIAL 321
#define _RESET_COND 322
#define CharacterLit 323
#define Colon 324
#define Comma 325
#define DISCONNECT 326
#define DOWNTO 327
#define DecimalInt 328
#define DecimalReal 329
#define Dot 330
#define DoubleStar 331
#define ELSE 332
#define ELSIF 333
#define _ENTITY 334
#define ERROR 335
#define _EVENT 336
#define _LEFT 337
#define _LENGTH 338
#define _RIGHT 339
#define _HIGH 340
#define _LOW 341
#define FOR 342
#define FUNCTION 343
#define GENERATE 344
#define GENERIC 345
#define GUARDED 346
#define IF 347
#define IS 348
#define _NS 349
#define _PS 350
#define _FS 351
#define _MS 352
#define Identifier 353
#define _LIBRARY 354
#define LOOP 355
#define LeftParen 356
#define MAP 357
#define MOD 358
#define Minus 359
#define NEW 360
#define OF 361
#define ON 362
#define OPEN 363
#define OTHERS 364
#define _PACKAGE 365
#define PORT 366
#define PROCEDURE 367
#define PROCESS 368
#define Plus 369
#define _RANGE 370
#define _REV_RANGE 371
#define RECORD 372
#define REGISTER 373
#define REM 374
#define REPORT 375
#define _RETURN 376
#define RightParen 377
#define SELECT 378
#define SEVERITY 379
#define SIGNAL 380
#define _STABLE 381
#define SUBTYPE 382
#define Semicolon 383
#define Slash 384
#define Star 385
#define StringLit 386
#define THEN 387
#define TO 388
#define TRANSPORT 389
#define _TYPE 390
#define UNITS 391
#define UNTIL 392
#define USE 393
#define _VARIABLE 394
#define VarAsgn 395
#define WAIT 396
#define WARNING 397
#define WHEN 398
#define WHILE 399
#define WITH 400

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 65 "./ctp_y.y"

          long          valu;
          char         *text;
          chain_list   *pcha;
          ctp_name      name;
          ctp_vexstr    list;
          ctltype_list  type;
       

#line 456 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL__AF = 3,                        /* _AF  */
  YYSYMBOL__AG = 4,                        /* _AG  */
  YYSYMBOL__AX = 5,                        /* _AX  */
  YYSYMBOL__AU = 6,                        /* _AU  */
  YYSYMBOL__EF = 7,                        /* _EF  */
  YYSYMBOL__EG = 8,                        /* _EG  */
  YYSYMBOL__EX = 9,                        /* _EX  */
  YYSYMBOL__EU = 10,                       /* _EU  */
  YYSYMBOL_Imply = 11,                     /* Imply  */
  YYSYMBOL_Equiv = 12,                     /* Equiv  */
  YYSYMBOL_tok_AND = 13,                   /* tok_AND  */
  YYSYMBOL__BEGIN = 14,                    /* _BEGIN  */
  YYSYMBOL__END = 15,                      /* _END  */
  YYSYMBOL__EQSym = 16,                    /* _EQSym  */
  YYSYMBOL__EXIT = 17,                     /* _EXIT  */
  YYSYMBOL__FILE = 18,                     /* _FILE  */
  YYSYMBOL__GESym = 19,                    /* _GESym  */
  YYSYMBOL__GTSym = 20,                    /* _GTSym  */
  YYSYMBOL__IN = 21,                       /* _IN  */
  YYSYMBOL__INOUT = 22,                    /* _INOUT  */
  YYSYMBOL__LABEL = 23,                    /* _LABEL  */
  YYSYMBOL__LESym = 24,                    /* _LESym  */
  YYSYMBOL__LINKAGE = 25,                  /* _LINKAGE  */
  YYSYMBOL__LTSym = 26,                    /* _LTSym  */
  YYSYMBOL__NAND = 27,                     /* _NAND  */
  YYSYMBOL__IFT = 28,                      /* _IFT  */
  YYSYMBOL__NXOR = 29,                     /* _NXOR  */
  YYSYMBOL__NESym = 30,                    /* _NESym  */
  YYSYMBOL__NEXT = 31,                     /* _NEXT  */
  YYSYMBOL__NOR = 32,                      /* _NOR  */
  YYSYMBOL__NOT = 33,                      /* _NOT  */
  YYSYMBOL__OR = 34,                       /* _OR  */
  YYSYMBOL__OUT = 35,                      /* _OUT  */
  YYSYMBOL__XOR = 36,                      /* _XOR  */
  YYSYMBOL_ABS = 37,                       /* ABS  */
  YYSYMBOL_ACCESS = 38,                    /* ACCESS  */
  YYSYMBOL_AFTER = 39,                     /* AFTER  */
  YYSYMBOL_ALIAS = 40,                     /* ALIAS  */
  YYSYMBOL_ALL = 41,                       /* ALL  */
  YYSYMBOL_ARCHITECTURE = 42,              /* ARCHITECTURE  */
  YYSYMBOL_ARRAY = 43,                     /* ARRAY  */
  YYSYMBOL_ASSERT = 44,                    /* ASSERT  */
  YYSYMBOL_ATTRIBUTE = 45,                 /* ATTRIBUTE  */
  YYSYMBOL_AbstractLit = 46,               /* AbstractLit  */
  YYSYMBOL_Ampersand = 47,                 /* Ampersand  */
  YYSYMBOL_Apostrophe = 48,                /* Apostrophe  */
  YYSYMBOL_Arrow = 49,                     /* Arrow  */
  YYSYMBOL_BLOCK = 50,                     /* BLOCK  */
  YYSYMBOL_BODY = 51,                      /* BODY  */
  YYSYMBOL_BUS = 52,                       /* BUS  */
  YYSYMBOL__BUFFER = 53,                   /* _BUFFER  */
  YYSYMBOL_Bar = 54,                       /* Bar  */
  YYSYMBOL_BasedInt = 55,                  /* BasedInt  */
  YYSYMBOL_BasedReal = 56,                 /* BasedReal  */
  YYSYMBOL_BitStringLit = 57,              /* BitStringLit  */
  YYSYMBOL__TRUE = 58,                     /* _TRUE  */
  YYSYMBOL__FALSE = 59,                    /* _FALSE  */
  YYSYMBOL_Box = 60,                       /* Box  */
  YYSYMBOL_CASE = 61,                      /* CASE  */
  YYSYMBOL_COMPONENT = 62,                 /* COMPONENT  */
  YYSYMBOL_CONFIGURATION = 63,             /* CONFIGURATION  */
  YYSYMBOL__DEFINE = 64,                   /* _DEFINE  */
  YYSYMBOL__ASSUME = 65,                   /* _ASSUME  */
  YYSYMBOL__INITIAL = 66,                  /* _INITIAL  */
  YYSYMBOL__RESET_COND = 67,               /* _RESET_COND  */
  YYSYMBOL_CharacterLit = 68,              /* CharacterLit  */
  YYSYMBOL_Colon = 69,                     /* Colon  */
  YYSYMBOL_Comma = 70,                     /* Comma  */
  YYSYMBOL_DISCONNECT = 71,                /* DISCONNECT  */
  YYSYMBOL_DOWNTO = 72,                    /* DOWNTO  */
  YYSYMBOL_DecimalInt = 73,                /* DecimalInt  */
  YYSYMBOL_DecimalReal = 74,               /* DecimalReal  */
  YYSYMBOL_Dot = 75,                       /* Dot  */
  YYSYMBOL_DoubleStar = 76,                /* DoubleStar  */
  YYSYMBOL_ELSE = 77,                      /* ELSE  */
  YYSYMBOL_ELSIF = 78,                     /* ELSIF  */
  YYSYMBOL__ENTITY = 79,                   /* _ENTITY  */
  YYSYMBOL_ERROR = 80,                     /* ERROR  */
  YYSYMBOL__EVENT = 81,                    /* _EVENT  */
  YYSYMBOL__LEFT = 82,                     /* _LEFT  */
  YYSYMBOL__LENGTH = 83,                   /* _LENGTH  */
  YYSYMBOL__RIGHT = 84,                    /* _RIGHT  */
  YYSYMBOL__HIGH = 85,                     /* _HIGH  */
  YYSYMBOL__LOW = 86,                      /* _LOW  */
  YYSYMBOL_FOR = 87,                       /* FOR  */
  YYSYMBOL_FUNCTION = 88,                  /* FUNCTION  */
  YYSYMBOL_GENERATE = 89,                  /* GENERATE  */
  YYSYMBOL_GENERIC = 90,                   /* GENERIC  */
  YYSYMBOL_GUARDED = 91,                   /* GUARDED  */
  YYSYMBOL_IF = 92,                        /* IF  */
  YYSYMBOL_IS = 93,                        /* IS  */
  YYSYMBOL__NS = 94,                       /* _NS  */
  YYSYMBOL__PS = 95,                       /* _PS  */
  YYSYMBOL__FS = 96,                       /* _FS  */
  YYSYMBOL__MS = 97,                       /* _MS  */
  YYSYMBOL_Identifier = 98,                /* Identifier  */
  YYSYMBOL__LIBRARY = 99,                  /* _LIBRARY  */
  YYSYMBOL_LOOP = 100,                     /* LOOP  */
  YYSYMBOL_LeftParen = 101,                /* LeftParen  */
  YYSYMBOL_MAP = 102,                      /* MAP  */
  YYSYMBOL_MOD = 103,                      /* MOD  */
  YYSYMBOL_Minus = 104,                    /* Minus  */
  YYSYMBOL_NEW = 105,                      /* NEW  */
  YYSYMBOL_OF = 106,                       /* OF  */
  YYSYMBOL_ON = 107,                       /* ON  */
  YYSYMBOL_OPEN = 108,                     /* OPEN  */
  YYSYMBOL_OTHERS = 109,                   /* OTHERS  */
  YYSYMBOL__PACKAGE = 110,                 /* _PACKAGE  */
  YYSYMBOL_PORT = 111,                     /* PORT  */
  YYSYMBOL_PROCEDURE = 112,                /* PROCEDURE  */
  YYSYMBOL_PROCESS = 113,                  /* PROCESS  */
  YYSYMBOL_Plus = 114,                     /* Plus  */
  YYSYMBOL__RANGE = 115,                   /* _RANGE  */
  YYSYMBOL__REV_RANGE = 116,               /* _REV_RANGE  */
  YYSYMBOL_RECORD = 117,                   /* RECORD  */
  YYSYMBOL_REGISTER = 118,                 /* REGISTER  */
  YYSYMBOL_REM = 119,                      /* REM  */
  YYSYMBOL_REPORT = 120,                   /* REPORT  */
  YYSYMBOL__RETURN = 121,                  /* _RETURN  */
  YYSYMBOL_RightParen = 122,               /* RightParen  */
  YYSYMBOL_SELECT = 123,                   /* SELECT  */
  YYSYMBOL_SEVERITY = 124,                 /* SEVERITY  */
  YYSYMBOL_SIGNAL = 125,                   /* SIGNAL  */
  YYSYMBOL__STABLE = 126,                  /* _STABLE  */
  YYSYMBOL_SUBTYPE = 127,                  /* SUBTYPE  */
  YYSYMBOL_Semicolon = 128,                /* Semicolon  */
  YYSYMBOL_Slash = 129,                    /* Slash  */
  YYSYMBOL_Star = 130,                     /* Star  */
  YYSYMBOL_StringLit = 131,                /* StringLit  */
  YYSYMBOL_THEN = 132,                     /* THEN  */
  YYSYMBOL_TO = 133,                       /* TO  */
  YYSYMBOL_TRANSPORT = 134,                /* TRANSPORT  */
  YYSYMBOL__TYPE = 135,                    /* _TYPE  */
  YYSYMBOL_UNITS = 136,                    /* UNITS  */
  YYSYMBOL_UNTIL = 137,                    /* UNTIL  */
  YYSYMBOL_USE = 138,                      /* USE  */
  YYSYMBOL__VARIABLE = 139,                /* _VARIABLE  */
  YYSYMBOL_VarAsgn = 140,                  /* VarAsgn  */
  YYSYMBOL_WAIT = 141,                     /* WAIT  */
  YYSYMBOL_WARNING = 142,                  /* WARNING  */
  YYSYMBOL_WHEN = 143,                     /* WHEN  */
  YYSYMBOL_WHILE = 144,                    /* WHILE  */
  YYSYMBOL_WITH = 145,                     /* WITH  */
  YYSYMBOL_YYACCEPT = 146,                 /* $accept  */
  YYSYMBOL_ctl_file = 147,                 /* ctl_file  */
  YYSYMBOL_148_1 = 148,                    /* $@1  */
  YYSYMBOL_ctl_body = 149,                 /* ctl_body  */
  YYSYMBOL_ctl_declarative_part = 150,     /* ctl_declarative_part  */
  YYSYMBOL_151_block_declarative_item_ = 151, /* ..block_declarative_item..  */
  YYSYMBOL_block_declarative_item = 152,   /* block_declarative_item  */
  YYSYMBOL_constant_declaration = 153,     /* constant_declaration  */
  YYSYMBOL_assumption_declaration = 154,   /* assumption_declaration  */
  YYSYMBOL_initial_declaration = 155,      /* initial_declaration  */
  YYSYMBOL_reset_cond_declaration = 156,   /* reset_cond_declaration  */
  YYSYMBOL_constant_VarAsgn__expression = 157, /* constant_VarAsgn__expression  */
  YYSYMBOL_variable_declaration = 158,     /* variable_declaration  */
  YYSYMBOL_type_declaration = 159,         /* type_declaration  */
  YYSYMBOL_full_type_declaration = 160,    /* full_type_declaration  */
  YYSYMBOL_type_definition = 161,          /* type_definition  */
  YYSYMBOL_subtype_declaration = 162,      /* subtype_declaration  */
  YYSYMBOL_subtype_indication = 163,       /* subtype_indication  */
  YYSYMBOL_type_or_function_name = 164,    /* type_or_function_name  */
  YYSYMBOL_scalar_type_definition = 165,   /* scalar_type_definition  */
  YYSYMBOL_enumeration_type_definition = 166, /* enumeration_type_definition  */
  YYSYMBOL_167_enumeration_literal_ = 167, /* ...enumeration_literal..  */
  YYSYMBOL_enumeration_literal = 168,      /* enumeration_literal  */
  YYSYMBOL_composite_type_definition = 169, /* composite_type_definition  */
  YYSYMBOL_array_type_definition = 170,    /* array_type_definition  */
  YYSYMBOL_constrained_array_definition = 171, /* constrained_array_definition  */
  YYSYMBOL_index_constraint = 172,         /* index_constraint  */
  YYSYMBOL_discrete_range = 173,           /* discrete_range  */
  YYSYMBOL_174_constraint_ = 174,          /* .constraint.  */
  YYSYMBOL_constraint = 175,               /* constraint  */
  YYSYMBOL_range_constraint = 176,         /* range_constraint  */
  YYSYMBOL_range = 177,                    /* range  */
  YYSYMBOL_direction = 178,                /* direction  */
  YYSYMBOL_type_mark = 179,                /* type_mark  */
  YYSYMBOL_ctl_statement_part = 180,       /* ctl_statement_part  */
  YYSYMBOL_181_concurrent_statement_ = 181, /* ..concurrent_statement..  */
  YYSYMBOL_concurrent_statement = 182,     /* concurrent_statement  */
  YYSYMBOL_formula_assignment_statement = 183, /* formula_assignment_statement  */
  YYSYMBOL_expression = 184,               /* expression  */
  YYSYMBOL_185_relation_AND__relation_ = 185, /* relation..AND__relation..  */
  YYSYMBOL_186_relation_OR__relation_ = 186, /* relation..OR__relation..  */
  YYSYMBOL_187_relation_NAND_NOR_NXOR_relation_ = 187, /* relation.NAND_NOR_NXOR_relation.  */
  YYSYMBOL_188_relation_XOR__relation_ = 188, /* relation..XOR__relation..  */
  YYSYMBOL_relation = 189,                 /* relation  */
  YYSYMBOL_simple_expression = 190,        /* simple_expression  */
  YYSYMBOL_191_sign_term_add_op__term_ = 191, /* .sign.term..add_op__term..  */
  YYSYMBOL_adding_operator = 192,          /* adding_operator  */
  YYSYMBOL_sign = 193,                     /* sign  */
  YYSYMBOL_multiplying_operator = 194,     /* multiplying_operator  */
  YYSYMBOL_term = 195,                     /* term  */
  YYSYMBOL_factor = 196,                   /* factor  */
  YYSYMBOL_primary = 197,                  /* primary  */
  YYSYMBOL_qualified_expression = 198,     /* qualified_expression  */
  YYSYMBOL_relational_operator = 199,      /* relational_operator  */
  YYSYMBOL_literal = 200,                  /* literal  */
  YYSYMBOL_aggregate = 201,                /* aggregate  */
  YYSYMBOL_202_element_association_ = 202, /* ...element_association..  */
  YYSYMBOL_element_association = 203,      /* element_association  */
  YYSYMBOL_name = 204,                     /* name  */
  YYSYMBOL_indexed_name = 205,             /* indexed_name  */
  YYSYMBOL_slice_name = 206,               /* slice_name  */
  YYSYMBOL_attribute_name = 207,           /* attribute_name  */
  YYSYMBOL_attribute_designator = 208,     /* attribute_designator  */
  YYSYMBOL_identifier_list = 209,          /* identifier_list  */
  YYSYMBOL_210_2 = 210,                    /* $@2  */
  YYSYMBOL_211_identifier_ = 211,          /* ...identifier..  */
  YYSYMBOL_simple_name = 212,              /* simple_name  */
  YYSYMBOL_RightParen_ERR = 213,           /* RightParen_ERR  */
  YYSYMBOL_Semicolon_ERR = 214,            /* Semicolon_ERR  */
  YYSYMBOL_END_ERR = 215                   /* END_ERR  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   376

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  146
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  70
/* YYNRULES -- Number of rules.  */
#define YYNRULES  151
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  251

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   400


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   278,   278,   278,   319,   329,   333,   334,   339,   340,
     341,   342,   343,   344,   345,   346,   354,   418,   459,   500,
     542,   548,   622,   626,   649,   651,   653,   658,   680,   699,
     719,   725,   731,   787,   788,   795,   799,   806,   813,   818,
     874,   881,   883,   888,   895,   900,   907,   912,   921,   927,
     937,   974,   976,   983,  1001,  1005,  1006,  1011,  1012,  1018,
    1041,  1043,  1045,  1047,  1052,  1058,  1067,  1073,  1082,  1084,
    1090,  1096,  1102,  1108,  1117,  1129,  1135,  1144,  1146,  1155,
    1160,  1162,  1174,  1183,  1185,  1187,  1191,  1193,  1198,  1200,
    1202,  1204,  1209,  1211,  1220,  1224,  1230,  1235,  1240,  1245,
    1250,  1255,  1260,  1265,  1273,  1283,  1310,  1399,  1415,  1462,
    1464,  1466,  1468,  1470,  1472,  1474,  1476,  1481,  1483,  1486,
    1488,  1490,  1492,  1497,  1513,  1516,  1530,  1539,  1553,  1567,
    1569,  1571,  1576,  1649,  1689,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1780,  1779,  1785,  1786,  1795,  1800,
    1805,  1810
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "_AF", "_AG", "_AX",
  "_AU", "_EF", "_EG", "_EX", "_EU", "Imply", "Equiv", "tok_AND", "_BEGIN",
  "_END", "_EQSym", "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT",
  "_LABEL", "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_IFT", "_NXOR",
  "_NESym", "_NEXT", "_NOR", "_NOT", "_OR", "_OUT", "_XOR", "ABS",
  "ACCESS", "AFTER", "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT",
  "ATTRIBUTE", "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BLOCK",
  "BODY", "BUS", "_BUFFER", "Bar", "BasedInt", "BasedReal", "BitStringLit",
  "_TRUE", "_FALSE", "Box", "CASE", "COMPONENT", "CONFIGURATION",
  "_DEFINE", "_ASSUME", "_INITIAL", "_RESET_COND", "CharacterLit", "Colon",
  "Comma", "DISCONNECT", "DOWNTO", "DecimalInt", "DecimalReal", "Dot",
  "DoubleStar", "ELSE", "ELSIF", "_ENTITY", "ERROR", "_EVENT", "_LEFT",
  "_LENGTH", "_RIGHT", "_HIGH", "_LOW", "FOR", "FUNCTION", "GENERATE",
  "GENERIC", "GUARDED", "IF", "IS", "_NS", "_PS", "_FS", "_MS",
  "Identifier", "_LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "Minus",
  "NEW", "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE",
  "PROCESS", "Plus", "_RANGE", "_REV_RANGE", "RECORD", "REGISTER", "REM",
  "REPORT", "_RETURN", "RightParen", "SELECT", "SEVERITY", "SIGNAL",
  "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star", "StringLit", "THEN",
  "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "_VARIABLE",
  "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH", "$accept",
  "ctl_file", "$@1", "ctl_body", "ctl_declarative_part",
  "..block_declarative_item..", "block_declarative_item",
  "constant_declaration", "assumption_declaration", "initial_declaration",
  "reset_cond_declaration", "constant_VarAsgn__expression",
  "variable_declaration", "type_declaration", "full_type_declaration",
  "type_definition", "subtype_declaration", "subtype_indication",
  "type_or_function_name", "scalar_type_definition",
  "enumeration_type_definition", "...enumeration_literal..",
  "enumeration_literal", "composite_type_definition",
  "array_type_definition", "constrained_array_definition",
  "index_constraint", "discrete_range", ".constraint.", "constraint",
  "range_constraint", "range", "direction", "type_mark",
  "ctl_statement_part", "..concurrent_statement..", "concurrent_statement",
  "formula_assignment_statement", "expression",
  "relation..AND__relation..", "relation..OR__relation..",
  "relation.NAND_NOR_NXOR_relation.", "relation..XOR__relation..",
  "relation", "simple_expression", ".sign.term..add_op__term..",
  "adding_operator", "sign", "multiplying_operator", "term", "factor",
  "primary", "qualified_expression", "relational_operator", "literal",
  "aggregate", "...element_association..", "element_association", "name",
  "indexed_name", "slice_name", "attribute_name", "attribute_designator",
  "identifier_list", "$@2", "...identifier..", "simple_name",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-99)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-55)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -99,    21,   -99,   -99,   -99,    14,    15,   -99,   -98,   -57,
     -43,   -42,   -38,   -34,   -33,   -30,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,   -99,    44,     2,   -99,   -99,    -8,
     -71,   -71,   -71,   -22,    -7,   -99,    20,   -99,   -98,   -98,
     -99,   -99,   -99,    22,    -3,   118,   -98,   -98,   -98,    -3,
       7,   -99,    -3,   -99,   -99,   118,   -49,   -99,   110,   110,
     110,     3,   110,   110,   110,    10,   110,   110,   -99,   -99,
     -99,   -99,   -99,    39,   -99,   -99,   -99,   -99,   100,    81,
     -99,    82,   231,   287,   -20,   196,    62,   -99,    43,   -99,
     -99,   -99,    96,   -99,   -99,   -99,    37,   -99,   -99,   -99,
     -98,    -3,   -49,    51,   -98,    59,   -44,   -98,   -99,   -99,
     -99,   -99,   -99,    91,   -49,   -98,   126,   126,   -71,   -99,
     -99,   -99,   -99,   -99,   126,   -99,   -99,   -99,   126,   -99,
     -99,   103,   -99,   -99,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   126,   -99,   -99,   -99,   196,    62,   -99,   -99,
     -99,   -99,   196,   110,   207,    39,   -99,   -99,   -49,   -99,
     -99,   126,    60,   -99,   -99,   -99,   -99,    73,   -98,   -99,
      52,   -60,   -23,   -99,   -98,   112,   117,   118,   -45,   -99,
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
      62,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,    90,   -99,    52,   -99,   -99,   -28,
     -48,    -3,   -19,   -99,   -99,   -99,   -99,   -99,   -99,   126,
     -99,   126,   126,   -99,    39,   -99,   126,   -99,   -99,   -99,
     -44,   -99,   -99,    52,    52,   -99,    52,   -99,   -99,   -99,
     -99
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     6,     1,     3,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    10,    11,
      12,     9,    13,    22,    14,     0,     0,   150,    15,     0,
       0,     0,     0,     0,     0,   144,     0,   151,     0,     0,
     148,    56,    57,     0,     0,     0,     0,     0,     0,     0,
       0,   146,     0,     4,    58,     0,    44,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,   120,
     121,   122,   118,     0,    87,    86,   119,    20,    60,    61,
      62,    63,    68,    77,    79,     0,    80,    92,    94,   107,
     104,   105,   106,   129,   130,   131,   128,    17,    18,    19,
       0,     0,    44,    53,     0,     0,     0,     0,    24,    31,
      25,    37,    38,   145,    44,     0,     0,     0,     0,    45,
      46,    99,    98,   100,     0,   101,   102,   103,     0,    97,
      96,     0,   126,   124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   116,   115,   109,   111,   112,   113,
     114,   110,     0,    85,    84,    83,     0,    81,    90,    91,
      89,    88,     0,     0,     0,     0,   132,    27,    44,    29,
      26,     0,     0,    36,    35,    33,    23,     0,     0,    59,
       0,     0,   131,    48,     0,     0,     0,     0,     0,    65,
      67,    76,    64,    69,    72,    71,    70,    66,    75,    78,
      82,    93,    95,   136,   137,   141,   138,   140,   139,   142,
     143,   135,   108,   134,    77,    28,     0,    41,    43,   106,
     128,     0,     0,   147,    21,   149,    47,    52,    51,     0,
      16,     0,     0,   127,     0,   123,     0,    40,    42,    39,
       0,    32,    50,     0,     0,   125,     0,    34,    74,    73,
     133
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -25,   -99,   -99,   -99,   -99,   -99,   -32,   -99,   -99,
     -99,   -99,   -67,   -99,   -99,   -99,   -99,   -99,   -80,   -99,
     -31,   -79,   -24,   -39,   -99,   -99,   -99,   -99,   -41,   -99,
     -99,   -99,   -99,   144,    41,   -99,   -99,   -99,   -99,   -66,
      18,   -27,   -99,   -99,   -99,   -81,   -99,   -36,    25,   -99,
     -99,   -59,   -99,   -99,   -99,   -99,   -26,    -9,   -37,   -99
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     2,     4,     5,     6,    16,    17,    18,    19,
      20,    46,    21,    22,    23,   107,    24,   100,   101,   108,
     109,   222,   175,   110,   111,   112,   172,   216,   118,   119,
     120,   180,   229,   102,    25,    26,    41,    42,   132,    78,
      79,    80,    81,    82,    83,    84,   156,    85,   162,    86,
      87,    88,    89,   152,    90,    91,   188,   133,    92,    93,
      94,    95,   213,    36,    51,   113,    96,   226,    28,    38
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,    53,    54,    39,    77,    56,    47,    48,   104,    97,
      98,    99,   227,   114,   115,   166,     8,   -54,    57,   157,
     164,     3,   169,   103,   173,   234,    57,   153,     7,    -5,
      27,   121,   122,   123,   178,   125,   126,   127,   183,   129,
     130,    29,    58,    59,    60,    61,    62,    63,    64,    65,
     105,   240,   116,   165,   174,    30,    31,   182,   182,    37,
      32,    44,   168,   167,    33,    34,   117,   170,    35,    45,
     176,    49,    66,   228,   -53,    57,    67,   225,   179,     9,
      10,    11,    12,   212,   154,    68,    50,   117,   215,    52,
     200,    55,   217,   184,   155,    40,    69,    70,    71,   -49,
      40,   144,   145,   225,   124,   -49,   146,    72,   106,   147,
     148,   128,   182,   134,   149,   135,   150,   -49,   136,   163,
     151,    58,    59,    60,    61,    62,    63,    64,    65,    58,
      59,    60,   218,    62,    63,    64,   202,    40,   165,   166,
      73,   224,    13,    74,   164,   220,   233,   230,   131,   -30,
      14,    66,   187,    75,    15,    67,    68,   181,   181,    66,
     171,   177,   227,    67,    68,   158,   221,    69,    70,    71,
      76,   223,    68,   247,   225,    69,    70,    71,    72,   235,
     201,   159,   231,    69,    70,    71,    72,   232,   238,   239,
     236,   160,   161,   199,    72,   103,   219,     0,   245,    58,
      59,    60,     0,    62,    63,    64,   214,   237,    40,     0,
       0,    73,   181,   241,     0,     0,    40,     0,     0,    73,
       0,     0,    74,   228,    40,     0,     0,    73,     0,    66,
      74,     0,    75,    67,   248,   249,     0,   250,     0,     0,
      75,    76,    68,     0,   137,     0,     0,     0,     0,    76,
       0,     0,     0,    69,    70,    71,     0,    76,   138,   139,
     140,     0,     0,   141,    72,   142,     0,   143,   185,     0,
     242,     0,   186,     0,     0,     0,     0,   246,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   203,   204,
     205,   206,   207,   208,    40,     0,     0,    73,   144,   145,
       0,     0,     0,   146,     0,     0,   147,   148,    73,     0,
       0,   149,     0,   150,     0,     0,     0,   151,     0,     0,
       0,     0,   209,   210,     0,     0,     0,    76,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244
};

static const yytype_int16 yycheck[] =
{
      26,    38,    39,     1,    45,    44,    31,    32,     1,    46,
      47,    48,    72,    52,    55,    96,     1,    15,    44,    85,
      48,     0,   102,    49,    68,    70,    52,    47,    14,    14,
     128,    58,    59,    60,   114,    62,    63,    64,   117,    66,
      67,    98,     3,     4,     5,     6,     7,     8,     9,    10,
      43,    70,   101,   101,    98,    98,    98,   116,   117,    15,
      98,    69,   101,   100,    98,    98,   115,   104,    98,   140,
     107,    93,    33,   133,   122,   101,    37,   122,   115,    64,
      65,    66,    67,   164,   104,    46,    93,   115,   168,    69,
     156,    69,   171,   118,   114,    98,    57,    58,    59,   122,
      98,    11,    12,   122,   101,   128,    16,    68,   101,    19,
      20,   101,   171,    13,    24,    34,    26,   140,    36,    76,
      30,     3,     4,     5,     6,     7,     8,     9,    10,     3,
       4,     5,   171,     7,     8,     9,   163,    98,   101,   220,
     101,   178,   127,   104,    48,   171,   187,   184,   109,    98,
     135,    33,    49,   114,   139,    37,    46,   116,   117,    33,
     101,    70,    72,    37,    46,   103,   106,    57,    58,    59,
     131,    98,    46,   240,   122,    57,    58,    59,    68,   188,
     162,   119,    70,    57,    58,    59,    68,    70,   219,   221,
     214,   129,   130,   152,    68,   221,   171,    -1,   234,     3,
       4,     5,    -1,     7,     8,     9,   165,   216,    98,    -1,
      -1,   101,   171,   222,    -1,    -1,    98,    -1,    -1,   101,
      -1,    -1,   104,   133,    98,    -1,    -1,   101,    -1,    33,
     104,    -1,   114,    37,   243,   244,    -1,   246,    -1,    -1,
     114,   131,    46,    -1,    13,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,    57,    58,    59,    -1,   131,    27,    28,
      29,    -1,    -1,    32,    68,    34,    -1,    36,   124,    -1,
     229,    -1,   128,    -1,    -1,    -1,    -1,   236,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    81,    82,
      83,    84,    85,    86,    98,    -1,    -1,   101,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,   101,    -1,
      -1,    24,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,   115,   116,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,   232
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   147,   148,     0,   149,   150,   151,    14,     1,    64,
      65,    66,    67,   127,   135,   139,   152,   153,   154,   155,
     156,   158,   159,   160,   162,   180,   181,   128,   214,    98,
      98,    98,    98,    98,    98,    98,   209,    15,   215,     1,
      98,   182,   183,   212,    69,   140,   157,   157,   157,    93,
      93,   210,    69,   214,   214,    69,   179,   212,     3,     4,
       5,     6,     7,     8,     9,    10,    33,    37,    46,    57,
      58,    59,    68,   101,   104,   114,   131,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   195,   196,   197,   198,
     200,   201,   204,   205,   206,   207,   212,   214,   214,   214,
     163,   164,   179,   212,     1,    43,   101,   161,   165,   166,
     169,   170,   171,   211,   179,   184,   101,   115,   174,   175,
     176,   197,   197,   197,   101,   197,   197,   197,   101,   197,
     197,   109,   184,   203,    13,    34,    36,    13,    27,    28,
      29,    32,    34,    36,    11,    12,    16,    19,    20,    24,
      26,    30,   199,    47,   104,   114,   192,   195,   103,   119,
     129,   130,   194,    76,    48,   101,   201,   214,   179,   174,
     214,   101,   172,    68,    98,   168,   214,    70,   174,   214,
     177,   190,   207,   177,   157,   189,   189,    49,   202,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   190,
     195,   196,   197,    81,    82,    83,    84,    85,    86,   115,
     116,   126,   201,   208,   190,   174,   173,   177,   179,   204,
     212,   106,   167,    98,   214,   122,   213,    72,   133,   178,
     214,    70,    70,   184,    70,   213,   178,   213,   176,   163,
      70,   213,   190,   189,   189,   203,   190,   168,   213,   213,
     213
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   146,   148,   147,   149,   150,   151,   151,   152,   152,
     152,   152,   152,   152,   152,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   161,   161,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   168,   169,   170,   171,
     172,   173,   173,   173,   174,   174,   175,   175,   176,   177,
     177,   178,   178,   179,   180,   181,   181,   182,   182,   183,
     184,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   188,   188,   189,   189,   190,
     191,   191,   191,   192,   192,   192,   193,   193,   194,   194,
     194,   194,   195,   195,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   197,   197,   197,   197,   198,   199,
     199,   199,   199,   199,   199,   199,   199,   200,   200,   200,
     200,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     204,   204,   205,   206,   207,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   210,   209,   211,   211,   212,   213,
     214,   215
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     5,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     7,     4,     4,     4,
       2,     6,     1,     5,     1,     1,     2,     5,     3,     2,
       1,     1,     4,     0,     3,     1,     1,     1,     1,     4,
       3,     1,     2,     1,     0,     1,     1,     3,     2,     1,
       3,     1,     1,     1,     1,     0,     2,     1,     2,     4,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     6,     6,     3,     3,     1,     3,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     0,     3,     1,     3,     1,     1,
       1,     1,     2,     6,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     1,     1,
       1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 278 "./ctp_y.y"
          {
            ctltype_list *CtlType;

            CTP_HEADFIG = addctlfig( CTP_FILENAME );;
            CTP_MODNAM  = CTP_HEADFIG->NAME;
            addctlpredefinedtype( CTP_HEADFIG );

            hshtab = initab ();

            CTP_NM1LST = NULL;
            CTP_INSLST = NULL;
            CTP_LINLST = NULL;
            CTP_VALLST = NULL;

            CTP_ERRFLG    = 0;
            CTP_LINNUM    = 1;
            CTP_NUMTYP    = 0;

            CtlType = CTP_HEADFIG->TYPE;

            while( CtlType )
            {
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_LBLDFN,CtlType->CLASS);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_TYPDFN,CtlType->INDEX);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMNDFN,CtlType->LEFT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMXDFN,CtlType->RIGHT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_PNTDFN,(long)CtlType);

              CtlType = CtlType->NEXT;
            }

            CTP_NUMTYP = VEX_MAX_TYPE;
          }
#line 1932 "y.tab.c"
    break;

  case 3: /* ctl_file: $@1 ctl_body  */
#line 313 "./ctp_y.y"
          {
            fretab( hshtab );
          }
#line 1940 "y.tab.c"
    break;

  case 4: /* ctl_body: ctl_declarative_part _BEGIN ctl_statement_part END_ERR Semicolon_ERR  */
#line 324 "./ctp_y.y"
         {
         }
#line 1947 "y.tab.c"
    break;

  case 15: /* block_declarative_item: error Semicolon_ERR  */
#line 348 "./ctp_y.y"
         {
           my_ctp_error(9,NULL);
         }
#line 1955 "y.tab.c"
    break;

  case 16: /* constant_declaration: _DEFINE Identifier Colon type_mark .constraint. constant_VarAsgn__expression Semicolon_ERR  */
#line 361 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlCst;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( (yyvsp[-3].name).NAME );

          if ( ( (yyvsp[-2].name).LEFT  == -1 ) &&
               ( (yyvsp[-2].name).RIGHT == -1 ) )
          {
            AttrLeft  = Type->LEFT;
            AttrRight = Type->RIGHT;
          }
          else
          {
            AttrLeft  = (yyvsp[-2].name).LEFT;
            AttrRight = (yyvsp[-2].name).RIGHT;
          }

          CtlCst  = (ctldecl_list *)ctp_addstr( 'C',0,val_type((yyvsp[-3].name).NAME),
                 (yyvsp[-3].name).TYPE,(yyvsp[-3].name).FLAG,(yyvsp[-5].text),AttrLeft,AttrRight,VexValue);

          Signed = ( IsVexNodeSigned( CtlCst->VEX_ATOM ) != 0 );

          {
            if ( IsVexAtomBit( CtlCst->VEX_ATOM ) )
            {
              Left  = -1;
              Right = -1;
            }
            else
            {
              Left  = CtlCst->VEX_ATOM->LEFT;
              Right = CtlCst->VEX_ATOM->RIGHT;
            }
          }

          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[-3].name).TYPE);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlCst->VEX_ATOM);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2014 "y.tab.c"
    break;

  case 17: /* assumption_declaration: _ASSUME Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 422 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'A',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2053 "y.tab.c"
    break;

  case 18: /* initial_declaration: _INITIAL Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 463 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'I',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2092 "y.tab.c"
    break;

  case 19: /* reset_cond_declaration: _RESET_COND Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 504 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'R',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2131 "y.tab.c"
    break;

  case 20: /* constant_VarAsgn__expression: VarAsgn expression  */
#line 544 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2137 "y.tab.c"
    break;

  case 21: /* variable_declaration: _VARIABLE identifier_list Colon type_mark .constraint. Semicolon_ERR  */
#line 554 "./ctp_y.y"
          {
            char         *LocalName;
            char         *signame;
            ctltype_list *Type;
            ctldecl_list *CtlVar;
            short         Signed;
            long          Left;
            long          Right;
            long          AttrLeft;
            long          AttrRight;

            LocalName = CTP_MODNAM;
            Type  = val_type( (yyvsp[-2].name).NAME );

            if ( ( (yyvsp[-1].name).LEFT  == -1 ) &&
                 ( (yyvsp[-1].name).RIGHT == -1 ) )
            {
              AttrLeft  = Type->LEFT;
              AttrRight = Type->RIGHT;
            }
            else
            {
              AttrLeft  = (yyvsp[-1].name).LEFT;
              AttrRight = (yyvsp[-1].name).RIGHT;
            }

            CTP_NM1LST = reverse (CTP_NM1LST);

            while (CTP_NM1LST != NULL)
            {
              signame = (char *)CTP_NM1LST->DATA;
              if (chktab (hshtab,signame,LocalName,CTP_SYMDFN) != 0)
                  my_ctp_error (80,signame);

              CtlVar = (ctldecl_list *)ctp_addstr( 'V', 0,
                      val_type((yyvsp[-2].name).NAME),(yyvsp[-2].name).TYPE,
                      (yyvsp[-2].name).FLAG,signame, AttrLeft, AttrRight, NULL );

              Signed = ( IsVexNodeSigned( CtlVar->VEX_ATOM ) != 0 );

              if ( IsVexAtomBit( CtlVar->VEX_ATOM ) )
              {
                Left  = -1;
                Right = -1;
              }
              else
              {
                Left  = CtlVar->VEX_ATOM->LEFT;
                Right = CtlVar->VEX_ATOM->RIGHT;
              }

              addtab (hshtab,signame,LocalName,CTP_SYMDFN,CTP_VARDFN);
              addtab (hshtab,signame,LocalName,CTP_TYPDFN,(yyvsp[-2].name).TYPE);
              addtab (hshtab,signame,LocalName,CTP_WMNDFN,Left);
              addtab (hshtab,signame,LocalName,CTP_WMXDFN,Right);
              addtab (hshtab,signame,LocalName,CTP_ATLDFN,AttrLeft);
              addtab (hshtab,signame,LocalName,CTP_ATRDFN,AttrRight);
              addtab (hshtab,signame,LocalName,CTP_LBLDFN,0);
              addtab (hshtab,signame,LocalName,CTP_PNTDFN,(long)CtlVar->VEX_ATOM);
              addtab (hshtab,signame,LocalName,CTP_SUNDFN,Signed);

              CTP_NM1LST = delchain (CTP_NM1LST,CTP_NM1LST);
            }
          }
#line 2206 "y.tab.c"
    break;

  case 23: /* full_type_declaration: _TYPE Identifier IS type_definition Semicolon_ERR  */
#line 631 "./ctp_y.y"
          {
           ctltype_list *CtlType;

           CtlType = addctltype( CTP_HEADFIG,(yyvsp[-3].text), CTP_NUMTYP, (yyvsp[-1].type).LEFT,
               (yyvsp[-1].type).RIGHT,(yyvsp[-1].type).SIZE,(yyvsp[-1].type).VALUE, (yyvsp[-1].type).CLASS, (yyvsp[-1].type).BASE );
           addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[-1].type).CLASS);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[-1].type).LEFT);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[-1].type).RIGHT);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlType );
           CTP_NUMTYP++;
         }
#line 2226 "y.tab.c"
    break;

  case 24: /* type_definition: scalar_type_definition  */
#line 650 "./ctp_y.y"
              { (yyval.type) = (yyvsp[0].type); }
#line 2232 "y.tab.c"
    break;

  case 25: /* type_definition: composite_type_definition  */
#line 652 "./ctp_y.y"
              { (yyval.type) = (yyvsp[0].type); }
#line 2238 "y.tab.c"
    break;

  case 26: /* type_definition: error Semicolon_ERR  */
#line 654 "./ctp_y.y"
              { yyerrok; }
#line 2244 "y.tab.c"
    break;

  case 27: /* subtype_declaration: SUBTYPE Identifier IS subtype_indication Semicolon_ERR  */
#line 663 "./ctp_y.y"
          {
            ctltype_list *CtlType;

            CtlType = addctltype(CTP_HEADFIG,(yyvsp[-3].text),(yyvsp[-1].type).INDEX,(yyvsp[-1].type).LEFT,
                   (yyvsp[-1].type).RIGHT, (yyvsp[-1].type).SIZE, (yyvsp[-1].type).VALUE, (yyvsp[-1].type).CLASS,(yyvsp[-1].type).BASE );
            addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[-1].type).CLASS);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[-1].type).INDEX);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[-1].type).LEFT);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[-1].type).RIGHT);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE);
            CTP_NUMTYP++;
          }
#line 2263 "y.tab.c"
    break;

  case 28: /* subtype_indication: type_or_function_name type_mark .constraint.  */
#line 683 "./ctp_y.y"
         {
           ctltype_list *ctltype_pnt;
  
           /*mode = */chktab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN);

           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).LEFT  = (yyvsp[0].name).LEFT ;
           (yyval.type).RIGHT = (yyvsp[0].name).RIGHT ;
           (yyval.type).CLASS = (yyvsp[0].name).FLAG ;
         }
#line 2284 "y.tab.c"
    break;

  case 29: /* subtype_indication: type_mark .constraint.  */
#line 701 "./ctp_y.y"
         {
           ctltype_list *ctltype_pnt;
  
           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).CLASS = (yyvsp[0].name).FLAG;

           (yyval.type).LEFT    = (yyvsp[0].name).LEFT ;
           (yyval.type).RIGHT   = (yyvsp[0].name).RIGHT ;
        }
#line 2304 "y.tab.c"
    break;

  case 30: /* type_or_function_name: simple_name  */
#line 720 "./ctp_y.y"
          { (yyval.text) = (yyvsp[0].text); }
#line 2310 "y.tab.c"
    break;

  case 31: /* scalar_type_definition: enumeration_type_definition  */
#line 726 "./ctp_y.y"
          {
            (yyval.type) = (yyvsp[0].type);
          }
#line 2318 "y.tab.c"
    break;

  case 32: /* enumeration_type_definition: LeftParen enumeration_literal ...enumeration_literal.. RightParen_ERR  */
#line 735 "./ctp_y.y"
          {
              char *enumname;
              long  size;
              long  indice;
              char **pnt;
              chain_list *nm1lst;

              CTP_NM1LST = reverse (CTP_NM1LST);

              nm1lst = CTP_NM1LST;
              size   = 0;

              while (nm1lst != NULL)
              {
                size++;
                nm1lst = nm1lst->NEXT;
              }

              pnt = (char **) autallocblock(size * sizeof(char*));

              indice = 0;

              while (CTP_NM1LST != NULL)
              {
                enumname = (char *)CTP_NM1LST->DATA;

                if (chktab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN) != 0)
                  my_ctp_error (82,enumname);

                addtab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMNDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMXDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_LBLDFN,indice);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_PNTDFN,(long)pnt);
                
                pnt[indice++] = enumname;
                CTP_NM1LST = delchain (CTP_NM1LST, CTP_NM1LST);
              }

              (yyval.type).VALUE = pnt ;
              (yyval.type).SIZE = size ;
              (yyval.type).LEFT = -1 ;
              (yyval.type).RIGHT = -1 ;
              (yyval.type).INDEX = CTP_NUMTYP;
              (yyval.type).CLASS = 'E' ;
              (yyval.type).BASE = 0 ;
        }
#line 2371 "y.tab.c"
    break;

  case 34: /* ...enumeration_literal..: ...enumeration_literal.. Comma enumeration_literal  */
#line 791 "./ctp_y.y"
                { yyerrok; }
#line 2377 "y.tab.c"
    break;

  case 35: /* enumeration_literal: Identifier  */
#line 796 "./ctp_y.y"
          {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
          }
#line 2385 "y.tab.c"
    break;

  case 36: /* enumeration_literal: CharacterLit  */
#line 800 "./ctp_y.y"
          {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
          }
#line 2393 "y.tab.c"
    break;

  case 37: /* composite_type_definition: array_type_definition  */
#line 807 "./ctp_y.y"
          {
            (yyval.type) = (yyvsp[0].type);
          }
#line 2401 "y.tab.c"
    break;

  case 38: /* array_type_definition: constrained_array_definition  */
#line 814 "./ctp_y.y"
              { (yyval.type) = (yyvsp[0].type); }
#line 2407 "y.tab.c"
    break;

  case 39: /* constrained_array_definition: ARRAY index_constraint OF subtype_indication  */
#line 822 "./ctp_y.y"
          {
            ctltype_list *NewType;
            char       *name;
            char        buffer[ 32 ];

            (yyval.type) = (yyvsp[0].type);

            if ( (yyvsp[0].type).CLASS == 'U' )
            {
              if ( (yyvsp[0].type).BASE->CLASS != 'A' )
              {
                my_ctp_error(123,NULL);
              }
            }
            else
            if ( (yyvsp[0].type).CLASS == 'A' )
            {
              if ( (yyvsp[0].type).BASE->CLASS != 'U' )
              {
                my_ctp_error(123,NULL);
              }

              sprintf( buffer, "_subtype_%ld", CTP_NUMTYP );
              name = namealloc( buffer );

              NewType = addctltype(CTP_HEADFIG,name,(yyvsp[0].type).INDEX, (yyvsp[0].type).LEFT,
                   (yyvsp[0].type).RIGHT,(yyvsp[0].type).SIZE,(yyvsp[0].type).VALUE,(yyvsp[0].type).CLASS,(yyvsp[0].type).BASE );
              addctlline( CTP_HEADFIG, &NewType->LINE, CTP_LINNUM);
              addtab(hshtab,name,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,name,CTP_MODNAM,CTP_LBLDFN,(yyvsp[0].type).CLASS);
              addtab(hshtab,name,CTP_MODNAM,CTP_TYPDFN,(yyvsp[0].type).INDEX);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMNDFN,(yyvsp[0].type).LEFT);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMXDFN,(yyvsp[0].type).RIGHT);
              addtab(hshtab,name,CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE );
              CTP_NUMTYP++;

              (yyval.type).BASE = NewType;
            }
            else
            {
              my_ctp_error(123,NULL);
            }

            (yyval.type).CLASS = 'A';
            (yyval.type).INDEX = (yyvsp[-2].name).TYPE;

            (yyval.type).LEFT  = (yyvsp[-2].name).LEFT;
            (yyval.type).RIGHT = (yyvsp[-2].name).RIGHT;
          }
#line 2461 "y.tab.c"
    break;

  case 40: /* index_constraint: LeftParen discrete_range RightParen_ERR  */
#line 877 "./ctp_y.y"
         { (yyval.name) = (yyvsp[-1].name);}
#line 2467 "y.tab.c"
    break;

  case 41: /* discrete_range: range  */
#line 882 "./ctp_y.y"
         { (yyval.name) = (yyvsp[0].name);}
#line 2473 "y.tab.c"
    break;

  case 42: /* discrete_range: name range_constraint  */
#line 885 "./ctp_y.y"
         { (yyval.name) = (yyvsp[0].name);
           (yyval.name).NAME = (yyvsp[-1].name).NAME;
         }
#line 2481 "y.tab.c"
    break;

  case 43: /* discrete_range: type_mark  */
#line 890 "./ctp_y.y"
         { (yyval.name) = (yyvsp[0].name);}
#line 2487 "y.tab.c"
    break;

  case 44: /* .constraint.: %empty  */
#line 895 "./ctp_y.y"
        {
          (yyval.name).FLAG   = 'U';
          (yyval.name).LEFT   = -1;
          (yyval.name).RIGHT  = -1;
        }
#line 2497 "y.tab.c"
    break;

  case 45: /* .constraint.: constraint  */
#line 901 "./ctp_y.y"
        { 
          (yyval.name) = (yyvsp[0].name);
        }
#line 2505 "y.tab.c"
    break;

  case 46: /* constraint: range_constraint  */
#line 908 "./ctp_y.y"
         { 
           (yyval.name) = (yyvsp[0].name);
         }
#line 2513 "y.tab.c"
    break;

  case 47: /* constraint: LeftParen range RightParen_ERR  */
#line 915 "./ctp_y.y"
         {
           (yyval.name) = (yyvsp[-1].name);
         }
#line 2521 "y.tab.c"
    break;

  case 48: /* range_constraint: _RANGE range  */
#line 923 "./ctp_y.y"
         { (yyval.name) = (yyvsp[0].name); }
#line 2527 "y.tab.c"
    break;

  case 49: /* range: attribute_name  */
#line 928 "./ctp_y.y"
         {
           if ( ( (yyvsp[0].name).FLAG != CTP_RANGE     ) &&
                ( (yyvsp[0].name).FLAG != CTP_REV_RANGE ) )
           {
             my_ctp_error (32,NULL);
           }

           (yyval.name) = (yyvsp[0].name);
         }
#line 2541 "y.tab.c"
    break;

  case 50: /* range: simple_expression direction simple_expression  */
#line 940 "./ctp_y.y"
         {
           long Left;
           long Right;
           long ErrorL;
           long  ErrorR;

           ErrorL = ctp_vextonum( (yyvsp[-2].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[0].list).VEX, &Right );

           (yyval.name).NAME   = NULL;
           (yyval.name).TYPE   = (yyvsp[-2].list).TYPE;
           (yyval.name).SIGNED = 0;
           (yyval.name).FLAG   = 'A';

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[-1].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[-1].valu) == CTP_DWTDFN)))
             {
               my_ctp_error (32,NULL);
             }

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             (yyval.name).LEFT    = (long)(yyvsp[-2].list).VEX;
             (yyval.name).RIGHT   = (long)(yyvsp[0].list).VEX;
           }
         }
#line 2577 "y.tab.c"
    break;

  case 51: /* direction: TO  */
#line 975 "./ctp_y.y"
                { (yyval.valu) = CTP_UPTDFN; }
#line 2583 "y.tab.c"
    break;

  case 52: /* direction: DOWNTO  */
#line 977 "./ctp_y.y"
                { (yyval.valu) = CTP_DWTDFN; }
#line 2589 "y.tab.c"
    break;

  case 53: /* type_mark: simple_name  */
#line 984 "./ctp_y.y"
           {
              long type;
              (yyval.name).NAME = (yyvsp[0].text);
              (yyval.name).LEFT = -1;
              (yyval.name).RIGHT = -1;
              (yyval.name).TYPE = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_TYPDFN);
              (yyval.name).FLAG = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_LBLDFN);
              type = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_SYMDFN);

              if (type != CTP_TPEDFN || (yyval.name).TYPE ==0)
              {
                my_ctp_error(84,(yyvsp[0].text));
              }
          }
#line 2608 "y.tab.c"
    break;

  case 58: /* concurrent_statement: error Semicolon_ERR  */
#line 1014 "./ctp_y.y"
                { my_ctp_error (18,NULL); }
#line 2614 "y.tab.c"
    break;

  case 59: /* formula_assignment_statement: simple_name Colon expression Semicolon_ERR  */
#line 1022 "./ctp_y.y"
         {
           ctlform_list *CtlForm;
           vexexpr      *VexForm;

           VexForm = simpvexexpr( (yyvsp[-1].list).VEX );

           if (chktab (hshtab,(yyvsp[-3].text), CTP_MODNAM,CTP_SYMDFN) != 0)
           {
             my_ctp_error (80,(yyvsp[-3].text));
           }

           CtlForm = addctlform( CTP_HEADFIG, (yyvsp[-3].text), VexForm );
           addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_LABDFN);
         }
#line 2635 "y.tab.c"
    break;

  case 60: /* expression: relation..AND__relation..  */
#line 1042 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2641 "y.tab.c"
    break;

  case 61: /* expression: relation..OR__relation..  */
#line 1044 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2647 "y.tab.c"
    break;

  case 62: /* expression: relation.NAND_NOR_NXOR_relation.  */
#line 1046 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2653 "y.tab.c"
    break;

  case 63: /* expression: relation..XOR__relation..  */
#line 1048 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2659 "y.tab.c"
    break;

  case 64: /* relation..AND__relation..: relation tok_AND relation  */
#line 1055 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2667 "y.tab.c"
    break;

  case 65: /* relation..AND__relation..: relation..AND__relation.. tok_AND relation  */
#line 1061 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2675 "y.tab.c"
    break;

  case 66: /* relation..OR__relation..: relation _OR relation  */
#line 1070 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2683 "y.tab.c"
    break;

  case 67: /* relation..OR__relation..: relation..OR__relation.. _OR relation  */
#line 1076 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2691 "y.tab.c"
    break;

  case 68: /* relation.NAND_NOR_NXOR_relation.: relation  */
#line 1083 "./ctp_y.y"
         { (yyval.list) = (yyvsp[0].list); }
#line 2697 "y.tab.c"
    break;

  case 69: /* relation.NAND_NOR_NXOR_relation.: relation _NAND relation  */
#line 1087 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_NAND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2705 "y.tab.c"
    break;

  case 70: /* relation.NAND_NOR_NXOR_relation.: relation _NOR relation  */
#line 1093 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_NOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2713 "y.tab.c"
    break;

  case 71: /* relation.NAND_NOR_NXOR_relation.: relation _NXOR relation  */
#line 1099 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_NXOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2721 "y.tab.c"
    break;

  case 72: /* relation.NAND_NOR_NXOR_relation.: relation _IFT relation  */
#line 1105 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_IFT,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2729 "y.tab.c"
    break;

  case 73: /* relation.NAND_NOR_NXOR_relation.: _EU LeftParen relation Comma relation RightParen_ERR  */
#line 1114 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_EU,(yyvsp[-3].list) ,(yyvsp[-1].list) ,-1,-1);
         }
#line 2737 "y.tab.c"
    break;

  case 74: /* relation.NAND_NOR_NXOR_relation.: _AU LeftParen relation Comma relation RightParen_ERR  */
#line 1123 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex (VEX_AU,(yyvsp[-3].list) ,(yyvsp[-1].list) ,-1,-1);
         }
#line 2745 "y.tab.c"
    break;

  case 75: /* relation..XOR__relation..: relation _XOR relation  */
#line 1132 "./ctp_y.y"
         {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2753 "y.tab.c"
    break;

  case 76: /* relation..XOR__relation..: relation..XOR__relation.. _XOR relation  */
#line 1138 "./ctp_y.y"
         {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2761 "y.tab.c"
    break;

  case 77: /* relation: simple_expression  */
#line 1145 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2767 "y.tab.c"
    break;

  case 78: /* relation: simple_expression relational_operator simple_expression  */
#line 1149 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex ((yyvsp[-1].valu) ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2775 "y.tab.c"
    break;

  case 79: /* simple_expression: .sign.term..add_op__term..  */
#line 1156 "./ctp_y.y"
                { (yyval.list) = (yyvsp[0].list); }
#line 2781 "y.tab.c"
    break;

  case 80: /* .sign.term..add_op__term..: term  */
#line 1161 "./ctp_y.y"
          { (yyval.list) = (yyvsp[0].list); }
#line 2787 "y.tab.c"
    break;

  case 81: /* .sign.term..add_op__term..: sign term  */
#line 1164 "./ctp_y.y"
          {
             if ( (yyvsp[-1].valu) == VEX_NEG )
             {
               (yyval.list) = ctp_crtvex( VEX_NEG,(yyvsp[0].list),NULL,-1,-1);
             }
             else
             {
               (yyval.list) = (yyvsp[0].list);
             }
          }
#line 2802 "y.tab.c"
    break;

  case 82: /* .sign.term..add_op__term..: .sign.term..add_op__term.. adding_operator term  */
#line 1177 "./ctp_y.y"
          {
            (yyval.list) = ctp_crtvex((yyvsp[-1].valu),(yyvsp[-2].list),(yyvsp[0].list),-1,-1);
          }
#line 2810 "y.tab.c"
    break;

  case 83: /* adding_operator: Plus  */
#line 1184 "./ctp_y.y"
               { (yyval.valu) = VEX_ADD; }
#line 2816 "y.tab.c"
    break;

  case 84: /* adding_operator: Minus  */
#line 1186 "./ctp_y.y"
               { (yyval.valu) = VEX_SUB; }
#line 2822 "y.tab.c"
    break;

  case 85: /* adding_operator: Ampersand  */
#line 1188 "./ctp_y.y"
               { (yyval.valu) = VEX_CONCAT; }
#line 2828 "y.tab.c"
    break;

  case 86: /* sign: Plus  */
#line 1192 "./ctp_y.y"
               { (yyval.valu) = 0; }
#line 2834 "y.tab.c"
    break;

  case 87: /* sign: Minus  */
#line 1194 "./ctp_y.y"
               { (yyval.valu) = VEX_NEG; }
#line 2840 "y.tab.c"
    break;

  case 88: /* multiplying_operator: Star  */
#line 1199 "./ctp_y.y"
               { (yyval.valu) = VEX_MUL; }
#line 2846 "y.tab.c"
    break;

  case 89: /* multiplying_operator: Slash  */
#line 1201 "./ctp_y.y"
               { (yyval.valu) = VEX_DIV; }
#line 2852 "y.tab.c"
    break;

  case 90: /* multiplying_operator: MOD  */
#line 1203 "./ctp_y.y"
               { (yyval.valu) = VEX_MOD; }
#line 2858 "y.tab.c"
    break;

  case 91: /* multiplying_operator: REM  */
#line 1205 "./ctp_y.y"
               { (yyval.valu) = VEX_REM; }
#line 2864 "y.tab.c"
    break;

  case 92: /* term: factor  */
#line 1210 "./ctp_y.y"
         { (yyval.list) = (yyvsp[0].list); }
#line 2870 "y.tab.c"
    break;

  case 93: /* term: term multiplying_operator factor  */
#line 1214 "./ctp_y.y"
         {
           (yyval.list) = ctp_crtvex( (yyvsp[-1].valu), (yyvsp[-2].list), (yyvsp[0].list),-1,-1);
         }
#line 2878 "y.tab.c"
    break;

  case 94: /* factor: primary  */
#line 1221 "./ctp_y.y"
         {
           (yyval.list) = (yyvsp[0].list);
         }
#line 2886 "y.tab.c"
    break;

  case 95: /* factor: primary DoubleStar primary  */
#line 1227 "./ctp_y.y"
         {
           (yyval.list) = ctp_crtvex( VEX_EXP,(yyvsp[-2].list),(yyvsp[0].list),-1,-1);
         }
#line 2894 "y.tab.c"
    break;

  case 96: /* factor: ABS primary  */
#line 1232 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_ABS,(yyvsp[0].list),CTP_EMPSTR,-1,-1); 
         }
#line 2902 "y.tab.c"
    break;

  case 97: /* factor: _NOT primary  */
#line 1237 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_NOT,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2910 "y.tab.c"
    break;

  case 98: /* factor: _AG primary  */
#line 1242 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_AG,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2918 "y.tab.c"
    break;

  case 99: /* factor: _AF primary  */
#line 1247 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_AF,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2926 "y.tab.c"
    break;

  case 100: /* factor: _AX primary  */
#line 1252 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_AX,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2934 "y.tab.c"
    break;

  case 101: /* factor: _EF primary  */
#line 1257 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_EF,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2942 "y.tab.c"
    break;

  case 102: /* factor: _EG primary  */
#line 1262 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_EG,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2950 "y.tab.c"
    break;

  case 103: /* factor: _EX primary  */
#line 1267 "./ctp_y.y"
         { 
           (yyval.list) = ctp_crtvex( VEX_EX,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2958 "y.tab.c"
    break;

  case 104: /* primary: literal  */
#line 1274 "./ctp_y.y"
        {
           struct ctp_expr expr1;

           expr1.IDENT = (yyvsp[0].text);
           expr1.TYPE  = -1;
           expr1.VEX   = (vexexpr *)0;

           (yyval.list) = ctp_crtvex( NOPS,expr1,CTP_EMPSTR,-1,-1);
        }
#line 2972 "y.tab.c"
    break;

  case 105: /* primary: aggregate  */
#line 1284 "./ctp_y.y"
        {
            ctp_vexstr *VexStr;
            chain_list *ScanChain;

            ScanChain = (yyvsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            if ( ScanChain->NEXT == (chain_list *)0 )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              (yyval.list) = *VexStr;

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
            else
            {
              (yyval.list).IDENT  = (char *)(yyvsp[0].pcha);
              (yyval.list).AGGREG = 1;
            }
        }
#line 3003 "y.tab.c"
    break;

  case 106: /* primary: name  */
#line 1311 "./ctp_y.y"
        {
          struct ctp_expr expr1;
          char           *LocalName;
          char            Buffer[ 40 ];
          long            left;
          long            right;
          long             mode;
          long             flag;

          flag = (yyvsp[0].name).FLAG;

          if ( ( flag != 0          ) &&
               ( flag != CTP_EVENT  ) &&
               ( flag != CTP_STABLE ) )
          {
            if ( ( flag != CTP_RANGE     ) &&
                 ( flag != CTP_REV_RANGE ) )
            {
              {
                sprintf( Buffer, "%ld", (yyvsp[0].name).LEFT );

                expr1.IDENT = Buffer;
                expr1.VEX   = (vexexpr *)0;
                expr1.TYPE  = -1;

                (yyval.list) = ctp_crtvex( NOPS, expr1, CTP_EMPSTR, -1, -1);
              }
            }
            else
            {
              autexit( 1 );
            }
          }
          else
          if ( ( (yyvsp[0].name).NAME[0] == '"' ) ||
               ( (yyvsp[0].name).NAME[0] == '\'') )
          {
            expr1.IDENT = (yyvsp[0].name).NAME;
            expr1.VEX   = (vexexpr *)0;
            expr1.TYPE  = -1;

            (yyval.list) = ctp_crtvex( NOPS ,expr1, CTP_EMPSTR, -1, -1); /* as for literal */
          }
          else
          {
            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_SYMDFN);

            if( mode == 0 )
            {
              my_ctp_error (17,(yyvsp[0].name).NAME);
            }

            /*left_bnd  =*/ chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_WMNDFN);
            /*right_bnd =*/ chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_WMXDFN);
              
            left  = (yyvsp[0].name).LEFT;
            right = (yyvsp[0].name).RIGHT;

            {
              long  type;

              expr1.IDENT = (yyvsp[0].name).NAME;
              type = chktab(hshtab,(yyvsp[0].name).NAME,LocalName,CTP_TYPDFN);
              expr1.TYPE = type;
              expr1.SIGNED = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_SUNDFN);

              {
                expr1 = ctp_crtvex (NOPI,expr1,CTP_EMPSTR,left,right);
              }

              if( flag == CTP_EVENT )
              {
                (yyval.list) = ctp_crtvex (VEX_EVENT,expr1,CTP_EMPSTR,left,right);
              }
              else
              if( flag == CTP_STABLE )
              {
                expr1 = ctp_crtvex(VEX_EVENT,expr1,CTP_EMPSTR,left,right);
                (yyval.list)    = ctp_crtvex (VEX_NOT,expr1,CTP_EMPSTR,-1,-1);
              }
              else
              {
                (yyval.list) = expr1;
              }
            }
          }
        }
#line 3096 "y.tab.c"
    break;

  case 107: /* primary: qualified_expression  */
#line 1400 "./ctp_y.y"
        {
          struct ctp_expr expr1;

          expr1.IDENT  = (yyvsp[0].name).NAME;
          expr1.TYPE   = (yyvsp[0].name).TYPE;
          expr1.SIGNED = (yyvsp[0].name).SIGNED;
          expr1.VEX    = (vexexpr *)(yyvsp[0].name).LEFT;

          expr1 = ctp_crtvex(SUBVAR,expr1,CTP_EMPSTR,expr1.VEX->LEFT,expr1.VEX->RIGHT);

          (yyval.list) = expr1;
        }
#line 3113 "y.tab.c"
    break;

  case 108: /* qualified_expression: name Apostrophe aggregate  */
#line 1418 "./ctp_y.y"
          {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            long        Def;

            ScanChain = (yyvsp[0].pcha);

            if ( ( ScanChain       == (chain_list *)0 ) ||
                 ( ScanChain->NEXT != (chain_list *)0 ) )
            {
              my_ctp_error(122,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SYMDFN);

            if ( Def == CTP_TPEDFN )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              VexExpr = createvexfunc( (yyvsp[-2].name).NAME, VexStr->VEX->WIDTH );
              addvexhexpr( VexExpr, VexStr->VEX );

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              (yyval.name).NAME    = (yyvsp[-2].name).NAME;
              (yyval.name).TYPE    = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED  = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SUNDFN);
              (yyval.name).FLAG    = 0;
              (yyval.name).LEFT    = (long)VexExpr;
              (yyval.name).RIGHT   = 0;

              freechain( (yyvsp[0].pcha) );
            }
            else
            {
              my_ctp_error(122, (yyvsp[-2].name).NAME);
            }
          }
#line 3159 "y.tab.c"
    break;

  case 109: /* relational_operator: _EQSym  */
#line 1463 "./ctp_y.y"
              { (yyval.valu) = VEX_EQ; }
#line 3165 "y.tab.c"
    break;

  case 110: /* relational_operator: _NESym  */
#line 1465 "./ctp_y.y"
              { (yyval.valu) = VEX_NE; }
#line 3171 "y.tab.c"
    break;

  case 111: /* relational_operator: _GESym  */
#line 1467 "./ctp_y.y"
              { (yyval.valu) = VEX_GE; }
#line 3177 "y.tab.c"
    break;

  case 112: /* relational_operator: _GTSym  */
#line 1469 "./ctp_y.y"
              { (yyval.valu) = VEX_GT; }
#line 3183 "y.tab.c"
    break;

  case 113: /* relational_operator: _LESym  */
#line 1471 "./ctp_y.y"
              { (yyval.valu) = VEX_LE; }
#line 3189 "y.tab.c"
    break;

  case 114: /* relational_operator: _LTSym  */
#line 1473 "./ctp_y.y"
              { (yyval.valu) = VEX_LT; }
#line 3195 "y.tab.c"
    break;

  case 115: /* relational_operator: Equiv  */
#line 1475 "./ctp_y.y"
              { (yyval.valu) = VEX_EQUIV; }
#line 3201 "y.tab.c"
    break;

  case 116: /* relational_operator: Imply  */
#line 1477 "./ctp_y.y"
              { (yyval.valu) = VEX_IMPLY; }
#line 3207 "y.tab.c"
    break;

  case 117: /* literal: AbstractLit  */
#line 1482 "./ctp_y.y"
              { (yyval.text) = (yyvsp[0].text); }
#line 3213 "y.tab.c"
    break;

  case 118: /* literal: CharacterLit  */
#line 1484 "./ctp_y.y"
              { 
                (yyval.text) = (yyvsp[0].text); }
#line 3220 "y.tab.c"
    break;

  case 119: /* literal: StringLit  */
#line 1487 "./ctp_y.y"
              { (yyval.text) = (yyvsp[0].text); }
#line 3226 "y.tab.c"
    break;

  case 120: /* literal: BitStringLit  */
#line 1489 "./ctp_y.y"
              { (yyval.text) = (yyvsp[0].text); }
#line 3232 "y.tab.c"
    break;

  case 121: /* literal: _TRUE  */
#line 1491 "./ctp_y.y"
              { (yyval.text) = namealloc( "'1'" ); }
#line 3238 "y.tab.c"
    break;

  case 122: /* literal: _FALSE  */
#line 1493 "./ctp_y.y"
              { (yyval.text) = namealloc( "'0'" ); }
#line 3244 "y.tab.c"
    break;

  case 123: /* aggregate: LeftParen element_association ...element_association.. RightParen_ERR  */
#line 1501 "./ctp_y.y"
          {
            if ( (yyvsp[-1].pcha) != (chain_list *)0 )
            {
              (yyvsp[-2].pcha)->NEXT = reverse( (yyvsp[-1].pcha) );
            }

            (yyval.pcha) = (yyvsp[-2].pcha);
          }
#line 3257 "y.tab.c"
    break;

  case 124: /* ...element_association..: %empty  */
#line 1513 "./ctp_y.y"
          { 
            (yyval.pcha) = (chain_list *)0;
          }
#line 3265 "y.tab.c"
    break;

  case 125: /* ...element_association..: ...element_association.. Comma element_association  */
#line 1519 "./ctp_y.y"
          {
            if ( (yyvsp[-2].pcha) != (chain_list *)0 )
            {
              (yyvsp[0].pcha)->NEXT = (yyvsp[-2].pcha);
            }

            (yyval.pcha) = (yyvsp[0].pcha);
          }
#line 3278 "y.tab.c"
    break;

  case 126: /* element_association: expression  */
#line 1531 "./ctp_y.y"
          { 
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = (yyvsp[0].list);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3291 "y.tab.c"
    break;

  case 127: /* element_association: OTHERS Arrow expression  */
#line 1542 "./ctp_y.y"
          {
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = ctp_crtvex( VEX_OTHERS, (yyvsp[0].list),CTP_EMPSTR,-1,-1);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3304 "y.tab.c"
    break;

  case 128: /* name: simple_name  */
#line 1554 "./ctp_y.y"
         {
           char     *LocalName;

           LocalName = CTP_MODNAM;

           (yyval.name).NAME = (yyvsp[0].text);
           (yyval.name).FLAG = 0;

           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_TYPDFN);
           (yyval.name).LEFT   = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_WMNDFN);
           (yyval.name).RIGHT  = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_WMXDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_SUNDFN);
         }
#line 3322 "y.tab.c"
    break;

  case 129: /* name: indexed_name  */
#line 1568 "./ctp_y.y"
              { (yyval.name) = (yyvsp[0].name); }
#line 3328 "y.tab.c"
    break;

  case 130: /* name: slice_name  */
#line 1570 "./ctp_y.y"
              { (yyval.name) = (yyvsp[0].name); }
#line 3334 "y.tab.c"
    break;

  case 131: /* name: attribute_name  */
#line 1572 "./ctp_y.y"
              { (yyval.name) = (yyvsp[0].name); }
#line 3340 "y.tab.c"
    break;

  case 132: /* indexed_name: simple_name aggregate  */
#line 1578 "./ctp_y.y"
          {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            long        Index;
            long         Error;
            long        Def;

            ScanChain = (yyvsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SYMDFN);

            if ( ScanChain->NEXT != (chain_list *)0 )
            {
              if ( ( ! Def                                    ) || 
                   ( ScanChain->NEXT->NEXT != (chain_list *)0 ) )
              {
                my_ctp_error(118,(yyvsp[-1].text));
              }

              /* ICI */

              (yyval.name).NAME   = (yyvsp[-1].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              VexStr  = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).LEFT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              ScanChain = ScanChain->NEXT;
              VexStr   = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).RIGHT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              freechain( (yyvsp[0].pcha) );
            }
            else
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;
              Error  = ctp_vextonum( VexStr->VEX, &Index );

              (yyval.name).NAME   = (yyvsp[-1].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              if ( Error )
              {
                my_ctp_error(36, (yyvsp[-1].text));
              }
              else
              {
                (yyval.name).LEFT   = Index;
                (yyval.name).RIGHT  = Index;
              }

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
          }
#line 3413 "y.tab.c"
    break;

  case 133: /* slice_name: simple_name LeftParen simple_expression direction simple_expression RightParen_ERR  */
#line 1655 "./ctp_y.y"
         {
           char *LocalName;
           long  Left;
           long  Right;
           long   ErrorL;
           long   ErrorR;

           LocalName = CTP_MODNAM;

           ErrorL = ctp_vextonum( (yyvsp[-3].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[-1].list).VEX, &Right );

           (yyval.name).NAME   = (yyvsp[-5].text);
           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-5].text),LocalName,CTP_TYPDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-5].text),LocalName,CTP_SUNDFN);
           (yyval.name).FLAG   = 0;

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[-2].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[-2].valu) == CTP_DWTDFN)))
               my_ctp_error (32,(yyvsp[-5].text));

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             my_ctp_error (36,(yyvsp[-5].text));
           }
         }
#line 3449 "y.tab.c"
    break;

  case 134: /* attribute_name: name Apostrophe attribute_designator  */
#line 1692 "./ctp_y.y"
          {
            char *LocalName;
            long   type;
            long   flag;
            long  AttrLeft;
            long  AttrRight;
            long  AttrLow;
            long  AttrHigh;

            LocalName = CTP_MODNAM;
            /*mode = */ chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SYMDFN);
            type = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_TYPDFN);
            flag = (yyvsp[0].valu);

            (yyval.name).NAME   = (yyvsp[-2].name).NAME;
            (yyval.name).TYPE   = type;
            (yyval.name).LEFT   = -1;
            (yyval.name).RIGHT  = -1;
            (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SUNDFN);
            (yyval.name).FLAG   = (yyvsp[0].valu);

            if ( ( flag == CTP_STABLE ) ||
                 ( flag == CTP_EVENT  ) )
            {
              if ( LocalName != CTP_MODNAM )
                my_ctp_error (79,(yyvsp[-2].name));
            }
            else
            {
              AttrLeft  = chktab( hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_ATLDFN);
              AttrRight = chktab( hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_ATRDFN);

              {
                if ( AttrLeft > AttrRight )
                {
                  AttrLow  = AttrRight;
                  AttrHigh = AttrLeft;
                }
                else
                {
                  AttrHigh = AttrRight;
                  AttrLow  = AttrLeft;
                }
              }

              switch ( flag )
              {
                case CTP_LEFT   : (yyval.name).LEFT = AttrLeft;
                break;

                case CTP_RIGHT  : (yyval.name).LEFT = AttrRight;
                break;

                case CTP_LOW    : (yyval.name).LEFT = AttrLow;
                break;

                case CTP_HIGH   : (yyval.name).LEFT = AttrHigh;
                break;

                case CTP_LENGTH : (yyval.name).LEFT = 1 + (AttrHigh - AttrLow);
                break;

                case CTP_RANGE  : (yyval.name).LEFT  = AttrLeft;
                                  (yyval.name).RIGHT = AttrRight;
                break;

                case CTP_REV_RANGE : (yyval.name).LEFT  = AttrRight;
                                     (yyval.name).RIGHT = AttrLeft;
                break;
              }
            }
          }
#line 3526 "y.tab.c"
    break;

  case 135: /* attribute_designator: _STABLE  */
#line 1767 "./ctp_y.y"
                      { (yyval.valu) = CTP_STABLE; }
#line 3532 "y.tab.c"
    break;

  case 136: /* attribute_designator: _EVENT  */
#line 1768 "./ctp_y.y"
                      { (yyval.valu) = CTP_EVENT; }
#line 3538 "y.tab.c"
    break;

  case 137: /* attribute_designator: _LEFT  */
#line 1769 "./ctp_y.y"
                      { (yyval.valu) = CTP_LEFT; }
#line 3544 "y.tab.c"
    break;

  case 138: /* attribute_designator: _RIGHT  */
#line 1770 "./ctp_y.y"
                      { (yyval.valu) = CTP_RIGHT; }
#line 3550 "y.tab.c"
    break;

  case 139: /* attribute_designator: _LOW  */
#line 1771 "./ctp_y.y"
                      { (yyval.valu) = CTP_LOW; }
#line 3556 "y.tab.c"
    break;

  case 140: /* attribute_designator: _HIGH  */
#line 1772 "./ctp_y.y"
                      { (yyval.valu) = CTP_HIGH; }
#line 3562 "y.tab.c"
    break;

  case 141: /* attribute_designator: _LENGTH  */
#line 1773 "./ctp_y.y"
                      { (yyval.valu) = CTP_LENGTH; }
#line 3568 "y.tab.c"
    break;

  case 142: /* attribute_designator: _RANGE  */
#line 1774 "./ctp_y.y"
                      { (yyval.valu) = CTP_RANGE; }
#line 3574 "y.tab.c"
    break;

  case 143: /* attribute_designator: _REV_RANGE  */
#line 1775 "./ctp_y.y"
                      { (yyval.valu) = CTP_REV_RANGE; }
#line 3580 "y.tab.c"
    break;

  case 144: /* $@2: %empty  */
#line 1780 "./ctp_y.y"
                { CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text)); }
#line 3586 "y.tab.c"
    break;

  case 147: /* ...identifier..: ...identifier.. Comma Identifier  */
#line 1789 "./ctp_y.y"
                { 
                  CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
                }
#line 3594 "y.tab.c"
    break;

  case 148: /* simple_name: Identifier  */
#line 1796 "./ctp_y.y"
              { (yyval.text) = (yyvsp[0].text); }
#line 3600 "y.tab.c"
    break;

  case 149: /* RightParen_ERR: RightParen  */
#line 1801 "./ctp_y.y"
              { yyerrok; }
#line 3606 "y.tab.c"
    break;

  case 150: /* Semicolon_ERR: Semicolon  */
#line 1806 "./ctp_y.y"
              { yyerrok; }
#line 3612 "y.tab.c"
    break;

  case 151: /* END_ERR: _END  */
#line 1811 "./ctp_y.y"
              { yyerrok; }
#line 3618 "y.tab.c"
    break;


#line 3622 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1814 "./ctp_y.y"


static struct dct_entry *addent (head , key)
struct dct_entry *head;
char             *key;

{
  struct dct_entry *entry = NULL;
  long              i;

  if (CTP_DCEHED == NULL)
    {
    CTP_DCEHED = (struct dct_entry *)
                 autallocblock (sizeof(struct dct_entry) * CTP_ALODFN);

    entry = CTP_DCEHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = CTP_DCEHED;
  CTP_DCEHED  = CTP_DCEHED->next;

  entry->next = head;
  entry->data = NULL;
  entry->key  = key;

  return (entry);
}

static struct dct_recrd *addrcd (head , key)

struct dct_recrd *head;
char             *key;

{
  struct dct_recrd *recrd = NULL;
  long               i;

  if (CTP_DCRHED == NULL)
    {
    CTP_DCRHED = (struct dct_recrd *)
                 autallocblock (sizeof(struct dct_recrd) * CTP_ALODFN);

    recrd = CTP_DCRHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      recrd->next = recrd + 1;
      recrd++;
      }
    recrd->next = NULL;
    }

  recrd           = CTP_DCRHED;
  CTP_DCRHED      = CTP_DCRHED->next;

  recrd->next     = head;
  recrd->key      = key;

  return (recrd);
}

static struct dct_entry **initab ()

{
  struct dct_entry **head = NULL;
  long                i;

  head = (struct dct_entry **)
         autallocblock (sizeof(struct dct_entry *) * CTP_HSZDFN);

  for (i=0 ; i<CTP_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
}

static void addtab (head,key_str,ctx_str,field,valu)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;
long               valu;

{
  long              found = 0;
  long              index;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  index     = ((unsigned long) key_str) % CTP_HSZDFN;
  entry_pnt = head[index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head[index] = addent (head[index],key_str);
    entry_pnt = head[index];
    }

  found = 0;
  recrd_pnt = entry_pnt->data;
  while (recrd_pnt != NULL)
    {
    if (recrd_pnt->key == ctx_str)
      {
      found = 1;
      break;
      }
    recrd_pnt = recrd_pnt->next;
    }

  if (found == 0)
    {
    entry_pnt->data = addrcd (entry_pnt->data,ctx_str);
    recrd_pnt       = entry_pnt->data ;
    }

  switch (field)
    {
      case CTP_MODDFN :
        recrd_pnt->fd0_val = valu;
        break;
      case CTP_SYMDFN :
        recrd_pnt->fd1_val = valu;
        break;
      case CTP_TYPDFN :
        recrd_pnt->fd2_val = valu;
        break;
      case CTP_SUNDFN :
        recrd_pnt->fd3_val = valu;
        break;
      case CTP_LBLDFN :
        recrd_pnt->fd4_val = valu;
        break;
      case CTP_WMXDFN :
        recrd_pnt->fd5_val = valu;
        break;
      case CTP_WMNDFN :
        recrd_pnt->fd6_val = valu;
        break;
      case CTP_ATLDFN :
        recrd_pnt->fd7_val = valu;
        break;
      case CTP_ATRDFN :
        recrd_pnt->fd8_val = valu;
        break;
      case CTP_PNTDFN :
        recrd_pnt->pnt_val = valu;
        break;
    }
}

static long chktab (head,key_str,ctx_str,field)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;

{
  long              found = 0;
  long              valu = 0;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  entry_pnt = head [((unsigned long)key_str) % CTP_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    found = 0;
    recrd_pnt = entry_pnt->data;
    while (recrd_pnt != NULL)
      {
      if (recrd_pnt->key == ctx_str)
        {
        found = 1;
        break;
        }
      recrd_pnt = recrd_pnt->next;
      }
    if (found == 1)
      {
      switch (field)
        {
        case CTP_MODDFN :
          valu = recrd_pnt->fd0_val;
          break;
        case CTP_SYMDFN :
          valu = recrd_pnt->fd1_val;
          break;
        case CTP_TYPDFN :
          valu = recrd_pnt->fd2_val;
          break;
        case CTP_SUNDFN :
          valu = recrd_pnt->fd3_val;
          break;
        case CTP_LBLDFN :
          valu = recrd_pnt->fd4_val;
          break;
        case CTP_WMXDFN :
          valu = recrd_pnt->fd5_val;
          break;
        case CTP_WMNDFN :
          valu = recrd_pnt->fd6_val;
          break;
        case CTP_ATLDFN :
          valu = recrd_pnt->fd7_val;
          break;
        case CTP_ATRDFN :
          valu = recrd_pnt->fd8_val;
          break;
        case CTP_PNTDFN :
          valu = recrd_pnt->pnt_val;
          break;
        }
      }
    }

  return (valu);
}

static void fretab (pt_hash)

struct dct_entry **pt_hash;
{
  struct dct_entry *pt_entry;
  struct dct_entry *pt_nxtentry;
  struct dct_recrd *pt_record;
  long              i;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<CTP_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry != NULL)
          {
          pt_record = pt_entry->data;

          while (pt_record->next != NULL)
            pt_record = pt_record->next;

          pt_record->next = CTP_DCRHED;
          CTP_DCRHED      = pt_entry->data;

          pt_nxtentry     = pt_entry->next;
          pt_entry->next  = CTP_DCEHED;
          CTP_DCEHED      = pt_entry;
          pt_entry        = pt_nxtentry;
          }
        }
      }
    autfreeblock(pt_hash);
    }
}

static void *ctp_addstr(object,mode,prtype,type,flag,name,left,right,exp)

char          object;
long           mode;
ctltype_list *prtype;
unsigned char type;
char          flag;
char         *name;
long          left;
long          right;
vexexpr      *exp;

{ 
  ctlform_list *CtlForm;
  ctldecl_list *CtlDeclar;
  void         *pnt    = NULL;
  vexexpr      *vex_pnt;
  long           bitsize;

  if ( object == 'F' )
  {
    CtlForm = addctlform( CTP_HEADFIG, name, exp );
    addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM );

    return( (void *)CtlForm );
  }


  if ( (flag == 'A') ||
       (flag == 'U') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an array ...                                   */
       /* ###------------------------------------------------------### */

    if ( flag == 'A' )
    {
      vex_pnt = createvexatomvec( name, prtype->LEFT, prtype->RIGHT ); 
    }
    else
    {
      vex_pnt = createvexatomvec( name, left, right );
    }

    if ( prtype->INDEX == VEX_TYPE_SIGNED )
    {
      SetVexNodeSigned( vex_pnt );
    }

  }
  else
  if ( (flag == 'I') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an integer ...                            */
       /* ###------------------------------------------------------### */

      if ((left == -1 ) && (right == -1))
      {
        left  = prtype->LEFT;
        right = prtype->RIGHT;
      }

      bitsize = ctp_intSize( left, right );

      vex_pnt = createvexatomvec( name, bitsize - 1, 0 );

      if ( ( left  < 0 ) ||
           ( right < 0 ) )
      {
        SetVexNodeSigned( vex_pnt );
      }
  }
  else
  {
       /* ###------------------------------------------------------### */
       /*   if object is a scalar ...                                   */
       /* ###------------------------------------------------------### */
    vex_pnt = createvexatombit( name );
  }

  if ( object == 'C' )
  {
    CtlDeclar = addctldecldef( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'V' )
  {
    CtlDeclar = addctldeclvar( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'A' )
  {
    CtlDeclar = addctldeclass( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'I' )
  {
    CtlDeclar = addctldeclinit( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'R' )
  {
    CtlDeclar = addctldeclreset( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }

  return (pnt);
}

static ctltype_list *val_type(name)

 char *name;
{
  return( searchctltype( CTP_HEADFIG, name ) );
}

#if THIS_IS_DISABLED
static ctltype_list *get_type(val)

  long val;
{
  ctltype_list *Type;

  for ( Type  = CTP_HEADFIG->TYPE;
        Type != (ctltype_list *)0;
        Type  = Type->NEXT )
  {
    if  ( Type->INDEX == val ) break;
  }

  return( Type );
}
#endif

int ctp_y_wrap ()
{
  return (1);
}

