/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with VRD_Y__ or vrd_y__.  They are
   private implementation details that can be changed or removed.  */

#ifndef VRD_Y__VRD_Y__Y_TAB_H_INCLUDED
# define VRD_Y__VRD_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef VRD_Y_DEBUG
# define VRD_Y_DEBUG 0
#endif
#if VRD_Y_DEBUG
extern int vrd_y_debug;
#endif

/* Token kinds.  */
#ifndef VRD_Y_TOKENTYPE
# define VRD_Y_TOKENTYPE
  enum vrd_y_tokentype
  {
    VRD_Y_EMPTY = -2,
    VRD_Y_EOF = 0,                     /* "end of file"  */
    VRD_Y_error = 256,                 /* error  */
    VRD_Y_UNDEF = 257,                 /* "invalid token"  */
    DRUC_REGLES = 258,             /* DRUC_REGLES  */
    DRUC_FIN = 259,                /* DRUC_FIN  */
    DRUC_REGLE = 260,              /* DRUC_REGLE  */
    DRUC_DEFINE = 261,             /* DRUC_DEFINE  */
    DRUC_UNDEFINE = 262,           /* DRUC_UNDEFINE  */
    DRUC_CARACTERISE = 263,        /* DRUC_CARACTERISE  */
    DRUC_RELATION = 264,           /* DRUC_RELATION  */
    DRUC_LAYER = 265,              /* DRUC_LAYER  */
    DRUC_NOM = 266,                /* DRUC_NOM  */
    DRUC_UNION = 267,              /* DRUC_UNION  */
    DRUC_EXCLUSION = 268,          /* DRUC_EXCLUSION  */
    DRUC_RESIZE = 269,             /* DRUC_RESIZE  */
    DRUC_ENVELOPPE = 270,          /* DRUC_ENVELOPPE  */
    DRUC_MARGE = 271,              /* DRUC_MARGE  */
    DRUC_CROIX = 272,              /* DRUC_CROIX  */
    DRUC_INTERSECT = 273,          /* DRUC_INTERSECT  */
    DRUC_EXTENSION = 274,          /* DRUC_EXTENSION  */
    DRUC_INCLUSION = 275,          /* DRUC_INCLUSION  */
    DRUC_DISTANCE = 276,           /* DRUC_DISTANCE  */
    DRUC_SURFACE_INTER = 277,      /* DRUC_SURFACE_INTER  */
    DRUC_LONG_INTER = 278,         /* DRUC_LONG_INTER  */
    DRUC_LARGE_INTER = 279,        /* DRUC_LARGE_INTER  */
    DRUC_PENET_INTER = 280,        /* DRUC_PENET_INTER  */
    DRUC_PARAL_INTER = 281,        /* DRUC_PARAL_INTER  */
    DRUC_PERPEN_INTER = 282,       /* DRUC_PERPEN_INTER  */
    DRUC_FRONTALE = 283,           /* DRUC_FRONTALE  */
    DRUC_LATERALE_MIN = 284,       /* DRUC_LATERALE_MIN  */
    DRUC_LATERALE_MAX = 285,       /* DRUC_LATERALE_MAX  */
    DRUC_LARGEUR_MIN = 286,        /* DRUC_LARGEUR_MIN  */
    DRUC_LARGEUR_MAX = 287,        /* DRUC_LARGEUR_MAX  */
    DRUC_LONGUEUR_MIN = 288,       /* DRUC_LONGUEUR_MIN  */
    DRUC_LONGUEUR_MAX = 289,       /* DRUC_LONGUEUR_MAX  */
    DRUC_SUP = 290,                /* DRUC_SUP  */
    DRUC_INF = 291,                /* DRUC_INF  */
    DRUC_AXIALE = 292,             /* DRUC_AXIALE  */
    DRUC_GEODESIQUE = 293,         /* DRUC_GEODESIQUE  */
    DRUC_SURFACE = 294,            /* DRUC_SURFACE  */
    DRUC_LONGUEUR = 295,           /* DRUC_LONGUEUR  */
    DRUC_LARGEUR = 296,            /* DRUC_LARGEUR  */
    DRUC_MIN = 297,                /* DRUC_MIN  */
    DRUC_MAX = 298,                /* DRUC_MAX  */
    DRUC_INFEQ = 299,              /* DRUC_INFEQ  */
    DRUC_SUPEQ = 300,              /* DRUC_SUPEQ  */
    DRUC_DIFF = 301,               /* DRUC_DIFF  */
    DRUC_NOTCH = 302,              /* DRUC_NOTCH  */
    DRUC_DESTINATION = 303,        /* DRUC_DESTINATION  */
    DRUC_ENTIER = 304,             /* DRUC_ENTIER  */
    DRUC_FLOAT = 305,              /* DRUC_FLOAT  */
    DRUC_NEG_FLOAT = 306           /* DRUC_NEG_FLOAT  */
  };
  typedef enum vrd_y_tokentype vrd_y_token_kind_t;
#endif
/* Token kinds.  */
#define VRD_Y_EMPTY -2
#define VRD_Y_EOF 0
#define VRD_Y_error 256
#define VRD_Y_UNDEF 257
#define DRUC_REGLES 258
#define DRUC_FIN 259
#define DRUC_REGLE 260
#define DRUC_DEFINE 261
#define DRUC_UNDEFINE 262
#define DRUC_CARACTERISE 263
#define DRUC_RELATION 264
#define DRUC_LAYER 265
#define DRUC_NOM 266
#define DRUC_UNION 267
#define DRUC_EXCLUSION 268
#define DRUC_RESIZE 269
#define DRUC_ENVELOPPE 270
#define DRUC_MARGE 271
#define DRUC_CROIX 272
#define DRUC_INTERSECT 273
#define DRUC_EXTENSION 274
#define DRUC_INCLUSION 275
#define DRUC_DISTANCE 276
#define DRUC_SURFACE_INTER 277
#define DRUC_LONG_INTER 278
#define DRUC_LARGE_INTER 279
#define DRUC_PENET_INTER 280
#define DRUC_PARAL_INTER 281
#define DRUC_PERPEN_INTER 282
#define DRUC_FRONTALE 283
#define DRUC_LATERALE_MIN 284
#define DRUC_LATERALE_MAX 285
#define DRUC_LARGEUR_MIN 286
#define DRUC_LARGEUR_MAX 287
#define DRUC_LONGUEUR_MIN 288
#define DRUC_LONGUEUR_MAX 289
#define DRUC_SUP 290
#define DRUC_INF 291
#define DRUC_AXIALE 292
#define DRUC_GEODESIQUE 293
#define DRUC_SURFACE 294
#define DRUC_LONGUEUR 295
#define DRUC_LARGEUR 296
#define DRUC_MIN 297
#define DRUC_MAX 298
#define DRUC_INFEQ 299
#define DRUC_SUPEQ 300
#define DRUC_DIFF 301
#define DRUC_NOTCH 302
#define DRUC_DESTINATION 303
#define DRUC_ENTIER 304
#define DRUC_FLOAT 305
#define DRUC_NEG_FLOAT 306

/* Value type.  */
#if ! defined VRD_Y_STYPE && ! defined VRD_Y_STYPE_IS_DECLARED
typedef int VRD_Y_STYPE;
# define VRD_Y_STYPE_IS_TRIVIAL 1
# define VRD_Y_STYPE_IS_DECLARED 1
#endif


extern VRD_Y_STYPE vrd_y_lval;


int vrd_y_parse (void);


#endif /* !VRD_Y__VRD_Y__Y_TAB_H_INCLUDED  */
