/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 7 "dpgen_ROM_code.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mut.h>

typedef struct vhdl_constant {
		struct vhdl_constant *NEXT;
		char                 *string;
		char                 *value;
} dptr;

static char oct2bin[8][4] = {
		"000",
		"001",
		"010",
		"011",
		"100",
		"101",
		"110",
		"111"
};

static char hex2bin[16][5] = {
		"0000",
		"0001",
		"0010",
		"0011",
		"0100",
		"0101",
		"0110",
		"0111",
		"1000",
		"1001",
		"1010",
		"1011",
		"1100",
		"1101",
		"1110",
		"1111"
};

static char *vhdl_line;
static dptr *asc = NULL;
static int line = 0;
static int notempty = 0;
static char datbuf[65];
static char adrbuf[33];
static long nwords, nbits, rf, ibmbull;
static long *ydata;
static long used[8912];
static char aorder; /* vector order for addresses */
static char forder; /* vector order for data out */
static void readvhdlfile();
static int yylex();
static int yyerror();

/* danger :
   These three functions use an internal buffer when called, so
   avoid calling them twice in the same function call. */
static char *octbin(s)
char *s;
{
static char b[256];
char t[2];

	b[0] = t[1] = '\0';
	while (*s) {
		*t = *s;
		strcat(b, oct2bin[strtol(t, (char **)NULL, 8)]);
		s++;
	}
	return b;
}

static char *hexbin(s)
char *s;
{
static char b[256];
char t[2];

	b[0] = t[1] = '\0';
	while (*s) {
		*t = *s;
		strcat(b, hex2bin[strtol(t, (char **)NULL, 16)]);
		s++;
	}
	return b;
}

static char *binvert(s)
char *s;
{
static char b[256];
int l = strlen(s) - 1, i = 0;

	while (l >= 0)
		b[i++] = s[l--];
	b[i] = '\0';
	return b;
}

static dptr *adddptr(h, s, v)
dptr *h;
char *s, *v;
{
dptr *p;

	p = (dptr *)mbkalloc(sizeof(dptr));
	p->string = (char *)mbkalloc(strlen(s) + 1);
	(void)strcpy(p->string, s);
	p->value = (char *)mbkalloc(strlen(v) + 1);
	(void)strcpy(p->value, v);
	p->NEXT = h;
	return p;
}

static char *getdptr(h, s)
dptr *h;
char *s;
{
	while (h != NULL) {
		if (!strcmp(h->string, s))
			return h->value;
		h = h->NEXT;
	}
	return NULL;
}


#line 203 "dpgen_ROM_code.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    CONSTANT = 258,                /* CONSTANT  */
    OTHERS = 259,                  /* OTHERS  */
    WHEN = 260,                    /* WHEN  */
    SELECT = 261,                  /* SELECT  */
    WITH = 262,                    /* WITH  */
    STRING = 263,                  /* STRING  */
    BSTRING = 264,                 /* BSTRING  */
    OSTRING = 265,                 /* OSTRING  */
    XSTRING = 266                  /* XSTRING  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define CONSTANT 258
#define OTHERS 259
#define WHEN 260
#define SELECT 261
#define WITH 262
#define STRING 263
#define BSTRING 264
#define OSTRING 265
#define XSTRING 266

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 139 "dpgen_ROM_code.y"

	int integer;
	char string[256];

#line 280 "dpgen_ROM_code.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_CONSTANT = 3,                   /* CONSTANT  */
  YYSYMBOL_OTHERS = 4,                     /* OTHERS  */
  YYSYMBOL_WHEN = 5,                       /* WHEN  */
  YYSYMBOL_SELECT = 6,                     /* SELECT  */
  YYSYMBOL_WITH = 7,                       /* WITH  */
  YYSYMBOL_STRING = 8,                     /* STRING  */
  YYSYMBOL_BSTRING = 9,                    /* BSTRING  */
  YYSYMBOL_OSTRING = 10,                   /* OSTRING  */
  YYSYMBOL_XSTRING = 11,                   /* XSTRING  */
  YYSYMBOL_12_ = 12,                       /* '('  */
  YYSYMBOL_13_ = 13,                       /* ')'  */
  YYSYMBOL_14_ = 14,                       /* '<'  */
  YYSYMBOL_15_ = 15,                       /* '='  */
  YYSYMBOL_16_ = 16,                       /* ','  */
  YYSYMBOL_17_ = 17,                       /* ';'  */
  YYSYMBOL_18_ = 18,                       /* '&'  */
  YYSYMBOL_YYACCEPT = 19,                  /* $accept  */
  YYSYMBOL_line = 20,                      /* line  */
  YYSYMBOL_constant = 21,                  /* constant  */
  YYSYMBOL_value = 22,                     /* value  */
  YYSYMBOL_dvalues = 23,                   /* dvalues  */
  YYSYMBOL_24_1 = 24,                      /* $@1  */
  YYSYMBOL_25_2 = 25,                      /* $@2  */
  YYSYMBOL_avalues = 26,                   /* avalues  */
  YYSYMBOL_27_3 = 27,                      /* $@3  */
  YYSYMBOL_28_4 = 28                       /* $@4  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   69

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  19
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  25
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  55

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   266


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    18,     2,
      12,    13,     2,     2,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    17,
      14,    15,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   151,   151,   152,   153,   166,   207,   236,   265,   291,
     294,   300,   301,   302,   305,   306,   306,   307,   317,   317,
     328,   329,   329,   330,   340,   340
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "CONSTANT", "OTHERS",
  "WHEN", "SELECT", "WITH", "STRING", "BSTRING", "OSTRING", "XSTRING",
  "'('", "')'", "'<'", "'='", "','", "';'", "'&'", "$accept", "line",
  "constant", "value", "dvalues", "$@1", "$@2", "avalues", "$@3", "$@4", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-37)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-25)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      11,     2,     7,    -1,   -37,   -37,   -37,    26,   -37,    14,
      29,    18,    33,    36,    30,   -37,    31,    19,    -2,    38,
      39,    28,    28,    34,    35,    37,    -4,    40,    42,    44,
      41,   -37,   -37,   -37,    43,    45,   -37,   -37,   -37,    46,
      47,    32,    32,    49,    50,   -37,   -37,    52,    51,   -37,
      28,    60,    32,    53,   -37
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       9,     0,     0,     3,    11,    12,    13,     0,     2,    14,
       0,     0,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,    23,    20,     0,     0,     0,     0,
      17,    19,    16,     8,     0,     0,     6,     7,    10,     0,
       0,     0,     0,     0,     0,    25,    22,     0,     0,     4,
       0,     0,     0,     0,     5
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -37,   -37,   -37,   -17,   -19,   -37,   -37,   -36,   -37,   -37
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     7,     8,     9,    10,    16,    14,    26,    35,    34
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      25,    27,    31,    32,   -17,    45,    46,     4,     5,     6,
      11,    13,    36,    37,     1,    12,    53,   -18,     2,     3,
       4,     5,     6,    23,    25,    25,    15,    24,     4,     5,
       6,    51,   -15,    18,    17,    25,    30,     4,     5,     6,
      24,     4,     5,     6,    20,    19,    28,    29,    21,    22,
      39,    33,    40,   -24,    43,   -21,     0,    38,    49,   -18,
      44,    41,    47,    42,    48,    52,    50,     0,     0,    54
};

static const yytype_int8 yycheck[] =
{
      17,    18,    21,    22,     5,    41,    42,     9,    10,    11,
       8,    12,    16,    17,     3,     8,    52,    18,     7,     8,
       9,    10,    11,     4,    41,    42,     0,     8,     9,    10,
      11,    50,    18,    15,     5,    52,     8,     9,    10,    11,
       8,     9,    10,    11,     8,    12,     8,     8,    18,    18,
       8,    17,     8,    18,     8,    18,    -1,    17,     6,    18,
      13,    18,    13,    18,    14,     5,    15,    -1,    -1,    16
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     7,     8,     9,    10,    11,    20,    21,    22,
      23,     8,     8,    12,    25,     0,    24,     5,    15,    12,
       8,    18,    18,     4,     8,    22,    26,    22,     8,     8,
       8,    23,    23,    17,    28,    27,    16,    17,    17,     8,
       8,    18,    18,     8,    13,    26,    26,    13,    14,     6,
      15,    23,     5,    26,    16
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    19,    20,    20,    20,    20,    20,    20,    20,    20,
      21,    22,    22,    22,    23,    24,    23,    23,    25,    23,
      26,    27,    26,    26,    28,    26
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     8,    12,     4,     4,     4,     0,
       5,     1,     1,     1,     1,     0,     4,     1,     0,     4,
       1,     0,     4,     1,     0,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* line: WITH STRING '(' STRING STRING STRING ')' SELECT  */
#line 154 "dpgen_ROM_code.y"
                        {
				if (atoi((yyvsp[-4].string)) != 0 && atoi((yyvsp[-2].string)) != 0)
					yyerror("illegal vector boundaries for GRoG");
				/* address order choice :
				   depends upon the bit ordering convention, and what is read
				   from the file. */
				if ((!ibmbull && !strcmp((yyvsp[-3].string), "TO"))
						|| (ibmbull && !strcmp((yyvsp[-3].string), "DOWNTO")))
					aorder = -1;
				else
					aorder = 1;
			}
#line 1320 "dpgen_ROM_code.c"
    break;

  case 5: /* line: STRING '(' STRING STRING STRING ')' '<' '=' dvalues WHEN avalues ','  */
#line 167 "dpgen_ROM_code.y"
                        {
			int i;
#ifdef PARSEOUT
				fprintf(stdout, "\n%s when %s\n", datbuf, adrbuf);
#endif
				if (atoi((yyvsp[-9].string)) != 0 && atoi((yyvsp[-7].string)) != 0)
					yyerror("illegal vector boundaries for GRoG");
				/* output ordering :
				   internally, the data is seen in the ibmbull convention, since
				   the generator was designed with this convention I hate
				   demanded. */
				if ((rf && !strcmp((yyvsp[-8].string), "TO")) || (!rf && !strcmp((yyvsp[-8].string), "DOWNTO")))
					forder = -1;
				else
					forder = 1;
				notempty = 1;
				if (strlen(datbuf) > nbits)
					yyerror("data too wide for the number of bits");
				if (strlen(adrbuf) > nwords)
					yyerror("address too high for the number of words");
				if (aorder == -1)
					strcpy(adrbuf, binvert(adrbuf));
				if (forder == -1)
					strcpy(datbuf, binvert(datbuf));
				if (nbits < 32) {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(datbuf, 0, 2);
					ydata[(i << 1) + 1] = 0;
				} else {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(&datbuf[nbits - 32], 0, 2);
					datbuf[nbits - 32] = '\0';
					ydata[(i << 1) + 1] = strtol(datbuf, 0, 2);
				}

				if (!used[i])
					used[i] = 1;
				else
					yyerror("same address used twice");
			}
#line 1365 "dpgen_ROM_code.c"
    break;

  case 6: /* line: dvalues WHEN avalues ','  */
#line 208 "dpgen_ROM_code.y"
                        {
			int i;
#ifdef PARSEOUT
				fprintf(stdout, "\n%s when %s\n", datbuf, adrbuf);
#endif
				if (strlen(datbuf) > nbits)
					yyerror("data too wide for the number of bits");
				if (strlen(adrbuf) > nwords)
					yyerror("address too high for the number of words");
				if (aorder == -1)
					strcpy(adrbuf, binvert(adrbuf));
				if (forder == -1)
					strcpy(datbuf, binvert(datbuf));
				if (nbits < 32) {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(datbuf, 0, 2);
					ydata[(i << 1) + 1] = 0;
				} else {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(&datbuf[nbits - 32], 0, 2);
					datbuf[nbits - 32] = '\0';
					ydata[(i << 1) + 1] = strtol(datbuf, 0, 2);
				}
				if (!used[i])
					used[i] = 1;
				else
					yyerror("same address used twice");
			}
#line 1398 "dpgen_ROM_code.c"
    break;

  case 7: /* line: dvalues WHEN avalues ';'  */
#line 237 "dpgen_ROM_code.y"
                        {
			int i;
#ifdef PARSEOUT
				fprintf(stdout, "\n%s when %s\n", datbuf, adrbuf);
#endif
				if (strlen(datbuf) > nbits)
					yyerror("data too wide for the number of bits");
				if (strlen(adrbuf) > nwords)
					yyerror("address too high for the number of words");
				if (aorder == -1)
					strcpy(adrbuf, binvert(adrbuf));
				if (forder == -1)
					strcpy(datbuf, binvert(datbuf));
				if (nbits < 32) {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(datbuf, 0, 2);
					ydata[(i << 1) + 1] = 0;
				} else {
					i = strtol(adrbuf, 0, 2);
					ydata[(i << 1)    ] = strtol(&datbuf[nbits - 32], 0, 2);
					datbuf[nbits - 32] = '\0';
					ydata[(i << 1) + 1] = strtol(datbuf, 0, 2);
				}
				if (!used[i])
					used[i] = 1;
				else
					yyerror("same address used twice");
			}
#line 1431 "dpgen_ROM_code.c"
    break;

  case 8: /* line: dvalues WHEN OTHERS ';'  */
#line 266 "dpgen_ROM_code.y"
                        {
			int  i;
         	long j[2];
#ifdef PARSEOUT
				fprintf(stdout, "\n%s when others\n", datbuf);
#endif
				if (strlen(datbuf) > nbits)
					yyerror("data too wide for the number of bits");
				if (strlen(adrbuf) > nwords)
					yyerror("address too high for the number of words");
				if (forder == -1)
					strcpy(datbuf, binvert(datbuf));
				if (nbits < 32) {
					j[0] = strtol(datbuf, 0, 2);
					j[1] = 0;
				} else {
					j[0] = strtol(&datbuf[nbits - 32], 0, 2);
					datbuf[nbits - 32] = '\0';
					j[1] = strtol(datbuf, 0, 2);
				}
				for (i = 0; i < nwords; i++)
					if (!used[i])
						ydata[(i << 1)    ] = j[0],
						ydata[(i << 1) + 1] = j[1];
			}
#line 1461 "dpgen_ROM_code.c"
    break;

  case 9: /* line: %empty  */
#line 291 "dpgen_ROM_code.y"
                                {strcpy((yyval.string), "Just to have bison shut up");}
#line 1467 "dpgen_ROM_code.c"
    break;

  case 10: /* constant: CONSTANT STRING '=' value ';'  */
#line 295 "dpgen_ROM_code.y"
                        {
				asc = adddptr(asc, (yyvsp[-3].string), (yyvsp[-1].string));
			}
#line 1475 "dpgen_ROM_code.c"
    break;

  case 11: /* value: BSTRING  */
#line 300 "dpgen_ROM_code.y"
                          {strcpy((yyval.string), (yyvsp[0].string));}
#line 1481 "dpgen_ROM_code.c"
    break;

  case 12: /* value: OSTRING  */
#line 301 "dpgen_ROM_code.y"
                                  {strcpy((yyval.string), octbin((yyvsp[0].string)));}
#line 1487 "dpgen_ROM_code.c"
    break;

  case 13: /* value: XSTRING  */
#line 302 "dpgen_ROM_code.y"
                                  {strcpy((yyval.string), hexbin((yyvsp[0].string)));}
#line 1493 "dpgen_ROM_code.c"
    break;

  case 14: /* dvalues: value  */
#line 305 "dpgen_ROM_code.y"
                      {strcat(datbuf, (yyvsp[0].string));}
#line 1499 "dpgen_ROM_code.c"
    break;

  case 15: /* $@1: %empty  */
#line 306 "dpgen_ROM_code.y"
                                      {strcat(datbuf, (yyvsp[0].string));}
#line 1505 "dpgen_ROM_code.c"
    break;

  case 17: /* dvalues: STRING  */
#line 308 "dpgen_ROM_code.y"
                        {
			char *p = getdptr(asc, (yyvsp[0].string));

				if (p == NULL) {
					sprintf(datbuf, "unknown constant %s", (yyvsp[0].string));
					yyerror(datbuf);
				}
				strcat(datbuf, p);
			}
#line 1519 "dpgen_ROM_code.c"
    break;

  case 18: /* $@2: %empty  */
#line 317 "dpgen_ROM_code.y"
                                       {
			char *p = getdptr(asc, (yyvsp[0].string));

				if (p == NULL) {
					sprintf(datbuf, "unknown constant %s", (yyvsp[0].string));
					yyerror(datbuf);
				}
				strcat(datbuf, p);
			}
#line 1533 "dpgen_ROM_code.c"
    break;

  case 20: /* avalues: value  */
#line 328 "dpgen_ROM_code.y"
                      {strcat(adrbuf, (yyvsp[0].string));}
#line 1539 "dpgen_ROM_code.c"
    break;

  case 21: /* $@3: %empty  */
#line 329 "dpgen_ROM_code.y"
                                      {strcat(adrbuf, (yyvsp[0].string));}
#line 1545 "dpgen_ROM_code.c"
    break;

  case 23: /* avalues: STRING  */
#line 331 "dpgen_ROM_code.y"
                        {
			char *p = getdptr(asc, (yyvsp[0].string));

				if (p == NULL) {
					sprintf(adrbuf, "unknown constant %s", (yyvsp[0].string));
					yyerror(adrbuf);
				}
				strcat(adrbuf, p);
			}
#line 1559 "dpgen_ROM_code.c"
    break;

  case 24: /* $@4: %empty  */
#line 340 "dpgen_ROM_code.y"
                                       {
			char *p = getdptr(asc, (yyvsp[0].string));

				if (p == NULL) {
					sprintf(adrbuf, "unknown constant %s", (yyvsp[0].string));
					yyerror(adrbuf);
				}
				strcat(adrbuf, p);
			}
#line 1573 "dpgen_ROM_code.c"
    break;


#line 1577 "dpgen_ROM_code.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 351 "dpgen_ROM_code.y"


void dpgen_ROM_code(s, nb, nw, r, msb, data)
char *s;
long nb, nw, r, msb;
long *data;
{
FILE *f;

	if ((f = mbkfopen(s, "vbe", "r")) == NULL) {
		fprintf(stderr, "DPGEN_ROM error : cannot open file %s.vbe\n", s);
		EXIT(1);
	}
	readvhdlfile(f, s, nb, nw, r, msb, data);
	if (!notempty) {
		(void)fflush(stdout);
		(void)fprintf(stdout, "DPGEN_ROM : the file was empty of usable data\n");
		(void)fprintf(stdout, "            the generated ROM will contain zeros\n");
	}
	fclose(f);
}

static FILE *vhdlfile;

static void nextvhdlline(f, str)
FILE *f;
char *str;
{
char *s, *t;
int space;

		if (fgets(str, 512, f) == (char *)NULL)
			return;
		s = t = str;
		space = isspace(*t) ? 0 : 1;
		while (*t)
			if (!isspace(*t) || space) {
				space = isspace(*t) || *t == ':' ? 0 : 1;
				if (islower(*t))
					*t = toupper(*t);
				*s++ = *t++;
			} else {
				t++;
				space = 0;
			}
		*s = '\0';
}

static char *nextline()
{
static char str[256];

	nextvhdlline(vhdlfile, str);
	return str;
}

static void readvhdlfile(f, s, nb, nw, r, msb, data)
FILE *f;
char *s;
long nb, nw, r, msb;
long *data;
{
char str[256];
int i;

	/* globalize variables for yacc */
	nwords = nw;
	nbits = nb;
	rf = r;
	ibmbull = msb;
	ydata = data;
	vhdlfile = f;

	/* initialize stuff for OTHERS */
	for (i = 0; i < 8912; i++)
		used[i] = 0;

	while (!feof(f)) {
		line++;
		nextvhdlline(f, str); 
		vhdl_line = str;
		datbuf[0] = adrbuf[0] = '\0';
		yyparse();
	}
}

/* lexical analyser */
static int yylex()
{
static int c;
int i = 0;
char *s = vhdl_line; /* remember where to start from */

	while (*s && isspace(*s))
		s++;

	switch (*s) {
		case '\0':

#ifdef PARSEOUT
			printf("\n");
#endif

			return -1; /* expected by yacc as end of entries */

		case ';':
			c = '\0'; /* reset to nul state */
		case '<':
		case '=':
		case ',':
		case '&':
		case '(':
		case ')':

#ifdef PARSEOUT
			printf("(%c)", *s);
#endif

			if (*s == '<' && c == SELECT)
				c = WITH;
			vhdl_line = s;
			return *vhdl_line++;

		case ':':
			s++;
			while (*s && *s != '=')
				s++;

#ifdef PARSEOUT
			printf("(%c)", *s);
#endif

			vhdl_line = ++s;
			return '=';

		case '-':
			if (*++s == '-') {
#ifdef PARSEOUT
				printf("COMMENT\n");
#endif
				return -1;
			} 
			return *vhdl_line++;

		case 'C':
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (!strcmp(yylval.string, "CONSTANT")) {

#ifdef PARSEOUT
				printf("TOKEN[%s]", yylval.string);
#endif

				return c = CONSTANT;
			}

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif
			if (c != SELECT && c != WITH && c != CONSTANT)
				*vhdl_line = '\0';
			return STRING;


		case 'G':
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (!strcmp(yylval.string, "GENERIC")) {
				while (1) {
					if (!*s)
						s = nextline();
					if (*s++ == '(') {
						s--;
						i = 0;
						break;
					}
				}
				while (1) {
					if (!*s)
						s = nextline();
					switch (*s++) {
						case '(':
							i++;
							break;
						case ')':
							i--;
							break;
						case '\n':
							line++;
					} 
					if (i == 0)
						break;
				}
			
				*vhdl_line = '\0';
				return STRING;
			}

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif
			if (c != SELECT && c != WITH && c != CONSTANT)
				*vhdl_line = '\0';
			return STRING;

		case 'W':
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (!strcmp(yylval.string, "WHEN")) {

#ifdef PARSEOUT
				printf("TOKEN[%s]", yylval.string);
#endif

				return WHEN;
			} else if (!strcmp(yylval.string, "WITH")) {

#ifdef PARSEOUT
				printf("TOKEN[%s]", yylval.string);
#endif

				c = SELECT;
				return WITH;
			} else {

#ifdef PARSEOUT
				printf("STRING{%s}", yylval.string);
#endif
				if (c != SELECT && c != WITH && c != CONSTANT)
					*vhdl_line = '\0';
				return STRING;
			}

		case 'S':
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (!strcmp(yylval.string, "SELECT")) {

#ifdef PARSEOUT
				printf("TOKEN[%s]", yylval.string);
#endif

				*vhdl_line = '\0';
				return SELECT;
			} else {

#ifdef PARSEOUT
				printf("STRING{%s}", yylval.string);
#endif
				if (c != SELECT && c != WITH && c != CONSTANT)
					*vhdl_line = '\0';
				return STRING;
			}

		case 'B':
			if (c != SELECT && c != WITH && c != CONSTANT) {
				*vhdl_line = '\0';
				return STRING;
			}
			if (*(s + 1) == '"') {
				s += 2;
				while (*s && *s != '"')
					if (*s != '0' && *s != '1')
						yyerror("bad binary number");
					else
						yylval.string[i++] = *s++;
				yylval.string[i] = '\0';
				vhdl_line = ++s;

#ifdef PARSEOUT
				printf("BSTRING{%s}", yylval.string);
#endif
				return BSTRING;
			}
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif
			return STRING;

		case 'O':
			if (c != SELECT && c != WITH && c != CONSTANT) {
				*vhdl_line = '\0';
				return STRING;
			}
				
			if (*(s + 1) == '"') {
				s += 2;
				while (*s && *s != '"')
					if (!isdigit(*s) && *s != '8' && *s != '9')
						yyerror("bad octal number");
					else
						yylval.string[i++] = *s++;
				yylval.string[i] = '\0';
				vhdl_line = ++s;

#ifdef PARSEOUT
				printf("OSTRING{%s}", yylval.string);
#endif
				return OSTRING;
			}
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (!strcmp(yylval.string, "OTHERS")) {

#ifdef PARSEOUT
				printf("TOKEN[%s]", yylval.string);
#endif

				return OTHERS;
			}

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif
			return STRING;

		case 'X':
			if (c != SELECT && c != WITH && c != CONSTANT) {
				*vhdl_line = '\0';
				return STRING;
			}
			if (*(s + 1) == '"') {
				s += 2;
				while (*s && *s != '"')
					if (!isxdigit(*s))
						yyerror("bad hexadecimal number");
					else
						yylval.string[i++] = *s++;
				yylval.string[i] = '\0';
				vhdl_line = ++s;

#ifdef PARSEOUT
				printf("XSTRING{%s}", yylval.string);
#endif
				return XSTRING;
			}
			while (*s && (isalnum(*s) || *s == '_'))
				yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif
			return STRING;

		default:
			if (c == SELECT)
				while (*s && !isspace(*s) && *s != '(' && *s != ')')
					yylval.string[i++] = *s++;
			else
				while (*s && !isspace(*s))
					yylval.string[i++] = *s++;
			yylval.string[i] = '\0';
			vhdl_line = s;
			if (c != SELECT && c != WITH && c != CONSTANT)
				*vhdl_line = '\0';

#ifdef PARSEOUT
			printf("STRING{%s}", yylval.string);
#endif

			return STRING;
	}
}

static int yyerror(s)
char *s;
{
	fflush(stdout);
	fprintf(stderr, "DPGEN_ROM : %s on line %d (%s), '%c'\n",
				     s, line, vhdl_line, yychar);
	exit(1);
}
