/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with EDIF_ or edif_.  They are
   private implementation details that can be changed or removed.  */

#ifndef EDIF_EDIF_Y_TAB_H_INCLUDED
# define EDIF_EDIF_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef EDIFDEBUG
# define EDIFDEBUG 0
#endif
#if EDIFDEBUG
extern int edifdebug;
#endif

/* Token kinds.  */
#ifndef EDIFTOKENTYPE
# define EDIFTOKENTYPE
  enum ediftokentype
  {
    EDIFEMPTY = -2,
    EDIFEOF = 0,                     /* "end of file"  */
    EDIFerror = 256,                 /* error  */
    EDIFUNDEF = 257,                 /* "invalid token"  */
    T_EDIF = 258,                  /* T_EDIF  */
    T_EDIFVERSION = 259,           /* T_EDIFVERSION  */
    T_EDIFLEVEL = 260,             /* T_EDIFLEVEL  */
    T_TECHNOLOGY = 261,            /* T_TECHNOLOGY  */
    T_CELLTYPE = 262,              /* T_CELLTYPE  */
    T_CELLTYPE_GENERIC = 263,      /* T_CELLTYPE_GENERIC  */
    T_CELLTYPE_TIE = 264,          /* T_CELLTYPE_TIE  */
    T_CELLTYPE_RIPPER = 265,       /* T_CELLTYPE_RIPPER  */
    T_PROPERTY = 266,              /* T_PROPERTY  */
    T_VIEWTYPE = 267,              /* T_VIEWTYPE  */
    T_INTERFACE = 268,             /* T_INTERFACE  */
    T_CONTENTS = 269,              /* T_CONTENTS  */
    T_JOINED = 270,                /* T_JOINED  */
    T_INSTANCE = 271,              /* T_INSTANCE  */
    T_VIEWREF = 272,               /* T_VIEWREF  */
    T_PORT = 273,                  /* T_PORT  */
    T_DIRECTION = 274,             /* T_DIRECTION  */
    T_INOUT = 275,                 /* T_INOUT  */
    T_PORTREF = 276,               /* T_PORTREF  */
    T_NETLIST = 277,               /* T_NETLIST  */
    T_KEYWORDMAP = 278,            /* T_KEYWORDMAP  */
    T_KEYWORDLEVEL = 279,          /* T_KEYWORDLEVEL  */
    T_EXTERNAL = 280,              /* T_EXTERNAL  */
    T_LIBRARYREF = 281,            /* T_LIBRARYREF  */
    T_OUTPUT = 282,                /* T_OUTPUT  */
    T_INSTANCEREF = 283,           /* T_INSTANCEREF  */
    T_MEMBER = 284,                /* T_MEMBER  */
    T_RENAME = 285,                /* T_RENAME  */
    T_NAME = 286,                  /* T_NAME  */
    T_STRING = 287,                /* T_STRING  */
    T_PORTINSTANCE = 288,          /* T_PORTINSTANCE  */
    T_LIBRARY = 289,               /* T_LIBRARY  */
    T_CELL = 290,                  /* T_CELL  */
    T_VIEW = 291,                  /* T_VIEW  */
    T_NET = 292,                   /* T_NET  */
    T_CELLREF = 293,               /* T_CELLREF  */
    T_INPUT = 294,                 /* T_INPUT  */
    T_STATUS = 295,                /* T_STATUS  */
    T_IDENT = 296,                 /* T_IDENT  */
    T_ARRAY = 297,                 /* T_ARRAY  */
    T_RENAME_STRING = 298,         /* T_RENAME_STRING  */
    T_PORTLIST = 299,              /* T_PORTLIST  */
    T_INTEGER = 300                /* T_INTEGER  */
  };
  typedef enum ediftokentype ediftoken_kind_t;
#endif
/* Token kinds.  */
#define EDIFEMPTY -2
#define EDIFEOF 0
#define EDIFerror 256
#define EDIFUNDEF 257
#define T_EDIF 258
#define T_EDIFVERSION 259
#define T_EDIFLEVEL 260
#define T_TECHNOLOGY 261
#define T_CELLTYPE 262
#define T_CELLTYPE_GENERIC 263
#define T_CELLTYPE_TIE 264
#define T_CELLTYPE_RIPPER 265
#define T_PROPERTY 266
#define T_VIEWTYPE 267
#define T_INTERFACE 268
#define T_CONTENTS 269
#define T_JOINED 270
#define T_INSTANCE 271
#define T_VIEWREF 272
#define T_PORT 273
#define T_DIRECTION 274
#define T_INOUT 275
#define T_PORTREF 276
#define T_NETLIST 277
#define T_KEYWORDMAP 278
#define T_KEYWORDLEVEL 279
#define T_EXTERNAL 280
#define T_LIBRARYREF 281
#define T_OUTPUT 282
#define T_INSTANCEREF 283
#define T_MEMBER 284
#define T_RENAME 285
#define T_NAME 286
#define T_STRING 287
#define T_PORTINSTANCE 288
#define T_LIBRARY 289
#define T_CELL 290
#define T_VIEW 291
#define T_NET 292
#define T_CELLREF 293
#define T_INPUT 294
#define T_STATUS 295
#define T_IDENT 296
#define T_ARRAY 297
#define T_RENAME_STRING 298
#define T_PORTLIST 299
#define T_INTEGER 300

/* Value type.  */
#if ! defined EDIFSTYPE && ! defined EDIFSTYPE_IS_DECLARED
union EDIFSTYPE
{
#line 79 "./parser_y.y"

		long    lval;
		char    sval[100];
	

#line 163 "y.tab.h"

};
typedef union EDIFSTYPE EDIFSTYPE;
# define EDIFSTYPE_IS_TRIVIAL 1
# define EDIFSTYPE_IS_DECLARED 1
#endif


extern EDIFSTYPE ediflval;


int edifparse (void);


#endif /* !EDIF_EDIF_Y_TAB_H_INCLUDED  */
