/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 13 "./mvl_scomp_y.y"

#include <stdio.h>
#include <string.h>
#include "mut.h"
#include "mlo.h"
#include "mvl_stype.h"
#include "mvl_syacc.h"
#include "mvl_stdef.h"
#include "gen_generic.h"


extern int           yylex      ();
extern void          yyerror    ();

static int           MVL_CONRNK = 0   ; /* rank of an implicit connexion*/
static int           MVL_SIGIDX = 1   ; /* structural's signal index    */
static int           MVL_SIMFLG = 0   ; /* simple flag                  */
static int           MVL_CONCNT = 0   ; /* connector's count            */
static char         *MVL_MODNAM ;       /* current model name           */
static char         *MVL_CHDNAM ;       /* child's model name           */
static char         *MVL_LOCNAM ;       /* instance's name              */
static struct chain *MVL_NM1LST = NULL; /* 1-st name liste              */
static struct chain *MVL_NM2LST = NULL; /* 2-nd name liste              */
static struct lofig *MVL_CHDPNT = NULL; /* current child pointer        */
static struct lofig *MVL_CHDHED = NULL; /* childs list                  */
static struct ptype *MVL_PTPPNT = NULL;
static struct chain *MVL_GENLST = NULL;
static struct logen *MVL_GENPNT = NULL;
static struct logen  MVL_LOGEN;
static long              base ;


#line 104 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    Ampersand = 258,               /* Ampersand  */
    Apostrophe = 259,              /* Apostrophe  */
    LeftParen = 260,               /* LeftParen  */
    RightParen = 261,              /* RightParen  */
    DoubleStar = 262,              /* DoubleStar  */
    Star = 263,                    /* Star  */
    Plus = 264,                    /* Plus  */
    Comma = 265,                   /* Comma  */
    Minus = 266,                   /* Minus  */
    VarAsgn = 267,                 /* VarAsgn  */
    Colon = 268,                   /* Colon  */
    Semicolon = 269,               /* Semicolon  */
    _LESym = 270,                  /* _LESym  */
    Box = 271,                     /* Box  */
    _LTSym = 272,                  /* _LTSym  */
    Arrow = 273,                   /* Arrow  */
    _EQSym = 274,                  /* _EQSym  */
    _GESym = 275,                  /* _GESym  */
    _GTSym = 276,                  /* _GTSym  */
    Bar = 277,                     /* Bar  */
    _NESym = 278,                  /* _NESym  */
    Dot = 279,                     /* Dot  */
    Slash = 280,                   /* Slash  */
    Identifier = 281,              /* Identifier  */
    DecimalInt = 282,              /* DecimalInt  */
    DecimalReal = 283,             /* DecimalReal  */
    AbstractLit = 284,             /* AbstractLit  */
    BasedInt = 285,                /* BasedInt  */
    BasedReal = 286,               /* BasedReal  */
    CharacterLit = 287,            /* CharacterLit  */
    StringLit = 288,               /* StringLit  */
    BitStringLit = 289,            /* BitStringLit  */
    ABS = 290,                     /* ABS  */
    ACCESS = 291,                  /* ACCESS  */
    AFTER = 292,                   /* AFTER  */
    ALIAS = 293,                   /* ALIAS  */
    ALL = 294,                     /* ALL  */
    tok_AND = 295,                 /* tok_AND  */
    ARCHITECTURE = 296,            /* ARCHITECTURE  */
    ARRAY = 297,                   /* ARRAY  */
    ARG = 298,                     /* ARG  */
    ASSERT = 299,                  /* ASSERT  */
    ATTRIBUTE = 300,               /* ATTRIBUTE  */
    _BEGIN = 301,                  /* _BEGIN  */
    BIT = 302,                     /* BIT  */
    BIT_VECTOR = 303,              /* BIT_VECTOR  */
    BLOCK = 304,                   /* BLOCK  */
    BODY = 305,                    /* BODY  */
    BUFFER = 306,                  /* BUFFER  */
    BUS = 307,                     /* BUS  */
    CASE = 308,                    /* CASE  */
    CLOCK = 309,                   /* CLOCK  */
    COMPONENT = 310,               /* COMPONENT  */
    CONFIGURATION = 311,           /* CONFIGURATION  */
    CONSTANT = 312,                /* CONSTANT  */
    CONVERT = 313,                 /* CONVERT  */
    DISCONNECT = 314,              /* DISCONNECT  */
    DOWNTO = 315,                  /* DOWNTO  */
    ELSE = 316,                    /* ELSE  */
    ELSIF = 317,                   /* ELSIF  */
    _END = 318,                    /* _END  */
    ENTITY = 319,                  /* ENTITY  */
    ERROR = 320,                   /* ERROR  */
    _EXIT = 321,                   /* _EXIT  */
    _FILE = 322,                   /* _FILE  */
    FOR = 323,                     /* FOR  */
    FUNCTION = 324,                /* FUNCTION  */
    GENERATE = 325,                /* GENERATE  */
    GENERIC = 326,                 /* GENERIC  */
    GUARDED = 327,                 /* GUARDED  */
    IF = 328,                      /* IF  */
    _IN = 329,                     /* _IN  */
    _INOUT = 330,                  /* _INOUT  */
    INTEGER = 331,                 /* INTEGER  */
    IS = 332,                      /* IS  */
    _LABEL = 333,                  /* _LABEL  */
    LIBRARY = 334,                 /* LIBRARY  */
    _LINKAGE = 335,                /* _LINKAGE  */
    _LIST = 336,                   /* _LIST  */
    LOOP = 337,                    /* LOOP  */
    MAP = 338,                     /* MAP  */
    MOD = 339,                     /* MOD  */
    MUX_BIT = 340,                 /* MUX_BIT  */
    MUX_VECTOR = 341,              /* MUX_VECTOR  */
    _NAND = 342,                   /* _NAND  */
    NATURAL = 343,                 /* NATURAL  */
    NATURAL_VECTOR = 344,          /* NATURAL_VECTOR  */
    NEW = 345,                     /* NEW  */
    _NEXT = 346,                   /* _NEXT  */
    _NOR = 347,                    /* _NOR  */
    _NOT = 348,                    /* _NOT  */
    tok_NULL = 349,                /* tok_NULL  */
    OF = 350,                      /* OF  */
    ON = 351,                      /* ON  */
    OPEN = 352,                    /* OPEN  */
    _OR = 353,                     /* _OR  */
    OTHERS = 354,                  /* OTHERS  */
    _OUT = 355,                    /* _OUT  */
    _PACKAGE = 356,                /* _PACKAGE  */
    PORT = 357,                    /* PORT  */
    POSITIVE = 358,                /* POSITIVE  */
    PROCEDURE = 359,               /* PROCEDURE  */
    PROCESS = 360,                 /* PROCESS  */
    RANGE = 361,                   /* RANGE  */
    RECORD = 362,                  /* RECORD  */
    REG_BIT = 363,                 /* REG_BIT  */
    REG_VECTOR = 364,              /* REG_VECTOR  */
    REGISTER = 365,                /* REGISTER  */
    REM = 366,                     /* REM  */
    REPORT = 367,                  /* REPORT  */
    RETURN = 368,                  /* RETURN  */
    SELECT = 369,                  /* SELECT  */
    SEVERITY = 370,                /* SEVERITY  */
    SIGNAL = 371,                  /* SIGNAL  */
    _STABLE = 372,                 /* _STABLE  */
    STRING = 373,                  /* STRING  */
    SUBTYPE = 374,                 /* SUBTYPE  */
    THEN = 375,                    /* THEN  */
    TO = 376,                      /* TO  */
    TRANSPORT = 377,               /* TRANSPORT  */
    _TYPE = 378,                   /* _TYPE  */
    UNITS = 379,                   /* UNITS  */
    UNTIL = 380,                   /* UNTIL  */
    USE = 381,                     /* USE  */
    VARIABLE = 382,                /* VARIABLE  */
    WAIT = 383,                    /* WAIT  */
    WARNING = 384,                 /* WARNING  */
    WHEN = 385,                    /* WHEN  */
    WHILE = 386,                   /* WHILE  */
    WITH = 387,                    /* WITH  */
    WOR_BIT = 388,                 /* WOR_BIT  */
    WOR_VECTOR = 389,              /* WOR_VECTOR  */
    _XOR = 390                     /* _XOR  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define Ampersand 258
#define Apostrophe 259
#define LeftParen 260
#define RightParen 261
#define DoubleStar 262
#define Star 263
#define Plus 264
#define Comma 265
#define Minus 266
#define VarAsgn 267
#define Colon 268
#define Semicolon 269
#define _LESym 270
#define Box 271
#define _LTSym 272
#define Arrow 273
#define _EQSym 274
#define _GESym 275
#define _GTSym 276
#define Bar 277
#define _NESym 278
#define Dot 279
#define Slash 280
#define Identifier 281
#define DecimalInt 282
#define DecimalReal 283
#define AbstractLit 284
#define BasedInt 285
#define BasedReal 286
#define CharacterLit 287
#define StringLit 288
#define BitStringLit 289
#define ABS 290
#define ACCESS 291
#define AFTER 292
#define ALIAS 293
#define ALL 294
#define tok_AND 295
#define ARCHITECTURE 296
#define ARRAY 297
#define ARG 298
#define ASSERT 299
#define ATTRIBUTE 300
#define _BEGIN 301
#define BIT 302
#define BIT_VECTOR 303
#define BLOCK 304
#define BODY 305
#define BUFFER 306
#define BUS 307
#define CASE 308
#define CLOCK 309
#define COMPONENT 310
#define CONFIGURATION 311
#define CONSTANT 312
#define CONVERT 313
#define DISCONNECT 314
#define DOWNTO 315
#define ELSE 316
#define ELSIF 317
#define _END 318
#define ENTITY 319
#define ERROR 320
#define _EXIT 321
#define _FILE 322
#define FOR 323
#define FUNCTION 324
#define GENERATE 325
#define GENERIC 326
#define GUARDED 327
#define IF 328
#define _IN 329
#define _INOUT 330
#define INTEGER 331
#define IS 332
#define _LABEL 333
#define LIBRARY 334
#define _LINKAGE 335
#define _LIST 336
#define LOOP 337
#define MAP 338
#define MOD 339
#define MUX_BIT 340
#define MUX_VECTOR 341
#define _NAND 342
#define NATURAL 343
#define NATURAL_VECTOR 344
#define NEW 345
#define _NEXT 346
#define _NOR 347
#define _NOT 348
#define tok_NULL 349
#define OF 350
#define ON 351
#define OPEN 352
#define _OR 353
#define OTHERS 354
#define _OUT 355
#define _PACKAGE 356
#define PORT 357
#define POSITIVE 358
#define PROCEDURE 359
#define PROCESS 360
#define RANGE 361
#define RECORD 362
#define REG_BIT 363
#define REG_VECTOR 364
#define REGISTER 365
#define REM 366
#define REPORT 367
#define RETURN 368
#define SELECT 369
#define SEVERITY 370
#define SIGNAL 371
#define _STABLE 372
#define STRING 373
#define SUBTYPE 374
#define THEN 375
#define TO 376
#define TRANSPORT 377
#define _TYPE 378
#define UNITS 379
#define UNTIL 380
#define USE 381
#define VARIABLE 382
#define WAIT 383
#define WARNING 384
#define WHEN 385
#define WHILE 386
#define WITH 387
#define WOR_BIT 388
#define WOR_VECTOR 389
#define _XOR 390

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 46 "./mvl_scomp_y.y"

  long         valu;
  char       *text;
  char        flag;
  mvl_name    name;
  mvl_expr    expr;
  

#line 436 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Ampersand = 3,                  /* Ampersand  */
  YYSYMBOL_Apostrophe = 4,                 /* Apostrophe  */
  YYSYMBOL_LeftParen = 5,                  /* LeftParen  */
  YYSYMBOL_RightParen = 6,                 /* RightParen  */
  YYSYMBOL_DoubleStar = 7,                 /* DoubleStar  */
  YYSYMBOL_Star = 8,                       /* Star  */
  YYSYMBOL_Plus = 9,                       /* Plus  */
  YYSYMBOL_Comma = 10,                     /* Comma  */
  YYSYMBOL_Minus = 11,                     /* Minus  */
  YYSYMBOL_VarAsgn = 12,                   /* VarAsgn  */
  YYSYMBOL_Colon = 13,                     /* Colon  */
  YYSYMBOL_Semicolon = 14,                 /* Semicolon  */
  YYSYMBOL__LESym = 15,                    /* _LESym  */
  YYSYMBOL_Box = 16,                       /* Box  */
  YYSYMBOL__LTSym = 17,                    /* _LTSym  */
  YYSYMBOL_Arrow = 18,                     /* Arrow  */
  YYSYMBOL__EQSym = 19,                    /* _EQSym  */
  YYSYMBOL__GESym = 20,                    /* _GESym  */
  YYSYMBOL__GTSym = 21,                    /* _GTSym  */
  YYSYMBOL_Bar = 22,                       /* Bar  */
  YYSYMBOL__NESym = 23,                    /* _NESym  */
  YYSYMBOL_Dot = 24,                       /* Dot  */
  YYSYMBOL_Slash = 25,                     /* Slash  */
  YYSYMBOL_Identifier = 26,                /* Identifier  */
  YYSYMBOL_DecimalInt = 27,                /* DecimalInt  */
  YYSYMBOL_DecimalReal = 28,               /* DecimalReal  */
  YYSYMBOL_AbstractLit = 29,               /* AbstractLit  */
  YYSYMBOL_BasedInt = 30,                  /* BasedInt  */
  YYSYMBOL_BasedReal = 31,                 /* BasedReal  */
  YYSYMBOL_CharacterLit = 32,              /* CharacterLit  */
  YYSYMBOL_StringLit = 33,                 /* StringLit  */
  YYSYMBOL_BitStringLit = 34,              /* BitStringLit  */
  YYSYMBOL_ABS = 35,                       /* ABS  */
  YYSYMBOL_ACCESS = 36,                    /* ACCESS  */
  YYSYMBOL_AFTER = 37,                     /* AFTER  */
  YYSYMBOL_ALIAS = 38,                     /* ALIAS  */
  YYSYMBOL_ALL = 39,                       /* ALL  */
  YYSYMBOL_tok_AND = 40,                   /* tok_AND  */
  YYSYMBOL_ARCHITECTURE = 41,              /* ARCHITECTURE  */
  YYSYMBOL_ARRAY = 42,                     /* ARRAY  */
  YYSYMBOL_ARG = 43,                       /* ARG  */
  YYSYMBOL_ASSERT = 44,                    /* ASSERT  */
  YYSYMBOL_ATTRIBUTE = 45,                 /* ATTRIBUTE  */
  YYSYMBOL__BEGIN = 46,                    /* _BEGIN  */
  YYSYMBOL_BIT = 47,                       /* BIT  */
  YYSYMBOL_BIT_VECTOR = 48,                /* BIT_VECTOR  */
  YYSYMBOL_BLOCK = 49,                     /* BLOCK  */
  YYSYMBOL_BODY = 50,                      /* BODY  */
  YYSYMBOL_BUFFER = 51,                    /* BUFFER  */
  YYSYMBOL_BUS = 52,                       /* BUS  */
  YYSYMBOL_CASE = 53,                      /* CASE  */
  YYSYMBOL_CLOCK = 54,                     /* CLOCK  */
  YYSYMBOL_COMPONENT = 55,                 /* COMPONENT  */
  YYSYMBOL_CONFIGURATION = 56,             /* CONFIGURATION  */
  YYSYMBOL_CONSTANT = 57,                  /* CONSTANT  */
  YYSYMBOL_CONVERT = 58,                   /* CONVERT  */
  YYSYMBOL_DISCONNECT = 59,                /* DISCONNECT  */
  YYSYMBOL_DOWNTO = 60,                    /* DOWNTO  */
  YYSYMBOL_ELSE = 61,                      /* ELSE  */
  YYSYMBOL_ELSIF = 62,                     /* ELSIF  */
  YYSYMBOL__END = 63,                      /* _END  */
  YYSYMBOL_ENTITY = 64,                    /* ENTITY  */
  YYSYMBOL_ERROR = 65,                     /* ERROR  */
  YYSYMBOL__EXIT = 66,                     /* _EXIT  */
  YYSYMBOL__FILE = 67,                     /* _FILE  */
  YYSYMBOL_FOR = 68,                       /* FOR  */
  YYSYMBOL_FUNCTION = 69,                  /* FUNCTION  */
  YYSYMBOL_GENERATE = 70,                  /* GENERATE  */
  YYSYMBOL_GENERIC = 71,                   /* GENERIC  */
  YYSYMBOL_GUARDED = 72,                   /* GUARDED  */
  YYSYMBOL_IF = 73,                        /* IF  */
  YYSYMBOL__IN = 74,                       /* _IN  */
  YYSYMBOL__INOUT = 75,                    /* _INOUT  */
  YYSYMBOL_INTEGER = 76,                   /* INTEGER  */
  YYSYMBOL_IS = 77,                        /* IS  */
  YYSYMBOL__LABEL = 78,                    /* _LABEL  */
  YYSYMBOL_LIBRARY = 79,                   /* LIBRARY  */
  YYSYMBOL__LINKAGE = 80,                  /* _LINKAGE  */
  YYSYMBOL__LIST = 81,                     /* _LIST  */
  YYSYMBOL_LOOP = 82,                      /* LOOP  */
  YYSYMBOL_MAP = 83,                       /* MAP  */
  YYSYMBOL_MOD = 84,                       /* MOD  */
  YYSYMBOL_MUX_BIT = 85,                   /* MUX_BIT  */
  YYSYMBOL_MUX_VECTOR = 86,                /* MUX_VECTOR  */
  YYSYMBOL__NAND = 87,                     /* _NAND  */
  YYSYMBOL_NATURAL = 88,                   /* NATURAL  */
  YYSYMBOL_NATURAL_VECTOR = 89,            /* NATURAL_VECTOR  */
  YYSYMBOL_NEW = 90,                       /* NEW  */
  YYSYMBOL__NEXT = 91,                     /* _NEXT  */
  YYSYMBOL__NOR = 92,                      /* _NOR  */
  YYSYMBOL__NOT = 93,                      /* _NOT  */
  YYSYMBOL_tok_NULL = 94,                  /* tok_NULL  */
  YYSYMBOL_OF = 95,                        /* OF  */
  YYSYMBOL_ON = 96,                        /* ON  */
  YYSYMBOL_OPEN = 97,                      /* OPEN  */
  YYSYMBOL__OR = 98,                       /* _OR  */
  YYSYMBOL_OTHERS = 99,                    /* OTHERS  */
  YYSYMBOL__OUT = 100,                     /* _OUT  */
  YYSYMBOL__PACKAGE = 101,                 /* _PACKAGE  */
  YYSYMBOL_PORT = 102,                     /* PORT  */
  YYSYMBOL_POSITIVE = 103,                 /* POSITIVE  */
  YYSYMBOL_PROCEDURE = 104,                /* PROCEDURE  */
  YYSYMBOL_PROCESS = 105,                  /* PROCESS  */
  YYSYMBOL_RANGE = 106,                    /* RANGE  */
  YYSYMBOL_RECORD = 107,                   /* RECORD  */
  YYSYMBOL_REG_BIT = 108,                  /* REG_BIT  */
  YYSYMBOL_REG_VECTOR = 109,               /* REG_VECTOR  */
  YYSYMBOL_REGISTER = 110,                 /* REGISTER  */
  YYSYMBOL_REM = 111,                      /* REM  */
  YYSYMBOL_REPORT = 112,                   /* REPORT  */
  YYSYMBOL_RETURN = 113,                   /* RETURN  */
  YYSYMBOL_SELECT = 114,                   /* SELECT  */
  YYSYMBOL_SEVERITY = 115,                 /* SEVERITY  */
  YYSYMBOL_SIGNAL = 116,                   /* SIGNAL  */
  YYSYMBOL__STABLE = 117,                  /* _STABLE  */
  YYSYMBOL_STRING = 118,                   /* STRING  */
  YYSYMBOL_SUBTYPE = 119,                  /* SUBTYPE  */
  YYSYMBOL_THEN = 120,                     /* THEN  */
  YYSYMBOL_TO = 121,                       /* TO  */
  YYSYMBOL_TRANSPORT = 122,                /* TRANSPORT  */
  YYSYMBOL__TYPE = 123,                    /* _TYPE  */
  YYSYMBOL_UNITS = 124,                    /* UNITS  */
  YYSYMBOL_UNTIL = 125,                    /* UNTIL  */
  YYSYMBOL_USE = 126,                      /* USE  */
  YYSYMBOL_VARIABLE = 127,                 /* VARIABLE  */
  YYSYMBOL_WAIT = 128,                     /* WAIT  */
  YYSYMBOL_WARNING = 129,                  /* WARNING  */
  YYSYMBOL_WHEN = 130,                     /* WHEN  */
  YYSYMBOL_WHILE = 131,                    /* WHILE  */
  YYSYMBOL_WITH = 132,                     /* WITH  */
  YYSYMBOL_WOR_BIT = 133,                  /* WOR_BIT  */
  YYSYMBOL_WOR_VECTOR = 134,               /* WOR_VECTOR  */
  YYSYMBOL__XOR = 135,                     /* _XOR  */
  YYSYMBOL_YYACCEPT = 136,                 /* $accept  */
  YYSYMBOL_design_file = 137,              /* design_file  */
  YYSYMBOL_entity_declaration = 138,       /* entity_declaration  */
  YYSYMBOL_139_1 = 139,                    /* $@1  */
  YYSYMBOL_140_generic_clause_ = 140,      /* .generic_clause.  */
  YYSYMBOL_generic_clause = 141,           /* generic_clause  */
  YYSYMBOL_142_2 = 142,                    /* $@2  */
  YYSYMBOL_formal_generic_list = 143,      /* formal_generic_list  */
  YYSYMBOL_144_formal_generic_element_ = 144, /* ...formal_generic_element..  */
  YYSYMBOL_formal_generic_element = 145,   /* formal_generic_element  */
  YYSYMBOL_generic_VarAsgn__expression = 146, /* generic_VarAsgn__expression  */
  YYSYMBOL_147_constraint_ = 147,          /* .constraint.  */
  YYSYMBOL_constraint = 148,               /* constraint  */
  YYSYMBOL_range = 149,                    /* range  */
  YYSYMBOL_direction = 150,                /* direction  */
  YYSYMBOL_151_port_clause_ = 151,         /* .port_clause.  */
  YYSYMBOL_port_clause = 152,              /* port_clause  */
  YYSYMBOL_formal_port_list = 153,         /* formal_port_list  */
  YYSYMBOL_154_formal_port_element_ = 154, /* ...formal_port_element..  */
  YYSYMBOL_formal_port_element = 155,      /* formal_port_element  */
  YYSYMBOL_architecture_body = 156,        /* architecture_body  */
  YYSYMBOL_157_3 = 157,                    /* $@3  */
  YYSYMBOL_158_4 = 158,                    /* $@4  */
  YYSYMBOL_architecture_declarative_part = 159, /* architecture_declarative_part  */
  YYSYMBOL_160_block_declaration_item_ = 160, /* ..block_declaration_item..  */
  YYSYMBOL_block_declaration_item = 161,   /* block_declaration_item  */
  YYSYMBOL_signal_declaration = 162,       /* signal_declaration  */
  YYSYMBOL_component_declaration = 163,    /* component_declaration  */
  YYSYMBOL_164_5 = 164,                    /* $@5  */
  YYSYMBOL_165_PORT__local_port_list_ = 165, /* .PORT__local_port_list.  */
  YYSYMBOL_local_port_list = 166,          /* local_port_list  */
  YYSYMBOL_167_local_port_element_ = 167,  /* ...local_port_element..  */
  YYSYMBOL_local_port_element = 168,       /* local_port_element  */
  YYSYMBOL_architecture_statement_part = 169, /* architecture_statement_part  */
  YYSYMBOL_170_concurrent_statement_ = 170, /* ..concurrent_statement..  */
  YYSYMBOL_concurrent_statement = 171,     /* concurrent_statement  */
  YYSYMBOL_component_instantiation_statement = 172, /* component_instantiation_statement  */
  YYSYMBOL_173_6 = 173,                    /* $@6  */
  YYSYMBOL_174_generic_map_aspect_ = 174,  /* .generic_map_aspect.  */
  YYSYMBOL_generic_map_aspect = 175,       /* generic_map_aspect  */
  YYSYMBOL_generic_association_list = 176, /* generic_association_list  */
  YYSYMBOL_177_generic_association_element_ = 177, /* ...generic_association_element..  */
  YYSYMBOL_generic_association_element = 178, /* generic_association_element  */
  YYSYMBOL_formal_generic_name = 179,      /* formal_generic_name  */
  YYSYMBOL_actual_generic_name = 180,      /* actual_generic_name  */
  YYSYMBOL_generic_expression = 181,       /* generic_expression  */
  YYSYMBOL_generic_relation = 182,         /* generic_relation  */
  YYSYMBOL_generic_simple_expression = 183, /* generic_simple_expression  */
  YYSYMBOL_184_7 = 184,                    /* $@7  */
  YYSYMBOL_185_sign_ = 185,                /* .sign.  */
  YYSYMBOL_generic_term = 186,             /* generic_term  */
  YYSYMBOL_187_generic_term_ = 187,        /* ...generic_term..  */
  YYSYMBOL_generic_factor = 188,           /* generic_factor  */
  YYSYMBOL_generic_primary = 189,          /* generic_primary  */
  YYSYMBOL_generic_aggregate = 190,        /* generic_aggregate  */
  YYSYMBOL_191_8 = 191,                    /* $@8  */
  YYSYMBOL_192_generic_element_association_ = 192, /* ...generic_element_association..  */
  YYSYMBOL_generic_element_association = 193, /* generic_element_association  */
  YYSYMBOL_194_generic_choices_ = 194,     /* .generic_choices.  */
  YYSYMBOL_generic_name = 195,             /* generic_name  */
  YYSYMBOL_generic_literal = 196,          /* generic_literal  */
  YYSYMBOL_197_port_map_aspect_ = 197,     /* .port_map_aspect.  */
  YYSYMBOL_port_map_aspect = 198,          /* port_map_aspect  */
  YYSYMBOL_association_list = 199,         /* association_list  */
  YYSYMBOL_200_association_element_ = 200, /* ...association_element..  */
  YYSYMBOL_association_element = 201,      /* association_element  */
  YYSYMBOL_formal_port_name = 202,         /* formal_port_name  */
  YYSYMBOL_actual_port_name = 203,         /* actual_port_name  */
  YYSYMBOL_name = 204,                     /* name  */
  YYSYMBOL_indexed_name = 205,             /* indexed_name  */
  YYSYMBOL_slice_name = 206,               /* slice_name  */
  YYSYMBOL_expression = 207,               /* expression  */
  YYSYMBOL_relation = 208,                 /* relation  */
  YYSYMBOL_simple_expression = 209,        /* simple_expression  */
  YYSYMBOL_210_sign_term_add_op__term_ = 210, /* .sign.term..add_op__term..  */
  YYSYMBOL_term = 211,                     /* term  */
  YYSYMBOL_factor = 212,                   /* factor  */
  YYSYMBOL_primary = 213,                  /* primary  */
  YYSYMBOL_aggregate = 214,                /* aggregate  */
  YYSYMBOL_type_convertion = 215,          /* type_convertion  */
  YYSYMBOL_216_SIGNAL_ = 216,              /* .SIGNAL.  */
  YYSYMBOL_217_local_port_mode_ = 217,     /* .local_port_mode.  */
  YYSYMBOL_218_mode_ = 218,                /* .mode.  */
  YYSYMBOL_type_mark = 219,                /* type_mark  */
  YYSYMBOL_220_BUS_ = 220,                 /* .BUS.  */
  YYSYMBOL_identifier_list = 221,          /* identifier_list  */
  YYSYMBOL_222_9 = 222,                    /* $@9  */
  YYSYMBOL_223_identifier_ = 223,          /* ...identifier..  */
  YYSYMBOL_a_label = 224,                  /* a_label  */
  YYSYMBOL_225_simple_name_ = 225,         /* .simple_name.  */
  YYSYMBOL_simple_name = 226,              /* simple_name  */
  YYSYMBOL_Semicolon_ERR = 227,            /* Semicolon_ERR  */
  YYSYMBOL_abstractlit = 228,              /* abstractlit  */
  YYSYMBOL_RightParen_ERR = 229,           /* RightParen_ERR  */
  YYSYMBOL_END_ERR = 230                   /* END_ERR  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   225

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  136
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  95
/* YYNRULES -- Number of rules.  */
#define YYNRULES  159
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  250

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   390


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   223,   223,   235,   232,   259,   265,   266,   271,   270,
     284,   290,   295,   296,   302,   334,   338,   344,   349,   354,
     361,   380,   382,   387,   388,   392,   397,   404,   409,   410,
     416,   547,   566,   574,   565,   588,   594,   598,   599,   604,
     605,   606,   612,   699,   697,   731,   732,   740,   745,   746,
     752,   859,   877,   881,   882,   887,   888,   896,   894,  1002,
    1005,  1009,  1021,  1026,  1027,  1033,  1040,  1045,  1049,  1053,
    1057,  1061,  1067,  1065,  1080,  1081,  1082,  1086,  1090,  1097,
    1101,  1106,  1107,  1117,  1116,  1126,  1127,  1133,  1143,  1153,
    1157,  1165,  1170,  1182,  1183,  1187,  1195,  1200,  1201,  1207,
    1262,  1326,  1345,  1368,  1373,  1379,  1381,  1386,  1398,  1409,
    1414,  1419,  1424,  1426,  1444,  1450,  1455,  1457,  1459,  1562,
    1569,  1578,  1579,  1584,  1585,  1587,  1589,  1591,  1600,  1601,
    1603,  1605,  1607,  1612,  1614,  1616,  1618,  1620,  1622,  1624,
    1626,  1628,  1630,  1632,  1634,  1636,  1642,  1643,  1649,  1648,
    1656,  1657,  1666,  1673,  1674,  1679,  1684,  1689,  1702,  1707
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Ampersand",
  "Apostrophe", "LeftParen", "RightParen", "DoubleStar", "Star", "Plus",
  "Comma", "Minus", "VarAsgn", "Colon", "Semicolon", "_LESym", "Box",
  "_LTSym", "Arrow", "_EQSym", "_GESym", "_GTSym", "Bar", "_NESym", "Dot",
  "Slash", "Identifier", "DecimalInt", "DecimalReal", "AbstractLit",
  "BasedInt", "BasedReal", "CharacterLit", "StringLit", "BitStringLit",
  "ABS", "ACCESS", "AFTER", "ALIAS", "ALL", "tok_AND", "ARCHITECTURE",
  "ARRAY", "ARG", "ASSERT", "ATTRIBUTE", "_BEGIN", "BIT", "BIT_VECTOR",
  "BLOCK", "BODY", "BUFFER", "BUS", "CASE", "CLOCK", "COMPONENT",
  "CONFIGURATION", "CONSTANT", "CONVERT", "DISCONNECT", "DOWNTO", "ELSE",
  "ELSIF", "_END", "ENTITY", "ERROR", "_EXIT", "_FILE", "FOR", "FUNCTION",
  "GENERATE", "GENERIC", "GUARDED", "IF", "_IN", "_INOUT", "INTEGER", "IS",
  "_LABEL", "LIBRARY", "_LINKAGE", "_LIST", "LOOP", "MAP", "MOD",
  "MUX_BIT", "MUX_VECTOR", "_NAND", "NATURAL", "NATURAL_VECTOR", "NEW",
  "_NEXT", "_NOR", "_NOT", "tok_NULL", "OF", "ON", "OPEN", "_OR", "OTHERS",
  "_OUT", "_PACKAGE", "PORT", "POSITIVE", "PROCEDURE", "PROCESS", "RANGE",
  "RECORD", "REG_BIT", "REG_VECTOR", "REGISTER", "REM", "REPORT", "RETURN",
  "SELECT", "SEVERITY", "SIGNAL", "_STABLE", "STRING", "SUBTYPE", "THEN",
  "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "VARIABLE", "WAIT",
  "WARNING", "WHEN", "WHILE", "WITH", "WOR_BIT", "WOR_VECTOR", "_XOR",
  "$accept", "design_file", "entity_declaration", "$@1",
  ".generic_clause.", "generic_clause", "$@2", "formal_generic_list",
  "...formal_generic_element..", "formal_generic_element",
  "generic_VarAsgn__expression", ".constraint.", "constraint", "range",
  "direction", ".port_clause.", "port_clause", "formal_port_list",
  "...formal_port_element..", "formal_port_element", "architecture_body",
  "$@3", "$@4", "architecture_declarative_part",
  "..block_declaration_item..", "block_declaration_item",
  "signal_declaration", "component_declaration", "$@5",
  ".PORT__local_port_list.", "local_port_list", "...local_port_element..",
  "local_port_element", "architecture_statement_part",
  "..concurrent_statement..", "concurrent_statement",
  "component_instantiation_statement", "$@6", ".generic_map_aspect.",
  "generic_map_aspect", "generic_association_list",
  "...generic_association_element..", "generic_association_element",
  "formal_generic_name", "actual_generic_name", "generic_expression",
  "generic_relation", "generic_simple_expression", "$@7", ".sign.",
  "generic_term", "...generic_term..", "generic_factor", "generic_primary",
  "generic_aggregate", "$@8", "...generic_element_association..",
  "generic_element_association", ".generic_choices.", "generic_name",
  "generic_literal", ".port_map_aspect.", "port_map_aspect",
  "association_list", "...association_element..", "association_element",
  "formal_port_name", "actual_port_name", "name", "indexed_name",
  "slice_name", "expression", "relation", "simple_expression",
  ".sign.term..add_op__term..", "term", "factor", "primary", "aggregate",
  "type_convertion", ".SIGNAL.", ".local_port_mode.", ".mode.",
  "type_mark", ".BUS.", "identifier_list", "$@9", "...identifier..",
  "a_label", ".simple_name.", "simple_name", "Semicolon_ERR",
  "abstractlit", "RightParen_ERR", "END_ERR", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-174)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-154)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -16,    13,    54,    20,  -174,  -174,   -18,  -174,  -174,    39,
    -174,  -174,  -174,    41,    -2,   -21,    45,    -8,  -174,    41,
      81,    93,    61,    38,  -174,    26,  -174,  -174,    35,    81,
       6,  -174,    41,  -174,  -174,    78,    99,  -174,  -174,  -174,
    -174,    99,  -174,    78,    81,  -174,  -174,    97,  -174,    81,
      81,    81,    81,    98,  -174,    60,     5,  -174,    -6,  -174,
      35,  -174,     6,   -22,  -174,    81,    87,    78,  -174,  -174,
    -174,   105,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,   112,  -174,  -174,  -174,  -174,
    -174,  -174,    -6,    38,    18,  -174,  -174,   106,    94,    96,
     118,  -174,   112,    41,    81,   120,  -174,  -174,    41,    -2,
      -6,  -174,  -174,    99,   -45,    36,  -174,    85,    81,  -174,
    -174,  -174,    43,   112,  -174,  -174,  -174,    96,  -174,  -174,
    -174,  -174,  -174,    67,  -174,  -174,  -174,    75,   133,    38,
      85,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,    65,    50,  -174,     7,   100,    81,  -174,
    -174,   148,    71,    81,  -174,  -174,    99,  -174,    78,    81,
    -174,  -174,    36,  -174,   138,   151,  -174,    81,    81,   144,
    -174,    58,  -174,  -174,    99,  -174,   140,  -174,  -174,  -174,
      29,  -174,     7,    34,  -174,  -174,  -174,   149,    36,  -174,
      30,   155,    99,  -174,   143,  -174,   145,  -174,  -174,  -174,
    -174,  -174,   162,  -174,  -174,  -174,  -174,  -174,   161,  -174,
    -174,  -174,  -174,  -174,    -6,  -174,   138,  -174,  -174,    99,
      30,  -174,   158,    30,    30,    96,  -174,   112,  -174,  -174,
      99,    29,  -174,  -174,     3,    85,  -174,  -174,  -174,  -174
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     5,   155,     0,   154,     1,     0,
       2,     3,    35,     0,     6,     0,     0,    23,     7,     0,
       0,     0,     0,     0,    24,     0,   156,    10,     0,     0,
       0,   159,   153,    33,    15,     0,     0,    12,    26,    31,
     122,     0,    28,     0,     0,    37,   148,     0,   158,     0,
      11,     0,    27,     0,     4,     0,     0,   150,     0,     9,
       0,    25,     0,   128,    53,     0,     0,     0,    38,    39,
      40,   149,   145,   133,   136,   139,   144,   135,   138,   140,
     141,   142,   143,   134,   137,    17,    13,    29,   129,   131,
     132,   130,     0,     0,     0,    41,    43,     0,     0,     0,
       0,    18,    17,   153,     0,     0,    54,    55,     0,     6,
       0,   151,   157,     0,     0,    74,    14,   146,     0,    56,
     152,    57,    45,    17,    19,    22,    21,     0,    75,    76,
      16,    70,    71,     0,   147,    30,    34,    59,     0,     0,
     146,    20,    83,    92,    91,    72,    77,    79,    82,    80,
      81,    89,    90,     0,    93,    60,     0,     0,     0,    88,
      78,     0,     0,     0,    94,    51,     0,    48,     0,     0,
      42,    85,    74,    73,     0,     0,    58,     0,    47,     0,
      44,     0,    87,    67,     0,    63,     0,    66,    69,    68,
       0,    46,     0,   123,    88,    84,    61,    62,    74,   101,
       0,     0,     0,    97,     0,   100,   118,   105,   106,   103,
     109,   110,   111,   112,   114,   115,   116,   117,   104,    49,
     124,   126,   127,   125,     0,    86,     0,    65,   118,     0,
       0,    95,    96,     0,     0,     0,   108,    17,    64,   119,
       0,     0,    99,   113,     0,   146,   120,    98,   107,    50
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -174,  -174,  -174,  -174,    63,  -174,  -174,  -174,  -174,   109,
    -174,   -97,   -44,  -174,  -174,  -174,  -174,  -174,  -174,   113,
    -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,   -15,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,   -48,  -174,   -17,   -86,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,  -174,  -174,   -14,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,   -65,  -174,   -54,  -170,  -174,
    -174,  -173,  -174,  -174,  -174,   -52,  -174,  -174,  -174,  -174,
    -107,  -174,  -174,   -89,  -129,   -39,  -174,  -174,  -174,   -19,
      -1,   -27,  -117,   -40,   -50
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     2,     3,    14,    17,    18,    21,    36,    50,    37,
     116,   100,   101,   113,   127,    23,    24,    41,    52,    42,
      10,    13,    45,    55,    56,    68,    69,    70,   109,   139,
     166,   178,   167,    93,    94,   106,   107,   137,   154,   155,
     184,   197,   185,   186,   187,   188,   131,   132,   160,   133,
     145,   173,   146,   147,   148,   159,   181,   171,   172,   149,
     150,   163,   164,   202,   232,   203,   204,   205,   228,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      43,   224,    92,    85,   135,    47,    57,    71,   108,     6,
     218,    27,   114,    49,    32
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       7,    51,    38,   102,    53,   117,    65,    39,   165,    48,
     141,   158,    15,    44,     4,   125,   152,    54,    25,   104,
     206,   123,    59,    60,    61,    62,   140,   229,    97,   130,
     199,     7,  -121,  -121,   200,   200,    34,    72,    95,     5,
      12,    73,    74,   103,   105,   128,    20,   129,     1,   168,
      -8,   -36,    88,    89,     8,     5,     5,   240,    90,    11,
      66,     9,    29,   125,    48,   -32,    30,     5,   194,    16,
      75,   206,   142,   124,    19,    76,   126,   119,    91,    77,
      78,   -52,    79,    80,   118,   168,   182,   201,   201,   157,
    -153,   136,    35,     5,    22,    26,   112,    81,    28,   143,
     144,    31,     7,    33,    46,    48,    64,   121,   220,   221,
      58,    63,    82,    96,   222,    98,   249,    99,   244,   110,
     111,    67,    40,    40,   126,   112,   177,    83,    84,   179,
     115,   170,   151,   120,   223,   237,   176,   134,   156,   183,
     245,   195,   180,   -74,   196,   138,   153,   128,   161,   129,
     191,   192,   162,   174,   175,   169,   190,   193,   198,   226,
     230,   233,   231,  -102,     5,   234,   235,   -74,   241,    86,
     -74,   -74,   122,   189,   236,    87,   247,   219,   238,   242,
     225,   227,   243,     0,     0,     0,     0,     0,     0,   239,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,     0,     0,     0,   248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189
};

static const yytype_int16 yycheck[] =
{
       1,    41,    29,    92,    43,   102,     1,     1,     1,     6,
     127,   140,    13,    32,     1,    60,   133,    44,    19,     1,
     190,   110,    49,    50,    51,    52,   123,   200,    67,   115,
       1,    32,    26,    26,     5,     5,     1,    43,    65,    26,
       1,    47,    48,    93,    26,     9,     1,    11,    64,   156,
       5,    46,    74,    75,     0,    26,    26,   230,    80,    77,
      55,    41,     1,    60,     6,    26,     5,    26,    10,    71,
      76,   241,     5,   113,    95,    81,   121,   104,   100,    85,
      86,    63,    88,    89,   103,   192,   172,    58,    58,   139,
      77,   118,    57,    26,   102,    14,    29,   103,     5,    32,
      33,    63,   103,    77,    26,     6,    46,   108,    74,    75,
      13,    13,   118,    26,    80,    10,   245,     5,   235,    13,
      26,   116,   116,   116,   121,    29,   166,   133,   134,   168,
      12,   158,   133,    13,   100,   224,   163,    52,     5,     1,
     237,   181,   169,     5,   184,   102,    71,     9,    83,    11,
     177,   178,   102,     5,    83,    55,     5,    13,    18,    10,
       5,    18,   202,    18,    26,     3,     5,    29,    10,    60,
      32,    33,   109,   174,   218,    62,   241,   192,   226,   233,
     194,   198,   234,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   226
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    64,   137,   138,     1,    26,   225,   226,     0,    41,
     156,    77,     1,   157,   139,   226,    71,   140,   141,    95,
       1,   142,   102,   151,   152,   226,    14,   227,     5,     1,
       5,    63,   230,    77,     1,    57,   143,   145,   227,     1,
     116,   153,   155,   216,   225,   158,    26,   221,     6,   229,
     144,   229,   154,   221,   227,   159,   160,   222,    13,   227,
     227,   227,   227,    13,    46,     1,    55,   116,   161,   162,
     163,   223,    43,    47,    48,    76,    81,    85,    86,    88,
      89,   103,   118,   133,   134,   219,   145,   155,    74,    75,
      80,   100,   218,   169,   170,   227,    26,   221,    10,     5,
     147,   148,   219,   230,     1,    26,   171,   172,   224,   164,
      13,    26,    29,   149,   228,    12,   146,   147,   225,   227,
      13,   226,   140,   219,   229,    60,   121,   150,     9,    11,
     181,   182,   183,   185,    52,   220,   227,   173,   102,   165,
     147,   228,     5,    32,    33,   186,   188,   189,   190,   195,
     196,   226,   228,    71,   174,   175,     5,   230,   220,   191,
     184,    83,   102,   197,   198,     1,   166,   168,   216,    55,
     227,   193,   194,   187,     5,    83,   227,   229,   167,   221,
     227,   192,   181,     1,   176,   178,   179,   180,   181,   226,
       5,   227,   227,    13,    10,   229,   229,   177,    18,     1,
       5,    58,   199,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   226,   168,
      74,    75,    80,   100,   217,   193,    10,   180,   204,   207,
       5,   229,   200,    18,     3,     5,   148,   219,   178,   229,
     207,    10,   203,   211,   228,   147,   229,   201,   229,   220
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   136,   137,   139,   138,   138,   140,   140,   142,   141,
     141,   143,   144,   144,   145,   145,   146,   147,   147,   148,
     149,   150,   150,   151,   151,   152,   152,   153,   154,   154,
     155,   155,   157,   158,   156,   156,   159,   160,   160,   161,
     161,   161,   162,   164,   163,   165,   165,   166,   167,   167,
     168,   168,   169,   170,   170,   171,   171,   173,   172,   174,
     174,   175,   176,   177,   177,   178,   178,   178,   179,   180,
     181,   182,   184,   183,   185,   185,   185,   186,   187,   188,
     189,   189,   189,   191,   190,   192,   192,   193,   194,   195,
     196,   196,   196,   197,   197,   198,   199,   200,   200,   201,
     201,   201,   202,   203,   204,   204,   204,   205,   206,   207,
     208,   209,   210,   210,   211,   212,   213,   213,   213,   214,
     215,   216,   216,   217,   217,   217,   217,   217,   218,   218,
     218,   218,   218,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   220,   220,   222,   221,
     223,   223,   224,   225,   225,   226,   227,   228,   229,   230
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     9,     2,     0,     1,     0,     6,
       3,     2,     0,     3,     6,     1,     2,     0,     1,     3,
       3,     1,     1,     0,     1,     5,     3,     2,     0,     3,
       7,     1,     0,     0,    13,     2,     1,     0,     2,     1,
       1,     2,     7,     0,     8,     0,     5,     2,     0,     3,
       7,     1,     1,     0,     2,     1,     2,     0,     6,     0,
       1,     5,     2,     0,     3,     3,     1,     1,     1,     1,
       1,     1,     0,     4,     0,     1,     1,     1,     0,     1,
       1,     1,     1,     0,     5,     0,     3,     2,     0,     1,
       1,     1,     1,     0,     1,     5,     2,     0,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     4,     2,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       4,     0,     1,     0,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     3,
       0,     3,     2,     0,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* design_file: entity_declaration architecture_body  */
#line 225 "./mvl_scomp_y.y"
                {
                freelomodel (MVL_CHDHED);
                mvl_fretab  (MVL_HSHTAB);
                }
#line 1874 "y.tab.c"
    break;

  case 3: /* $@1: %empty  */
#line 235 "./mvl_scomp_y.y"
                {
                MVL_HSHTAB = mvl_initab ();
                MVL_SIMFLG = 0   ;      /* simple flag                  */
                MVL_NM1LST = NULL;      /* 1-st name liste              */
                MVL_NM2LST = NULL;      /* 2-nd name liste              */
                MVL_CHDPNT = NULL;      /* current child pointer        */
                MVL_CHDHED = NULL;      /* childs list                  */

                MVL_MODNAM = (yyvsp[-1].text);
                mvl_addtab (MVL_HSHTAB,MVL_MODNAM,MVL_MODNAM,MVL_MODDFN,
                            MVL_ROTDFN);
                }
#line 1891 "y.tab.c"
    break;

  case 4: /* entity_declaration: ENTITY .simple_name. IS $@1 .generic_clause. .port_clause. END_ERR .simple_name. Semicolon_ERR  */
#line 252 "./mvl_scomp_y.y"
                {
                if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-7].text)))
                  mvl_error (1, (yyvsp[-1].text));
                mvl_addtab (MVL_HSHTAB,MVL_MODNAM,MVL_MODNAM,MVL_CCNDFN,
                            MVL_CONCNT);
                MVL_CONCNT = 0;
                }
#line 1903 "y.tab.c"
    break;

  case 5: /* entity_declaration: ENTITY error  */
#line 261 "./mvl_scomp_y.y"
                { mvl_error (2, NULL); }
#line 1909 "y.tab.c"
    break;

  case 8: /* $@2: %empty  */
#line 271 "./mvl_scomp_y.y"
            {                 /* NULL means we're in the entity declaration */
               if (!MVL_CHDHED) {
                  MVL_LOFPNT->USER=addptype(MVL_LOFPNT->USER,LOGEN,NULL);
                  MVL_PTPPNT=MVL_LOFPNT->USER;
               } else {
                  MVL_CHDPNT->USER=addptype(MVL_LOFPNT->USER,LOGEN,NULL);
                  MVL_PTPPNT=MVL_CHDPNT->USER;
               }
            }
#line 1923 "y.tab.c"
    break;

  case 14: /* formal_generic_element: CONSTANT identifier_list Colon type_mark .constraint. generic_VarAsgn__expression  */
#line 308 "./mvl_scomp_y.y"
             {
             struct chain *l;
                
                for (l=MVL_NM1LST;l;l=l->NEXT) {
                   MVL_PTPPNT->DATA=duplogen(&MVL_LOGEN,
                                             MVL_PTPPNT->DATA,l->DATA);
                }
                switch ((yyvsp[-2].valu)) {
                   case MVL_ARGDFN:
                   {
                      logen_list *gen = (logen_list *)MVL_PTPPNT->DATA;
                      gen->TYPE=GENTYPE_ARG;
                   }
                   break;
                   case MVL_BITDFN:
                   {
                      logen_list *gen = (logen_list *)MVL_PTPPNT->DATA;
                      gen->TYPE=GENTYPE_BIT;
                   }
                   break;
                }

                MVL_LOGEN.TYPE=GENTYPE_EMPTY;
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
             }
#line 1954 "y.tab.c"
    break;

  case 17: /* .constraint.: %empty  */
#line 344 "./mvl_scomp_y.y"
                {
                (yyval.name).LEFT  = -1;
                (yyval.name).RIGHT = -1;
                (yyval.name).ERR_FLG = 0;
                }
#line 1964 "y.tab.c"
    break;

  case 18: /* .constraint.: constraint  */
#line 350 "./mvl_scomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 1970 "y.tab.c"
    break;

  case 19: /* constraint: LeftParen range RightParen_ERR  */
#line 357 "./mvl_scomp_y.y"
                { (yyval.name) = (yyvsp[-1].name); }
#line 1976 "y.tab.c"
    break;

  case 20: /* range: abstractlit direction abstractlit  */
#line 364 "./mvl_scomp_y.y"
                {
                (yyval.name).LEFT  = (yyvsp[-2].valu);
                (yyval.name).RIGHT = (yyvsp[0].valu);

                if ((((yyvsp[-2].valu) > (yyvsp[0].valu)) && ((yyvsp[-1].valu) == MVL_UPTDFN)) ||
                    (((yyvsp[-2].valu) < (yyvsp[0].valu)) && ((yyvsp[-1].valu) == MVL_DWTDFN)))
                  {
                  mvl_error (32, NULL);
                  (yyval.name).ERR_FLG = 1;
                  }
                else
                  (yyval.name).ERR_FLG = 0;
                }
#line 1994 "y.tab.c"
    break;

  case 21: /* direction: TO  */
#line 381 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_UPTDFN; }
#line 2000 "y.tab.c"
    break;

  case 22: /* direction: DOWNTO  */
#line 383 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_DWTDFN; }
#line 2006 "y.tab.c"
    break;

  case 26: /* port_clause: PORT error Semicolon_ERR  */
#line 400 "./mvl_scomp_y.y"
                { mvl_error (3, NULL); }
#line 2012 "y.tab.c"
    break;

  case 30: /* formal_port_element: .SIGNAL. identifier_list Colon .mode. type_mark .constraint. .BUS.  */
#line 423 "./mvl_scomp_y.y"
                {
                struct losig *losig_pnt;
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err;

                local_err = (yyvsp[-1].name).ERR_FLG;
                if ( ((yyvsp[-1].name).LEFT == -1) && (((yyvsp[-2].valu) == MVL_BTVDFN) ||
                                         ((yyvsp[-2].valu) == MVL_MXVDFN) ||
                                         ((yyvsp[-2].valu) == MVL_WRVDFN)))
                  {
                  mvl_error (33, NULL);
                  }

                if ((yyvsp[-1].name).LEFT <= (yyvsp[-1].name).RIGHT)
                  sig_width = (yyvsp[-1].name).RIGHT - (yyvsp[-1].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-1].name).LEFT  - (yyvsp[-1].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-2].valu) + (yyvsp[0].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;

                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_MODNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (4, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_ICNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_ICNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'I',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_OCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'O',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','M',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'Z',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','W',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'Z',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_BCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'B',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','M',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'T',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','W',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'T',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_XCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_XCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'X',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;
                      default :
                        mvl_error (5, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_PNTDFN,
                                  (long)losig_pnt);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_LFTDFN,
                                  (yyvsp[-1].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_RGTDFN,
                                  (yyvsp[-1].name).RIGHT);
                      MVL_CONCNT += sig_width;
                      MVL_SIGIDX += sig_width;
                      }
                    }

                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2141 "y.tab.c"
    break;

  case 31: /* formal_port_element: error  */
#line 548 "./mvl_scomp_y.y"
                {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Semicolon') is found                   */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Semicolon) && (yychar != 0));
                yyerrok;

                mvl_error (6, NULL);
                }
#line 2160 "y.tab.c"
    break;

  case 32: /* $@3: %empty  */
#line 566 "./mvl_scomp_y.y"
                {
                if (!strcmp (IN_LO, "vbe"))
                  YYACCEPT;
                }
#line 2169 "y.tab.c"
    break;

  case 33: /* $@4: %empty  */
#line 574 "./mvl_scomp_y.y"
                {
                if ((yyvsp[-1].text) != MVL_MODNAM)
                  mvl_error (1, (yyvsp[-1].text));
                }
#line 2178 "y.tab.c"
    break;

  case 34: /* architecture_body: ARCHITECTURE $@3 simple_name OF simple_name IS $@4 architecture_declarative_part _BEGIN architecture_statement_part END_ERR .simple_name. Semicolon_ERR  */
#line 584 "./mvl_scomp_y.y"
                {
                if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-10].text)))
                  mvl_error (7, (yyvsp[-1].text));
                }
#line 2187 "y.tab.c"
    break;

  case 35: /* architecture_body: ARCHITECTURE error  */
#line 590 "./mvl_scomp_y.y"
                { mvl_error (8, NULL); }
#line 2193 "y.tab.c"
    break;

  case 41: /* block_declaration_item: error Semicolon_ERR  */
#line 608 "./mvl_scomp_y.y"
                { mvl_error (9, NULL); }
#line 2199 "y.tab.c"
    break;

  case 42: /* signal_declaration: SIGNAL identifier_list Colon type_mark .constraint. .BUS. Semicolon_ERR  */
#line 619 "./mvl_scomp_y.y"
                {
                struct losig *losig_pnt;
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err;

                local_err = (yyvsp[-2].name).ERR_FLG;
                if (((yyvsp[-2].name).LEFT==-1) && (((yyvsp[-3].valu)==MVL_BTVDFN) || ((yyvsp[-3].valu)==MVL_RGVDFN)))
                  {
                  mvl_error (33, NULL);
                  }
                if ((yyvsp[-2].name).LEFT <= (yyvsp[-2].name).RIGHT)
                  sig_width = (yyvsp[-2].name).RIGHT - (yyvsp[-2].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-2].name).LEFT  - (yyvsp[-2].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-1].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;

                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_MODNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (10, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_BITDFN + MVL_NORDFN):
                      case (MVL_BTVDFN + MVL_NORDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','0',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      case (MVL_MUXDFN + MVL_BUSDFN):
                      case (MVL_MXVDFN + MVL_BUSDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','M',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      case (MVL_WORDFN + MVL_BUSDFN):
                      case (MVL_WRVDFN + MVL_BUSDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','W',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      default:
                        mvl_error (11, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_PNTDFN,
                                  (long)losig_pnt);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_LFTDFN,
                                  (yyvsp[-2].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_RGTDFN,
                                  (yyvsp[-2].name).RIGHT);
                      MVL_SIGIDX += sig_width;
                      }
                    }

                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2279 "y.tab.c"
    break;

  case 43: /* $@5: %empty  */
#line 699 "./mvl_scomp_y.y"
                {
                MVL_CHDNAM = (yyvsp[0].text);

                if (mvl_chktab (MVL_HSHTAB,MVL_CHDNAM,MVL_MODNAM,MVL_MODDFN) != 0)
                  {
                  mvl_error (12, MVL_CHDNAM);
                  MVL_CHDPNT = NULL;
                  }
                else
                  {
                  MVL_CHDHED = addlomodel (MVL_CHDHED,MVL_CHDNAM);

                  MVL_CHDPNT = MVL_CHDHED;
                  mvl_addtab (MVL_HSHTAB,MVL_CHDNAM,MVL_MODNAM,MVL_MODDFN,MVL_CHDDFN);
                  }
                }
#line 2300 "y.tab.c"
    break;

  case 44: /* component_declaration: COMPONENT Identifier $@5 .generic_clause. .PORT__local_port_list. END_ERR COMPONENT Semicolon_ERR  */
#line 720 "./mvl_scomp_y.y"
                {
                if (MVL_CHDPNT != NULL)
                  {
                  mvl_addtab (MVL_HSHTAB,(yyvsp[-6].text),MVL_MODNAM,MVL_CCNDFN,MVL_CONCNT);
                  MVL_LOFPNT->MODELCHAIN = addchain (MVL_LOFPNT->MODELCHAIN,(yyvsp[-6].text));
                  }
                MVL_CONCNT = 0;
                }
#line 2313 "y.tab.c"
    break;

  case 50: /* local_port_element: .SIGNAL. identifier_list Colon .local_port_mode. type_mark .constraint. .BUS.  */
#line 759 "./mvl_scomp_y.y"
                {
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err = 0;

                if (((yyvsp[-1].name).ERR_FLG != 0) || (MVL_CHDPNT == NULL))
                  local_err = 1;

                if (((yyvsp[-1].name).LEFT == -1) && (((yyvsp[-2].valu) == MVL_BTVDFN) ||
                                        ((yyvsp[-2].valu) == MVL_MXVDFN) ||
                                        ((yyvsp[-2].valu) == MVL_WRVDFN))  )
                  {
                  mvl_error (33, NULL);
                  }
                if ((yyvsp[-1].name).LEFT <= (yyvsp[-1].name).RIGHT)
                  sig_width = (yyvsp[-1].name).RIGHT - (yyvsp[-1].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-1].name).LEFT  - (yyvsp[-1].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-2].valu) + (yyvsp[0].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;
                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_CHDNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (4, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_ICNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_ICNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'I', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_OCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'O', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'Z', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'Z', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_BCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'B', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'T', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'T', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_XCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_XCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'X', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      default :
                        mvl_error (5, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,MVL_CONCNT,MVL_CHDNAM,MVL_PNTDFN,
                                  sig_name);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_RNGDFN,
                                  MVL_CONCNT);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_LFTDFN,
                                  (yyvsp[-1].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_RGTDFN,
                                  (yyvsp[-1].name).RIGHT);
                      MVL_CONCNT += sig_width;
                      }
                    }
                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2418 "y.tab.c"
    break;

  case 51: /* local_port_element: error  */
#line 860 "./mvl_scomp_y.y"
                {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Semicolon') is found                   */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Semicolon) && (yychar != 0));
                yyerrok;

                mvl_error (6, NULL);
                }
#line 2437 "y.tab.c"
    break;

  case 56: /* concurrent_statement: error Semicolon_ERR  */
#line 890 "./mvl_scomp_y.y"
                { mvl_error (18, NULL); }
#line 2443 "y.tab.c"
    break;

  case 57: /* $@6: %empty  */
#line 896 "./mvl_scomp_y.y"
                {
                long con_count;
                long local_err = 0;

                MVL_CONRNK = 0;
                MVL_CHDNAM = (yyvsp[0].text);
                MVL_LOCNAM = (yyvsp[-1].text);

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[-1].text),MVL_MODNAM,MVL_LBLDFN) != 0)
                  {
                  mvl_error (13, (yyvsp[-1].text));
                  local_err = 1;
                  }

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[0].text),MVL_MODNAM,
                                MVL_MODDFN) != MVL_CHDDFN)
                  {
                  mvl_error (14, (yyvsp[0].text));
                  local_err = 1;
                  }

                if (local_err == 0)
                  {
                  mvl_addtab (MVL_HSHTAB,(yyvsp[-1].text),MVL_MODNAM,MVL_LBLDFN,1);
                  con_count  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].text),MVL_MODNAM,MVL_CCNDFN);
                  MVL_NM1LST = NULL;
                  while (con_count != 0)
                    {
                    MVL_NM1LST = addchain (MVL_NM1LST,NULL);
                    con_count--;
                    }
                  MVL_CHDPNT = MVL_CHDHED;
                  while (MVL_CHDPNT != NULL)
                    {
                    if (MVL_CHDPNT->NAME == (yyvsp[0].text))
                      break;
                    MVL_CHDPNT = MVL_CHDPNT->NEXT;
                    }
                  }
                else
                  MVL_CHDPNT = NULL;

                }
#line 2491 "y.tab.c"
    break;

  case 58: /* component_instantiation_statement: a_label simple_name $@6 .generic_map_aspect. .port_map_aspect. Semicolon_ERR  */
#line 942 "./mvl_scomp_y.y"
                {
                struct loins *loins_pnt    ;
                struct locon *locon_pnt    ;
                struct chain *chain_pnt    ;
                char          tampon [256] ;

                if (MVL_CHDPNT != NULL)
                  {
                  MVL_NM1LST = reverse (MVL_NM1LST);

                  chain_pnt  = MVL_NM1LST;
                  locon_pnt  = MVL_CHDPNT->LOCON;

                  while (chain_pnt != NULL)
                    {
                    if (chain_pnt->DATA == NULL)
                      {
                      MVL_SIGIDX++;
                      sprintf(tampon,"%s:%s.%s",MVL_CHDNAM,(yyvsp[-5].text),locon_pnt->NAME);
                      chain_pnt->DATA = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,
                                                      'I','0',tampon,-1,-1);
                      }
                    chain_pnt = chain_pnt->NEXT;
                    locon_pnt = locon_pnt->NEXT;
                    }

                  if (MVL_ERRFLG == 0) {
                    loins_pnt = addloins (MVL_LOFPNT, (yyvsp[-5].text)  , MVL_CHDPNT,
                                          MVL_NM1LST );
                     if (MVL_CHDPNT->USER) {
                        if (!MVL_PTPPNT)
                           MVL_PTPPNT = addptype(NULL,LOGEN,NULL);  
                        loins_pnt->USER=MVL_PTPPNT;
                        MVL_PTPPNT->DATA
                                = chklogen(loins_pnt->USER->DATA,
                                             MVL_CHDPNT->USER->DATA,
                                             MVL_CHDNAM, loins_pnt->INSNAME);
                     } else {
                        if (MVL_PTPPNT) {
                           fprintf(stderr,"No generic for model %s, NULLed !\n",
                                MVL_CHDPNT->NAME);
                           loins_pnt->USER=NULL;
                        }
                     }

                    }
                  }

                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                MVL_SIMFLG = MVL_UKNDFN;
                }
#line 2548 "y.tab.c"
    break;

  case 59: /* .generic_map_aspect.: %empty  */
#line 1002 "./mvl_scomp_y.y"
          {
             MVL_PTPPNT = NULL;
          }
#line 2556 "y.tab.c"
    break;

  case 61: /* generic_map_aspect: GENERIC MAP LeftParen generic_association_list RightParen_ERR  */
#line 1014 "./mvl_scomp_y.y"
          {
             MVL_PTPPNT = addptype(NULL,LOGEN,MVL_GENPNT);  
             MVL_GENPNT = NULL;
          }
#line 2565 "y.tab.c"
    break;

  case 65: /* generic_association_element: formal_generic_name Arrow actual_generic_name  */
#line 1036 "./mvl_scomp_y.y"
          {
             MVL_GENPNT = duplogen(&MVL_LOGEN,MVL_GENPNT,(yyvsp[-2].text));
             MVL_LOGEN.TYPE=GENTYPE_EMPTY;
          }
#line 2574 "y.tab.c"
    break;

  case 66: /* generic_association_element: actual_generic_name  */
#line 1041 "./mvl_scomp_y.y"
          {
             MVL_GENPNT = duplogen(&MVL_LOGEN,MVL_GENPNT,NULL);
             MVL_LOGEN.TYPE=GENTYPE_EMPTY;
          }
#line 2583 "y.tab.c"
    break;

  case 72: /* $@7: %empty  */
#line 1067 "./mvl_scomp_y.y"
                {
                   if ((yyvsp[-1].flag)) {
                      if (MVL_LOGEN.TYPE!=GENTYPE_VAL) {
                         fputs("Don't know how to change Identifier sign\n",
                               stderr);
                      } else
                         MVL_LOGEN.VALUE.VAL = -MVL_LOGEN.VALUE.VAL;
                   }
                }
#line 2597 "y.tab.c"
    break;

  case 74: /* .sign.: %empty  */
#line 1080 "./mvl_scomp_y.y"
                                { (yyval.flag) = 0; }
#line 2603 "y.tab.c"
    break;

  case 75: /* .sign.: Plus  */
#line 1081 "./mvl_scomp_y.y"
                                { (yyval.flag) = 0; }
#line 2609 "y.tab.c"
    break;

  case 76: /* .sign.: Minus  */
#line 1082 "./mvl_scomp_y.y"
                                { (yyval.flag) = 1; }
#line 2615 "y.tab.c"
    break;

  case 80: /* generic_primary: generic_name  */
#line 1102 "./mvl_scomp_y.y"
          {
             MVL_LOGEN.VALUE.TEXT=namealloc((yyvsp[0].text));
             MVL_LOGEN.TYPE=GENTYPE_TEXT;
          }
#line 2624 "y.tab.c"
    break;

  case 82: /* generic_primary: generic_aggregate  */
#line 1108 "./mvl_scomp_y.y"
          {
             MVL_LOGEN.VALUE.LIST = (logen_list *)reverse(MVL_GENLST->DATA);
             MVL_LOGEN.TYPE = GENTYPE_LIST;
             MVL_GENLST = delchain(MVL_GENLST, MVL_GENLST);
          }
#line 2634 "y.tab.c"
    break;

  case 83: /* $@8: %empty  */
#line 1117 "./mvl_scomp_y.y"
          {
             MVL_GENLST = addchain(MVL_GENLST, NULL);
          }
#line 2642 "y.tab.c"
    break;

  case 87: /* generic_element_association: .generic_choices. generic_expression  */
#line 1135 "./mvl_scomp_y.y"
          {
             MVL_GENLST->DATA = duplogen (&MVL_LOGEN,
                                ((logen_list *)MVL_GENLST->DATA), NULL);
             MVL_LOGEN.TYPE = GENTYPE_EMPTY;
          }
#line 2652 "y.tab.c"
    break;

  case 89: /* generic_name: simple_name  */
#line 1153 "./mvl_scomp_y.y"
                                { (yyval.text) = (yyvsp[0].text); }
#line 2658 "y.tab.c"
    break;

  case 90: /* generic_literal: abstractlit  */
#line 1158 "./mvl_scomp_y.y"
          {
             MVL_LOGEN.VALUE.VAL = (yyvsp[0].valu);
             if (base==16)
                MVL_LOGEN.TYPE = GENTYPE_HEX ;
             else
                MVL_LOGEN.TYPE = GENTYPE_VAL ;
          }
#line 2670 "y.tab.c"
    break;

  case 91: /* generic_literal: StringLit  */
#line 1166 "./mvl_scomp_y.y"
          {
             MVL_LOGEN.VALUE.TEXT = strdup((yyvsp[0].text));
             MVL_LOGEN.TYPE = GENTYPE_TEXT;
          }
#line 2679 "y.tab.c"
    break;

  case 92: /* generic_literal: CharacterLit  */
#line 1171 "./mvl_scomp_y.y"
          {
             MVL_LOGEN.VALUE.CHAR = (yyvsp[0].text)[1];
             MVL_LOGEN.TYPE = GENTYPE_BIT;
          }
#line 2688 "y.tab.c"
    break;

  case 99: /* association_element: formal_port_name Arrow actual_port_name  */
#line 1210 "./mvl_scomp_y.y"
                {
                long           sig_width;
                long           con_pos;
                struct chain *sig_list1;
                struct chain *sig_list2;
                long           local_err = 0;

                if (MVL_CHDPNT == NULL)
                  local_err = 1;
                sig_list1 = MVL_NM1LST;

                if (MVL_SIMFLG == MVL_IMPDFN)
                  sig_list1 = MVL_NM2LST;
                MVL_SIMFLG = MVL_EXPDFN;

                if ((yyvsp[-2].name).LEFT <= (yyvsp[-2].name).RIGHT)
                  sig_width = (yyvsp[-2].name).RIGHT - (yyvsp[-2].name).LEFT + 1;
                else
                  sig_width = (yyvsp[-2].name).LEFT - (yyvsp[-2].name).RIGHT + 1;

                if (local_err == 0)
                  {
                  if (sig_width != (yyvsp[0].expr).WIDTH)
                    mvl_error (38, NULL);
                  else
                    {
                    if (MVL_ERRFLG == 0)
                      {
                      con_pos = mvl_chktab (MVL_HSHTAB, (yyvsp[-2].name).NAME, MVL_CHDNAM,
                                            MVL_RNGDFN);
                      while (con_pos != 0)
                        {
                        sig_list1 = sig_list1->NEXT;
                        con_pos--;
                        }
                      sig_list2 = (yyvsp[0].expr).LIST;
                      while (sig_list2 != NULL)
                        {
                        if (sig_list1->DATA != NULL)
                          {
                          mvl_error (41, (yyvsp[-2].name).NAME);
                          break;
                          }
                        sig_list1->DATA = sig_list2->DATA;
                        sig_list2       = sig_list2->NEXT;
                        sig_list1       = sig_list1->NEXT;
                        }
                      }
                    }
                  }
                freechain ((yyvsp[0].expr).LIST);
                }
#line 2745 "y.tab.c"
    break;

  case 100: /* association_element: actual_port_name  */
#line 1263 "./mvl_scomp_y.y"
                {
                struct chain *sig_list1 ;
                char         *prt_name  ;
                long           prt_width ;
                long           left_bnd  ;
                long           right_bnd ;
                long           local_err = 0;
                long           i         ;

                if (MVL_CHDPNT == NULL)
                  local_err = 1;

                if (MVL_SIMFLG == MVL_UKNDFN)
                  {
                  MVL_SIMFLG = MVL_IMPDFN;
                  MVL_NM2LST = MVL_NM1LST;
                  }
                if (MVL_SIMFLG != MVL_IMPDFN)
                  {
                  mvl_error (15, NULL);
                  local_err = 1;
                  }

                prt_name  = (char *) mvl_chktab (MVL_HSHTAB,MVL_CONRNK,
                                                 MVL_CHDNAM,MVL_PNTDFN);
                if (prt_name == NULL)
                  {
                  local_err = 1;
                  mvl_error (76, MVL_LOCNAM);
                  }

                right_bnd = mvl_chktab (MVL_HSHTAB,prt_name,MVL_CHDNAM,
                                        MVL_LFTDFN);
                left_bnd  = mvl_chktab (MVL_HSHTAB,prt_name,MVL_CHDNAM,
                                        MVL_RGTDFN);

                if (left_bnd <= right_bnd)
                  prt_width = right_bnd - left_bnd  + 1;
                else
                  prt_width = left_bnd  - right_bnd + 1;

                if (local_err == 0)
                  {
                  if (prt_width != (yyvsp[0].expr).WIDTH)
                    {
                    mvl_error (38, NULL);
                    for (i=0 ; i<prt_width ; i++)
                      MVL_NM2LST = MVL_NM2LST->NEXT;
                    }
                  else
                    {
                    sig_list1 = (yyvsp[0].expr).LIST;
                    while (sig_list1 != NULL)
                      {
                      MVL_NM2LST->DATA = sig_list1->DATA;
                      sig_list1        = sig_list1->NEXT;
                      MVL_NM2LST       = MVL_NM2LST->NEXT;
                      }
                    }
                  MVL_CONRNK += prt_width;
                  }
                freechain ((yyvsp[0].expr).LIST);
                }
#line 2813 "y.tab.c"
    break;

  case 101: /* association_element: error  */
#line 1327 "./mvl_scomp_y.y"
                {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Comma') is found                       */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Comma) && (yychar != 0));
                yyerrok;

                MVL_CONRNK++;
                mvl_error (31, NULL);
                }
#line 2833 "y.tab.c"
    break;

  case 102: /* formal_port_name: name  */
#line 1346 "./mvl_scomp_y.y"
                {
                if (MVL_CHDPNT != NULL)
                  {
                  if (mvl_chktab(MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,MVL_SIGDFN) != 0)
                    {
                    (yyval.name).LEFT  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,
                                           MVL_LFTDFN);
                    (yyval.name).RIGHT = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,
                                           MVL_RGTDFN);
                    }
                  else
                    {
                    mvl_error (16, (yyvsp[0].name).NAME);
                    (yyval.name) = (yyvsp[0].name);
                    }
                  }
                else
                  (yyval.name) = (yyvsp[0].name);
                }
#line 2857 "y.tab.c"
    break;

  case 103: /* actual_port_name: expression  */
#line 1369 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2863 "y.tab.c"
    break;

  case 104: /* name: simple_name  */
#line 1374 "./mvl_scomp_y.y"
                {
                (yyval.name).NAME  = (yyvsp[0].text);
                (yyval.name).LEFT  = -1;
                (yyval.name).RIGHT = -1;
                }
#line 2873 "y.tab.c"
    break;

  case 105: /* name: indexed_name  */
#line 1380 "./mvl_scomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 2879 "y.tab.c"
    break;

  case 106: /* name: slice_name  */
#line 1382 "./mvl_scomp_y.y"
                { (yyval.name) = (yyvsp[0].name); }
#line 2885 "y.tab.c"
    break;

  case 107: /* indexed_name: simple_name LeftParen abstractlit RightParen_ERR  */
#line 1390 "./mvl_scomp_y.y"
                {
                (yyval.name).NAME  = (yyvsp[-3].text);
                (yyval.name).LEFT  = (yyvsp[-1].valu);
                (yyval.name).RIGHT = (yyvsp[-1].valu);
                }
#line 2895 "y.tab.c"
    break;

  case 108: /* slice_name: simple_name constraint  */
#line 1400 "./mvl_scomp_y.y"
                {
                (yyval.name).NAME  = (yyvsp[-1].text);
                (yyval.name).LEFT  = (yyvsp[0].name).LEFT;
                (yyval.name).RIGHT = (yyvsp[0].name).RIGHT;
                }
#line 2905 "y.tab.c"
    break;

  case 109: /* expression: relation  */
#line 1410 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2911 "y.tab.c"
    break;

  case 110: /* relation: simple_expression  */
#line 1415 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2917 "y.tab.c"
    break;

  case 111: /* simple_expression: .sign.term..add_op__term..  */
#line 1420 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2923 "y.tab.c"
    break;

  case 112: /* .sign.term..add_op__term..: term  */
#line 1425 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2929 "y.tab.c"
    break;

  case 113: /* .sign.term..add_op__term..: .sign.term..add_op__term.. Ampersand term  */
#line 1429 "./mvl_scomp_y.y"
                {
                struct chain *list1;

                list1 = (yyvsp[-2].expr).LIST;
                while (list1->NEXT != NULL)
                  list1 = list1->NEXT;

                list1->NEXT = (yyvsp[0].expr).LIST;
                (yyval.expr).LIST     = (yyvsp[-2].expr).LIST;
                (yyval.expr).WIDTH    = (yyvsp[-2].expr).WIDTH + (yyvsp[0].expr).WIDTH;
                }
#line 2945 "y.tab.c"
    break;

  case 114: /* term: factor  */
#line 1445 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2951 "y.tab.c"
    break;

  case 115: /* factor: primary  */
#line 1451 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2957 "y.tab.c"
    break;

  case 116: /* primary: aggregate  */
#line 1456 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2963 "y.tab.c"
    break;

  case 117: /* primary: type_convertion  */
#line 1458 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[0].expr); }
#line 2969 "y.tab.c"
    break;

  case 118: /* primary: name  */
#line 1460 "./mvl_scomp_y.y"
                {
                mvl_expr      expr;
                struct losig *losig_pnt;
                long           i;
                long           left;
                long           right;
                long           left_bnd;
                long           right_bnd;
                long           sig_width;
                long           rev_flg;
                long           in_bound;
                long           out_bound;

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,MVL_SIGDFN) != 0)
                  {
                  left_bnd  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_LFTDFN);
                  right_bnd = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_RGTDFN);

                  if ((yyvsp[0].name).LEFT == -1)
                    {
                    left  = left_bnd;
                    right = right_bnd;
                    }
                  else
                    {
                    left  = (yyvsp[0].name).LEFT;
                    right = (yyvsp[0].name).RIGHT;
                    }

                  if (left_bnd <= right_bnd)
                    {
                    sig_width = right_bnd - left_bnd + 1;
                    if (left <= right)
                      {
                      expr.WIDTH   = right - left + 1;
                      rev_flg    = 0;
                      in_bound   = right_bnd - right;
                      out_bound  = right_bnd - left;
                      if ((left < left_bnd) || (right > right_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    else
                      {
                      expr.WIDTH   = left - right + 1;
                      rev_flg    = 1;
                      in_bound   = right_bnd - left;
                      out_bound  = right_bnd - right;
                      if ((left > right_bnd) || (right < left_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    }
                  else
                    {
                    sig_width = left_bnd - right_bnd + 1;
                    if (left <= right)
                      {
                      expr.WIDTH   = right - left + 1;
                      rev_flg    = 1;
                      in_bound   = left  - right_bnd;
                      out_bound  = right - right_bnd;
                      if ((left < right_bnd) || (right > left_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    else
                      {
                      expr.WIDTH   = left - right + 1;
                      rev_flg    = 0;
                      in_bound   = right - right_bnd;
                      out_bound  = left  - right_bnd;
                      if ((left > left_bnd) || (right < right_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    }

                  losig_pnt = (struct losig *)
                              mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_PNTDFN);
                  expr.LIST = NULL;
                  for (i=0 ; i<sig_width ; i++)
                    {
                    if (i >= in_bound)
                      expr.LIST = addchain (expr.LIST,losig_pnt);
                    if (i >= out_bound)
                      break;
                    losig_pnt = losig_pnt->NEXT;
                    }
                  if (rev_flg == 1)
                    expr.LIST = reverse (expr.LIST);
                  }
                else
                  {
                  mvl_error (17, (yyvsp[0].name).NAME);
                  expr.WIDTH = 1;
                  expr.LIST  = addchain (NULL,NULL);
                  }
                (yyval.expr) = expr;
                }
#line 3073 "y.tab.c"
    break;

  case 119: /* aggregate: LeftParen expression RightParen_ERR  */
#line 1565 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[-1].expr); }
#line 3079 "y.tab.c"
    break;

  case 120: /* type_convertion: CONVERT LeftParen expression RightParen_ERR  */
#line 1573 "./mvl_scomp_y.y"
                { (yyval.expr) = (yyvsp[-1].expr); }
#line 3085 "y.tab.c"
    break;

  case 123: /* .local_port_mode.: %empty  */
#line 1584 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_ICNDFN; }
#line 3091 "y.tab.c"
    break;

  case 124: /* .local_port_mode.: _IN  */
#line 1586 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_ICNDFN; }
#line 3097 "y.tab.c"
    break;

  case 125: /* .local_port_mode.: _OUT  */
#line 1588 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_OCNDFN; }
#line 3103 "y.tab.c"
    break;

  case 126: /* .local_port_mode.: _INOUT  */
#line 1590 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_BCNDFN; }
#line 3109 "y.tab.c"
    break;

  case 127: /* .local_port_mode.: _LINKAGE  */
#line 1592 "./mvl_scomp_y.y"
                {
                mvl_warning (2, NULL);
                (yyval.valu) = MVL_XCNDFN;
                }
#line 3118 "y.tab.c"
    break;

  case 128: /* .mode.: %empty  */
#line 1600 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_ICNDFN; }
#line 3124 "y.tab.c"
    break;

  case 129: /* .mode.: _IN  */
#line 1602 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_ICNDFN; }
#line 3130 "y.tab.c"
    break;

  case 130: /* .mode.: _OUT  */
#line 1604 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_OCNDFN; }
#line 3136 "y.tab.c"
    break;

  case 131: /* .mode.: _INOUT  */
#line 1606 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_BCNDFN; }
#line 3142 "y.tab.c"
    break;

  case 132: /* .mode.: _LINKAGE  */
#line 1608 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_XCNDFN; }
#line 3148 "y.tab.c"
    break;

  case 133: /* type_mark: BIT  */
#line 1613 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_BITDFN; }
#line 3154 "y.tab.c"
    break;

  case 134: /* type_mark: WOR_BIT  */
#line 1615 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_WORDFN; }
#line 3160 "y.tab.c"
    break;

  case 135: /* type_mark: MUX_BIT  */
#line 1617 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_MUXDFN; }
#line 3166 "y.tab.c"
    break;

  case 136: /* type_mark: BIT_VECTOR  */
#line 1619 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_BTVDFN; }
#line 3172 "y.tab.c"
    break;

  case 137: /* type_mark: WOR_VECTOR  */
#line 1621 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_WRVDFN; }
#line 3178 "y.tab.c"
    break;

  case 138: /* type_mark: MUX_VECTOR  */
#line 1623 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_MXVDFN; }
#line 3184 "y.tab.c"
    break;

  case 139: /* type_mark: INTEGER  */
#line 1625 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_NATDFN; }
#line 3190 "y.tab.c"
    break;

  case 140: /* type_mark: NATURAL  */
#line 1627 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_NATDFN; }
#line 3196 "y.tab.c"
    break;

  case 141: /* type_mark: NATURAL_VECTOR  */
#line 1629 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_NAVDFN; }
#line 3202 "y.tab.c"
    break;

  case 142: /* type_mark: POSITIVE  */
#line 1631 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_NATDFN; }
#line 3208 "y.tab.c"
    break;

  case 143: /* type_mark: STRING  */
#line 1633 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_STRDFN; }
#line 3214 "y.tab.c"
    break;

  case 144: /* type_mark: _LIST  */
#line 1635 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_LSTDFN; }
#line 3220 "y.tab.c"
    break;

  case 145: /* type_mark: ARG  */
#line 1637 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_ARGDFN; }
#line 3226 "y.tab.c"
    break;

  case 146: /* .BUS.: %empty  */
#line 1642 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_NORDFN; }
#line 3232 "y.tab.c"
    break;

  case 147: /* .BUS.: BUS  */
#line 1644 "./mvl_scomp_y.y"
                { (yyval.valu) = MVL_BUSDFN; }
#line 3238 "y.tab.c"
    break;

  case 148: /* $@9: %empty  */
#line 1649 "./mvl_scomp_y.y"
                {
                  MVL_NM1LST = addchain (MVL_NM1LST,(yyvsp[0].text));
                }
#line 3246 "y.tab.c"
    break;

  case 151: /* ...identifier..: ...identifier.. Comma Identifier  */
#line 1660 "./mvl_scomp_y.y"
                {
                  MVL_NM1LST = addchain (MVL_NM1LST,(yyvsp[0].text));
                }
#line 3254 "y.tab.c"
    break;

  case 152: /* a_label: Identifier Colon  */
#line 1668 "./mvl_scomp_y.y"
                { (yyval.text) = (yyvsp[-1].text); }
#line 3260 "y.tab.c"
    break;

  case 153: /* .simple_name.: %empty  */
#line 1673 "./mvl_scomp_y.y"
                { (yyval.text) = NULL; }
#line 3266 "y.tab.c"
    break;

  case 154: /* .simple_name.: simple_name  */
#line 1675 "./mvl_scomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3272 "y.tab.c"
    break;

  case 155: /* simple_name: Identifier  */
#line 1680 "./mvl_scomp_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3278 "y.tab.c"
    break;

  case 156: /* Semicolon_ERR: Semicolon  */
#line 1685 "./mvl_scomp_y.y"
                { yyerrok; }
#line 3284 "y.tab.c"
    break;

  case 157: /* abstractlit: AbstractLit  */
#line 1690 "./mvl_scomp_y.y"
                {
                  char *absend, *absbase;

                  base = strtoul ((yyvsp[0].text), &absbase, 10);
                  if (*absbase=='\0')
                     (yyval.valu) = base;
                  else
                     (yyval.valu) = strtoul(absbase+1, &absend, base);
                }
#line 3298 "y.tab.c"
    break;

  case 158: /* RightParen_ERR: RightParen  */
#line 1703 "./mvl_scomp_y.y"
                { yyerrok; }
#line 3304 "y.tab.c"
    break;

  case 159: /* END_ERR: _END  */
#line 1708 "./mvl_scomp_y.y"
                { yyerrok; }
#line 3310 "y.tab.c"
    break;


#line 3314 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1711 "./mvl_scomp_y.y"

