/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with CTL_Y__ or ctp_y__.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with ctp_y_ or CTL_Y_, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define CTL_Y_BISON 30802

/* Bison version string.  */
#define CTL_Y_BISON_VERSION "3.8.2"

/* Skeleton name.  */
#define CTL_Y_SKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define CTL_Y_PURE 0

/* Push parsers.  */
#define CTL_Y_PUSH 0

/* Pull parsers.  */
#define CTL_Y_PULL 1




/* First part of user prologue.  */
#line 33 "./ctp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "vex.h"
#include "ctl.h"

#include "ctp_utype.h"
#include "ctp_bedef.h"
#include "ctp_bspec.h"
#include "ctp_byacc.h"

#if 1
# define my_fprintf fprintf( stdout, "%s.%d:", autbasename(__FILE__,NULL), __LINE__ ); fprintf
# define my_ctp_error(N,V) \
   do { fprintf( stderr, "%s.%d:", autbasename(__FILE__,NULL), __LINE__); ctp_error(N,V); } while(0)
#else
# define my_fprintf   fprintf
# define my_ctp_error ctp_error
#endif

extern int   ctp_y_lex   (void);
extern void  ctp_y_error (char*);

#ifdef CTP_DEBUG
#define CTL_Y_DEBUG 1
#endif


#line 103 "y.tab.c"

# ifndef CTL_Y__CAST
#  ifdef __cplusplus
#   define CTL_Y__CAST(Type, Val) static_cast<Type> (Val)
#   define CTL_Y__REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define CTL_Y__CAST(Type, Val) ((Type) (Val))
#   define CTL_Y__REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef CTL_Y__NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define CTL_Y__NULLPTR nullptr
#   else
#    define CTL_Y__NULLPTR 0
#   endif
#  else
#   define CTL_Y__NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef CTL_Y__CTL_Y__Y_TAB_H_INCLUDED
# define CTL_Y__CTL_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef CTL_Y_DEBUG
# define CTL_Y_DEBUG 0
#endif
#if CTL_Y_DEBUG
extern int ctp_y_debug;
#endif

/* Token kinds.  */
#ifndef CTL_Y_TOKENTYPE
# define CTL_Y_TOKENTYPE
  enum ctp_y_tokentype
  {
    CTL_Y_EMPTY = -2,
    CTL_Y_EOF = 0,                     /* "end of file"  */
    CTL_Y_error = 256,                 /* error  */
    CTL_Y_UNDEF = 257,                 /* "invalid token"  */
    _AF = 258,                     /* _AF  */
    _AG = 259,                     /* _AG  */
    _AX = 260,                     /* _AX  */
    _AU = 261,                     /* _AU  */
    _EF = 262,                     /* _EF  */
    _EG = 263,                     /* _EG  */
    _EX = 264,                     /* _EX  */
    _EU = 265,                     /* _EU  */
    Imply = 266,                   /* Imply  */
    Equiv = 267,                   /* Equiv  */
    tok_AND = 268,                 /* tok_AND  */
    _BEGIN = 269,                  /* _BEGIN  */
    _END = 270,                    /* _END  */
    _EQSym = 271,                  /* _EQSym  */
    _EXIT = 272,                   /* _EXIT  */
    _FILE = 273,                   /* _FILE  */
    _GESym = 274,                  /* _GESym  */
    _GTSym = 275,                  /* _GTSym  */
    _IN = 276,                     /* _IN  */
    _INOUT = 277,                  /* _INOUT  */
    _LABEL = 278,                  /* _LABEL  */
    _LESym = 279,                  /* _LESym  */
    _LINKAGE = 280,                /* _LINKAGE  */
    _LTSym = 281,                  /* _LTSym  */
    _NAND = 282,                   /* _NAND  */
    _IFT = 283,                    /* _IFT  */
    _NXOR = 284,                   /* _NXOR  */
    _NESym = 285,                  /* _NESym  */
    _NEXT = 286,                   /* _NEXT  */
    _NOR = 287,                    /* _NOR  */
    _NOT = 288,                    /* _NOT  */
    _OR = 289,                     /* _OR  */
    _OUT = 290,                    /* _OUT  */
    _XOR = 291,                    /* _XOR  */
    ABS = 292,                     /* ABS  */
    ACCESS = 293,                  /* ACCESS  */
    AFTER = 294,                   /* AFTER  */
    ALIAS = 295,                   /* ALIAS  */
    ALL = 296,                     /* ALL  */
    ARCHITECTURE = 297,            /* ARCHITECTURE  */
    ARRAY = 298,                   /* ARRAY  */
    ASSERT = 299,                  /* ASSERT  */
    ATTRIBUTE = 300,               /* ATTRIBUTE  */
    AbstractLit = 301,             /* AbstractLit  */
    Ampersand = 302,               /* Ampersand  */
    Apostrophe = 303,              /* Apostrophe  */
    Arrow = 304,                   /* Arrow  */
    BLOCK = 305,                   /* BLOCK  */
    BODY = 306,                    /* BODY  */
    BUS = 307,                     /* BUS  */
    _BUFFER = 308,                 /* _BUFFER  */
    Bar = 309,                     /* Bar  */
    BasedInt = 310,                /* BasedInt  */
    BasedReal = 311,               /* BasedReal  */
    BitStringLit = 312,            /* BitStringLit  */
    _TRUE = 313,                   /* _TRUE  */
    _FALSE = 314,                  /* _FALSE  */
    Box = 315,                     /* Box  */
    CASE = 316,                    /* CASE  */
    COMPONENT = 317,               /* COMPONENT  */
    CONFIGURATION = 318,           /* CONFIGURATION  */
    _DEFINE = 319,                 /* _DEFINE  */
    _ASSUME = 320,                 /* _ASSUME  */
    _INITIAL = 321,                /* _INITIAL  */
    _RESET_COND = 322,             /* _RESET_COND  */
    CharacterLit = 323,            /* CharacterLit  */
    Colon = 324,                   /* Colon  */
    Comma = 325,                   /* Comma  */
    DISCONNECT = 326,              /* DISCONNECT  */
    DOWNTO = 327,                  /* DOWNTO  */
    DecimalInt = 328,              /* DecimalInt  */
    DecimalReal = 329,             /* DecimalReal  */
    Dot = 330,                     /* Dot  */
    DoubleStar = 331,              /* DoubleStar  */
    ELSE = 332,                    /* ELSE  */
    ELSIF = 333,                   /* ELSIF  */
    _ENTITY = 334,                 /* _ENTITY  */
    ERROR = 335,                   /* ERROR  */
    _EVENT = 336,                  /* _EVENT  */
    _LEFT = 337,                   /* _LEFT  */
    _LENGTH = 338,                 /* _LENGTH  */
    _RIGHT = 339,                  /* _RIGHT  */
    _HIGH = 340,                   /* _HIGH  */
    _LOW = 341,                    /* _LOW  */
    FOR = 342,                     /* FOR  */
    FUNCTION = 343,                /* FUNCTION  */
    GENERATE = 344,                /* GENERATE  */
    GENERIC = 345,                 /* GENERIC  */
    GUARDED = 346,                 /* GUARDED  */
    IF = 347,                      /* IF  */
    IS = 348,                      /* IS  */
    _NS = 349,                     /* _NS  */
    _PS = 350,                     /* _PS  */
    _FS = 351,                     /* _FS  */
    _MS = 352,                     /* _MS  */
    Identifier = 353,              /* Identifier  */
    _LIBRARY = 354,                /* _LIBRARY  */
    LOOP = 355,                    /* LOOP  */
    LeftParen = 356,               /* LeftParen  */
    MAP = 357,                     /* MAP  */
    MOD = 358,                     /* MOD  */
    Minus = 359,                   /* Minus  */
    NEW = 360,                     /* NEW  */
    OF = 361,                      /* OF  */
    ON = 362,                      /* ON  */
    OPEN = 363,                    /* OPEN  */
    OTHERS = 364,                  /* OTHERS  */
    _PACKAGE = 365,                /* _PACKAGE  */
    PORT = 366,                    /* PORT  */
    PROCEDURE = 367,               /* PROCEDURE  */
    PROCESS = 368,                 /* PROCESS  */
    Plus = 369,                    /* Plus  */
    _RANGE = 370,                  /* _RANGE  */
    _REV_RANGE = 371,              /* _REV_RANGE  */
    RECORD = 372,                  /* RECORD  */
    REGISTER = 373,                /* REGISTER  */
    REM = 374,                     /* REM  */
    REPORT = 375,                  /* REPORT  */
    _RETURN = 376,                 /* _RETURN  */
    RightParen = 377,              /* RightParen  */
    SELECT = 378,                  /* SELECT  */
    SEVERITY = 379,                /* SEVERITY  */
    SIGNAL = 380,                  /* SIGNAL  */
    _STABLE = 381,                 /* _STABLE  */
    SUBTYPE = 382,                 /* SUBTYPE  */
    Semicolon = 383,               /* Semicolon  */
    Slash = 384,                   /* Slash  */
    Star = 385,                    /* Star  */
    StringLit = 386,               /* StringLit  */
    THEN = 387,                    /* THEN  */
    TO = 388,                      /* TO  */
    TRANSPORT = 389,               /* TRANSPORT  */
    _TYPE = 390,                   /* _TYPE  */
    UNITS = 391,                   /* UNITS  */
    UNTIL = 392,                   /* UNTIL  */
    USE = 393,                     /* USE  */
    _VARIABLE = 394,               /* _VARIABLE  */
    VarAsgn = 395,                 /* VarAsgn  */
    WAIT = 396,                    /* WAIT  */
    WARNING = 397,                 /* WARNING  */
    WHEN = 398,                    /* WHEN  */
    WHILE = 399,                   /* WHILE  */
    WITH = 400                     /* WITH  */
  };
  typedef enum ctp_y_tokentype ctp_y_token_kind_t;
#endif
/* Token kinds.  */
#define CTL_Y_EMPTY -2
#define CTL_Y_EOF 0
#define CTL_Y_error 256
#define CTL_Y_UNDEF 257
#define _AF 258
#define _AG 259
#define _AX 260
#define _AU 261
#define _EF 262
#define _EG 263
#define _EX 264
#define _EU 265
#define Imply 266
#define Equiv 267
#define tok_AND 268
#define _BEGIN 269
#define _END 270
#define _EQSym 271
#define _EXIT 272
#define _FILE 273
#define _GESym 274
#define _GTSym 275
#define _IN 276
#define _INOUT 277
#define _LABEL 278
#define _LESym 279
#define _LINKAGE 280
#define _LTSym 281
#define _NAND 282
#define _IFT 283
#define _NXOR 284
#define _NESym 285
#define _NEXT 286
#define _NOR 287
#define _NOT 288
#define _OR 289
#define _OUT 290
#define _XOR 291
#define ABS 292
#define ACCESS 293
#define AFTER 294
#define ALIAS 295
#define ALL 296
#define ARCHITECTURE 297
#define ARRAY 298
#define ASSERT 299
#define ATTRIBUTE 300
#define AbstractLit 301
#define Ampersand 302
#define Apostrophe 303
#define Arrow 304
#define BLOCK 305
#define BODY 306
#define BUS 307
#define _BUFFER 308
#define Bar 309
#define BasedInt 310
#define BasedReal 311
#define BitStringLit 312
#define _TRUE 313
#define _FALSE 314
#define Box 315
#define CASE 316
#define COMPONENT 317
#define CONFIGURATION 318
#define _DEFINE 319
#define _ASSUME 320
#define _INITIAL 321
#define _RESET_COND 322
#define CharacterLit 323
#define Colon 324
#define Comma 325
#define DISCONNECT 326
#define DOWNTO 327
#define DecimalInt 328
#define DecimalReal 329
#define Dot 330
#define DoubleStar 331
#define ELSE 332
#define ELSIF 333
#define _ENTITY 334
#define ERROR 335
#define _EVENT 336
#define _LEFT 337
#define _LENGTH 338
#define _RIGHT 339
#define _HIGH 340
#define _LOW 341
#define FOR 342
#define FUNCTION 343
#define GENERATE 344
#define GENERIC 345
#define GUARDED 346
#define IF 347
#define IS 348
#define _NS 349
#define _PS 350
#define _FS 351
#define _MS 352
#define Identifier 353
#define _LIBRARY 354
#define LOOP 355
#define LeftParen 356
#define MAP 357
#define MOD 358
#define Minus 359
#define NEW 360
#define OF 361
#define ON 362
#define OPEN 363
#define OTHERS 364
#define _PACKAGE 365
#define PORT 366
#define PROCEDURE 367
#define PROCESS 368
#define Plus 369
#define _RANGE 370
#define _REV_RANGE 371
#define RECORD 372
#define REGISTER 373
#define REM 374
#define REPORT 375
#define _RETURN 376
#define RightParen 377
#define SELECT 378
#define SEVERITY 379
#define SIGNAL 380
#define _STABLE 381
#define SUBTYPE 382
#define Semicolon 383
#define Slash 384
#define Star 385
#define StringLit 386
#define THEN 387
#define TO 388
#define TRANSPORT 389
#define _TYPE 390
#define UNITS 391
#define UNTIL 392
#define USE 393
#define _VARIABLE 394
#define VarAsgn 395
#define WAIT 396
#define WARNING 397
#define WHEN 398
#define WHILE 399
#define WITH 400

/* Value type.  */
#if ! defined CTL_Y_STYPE && ! defined CTL_Y_STYPE_IS_DECLARED
union CTL_Y_STYPE
{
#line 65 "./ctp_y.y"

          long          valu;
          char         *text;
          chain_list   *pcha;
          ctp_name      name;
          ctp_vexstr    list;
          ctltype_list  type;
       

#line 456 "y.tab.c"

};
typedef union CTL_Y_STYPE CTL_Y_STYPE;
# define CTL_Y_STYPE_IS_TRIVIAL 1
# define CTL_Y_STYPE_IS_DECLARED 1
#endif


extern CTL_Y_STYPE ctp_y_lval;


int ctp_y_parse (void);


#endif /* !CTL_Y__CTL_Y__Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum ctp_y_symbol_kind_t
{
  CTL_Y_SYMBOL_CTL_Y_EMPTY = -2,
  CTL_Y_SYMBOL_CTL_Y_EOF = 0,                      /* "end of file"  */
  CTL_Y_SYMBOL_CTL_Y_error = 1,                    /* error  */
  CTL_Y_SYMBOL_CTL_Y_UNDEF = 2,                    /* "invalid token"  */
  CTL_Y_SYMBOL__AF = 3,                        /* _AF  */
  CTL_Y_SYMBOL__AG = 4,                        /* _AG  */
  CTL_Y_SYMBOL__AX = 5,                        /* _AX  */
  CTL_Y_SYMBOL__AU = 6,                        /* _AU  */
  CTL_Y_SYMBOL__EF = 7,                        /* _EF  */
  CTL_Y_SYMBOL__EG = 8,                        /* _EG  */
  CTL_Y_SYMBOL__EX = 9,                        /* _EX  */
  CTL_Y_SYMBOL__EU = 10,                       /* _EU  */
  CTL_Y_SYMBOL_Imply = 11,                     /* Imply  */
  CTL_Y_SYMBOL_Equiv = 12,                     /* Equiv  */
  CTL_Y_SYMBOL_tok_AND = 13,                   /* tok_AND  */
  CTL_Y_SYMBOL__BEGIN = 14,                    /* _BEGIN  */
  CTL_Y_SYMBOL__END = 15,                      /* _END  */
  CTL_Y_SYMBOL__EQSym = 16,                    /* _EQSym  */
  CTL_Y_SYMBOL__EXIT = 17,                     /* _EXIT  */
  CTL_Y_SYMBOL__FILE = 18,                     /* _FILE  */
  CTL_Y_SYMBOL__GESym = 19,                    /* _GESym  */
  CTL_Y_SYMBOL__GTSym = 20,                    /* _GTSym  */
  CTL_Y_SYMBOL__IN = 21,                       /* _IN  */
  CTL_Y_SYMBOL__INOUT = 22,                    /* _INOUT  */
  CTL_Y_SYMBOL__LABEL = 23,                    /* _LABEL  */
  CTL_Y_SYMBOL__LESym = 24,                    /* _LESym  */
  CTL_Y_SYMBOL__LINKAGE = 25,                  /* _LINKAGE  */
  CTL_Y_SYMBOL__LTSym = 26,                    /* _LTSym  */
  CTL_Y_SYMBOL__NAND = 27,                     /* _NAND  */
  CTL_Y_SYMBOL__IFT = 28,                      /* _IFT  */
  CTL_Y_SYMBOL__NXOR = 29,                     /* _NXOR  */
  CTL_Y_SYMBOL__NESym = 30,                    /* _NESym  */
  CTL_Y_SYMBOL__NEXT = 31,                     /* _NEXT  */
  CTL_Y_SYMBOL__NOR = 32,                      /* _NOR  */
  CTL_Y_SYMBOL__NOT = 33,                      /* _NOT  */
  CTL_Y_SYMBOL__OR = 34,                       /* _OR  */
  CTL_Y_SYMBOL__OUT = 35,                      /* _OUT  */
  CTL_Y_SYMBOL__XOR = 36,                      /* _XOR  */
  CTL_Y_SYMBOL_ABS = 37,                       /* ABS  */
  CTL_Y_SYMBOL_ACCESS = 38,                    /* ACCESS  */
  CTL_Y_SYMBOL_AFTER = 39,                     /* AFTER  */
  CTL_Y_SYMBOL_ALIAS = 40,                     /* ALIAS  */
  CTL_Y_SYMBOL_ALL = 41,                       /* ALL  */
  CTL_Y_SYMBOL_ARCHITECTURE = 42,              /* ARCHITECTURE  */
  CTL_Y_SYMBOL_ARRAY = 43,                     /* ARRAY  */
  CTL_Y_SYMBOL_ASSERT = 44,                    /* ASSERT  */
  CTL_Y_SYMBOL_ATTRIBUTE = 45,                 /* ATTRIBUTE  */
  CTL_Y_SYMBOL_AbstractLit = 46,               /* AbstractLit  */
  CTL_Y_SYMBOL_Ampersand = 47,                 /* Ampersand  */
  CTL_Y_SYMBOL_Apostrophe = 48,                /* Apostrophe  */
  CTL_Y_SYMBOL_Arrow = 49,                     /* Arrow  */
  CTL_Y_SYMBOL_BLOCK = 50,                     /* BLOCK  */
  CTL_Y_SYMBOL_BODY = 51,                      /* BODY  */
  CTL_Y_SYMBOL_BUS = 52,                       /* BUS  */
  CTL_Y_SYMBOL__BUFFER = 53,                   /* _BUFFER  */
  CTL_Y_SYMBOL_Bar = 54,                       /* Bar  */
  CTL_Y_SYMBOL_BasedInt = 55,                  /* BasedInt  */
  CTL_Y_SYMBOL_BasedReal = 56,                 /* BasedReal  */
  CTL_Y_SYMBOL_BitStringLit = 57,              /* BitStringLit  */
  CTL_Y_SYMBOL__TRUE = 58,                     /* _TRUE  */
  CTL_Y_SYMBOL__FALSE = 59,                    /* _FALSE  */
  CTL_Y_SYMBOL_Box = 60,                       /* Box  */
  CTL_Y_SYMBOL_CASE = 61,                      /* CASE  */
  CTL_Y_SYMBOL_COMPONENT = 62,                 /* COMPONENT  */
  CTL_Y_SYMBOL_CONFIGURATION = 63,             /* CONFIGURATION  */
  CTL_Y_SYMBOL__DEFINE = 64,                   /* _DEFINE  */
  CTL_Y_SYMBOL__ASSUME = 65,                   /* _ASSUME  */
  CTL_Y_SYMBOL__INITIAL = 66,                  /* _INITIAL  */
  CTL_Y_SYMBOL__RESET_COND = 67,               /* _RESET_COND  */
  CTL_Y_SYMBOL_CharacterLit = 68,              /* CharacterLit  */
  CTL_Y_SYMBOL_Colon = 69,                     /* Colon  */
  CTL_Y_SYMBOL_Comma = 70,                     /* Comma  */
  CTL_Y_SYMBOL_DISCONNECT = 71,                /* DISCONNECT  */
  CTL_Y_SYMBOL_DOWNTO = 72,                    /* DOWNTO  */
  CTL_Y_SYMBOL_DecimalInt = 73,                /* DecimalInt  */
  CTL_Y_SYMBOL_DecimalReal = 74,               /* DecimalReal  */
  CTL_Y_SYMBOL_Dot = 75,                       /* Dot  */
  CTL_Y_SYMBOL_DoubleStar = 76,                /* DoubleStar  */
  CTL_Y_SYMBOL_ELSE = 77,                      /* ELSE  */
  CTL_Y_SYMBOL_ELSIF = 78,                     /* ELSIF  */
  CTL_Y_SYMBOL__ENTITY = 79,                   /* _ENTITY  */
  CTL_Y_SYMBOL_ERROR = 80,                     /* ERROR  */
  CTL_Y_SYMBOL__EVENT = 81,                    /* _EVENT  */
  CTL_Y_SYMBOL__LEFT = 82,                     /* _LEFT  */
  CTL_Y_SYMBOL__LENGTH = 83,                   /* _LENGTH  */
  CTL_Y_SYMBOL__RIGHT = 84,                    /* _RIGHT  */
  CTL_Y_SYMBOL__HIGH = 85,                     /* _HIGH  */
  CTL_Y_SYMBOL__LOW = 86,                      /* _LOW  */
  CTL_Y_SYMBOL_FOR = 87,                       /* FOR  */
  CTL_Y_SYMBOL_FUNCTION = 88,                  /* FUNCTION  */
  CTL_Y_SYMBOL_GENERATE = 89,                  /* GENERATE  */
  CTL_Y_SYMBOL_GENERIC = 90,                   /* GENERIC  */
  CTL_Y_SYMBOL_GUARDED = 91,                   /* GUARDED  */
  CTL_Y_SYMBOL_IF = 92,                        /* IF  */
  CTL_Y_SYMBOL_IS = 93,                        /* IS  */
  CTL_Y_SYMBOL__NS = 94,                       /* _NS  */
  CTL_Y_SYMBOL__PS = 95,                       /* _PS  */
  CTL_Y_SYMBOL__FS = 96,                       /* _FS  */
  CTL_Y_SYMBOL__MS = 97,                       /* _MS  */
  CTL_Y_SYMBOL_Identifier = 98,                /* Identifier  */
  CTL_Y_SYMBOL__LIBRARY = 99,                  /* _LIBRARY  */
  CTL_Y_SYMBOL_LOOP = 100,                     /* LOOP  */
  CTL_Y_SYMBOL_LeftParen = 101,                /* LeftParen  */
  CTL_Y_SYMBOL_MAP = 102,                      /* MAP  */
  CTL_Y_SYMBOL_MOD = 103,                      /* MOD  */
  CTL_Y_SYMBOL_Minus = 104,                    /* Minus  */
  CTL_Y_SYMBOL_NEW = 105,                      /* NEW  */
  CTL_Y_SYMBOL_OF = 106,                       /* OF  */
  CTL_Y_SYMBOL_ON = 107,                       /* ON  */
  CTL_Y_SYMBOL_OPEN = 108,                     /* OPEN  */
  CTL_Y_SYMBOL_OTHERS = 109,                   /* OTHERS  */
  CTL_Y_SYMBOL__PACKAGE = 110,                 /* _PACKAGE  */
  CTL_Y_SYMBOL_PORT = 111,                     /* PORT  */
  CTL_Y_SYMBOL_PROCEDURE = 112,                /* PROCEDURE  */
  CTL_Y_SYMBOL_PROCESS = 113,                  /* PROCESS  */
  CTL_Y_SYMBOL_Plus = 114,                     /* Plus  */
  CTL_Y_SYMBOL__RANGE = 115,                   /* _RANGE  */
  CTL_Y_SYMBOL__REV_RANGE = 116,               /* _REV_RANGE  */
  CTL_Y_SYMBOL_RECORD = 117,                   /* RECORD  */
  CTL_Y_SYMBOL_REGISTER = 118,                 /* REGISTER  */
  CTL_Y_SYMBOL_REM = 119,                      /* REM  */
  CTL_Y_SYMBOL_REPORT = 120,                   /* REPORT  */
  CTL_Y_SYMBOL__RETURN = 121,                  /* _RETURN  */
  CTL_Y_SYMBOL_RightParen = 122,               /* RightParen  */
  CTL_Y_SYMBOL_SELECT = 123,                   /* SELECT  */
  CTL_Y_SYMBOL_SEVERITY = 124,                 /* SEVERITY  */
  CTL_Y_SYMBOL_SIGNAL = 125,                   /* SIGNAL  */
  CTL_Y_SYMBOL__STABLE = 126,                  /* _STABLE  */
  CTL_Y_SYMBOL_SUBTYPE = 127,                  /* SUBTYPE  */
  CTL_Y_SYMBOL_Semicolon = 128,                /* Semicolon  */
  CTL_Y_SYMBOL_Slash = 129,                    /* Slash  */
  CTL_Y_SYMBOL_Star = 130,                     /* Star  */
  CTL_Y_SYMBOL_StringLit = 131,                /* StringLit  */
  CTL_Y_SYMBOL_THEN = 132,                     /* THEN  */
  CTL_Y_SYMBOL_TO = 133,                       /* TO  */
  CTL_Y_SYMBOL_TRANSPORT = 134,                /* TRANSPORT  */
  CTL_Y_SYMBOL__TYPE = 135,                    /* _TYPE  */
  CTL_Y_SYMBOL_UNITS = 136,                    /* UNITS  */
  CTL_Y_SYMBOL_UNTIL = 137,                    /* UNTIL  */
  CTL_Y_SYMBOL_USE = 138,                      /* USE  */
  CTL_Y_SYMBOL__VARIABLE = 139,                /* _VARIABLE  */
  CTL_Y_SYMBOL_VarAsgn = 140,                  /* VarAsgn  */
  CTL_Y_SYMBOL_WAIT = 141,                     /* WAIT  */
  CTL_Y_SYMBOL_WARNING = 142,                  /* WARNING  */
  CTL_Y_SYMBOL_WHEN = 143,                     /* WHEN  */
  CTL_Y_SYMBOL_WHILE = 144,                    /* WHILE  */
  CTL_Y_SYMBOL_WITH = 145,                     /* WITH  */
  CTL_Y_SYMBOL_CTL_Y_ACCEPT = 146,                 /* $accept  */
  CTL_Y_SYMBOL_ctl_file = 147,                 /* ctl_file  */
  CTL_Y_SYMBOL_148_1 = 148,                    /* $@1  */
  CTL_Y_SYMBOL_ctl_body = 149,                 /* ctl_body  */
  CTL_Y_SYMBOL_ctl_declarative_part = 150,     /* ctl_declarative_part  */
  CTL_Y_SYMBOL_151_block_declarative_item_ = 151, /* ..block_declarative_item..  */
  CTL_Y_SYMBOL_block_declarative_item = 152,   /* block_declarative_item  */
  CTL_Y_SYMBOL_constant_declaration = 153,     /* constant_declaration  */
  CTL_Y_SYMBOL_assumption_declaration = 154,   /* assumption_declaration  */
  CTL_Y_SYMBOL_initial_declaration = 155,      /* initial_declaration  */
  CTL_Y_SYMBOL_reset_cond_declaration = 156,   /* reset_cond_declaration  */
  CTL_Y_SYMBOL_constant_VarAsgn__expression = 157, /* constant_VarAsgn__expression  */
  CTL_Y_SYMBOL_variable_declaration = 158,     /* variable_declaration  */
  CTL_Y_SYMBOL_type_declaration = 159,         /* type_declaration  */
  CTL_Y_SYMBOL_full_type_declaration = 160,    /* full_type_declaration  */
  CTL_Y_SYMBOL_type_definition = 161,          /* type_definition  */
  CTL_Y_SYMBOL_subtype_declaration = 162,      /* subtype_declaration  */
  CTL_Y_SYMBOL_subtype_indication = 163,       /* subtype_indication  */
  CTL_Y_SYMBOL_type_or_function_name = 164,    /* type_or_function_name  */
  CTL_Y_SYMBOL_scalar_type_definition = 165,   /* scalar_type_definition  */
  CTL_Y_SYMBOL_enumeration_type_definition = 166, /* enumeration_type_definition  */
  CTL_Y_SYMBOL_167_enumeration_literal_ = 167, /* ...enumeration_literal..  */
  CTL_Y_SYMBOL_enumeration_literal = 168,      /* enumeration_literal  */
  CTL_Y_SYMBOL_composite_type_definition = 169, /* composite_type_definition  */
  CTL_Y_SYMBOL_array_type_definition = 170,    /* array_type_definition  */
  CTL_Y_SYMBOL_constrained_array_definition = 171, /* constrained_array_definition  */
  CTL_Y_SYMBOL_index_constraint = 172,         /* index_constraint  */
  CTL_Y_SYMBOL_discrete_range = 173,           /* discrete_range  */
  CTL_Y_SYMBOL_174_constraint_ = 174,          /* .constraint.  */
  CTL_Y_SYMBOL_constraint = 175,               /* constraint  */
  CTL_Y_SYMBOL_range_constraint = 176,         /* range_constraint  */
  CTL_Y_SYMBOL_range = 177,                    /* range  */
  CTL_Y_SYMBOL_direction = 178,                /* direction  */
  CTL_Y_SYMBOL_type_mark = 179,                /* type_mark  */
  CTL_Y_SYMBOL_ctl_statement_part = 180,       /* ctl_statement_part  */
  CTL_Y_SYMBOL_181_concurrent_statement_ = 181, /* ..concurrent_statement..  */
  CTL_Y_SYMBOL_concurrent_statement = 182,     /* concurrent_statement  */
  CTL_Y_SYMBOL_formula_assignment_statement = 183, /* formula_assignment_statement  */
  CTL_Y_SYMBOL_expression = 184,               /* expression  */
  CTL_Y_SYMBOL_185_relation_AND__relation_ = 185, /* relation..AND__relation..  */
  CTL_Y_SYMBOL_186_relation_OR__relation_ = 186, /* relation..OR__relation..  */
  CTL_Y_SYMBOL_187_relation_NAND_NOR_NXOR_relation_ = 187, /* relation.NAND_NOR_NXOR_relation.  */
  CTL_Y_SYMBOL_188_relation_XOR__relation_ = 188, /* relation..XOR__relation..  */
  CTL_Y_SYMBOL_relation = 189,                 /* relation  */
  CTL_Y_SYMBOL_simple_expression = 190,        /* simple_expression  */
  CTL_Y_SYMBOL_191_sign_term_add_op__term_ = 191, /* .sign.term..add_op__term..  */
  CTL_Y_SYMBOL_adding_operator = 192,          /* adding_operator  */
  CTL_Y_SYMBOL_sign = 193,                     /* sign  */
  CTL_Y_SYMBOL_multiplying_operator = 194,     /* multiplying_operator  */
  CTL_Y_SYMBOL_term = 195,                     /* term  */
  CTL_Y_SYMBOL_factor = 196,                   /* factor  */
  CTL_Y_SYMBOL_primary = 197,                  /* primary  */
  CTL_Y_SYMBOL_qualified_expression = 198,     /* qualified_expression  */
  CTL_Y_SYMBOL_relational_operator = 199,      /* relational_operator  */
  CTL_Y_SYMBOL_literal = 200,                  /* literal  */
  CTL_Y_SYMBOL_aggregate = 201,                /* aggregate  */
  CTL_Y_SYMBOL_202_element_association_ = 202, /* ...element_association..  */
  CTL_Y_SYMBOL_element_association = 203,      /* element_association  */
  CTL_Y_SYMBOL_name = 204,                     /* name  */
  CTL_Y_SYMBOL_indexed_name = 205,             /* indexed_name  */
  CTL_Y_SYMBOL_slice_name = 206,               /* slice_name  */
  CTL_Y_SYMBOL_attribute_name = 207,           /* attribute_name  */
  CTL_Y_SYMBOL_attribute_designator = 208,     /* attribute_designator  */
  CTL_Y_SYMBOL_identifier_list = 209,          /* identifier_list  */
  CTL_Y_SYMBOL_210_2 = 210,                    /* $@2  */
  CTL_Y_SYMBOL_211_identifier_ = 211,          /* ...identifier..  */
  CTL_Y_SYMBOL_simple_name = 212,              /* simple_name  */
  CTL_Y_SYMBOL_RightParen_ERR = 213,           /* RightParen_ERR  */
  CTL_Y_SYMBOL_Semicolon_ERR = 214,            /* Semicolon_ERR  */
  CTL_Y_SYMBOL_END_ERR = 215                   /* END_ERR  */
};
typedef enum ctp_y_symbol_kind_t ctp_y_symbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define CTL_Y__STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ ctp_y_type_int8;
#elif defined CTL_Y__STDINT_H
typedef int_least8_t ctp_y_type_int8;
#else
typedef signed char ctp_y_type_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ ctp_y_type_int16;
#elif defined CTL_Y__STDINT_H
typedef int_least16_t ctp_y_type_int16;
#else
typedef short ctp_y_type_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ ctp_y_type_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined CTL_Y__STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t ctp_y_type_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char ctp_y_type_uint8;
#else
typedef short ctp_y_type_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ ctp_y_type_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined CTL_Y__STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t ctp_y_type_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short ctp_y_type_uint16;
#else
typedef int ctp_y_type_uint16;
#endif

#ifndef CTL_Y_PTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define CTL_Y_PTRDIFF_T __PTRDIFF_TYPE__
#  define CTL_Y_PTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define CTL_Y_PTRDIFF_T ptrdiff_t
#  define CTL_Y_PTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define CTL_Y_PTRDIFF_T long
#  define CTL_Y_PTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef CTL_Y_SIZE_T
# ifdef __SIZE_TYPE__
#  define CTL_Y_SIZE_T __SIZE_TYPE__
# elif defined size_t
#  define CTL_Y_SIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define CTL_Y_SIZE_T size_t
# else
#  define CTL_Y_SIZE_T unsigned
# endif
#endif

#define CTL_Y_SIZE_MAXIMUM                                  \
  CTL_Y__CAST (CTL_Y_PTRDIFF_T,                                 \
           (CTL_Y_PTRDIFF_MAXIMUM < CTL_Y__CAST (CTL_Y_SIZE_T, -1)  \
            ? CTL_Y_PTRDIFF_MAXIMUM                         \
            : CTL_Y__CAST (CTL_Y_SIZE_T, -1)))

#define CTL_Y_SIZEOF(X) CTL_Y__CAST (CTL_Y_PTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef ctp_y_type_uint8 ctp_y__state_t;

/* State numbers in computations.  */
typedef int ctp_y__state_fast_t;

#ifndef CTL_Y__
# if defined CTL_Y_ENABLE_NLS && CTL_Y_ENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define CTL_Y__(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef CTL_Y__
#  define CTL_Y__(Msgid) Msgid
# endif
#endif


#ifndef CTL_Y__ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define CTL_Y__ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define CTL_Y__ATTRIBUTE_PURE
# endif
#endif

#ifndef CTL_Y__ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define CTL_Y__ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define CTL_Y__ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define CTL_Y__USE(E) ((void) (E))
#else
# define CTL_Y__USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about ctp_y_lval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define CTL_Y__INITIAL_VALUE(Value) Value
#endif
#ifndef CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef CTL_Y__INITIAL_VALUE
# define CTL_Y__INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define CTL_Y__IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define CTL_Y__IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef CTL_Y__IGNORE_USELESS_CAST_BEGIN
# define CTL_Y__IGNORE_USELESS_CAST_BEGIN
# define CTL_Y__IGNORE_USELESS_CAST_END
#endif


#define CTL_Y__ASSERT(E) ((void) (0 && (E)))

#if !defined ctp_y_overflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef CTL_Y_STACK_USE_ALLOCA
#  if CTL_Y_STACK_USE_ALLOCA
#   ifdef __GNUC__
#    define CTL_Y_STACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define CTL_Y_STACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define CTL_Y_STACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef CTL_Y_STACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define CTL_Y_STACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef CTL_Y_STACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define CTL_Y_STACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define CTL_Y_STACK_ALLOC CTL_Y_MALLOC
#  define CTL_Y_STACK_FREE CTL_Y_FREE
#  ifndef CTL_Y_STACK_ALLOC_MAXIMUM
#   define CTL_Y_STACK_ALLOC_MAXIMUM CTL_Y_SIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined CTL_Y_MALLOC || defined malloc) \
             && (defined CTL_Y_FREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef CTL_Y_MALLOC
#   define CTL_Y_MALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (CTL_Y_SIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef CTL_Y_FREE
#   define CTL_Y_FREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined ctp_y_overflow */

#if (! defined ctp_y_overflow \
     && (! defined __cplusplus \
         || (defined CTL_Y_STYPE_IS_TRIVIAL && CTL_Y_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union ctp_y_alloc
{
  ctp_y__state_t ctp_y_ss_alloc;
  CTL_Y_STYPE ctp_y_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define CTL_Y_STACK_GAP_MAXIMUM (CTL_Y_SIZEOF (union ctp_y_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define CTL_Y_STACK_BYTES(N) \
     ((N) * (CTL_Y_SIZEOF (ctp_y__state_t) + CTL_Y_SIZEOF (CTL_Y_STYPE)) \
      + CTL_Y_STACK_GAP_MAXIMUM)

# define CTL_Y_COPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables CTL_Y_SIZE and CTL_Y_STACKSIZE give the old and new number of
   elements in the stack, and CTL_Y_PTR gives the new location of the
   stack.  Advance CTL_Y_PTR to a properly aligned location for the next
   stack.  */
# define CTL_Y_STACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        CTL_Y_PTRDIFF_T ctp_y_newbytes;                                         \
        CTL_Y_COPY (&ctp_y_ptr->Stack_alloc, Stack, ctp_y_size);                    \
        Stack = &ctp_y_ptr->Stack_alloc;                                    \
        ctp_y_newbytes = ctp_y_stacksize * CTL_Y_SIZEOF (*Stack) + CTL_Y_STACK_GAP_MAXIMUM; \
        ctp_y_ptr += ctp_y_newbytes / CTL_Y_SIZEOF (*ctp_y_ptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined CTL_Y_COPY_NEEDED && CTL_Y_COPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef CTL_Y_COPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define CTL_Y_COPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, CTL_Y__CAST (CTL_Y_SIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define CTL_Y_COPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          CTL_Y_PTRDIFF_T ctp_y_i;                      \
          for (ctp_y_i = 0; ctp_y_i < (Count); ctp_y_i++)   \
            (Dst)[ctp_y_i] = (Src)[ctp_y_i];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !CTL_Y_COPY_NEEDED */

/* CTL_Y_FINAL -- State number of the termination state.  */
#define CTL_Y_FINAL  3
/* CTL_Y_LAST -- Last index in CTL_Y_TABLE.  */
#define CTL_Y_LAST   376

/* CTL_Y_NTOKENS -- Number of terminals.  */
#define CTL_Y_NTOKENS  146
/* CTL_Y_NNTS -- Number of nonterminals.  */
#define CTL_Y_NNTS  70
/* CTL_Y_NRULES -- Number of rules.  */
#define CTL_Y_NRULES  151
/* CTL_Y_NSTATES -- Number of states.  */
#define CTL_Y_NSTATES  251

/* CTL_Y_MAXUTOK -- Last valid token kind.  */
#define CTL_Y_MAXUTOK   400


/* CTL_Y_TRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by ctp_y_lex, with out-of-bounds checking.  */
#define CTL_Y_TRANSLATE(CTL_Y_X)                                \
  (0 <= (CTL_Y_X) && (CTL_Y_X) <= CTL_Y_MAXUTOK                     \
   ? CTL_Y__CAST (ctp_y_symbol_kind_t, ctp_y_translate[CTL_Y_X])        \
   : CTL_Y_SYMBOL_CTL_Y_UNDEF)

/* CTL_Y_TRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by ctp_y_lex.  */
static const ctp_y_type_uint8 ctp_y_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
};

#if CTL_Y_DEBUG
/* CTL_Y_RLINE[CTL_Y_N] -- Source line where rule number CTL_Y_N was defined.  */
static const ctp_y_type_int16 ctp_y_rline[] =
{
       0,   278,   278,   278,   319,   329,   333,   334,   339,   340,
     341,   342,   343,   344,   345,   346,   354,   418,   459,   500,
     542,   548,   622,   626,   649,   651,   653,   658,   680,   699,
     719,   725,   731,   787,   788,   795,   799,   806,   813,   818,
     874,   881,   883,   888,   895,   900,   907,   912,   921,   927,
     937,   974,   976,   983,  1001,  1005,  1006,  1011,  1012,  1018,
    1041,  1043,  1045,  1047,  1052,  1058,  1067,  1073,  1082,  1084,
    1090,  1096,  1102,  1108,  1117,  1129,  1135,  1144,  1146,  1155,
    1160,  1162,  1174,  1183,  1185,  1187,  1191,  1193,  1198,  1200,
    1202,  1204,  1209,  1211,  1220,  1224,  1230,  1235,  1240,  1245,
    1250,  1255,  1260,  1265,  1273,  1283,  1310,  1399,  1415,  1462,
    1464,  1466,  1468,  1470,  1472,  1474,  1476,  1481,  1483,  1486,
    1488,  1490,  1492,  1497,  1513,  1516,  1530,  1539,  1553,  1567,
    1569,  1571,  1576,  1649,  1689,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1780,  1779,  1785,  1786,  1795,  1800,
    1805,  1810
};
#endif

/** Accessing symbol of state STATE.  */
#define CTL_Y__ACCESSING_SYMBOL(State) CTL_Y__CAST (ctp_y_symbol_kind_t, ctp_y_stos[State])

#if CTL_Y_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   CTL_Y_SYMBOL.  No bounds checking.  */
static const char *ctp_y_symbol_name (ctp_y_symbol_kind_t ctp_y_symbol) CTL_Y__ATTRIBUTE_UNUSED;

/* CTL_Y_TNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at CTL_Y_NTOKENS, nonterminals.  */
static const char *const ctp_y_tname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "_AF", "_AG", "_AX",
  "_AU", "_EF", "_EG", "_EX", "_EU", "Imply", "Equiv", "tok_AND", "_BEGIN",
  "_END", "_EQSym", "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT",
  "_LABEL", "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_IFT", "_NXOR",
  "_NESym", "_NEXT", "_NOR", "_NOT", "_OR", "_OUT", "_XOR", "ABS",
  "ACCESS", "AFTER", "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT",
  "ATTRIBUTE", "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BLOCK",
  "BODY", "BUS", "_BUFFER", "Bar", "BasedInt", "BasedReal", "BitStringLit",
  "_TRUE", "_FALSE", "Box", "CASE", "COMPONENT", "CONFIGURATION",
  "_DEFINE", "_ASSUME", "_INITIAL", "_RESET_COND", "CharacterLit", "Colon",
  "Comma", "DISCONNECT", "DOWNTO", "DecimalInt", "DecimalReal", "Dot",
  "DoubleStar", "ELSE", "ELSIF", "_ENTITY", "ERROR", "_EVENT", "_LEFT",
  "_LENGTH", "_RIGHT", "_HIGH", "_LOW", "FOR", "FUNCTION", "GENERATE",
  "GENERIC", "GUARDED", "IF", "IS", "_NS", "_PS", "_FS", "_MS",
  "Identifier", "_LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "Minus",
  "NEW", "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE",
  "PROCESS", "Plus", "_RANGE", "_REV_RANGE", "RECORD", "REGISTER", "REM",
  "REPORT", "_RETURN", "RightParen", "SELECT", "SEVERITY", "SIGNAL",
  "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star", "StringLit", "THEN",
  "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "_VARIABLE",
  "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH", "$accept",
  "ctl_file", "$@1", "ctl_body", "ctl_declarative_part",
  "..block_declarative_item..", "block_declarative_item",
  "constant_declaration", "assumption_declaration", "initial_declaration",
  "reset_cond_declaration", "constant_VarAsgn__expression",
  "variable_declaration", "type_declaration", "full_type_declaration",
  "type_definition", "subtype_declaration", "subtype_indication",
  "type_or_function_name", "scalar_type_definition",
  "enumeration_type_definition", "...enumeration_literal..",
  "enumeration_literal", "composite_type_definition",
  "array_type_definition", "constrained_array_definition",
  "index_constraint", "discrete_range", ".constraint.", "constraint",
  "range_constraint", "range", "direction", "type_mark",
  "ctl_statement_part", "..concurrent_statement..", "concurrent_statement",
  "formula_assignment_statement", "expression",
  "relation..AND__relation..", "relation..OR__relation..",
  "relation.NAND_NOR_NXOR_relation.", "relation..XOR__relation..",
  "relation", "simple_expression", ".sign.term..add_op__term..",
  "adding_operator", "sign", "multiplying_operator", "term", "factor",
  "primary", "qualified_expression", "relational_operator", "literal",
  "aggregate", "...element_association..", "element_association", "name",
  "indexed_name", "slice_name", "attribute_name", "attribute_designator",
  "identifier_list", "$@2", "...identifier..", "simple_name",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", CTL_Y__NULLPTR
};

static const char *
ctp_y_symbol_name (ctp_y_symbol_kind_t ctp_y_symbol)
{
  return ctp_y_tname[ctp_y_symbol];
}
#endif

#define CTL_Y_PACT_NINF (-99)

#define ctp_y_pact_value_is_default(Yyn) \
  ((Yyn) == CTL_Y_PACT_NINF)

#define CTL_Y_TABLE_NINF (-55)

#define ctp_y_table_value_is_error(Yyn) \
  0

/* CTL_Y_PACT[STATE-NUM] -- Index in CTL_Y_TABLE of the portion describing
   STATE-NUM.  */
static const ctp_y_type_int16 ctp_y_pact[] =
{
     -99,    21,   -99,   -99,   -99,    14,    15,   -99,   -98,   -57,
     -43,   -42,   -38,   -34,   -33,   -30,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,   -99,    44,     2,   -99,   -99,    -8,
     -71,   -71,   -71,   -22,    -7,   -99,    20,   -99,   -98,   -98,
     -99,   -99,   -99,    22,    -3,   118,   -98,   -98,   -98,    -3,
       7,   -99,    -3,   -99,   -99,   118,   -49,   -99,   110,   110,
     110,     3,   110,   110,   110,    10,   110,   110,   -99,   -99,
     -99,   -99,   -99,    39,   -99,   -99,   -99,   -99,   100,    81,
     -99,    82,   231,   287,   -20,   196,    62,   -99,    43,   -99,
     -99,   -99,    96,   -99,   -99,   -99,    37,   -99,   -99,   -99,
     -98,    -3,   -49,    51,   -98,    59,   -44,   -98,   -99,   -99,
     -99,   -99,   -99,    91,   -49,   -98,   126,   126,   -71,   -99,
     -99,   -99,   -99,   -99,   126,   -99,   -99,   -99,   126,   -99,
     -99,   103,   -99,   -99,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   126,   -99,   -99,   -99,   196,    62,   -99,   -99,
     -99,   -99,   196,   110,   207,    39,   -99,   -99,   -49,   -99,
     -99,   126,    60,   -99,   -99,   -99,   -99,    73,   -98,   -99,
      52,   -60,   -23,   -99,   -98,   112,   117,   118,   -45,   -99,
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
      62,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,    90,   -99,    52,   -99,   -99,   -28,
     -48,    -3,   -19,   -99,   -99,   -99,   -99,   -99,   -99,   126,
     -99,   126,   126,   -99,    39,   -99,   126,   -99,   -99,   -99,
     -44,   -99,   -99,    52,    52,   -99,    52,   -99,   -99,   -99,
     -99
};

/* CTL_Y_DEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when CTL_Y_TABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const ctp_y_type_uint8 ctp_y_defact[] =
{
       2,     0,     6,     1,     3,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    10,    11,
      12,     9,    13,    22,    14,     0,     0,   150,    15,     0,
       0,     0,     0,     0,     0,   144,     0,   151,     0,     0,
     148,    56,    57,     0,     0,     0,     0,     0,     0,     0,
       0,   146,     0,     4,    58,     0,    44,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,   120,
     121,   122,   118,     0,    87,    86,   119,    20,    60,    61,
      62,    63,    68,    77,    79,     0,    80,    92,    94,   107,
     104,   105,   106,   129,   130,   131,   128,    17,    18,    19,
       0,     0,    44,    53,     0,     0,     0,     0,    24,    31,
      25,    37,    38,   145,    44,     0,     0,     0,     0,    45,
      46,    99,    98,   100,     0,   101,   102,   103,     0,    97,
      96,     0,   126,   124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   116,   115,   109,   111,   112,   113,
     114,   110,     0,    85,    84,    83,     0,    81,    90,    91,
      89,    88,     0,     0,     0,     0,   132,    27,    44,    29,
      26,     0,     0,    36,    35,    33,    23,     0,     0,    59,
       0,     0,   131,    48,     0,     0,     0,     0,     0,    65,
      67,    76,    64,    69,    72,    71,    70,    66,    75,    78,
      82,    93,    95,   136,   137,   141,   138,   140,   139,   142,
     143,   135,   108,   134,    77,    28,     0,    41,    43,   106,
     128,     0,     0,   147,    21,   149,    47,    52,    51,     0,
      16,     0,     0,   127,     0,   123,     0,    40,    42,    39,
       0,    32,    50,     0,     0,   125,     0,    34,    74,    73,
     133
};

/* CTL_Y_PGOTO[NTERM-NUM].  */
static const ctp_y_type_int16 ctp_y_pgoto[] =
{
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -25,   -99,   -99,   -99,   -99,   -99,   -32,   -99,   -99,
     -99,   -99,   -67,   -99,   -99,   -99,   -99,   -99,   -80,   -99,
     -31,   -79,   -24,   -39,   -99,   -99,   -99,   -99,   -41,   -99,
     -99,   -99,   -99,   144,    41,   -99,   -99,   -99,   -99,   -66,
      18,   -27,   -99,   -99,   -99,   -81,   -99,   -36,    25,   -99,
     -99,   -59,   -99,   -99,   -99,   -99,   -26,    -9,   -37,   -99
};

/* CTL_Y_DEFGOTO[NTERM-NUM].  */
static const ctp_y_type_uint8 ctp_y_defgoto[] =
{
       0,     1,     2,     4,     5,     6,    16,    17,    18,    19,
      20,    46,    21,    22,    23,   107,    24,   100,   101,   108,
     109,   222,   175,   110,   111,   112,   172,   216,   118,   119,
     120,   180,   229,   102,    25,    26,    41,    42,   132,    78,
      79,    80,    81,    82,    83,    84,   156,    85,   162,    86,
      87,    88,    89,   152,    90,    91,   188,   133,    92,    93,
      94,    95,   213,    36,    51,   113,    96,   226,    28,    38
};

/* CTL_Y_TABLE[CTL_Y_PACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If CTL_Y_TABLE_NINF, syntax error.  */
static const ctp_y_type_int16 ctp_y_table[] =
{
      43,    53,    54,    39,    77,    56,    47,    48,   104,    97,
      98,    99,   227,   114,   115,   166,     8,   -54,    57,   157,
     164,     3,   169,   103,   173,   234,    57,   153,     7,    -5,
      27,   121,   122,   123,   178,   125,   126,   127,   183,   129,
     130,    29,    58,    59,    60,    61,    62,    63,    64,    65,
     105,   240,   116,   165,   174,    30,    31,   182,   182,    37,
      32,    44,   168,   167,    33,    34,   117,   170,    35,    45,
     176,    49,    66,   228,   -53,    57,    67,   225,   179,     9,
      10,    11,    12,   212,   154,    68,    50,   117,   215,    52,
     200,    55,   217,   184,   155,    40,    69,    70,    71,   -49,
      40,   144,   145,   225,   124,   -49,   146,    72,   106,   147,
     148,   128,   182,   134,   149,   135,   150,   -49,   136,   163,
     151,    58,    59,    60,    61,    62,    63,    64,    65,    58,
      59,    60,   218,    62,    63,    64,   202,    40,   165,   166,
      73,   224,    13,    74,   164,   220,   233,   230,   131,   -30,
      14,    66,   187,    75,    15,    67,    68,   181,   181,    66,
     171,   177,   227,    67,    68,   158,   221,    69,    70,    71,
      76,   223,    68,   247,   225,    69,    70,    71,    72,   235,
     201,   159,   231,    69,    70,    71,    72,   232,   238,   239,
     236,   160,   161,   199,    72,   103,   219,     0,   245,    58,
      59,    60,     0,    62,    63,    64,   214,   237,    40,     0,
       0,    73,   181,   241,     0,     0,    40,     0,     0,    73,
       0,     0,    74,   228,    40,     0,     0,    73,     0,    66,
      74,     0,    75,    67,   248,   249,     0,   250,     0,     0,
      75,    76,    68,     0,   137,     0,     0,     0,     0,    76,
       0,     0,     0,    69,    70,    71,     0,    76,   138,   139,
     140,     0,     0,   141,    72,   142,     0,   143,   185,     0,
     242,     0,   186,     0,     0,     0,     0,   246,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   203,   204,
     205,   206,   207,   208,    40,     0,     0,    73,   144,   145,
       0,     0,     0,   146,     0,     0,   147,   148,    73,     0,
       0,   149,     0,   150,     0,     0,     0,   151,     0,     0,
       0,     0,   209,   210,     0,     0,     0,    76,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244
};

static const ctp_y_type_int16 ctp_y_check[] =
{
      26,    38,    39,     1,    45,    44,    31,    32,     1,    46,
      47,    48,    72,    52,    55,    96,     1,    15,    44,    85,
      48,     0,   102,    49,    68,    70,    52,    47,    14,    14,
     128,    58,    59,    60,   114,    62,    63,    64,   117,    66,
      67,    98,     3,     4,     5,     6,     7,     8,     9,    10,
      43,    70,   101,   101,    98,    98,    98,   116,   117,    15,
      98,    69,   101,   100,    98,    98,   115,   104,    98,   140,
     107,    93,    33,   133,   122,   101,    37,   122,   115,    64,
      65,    66,    67,   164,   104,    46,    93,   115,   168,    69,
     156,    69,   171,   118,   114,    98,    57,    58,    59,   122,
      98,    11,    12,   122,   101,   128,    16,    68,   101,    19,
      20,   101,   171,    13,    24,    34,    26,   140,    36,    76,
      30,     3,     4,     5,     6,     7,     8,     9,    10,     3,
       4,     5,   171,     7,     8,     9,   163,    98,   101,   220,
     101,   178,   127,   104,    48,   171,   187,   184,   109,    98,
     135,    33,    49,   114,   139,    37,    46,   116,   117,    33,
     101,    70,    72,    37,    46,   103,   106,    57,    58,    59,
     131,    98,    46,   240,   122,    57,    58,    59,    68,   188,
     162,   119,    70,    57,    58,    59,    68,    70,   219,   221,
     214,   129,   130,   152,    68,   221,   171,    -1,   234,     3,
       4,     5,    -1,     7,     8,     9,   165,   216,    98,    -1,
      -1,   101,   171,   222,    -1,    -1,    98,    -1,    -1,   101,
      -1,    -1,   104,   133,    98,    -1,    -1,   101,    -1,    33,
     104,    -1,   114,    37,   243,   244,    -1,   246,    -1,    -1,
     114,   131,    46,    -1,    13,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,    57,    58,    59,    -1,   131,    27,    28,
      29,    -1,    -1,    32,    68,    34,    -1,    36,   124,    -1,
     229,    -1,   128,    -1,    -1,    -1,    -1,   236,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    81,    82,
      83,    84,    85,    86,    98,    -1,    -1,   101,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,   101,    -1,
      -1,    24,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,   115,   116,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,   232
};

/* CTL_Y_STOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const ctp_y_type_uint8 ctp_y_stos[] =
{
       0,   147,   148,     0,   149,   150,   151,    14,     1,    64,
      65,    66,    67,   127,   135,   139,   152,   153,   154,   155,
     156,   158,   159,   160,   162,   180,   181,   128,   214,    98,
      98,    98,    98,    98,    98,    98,   209,    15,   215,     1,
      98,   182,   183,   212,    69,   140,   157,   157,   157,    93,
      93,   210,    69,   214,   214,    69,   179,   212,     3,     4,
       5,     6,     7,     8,     9,    10,    33,    37,    46,    57,
      58,    59,    68,   101,   104,   114,   131,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   195,   196,   197,   198,
     200,   201,   204,   205,   206,   207,   212,   214,   214,   214,
     163,   164,   179,   212,     1,    43,   101,   161,   165,   166,
     169,   170,   171,   211,   179,   184,   101,   115,   174,   175,
     176,   197,   197,   197,   101,   197,   197,   197,   101,   197,
     197,   109,   184,   203,    13,    34,    36,    13,    27,    28,
      29,    32,    34,    36,    11,    12,    16,    19,    20,    24,
      26,    30,   199,    47,   104,   114,   192,   195,   103,   119,
     129,   130,   194,    76,    48,   101,   201,   214,   179,   174,
     214,   101,   172,    68,    98,   168,   214,    70,   174,   214,
     177,   190,   207,   177,   157,   189,   189,    49,   202,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   190,
     195,   196,   197,    81,    82,    83,    84,    85,    86,   115,
     116,   126,   201,   208,   190,   174,   173,   177,   179,   204,
     212,   106,   167,    98,   214,   122,   213,    72,   133,   178,
     214,    70,    70,   184,    70,   213,   178,   213,   176,   163,
      70,   213,   190,   189,   189,   203,   190,   168,   213,   213,
     213
};

/* CTL_Y_R1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const ctp_y_type_uint8 ctp_y_r1[] =
{
       0,   146,   148,   147,   149,   150,   151,   151,   152,   152,
     152,   152,   152,   152,   152,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   161,   161,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   168,   169,   170,   171,
     172,   173,   173,   173,   174,   174,   175,   175,   176,   177,
     177,   178,   178,   179,   180,   181,   181,   182,   182,   183,
     184,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   188,   188,   189,   189,   190,
     191,   191,   191,   192,   192,   192,   193,   193,   194,   194,
     194,   194,   195,   195,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   197,   197,   197,   197,   198,   199,
     199,   199,   199,   199,   199,   199,   199,   200,   200,   200,
     200,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     204,   204,   205,   206,   207,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   210,   209,   211,   211,   212,   213,
     214,   215
};

/* CTL_Y_R2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const ctp_y_type_int8 ctp_y_r2[] =
{
       0,     2,     0,     2,     5,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     7,     4,     4,     4,
       2,     6,     1,     5,     1,     1,     2,     5,     3,     2,
       1,     1,     4,     0,     3,     1,     1,     1,     1,     4,
       3,     1,     2,     1,     0,     1,     1,     3,     2,     1,
       3,     1,     1,     1,     1,     0,     2,     1,     2,     4,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     6,     6,     3,     3,     1,     3,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     0,     3,     1,     3,     1,     1,
       1,     1,     2,     6,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     1,     1,
       1,     1
};


enum { CTL_Y_ENOMEM = -2 };

#define ctp_y_errok         (ctp_y_errstatus = 0)
#define ctp_y_clearin       (ctp_y_char = CTL_Y_EMPTY)

#define CTL_Y_ACCEPT        goto ctp_y_acceptlab
#define CTL_Y_ABORT         goto ctp_y_abortlab
#define CTL_Y_ERROR         goto ctp_y_errorlab
#define CTL_Y_NOMEM         goto ctp_y_exhaustedlab


#define CTL_Y_RECOVERING()  (!!ctp_y_errstatus)

#define CTL_Y_BACKUP(Token, Value)                                    \
  do                                                              \
    if (ctp_y_char == CTL_Y_EMPTY)                                        \
      {                                                           \
        ctp_y_char = (Token);                                         \
        ctp_y_lval = (Value);                                         \
        CTL_Y_POPSTACK (ctp_y_len);                                       \
        ctp_y_state = *ctp_y_ssp;                                         \
        goto ctp_y_backup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        ctp_y_error (CTL_Y__("syntax error: cannot back up")); \
        CTL_Y_ERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use CTL_Y_error or CTL_Y_UNDEF. */
#define CTL_Y_ERRCODE CTL_Y_UNDEF


/* Enable debugging if requested.  */
#if CTL_Y_DEBUG

# ifndef CTL_Y_FPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define CTL_Y_FPRINTF fprintf
# endif

# define CTL_Y_DPRINTF(Args)                        \
do {                                            \
  if (ctp_y_debug)                                  \
    CTL_Y_FPRINTF Args;                             \
} while (0)




# define CTL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (ctp_y_debug)                                                            \
    {                                                                     \
      CTL_Y_FPRINTF (stderr, "%s ", Title);                                   \
      ctp_y__symbol_print (stderr,                                            \
                  Kind, Value); \
      CTL_Y_FPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on CTL_Y_O.  |
`-----------------------------------*/

static void
ctp_y__symbol_value_print (FILE *ctp_y_o,
                       ctp_y_symbol_kind_t ctp_y_kind, CTL_Y_STYPE const * const ctp_y_valuep)
{
  FILE *ctp_y_output = ctp_y_o;
  CTL_Y__USE (ctp_y_output);
  if (!ctp_y_valuep)
    return;
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  CTL_Y__USE (ctp_y_kind);
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on CTL_Y_O.  |
`---------------------------*/

static void
ctp_y__symbol_print (FILE *ctp_y_o,
                 ctp_y_symbol_kind_t ctp_y_kind, CTL_Y_STYPE const * const ctp_y_valuep)
{
  CTL_Y_FPRINTF (ctp_y_o, "%s %s (",
             ctp_y_kind < CTL_Y_NTOKENS ? "token" : "nterm", ctp_y_symbol_name (ctp_y_kind));

  ctp_y__symbol_value_print (ctp_y_o, ctp_y_kind, ctp_y_valuep);
  CTL_Y_FPRINTF (ctp_y_o, ")");
}

/*------------------------------------------------------------------.
| ctp_y__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
ctp_y__stack_print (ctp_y__state_t *ctp_y_bottom, ctp_y__state_t *ctp_y_top)
{
  CTL_Y_FPRINTF (stderr, "Stack now");
  for (; ctp_y_bottom <= ctp_y_top; ctp_y_bottom++)
    {
      int ctp_y_bot = *ctp_y_bottom;
      CTL_Y_FPRINTF (stderr, " %d", ctp_y_bot);
    }
  CTL_Y_FPRINTF (stderr, "\n");
}

# define CTL_Y__STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (ctp_y_debug)                                                  \
    ctp_y__stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the CTL_Y_RULE is going to be reduced.  |
`------------------------------------------------*/

static void
ctp_y__reduce_print (ctp_y__state_t *ctp_y_ssp, CTL_Y_STYPE *ctp_y_vsp,
                 int ctp_y_rule)
{
  int ctp_y_lno = ctp_y_rline[ctp_y_rule];
  int ctp_y_nrhs = ctp_y_r2[ctp_y_rule];
  int ctp_y_i;
  CTL_Y_FPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             ctp_y_rule - 1, ctp_y_lno);
  /* The symbols being reduced.  */
  for (ctp_y_i = 0; ctp_y_i < ctp_y_nrhs; ctp_y_i++)
    {
      CTL_Y_FPRINTF (stderr, "   $%d = ", ctp_y_i + 1);
      ctp_y__symbol_print (stderr,
                       CTL_Y__ACCESSING_SYMBOL (+ctp_y_ssp[ctp_y_i + 1 - ctp_y_nrhs]),
                       &ctp_y_vsp[(ctp_y_i + 1) - (ctp_y_nrhs)]);
      CTL_Y_FPRINTF (stderr, "\n");
    }
}

# define CTL_Y__REDUCE_PRINT(Rule)          \
do {                                    \
  if (ctp_y_debug)                          \
    ctp_y__reduce_print (ctp_y_ssp, ctp_y_vsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int ctp_y_debug;
#else /* !CTL_Y_DEBUG */
# define CTL_Y_DPRINTF(Args) ((void) 0)
# define CTL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)
# define CTL_Y__STACK_PRINT(Bottom, Top)
# define CTL_Y__REDUCE_PRINT(Rule)
#endif /* !CTL_Y_DEBUG */


/* CTL_Y_INITDEPTH -- initial size of the parser's stacks.  */
#ifndef CTL_Y_INITDEPTH
# define CTL_Y_INITDEPTH 200
#endif

/* CTL_Y_MAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   CTL_Y_STACK_ALLOC_MAXIMUM < CTL_Y_STACK_BYTES (CTL_Y_MAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef CTL_Y_MAXDEPTH
# define CTL_Y_MAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
ctp_y_destruct (const char *ctp_y_msg,
            ctp_y_symbol_kind_t ctp_y_kind, CTL_Y_STYPE *ctp_y_valuep)
{
  CTL_Y__USE (ctp_y_valuep);
  if (!ctp_y_msg)
    ctp_y_msg = "Deleting";
  CTL_Y__SYMBOL_PRINT (ctp_y_msg, ctp_y_kind, ctp_y_valuep, ctp_y_locationp);

  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  CTL_Y__USE (ctp_y_kind);
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int ctp_y_char;

/* The semantic value of the lookahead symbol.  */
CTL_Y_STYPE ctp_y_lval;
/* Number of syntax errors so far.  */
int ctp_y_nerrs;




/*----------.
| ctp_y_parse.  |
`----------*/

int
ctp_y_parse (void)
{
    ctp_y__state_fast_t ctp_y_state = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int ctp_y_errstatus = 0;

    /* Refer to the stacks through separate pointers, to allow ctp_y_overflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    CTL_Y_PTRDIFF_T ctp_y_stacksize = CTL_Y_INITDEPTH;

    /* The state stack: array, bottom, top.  */
    ctp_y__state_t ctp_y_ssa[CTL_Y_INITDEPTH];
    ctp_y__state_t *ctp_y_ss = ctp_y_ssa;
    ctp_y__state_t *ctp_y_ssp = ctp_y_ss;

    /* The semantic value stack: array, bottom, top.  */
    CTL_Y_STYPE ctp_y_vsa[CTL_Y_INITDEPTH];
    CTL_Y_STYPE *ctp_y_vs = ctp_y_vsa;
    CTL_Y_STYPE *ctp_y_vsp = ctp_y_vs;

  int ctp_y_n;
  /* The return value of ctp_y_parse.  */
  int ctp_y_result;
  /* Lookahead symbol kind.  */
  ctp_y_symbol_kind_t ctp_y_token = CTL_Y_SYMBOL_CTL_Y_EMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  CTL_Y_STYPE ctp_y_val;



#define CTL_Y_POPSTACK(N)   (ctp_y_vsp -= (N), ctp_y_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int ctp_y_len = 0;

  CTL_Y_DPRINTF ((stderr, "Starting parse\n"));

  ctp_y_char = CTL_Y_EMPTY; /* Cause a token to be read.  */

  goto ctp_y_setstate;


/*------------------------------------------------------------.
| ctp_y_newstate -- push a new state, which is found in ctp_y_state.  |
`------------------------------------------------------------*/
ctp_y_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  ctp_y_ssp++;


/*--------------------------------------------------------------------.
| ctp_y_setstate -- set current state (the top of the stack) to ctp_y_state.  |
`--------------------------------------------------------------------*/
ctp_y_setstate:
  CTL_Y_DPRINTF ((stderr, "Entering state %d\n", ctp_y_state));
  CTL_Y__ASSERT (0 <= ctp_y_state && ctp_y_state < CTL_Y_NSTATES);
  CTL_Y__IGNORE_USELESS_CAST_BEGIN
  *ctp_y_ssp = CTL_Y__CAST (ctp_y__state_t, ctp_y_state);
  CTL_Y__IGNORE_USELESS_CAST_END
  CTL_Y__STACK_PRINT (ctp_y_ss, ctp_y_ssp);

  if (ctp_y_ss + ctp_y_stacksize - 1 <= ctp_y_ssp)
#if !defined ctp_y_overflow && !defined CTL_Y_STACK_RELOCATE
    CTL_Y_NOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      CTL_Y_PTRDIFF_T ctp_y_size = ctp_y_ssp - ctp_y_ss + 1;

# if defined ctp_y_overflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        ctp_y__state_t *ctp_y_ss1 = ctp_y_ss;
        CTL_Y_STYPE *ctp_y_vs1 = ctp_y_vs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if ctp_y_overflow is a macro.  */
        ctp_y_overflow (CTL_Y__("memory exhausted"),
                    &ctp_y_ss1, ctp_y_size * CTL_Y_SIZEOF (*ctp_y_ssp),
                    &ctp_y_vs1, ctp_y_size * CTL_Y_SIZEOF (*ctp_y_vsp),
                    &ctp_y_stacksize);
        ctp_y_ss = ctp_y_ss1;
        ctp_y_vs = ctp_y_vs1;
      }
# else /* defined CTL_Y_STACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (CTL_Y_MAXDEPTH <= ctp_y_stacksize)
        CTL_Y_NOMEM;
      ctp_y_stacksize *= 2;
      if (CTL_Y_MAXDEPTH < ctp_y_stacksize)
        ctp_y_stacksize = CTL_Y_MAXDEPTH;

      {
        ctp_y__state_t *ctp_y_ss1 = ctp_y_ss;
        union ctp_y_alloc *ctp_y_ptr =
          CTL_Y__CAST (union ctp_y_alloc *,
                   CTL_Y_STACK_ALLOC (CTL_Y__CAST (CTL_Y_SIZE_T, CTL_Y_STACK_BYTES (ctp_y_stacksize))));
        if (! ctp_y_ptr)
          CTL_Y_NOMEM;
        CTL_Y_STACK_RELOCATE (ctp_y_ss_alloc, ctp_y_ss);
        CTL_Y_STACK_RELOCATE (ctp_y_vs_alloc, ctp_y_vs);
#  undef CTL_Y_STACK_RELOCATE
        if (ctp_y_ss1 != ctp_y_ssa)
          CTL_Y_STACK_FREE (ctp_y_ss1);
      }
# endif

      ctp_y_ssp = ctp_y_ss + ctp_y_size - 1;
      ctp_y_vsp = ctp_y_vs + ctp_y_size - 1;

      CTL_Y__IGNORE_USELESS_CAST_BEGIN
      CTL_Y_DPRINTF ((stderr, "Stack size increased to %ld\n",
                  CTL_Y__CAST (long, ctp_y_stacksize)));
      CTL_Y__IGNORE_USELESS_CAST_END

      if (ctp_y_ss + ctp_y_stacksize - 1 <= ctp_y_ssp)
        CTL_Y_ABORT;
    }
#endif /* !defined ctp_y_overflow && !defined CTL_Y_STACK_RELOCATE */


  if (ctp_y_state == CTL_Y_FINAL)
    CTL_Y_ACCEPT;

  goto ctp_y_backup;


/*-----------.
| ctp_y_backup.  |
`-----------*/
ctp_y_backup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  ctp_y_n = ctp_y_pact[ctp_y_state];
  if (ctp_y_pact_value_is_default (ctp_y_n))
    goto ctp_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* CTL_Y_CHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (ctp_y_char == CTL_Y_EMPTY)
    {
      CTL_Y_DPRINTF ((stderr, "Reading a token\n"));
      ctp_y_char = ctp_y_lex ();
    }

  if (ctp_y_char <= CTL_Y_EOF)
    {
      ctp_y_char = CTL_Y_EOF;
      ctp_y_token = CTL_Y_SYMBOL_CTL_Y_EOF;
      CTL_Y_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (ctp_y_char == CTL_Y_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      ctp_y_char = CTL_Y_UNDEF;
      ctp_y_token = CTL_Y_SYMBOL_CTL_Y_error;
      goto ctp_y_errlab1;
    }
  else
    {
      ctp_y_token = CTL_Y_TRANSLATE (ctp_y_char);
      CTL_Y__SYMBOL_PRINT ("Next token is", ctp_y_token, &ctp_y_lval, &ctp_y_lloc);
    }

  /* If the proper action on seeing token CTL_Y_TOKEN is to reduce or to
     detect an error, take that action.  */
  ctp_y_n += ctp_y_token;
  if (ctp_y_n < 0 || CTL_Y_LAST < ctp_y_n || ctp_y_check[ctp_y_n] != ctp_y_token)
    goto ctp_y_default;
  ctp_y_n = ctp_y_table[ctp_y_n];
  if (ctp_y_n <= 0)
    {
      if (ctp_y_table_value_is_error (ctp_y_n))
        goto ctp_y_errlab;
      ctp_y_n = -ctp_y_n;
      goto ctp_y_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (ctp_y_errstatus)
    ctp_y_errstatus--;

  /* Shift the lookahead token.  */
  CTL_Y__SYMBOL_PRINT ("Shifting", ctp_y_token, &ctp_y_lval, &ctp_y_lloc);
  ctp_y_state = ctp_y_n;
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++ctp_y_vsp = ctp_y_lval;
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  ctp_y_char = CTL_Y_EMPTY;
  goto ctp_y_newstate;


/*-----------------------------------------------------------.
| ctp_y_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
ctp_y_default:
  ctp_y_n = ctp_y_defact[ctp_y_state];
  if (ctp_y_n == 0)
    goto ctp_y_errlab;
  goto ctp_y_reduce;


/*-----------------------------.
| ctp_y_reduce -- do a reduction.  |
`-----------------------------*/
ctp_y_reduce:
  /* ctp_y_n is the number of a rule to reduce with.  */
  ctp_y_len = ctp_y_r2[ctp_y_n];

  /* If CTL_Y_LEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets CTL_Y_VAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to CTL_Y_VAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that CTL_Y_VAL may be used uninitialized.  */
  ctp_y_val = ctp_y_vsp[1-ctp_y_len];


  CTL_Y__REDUCE_PRINT (ctp_y_n);
  switch (ctp_y_n)
    {
  case 2: /* $@1: %empty  */
#line 278 "./ctp_y.y"
          {
            ctltype_list *CtlType;

            CTP_HEADFIG = addctlfig( CTP_FILENAME );;
            CTP_MODNAM  = CTP_HEADFIG->NAME;
            addctlpredefinedtype( CTP_HEADFIG );

            hshtab = initab ();

            CTP_NM1LST = NULL;
            CTP_INSLST = NULL;
            CTP_LINLST = NULL;
            CTP_VALLST = NULL;

            CTP_ERRFLG    = 0;
            CTP_LINNUM    = 1;
            CTP_NUMTYP    = 0;

            CtlType = CTP_HEADFIG->TYPE;

            while( CtlType )
            {
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_LBLDFN,CtlType->CLASS);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_TYPDFN,CtlType->INDEX);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMNDFN,CtlType->LEFT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMXDFN,CtlType->RIGHT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_PNTDFN,(long)CtlType);

              CtlType = CtlType->NEXT;
            }

            CTP_NUMTYP = VEX_MAX_TYPE;
          }
#line 1932 "y.tab.c"
    break;

  case 3: /* ctl_file: $@1 ctl_body  */
#line 313 "./ctp_y.y"
          {
            fretab( hshtab );
          }
#line 1940 "y.tab.c"
    break;

  case 4: /* ctl_body: ctl_declarative_part _BEGIN ctl_statement_part END_ERR Semicolon_ERR  */
#line 324 "./ctp_y.y"
         {
         }
#line 1947 "y.tab.c"
    break;

  case 15: /* block_declarative_item: error Semicolon_ERR  */
#line 348 "./ctp_y.y"
         {
           my_ctp_error(9,NULL);
         }
#line 1955 "y.tab.c"
    break;

  case 16: /* constant_declaration: _DEFINE Identifier Colon type_mark .constraint. constant_VarAsgn__expression Semicolon_ERR  */
#line 361 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlCst;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (ctp_y_vsp[-1].list).VEX );

          Type = val_type( (ctp_y_vsp[-3].name).NAME );

          if ( ( (ctp_y_vsp[-2].name).LEFT  == -1 ) &&
               ( (ctp_y_vsp[-2].name).RIGHT == -1 ) )
          {
            AttrLeft  = Type->LEFT;
            AttrRight = Type->RIGHT;
          }
          else
          {
            AttrLeft  = (ctp_y_vsp[-2].name).LEFT;
            AttrRight = (ctp_y_vsp[-2].name).RIGHT;
          }

          CtlCst  = (ctldecl_list *)ctp_addstr( 'C',0,val_type((ctp_y_vsp[-3].name).NAME),
                 (ctp_y_vsp[-3].name).TYPE,(ctp_y_vsp[-3].name).FLAG,(ctp_y_vsp[-5].text),AttrLeft,AttrRight,VexValue);

          Signed = ( IsVexNodeSigned( CtlCst->VEX_ATOM ) != 0 );

          {
            if ( IsVexAtomBit( CtlCst->VEX_ATOM ) )
            {
              Left  = -1;
              Right = -1;
            }
            else
            {
              Left  = CtlCst->VEX_ATOM->LEFT;
              Right = CtlCst->VEX_ATOM->RIGHT;
            }
          }

          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_TYPDFN,(ctp_y_vsp[-3].name).TYPE);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlCst->VEX_ATOM);
          addtab(hshtab,(ctp_y_vsp[-5].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2014 "y.tab.c"
    break;

  case 17: /* assumption_declaration: _ASSUME Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 422 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (ctp_y_vsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'A',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (ctp_y_vsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2053 "y.tab.c"
    break;

  case 18: /* initial_declaration: _INITIAL Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 463 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (ctp_y_vsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'I',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (ctp_y_vsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2092 "y.tab.c"
    break;

  case 19: /* reset_cond_declaration: _RESET_COND Identifier constant_VarAsgn__expression Semicolon_ERR  */
#line 504 "./ctp_y.y"
        {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          short          Signed;
          long           Left;
          long           Right;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (ctp_y_vsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'R',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (ctp_y_vsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2131 "y.tab.c"
    break;

  case 20: /* constant_VarAsgn__expression: VarAsgn expression  */
#line 544 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2137 "y.tab.c"
    break;

  case 21: /* variable_declaration: _VARIABLE identifier_list Colon type_mark .constraint. Semicolon_ERR  */
#line 554 "./ctp_y.y"
          {
            char         *LocalName;
            char         *signame;
            ctltype_list *Type;
            ctldecl_list *CtlVar;
            short         Signed;
            long          Left;
            long          Right;
            long          AttrLeft;
            long          AttrRight;

            LocalName = CTP_MODNAM;
            Type  = val_type( (ctp_y_vsp[-2].name).NAME );

            if ( ( (ctp_y_vsp[-1].name).LEFT  == -1 ) &&
                 ( (ctp_y_vsp[-1].name).RIGHT == -1 ) )
            {
              AttrLeft  = Type->LEFT;
              AttrRight = Type->RIGHT;
            }
            else
            {
              AttrLeft  = (ctp_y_vsp[-1].name).LEFT;
              AttrRight = (ctp_y_vsp[-1].name).RIGHT;
            }

            CTP_NM1LST = reverse (CTP_NM1LST);

            while (CTP_NM1LST != NULL)
            {
              signame = (char *)CTP_NM1LST->DATA;
              if (chktab (hshtab,signame,LocalName,CTP_SYMDFN) != 0)
                  my_ctp_error (80,signame);

              CtlVar = (ctldecl_list *)ctp_addstr( 'V', 0,
                      val_type((ctp_y_vsp[-2].name).NAME),(ctp_y_vsp[-2].name).TYPE,
                      (ctp_y_vsp[-2].name).FLAG,signame, AttrLeft, AttrRight, NULL );

              Signed = ( IsVexNodeSigned( CtlVar->VEX_ATOM ) != 0 );

              if ( IsVexAtomBit( CtlVar->VEX_ATOM ) )
              {
                Left  = -1;
                Right = -1;
              }
              else
              {
                Left  = CtlVar->VEX_ATOM->LEFT;
                Right = CtlVar->VEX_ATOM->RIGHT;
              }

              addtab (hshtab,signame,LocalName,CTP_SYMDFN,CTP_VARDFN);
              addtab (hshtab,signame,LocalName,CTP_TYPDFN,(ctp_y_vsp[-2].name).TYPE);
              addtab (hshtab,signame,LocalName,CTP_WMNDFN,Left);
              addtab (hshtab,signame,LocalName,CTP_WMXDFN,Right);
              addtab (hshtab,signame,LocalName,CTP_ATLDFN,AttrLeft);
              addtab (hshtab,signame,LocalName,CTP_ATRDFN,AttrRight);
              addtab (hshtab,signame,LocalName,CTP_LBLDFN,0);
              addtab (hshtab,signame,LocalName,CTP_PNTDFN,(long)CtlVar->VEX_ATOM);
              addtab (hshtab,signame,LocalName,CTP_SUNDFN,Signed);

              CTP_NM1LST = delchain (CTP_NM1LST,CTP_NM1LST);
            }
          }
#line 2206 "y.tab.c"
    break;

  case 23: /* full_type_declaration: _TYPE Identifier IS type_definition Semicolon_ERR  */
#line 631 "./ctp_y.y"
          {
           ctltype_list *CtlType;

           CtlType = addctltype( CTP_HEADFIG,(ctp_y_vsp[-3].text), CTP_NUMTYP, (ctp_y_vsp[-1].type).LEFT,
               (ctp_y_vsp[-1].type).RIGHT,(ctp_y_vsp[-1].type).SIZE,(ctp_y_vsp[-1].type).VALUE, (ctp_y_vsp[-1].type).CLASS, (ctp_y_vsp[-1].type).BASE );
           addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);

           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(ctp_y_vsp[-1].type).CLASS);
           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(ctp_y_vsp[-1].type).LEFT);
           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(ctp_y_vsp[-1].type).RIGHT);
           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlType );
           CTP_NUMTYP++;
         }
#line 2226 "y.tab.c"
    break;

  case 24: /* type_definition: scalar_type_definition  */
#line 650 "./ctp_y.y"
              { (ctp_y_val.type) = (ctp_y_vsp[0].type); }
#line 2232 "y.tab.c"
    break;

  case 25: /* type_definition: composite_type_definition  */
#line 652 "./ctp_y.y"
              { (ctp_y_val.type) = (ctp_y_vsp[0].type); }
#line 2238 "y.tab.c"
    break;

  case 26: /* type_definition: error Semicolon_ERR  */
#line 654 "./ctp_y.y"
              { ctp_y_errok; }
#line 2244 "y.tab.c"
    break;

  case 27: /* subtype_declaration: SUBTYPE Identifier IS subtype_indication Semicolon_ERR  */
#line 663 "./ctp_y.y"
          {
            ctltype_list *CtlType;

            CtlType = addctltype(CTP_HEADFIG,(ctp_y_vsp[-3].text),(ctp_y_vsp[-1].type).INDEX,(ctp_y_vsp[-1].type).LEFT,
                   (ctp_y_vsp[-1].type).RIGHT, (ctp_y_vsp[-1].type).SIZE, (ctp_y_vsp[-1].type).VALUE, (ctp_y_vsp[-1].type).CLASS,(ctp_y_vsp[-1].type).BASE );
            addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(ctp_y_vsp[-1].type).CLASS);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_TYPDFN,(ctp_y_vsp[-1].type).INDEX);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(ctp_y_vsp[-1].type).LEFT);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(ctp_y_vsp[-1].type).RIGHT);
            addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE);
            CTP_NUMTYP++;
          }
#line 2263 "y.tab.c"
    break;

  case 28: /* subtype_indication: type_or_function_name type_mark .constraint.  */
#line 683 "./ctp_y.y"
         {
           ctltype_list *ctltype_pnt;
  
           /*mode = */chktab(hshtab,(ctp_y_vsp[-2].text),CTP_MODNAM,CTP_SYMDFN);

           ctltype_pnt = (ctltype_list *)chktab(hshtab,(ctp_y_vsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (ctp_y_val.type).NAME = NULL;
           (ctp_y_val.type).BASE = ctltype_pnt;
           (ctp_y_val.type).VALUE = NULL ;
           (ctp_y_val.type).SIZE = 0 ;
           (ctp_y_val.type).INDEX = CTP_NUMTYP;
           (ctp_y_val.type).LEFT  = (ctp_y_vsp[0].name).LEFT ;
           (ctp_y_val.type).RIGHT = (ctp_y_vsp[0].name).RIGHT ;
           (ctp_y_val.type).CLASS = (ctp_y_vsp[0].name).FLAG ;
         }
#line 2284 "y.tab.c"
    break;

  case 29: /* subtype_indication: type_mark .constraint.  */
#line 701 "./ctp_y.y"
         {
           ctltype_list *ctltype_pnt;
  
           ctltype_pnt = (ctltype_list *)chktab(hshtab,(ctp_y_vsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (ctp_y_val.type).NAME = NULL;
           (ctp_y_val.type).BASE = ctltype_pnt;
           (ctp_y_val.type).VALUE = NULL ;
           (ctp_y_val.type).SIZE = 0 ;
           (ctp_y_val.type).INDEX = CTP_NUMTYP;
           (ctp_y_val.type).CLASS = (ctp_y_vsp[0].name).FLAG;

           (ctp_y_val.type).LEFT    = (ctp_y_vsp[0].name).LEFT ;
           (ctp_y_val.type).RIGHT   = (ctp_y_vsp[0].name).RIGHT ;
        }
#line 2304 "y.tab.c"
    break;

  case 30: /* type_or_function_name: simple_name  */
#line 720 "./ctp_y.y"
          { (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 2310 "y.tab.c"
    break;

  case 31: /* scalar_type_definition: enumeration_type_definition  */
#line 726 "./ctp_y.y"
          {
            (ctp_y_val.type) = (ctp_y_vsp[0].type);
          }
#line 2318 "y.tab.c"
    break;

  case 32: /* enumeration_type_definition: LeftParen enumeration_literal ...enumeration_literal.. RightParen_ERR  */
#line 735 "./ctp_y.y"
          {
              char *enumname;
              long  size;
              long  indice;
              char **pnt;
              chain_list *nm1lst;

              CTP_NM1LST = reverse (CTP_NM1LST);

              nm1lst = CTP_NM1LST;
              size   = 0;

              while (nm1lst != NULL)
              {
                size++;
                nm1lst = nm1lst->NEXT;
              }

              pnt = (char **) autallocblock(size * sizeof(char*));

              indice = 0;

              while (CTP_NM1LST != NULL)
              {
                enumname = (char *)CTP_NM1LST->DATA;

                if (chktab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN) != 0)
                  my_ctp_error (82,enumname);

                addtab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMNDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMXDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_LBLDFN,indice);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_PNTDFN,(long)pnt);
                
                pnt[indice++] = enumname;
                CTP_NM1LST = delchain (CTP_NM1LST, CTP_NM1LST);
              }

              (ctp_y_val.type).VALUE = pnt ;
              (ctp_y_val.type).SIZE = size ;
              (ctp_y_val.type).LEFT = -1 ;
              (ctp_y_val.type).RIGHT = -1 ;
              (ctp_y_val.type).INDEX = CTP_NUMTYP;
              (ctp_y_val.type).CLASS = 'E' ;
              (ctp_y_val.type).BASE = 0 ;
        }
#line 2371 "y.tab.c"
    break;

  case 34: /* ...enumeration_literal..: ...enumeration_literal.. Comma enumeration_literal  */
#line 791 "./ctp_y.y"
                { ctp_y_errok; }
#line 2377 "y.tab.c"
    break;

  case 35: /* enumeration_literal: Identifier  */
#line 796 "./ctp_y.y"
          {
            CTP_NM1LST = addchain (CTP_NM1LST,(ctp_y_vsp[0].text));
          }
#line 2385 "y.tab.c"
    break;

  case 36: /* enumeration_literal: CharacterLit  */
#line 800 "./ctp_y.y"
          {
            CTP_NM1LST = addchain (CTP_NM1LST,(ctp_y_vsp[0].text));
          }
#line 2393 "y.tab.c"
    break;

  case 37: /* composite_type_definition: array_type_definition  */
#line 807 "./ctp_y.y"
          {
            (ctp_y_val.type) = (ctp_y_vsp[0].type);
          }
#line 2401 "y.tab.c"
    break;

  case 38: /* array_type_definition: constrained_array_definition  */
#line 814 "./ctp_y.y"
              { (ctp_y_val.type) = (ctp_y_vsp[0].type); }
#line 2407 "y.tab.c"
    break;

  case 39: /* constrained_array_definition: ARRAY index_constraint OF subtype_indication  */
#line 822 "./ctp_y.y"
          {
            ctltype_list *NewType;
            char       *name;
            char        buffer[ 32 ];

            (ctp_y_val.type) = (ctp_y_vsp[0].type);

            if ( (ctp_y_vsp[0].type).CLASS == 'U' )
            {
              if ( (ctp_y_vsp[0].type).BASE->CLASS != 'A' )
              {
                my_ctp_error(123,NULL);
              }
            }
            else
            if ( (ctp_y_vsp[0].type).CLASS == 'A' )
            {
              if ( (ctp_y_vsp[0].type).BASE->CLASS != 'U' )
              {
                my_ctp_error(123,NULL);
              }

              sprintf( buffer, "_subtype_%ld", CTP_NUMTYP );
              name = namealloc( buffer );

              NewType = addctltype(CTP_HEADFIG,name,(ctp_y_vsp[0].type).INDEX, (ctp_y_vsp[0].type).LEFT,
                   (ctp_y_vsp[0].type).RIGHT,(ctp_y_vsp[0].type).SIZE,(ctp_y_vsp[0].type).VALUE,(ctp_y_vsp[0].type).CLASS,(ctp_y_vsp[0].type).BASE );
              addctlline( CTP_HEADFIG, &NewType->LINE, CTP_LINNUM);
              addtab(hshtab,name,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,name,CTP_MODNAM,CTP_LBLDFN,(ctp_y_vsp[0].type).CLASS);
              addtab(hshtab,name,CTP_MODNAM,CTP_TYPDFN,(ctp_y_vsp[0].type).INDEX);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMNDFN,(ctp_y_vsp[0].type).LEFT);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMXDFN,(ctp_y_vsp[0].type).RIGHT);
              addtab(hshtab,name,CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE );
              CTP_NUMTYP++;

              (ctp_y_val.type).BASE = NewType;
            }
            else
            {
              my_ctp_error(123,NULL);
            }

            (ctp_y_val.type).CLASS = 'A';
            (ctp_y_val.type).INDEX = (ctp_y_vsp[-2].name).TYPE;

            (ctp_y_val.type).LEFT  = (ctp_y_vsp[-2].name).LEFT;
            (ctp_y_val.type).RIGHT = (ctp_y_vsp[-2].name).RIGHT;
          }
#line 2461 "y.tab.c"
    break;

  case 40: /* index_constraint: LeftParen discrete_range RightParen_ERR  */
#line 877 "./ctp_y.y"
         { (ctp_y_val.name) = (ctp_y_vsp[-1].name);}
#line 2467 "y.tab.c"
    break;

  case 41: /* discrete_range: range  */
#line 882 "./ctp_y.y"
         { (ctp_y_val.name) = (ctp_y_vsp[0].name);}
#line 2473 "y.tab.c"
    break;

  case 42: /* discrete_range: name range_constraint  */
#line 885 "./ctp_y.y"
         { (ctp_y_val.name) = (ctp_y_vsp[0].name);
           (ctp_y_val.name).NAME = (ctp_y_vsp[-1].name).NAME;
         }
#line 2481 "y.tab.c"
    break;

  case 43: /* discrete_range: type_mark  */
#line 890 "./ctp_y.y"
         { (ctp_y_val.name) = (ctp_y_vsp[0].name);}
#line 2487 "y.tab.c"
    break;

  case 44: /* .constraint.: %empty  */
#line 895 "./ctp_y.y"
        {
          (ctp_y_val.name).FLAG   = 'U';
          (ctp_y_val.name).LEFT   = -1;
          (ctp_y_val.name).RIGHT  = -1;
        }
#line 2497 "y.tab.c"
    break;

  case 45: /* .constraint.: constraint  */
#line 901 "./ctp_y.y"
        { 
          (ctp_y_val.name) = (ctp_y_vsp[0].name);
        }
#line 2505 "y.tab.c"
    break;

  case 46: /* constraint: range_constraint  */
#line 908 "./ctp_y.y"
         { 
           (ctp_y_val.name) = (ctp_y_vsp[0].name);
         }
#line 2513 "y.tab.c"
    break;

  case 47: /* constraint: LeftParen range RightParen_ERR  */
#line 915 "./ctp_y.y"
         {
           (ctp_y_val.name) = (ctp_y_vsp[-1].name);
         }
#line 2521 "y.tab.c"
    break;

  case 48: /* range_constraint: _RANGE range  */
#line 923 "./ctp_y.y"
         { (ctp_y_val.name) = (ctp_y_vsp[0].name); }
#line 2527 "y.tab.c"
    break;

  case 49: /* range: attribute_name  */
#line 928 "./ctp_y.y"
         {
           if ( ( (ctp_y_vsp[0].name).FLAG != CTP_RANGE     ) &&
                ( (ctp_y_vsp[0].name).FLAG != CTP_REV_RANGE ) )
           {
             my_ctp_error (32,NULL);
           }

           (ctp_y_val.name) = (ctp_y_vsp[0].name);
         }
#line 2541 "y.tab.c"
    break;

  case 50: /* range: simple_expression direction simple_expression  */
#line 940 "./ctp_y.y"
         {
           long Left;
           long Right;
           long ErrorL;
           long  ErrorR;

           ErrorL = ctp_vextonum( (ctp_y_vsp[-2].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (ctp_y_vsp[0].list).VEX, &Right );

           (ctp_y_val.name).NAME   = NULL;
           (ctp_y_val.name).TYPE   = (ctp_y_vsp[-2].list).TYPE;
           (ctp_y_val.name).SIGNED = 0;
           (ctp_y_val.name).FLAG   = 'A';

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((ctp_y_vsp[-1].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((ctp_y_vsp[-1].valu) == CTP_DWTDFN)))
             {
               my_ctp_error (32,NULL);
             }

             (ctp_y_val.name).LEFT   = Left;
             (ctp_y_val.name).RIGHT  = Right;
           }
           else
           {
             (ctp_y_val.name).LEFT    = (long)(ctp_y_vsp[-2].list).VEX;
             (ctp_y_val.name).RIGHT   = (long)(ctp_y_vsp[0].list).VEX;
           }
         }
#line 2577 "y.tab.c"
    break;

  case 51: /* direction: TO  */
#line 975 "./ctp_y.y"
                { (ctp_y_val.valu) = CTP_UPTDFN; }
#line 2583 "y.tab.c"
    break;

  case 52: /* direction: DOWNTO  */
#line 977 "./ctp_y.y"
                { (ctp_y_val.valu) = CTP_DWTDFN; }
#line 2589 "y.tab.c"
    break;

  case 53: /* type_mark: simple_name  */
#line 984 "./ctp_y.y"
           {
              long type;
              (ctp_y_val.name).NAME = (ctp_y_vsp[0].text);
              (ctp_y_val.name).LEFT = -1;
              (ctp_y_val.name).RIGHT = -1;
              (ctp_y_val.name).TYPE = chktab(hshtab,(ctp_y_vsp[0].text),CTP_MODNAM,CTP_TYPDFN);
              (ctp_y_val.name).FLAG = chktab(hshtab,(ctp_y_vsp[0].text),CTP_MODNAM,CTP_LBLDFN);
              type = chktab(hshtab,(ctp_y_vsp[0].text),CTP_MODNAM,CTP_SYMDFN);

              if (type != CTP_TPEDFN || (ctp_y_val.name).TYPE ==0)
              {
                my_ctp_error(84,(ctp_y_vsp[0].text));
              }
          }
#line 2608 "y.tab.c"
    break;

  case 58: /* concurrent_statement: error Semicolon_ERR  */
#line 1014 "./ctp_y.y"
                { my_ctp_error (18,NULL); }
#line 2614 "y.tab.c"
    break;

  case 59: /* formula_assignment_statement: simple_name Colon expression Semicolon_ERR  */
#line 1022 "./ctp_y.y"
         {
           ctlform_list *CtlForm;
           vexexpr      *VexForm;

           VexForm = simpvexexpr( (ctp_y_vsp[-1].list).VEX );

           if (chktab (hshtab,(ctp_y_vsp[-3].text), CTP_MODNAM,CTP_SYMDFN) != 0)
           {
             my_ctp_error (80,(ctp_y_vsp[-3].text));
           }

           CtlForm = addctlform( CTP_HEADFIG, (ctp_y_vsp[-3].text), VexForm );
           addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM);

           addtab(hshtab,(ctp_y_vsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_LABDFN);
         }
#line 2635 "y.tab.c"
    break;

  case 60: /* expression: relation..AND__relation..  */
#line 1042 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2641 "y.tab.c"
    break;

  case 61: /* expression: relation..OR__relation..  */
#line 1044 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2647 "y.tab.c"
    break;

  case 62: /* expression: relation.NAND_NOR_NXOR_relation.  */
#line 1046 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2653 "y.tab.c"
    break;

  case 63: /* expression: relation..XOR__relation..  */
#line 1048 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2659 "y.tab.c"
    break;

  case 64: /* relation..AND__relation..: relation tok_AND relation  */
#line 1055 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_AND ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2667 "y.tab.c"
    break;

  case 65: /* relation..AND__relation..: relation..AND__relation.. tok_AND relation  */
#line 1061 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_AND ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2675 "y.tab.c"
    break;

  case 66: /* relation..OR__relation..: relation _OR relation  */
#line 1070 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_OR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2683 "y.tab.c"
    break;

  case 67: /* relation..OR__relation..: relation..OR__relation.. _OR relation  */
#line 1076 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_OR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2691 "y.tab.c"
    break;

  case 68: /* relation.NAND_NOR_NXOR_relation.: relation  */
#line 1083 "./ctp_y.y"
         { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2697 "y.tab.c"
    break;

  case 69: /* relation.NAND_NOR_NXOR_relation.: relation _NAND relation  */
#line 1087 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_NAND ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2705 "y.tab.c"
    break;

  case 70: /* relation.NAND_NOR_NXOR_relation.: relation _NOR relation  */
#line 1093 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_NOR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2713 "y.tab.c"
    break;

  case 71: /* relation.NAND_NOR_NXOR_relation.: relation _NXOR relation  */
#line 1099 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_NXOR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2721 "y.tab.c"
    break;

  case 72: /* relation.NAND_NOR_NXOR_relation.: relation _IFT relation  */
#line 1105 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_IFT,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2729 "y.tab.c"
    break;

  case 73: /* relation.NAND_NOR_NXOR_relation.: _EU LeftParen relation Comma relation RightParen_ERR  */
#line 1114 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_EU,(ctp_y_vsp[-3].list) ,(ctp_y_vsp[-1].list) ,-1,-1);
         }
#line 2737 "y.tab.c"
    break;

  case 74: /* relation.NAND_NOR_NXOR_relation.: _AU LeftParen relation Comma relation RightParen_ERR  */
#line 1123 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex (VEX_AU,(ctp_y_vsp[-3].list) ,(ctp_y_vsp[-1].list) ,-1,-1);
         }
#line 2745 "y.tab.c"
    break;

  case 75: /* relation..XOR__relation..: relation _XOR relation  */
#line 1132 "./ctp_y.y"
         {
           (ctp_y_val.list) = ctp_crtvex (VEX_XOR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2753 "y.tab.c"
    break;

  case 76: /* relation..XOR__relation..: relation..XOR__relation.. _XOR relation  */
#line 1138 "./ctp_y.y"
         {
           (ctp_y_val.list) = ctp_crtvex (VEX_XOR ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2761 "y.tab.c"
    break;

  case 77: /* relation: simple_expression  */
#line 1145 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2767 "y.tab.c"
    break;

  case 78: /* relation: simple_expression relational_operator simple_expression  */
#line 1149 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex ((ctp_y_vsp[-1].valu) ,(ctp_y_vsp[-2].list) ,(ctp_y_vsp[0].list) ,-1,-1);
         }
#line 2775 "y.tab.c"
    break;

  case 79: /* simple_expression: .sign.term..add_op__term..  */
#line 1156 "./ctp_y.y"
                { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2781 "y.tab.c"
    break;

  case 80: /* .sign.term..add_op__term..: term  */
#line 1161 "./ctp_y.y"
          { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2787 "y.tab.c"
    break;

  case 81: /* .sign.term..add_op__term..: sign term  */
#line 1164 "./ctp_y.y"
          {
             if ( (ctp_y_vsp[-1].valu) == VEX_NEG )
             {
               (ctp_y_val.list) = ctp_crtvex( VEX_NEG,(ctp_y_vsp[0].list),NULL,-1,-1);
             }
             else
             {
               (ctp_y_val.list) = (ctp_y_vsp[0].list);
             }
          }
#line 2802 "y.tab.c"
    break;

  case 82: /* .sign.term..add_op__term..: .sign.term..add_op__term.. adding_operator term  */
#line 1177 "./ctp_y.y"
          {
            (ctp_y_val.list) = ctp_crtvex((ctp_y_vsp[-1].valu),(ctp_y_vsp[-2].list),(ctp_y_vsp[0].list),-1,-1);
          }
#line 2810 "y.tab.c"
    break;

  case 83: /* adding_operator: Plus  */
#line 1184 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_ADD; }
#line 2816 "y.tab.c"
    break;

  case 84: /* adding_operator: Minus  */
#line 1186 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_SUB; }
#line 2822 "y.tab.c"
    break;

  case 85: /* adding_operator: Ampersand  */
#line 1188 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_CONCAT; }
#line 2828 "y.tab.c"
    break;

  case 86: /* sign: Plus  */
#line 1192 "./ctp_y.y"
               { (ctp_y_val.valu) = 0; }
#line 2834 "y.tab.c"
    break;

  case 87: /* sign: Minus  */
#line 1194 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_NEG; }
#line 2840 "y.tab.c"
    break;

  case 88: /* multiplying_operator: Star  */
#line 1199 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_MUL; }
#line 2846 "y.tab.c"
    break;

  case 89: /* multiplying_operator: Slash  */
#line 1201 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_DIV; }
#line 2852 "y.tab.c"
    break;

  case 90: /* multiplying_operator: MOD  */
#line 1203 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_MOD; }
#line 2858 "y.tab.c"
    break;

  case 91: /* multiplying_operator: REM  */
#line 1205 "./ctp_y.y"
               { (ctp_y_val.valu) = VEX_REM; }
#line 2864 "y.tab.c"
    break;

  case 92: /* term: factor  */
#line 1210 "./ctp_y.y"
         { (ctp_y_val.list) = (ctp_y_vsp[0].list); }
#line 2870 "y.tab.c"
    break;

  case 93: /* term: term multiplying_operator factor  */
#line 1214 "./ctp_y.y"
         {
           (ctp_y_val.list) = ctp_crtvex( (ctp_y_vsp[-1].valu), (ctp_y_vsp[-2].list), (ctp_y_vsp[0].list),-1,-1);
         }
#line 2878 "y.tab.c"
    break;

  case 94: /* factor: primary  */
#line 1221 "./ctp_y.y"
         {
           (ctp_y_val.list) = (ctp_y_vsp[0].list);
         }
#line 2886 "y.tab.c"
    break;

  case 95: /* factor: primary DoubleStar primary  */
#line 1227 "./ctp_y.y"
         {
           (ctp_y_val.list) = ctp_crtvex( VEX_EXP,(ctp_y_vsp[-2].list),(ctp_y_vsp[0].list),-1,-1);
         }
#line 2894 "y.tab.c"
    break;

  case 96: /* factor: ABS primary  */
#line 1232 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_ABS,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1); 
         }
#line 2902 "y.tab.c"
    break;

  case 97: /* factor: _NOT primary  */
#line 1237 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_NOT,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2910 "y.tab.c"
    break;

  case 98: /* factor: _AG primary  */
#line 1242 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_AG,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2918 "y.tab.c"
    break;

  case 99: /* factor: _AF primary  */
#line 1247 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_AF,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2926 "y.tab.c"
    break;

  case 100: /* factor: _AX primary  */
#line 1252 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_AX,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2934 "y.tab.c"
    break;

  case 101: /* factor: _EF primary  */
#line 1257 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_EF,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2942 "y.tab.c"
    break;

  case 102: /* factor: _EG primary  */
#line 1262 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_EG,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2950 "y.tab.c"
    break;

  case 103: /* factor: _EX primary  */
#line 1267 "./ctp_y.y"
         { 
           (ctp_y_val.list) = ctp_crtvex( VEX_EX,(ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2958 "y.tab.c"
    break;

  case 104: /* primary: literal  */
#line 1274 "./ctp_y.y"
        {
           struct ctp_expr expr1;

           expr1.IDENT = (ctp_y_vsp[0].text);
           expr1.TYPE  = -1;
           expr1.VEX   = (vexexpr *)0;

           (ctp_y_val.list) = ctp_crtvex( NOPS,expr1,CTP_EMPSTR,-1,-1);
        }
#line 2972 "y.tab.c"
    break;

  case 105: /* primary: aggregate  */
#line 1284 "./ctp_y.y"
        {
            ctp_vexstr *VexStr;
            chain_list *ScanChain;

            ScanChain = (ctp_y_vsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            if ( ScanChain->NEXT == (chain_list *)0 )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              (ctp_y_val.list) = *VexStr;

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
            else
            {
              (ctp_y_val.list).IDENT  = (char *)(ctp_y_vsp[0].pcha);
              (ctp_y_val.list).AGGREG = 1;
            }
        }
#line 3003 "y.tab.c"
    break;

  case 106: /* primary: name  */
#line 1311 "./ctp_y.y"
        {
          struct ctp_expr expr1;
          char           *LocalName;
          char            Buffer[ 40 ];
          long            left;
          long            right;
          long             mode;
          long             flag;

          flag = (ctp_y_vsp[0].name).FLAG;

          if ( ( flag != 0          ) &&
               ( flag != CTP_EVENT  ) &&
               ( flag != CTP_STABLE ) )
          {
            if ( ( flag != CTP_RANGE     ) &&
                 ( flag != CTP_REV_RANGE ) )
            {
              {
                sprintf( Buffer, "%ld", (ctp_y_vsp[0].name).LEFT );

                expr1.IDENT = Buffer;
                expr1.VEX   = (vexexpr *)0;
                expr1.TYPE  = -1;

                (ctp_y_val.list) = ctp_crtvex( NOPS, expr1, CTP_EMPSTR, -1, -1);
              }
            }
            else
            {
              autexit( 1 );
            }
          }
          else
          if ( ( (ctp_y_vsp[0].name).NAME[0] == '"' ) ||
               ( (ctp_y_vsp[0].name).NAME[0] == '\'') )
          {
            expr1.IDENT = (ctp_y_vsp[0].name).NAME;
            expr1.VEX   = (vexexpr *)0;
            expr1.TYPE  = -1;

            (ctp_y_val.list) = ctp_crtvex( NOPS ,expr1, CTP_EMPSTR, -1, -1); /* as for literal */
          }
          else
          {
            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(ctp_y_vsp[0].name).NAME,LocalName,CTP_SYMDFN);

            if( mode == 0 )
            {
              my_ctp_error (17,(ctp_y_vsp[0].name).NAME);
            }

            /*left_bnd  =*/ chktab (hshtab,(ctp_y_vsp[0].name).NAME,LocalName,CTP_WMNDFN);
            /*right_bnd =*/ chktab (hshtab,(ctp_y_vsp[0].name).NAME,LocalName,CTP_WMXDFN);
              
            left  = (ctp_y_vsp[0].name).LEFT;
            right = (ctp_y_vsp[0].name).RIGHT;

            {
              long  type;

              expr1.IDENT = (ctp_y_vsp[0].name).NAME;
              type = chktab(hshtab,(ctp_y_vsp[0].name).NAME,LocalName,CTP_TYPDFN);
              expr1.TYPE = type;
              expr1.SIGNED = chktab (hshtab,(ctp_y_vsp[0].name).NAME,LocalName,CTP_SUNDFN);

              {
                expr1 = ctp_crtvex (NOPI,expr1,CTP_EMPSTR,left,right);
              }

              if( flag == CTP_EVENT )
              {
                (ctp_y_val.list) = ctp_crtvex (VEX_EVENT,expr1,CTP_EMPSTR,left,right);
              }
              else
              if( flag == CTP_STABLE )
              {
                expr1 = ctp_crtvex(VEX_EVENT,expr1,CTP_EMPSTR,left,right);
                (ctp_y_val.list)    = ctp_crtvex (VEX_NOT,expr1,CTP_EMPSTR,-1,-1);
              }
              else
              {
                (ctp_y_val.list) = expr1;
              }
            }
          }
        }
#line 3096 "y.tab.c"
    break;

  case 107: /* primary: qualified_expression  */
#line 1400 "./ctp_y.y"
        {
          struct ctp_expr expr1;

          expr1.IDENT  = (ctp_y_vsp[0].name).NAME;
          expr1.TYPE   = (ctp_y_vsp[0].name).TYPE;
          expr1.SIGNED = (ctp_y_vsp[0].name).SIGNED;
          expr1.VEX    = (vexexpr *)(ctp_y_vsp[0].name).LEFT;

          expr1 = ctp_crtvex(SUBVAR,expr1,CTP_EMPSTR,expr1.VEX->LEFT,expr1.VEX->RIGHT);

          (ctp_y_val.list) = expr1;
        }
#line 3113 "y.tab.c"
    break;

  case 108: /* qualified_expression: name Apostrophe aggregate  */
#line 1418 "./ctp_y.y"
          {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            long        Def;

            ScanChain = (ctp_y_vsp[0].pcha);

            if ( ( ScanChain       == (chain_list *)0 ) ||
                 ( ScanChain->NEXT != (chain_list *)0 ) )
            {
              my_ctp_error(122,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_SYMDFN);

            if ( Def == CTP_TPEDFN )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              VexExpr = createvexfunc( (ctp_y_vsp[-2].name).NAME, VexStr->VEX->WIDTH );
              addvexhexpr( VexExpr, VexStr->VEX );

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              (ctp_y_val.name).NAME    = (ctp_y_vsp[-2].name).NAME;
              (ctp_y_val.name).TYPE    = chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_TYPDFN);
              (ctp_y_val.name).SIGNED  = chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_SUNDFN);
              (ctp_y_val.name).FLAG    = 0;
              (ctp_y_val.name).LEFT    = (long)VexExpr;
              (ctp_y_val.name).RIGHT   = 0;

              freechain( (ctp_y_vsp[0].pcha) );
            }
            else
            {
              my_ctp_error(122, (ctp_y_vsp[-2].name).NAME);
            }
          }
#line 3159 "y.tab.c"
    break;

  case 109: /* relational_operator: _EQSym  */
#line 1463 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_EQ; }
#line 3165 "y.tab.c"
    break;

  case 110: /* relational_operator: _NESym  */
#line 1465 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_NE; }
#line 3171 "y.tab.c"
    break;

  case 111: /* relational_operator: _GESym  */
#line 1467 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_GE; }
#line 3177 "y.tab.c"
    break;

  case 112: /* relational_operator: _GTSym  */
#line 1469 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_GT; }
#line 3183 "y.tab.c"
    break;

  case 113: /* relational_operator: _LESym  */
#line 1471 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_LE; }
#line 3189 "y.tab.c"
    break;

  case 114: /* relational_operator: _LTSym  */
#line 1473 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_LT; }
#line 3195 "y.tab.c"
    break;

  case 115: /* relational_operator: Equiv  */
#line 1475 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_EQUIV; }
#line 3201 "y.tab.c"
    break;

  case 116: /* relational_operator: Imply  */
#line 1477 "./ctp_y.y"
              { (ctp_y_val.valu) = VEX_IMPLY; }
#line 3207 "y.tab.c"
    break;

  case 117: /* literal: AbstractLit  */
#line 1482 "./ctp_y.y"
              { (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 3213 "y.tab.c"
    break;

  case 118: /* literal: CharacterLit  */
#line 1484 "./ctp_y.y"
              { 
                (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 3220 "y.tab.c"
    break;

  case 119: /* literal: StringLit  */
#line 1487 "./ctp_y.y"
              { (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 3226 "y.tab.c"
    break;

  case 120: /* literal: BitStringLit  */
#line 1489 "./ctp_y.y"
              { (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 3232 "y.tab.c"
    break;

  case 121: /* literal: _TRUE  */
#line 1491 "./ctp_y.y"
              { (ctp_y_val.text) = namealloc( "'1'" ); }
#line 3238 "y.tab.c"
    break;

  case 122: /* literal: _FALSE  */
#line 1493 "./ctp_y.y"
              { (ctp_y_val.text) = namealloc( "'0'" ); }
#line 3244 "y.tab.c"
    break;

  case 123: /* aggregate: LeftParen element_association ...element_association.. RightParen_ERR  */
#line 1501 "./ctp_y.y"
          {
            if ( (ctp_y_vsp[-1].pcha) != (chain_list *)0 )
            {
              (ctp_y_vsp[-2].pcha)->NEXT = reverse( (ctp_y_vsp[-1].pcha) );
            }

            (ctp_y_val.pcha) = (ctp_y_vsp[-2].pcha);
          }
#line 3257 "y.tab.c"
    break;

  case 124: /* ...element_association..: %empty  */
#line 1513 "./ctp_y.y"
          { 
            (ctp_y_val.pcha) = (chain_list *)0;
          }
#line 3265 "y.tab.c"
    break;

  case 125: /* ...element_association..: ...element_association.. Comma element_association  */
#line 1519 "./ctp_y.y"
          {
            if ( (ctp_y_vsp[-2].pcha) != (chain_list *)0 )
            {
              (ctp_y_vsp[0].pcha)->NEXT = (ctp_y_vsp[-2].pcha);
            }

            (ctp_y_val.pcha) = (ctp_y_vsp[0].pcha);
          }
#line 3278 "y.tab.c"
    break;

  case 126: /* element_association: expression  */
#line 1531 "./ctp_y.y"
          { 
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = (ctp_y_vsp[0].list);

            (ctp_y_val.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3291 "y.tab.c"
    break;

  case 127: /* element_association: OTHERS Arrow expression  */
#line 1542 "./ctp_y.y"
          {
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = ctp_crtvex( VEX_OTHERS, (ctp_y_vsp[0].list),CTP_EMPSTR,-1,-1);

            (ctp_y_val.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3304 "y.tab.c"
    break;

  case 128: /* name: simple_name  */
#line 1554 "./ctp_y.y"
         {
           char     *LocalName;

           LocalName = CTP_MODNAM;

           (ctp_y_val.name).NAME = (ctp_y_vsp[0].text);
           (ctp_y_val.name).FLAG = 0;

           (ctp_y_val.name).TYPE   = chktab (hshtab,(ctp_y_vsp[0].text),LocalName,CTP_TYPDFN);
           (ctp_y_val.name).LEFT   = chktab (hshtab,(ctp_y_vsp[0].text),LocalName,CTP_WMNDFN);
           (ctp_y_val.name).RIGHT  = chktab (hshtab,(ctp_y_vsp[0].text),LocalName,CTP_WMXDFN);
           (ctp_y_val.name).SIGNED = chktab (hshtab,(ctp_y_vsp[0].text),LocalName,CTP_SUNDFN);
         }
#line 3322 "y.tab.c"
    break;

  case 129: /* name: indexed_name  */
#line 1568 "./ctp_y.y"
              { (ctp_y_val.name) = (ctp_y_vsp[0].name); }
#line 3328 "y.tab.c"
    break;

  case 130: /* name: slice_name  */
#line 1570 "./ctp_y.y"
              { (ctp_y_val.name) = (ctp_y_vsp[0].name); }
#line 3334 "y.tab.c"
    break;

  case 131: /* name: attribute_name  */
#line 1572 "./ctp_y.y"
              { (ctp_y_val.name) = (ctp_y_vsp[0].name); }
#line 3340 "y.tab.c"
    break;

  case 132: /* indexed_name: simple_name aggregate  */
#line 1578 "./ctp_y.y"
          {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            long        Index;
            long         Error;
            long        Def;

            ScanChain = (ctp_y_vsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(ctp_y_vsp[-1].text),LocalName,CTP_SYMDFN);

            if ( ScanChain->NEXT != (chain_list *)0 )
            {
              if ( ( ! Def                                    ) || 
                   ( ScanChain->NEXT->NEXT != (chain_list *)0 ) )
              {
                my_ctp_error(118,(ctp_y_vsp[-1].text));
              }

              /* ICI */

              (ctp_y_val.name).NAME   = (ctp_y_vsp[-1].text);
              (ctp_y_val.name).TYPE   = chktab (hshtab,(ctp_y_vsp[-1].text),LocalName,CTP_TYPDFN);
              (ctp_y_val.name).SIGNED = chktab (hshtab,(ctp_y_vsp[-1].text),LocalName,CTP_SUNDFN);
              (ctp_y_val.name).FLAG   = 0;

              VexStr  = (ctp_vexstr *)ScanChain->DATA;
              (ctp_y_val.name).LEFT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              ScanChain = ScanChain->NEXT;
              VexStr   = (ctp_vexstr *)ScanChain->DATA;
              (ctp_y_val.name).RIGHT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              freechain( (ctp_y_vsp[0].pcha) );
            }
            else
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;
              Error  = ctp_vextonum( VexStr->VEX, &Index );

              (ctp_y_val.name).NAME   = (ctp_y_vsp[-1].text);
              (ctp_y_val.name).TYPE   = chktab (hshtab,(ctp_y_vsp[-1].text),LocalName,CTP_TYPDFN);
              (ctp_y_val.name).SIGNED = chktab (hshtab,(ctp_y_vsp[-1].text),LocalName,CTP_SUNDFN);
              (ctp_y_val.name).FLAG   = 0;

              if ( Error )
              {
                my_ctp_error(36, (ctp_y_vsp[-1].text));
              }
              else
              {
                (ctp_y_val.name).LEFT   = Index;
                (ctp_y_val.name).RIGHT  = Index;
              }

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
          }
#line 3413 "y.tab.c"
    break;

  case 133: /* slice_name: simple_name LeftParen simple_expression direction simple_expression RightParen_ERR  */
#line 1655 "./ctp_y.y"
         {
           char *LocalName;
           long  Left;
           long  Right;
           long   ErrorL;
           long   ErrorR;

           LocalName = CTP_MODNAM;

           ErrorL = ctp_vextonum( (ctp_y_vsp[-3].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (ctp_y_vsp[-1].list).VEX, &Right );

           (ctp_y_val.name).NAME   = (ctp_y_vsp[-5].text);
           (ctp_y_val.name).TYPE   = chktab (hshtab,(ctp_y_vsp[-5].text),LocalName,CTP_TYPDFN);
           (ctp_y_val.name).SIGNED = chktab (hshtab,(ctp_y_vsp[-5].text),LocalName,CTP_SUNDFN);
           (ctp_y_val.name).FLAG   = 0;

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((ctp_y_vsp[-2].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((ctp_y_vsp[-2].valu) == CTP_DWTDFN)))
               my_ctp_error (32,(ctp_y_vsp[-5].text));

             (ctp_y_val.name).LEFT   = Left;
             (ctp_y_val.name).RIGHT  = Right;
           }
           else
           {
             my_ctp_error (36,(ctp_y_vsp[-5].text));
           }
         }
#line 3449 "y.tab.c"
    break;

  case 134: /* attribute_name: name Apostrophe attribute_designator  */
#line 1692 "./ctp_y.y"
          {
            char *LocalName;
            long   type;
            long   flag;
            long  AttrLeft;
            long  AttrRight;
            long  AttrLow;
            long  AttrHigh;

            LocalName = CTP_MODNAM;
            /*mode = */ chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_SYMDFN);
            type = chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_TYPDFN);
            flag = (ctp_y_vsp[0].valu);

            (ctp_y_val.name).NAME   = (ctp_y_vsp[-2].name).NAME;
            (ctp_y_val.name).TYPE   = type;
            (ctp_y_val.name).LEFT   = -1;
            (ctp_y_val.name).RIGHT  = -1;
            (ctp_y_val.name).SIGNED = chktab (hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_SUNDFN);
            (ctp_y_val.name).FLAG   = (ctp_y_vsp[0].valu);

            if ( ( flag == CTP_STABLE ) ||
                 ( flag == CTP_EVENT  ) )
            {
              if ( LocalName != CTP_MODNAM )
                my_ctp_error (79,(ctp_y_vsp[-2].name));
            }
            else
            {
              AttrLeft  = chktab( hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_ATLDFN);
              AttrRight = chktab( hshtab,(ctp_y_vsp[-2].name).NAME,LocalName,CTP_ATRDFN);

              {
                if ( AttrLeft > AttrRight )
                {
                  AttrLow  = AttrRight;
                  AttrHigh = AttrLeft;
                }
                else
                {
                  AttrHigh = AttrRight;
                  AttrLow  = AttrLeft;
                }
              }

              switch ( flag )
              {
                case CTP_LEFT   : (ctp_y_val.name).LEFT = AttrLeft;
                break;

                case CTP_RIGHT  : (ctp_y_val.name).LEFT = AttrRight;
                break;

                case CTP_LOW    : (ctp_y_val.name).LEFT = AttrLow;
                break;

                case CTP_HIGH   : (ctp_y_val.name).LEFT = AttrHigh;
                break;

                case CTP_LENGTH : (ctp_y_val.name).LEFT = 1 + (AttrHigh - AttrLow);
                break;

                case CTP_RANGE  : (ctp_y_val.name).LEFT  = AttrLeft;
                                  (ctp_y_val.name).RIGHT = AttrRight;
                break;

                case CTP_REV_RANGE : (ctp_y_val.name).LEFT  = AttrRight;
                                     (ctp_y_val.name).RIGHT = AttrLeft;
                break;
              }
            }
          }
#line 3526 "y.tab.c"
    break;

  case 135: /* attribute_designator: _STABLE  */
#line 1767 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_STABLE; }
#line 3532 "y.tab.c"
    break;

  case 136: /* attribute_designator: _EVENT  */
#line 1768 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_EVENT; }
#line 3538 "y.tab.c"
    break;

  case 137: /* attribute_designator: _LEFT  */
#line 1769 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_LEFT; }
#line 3544 "y.tab.c"
    break;

  case 138: /* attribute_designator: _RIGHT  */
#line 1770 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_RIGHT; }
#line 3550 "y.tab.c"
    break;

  case 139: /* attribute_designator: _LOW  */
#line 1771 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_LOW; }
#line 3556 "y.tab.c"
    break;

  case 140: /* attribute_designator: _HIGH  */
#line 1772 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_HIGH; }
#line 3562 "y.tab.c"
    break;

  case 141: /* attribute_designator: _LENGTH  */
#line 1773 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_LENGTH; }
#line 3568 "y.tab.c"
    break;

  case 142: /* attribute_designator: _RANGE  */
#line 1774 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_RANGE; }
#line 3574 "y.tab.c"
    break;

  case 143: /* attribute_designator: _REV_RANGE  */
#line 1775 "./ctp_y.y"
                      { (ctp_y_val.valu) = CTP_REV_RANGE; }
#line 3580 "y.tab.c"
    break;

  case 144: /* $@2: %empty  */
#line 1780 "./ctp_y.y"
                { CTP_NM1LST = addchain (CTP_NM1LST,(ctp_y_vsp[0].text)); }
#line 3586 "y.tab.c"
    break;

  case 147: /* ...identifier..: ...identifier.. Comma Identifier  */
#line 1789 "./ctp_y.y"
                { 
                  CTP_NM1LST = addchain (CTP_NM1LST,(ctp_y_vsp[0].text));
                }
#line 3594 "y.tab.c"
    break;

  case 148: /* simple_name: Identifier  */
#line 1796 "./ctp_y.y"
              { (ctp_y_val.text) = (ctp_y_vsp[0].text); }
#line 3600 "y.tab.c"
    break;

  case 149: /* RightParen_ERR: RightParen  */
#line 1801 "./ctp_y.y"
              { ctp_y_errok; }
#line 3606 "y.tab.c"
    break;

  case 150: /* Semicolon_ERR: Semicolon  */
#line 1806 "./ctp_y.y"
              { ctp_y_errok; }
#line 3612 "y.tab.c"
    break;

  case 151: /* END_ERR: _END  */
#line 1811 "./ctp_y.y"
              { ctp_y_errok; }
#line 3618 "y.tab.c"
    break;


#line 3622 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter ctp_y_char, and that requires
     that ctp_y_token be updated with the new translation.  We take the
     approach of translating immediately before every use of ctp_y_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     CTL_Y_ABORT, CTL_Y_ACCEPT, or CTL_Y_ERROR immediately after altering ctp_y_char or
     if it invokes CTL_Y_BACKUP.  In the case of CTL_Y_ABORT or CTL_Y_ACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of CTL_Y_ERROR or CTL_Y_BACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  CTL_Y__SYMBOL_PRINT ("-> $$ =", CTL_Y__CAST (ctp_y_symbol_kind_t, ctp_y_r1[ctp_y_n]), &ctp_y_val, &ctp_y_loc);

  CTL_Y_POPSTACK (ctp_y_len);
  ctp_y_len = 0;

  *++ctp_y_vsp = ctp_y_val;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int ctp_y_lhs = ctp_y_r1[ctp_y_n] - CTL_Y_NTOKENS;
    const int ctp_y_i = ctp_y_pgoto[ctp_y_lhs] + *ctp_y_ssp;
    ctp_y_state = (0 <= ctp_y_i && ctp_y_i <= CTL_Y_LAST && ctp_y_check[ctp_y_i] == *ctp_y_ssp
               ? ctp_y_table[ctp_y_i]
               : ctp_y_defgoto[ctp_y_lhs]);
  }

  goto ctp_y_newstate;


/*--------------------------------------.
| ctp_y_errlab -- here on detecting error.  |
`--------------------------------------*/
ctp_y_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  ctp_y_token = ctp_y_char == CTL_Y_EMPTY ? CTL_Y_SYMBOL_CTL_Y_EMPTY : CTL_Y_TRANSLATE (ctp_y_char);
  /* If not already recovering from an error, report this error.  */
  if (!ctp_y_errstatus)
    {
      ++ctp_y_nerrs;
      ctp_y_error (CTL_Y__("syntax error"));
    }

  if (ctp_y_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (ctp_y_char <= CTL_Y_EOF)
        {
          /* Return failure if at end of input.  */
          if (ctp_y_char == CTL_Y_EOF)
            CTL_Y_ABORT;
        }
      else
        {
          ctp_y_destruct ("Error: discarding",
                      ctp_y_token, &ctp_y_lval);
          ctp_y_char = CTL_Y_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto ctp_y_errlab1;


/*---------------------------------------------------.
| ctp_y_errorlab -- error raised explicitly by CTL_Y_ERROR.  |
`---------------------------------------------------*/
ctp_y_errorlab:
  /* Pacify compilers when the user code never invokes CTL_Y_ERROR and the
     label ctp_y_errorlab therefore never appears in user code.  */
  if (0)
    CTL_Y_ERROR;
  ++ctp_y_nerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this CTL_Y_ERROR.  */
  CTL_Y_POPSTACK (ctp_y_len);
  ctp_y_len = 0;
  CTL_Y__STACK_PRINT (ctp_y_ss, ctp_y_ssp);
  ctp_y_state = *ctp_y_ssp;
  goto ctp_y_errlab1;


/*-------------------------------------------------------------.
| ctp_y_errlab1 -- common code for both syntax error and CTL_Y_ERROR.  |
`-------------------------------------------------------------*/
ctp_y_errlab1:
  ctp_y_errstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      ctp_y_n = ctp_y_pact[ctp_y_state];
      if (!ctp_y_pact_value_is_default (ctp_y_n))
        {
          ctp_y_n += CTL_Y_SYMBOL_CTL_Y_error;
          if (0 <= ctp_y_n && ctp_y_n <= CTL_Y_LAST && ctp_y_check[ctp_y_n] == CTL_Y_SYMBOL_CTL_Y_error)
            {
              ctp_y_n = ctp_y_table[ctp_y_n];
              if (0 < ctp_y_n)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (ctp_y_ssp == ctp_y_ss)
        CTL_Y_ABORT;


      ctp_y_destruct ("Error: popping",
                  CTL_Y__ACCESSING_SYMBOL (ctp_y_state), ctp_y_vsp);
      CTL_Y_POPSTACK (1);
      ctp_y_state = *ctp_y_ssp;
      CTL_Y__STACK_PRINT (ctp_y_ss, ctp_y_ssp);
    }

  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++ctp_y_vsp = ctp_y_lval;
  CTL_Y__IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  CTL_Y__SYMBOL_PRINT ("Shifting", CTL_Y__ACCESSING_SYMBOL (ctp_y_n), ctp_y_vsp, ctp_y_lsp);

  ctp_y_state = ctp_y_n;
  goto ctp_y_newstate;


/*-------------------------------------.
| ctp_y_acceptlab -- CTL_Y_ACCEPT comes here.  |
`-------------------------------------*/
ctp_y_acceptlab:
  ctp_y_result = 0;
  goto ctp_y_returnlab;


/*-----------------------------------.
| ctp_y_abortlab -- CTL_Y_ABORT comes here.  |
`-----------------------------------*/
ctp_y_abortlab:
  ctp_y_result = 1;
  goto ctp_y_returnlab;


/*-----------------------------------------------------------.
| ctp_y_exhaustedlab -- CTL_Y_NOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
ctp_y_exhaustedlab:
  ctp_y_error (CTL_Y__("memory exhausted"));
  ctp_y_result = 2;
  goto ctp_y_returnlab;


/*----------------------------------------------------------.
| ctp_y_returnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
ctp_y_returnlab:
  if (ctp_y_char != CTL_Y_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      ctp_y_token = CTL_Y_TRANSLATE (ctp_y_char);
      ctp_y_destruct ("Cleanup: discarding lookahead",
                  ctp_y_token, &ctp_y_lval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this CTL_Y_ABORT or CTL_Y_ACCEPT.  */
  CTL_Y_POPSTACK (ctp_y_len);
  CTL_Y__STACK_PRINT (ctp_y_ss, ctp_y_ssp);
  while (ctp_y_ssp != ctp_y_ss)
    {
      ctp_y_destruct ("Cleanup: popping",
                  CTL_Y__ACCESSING_SYMBOL (+*ctp_y_ssp), ctp_y_vsp);
      CTL_Y_POPSTACK (1);
    }
#ifndef ctp_y_overflow
  if (ctp_y_ss != ctp_y_ssa)
    CTL_Y_STACK_FREE (ctp_y_ss);
#endif

  return ctp_y_result;
}

#line 1814 "./ctp_y.y"


static struct dct_entry *addent (head , key)
struct dct_entry *head;
char             *key;

{
  struct dct_entry *entry = NULL;
  long              i;

  if (CTP_DCEHED == NULL)
    {
    CTP_DCEHED = (struct dct_entry *)
                 autallocblock (sizeof(struct dct_entry) * CTP_ALODFN);

    entry = CTP_DCEHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = CTP_DCEHED;
  CTP_DCEHED  = CTP_DCEHED->next;

  entry->next = head;
  entry->data = NULL;
  entry->key  = key;

  return (entry);
}

static struct dct_recrd *addrcd (head , key)

struct dct_recrd *head;
char             *key;

{
  struct dct_recrd *recrd = NULL;
  long               i;

  if (CTP_DCRHED == NULL)
    {
    CTP_DCRHED = (struct dct_recrd *)
                 autallocblock (sizeof(struct dct_recrd) * CTP_ALODFN);

    recrd = CTP_DCRHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      recrd->next = recrd + 1;
      recrd++;
      }
    recrd->next = NULL;
    }

  recrd           = CTP_DCRHED;
  CTP_DCRHED      = CTP_DCRHED->next;

  recrd->next     = head;
  recrd->key      = key;

  return (recrd);
}

static struct dct_entry **initab ()

{
  struct dct_entry **head = NULL;
  long                i;

  head = (struct dct_entry **)
         autallocblock (sizeof(struct dct_entry *) * CTP_HSZDFN);

  for (i=0 ; i<CTP_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
}

static void addtab (head,key_str,ctx_str,field,valu)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;
long               valu;

{
  long              found = 0;
  long              index;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  index     = ((unsigned long) key_str) % CTP_HSZDFN;
  entry_pnt = head[index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head[index] = addent (head[index],key_str);
    entry_pnt = head[index];
    }

  found = 0;
  recrd_pnt = entry_pnt->data;
  while (recrd_pnt != NULL)
    {
    if (recrd_pnt->key == ctx_str)
      {
      found = 1;
      break;
      }
    recrd_pnt = recrd_pnt->next;
    }

  if (found == 0)
    {
    entry_pnt->data = addrcd (entry_pnt->data,ctx_str);
    recrd_pnt       = entry_pnt->data ;
    }

  switch (field)
    {
      case CTP_MODDFN :
        recrd_pnt->fd0_val = valu;
        break;
      case CTP_SYMDFN :
        recrd_pnt->fd1_val = valu;
        break;
      case CTP_TYPDFN :
        recrd_pnt->fd2_val = valu;
        break;
      case CTP_SUNDFN :
        recrd_pnt->fd3_val = valu;
        break;
      case CTP_LBLDFN :
        recrd_pnt->fd4_val = valu;
        break;
      case CTP_WMXDFN :
        recrd_pnt->fd5_val = valu;
        break;
      case CTP_WMNDFN :
        recrd_pnt->fd6_val = valu;
        break;
      case CTP_ATLDFN :
        recrd_pnt->fd7_val = valu;
        break;
      case CTP_ATRDFN :
        recrd_pnt->fd8_val = valu;
        break;
      case CTP_PNTDFN :
        recrd_pnt->pnt_val = valu;
        break;
    }
}

static long chktab (head,key_str,ctx_str,field)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;

{
  long              found = 0;
  long              valu = 0;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  entry_pnt = head [((unsigned long)key_str) % CTP_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    found = 0;
    recrd_pnt = entry_pnt->data;
    while (recrd_pnt != NULL)
      {
      if (recrd_pnt->key == ctx_str)
        {
        found = 1;
        break;
        }
      recrd_pnt = recrd_pnt->next;
      }
    if (found == 1)
      {
      switch (field)
        {
        case CTP_MODDFN :
          valu = recrd_pnt->fd0_val;
          break;
        case CTP_SYMDFN :
          valu = recrd_pnt->fd1_val;
          break;
        case CTP_TYPDFN :
          valu = recrd_pnt->fd2_val;
          break;
        case CTP_SUNDFN :
          valu = recrd_pnt->fd3_val;
          break;
        case CTP_LBLDFN :
          valu = recrd_pnt->fd4_val;
          break;
        case CTP_WMXDFN :
          valu = recrd_pnt->fd5_val;
          break;
        case CTP_WMNDFN :
          valu = recrd_pnt->fd6_val;
          break;
        case CTP_ATLDFN :
          valu = recrd_pnt->fd7_val;
          break;
        case CTP_ATRDFN :
          valu = recrd_pnt->fd8_val;
          break;
        case CTP_PNTDFN :
          valu = recrd_pnt->pnt_val;
          break;
        }
      }
    }

  return (valu);
}

static void fretab (pt_hash)

struct dct_entry **pt_hash;
{
  struct dct_entry *pt_entry;
  struct dct_entry *pt_nxtentry;
  struct dct_recrd *pt_record;
  long              i;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<CTP_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry != NULL)
          {
          pt_record = pt_entry->data;

          while (pt_record->next != NULL)
            pt_record = pt_record->next;

          pt_record->next = CTP_DCRHED;
          CTP_DCRHED      = pt_entry->data;

          pt_nxtentry     = pt_entry->next;
          pt_entry->next  = CTP_DCEHED;
          CTP_DCEHED      = pt_entry;
          pt_entry        = pt_nxtentry;
          }
        }
      }
    autfreeblock(pt_hash);
    }
}

static void *ctp_addstr(object,mode,prtype,type,flag,name,left,right,exp)

char          object;
long           mode;
ctltype_list *prtype;
unsigned char type;
char          flag;
char         *name;
long          left;
long          right;
vexexpr      *exp;

{ 
  ctlform_list *CtlForm;
  ctldecl_list *CtlDeclar;
  void         *pnt    = NULL;
  vexexpr      *vex_pnt;
  long           bitsize;

  if ( object == 'F' )
  {
    CtlForm = addctlform( CTP_HEADFIG, name, exp );
    addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM );

    return( (void *)CtlForm );
  }


  if ( (flag == 'A') ||
       (flag == 'U') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an array ...                                   */
       /* ###------------------------------------------------------### */

    if ( flag == 'A' )
    {
      vex_pnt = createvexatomvec( name, prtype->LEFT, prtype->RIGHT ); 
    }
    else
    {
      vex_pnt = createvexatomvec( name, left, right );
    }

    if ( prtype->INDEX == VEX_TYPE_SIGNED )
    {
      SetVexNodeSigned( vex_pnt );
    }

  }
  else
  if ( (flag == 'I') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an integer ...                            */
       /* ###------------------------------------------------------### */

      if ((left == -1 ) && (right == -1))
      {
        left  = prtype->LEFT;
        right = prtype->RIGHT;
      }

      bitsize = ctp_intSize( left, right );

      vex_pnt = createvexatomvec( name, bitsize - 1, 0 );

      if ( ( left  < 0 ) ||
           ( right < 0 ) )
      {
        SetVexNodeSigned( vex_pnt );
      }
  }
  else
  {
       /* ###------------------------------------------------------### */
       /*   if object is a scalar ...                                   */
       /* ###------------------------------------------------------### */
    vex_pnt = createvexatombit( name );
  }

  if ( object == 'C' )
  {
    CtlDeclar = addctldecldef( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'V' )
  {
    CtlDeclar = addctldeclvar( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'A' )
  {
    CtlDeclar = addctldeclass( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'I' )
  {
    CtlDeclar = addctldeclinit( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'R' )
  {
    CtlDeclar = addctldeclreset( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }

  return (pnt);
}

static ctltype_list *val_type(name)

 char *name;
{
  return( searchctltype( CTP_HEADFIG, name ) );
}

#if THIS_IS_DISABLED
static ctltype_list *get_type(val)

  long val;
{
  ctltype_list *Type;

  for ( Type  = CTP_HEADFIG->TYPE;
        Type != (ctltype_list *)0;
        Type  = Type->NEXT )
  {
    if  ( Type->INDEX == val ) break;
  }

  return( Type );
}
#endif

int ctp_y_wrap ()
{
  return (1);
}

