/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with VRD_Y__ or vrd_y__.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with vrd_y_ or VRD_Y_, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define VRD_Y_BISON 30802

/* Bison version string.  */
#define VRD_Y_BISON_VERSION "3.8.2"

/* Skeleton name.  */
#define VRD_Y_SKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define VRD_Y_PURE 0

/* Push parsers.  */
#define VRD_Y_PUSH 0

/* Pull parsers.  */
#define VRD_Y_PULL 1




/* First part of user prologue.  */
#line 1 "./drucompi_y.y"

#include <stdio.h>
#include "mph.h"
#include "mut.h"
#include "rds.h"
#include "rwi.h"
#include "rut.h"
#include "rtl.h"
#include "rfm.h"
#include "rpr.h"
#include "drucutil.h"
#include "drucompi.h"

/*------------------------------------------------------------\
|                                                             |
|                  Druc MODIFICATIONS                         |
|                                                             |
|  Patrick: 07/03/94                                          |
|    Ajouter DRUC_FRONTALE et DRUC_LATERALE_MIN               |
|    qui etaient oublies dans les derivations                 |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                  Druc Variables LEX/YACC                    |
|                                                             |
\------------------------------------------------------------*/
extern int   vrd_y_lineno;
extern FILE *vrd_y_in;
       int   DrucIndexMesure;
       int   DrucInputEntier;
       int   DrucNegatif;
       float DrucInputFloat;
       char  DrucInputChaine[DRUC_MAX_STRING_BUFFER + 1];
extern int   vrd_y_lex ();

#line 108 "y.tab.c"

# ifndef VRD_Y__CAST
#  ifdef __cplusplus
#   define VRD_Y__CAST(Type, Val) static_cast<Type> (Val)
#   define VRD_Y__REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define VRD_Y__CAST(Type, Val) ((Type) (Val))
#   define VRD_Y__REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef VRD_Y__NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define VRD_Y__NULLPTR nullptr
#   else
#    define VRD_Y__NULLPTR 0
#   endif
#  else
#   define VRD_Y__NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef VRD_Y__VRD_Y__Y_TAB_H_INCLUDED
# define VRD_Y__VRD_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef VRD_Y_DEBUG
# define VRD_Y_DEBUG 0
#endif
#if VRD_Y_DEBUG
extern int vrd_y_debug;
#endif

/* Token kinds.  */
#ifndef VRD_Y_TOKENTYPE
# define VRD_Y_TOKENTYPE
  enum vrd_y_tokentype
  {
    VRD_Y_EMPTY = -2,
    VRD_Y_EOF = 0,                     /* "end of file"  */
    VRD_Y_error = 256,                 /* error  */
    VRD_Y_UNDEF = 257,                 /* "invalid token"  */
    DRUC_REGLES = 258,             /* DRUC_REGLES  */
    DRUC_FIN = 259,                /* DRUC_FIN  */
    DRUC_REGLE = 260,              /* DRUC_REGLE  */
    DRUC_DEFINE = 261,             /* DRUC_DEFINE  */
    DRUC_UNDEFINE = 262,           /* DRUC_UNDEFINE  */
    DRUC_CARACTERISE = 263,        /* DRUC_CARACTERISE  */
    DRUC_RELATION = 264,           /* DRUC_RELATION  */
    DRUC_LAYER = 265,              /* DRUC_LAYER  */
    DRUC_NOM = 266,                /* DRUC_NOM  */
    DRUC_UNION = 267,              /* DRUC_UNION  */
    DRUC_EXCLUSION = 268,          /* DRUC_EXCLUSION  */
    DRUC_RESIZE = 269,             /* DRUC_RESIZE  */
    DRUC_ENVELOPPE = 270,          /* DRUC_ENVELOPPE  */
    DRUC_MARGE = 271,              /* DRUC_MARGE  */
    DRUC_CROIX = 272,              /* DRUC_CROIX  */
    DRUC_INTERSECT = 273,          /* DRUC_INTERSECT  */
    DRUC_EXTENSION = 274,          /* DRUC_EXTENSION  */
    DRUC_INCLUSION = 275,          /* DRUC_INCLUSION  */
    DRUC_DISTANCE = 276,           /* DRUC_DISTANCE  */
    DRUC_SURFACE_INTER = 277,      /* DRUC_SURFACE_INTER  */
    DRUC_LONG_INTER = 278,         /* DRUC_LONG_INTER  */
    DRUC_LARGE_INTER = 279,        /* DRUC_LARGE_INTER  */
    DRUC_PENET_INTER = 280,        /* DRUC_PENET_INTER  */
    DRUC_PARAL_INTER = 281,        /* DRUC_PARAL_INTER  */
    DRUC_PERPEN_INTER = 282,       /* DRUC_PERPEN_INTER  */
    DRUC_FRONTALE = 283,           /* DRUC_FRONTALE  */
    DRUC_LATERALE_MIN = 284,       /* DRUC_LATERALE_MIN  */
    DRUC_LATERALE_MAX = 285,       /* DRUC_LATERALE_MAX  */
    DRUC_LARGEUR_MIN = 286,        /* DRUC_LARGEUR_MIN  */
    DRUC_LARGEUR_MAX = 287,        /* DRUC_LARGEUR_MAX  */
    DRUC_LONGUEUR_MIN = 288,       /* DRUC_LONGUEUR_MIN  */
    DRUC_LONGUEUR_MAX = 289,       /* DRUC_LONGUEUR_MAX  */
    DRUC_SUP = 290,                /* DRUC_SUP  */
    DRUC_INF = 291,                /* DRUC_INF  */
    DRUC_AXIALE = 292,             /* DRUC_AXIALE  */
    DRUC_GEODESIQUE = 293,         /* DRUC_GEODESIQUE  */
    DRUC_SURFACE = 294,            /* DRUC_SURFACE  */
    DRUC_LONGUEUR = 295,           /* DRUC_LONGUEUR  */
    DRUC_LARGEUR = 296,            /* DRUC_LARGEUR  */
    DRUC_MIN = 297,                /* DRUC_MIN  */
    DRUC_MAX = 298,                /* DRUC_MAX  */
    DRUC_INFEQ = 299,              /* DRUC_INFEQ  */
    DRUC_SUPEQ = 300,              /* DRUC_SUPEQ  */
    DRUC_DIFF = 301,               /* DRUC_DIFF  */
    DRUC_NOTCH = 302,              /* DRUC_NOTCH  */
    DRUC_DESTINATION = 303,        /* DRUC_DESTINATION  */
    DRUC_ENTIER = 304,             /* DRUC_ENTIER  */
    DRUC_FLOAT = 305,              /* DRUC_FLOAT  */
    DRUC_NEG_FLOAT = 306           /* DRUC_NEG_FLOAT  */
  };
  typedef enum vrd_y_tokentype vrd_y_token_kind_t;
#endif
/* Token kinds.  */
#define VRD_Y_EMPTY -2
#define VRD_Y_EOF 0
#define VRD_Y_error 256
#define VRD_Y_UNDEF 257
#define DRUC_REGLES 258
#define DRUC_FIN 259
#define DRUC_REGLE 260
#define DRUC_DEFINE 261
#define DRUC_UNDEFINE 262
#define DRUC_CARACTERISE 263
#define DRUC_RELATION 264
#define DRUC_LAYER 265
#define DRUC_NOM 266
#define DRUC_UNION 267
#define DRUC_EXCLUSION 268
#define DRUC_RESIZE 269
#define DRUC_ENVELOPPE 270
#define DRUC_MARGE 271
#define DRUC_CROIX 272
#define DRUC_INTERSECT 273
#define DRUC_EXTENSION 274
#define DRUC_INCLUSION 275
#define DRUC_DISTANCE 276
#define DRUC_SURFACE_INTER 277
#define DRUC_LONG_INTER 278
#define DRUC_LARGE_INTER 279
#define DRUC_PENET_INTER 280
#define DRUC_PARAL_INTER 281
#define DRUC_PERPEN_INTER 282
#define DRUC_FRONTALE 283
#define DRUC_LATERALE_MIN 284
#define DRUC_LATERALE_MAX 285
#define DRUC_LARGEUR_MIN 286
#define DRUC_LARGEUR_MAX 287
#define DRUC_LONGUEUR_MIN 288
#define DRUC_LONGUEUR_MAX 289
#define DRUC_SUP 290
#define DRUC_INF 291
#define DRUC_AXIALE 292
#define DRUC_GEODESIQUE 293
#define DRUC_SURFACE 294
#define DRUC_LONGUEUR 295
#define DRUC_LARGEUR 296
#define DRUC_MIN 297
#define DRUC_MAX 298
#define DRUC_INFEQ 299
#define DRUC_SUPEQ 300
#define DRUC_DIFF 301
#define DRUC_NOTCH 302
#define DRUC_DESTINATION 303
#define DRUC_ENTIER 304
#define DRUC_FLOAT 305
#define DRUC_NEG_FLOAT 306

/* Value type.  */
#if ! defined VRD_Y_STYPE && ! defined VRD_Y_STYPE_IS_DECLARED
typedef int VRD_Y_STYPE;
# define VRD_Y_STYPE_IS_TRIVIAL 1
# define VRD_Y_STYPE_IS_DECLARED 1
#endif


extern VRD_Y_STYPE vrd_y_lval;


int vrd_y_parse (void);


#endif /* !VRD_Y__VRD_Y__Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum vrd_y_symbol_kind_t
{
  VRD_Y_SYMBOL_VRD_Y_EMPTY = -2,
  VRD_Y_SYMBOL_VRD_Y_EOF = 0,                      /* "end of file"  */
  VRD_Y_SYMBOL_VRD_Y_error = 1,                    /* error  */
  VRD_Y_SYMBOL_VRD_Y_UNDEF = 2,                    /* "invalid token"  */
  VRD_Y_SYMBOL_DRUC_REGLES = 3,                /* DRUC_REGLES  */
  VRD_Y_SYMBOL_DRUC_FIN = 4,                   /* DRUC_FIN  */
  VRD_Y_SYMBOL_DRUC_REGLE = 5,                 /* DRUC_REGLE  */
  VRD_Y_SYMBOL_DRUC_DEFINE = 6,                /* DRUC_DEFINE  */
  VRD_Y_SYMBOL_DRUC_UNDEFINE = 7,              /* DRUC_UNDEFINE  */
  VRD_Y_SYMBOL_DRUC_CARACTERISE = 8,           /* DRUC_CARACTERISE  */
  VRD_Y_SYMBOL_DRUC_RELATION = 9,              /* DRUC_RELATION  */
  VRD_Y_SYMBOL_DRUC_LAYER = 10,                /* DRUC_LAYER  */
  VRD_Y_SYMBOL_DRUC_NOM = 11,                  /* DRUC_NOM  */
  VRD_Y_SYMBOL_DRUC_UNION = 12,                /* DRUC_UNION  */
  VRD_Y_SYMBOL_DRUC_EXCLUSION = 13,            /* DRUC_EXCLUSION  */
  VRD_Y_SYMBOL_DRUC_RESIZE = 14,               /* DRUC_RESIZE  */
  VRD_Y_SYMBOL_DRUC_ENVELOPPE = 15,            /* DRUC_ENVELOPPE  */
  VRD_Y_SYMBOL_DRUC_MARGE = 16,                /* DRUC_MARGE  */
  VRD_Y_SYMBOL_DRUC_CROIX = 17,                /* DRUC_CROIX  */
  VRD_Y_SYMBOL_DRUC_INTERSECT = 18,            /* DRUC_INTERSECT  */
  VRD_Y_SYMBOL_DRUC_EXTENSION = 19,            /* DRUC_EXTENSION  */
  VRD_Y_SYMBOL_DRUC_INCLUSION = 20,            /* DRUC_INCLUSION  */
  VRD_Y_SYMBOL_DRUC_DISTANCE = 21,             /* DRUC_DISTANCE  */
  VRD_Y_SYMBOL_DRUC_SURFACE_INTER = 22,        /* DRUC_SURFACE_INTER  */
  VRD_Y_SYMBOL_DRUC_LONG_INTER = 23,           /* DRUC_LONG_INTER  */
  VRD_Y_SYMBOL_DRUC_LARGE_INTER = 24,          /* DRUC_LARGE_INTER  */
  VRD_Y_SYMBOL_DRUC_PENET_INTER = 25,          /* DRUC_PENET_INTER  */
  VRD_Y_SYMBOL_DRUC_PARAL_INTER = 26,          /* DRUC_PARAL_INTER  */
  VRD_Y_SYMBOL_DRUC_PERPEN_INTER = 27,         /* DRUC_PERPEN_INTER  */
  VRD_Y_SYMBOL_DRUC_FRONTALE = 28,             /* DRUC_FRONTALE  */
  VRD_Y_SYMBOL_DRUC_LATERALE_MIN = 29,         /* DRUC_LATERALE_MIN  */
  VRD_Y_SYMBOL_DRUC_LATERALE_MAX = 30,         /* DRUC_LATERALE_MAX  */
  VRD_Y_SYMBOL_DRUC_LARGEUR_MIN = 31,          /* DRUC_LARGEUR_MIN  */
  VRD_Y_SYMBOL_DRUC_LARGEUR_MAX = 32,          /* DRUC_LARGEUR_MAX  */
  VRD_Y_SYMBOL_DRUC_LONGUEUR_MIN = 33,         /* DRUC_LONGUEUR_MIN  */
  VRD_Y_SYMBOL_DRUC_LONGUEUR_MAX = 34,         /* DRUC_LONGUEUR_MAX  */
  VRD_Y_SYMBOL_DRUC_SUP = 35,                  /* DRUC_SUP  */
  VRD_Y_SYMBOL_DRUC_INF = 36,                  /* DRUC_INF  */
  VRD_Y_SYMBOL_DRUC_AXIALE = 37,               /* DRUC_AXIALE  */
  VRD_Y_SYMBOL_DRUC_GEODESIQUE = 38,           /* DRUC_GEODESIQUE  */
  VRD_Y_SYMBOL_DRUC_SURFACE = 39,              /* DRUC_SURFACE  */
  VRD_Y_SYMBOL_DRUC_LONGUEUR = 40,             /* DRUC_LONGUEUR  */
  VRD_Y_SYMBOL_DRUC_LARGEUR = 41,              /* DRUC_LARGEUR  */
  VRD_Y_SYMBOL_DRUC_MIN = 42,                  /* DRUC_MIN  */
  VRD_Y_SYMBOL_DRUC_MAX = 43,                  /* DRUC_MAX  */
  VRD_Y_SYMBOL_DRUC_INFEQ = 44,                /* DRUC_INFEQ  */
  VRD_Y_SYMBOL_DRUC_SUPEQ = 45,                /* DRUC_SUPEQ  */
  VRD_Y_SYMBOL_DRUC_DIFF = 46,                 /* DRUC_DIFF  */
  VRD_Y_SYMBOL_DRUC_NOTCH = 47,                /* DRUC_NOTCH  */
  VRD_Y_SYMBOL_DRUC_DESTINATION = 48,          /* DRUC_DESTINATION  */
  VRD_Y_SYMBOL_DRUC_ENTIER = 49,               /* DRUC_ENTIER  */
  VRD_Y_SYMBOL_DRUC_FLOAT = 50,                /* DRUC_FLOAT  */
  VRD_Y_SYMBOL_DRUC_NEG_FLOAT = 51,            /* DRUC_NEG_FLOAT  */
  VRD_Y_SYMBOL_52_ = 52,                       /* ';'  */
  VRD_Y_SYMBOL_53_ = 53,                       /* ','  */
  VRD_Y_SYMBOL_54_ = 54,                       /* '('  */
  VRD_Y_SYMBOL_55_ = 55,                       /* ')'  */
  VRD_Y_SYMBOL_56_ = 56,                       /* ':'  */
  VRD_Y_SYMBOL_57_ = 57,                       /* '<'  */
  VRD_Y_SYMBOL_58_ = 58,                       /* '>'  */
  VRD_Y_SYMBOL_59_ = 59,                       /* '='  */
  VRD_Y_SYMBOL_VRD_Y_ACCEPT = 60,                  /* $accept  */
  VRD_Y_SYMBOL_drc = 61,                       /* drc  */
  VRD_Y_SYMBOL_62_1 = 62,                      /* $@1  */
  VRD_Y_SYMBOL_list_layer = 63,                /* list_layer  */
  VRD_Y_SYMBOL_layer = 64,                     /* layer  */
  VRD_Y_SYMBOL_65_2 = 65,                      /* $@2  */
  VRD_Y_SYMBOL_66_3 = 66,                      /* $@3  */
  VRD_Y_SYMBOL_list_bloc = 67,                 /* list_bloc  */
  VRD_Y_SYMBOL_bloc = 68,                      /* bloc  */
  VRD_Y_SYMBOL_define = 69,                    /* define  */
  VRD_Y_SYMBOL_70_4 = 70,                      /* $@4  */
  VRD_Y_SYMBOL_71_5 = 71,                      /* $@5  */
  VRD_Y_SYMBOL_resiz = 72,                     /* resiz  */
  VRD_Y_SYMBOL_73_6 = 73,                      /* $@6  */
  VRD_Y_SYMBOL_valresiz = 74,                  /* valresiz  */
  VRD_Y_SYMBOL_defoper = 75,                   /* defoper  */
  VRD_Y_SYMBOL_76_7 = 76,                      /* $@7  */
  VRD_Y_SYMBOL_77_8 = 77,                      /* $@8  */
  VRD_Y_SYMBOL_compose = 78,                   /* compose  */
  VRD_Y_SYMBOL_defmodif = 79,                  /* defmodif  */
  VRD_Y_SYMBOL_undefine = 80,                  /* undefine  */
  VRD_Y_SYMBOL_81_9 = 81,                      /* $@9  */
  VRD_Y_SYMBOL_caracter = 82,                  /* caracter  */
  VRD_Y_SYMBOL_83_10 = 83,                     /* $@10  */
  VRD_Y_SYMBOL_lst_rgl_1 = 84,                 /* lst_rgl_1  */
  VRD_Y_SYMBOL_regle_1 = 85,                   /* regle_1  */
  VRD_Y_SYMBOL_86_11 = 86,                     /* $@11  */
  VRD_Y_SYMBOL_87_12 = 87,                     /* $@12  */
  VRD_Y_SYMBOL_88_13 = 88,                     /* $@13  */
  VRD_Y_SYMBOL_relation = 89,                  /* relation  */
  VRD_Y_SYMBOL_90_14 = 90,                     /* $@14  */
  VRD_Y_SYMBOL_91_15 = 91,                     /* $@15  */
  VRD_Y_SYMBOL_92_16 = 92,                     /* $@16  */
  VRD_Y_SYMBOL_lst_rgl_2 = 93,                 /* lst_rgl_2  */
  VRD_Y_SYMBOL_regle_2 = 94,                   /* regle_2  */
  VRD_Y_SYMBOL_95_17 = 95,                     /* $@17  */
  VRD_Y_SYMBOL_96_18 = 96,                     /* $@18  */
  VRD_Y_SYMBOL_97_19 = 97,                     /* $@19  */
  VRD_Y_SYMBOL_config = 98,                    /* config  */
  VRD_Y_SYMBOL_mesure_rel = 99,                /* mesure_rel  */
  VRD_Y_SYMBOL_mesure = 100,                   /* mesure  */
  VRD_Y_SYMBOL_compar = 101                    /* compar  */
};
typedef enum vrd_y_symbol_kind_t vrd_y_symbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define VRD_Y__STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ vrd_y_type_int8;
#elif defined VRD_Y__STDINT_H
typedef int_least8_t vrd_y_type_int8;
#else
typedef signed char vrd_y_type_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ vrd_y_type_int16;
#elif defined VRD_Y__STDINT_H
typedef int_least16_t vrd_y_type_int16;
#else
typedef short vrd_y_type_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ vrd_y_type_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined VRD_Y__STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t vrd_y_type_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char vrd_y_type_uint8;
#else
typedef short vrd_y_type_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ vrd_y_type_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined VRD_Y__STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t vrd_y_type_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short vrd_y_type_uint16;
#else
typedef int vrd_y_type_uint16;
#endif

#ifndef VRD_Y_PTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define VRD_Y_PTRDIFF_T __PTRDIFF_TYPE__
#  define VRD_Y_PTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define VRD_Y_PTRDIFF_T ptrdiff_t
#  define VRD_Y_PTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define VRD_Y_PTRDIFF_T long
#  define VRD_Y_PTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef VRD_Y_SIZE_T
# ifdef __SIZE_TYPE__
#  define VRD_Y_SIZE_T __SIZE_TYPE__
# elif defined size_t
#  define VRD_Y_SIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define VRD_Y_SIZE_T size_t
# else
#  define VRD_Y_SIZE_T unsigned
# endif
#endif

#define VRD_Y_SIZE_MAXIMUM                                  \
  VRD_Y__CAST (VRD_Y_PTRDIFF_T,                                 \
           (VRD_Y_PTRDIFF_MAXIMUM < VRD_Y__CAST (VRD_Y_SIZE_T, -1)  \
            ? VRD_Y_PTRDIFF_MAXIMUM                         \
            : VRD_Y__CAST (VRD_Y_SIZE_T, -1)))

#define VRD_Y_SIZEOF(X) VRD_Y__CAST (VRD_Y_PTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef vrd_y_type_uint8 vrd_y__state_t;

/* State numbers in computations.  */
typedef int vrd_y__state_fast_t;

#ifndef VRD_Y__
# if defined VRD_Y_ENABLE_NLS && VRD_Y_ENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define VRD_Y__(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef VRD_Y__
#  define VRD_Y__(Msgid) Msgid
# endif
#endif


#ifndef VRD_Y__ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define VRD_Y__ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define VRD_Y__ATTRIBUTE_PURE
# endif
#endif

#ifndef VRD_Y__ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define VRD_Y__ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define VRD_Y__ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define VRD_Y__USE(E) ((void) (E))
#else
# define VRD_Y__USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about vrd_y_lval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define VRD_Y__INITIAL_VALUE(Value) Value
#endif
#ifndef VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef VRD_Y__INITIAL_VALUE
# define VRD_Y__INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define VRD_Y__IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define VRD_Y__IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef VRD_Y__IGNORE_USELESS_CAST_BEGIN
# define VRD_Y__IGNORE_USELESS_CAST_BEGIN
# define VRD_Y__IGNORE_USELESS_CAST_END
#endif


#define VRD_Y__ASSERT(E) ((void) (0 && (E)))

#if !defined vrd_y_overflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef VRD_Y_STACK_USE_ALLOCA
#  if VRD_Y_STACK_USE_ALLOCA
#   ifdef __GNUC__
#    define VRD_Y_STACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define VRD_Y_STACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define VRD_Y_STACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef VRD_Y_STACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define VRD_Y_STACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef VRD_Y_STACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define VRD_Y_STACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define VRD_Y_STACK_ALLOC VRD_Y_MALLOC
#  define VRD_Y_STACK_FREE VRD_Y_FREE
#  ifndef VRD_Y_STACK_ALLOC_MAXIMUM
#   define VRD_Y_STACK_ALLOC_MAXIMUM VRD_Y_SIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined VRD_Y_MALLOC || defined malloc) \
             && (defined VRD_Y_FREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef VRD_Y_MALLOC
#   define VRD_Y_MALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (VRD_Y_SIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef VRD_Y_FREE
#   define VRD_Y_FREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined vrd_y_overflow */

#if (! defined vrd_y_overflow \
     && (! defined __cplusplus \
         || (defined VRD_Y_STYPE_IS_TRIVIAL && VRD_Y_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union vrd_y_alloc
{
  vrd_y__state_t vrd_y_ss_alloc;
  VRD_Y_STYPE vrd_y_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define VRD_Y_STACK_GAP_MAXIMUM (VRD_Y_SIZEOF (union vrd_y_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define VRD_Y_STACK_BYTES(N) \
     ((N) * (VRD_Y_SIZEOF (vrd_y__state_t) + VRD_Y_SIZEOF (VRD_Y_STYPE)) \
      + VRD_Y_STACK_GAP_MAXIMUM)

# define VRD_Y_COPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables VRD_Y_SIZE and VRD_Y_STACKSIZE give the old and new number of
   elements in the stack, and VRD_Y_PTR gives the new location of the
   stack.  Advance VRD_Y_PTR to a properly aligned location for the next
   stack.  */
# define VRD_Y_STACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        VRD_Y_PTRDIFF_T vrd_y_newbytes;                                         \
        VRD_Y_COPY (&vrd_y_ptr->Stack_alloc, Stack, vrd_y_size);                    \
        Stack = &vrd_y_ptr->Stack_alloc;                                    \
        vrd_y_newbytes = vrd_y_stacksize * VRD_Y_SIZEOF (*Stack) + VRD_Y_STACK_GAP_MAXIMUM; \
        vrd_y_ptr += vrd_y_newbytes / VRD_Y_SIZEOF (*vrd_y_ptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined VRD_Y_COPY_NEEDED && VRD_Y_COPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef VRD_Y_COPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define VRD_Y_COPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, VRD_Y__CAST (VRD_Y_SIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define VRD_Y_COPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          VRD_Y_PTRDIFF_T vrd_y_i;                      \
          for (vrd_y_i = 0; vrd_y_i < (Count); vrd_y_i++)   \
            (Dst)[vrd_y_i] = (Src)[vrd_y_i];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !VRD_Y_COPY_NEEDED */

/* VRD_Y_FINAL -- State number of the termination state.  */
#define VRD_Y_FINAL  3
/* VRD_Y_LAST -- Last index in VRD_Y_TABLE.  */
#define VRD_Y_LAST   101

/* VRD_Y_NTOKENS -- Number of terminals.  */
#define VRD_Y_NTOKENS  60
/* VRD_Y_NNTS -- Number of nonterminals.  */
#define VRD_Y_NNTS  42
/* VRD_Y_NRULES -- Number of rules.  */
#define VRD_Y_NRULES  90
/* VRD_Y_NSTATES -- Number of states.  */
#define VRD_Y_NSTATES  136

/* VRD_Y_MAXUTOK -- Last valid token kind.  */
#define VRD_Y_MAXUTOK   306


/* VRD_Y_TRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by vrd_y_lex, with out-of-bounds checking.  */
#define VRD_Y_TRANSLATE(VRD_Y_X)                                \
  (0 <= (VRD_Y_X) && (VRD_Y_X) <= VRD_Y_MAXUTOK                     \
   ? VRD_Y__CAST (vrd_y_symbol_kind_t, vrd_y_translate[VRD_Y_X])        \
   : VRD_Y_SYMBOL_VRD_Y_UNDEF)

/* VRD_Y_TRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by vrd_y_lex.  */
static const vrd_y_type_int8 vrd_y_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      54,    55,     2,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    52,
      57,    59,    58,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51
};

#if VRD_Y_DEBUG
/* VRD_Y_RLINE[VRD_Y_N] -- Source line where rule number VRD_Y_N was defined.  */
static const vrd_y_type_int16 vrd_y_rline[] =
{
       0,    94,    94,    94,   103,   104,   108,   109,   107,   113,
     115,   118,   119,   120,   121,   125,   129,   124,   133,   136,
     136,   140,   141,   146,   147,   146,   149,   152,   153,   154,
     155,   158,   162,   161,   167,   166,   176,   178,   181,   182,
     187,   181,   192,   193,   195,   192,   203,   205,   208,   209,
     215,   208,   220,   222,   224,   226,   228,   230,   232,   236,
     238,   240,   242,   244,   246,   248,   250,   252,   254,   256,
     258,   260,   262,   264,   266,   268,   272,   274,   276,   278,
     280,   282,   284,   288,   290,   292,   294,   296,   298,   300,
     302
};
#endif

/** Accessing symbol of state STATE.  */
#define VRD_Y__ACCESSING_SYMBOL(State) VRD_Y__CAST (vrd_y_symbol_kind_t, vrd_y_stos[State])

#if VRD_Y_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   VRD_Y_SYMBOL.  No bounds checking.  */
static const char *vrd_y_symbol_name (vrd_y_symbol_kind_t vrd_y_symbol) VRD_Y__ATTRIBUTE_UNUSED;

/* VRD_Y_TNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at VRD_Y_NTOKENS, nonterminals.  */
static const char *const vrd_y_tname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DRUC_REGLES",
  "DRUC_FIN", "DRUC_REGLE", "DRUC_DEFINE", "DRUC_UNDEFINE",
  "DRUC_CARACTERISE", "DRUC_RELATION", "DRUC_LAYER", "DRUC_NOM",
  "DRUC_UNION", "DRUC_EXCLUSION", "DRUC_RESIZE", "DRUC_ENVELOPPE",
  "DRUC_MARGE", "DRUC_CROIX", "DRUC_INTERSECT", "DRUC_EXTENSION",
  "DRUC_INCLUSION", "DRUC_DISTANCE", "DRUC_SURFACE_INTER",
  "DRUC_LONG_INTER", "DRUC_LARGE_INTER", "DRUC_PENET_INTER",
  "DRUC_PARAL_INTER", "DRUC_PERPEN_INTER", "DRUC_FRONTALE",
  "DRUC_LATERALE_MIN", "DRUC_LATERALE_MAX", "DRUC_LARGEUR_MIN",
  "DRUC_LARGEUR_MAX", "DRUC_LONGUEUR_MIN", "DRUC_LONGUEUR_MAX", "DRUC_SUP",
  "DRUC_INF", "DRUC_AXIALE", "DRUC_GEODESIQUE", "DRUC_SURFACE",
  "DRUC_LONGUEUR", "DRUC_LARGEUR", "DRUC_MIN", "DRUC_MAX", "DRUC_INFEQ",
  "DRUC_SUPEQ", "DRUC_DIFF", "DRUC_NOTCH", "DRUC_DESTINATION",
  "DRUC_ENTIER", "DRUC_FLOAT", "DRUC_NEG_FLOAT", "';'", "','", "'('",
  "')'", "':'", "'<'", "'>'", "'='", "$accept", "drc", "$@1", "list_layer",
  "layer", "$@2", "$@3", "list_bloc", "bloc", "define", "$@4", "$@5",
  "resiz", "$@6", "valresiz", "defoper", "$@7", "$@8", "compose",
  "defmodif", "undefine", "$@9", "caracter", "$@10", "lst_rgl_1",
  "regle_1", "$@11", "$@12", "$@13", "relation", "$@14", "$@15", "$@16",
  "lst_rgl_2", "regle_2", "$@17", "$@18", "$@19", "config", "mesure_rel",
  "mesure", "compar", VRD_Y__NULLPTR
};

static const char *
vrd_y_symbol_name (vrd_y_symbol_kind_t vrd_y_symbol)
{
  return vrd_y_tname[vrd_y_symbol];
}
#endif

#define VRD_Y_PACT_NINF (-35)

#define vrd_y_pact_value_is_default(Yyn) \
  ((Yyn) == VRD_Y_PACT_NINF)

#define VRD_Y_TABLE_NINF (-1)

#define vrd_y_table_value_is_error(Yyn) \
  0

/* VRD_Y_PACT[STATE-NUM] -- Index in VRD_Y_TABLE of the portion describing
   STATE-NUM.  */
static const vrd_y_type_int8 vrd_y_pact[] =
{
     -35,     7,     5,   -35,    18,     3,   -35,   -35,    29,   -35,
     -20,    20,    22,    58,   -35,    10,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,    59,    36,   -35,   -12,    19,
      21,    17,   -35,   -35,   -35,    -9,   -35,    69,    23,   -35,
     -35,   -35,    27,    63,   -35,    -5,   -35,    67,    14,    68,
     -35,    31,    32,    33,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,    26,    34,    71,    35,
      78,   -35,   -35,   -19,   -35,    -4,   -35,    14,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -34,    38,    37,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,    40,   -35,
     -35,   -35,    39,    41,    28,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,    30,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -34,    42,   -35,    44,   -35
};

/* VRD_Y_DEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when VRD_Y_TABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const vrd_y_type_int8 vrd_y_defact[] =
{
       2,     0,     0,     1,     0,     0,     5,     6,     0,     4,
       0,     0,     0,     0,    42,     0,    10,    11,    12,    13,
      14,     7,    15,    32,    34,     0,     0,     9,     0,     0,
       0,     0,    43,     3,     8,     0,    33,     0,     0,    19,
      21,    22,     0,     0,    38,     0,    37,     0,     0,     0,
      31,    26,     0,     0,    36,    44,    27,    29,    28,    30,
      20,    16,    23,    18,    39,    35,     0,     0,     0,     0,
       0,    17,    24,     0,    48,     0,    47,     0,    80,    81,
      82,    76,    77,    78,    79,     0,     0,     0,    46,    25,
      83,    84,    85,    86,    90,    87,    88,    89,     0,    49,
      45,    40,     0,     0,     0,    41,    56,    57,    58,    53,
      54,    55,    52,     0,    59,    60,    61,    62,    63,    64,
      69,    70,    71,    67,    68,    65,    66,    72,    73,    74,
      75,     0,     0,    50,     0,    51
};

/* VRD_Y_PGOTO[NTERM-NUM].  */
static const vrd_y_type_int8 vrd_y_pgoto[] =
{
     -35,   -35,   -35,   -35,    83,   -35,   -35,   -35,    79,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,    24,   -35,
     -35,   -35,   -35,   -35,   -35,    52,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,    25,   -35,   -35,   -35,   -35,   -35,
     -35,   -33
};

/* VRD_Y_DEFGOTO[NTERM-NUM].  */
static const vrd_y_type_uint8 vrd_y_defgoto[] =
{
       0,     1,     2,     5,     6,    10,    28,    15,    16,    17,
      29,    67,    42,    48,    43,    63,    68,    77,    60,    51,
      18,    30,    19,    31,    45,    46,    52,    69,   103,    20,
      25,    38,    66,    75,    76,    86,   102,   134,   113,   131,
      85,    98
};

/* VRD_Y_TABLE[VRD_Y_PACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If VRD_Y_TABLE_NINF, syntax error.  */
static const vrd_y_type_uint8 vrd_y_table[] =
{
      44,    74,    39,    78,    79,    80,     8,     3,    90,    91,
      92,    93,    94,     4,    26,     4,    11,    12,    13,    14,
      81,    82,    83,    95,    96,    97,    56,    57,    84,     7,
      21,    22,    58,    23,    59,    11,    12,    13,    14,    33,
      34,    40,    41,   106,   107,   108,   109,   110,   111,   112,
      53,    87,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,    24,
      32,    37,    35,    36,    44,    49,    47,    50,    55,    61,
      70,    64,    72,    74,    62,    65,    71,    99,     9,   100,
     101,    73,   133,   105,    27,   104,   135,    54,   132,     0,
      88,    89
};

static const vrd_y_type_int16 vrd_y_check[] =
{
       5,     5,    11,    22,    23,    24,     3,     0,    42,    43,
      44,    45,    46,    10,     4,    10,     6,     7,     8,     9,
      39,    40,    41,    57,    58,    59,    12,    13,    47,    11,
      50,    11,    18,    11,    20,     6,     7,     8,     9,     3,
      52,    50,    51,    15,    16,    17,    18,    19,    20,    21,
      55,    55,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    11,
      11,    54,    53,    52,     5,    48,    53,    14,    11,    11,
      54,    49,    11,     5,    53,    52,    52,    49,     5,    52,
      50,    56,    50,    52,    15,    56,    52,    45,   131,    -1,
      75,    77
};

/* VRD_Y_STOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const vrd_y_type_int8 vrd_y_stos[] =
{
       0,    61,    62,     0,    10,    63,    64,    11,     3,    64,
      65,     6,     7,     8,     9,    67,    68,    69,    80,    82,
      89,    50,    11,    11,    11,    90,     4,    68,    66,    70,
      81,    83,    11,     3,    52,    53,    52,    54,    91,    11,
      50,    51,    72,    74,     5,    84,    85,    53,    73,    48,
      14,    79,    86,    55,    85,    11,    12,    13,    18,    20,
      78,    11,    53,    75,    49,    52,    92,    71,    76,    87,
      54,    52,    11,    56,     5,    93,    94,    77,    22,    23,
      24,    39,    40,    41,    47,   100,    95,    55,    94,    78,
      42,    43,    44,    45,    46,    57,    58,    59,   101,    49,
      52,    50,    96,    88,    56,    52,    15,    16,    17,    18,
      19,    20,    21,    98,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    99,   101,    50,    97,    52
};

/* VRD_Y_R1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const vrd_y_type_int8 vrd_y_r1[] =
{
       0,    60,    62,    61,    63,    63,    65,    66,    64,    67,
      67,    68,    68,    68,    68,    70,    71,    69,    72,    73,
      72,    74,    74,    76,    77,    75,    75,    78,    78,    78,
      78,    79,    81,    80,    83,    82,    84,    84,    86,    87,
      88,    85,    90,    91,    92,    89,    93,    93,    95,    96,
      97,    94,    98,    98,    98,    98,    98,    98,    98,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   101,   101,   101,   101,   101,   101,   101,
     101
};

/* VRD_Y_R2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const vrd_y_type_int8 vrd_y_r2[] =
{
       0,     2,     0,     6,     2,     1,     0,     0,     6,     2,
       1,     1,     1,     1,     1,     0,     0,     9,     3,     0,
       3,     1,     1,     0,     0,     5,     0,     1,     1,     1,
       1,     1,     0,     4,     0,     7,     2,     1,     0,     0,
       0,    10,     0,     0,     0,    11,     2,     1,     0,     0,
       0,    11,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


enum { VRD_Y_ENOMEM = -2 };

#define vrd_y_errok         (vrd_y_errstatus = 0)
#define vrd_y_clearin       (vrd_y_char = VRD_Y_EMPTY)

#define VRD_Y_ACCEPT        goto vrd_y_acceptlab
#define VRD_Y_ABORT         goto vrd_y_abortlab
#define VRD_Y_ERROR         goto vrd_y_errorlab
#define VRD_Y_NOMEM         goto vrd_y_exhaustedlab


#define VRD_Y_RECOVERING()  (!!vrd_y_errstatus)

#define VRD_Y_BACKUP(Token, Value)                                    \
  do                                                              \
    if (vrd_y_char == VRD_Y_EMPTY)                                        \
      {                                                           \
        vrd_y_char = (Token);                                         \
        vrd_y_lval = (Value);                                         \
        VRD_Y_POPSTACK (vrd_y_len);                                       \
        vrd_y_state = *vrd_y_ssp;                                         \
        goto vrd_y_backup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        vrd_y_error (VRD_Y__("syntax error: cannot back up")); \
        VRD_Y_ERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use VRD_Y_error or VRD_Y_UNDEF. */
#define VRD_Y_ERRCODE VRD_Y_UNDEF


/* Enable debugging if requested.  */
#if VRD_Y_DEBUG

# ifndef VRD_Y_FPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define VRD_Y_FPRINTF fprintf
# endif

# define VRD_Y_DPRINTF(Args)                        \
do {                                            \
  if (vrd_y_debug)                                  \
    VRD_Y_FPRINTF Args;                             \
} while (0)




# define VRD_Y__SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (vrd_y_debug)                                                            \
    {                                                                     \
      VRD_Y_FPRINTF (stderr, "%s ", Title);                                   \
      vrd_y__symbol_print (stderr,                                            \
                  Kind, Value); \
      VRD_Y_FPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on VRD_Y_O.  |
`-----------------------------------*/

static void
vrd_y__symbol_value_print (FILE *vrd_y_o,
                       vrd_y_symbol_kind_t vrd_y_kind, VRD_Y_STYPE const * const vrd_y_valuep)
{
  FILE *vrd_y_output = vrd_y_o;
  VRD_Y__USE (vrd_y_output);
  if (!vrd_y_valuep)
    return;
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  VRD_Y__USE (vrd_y_kind);
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on VRD_Y_O.  |
`---------------------------*/

static void
vrd_y__symbol_print (FILE *vrd_y_o,
                 vrd_y_symbol_kind_t vrd_y_kind, VRD_Y_STYPE const * const vrd_y_valuep)
{
  VRD_Y_FPRINTF (vrd_y_o, "%s %s (",
             vrd_y_kind < VRD_Y_NTOKENS ? "token" : "nterm", vrd_y_symbol_name (vrd_y_kind));

  vrd_y__symbol_value_print (vrd_y_o, vrd_y_kind, vrd_y_valuep);
  VRD_Y_FPRINTF (vrd_y_o, ")");
}

/*------------------------------------------------------------------.
| vrd_y__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
vrd_y__stack_print (vrd_y__state_t *vrd_y_bottom, vrd_y__state_t *vrd_y_top)
{
  VRD_Y_FPRINTF (stderr, "Stack now");
  for (; vrd_y_bottom <= vrd_y_top; vrd_y_bottom++)
    {
      int vrd_y_bot = *vrd_y_bottom;
      VRD_Y_FPRINTF (stderr, " %d", vrd_y_bot);
    }
  VRD_Y_FPRINTF (stderr, "\n");
}

# define VRD_Y__STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (vrd_y_debug)                                                  \
    vrd_y__stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the VRD_Y_RULE is going to be reduced.  |
`------------------------------------------------*/

static void
vrd_y__reduce_print (vrd_y__state_t *vrd_y_ssp, VRD_Y_STYPE *vrd_y_vsp,
                 int vrd_y_rule)
{
  int vrd_y_lno = vrd_y_rline[vrd_y_rule];
  int vrd_y_nrhs = vrd_y_r2[vrd_y_rule];
  int vrd_y_i;
  VRD_Y_FPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             vrd_y_rule - 1, vrd_y_lno);
  /* The symbols being reduced.  */
  for (vrd_y_i = 0; vrd_y_i < vrd_y_nrhs; vrd_y_i++)
    {
      VRD_Y_FPRINTF (stderr, "   $%d = ", vrd_y_i + 1);
      vrd_y__symbol_print (stderr,
                       VRD_Y__ACCESSING_SYMBOL (+vrd_y_ssp[vrd_y_i + 1 - vrd_y_nrhs]),
                       &vrd_y_vsp[(vrd_y_i + 1) - (vrd_y_nrhs)]);
      VRD_Y_FPRINTF (stderr, "\n");
    }
}

# define VRD_Y__REDUCE_PRINT(Rule)          \
do {                                    \
  if (vrd_y_debug)                          \
    vrd_y__reduce_print (vrd_y_ssp, vrd_y_vsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int vrd_y_debug;
#else /* !VRD_Y_DEBUG */
# define VRD_Y_DPRINTF(Args) ((void) 0)
# define VRD_Y__SYMBOL_PRINT(Title, Kind, Value, Location)
# define VRD_Y__STACK_PRINT(Bottom, Top)
# define VRD_Y__REDUCE_PRINT(Rule)
#endif /* !VRD_Y_DEBUG */


/* VRD_Y_INITDEPTH -- initial size of the parser's stacks.  */
#ifndef VRD_Y_INITDEPTH
# define VRD_Y_INITDEPTH 200
#endif

/* VRD_Y_MAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   VRD_Y_STACK_ALLOC_MAXIMUM < VRD_Y_STACK_BYTES (VRD_Y_MAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef VRD_Y_MAXDEPTH
# define VRD_Y_MAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
vrd_y_destruct (const char *vrd_y_msg,
            vrd_y_symbol_kind_t vrd_y_kind, VRD_Y_STYPE *vrd_y_valuep)
{
  VRD_Y__USE (vrd_y_valuep);
  if (!vrd_y_msg)
    vrd_y_msg = "Deleting";
  VRD_Y__SYMBOL_PRINT (vrd_y_msg, vrd_y_kind, vrd_y_valuep, vrd_y_locationp);

  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  VRD_Y__USE (vrd_y_kind);
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int vrd_y_char;

/* The semantic value of the lookahead symbol.  */
VRD_Y_STYPE vrd_y_lval;
/* Number of syntax errors so far.  */
int vrd_y_nerrs;




/*----------.
| vrd_y_parse.  |
`----------*/

int
vrd_y_parse (void)
{
    vrd_y__state_fast_t vrd_y_state = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int vrd_y_errstatus = 0;

    /* Refer to the stacks through separate pointers, to allow vrd_y_overflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    VRD_Y_PTRDIFF_T vrd_y_stacksize = VRD_Y_INITDEPTH;

    /* The state stack: array, bottom, top.  */
    vrd_y__state_t vrd_y_ssa[VRD_Y_INITDEPTH];
    vrd_y__state_t *vrd_y_ss = vrd_y_ssa;
    vrd_y__state_t *vrd_y_ssp = vrd_y_ss;

    /* The semantic value stack: array, bottom, top.  */
    VRD_Y_STYPE vrd_y_vsa[VRD_Y_INITDEPTH];
    VRD_Y_STYPE *vrd_y_vs = vrd_y_vsa;
    VRD_Y_STYPE *vrd_y_vsp = vrd_y_vs;

  int vrd_y_n;
  /* The return value of vrd_y_parse.  */
  int vrd_y_result;
  /* Lookahead symbol kind.  */
  vrd_y_symbol_kind_t vrd_y_token = VRD_Y_SYMBOL_VRD_Y_EMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  VRD_Y_STYPE vrd_y_val;



#define VRD_Y_POPSTACK(N)   (vrd_y_vsp -= (N), vrd_y_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int vrd_y_len = 0;

  VRD_Y_DPRINTF ((stderr, "Starting parse\n"));

  vrd_y_char = VRD_Y_EMPTY; /* Cause a token to be read.  */

  goto vrd_y_setstate;


/*------------------------------------------------------------.
| vrd_y_newstate -- push a new state, which is found in vrd_y_state.  |
`------------------------------------------------------------*/
vrd_y_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  vrd_y_ssp++;


/*--------------------------------------------------------------------.
| vrd_y_setstate -- set current state (the top of the stack) to vrd_y_state.  |
`--------------------------------------------------------------------*/
vrd_y_setstate:
  VRD_Y_DPRINTF ((stderr, "Entering state %d\n", vrd_y_state));
  VRD_Y__ASSERT (0 <= vrd_y_state && vrd_y_state < VRD_Y_NSTATES);
  VRD_Y__IGNORE_USELESS_CAST_BEGIN
  *vrd_y_ssp = VRD_Y__CAST (vrd_y__state_t, vrd_y_state);
  VRD_Y__IGNORE_USELESS_CAST_END
  VRD_Y__STACK_PRINT (vrd_y_ss, vrd_y_ssp);

  if (vrd_y_ss + vrd_y_stacksize - 1 <= vrd_y_ssp)
#if !defined vrd_y_overflow && !defined VRD_Y_STACK_RELOCATE
    VRD_Y_NOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      VRD_Y_PTRDIFF_T vrd_y_size = vrd_y_ssp - vrd_y_ss + 1;

# if defined vrd_y_overflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        vrd_y__state_t *vrd_y_ss1 = vrd_y_ss;
        VRD_Y_STYPE *vrd_y_vs1 = vrd_y_vs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if vrd_y_overflow is a macro.  */
        vrd_y_overflow (VRD_Y__("memory exhausted"),
                    &vrd_y_ss1, vrd_y_size * VRD_Y_SIZEOF (*vrd_y_ssp),
                    &vrd_y_vs1, vrd_y_size * VRD_Y_SIZEOF (*vrd_y_vsp),
                    &vrd_y_stacksize);
        vrd_y_ss = vrd_y_ss1;
        vrd_y_vs = vrd_y_vs1;
      }
# else /* defined VRD_Y_STACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (VRD_Y_MAXDEPTH <= vrd_y_stacksize)
        VRD_Y_NOMEM;
      vrd_y_stacksize *= 2;
      if (VRD_Y_MAXDEPTH < vrd_y_stacksize)
        vrd_y_stacksize = VRD_Y_MAXDEPTH;

      {
        vrd_y__state_t *vrd_y_ss1 = vrd_y_ss;
        union vrd_y_alloc *vrd_y_ptr =
          VRD_Y__CAST (union vrd_y_alloc *,
                   VRD_Y_STACK_ALLOC (VRD_Y__CAST (VRD_Y_SIZE_T, VRD_Y_STACK_BYTES (vrd_y_stacksize))));
        if (! vrd_y_ptr)
          VRD_Y_NOMEM;
        VRD_Y_STACK_RELOCATE (vrd_y_ss_alloc, vrd_y_ss);
        VRD_Y_STACK_RELOCATE (vrd_y_vs_alloc, vrd_y_vs);
#  undef VRD_Y_STACK_RELOCATE
        if (vrd_y_ss1 != vrd_y_ssa)
          VRD_Y_STACK_FREE (vrd_y_ss1);
      }
# endif

      vrd_y_ssp = vrd_y_ss + vrd_y_size - 1;
      vrd_y_vsp = vrd_y_vs + vrd_y_size - 1;

      VRD_Y__IGNORE_USELESS_CAST_BEGIN
      VRD_Y_DPRINTF ((stderr, "Stack size increased to %ld\n",
                  VRD_Y__CAST (long, vrd_y_stacksize)));
      VRD_Y__IGNORE_USELESS_CAST_END

      if (vrd_y_ss + vrd_y_stacksize - 1 <= vrd_y_ssp)
        VRD_Y_ABORT;
    }
#endif /* !defined vrd_y_overflow && !defined VRD_Y_STACK_RELOCATE */


  if (vrd_y_state == VRD_Y_FINAL)
    VRD_Y_ACCEPT;

  goto vrd_y_backup;


/*-----------.
| vrd_y_backup.  |
`-----------*/
vrd_y_backup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  vrd_y_n = vrd_y_pact[vrd_y_state];
  if (vrd_y_pact_value_is_default (vrd_y_n))
    goto vrd_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* VRD_Y_CHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (vrd_y_char == VRD_Y_EMPTY)
    {
      VRD_Y_DPRINTF ((stderr, "Reading a token\n"));
      vrd_y_char = vrd_y_lex ();
    }

  if (vrd_y_char <= VRD_Y_EOF)
    {
      vrd_y_char = VRD_Y_EOF;
      vrd_y_token = VRD_Y_SYMBOL_VRD_Y_EOF;
      VRD_Y_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (vrd_y_char == VRD_Y_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      vrd_y_char = VRD_Y_UNDEF;
      vrd_y_token = VRD_Y_SYMBOL_VRD_Y_error;
      goto vrd_y_errlab1;
    }
  else
    {
      vrd_y_token = VRD_Y_TRANSLATE (vrd_y_char);
      VRD_Y__SYMBOL_PRINT ("Next token is", vrd_y_token, &vrd_y_lval, &vrd_y_lloc);
    }

  /* If the proper action on seeing token VRD_Y_TOKEN is to reduce or to
     detect an error, take that action.  */
  vrd_y_n += vrd_y_token;
  if (vrd_y_n < 0 || VRD_Y_LAST < vrd_y_n || vrd_y_check[vrd_y_n] != vrd_y_token)
    goto vrd_y_default;
  vrd_y_n = vrd_y_table[vrd_y_n];
  if (vrd_y_n <= 0)
    {
      if (vrd_y_table_value_is_error (vrd_y_n))
        goto vrd_y_errlab;
      vrd_y_n = -vrd_y_n;
      goto vrd_y_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (vrd_y_errstatus)
    vrd_y_errstatus--;

  /* Shift the lookahead token.  */
  VRD_Y__SYMBOL_PRINT ("Shifting", vrd_y_token, &vrd_y_lval, &vrd_y_lloc);
  vrd_y_state = vrd_y_n;
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++vrd_y_vsp = vrd_y_lval;
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  vrd_y_char = VRD_Y_EMPTY;
  goto vrd_y_newstate;


/*-----------------------------------------------------------.
| vrd_y_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
vrd_y_default:
  vrd_y_n = vrd_y_defact[vrd_y_state];
  if (vrd_y_n == 0)
    goto vrd_y_errlab;
  goto vrd_y_reduce;


/*-----------------------------.
| vrd_y_reduce -- do a reduction.  |
`-----------------------------*/
vrd_y_reduce:
  /* vrd_y_n is the number of a rule to reduce with.  */
  vrd_y_len = vrd_y_r2[vrd_y_n];

  /* If VRD_Y_LEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets VRD_Y_VAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to VRD_Y_VAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that VRD_Y_VAL may be used uninitialized.  */
  vrd_y_val = vrd_y_vsp[1-vrd_y_len];


  VRD_Y__REDUCE_PRINT (vrd_y_n);
  switch (vrd_y_n)
    {
  case 2: /* $@1: %empty  */
#line 94 "./drucompi_y.y"
                             { DrucNombreInstructions = 0;
                               DrucInitCompiler () ;}
#line 1443 "y.tab.c"
    break;

  case 3: /* drc: $@1 list_layer DRUC_REGLES list_bloc DRUC_FIN DRUC_REGLES  */
#line 100 "./drucompi_y.y"
                             { return 0;}
#line 1449 "y.tab.c"
    break;

  case 6: /* $@2: %empty  */
#line 108 "./drucompi_y.y"
                             { DrucInitRdsLayerName ( DrucInputChaine ) ;}
#line 1455 "y.tab.c"
    break;

  case 7: /* $@3: %empty  */
#line 109 "./drucompi_y.y"
                             { DrucInitRdsLayerDef ( RprTranslateParam ( DrucInputFloat ) );}
#line 1461 "y.tab.c"
    break;

  case 11: /* bloc: define  */
#line 118 "./drucompi_y.y"
                             { DrucLoadInstructionDefine () ;}
#line 1467 "y.tab.c"
    break;

  case 12: /* bloc: undefine  */
#line 119 "./drucompi_y.y"
                             { DrucLoadInstructionUndefine () ;}
#line 1473 "y.tab.c"
    break;

  case 13: /* bloc: caracter  */
#line 120 "./drucompi_y.y"
                             { DrucLoadInstructionRegle () ;}
#line 1479 "y.tab.c"
    break;

  case 14: /* bloc: relation  */
#line 121 "./drucompi_y.y"
                             { DrucLoadInstructionRegle () ;}
#line 1485 "y.tab.c"
    break;

  case 15: /* $@4: %empty  */
#line 125 "./drucompi_y.y"
                             { DrucInitDefineLayerA ( DrucInputChaine ) ;}
#line 1491 "y.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 129 "./drucompi_y.y"
                             { DrucInitDefineLayerDest ( DrucInputChaine ) ;}
#line 1497 "y.tab.c"
    break;

  case 19: /* $@6: %empty  */
#line 136 "./drucompi_y.y"
                             { DrucInitDefineLayerB ( DrucInputChaine ) ;}
#line 1503 "y.tab.c"
    break;

  case 21: /* valresiz: DRUC_FLOAT  */
#line 140 "./drucompi_y.y"
                             { DrucInitDefineValeur ( RprTranslateParam ( DrucInputFloat)) ;}
#line 1509 "y.tab.c"
    break;

  case 22: /* valresiz: DRUC_NEG_FLOAT  */
#line 141 "./drucompi_y.y"
                             { long i ; 
                               i =  RprTranslateParam ( DrucInputFloat ); 
                               DrucInitDefineValeur ( i );}
#line 1517 "y.tab.c"
    break;

  case 23: /* $@7: %empty  */
#line 146 "./drucompi_y.y"
                             { DrucInitOpUnaire   ( ) ;}
#line 1523 "y.tab.c"
    break;

  case 24: /* $@8: %empty  */
#line 147 "./drucompi_y.y"
                             { DrucInitDefineLayerB ( DrucInputChaine ) ;}
#line 1529 "y.tab.c"
    break;

  case 27: /* compose: DRUC_UNION  */
#line 152 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_UNION );}
#line 1535 "y.tab.c"
    break;

  case 28: /* compose: DRUC_INTERSECT  */
#line 153 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_INTERSECT );}
#line 1541 "y.tab.c"
    break;

  case 29: /* compose: DRUC_EXCLUSION  */
#line 154 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_EXCLUSION );}
#line 1547 "y.tab.c"
    break;

  case 30: /* compose: DRUC_INCLUSION  */
#line 155 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_INCLUSION );}
#line 1553 "y.tab.c"
    break;

  case 31: /* defmodif: DRUC_RESIZE  */
#line 158 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_RESIZE    );}
#line 1559 "y.tab.c"
    break;

  case 32: /* $@9: %empty  */
#line 162 "./drucompi_y.y"
                             { DrucInitUndefineUserLayer ( DrucInputChaine ) ;}
#line 1565 "y.tab.c"
    break;

  case 34: /* $@10: %empty  */
#line 167 "./drucompi_y.y"
                             { DrucInitRegleLayerA ( DrucInputChaine ) ;
                               DrucInitRegleInstruction ( DRUC_INSTR_CARACTERISE ) ;
                               DrucIndexMesure = -1 ;}
#line 1573 "y.tab.c"
    break;

  case 38: /* $@11: %empty  */
#line 181 "./drucompi_y.y"
                             { DrucIndexMesure ++ ;}
#line 1579 "y.tab.c"
    break;

  case 39: /* $@12: %empty  */
#line 182 "./drucompi_y.y"
                             { DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure) ;}
#line 1586 "y.tab.c"
    break;

  case 40: /* $@13: %empty  */
#line 187 "./drucompi_y.y"
                             { DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
#line 1593 "y.tab.c"
    break;

  case 42: /* $@14: %empty  */
#line 192 "./drucompi_y.y"
                             { DrucInitRegleInstruction ( DRUC_INSTR_RELATION ) ;}
#line 1599 "y.tab.c"
    break;

  case 43: /* $@15: %empty  */
#line 193 "./drucompi_y.y"
                             { DrucInitRegleLayerA ( DrucInputChaine ) ;}
#line 1605 "y.tab.c"
    break;

  case 44: /* $@16: %empty  */
#line 195 "./drucompi_y.y"
                             { DrucInitRegleLayerB ( DrucInputChaine ) ;
                               DrucIndexMesure = -1 ; }
#line 1612 "y.tab.c"
    break;

  case 48: /* $@17: %empty  */
#line 208 "./drucompi_y.y"
                             { DrucIndexMesure ++ ;}
#line 1618 "y.tab.c"
    break;

  case 49: /* $@18: %empty  */
#line 209 "./drucompi_y.y"
                             { DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure ) ;}
#line 1625 "y.tab.c"
    break;

  case 50: /* $@19: %empty  */
#line 215 "./drucompi_y.y"
                             { DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
#line 1632 "y.tab.c"
    break;

  case 52: /* config: DRUC_DISTANCE  */
#line 220 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_DISTANCE,
                                                      DrucIndexMesure );}
#line 1639 "y.tab.c"
    break;

  case 53: /* config: DRUC_INTERSECT  */
#line 222 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_INTERSECTION,
                                                      DrucIndexMesure );}
#line 1646 "y.tab.c"
    break;

  case 54: /* config: DRUC_EXTENSION  */
#line 224 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_EXTENSION,
                                                      DrucIndexMesure );}
#line 1653 "y.tab.c"
    break;

  case 55: /* config: DRUC_INCLUSION  */
#line 226 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_INCLUSION,
                                                      DrucIndexMesure );}
#line 1660 "y.tab.c"
    break;

  case 56: /* config: DRUC_ENVELOPPE  */
#line 228 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_ENVELOPPE,
                                                      DrucIndexMesure );}
#line 1667 "y.tab.c"
    break;

  case 57: /* config: DRUC_MARGE  */
#line 230 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_MARGE,
                                                      DrucIndexMesure );}
#line 1674 "y.tab.c"
    break;

  case 58: /* config: DRUC_CROIX  */
#line 232 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_CROIX,
                                                      DrucIndexMesure );}
#line 1681 "y.tab.c"
    break;

  case 59: /* mesure_rel: DRUC_SURFACE_INTER  */
#line 236 "./drucompi_y.y"
                              { DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
#line 1688 "y.tab.c"
    break;

  case 60: /* mesure_rel: DRUC_LONG_INTER  */
#line 238 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
#line 1695 "y.tab.c"
    break;

  case 61: /* mesure_rel: DRUC_LARGE_INTER  */
#line 240 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
#line 1702 "y.tab.c"
    break;

  case 62: /* mesure_rel: DRUC_PENET_INTER  */
#line 242 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PENETRE_INTER,
                                                    DrucIndexMesure );}
#line 1709 "y.tab.c"
    break;

  case 63: /* mesure_rel: DRUC_PARAL_INTER  */
#line 244 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PARALEL_INTER,
                                                    DrucIndexMesure );}
#line 1716 "y.tab.c"
    break;

  case 64: /* mesure_rel: DRUC_PERPEN_INTER  */
#line 246 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PERPEND_INTER,
                                                    DrucIndexMesure );}
#line 1723 "y.tab.c"
    break;

  case 65: /* mesure_rel: DRUC_LONGUEUR_MIN  */
#line 248 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MIN,
                                                    DrucIndexMesure );}
#line 1730 "y.tab.c"
    break;

  case 66: /* mesure_rel: DRUC_LONGUEUR_MAX  */
#line 250 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MAX,
                                                    DrucIndexMesure );}
#line 1737 "y.tab.c"
    break;

  case 67: /* mesure_rel: DRUC_LARGEUR_MIN  */
#line 252 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MIN,
                                                    DrucIndexMesure );}
#line 1744 "y.tab.c"
    break;

  case 68: /* mesure_rel: DRUC_LARGEUR_MAX  */
#line 254 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MAX,
                                                    DrucIndexMesure );}
#line 1751 "y.tab.c"
    break;

  case 69: /* mesure_rel: DRUC_FRONTALE  */
#line 256 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_FRONTALE,
                                                    DrucIndexMesure );}
#line 1758 "y.tab.c"
    break;

  case 70: /* mesure_rel: DRUC_LATERALE_MIN  */
#line 258 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LATERALE_MIN,
                                                    DrucIndexMesure );}
#line 1765 "y.tab.c"
    break;

  case 71: /* mesure_rel: DRUC_LATERALE_MAX  */
#line 260 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LATERALE_MAX,
                                                    DrucIndexMesure );}
#line 1772 "y.tab.c"
    break;

  case 72: /* mesure_rel: DRUC_SUP  */
#line 262 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_SUP,
                                                    DrucIndexMesure );}
#line 1779 "y.tab.c"
    break;

  case 73: /* mesure_rel: DRUC_INF  */
#line 264 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_INF,
                                                    DrucIndexMesure );}
#line 1786 "y.tab.c"
    break;

  case 74: /* mesure_rel: DRUC_AXIALE  */
#line 266 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_AXIALE,
                                                    DrucIndexMesure );}
#line 1793 "y.tab.c"
    break;

  case 75: /* mesure_rel: DRUC_GEODESIQUE  */
#line 268 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_GEODESIQUE,
                                                    DrucIndexMesure );}
#line 1800 "y.tab.c"
    break;

  case 76: /* mesure: DRUC_SURFACE  */
#line 272 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_SURFACE,
                                                    DrucIndexMesure );}
#line 1807 "y.tab.c"
    break;

  case 77: /* mesure: DRUC_LONGUEUR  */
#line 274 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR,
                                                    DrucIndexMesure );}
#line 1814 "y.tab.c"
    break;

  case 78: /* mesure: DRUC_LARGEUR  */
#line 276 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR,
                                                    DrucIndexMesure );}
#line 1821 "y.tab.c"
    break;

  case 79: /* mesure: DRUC_NOTCH  */
#line 278 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_NOTCH,
                                                    DrucIndexMesure );}
#line 1828 "y.tab.c"
    break;

  case 80: /* mesure: DRUC_SURFACE_INTER  */
#line 280 "./drucompi_y.y"
                               { DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
#line 1835 "y.tab.c"
    break;

  case 81: /* mesure: DRUC_LONG_INTER  */
#line 282 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
#line 1842 "y.tab.c"
    break;

  case 82: /* mesure: DRUC_LARGE_INTER  */
#line 284 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
#line 1849 "y.tab.c"
    break;

  case 83: /* compar: DRUC_MIN  */
#line 288 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_MIN,
                                                        DrucIndexMesure );}
#line 1856 "y.tab.c"
    break;

  case 84: /* compar: DRUC_MAX  */
#line 290 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_MAX,
                                                        DrucIndexMesure );}
#line 1863 "y.tab.c"
    break;

  case 85: /* compar: DRUC_INFEQ  */
#line 292 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_INFEQ,
                                                        DrucIndexMesure );}
#line 1870 "y.tab.c"
    break;

  case 86: /* compar: DRUC_SUPEQ  */
#line 294 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_SUPEQ,
                                                        DrucIndexMesure );}
#line 1877 "y.tab.c"
    break;

  case 87: /* compar: '<'  */
#line 296 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_INF,
                                                        DrucIndexMesure );}
#line 1884 "y.tab.c"
    break;

  case 88: /* compar: '>'  */
#line 298 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_SUP,
                                                        DrucIndexMesure );}
#line 1891 "y.tab.c"
    break;

  case 89: /* compar: '='  */
#line 300 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_EQUAL,
                                                        DrucIndexMesure );}
#line 1898 "y.tab.c"
    break;

  case 90: /* compar: DRUC_DIFF  */
#line 302 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_DIFF,
                                                        DrucIndexMesure );}
#line 1905 "y.tab.c"
    break;


#line 1909 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter vrd_y_char, and that requires
     that vrd_y_token be updated with the new translation.  We take the
     approach of translating immediately before every use of vrd_y_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     VRD_Y_ABORT, VRD_Y_ACCEPT, or VRD_Y_ERROR immediately after altering vrd_y_char or
     if it invokes VRD_Y_BACKUP.  In the case of VRD_Y_ABORT or VRD_Y_ACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of VRD_Y_ERROR or VRD_Y_BACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  VRD_Y__SYMBOL_PRINT ("-> $$ =", VRD_Y__CAST (vrd_y_symbol_kind_t, vrd_y_r1[vrd_y_n]), &vrd_y_val, &vrd_y_loc);

  VRD_Y_POPSTACK (vrd_y_len);
  vrd_y_len = 0;

  *++vrd_y_vsp = vrd_y_val;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int vrd_y_lhs = vrd_y_r1[vrd_y_n] - VRD_Y_NTOKENS;
    const int vrd_y_i = vrd_y_pgoto[vrd_y_lhs] + *vrd_y_ssp;
    vrd_y_state = (0 <= vrd_y_i && vrd_y_i <= VRD_Y_LAST && vrd_y_check[vrd_y_i] == *vrd_y_ssp
               ? vrd_y_table[vrd_y_i]
               : vrd_y_defgoto[vrd_y_lhs]);
  }

  goto vrd_y_newstate;


/*--------------------------------------.
| vrd_y_errlab -- here on detecting error.  |
`--------------------------------------*/
vrd_y_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  vrd_y_token = vrd_y_char == VRD_Y_EMPTY ? VRD_Y_SYMBOL_VRD_Y_EMPTY : VRD_Y_TRANSLATE (vrd_y_char);
  /* If not already recovering from an error, report this error.  */
  if (!vrd_y_errstatus)
    {
      ++vrd_y_nerrs;
      vrd_y_error (VRD_Y__("syntax error"));
    }

  if (vrd_y_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (vrd_y_char <= VRD_Y_EOF)
        {
          /* Return failure if at end of input.  */
          if (vrd_y_char == VRD_Y_EOF)
            VRD_Y_ABORT;
        }
      else
        {
          vrd_y_destruct ("Error: discarding",
                      vrd_y_token, &vrd_y_lval);
          vrd_y_char = VRD_Y_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto vrd_y_errlab1;


/*---------------------------------------------------.
| vrd_y_errorlab -- error raised explicitly by VRD_Y_ERROR.  |
`---------------------------------------------------*/
vrd_y_errorlab:
  /* Pacify compilers when the user code never invokes VRD_Y_ERROR and the
     label vrd_y_errorlab therefore never appears in user code.  */
  if (0)
    VRD_Y_ERROR;
  ++vrd_y_nerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this VRD_Y_ERROR.  */
  VRD_Y_POPSTACK (vrd_y_len);
  vrd_y_len = 0;
  VRD_Y__STACK_PRINT (vrd_y_ss, vrd_y_ssp);
  vrd_y_state = *vrd_y_ssp;
  goto vrd_y_errlab1;


/*-------------------------------------------------------------.
| vrd_y_errlab1 -- common code for both syntax error and VRD_Y_ERROR.  |
`-------------------------------------------------------------*/
vrd_y_errlab1:
  vrd_y_errstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      vrd_y_n = vrd_y_pact[vrd_y_state];
      if (!vrd_y_pact_value_is_default (vrd_y_n))
        {
          vrd_y_n += VRD_Y_SYMBOL_VRD_Y_error;
          if (0 <= vrd_y_n && vrd_y_n <= VRD_Y_LAST && vrd_y_check[vrd_y_n] == VRD_Y_SYMBOL_VRD_Y_error)
            {
              vrd_y_n = vrd_y_table[vrd_y_n];
              if (0 < vrd_y_n)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (vrd_y_ssp == vrd_y_ss)
        VRD_Y_ABORT;


      vrd_y_destruct ("Error: popping",
                  VRD_Y__ACCESSING_SYMBOL (vrd_y_state), vrd_y_vsp);
      VRD_Y_POPSTACK (1);
      vrd_y_state = *vrd_y_ssp;
      VRD_Y__STACK_PRINT (vrd_y_ss, vrd_y_ssp);
    }

  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++vrd_y_vsp = vrd_y_lval;
  VRD_Y__IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  VRD_Y__SYMBOL_PRINT ("Shifting", VRD_Y__ACCESSING_SYMBOL (vrd_y_n), vrd_y_vsp, vrd_y_lsp);

  vrd_y_state = vrd_y_n;
  goto vrd_y_newstate;


/*-------------------------------------.
| vrd_y_acceptlab -- VRD_Y_ACCEPT comes here.  |
`-------------------------------------*/
vrd_y_acceptlab:
  vrd_y_result = 0;
  goto vrd_y_returnlab;


/*-----------------------------------.
| vrd_y_abortlab -- VRD_Y_ABORT comes here.  |
`-----------------------------------*/
vrd_y_abortlab:
  vrd_y_result = 1;
  goto vrd_y_returnlab;


/*-----------------------------------------------------------.
| vrd_y_exhaustedlab -- VRD_Y_NOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
vrd_y_exhaustedlab:
  vrd_y_error (VRD_Y__("memory exhausted"));
  vrd_y_result = 2;
  goto vrd_y_returnlab;


/*----------------------------------------------------------.
| vrd_y_returnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
vrd_y_returnlab:
  if (vrd_y_char != VRD_Y_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      vrd_y_token = VRD_Y_TRANSLATE (vrd_y_char);
      vrd_y_destruct ("Cleanup: discarding lookahead",
                  vrd_y_token, &vrd_y_lval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this VRD_Y_ABORT or VRD_Y_ACCEPT.  */
  VRD_Y_POPSTACK (vrd_y_len);
  VRD_Y__STACK_PRINT (vrd_y_ss, vrd_y_ssp);
  while (vrd_y_ssp != vrd_y_ss)
    {
      vrd_y_destruct ("Cleanup: popping",
                  VRD_Y__ACCESSING_SYMBOL (+*vrd_y_ssp), vrd_y_vsp);
      VRD_Y_POPSTACK (1);
    }
#ifndef vrd_y_overflow
  if (vrd_y_ss != vrd_y_ssa)
    VRD_Y_STACK_FREE (vrd_y_ss);
#endif

  return vrd_y_result;
}

#line 307 "./drucompi_y.y"

