/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "./drucompi_y.y"

#include <stdio.h>
#include "mph.h"
#include "mut.h"
#include "rds.h"
#include "rwi.h"
#include "rut.h"
#include "rtl.h"
#include "rfm.h"
#include "rpr.h"
#include "drucutil.h"
#include "drucompi.h"

/*------------------------------------------------------------\
|                                                             |
|                  Druc MODIFICATIONS                         |
|                                                             |
|  Patrick: 07/03/94                                          |
|    Ajouter DRUC_FRONTALE et DRUC_LATERALE_MIN               |
|    qui etaient oublies dans les derivations                 |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                  Druc Variables LEX/YACC                    |
|                                                             |
\------------------------------------------------------------*/
extern int   yylineno;
extern FILE *yyin;
       int   DrucIndexMesure;
       int   DrucInputEntier;
       int   DrucNegatif;
       float DrucInputFloat;
       char  DrucInputChaine[DRUC_MAX_STRING_BUFFER + 1];
extern int   yylex ();

#line 108 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    DRUC_REGLES = 258,             /* DRUC_REGLES  */
    DRUC_FIN = 259,                /* DRUC_FIN  */
    DRUC_REGLE = 260,              /* DRUC_REGLE  */
    DRUC_DEFINE = 261,             /* DRUC_DEFINE  */
    DRUC_UNDEFINE = 262,           /* DRUC_UNDEFINE  */
    DRUC_CARACTERISE = 263,        /* DRUC_CARACTERISE  */
    DRUC_RELATION = 264,           /* DRUC_RELATION  */
    DRUC_LAYER = 265,              /* DRUC_LAYER  */
    DRUC_NOM = 266,                /* DRUC_NOM  */
    DRUC_UNION = 267,              /* DRUC_UNION  */
    DRUC_EXCLUSION = 268,          /* DRUC_EXCLUSION  */
    DRUC_RESIZE = 269,             /* DRUC_RESIZE  */
    DRUC_ENVELOPPE = 270,          /* DRUC_ENVELOPPE  */
    DRUC_MARGE = 271,              /* DRUC_MARGE  */
    DRUC_CROIX = 272,              /* DRUC_CROIX  */
    DRUC_INTERSECT = 273,          /* DRUC_INTERSECT  */
    DRUC_EXTENSION = 274,          /* DRUC_EXTENSION  */
    DRUC_INCLUSION = 275,          /* DRUC_INCLUSION  */
    DRUC_DISTANCE = 276,           /* DRUC_DISTANCE  */
    DRUC_SURFACE_INTER = 277,      /* DRUC_SURFACE_INTER  */
    DRUC_LONG_INTER = 278,         /* DRUC_LONG_INTER  */
    DRUC_LARGE_INTER = 279,        /* DRUC_LARGE_INTER  */
    DRUC_PENET_INTER = 280,        /* DRUC_PENET_INTER  */
    DRUC_PARAL_INTER = 281,        /* DRUC_PARAL_INTER  */
    DRUC_PERPEN_INTER = 282,       /* DRUC_PERPEN_INTER  */
    DRUC_FRONTALE = 283,           /* DRUC_FRONTALE  */
    DRUC_LATERALE_MIN = 284,       /* DRUC_LATERALE_MIN  */
    DRUC_LATERALE_MAX = 285,       /* DRUC_LATERALE_MAX  */
    DRUC_LARGEUR_MIN = 286,        /* DRUC_LARGEUR_MIN  */
    DRUC_LARGEUR_MAX = 287,        /* DRUC_LARGEUR_MAX  */
    DRUC_LONGUEUR_MIN = 288,       /* DRUC_LONGUEUR_MIN  */
    DRUC_LONGUEUR_MAX = 289,       /* DRUC_LONGUEUR_MAX  */
    DRUC_SUP = 290,                /* DRUC_SUP  */
    DRUC_INF = 291,                /* DRUC_INF  */
    DRUC_AXIALE = 292,             /* DRUC_AXIALE  */
    DRUC_GEODESIQUE = 293,         /* DRUC_GEODESIQUE  */
    DRUC_SURFACE = 294,            /* DRUC_SURFACE  */
    DRUC_LONGUEUR = 295,           /* DRUC_LONGUEUR  */
    DRUC_LARGEUR = 296,            /* DRUC_LARGEUR  */
    DRUC_MIN = 297,                /* DRUC_MIN  */
    DRUC_MAX = 298,                /* DRUC_MAX  */
    DRUC_INFEQ = 299,              /* DRUC_INFEQ  */
    DRUC_SUPEQ = 300,              /* DRUC_SUPEQ  */
    DRUC_DIFF = 301,               /* DRUC_DIFF  */
    DRUC_NOTCH = 302,              /* DRUC_NOTCH  */
    DRUC_DESTINATION = 303,        /* DRUC_DESTINATION  */
    DRUC_ENTIER = 304,             /* DRUC_ENTIER  */
    DRUC_FLOAT = 305,              /* DRUC_FLOAT  */
    DRUC_NEG_FLOAT = 306           /* DRUC_NEG_FLOAT  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define DRUC_REGLES 258
#define DRUC_FIN 259
#define DRUC_REGLE 260
#define DRUC_DEFINE 261
#define DRUC_UNDEFINE 262
#define DRUC_CARACTERISE 263
#define DRUC_RELATION 264
#define DRUC_LAYER 265
#define DRUC_NOM 266
#define DRUC_UNION 267
#define DRUC_EXCLUSION 268
#define DRUC_RESIZE 269
#define DRUC_ENVELOPPE 270
#define DRUC_MARGE 271
#define DRUC_CROIX 272
#define DRUC_INTERSECT 273
#define DRUC_EXTENSION 274
#define DRUC_INCLUSION 275
#define DRUC_DISTANCE 276
#define DRUC_SURFACE_INTER 277
#define DRUC_LONG_INTER 278
#define DRUC_LARGE_INTER 279
#define DRUC_PENET_INTER 280
#define DRUC_PARAL_INTER 281
#define DRUC_PERPEN_INTER 282
#define DRUC_FRONTALE 283
#define DRUC_LATERALE_MIN 284
#define DRUC_LATERALE_MAX 285
#define DRUC_LARGEUR_MIN 286
#define DRUC_LARGEUR_MAX 287
#define DRUC_LONGUEUR_MIN 288
#define DRUC_LONGUEUR_MAX 289
#define DRUC_SUP 290
#define DRUC_INF 291
#define DRUC_AXIALE 292
#define DRUC_GEODESIQUE 293
#define DRUC_SURFACE 294
#define DRUC_LONGUEUR 295
#define DRUC_LARGEUR 296
#define DRUC_MIN 297
#define DRUC_MAX 298
#define DRUC_INFEQ 299
#define DRUC_SUPEQ 300
#define DRUC_DIFF 301
#define DRUC_NOTCH 302
#define DRUC_DESTINATION 303
#define DRUC_ENTIER 304
#define DRUC_FLOAT 305
#define DRUC_NEG_FLOAT 306

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DRUC_REGLES = 3,                /* DRUC_REGLES  */
  YYSYMBOL_DRUC_FIN = 4,                   /* DRUC_FIN  */
  YYSYMBOL_DRUC_REGLE = 5,                 /* DRUC_REGLE  */
  YYSYMBOL_DRUC_DEFINE = 6,                /* DRUC_DEFINE  */
  YYSYMBOL_DRUC_UNDEFINE = 7,              /* DRUC_UNDEFINE  */
  YYSYMBOL_DRUC_CARACTERISE = 8,           /* DRUC_CARACTERISE  */
  YYSYMBOL_DRUC_RELATION = 9,              /* DRUC_RELATION  */
  YYSYMBOL_DRUC_LAYER = 10,                /* DRUC_LAYER  */
  YYSYMBOL_DRUC_NOM = 11,                  /* DRUC_NOM  */
  YYSYMBOL_DRUC_UNION = 12,                /* DRUC_UNION  */
  YYSYMBOL_DRUC_EXCLUSION = 13,            /* DRUC_EXCLUSION  */
  YYSYMBOL_DRUC_RESIZE = 14,               /* DRUC_RESIZE  */
  YYSYMBOL_DRUC_ENVELOPPE = 15,            /* DRUC_ENVELOPPE  */
  YYSYMBOL_DRUC_MARGE = 16,                /* DRUC_MARGE  */
  YYSYMBOL_DRUC_CROIX = 17,                /* DRUC_CROIX  */
  YYSYMBOL_DRUC_INTERSECT = 18,            /* DRUC_INTERSECT  */
  YYSYMBOL_DRUC_EXTENSION = 19,            /* DRUC_EXTENSION  */
  YYSYMBOL_DRUC_INCLUSION = 20,            /* DRUC_INCLUSION  */
  YYSYMBOL_DRUC_DISTANCE = 21,             /* DRUC_DISTANCE  */
  YYSYMBOL_DRUC_SURFACE_INTER = 22,        /* DRUC_SURFACE_INTER  */
  YYSYMBOL_DRUC_LONG_INTER = 23,           /* DRUC_LONG_INTER  */
  YYSYMBOL_DRUC_LARGE_INTER = 24,          /* DRUC_LARGE_INTER  */
  YYSYMBOL_DRUC_PENET_INTER = 25,          /* DRUC_PENET_INTER  */
  YYSYMBOL_DRUC_PARAL_INTER = 26,          /* DRUC_PARAL_INTER  */
  YYSYMBOL_DRUC_PERPEN_INTER = 27,         /* DRUC_PERPEN_INTER  */
  YYSYMBOL_DRUC_FRONTALE = 28,             /* DRUC_FRONTALE  */
  YYSYMBOL_DRUC_LATERALE_MIN = 29,         /* DRUC_LATERALE_MIN  */
  YYSYMBOL_DRUC_LATERALE_MAX = 30,         /* DRUC_LATERALE_MAX  */
  YYSYMBOL_DRUC_LARGEUR_MIN = 31,          /* DRUC_LARGEUR_MIN  */
  YYSYMBOL_DRUC_LARGEUR_MAX = 32,          /* DRUC_LARGEUR_MAX  */
  YYSYMBOL_DRUC_LONGUEUR_MIN = 33,         /* DRUC_LONGUEUR_MIN  */
  YYSYMBOL_DRUC_LONGUEUR_MAX = 34,         /* DRUC_LONGUEUR_MAX  */
  YYSYMBOL_DRUC_SUP = 35,                  /* DRUC_SUP  */
  YYSYMBOL_DRUC_INF = 36,                  /* DRUC_INF  */
  YYSYMBOL_DRUC_AXIALE = 37,               /* DRUC_AXIALE  */
  YYSYMBOL_DRUC_GEODESIQUE = 38,           /* DRUC_GEODESIQUE  */
  YYSYMBOL_DRUC_SURFACE = 39,              /* DRUC_SURFACE  */
  YYSYMBOL_DRUC_LONGUEUR = 40,             /* DRUC_LONGUEUR  */
  YYSYMBOL_DRUC_LARGEUR = 41,              /* DRUC_LARGEUR  */
  YYSYMBOL_DRUC_MIN = 42,                  /* DRUC_MIN  */
  YYSYMBOL_DRUC_MAX = 43,                  /* DRUC_MAX  */
  YYSYMBOL_DRUC_INFEQ = 44,                /* DRUC_INFEQ  */
  YYSYMBOL_DRUC_SUPEQ = 45,                /* DRUC_SUPEQ  */
  YYSYMBOL_DRUC_DIFF = 46,                 /* DRUC_DIFF  */
  YYSYMBOL_DRUC_NOTCH = 47,                /* DRUC_NOTCH  */
  YYSYMBOL_DRUC_DESTINATION = 48,          /* DRUC_DESTINATION  */
  YYSYMBOL_DRUC_ENTIER = 49,               /* DRUC_ENTIER  */
  YYSYMBOL_DRUC_FLOAT = 50,                /* DRUC_FLOAT  */
  YYSYMBOL_DRUC_NEG_FLOAT = 51,            /* DRUC_NEG_FLOAT  */
  YYSYMBOL_52_ = 52,                       /* ';'  */
  YYSYMBOL_53_ = 53,                       /* ','  */
  YYSYMBOL_54_ = 54,                       /* '('  */
  YYSYMBOL_55_ = 55,                       /* ')'  */
  YYSYMBOL_56_ = 56,                       /* ':'  */
  YYSYMBOL_57_ = 57,                       /* '<'  */
  YYSYMBOL_58_ = 58,                       /* '>'  */
  YYSYMBOL_59_ = 59,                       /* '='  */
  YYSYMBOL_YYACCEPT = 60,                  /* $accept  */
  YYSYMBOL_drc = 61,                       /* drc  */
  YYSYMBOL_62_1 = 62,                      /* $@1  */
  YYSYMBOL_list_layer = 63,                /* list_layer  */
  YYSYMBOL_layer = 64,                     /* layer  */
  YYSYMBOL_65_2 = 65,                      /* $@2  */
  YYSYMBOL_66_3 = 66,                      /* $@3  */
  YYSYMBOL_list_bloc = 67,                 /* list_bloc  */
  YYSYMBOL_bloc = 68,                      /* bloc  */
  YYSYMBOL_define = 69,                    /* define  */
  YYSYMBOL_70_4 = 70,                      /* $@4  */
  YYSYMBOL_71_5 = 71,                      /* $@5  */
  YYSYMBOL_resiz = 72,                     /* resiz  */
  YYSYMBOL_73_6 = 73,                      /* $@6  */
  YYSYMBOL_valresiz = 74,                  /* valresiz  */
  YYSYMBOL_defoper = 75,                   /* defoper  */
  YYSYMBOL_76_7 = 76,                      /* $@7  */
  YYSYMBOL_77_8 = 77,                      /* $@8  */
  YYSYMBOL_compose = 78,                   /* compose  */
  YYSYMBOL_defmodif = 79,                  /* defmodif  */
  YYSYMBOL_undefine = 80,                  /* undefine  */
  YYSYMBOL_81_9 = 81,                      /* $@9  */
  YYSYMBOL_caracter = 82,                  /* caracter  */
  YYSYMBOL_83_10 = 83,                     /* $@10  */
  YYSYMBOL_lst_rgl_1 = 84,                 /* lst_rgl_1  */
  YYSYMBOL_regle_1 = 85,                   /* regle_1  */
  YYSYMBOL_86_11 = 86,                     /* $@11  */
  YYSYMBOL_87_12 = 87,                     /* $@12  */
  YYSYMBOL_88_13 = 88,                     /* $@13  */
  YYSYMBOL_relation = 89,                  /* relation  */
  YYSYMBOL_90_14 = 90,                     /* $@14  */
  YYSYMBOL_91_15 = 91,                     /* $@15  */
  YYSYMBOL_92_16 = 92,                     /* $@16  */
  YYSYMBOL_lst_rgl_2 = 93,                 /* lst_rgl_2  */
  YYSYMBOL_regle_2 = 94,                   /* regle_2  */
  YYSYMBOL_95_17 = 95,                     /* $@17  */
  YYSYMBOL_96_18 = 96,                     /* $@18  */
  YYSYMBOL_97_19 = 97,                     /* $@19  */
  YYSYMBOL_config = 98,                    /* config  */
  YYSYMBOL_mesure_rel = 99,                /* mesure_rel  */
  YYSYMBOL_mesure = 100,                   /* mesure  */
  YYSYMBOL_compar = 101                    /* compar  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   101

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  42
/* YYNRULES -- Number of rules.  */
#define YYNRULES  90
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  136

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   306


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      54,    55,     2,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    52,
      57,    59,    58,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    94,    94,    94,   103,   104,   108,   109,   107,   113,
     115,   118,   119,   120,   121,   125,   129,   124,   133,   136,
     136,   140,   141,   146,   147,   146,   149,   152,   153,   154,
     155,   158,   162,   161,   167,   166,   176,   178,   181,   182,
     187,   181,   192,   193,   195,   192,   203,   205,   208,   209,
     215,   208,   220,   222,   224,   226,   228,   230,   232,   236,
     238,   240,   242,   244,   246,   248,   250,   252,   254,   256,
     258,   260,   262,   264,   266,   268,   272,   274,   276,   278,
     280,   282,   284,   288,   290,   292,   294,   296,   298,   300,
     302
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DRUC_REGLES",
  "DRUC_FIN", "DRUC_REGLE", "DRUC_DEFINE", "DRUC_UNDEFINE",
  "DRUC_CARACTERISE", "DRUC_RELATION", "DRUC_LAYER", "DRUC_NOM",
  "DRUC_UNION", "DRUC_EXCLUSION", "DRUC_RESIZE", "DRUC_ENVELOPPE",
  "DRUC_MARGE", "DRUC_CROIX", "DRUC_INTERSECT", "DRUC_EXTENSION",
  "DRUC_INCLUSION", "DRUC_DISTANCE", "DRUC_SURFACE_INTER",
  "DRUC_LONG_INTER", "DRUC_LARGE_INTER", "DRUC_PENET_INTER",
  "DRUC_PARAL_INTER", "DRUC_PERPEN_INTER", "DRUC_FRONTALE",
  "DRUC_LATERALE_MIN", "DRUC_LATERALE_MAX", "DRUC_LARGEUR_MIN",
  "DRUC_LARGEUR_MAX", "DRUC_LONGUEUR_MIN", "DRUC_LONGUEUR_MAX", "DRUC_SUP",
  "DRUC_INF", "DRUC_AXIALE", "DRUC_GEODESIQUE", "DRUC_SURFACE",
  "DRUC_LONGUEUR", "DRUC_LARGEUR", "DRUC_MIN", "DRUC_MAX", "DRUC_INFEQ",
  "DRUC_SUPEQ", "DRUC_DIFF", "DRUC_NOTCH", "DRUC_DESTINATION",
  "DRUC_ENTIER", "DRUC_FLOAT", "DRUC_NEG_FLOAT", "';'", "','", "'('",
  "')'", "':'", "'<'", "'>'", "'='", "$accept", "drc", "$@1", "list_layer",
  "layer", "$@2", "$@3", "list_bloc", "bloc", "define", "$@4", "$@5",
  "resiz", "$@6", "valresiz", "defoper", "$@7", "$@8", "compose",
  "defmodif", "undefine", "$@9", "caracter", "$@10", "lst_rgl_1",
  "regle_1", "$@11", "$@12", "$@13", "relation", "$@14", "$@15", "$@16",
  "lst_rgl_2", "regle_2", "$@17", "$@18", "$@19", "config", "mesure_rel",
  "mesure", "compar", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-35)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -35,     7,     5,   -35,    18,     3,   -35,   -35,    29,   -35,
     -20,    20,    22,    58,   -35,    10,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,    59,    36,   -35,   -12,    19,
      21,    17,   -35,   -35,   -35,    -9,   -35,    69,    23,   -35,
     -35,   -35,    27,    63,   -35,    -5,   -35,    67,    14,    68,
     -35,    31,    32,    33,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,    26,    34,    71,    35,
      78,   -35,   -35,   -19,   -35,    -4,   -35,    14,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -34,    38,    37,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,    40,   -35,
     -35,   -35,    39,    41,    28,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,    30,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -35,   -34,    42,   -35,    44,   -35
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     0,     1,     0,     0,     5,     6,     0,     4,
       0,     0,     0,     0,    42,     0,    10,    11,    12,    13,
      14,     7,    15,    32,    34,     0,     0,     9,     0,     0,
       0,     0,    43,     3,     8,     0,    33,     0,     0,    19,
      21,    22,     0,     0,    38,     0,    37,     0,     0,     0,
      31,    26,     0,     0,    36,    44,    27,    29,    28,    30,
      20,    16,    23,    18,    39,    35,     0,     0,     0,     0,
       0,    17,    24,     0,    48,     0,    47,     0,    80,    81,
      82,    76,    77,    78,    79,     0,     0,     0,    46,    25,
      83,    84,    85,    86,    90,    87,    88,    89,     0,    49,
      45,    40,     0,     0,     0,    41,    56,    57,    58,    53,
      54,    55,    52,     0,    59,    60,    61,    62,    63,    64,
      69,    70,    71,    67,    68,    65,    66,    72,    73,    74,
      75,     0,     0,    50,     0,    51
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -35,   -35,   -35,   -35,    83,   -35,   -35,   -35,    79,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,    24,   -35,
     -35,   -35,   -35,   -35,   -35,    52,   -35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,    25,   -35,   -35,   -35,   -35,   -35,
     -35,   -33
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     2,     5,     6,    10,    28,    15,    16,    17,
      29,    67,    42,    48,    43,    63,    68,    77,    60,    51,
      18,    30,    19,    31,    45,    46,    52,    69,   103,    20,
      25,    38,    66,    75,    76,    86,   102,   134,   113,   131,
      85,    98
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      44,    74,    39,    78,    79,    80,     8,     3,    90,    91,
      92,    93,    94,     4,    26,     4,    11,    12,    13,    14,
      81,    82,    83,    95,    96,    97,    56,    57,    84,     7,
      21,    22,    58,    23,    59,    11,    12,    13,    14,    33,
      34,    40,    41,   106,   107,   108,   109,   110,   111,   112,
      53,    87,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,    24,
      32,    37,    35,    36,    44,    49,    47,    50,    55,    61,
      70,    64,    72,    74,    62,    65,    71,    99,     9,   100,
     101,    73,   133,   105,    27,   104,   135,    54,   132,     0,
      88,    89
};

static const yytype_int16 yycheck[] =
{
       5,     5,    11,    22,    23,    24,     3,     0,    42,    43,
      44,    45,    46,    10,     4,    10,     6,     7,     8,     9,
      39,    40,    41,    57,    58,    59,    12,    13,    47,    11,
      50,    11,    18,    11,    20,     6,     7,     8,     9,     3,
      52,    50,    51,    15,    16,    17,    18,    19,    20,    21,
      55,    55,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    11,
      11,    54,    53,    52,     5,    48,    53,    14,    11,    11,
      54,    49,    11,     5,    53,    52,    52,    49,     5,    52,
      50,    56,    50,    52,    15,    56,    52,    45,   131,    -1,
      75,    77
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    61,    62,     0,    10,    63,    64,    11,     3,    64,
      65,     6,     7,     8,     9,    67,    68,    69,    80,    82,
      89,    50,    11,    11,    11,    90,     4,    68,    66,    70,
      81,    83,    11,     3,    52,    53,    52,    54,    91,    11,
      50,    51,    72,    74,     5,    84,    85,    53,    73,    48,
      14,    79,    86,    55,    85,    11,    12,    13,    18,    20,
      78,    11,    53,    75,    49,    52,    92,    71,    76,    87,
      54,    52,    11,    56,     5,    93,    94,    77,    22,    23,
      24,    39,    40,    41,    47,   100,    95,    55,    94,    78,
      42,    43,    44,    45,    46,    57,    58,    59,   101,    49,
      52,    50,    96,    88,    56,    52,    15,    16,    17,    18,
      19,    20,    21,    98,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    99,   101,    50,    97,    52
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    60,    62,    61,    63,    63,    65,    66,    64,    67,
      67,    68,    68,    68,    68,    70,    71,    69,    72,    73,
      72,    74,    74,    76,    77,    75,    75,    78,    78,    78,
      78,    79,    81,    80,    83,    82,    84,    84,    86,    87,
      88,    85,    90,    91,    92,    89,    93,    93,    95,    96,
      97,    94,    98,    98,    98,    98,    98,    98,    98,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   101,   101,   101,   101,   101,   101,   101,
     101
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     6,     2,     1,     0,     0,     6,     2,
       1,     1,     1,     1,     1,     0,     0,     9,     3,     0,
       3,     1,     1,     0,     0,     5,     0,     1,     1,     1,
       1,     1,     0,     4,     0,     7,     2,     1,     0,     0,
       0,    10,     0,     0,     0,    11,     2,     1,     0,     0,
       0,    11,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 94 "./drucompi_y.y"
                             { DrucNombreInstructions = 0;
                               DrucInitCompiler () ;}
#line 1443 "y.tab.c"
    break;

  case 3: /* drc: $@1 list_layer DRUC_REGLES list_bloc DRUC_FIN DRUC_REGLES  */
#line 100 "./drucompi_y.y"
                             { return 0;}
#line 1449 "y.tab.c"
    break;

  case 6: /* $@2: %empty  */
#line 108 "./drucompi_y.y"
                             { DrucInitRdsLayerName ( DrucInputChaine ) ;}
#line 1455 "y.tab.c"
    break;

  case 7: /* $@3: %empty  */
#line 109 "./drucompi_y.y"
                             { DrucInitRdsLayerDef ( RprTranslateParam ( DrucInputFloat ) );}
#line 1461 "y.tab.c"
    break;

  case 11: /* bloc: define  */
#line 118 "./drucompi_y.y"
                             { DrucLoadInstructionDefine () ;}
#line 1467 "y.tab.c"
    break;

  case 12: /* bloc: undefine  */
#line 119 "./drucompi_y.y"
                             { DrucLoadInstructionUndefine () ;}
#line 1473 "y.tab.c"
    break;

  case 13: /* bloc: caracter  */
#line 120 "./drucompi_y.y"
                             { DrucLoadInstructionRegle () ;}
#line 1479 "y.tab.c"
    break;

  case 14: /* bloc: relation  */
#line 121 "./drucompi_y.y"
                             { DrucLoadInstructionRegle () ;}
#line 1485 "y.tab.c"
    break;

  case 15: /* $@4: %empty  */
#line 125 "./drucompi_y.y"
                             { DrucInitDefineLayerA ( DrucInputChaine ) ;}
#line 1491 "y.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 129 "./drucompi_y.y"
                             { DrucInitDefineLayerDest ( DrucInputChaine ) ;}
#line 1497 "y.tab.c"
    break;

  case 19: /* $@6: %empty  */
#line 136 "./drucompi_y.y"
                             { DrucInitDefineLayerB ( DrucInputChaine ) ;}
#line 1503 "y.tab.c"
    break;

  case 21: /* valresiz: DRUC_FLOAT  */
#line 140 "./drucompi_y.y"
                             { DrucInitDefineValeur ( RprTranslateParam ( DrucInputFloat)) ;}
#line 1509 "y.tab.c"
    break;

  case 22: /* valresiz: DRUC_NEG_FLOAT  */
#line 141 "./drucompi_y.y"
                             { long i ; 
                               i =  RprTranslateParam ( DrucInputFloat ); 
                               DrucInitDefineValeur ( i );}
#line 1517 "y.tab.c"
    break;

  case 23: /* $@7: %empty  */
#line 146 "./drucompi_y.y"
                             { DrucInitOpUnaire   ( ) ;}
#line 1523 "y.tab.c"
    break;

  case 24: /* $@8: %empty  */
#line 147 "./drucompi_y.y"
                             { DrucInitDefineLayerB ( DrucInputChaine ) ;}
#line 1529 "y.tab.c"
    break;

  case 27: /* compose: DRUC_UNION  */
#line 152 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_UNION );}
#line 1535 "y.tab.c"
    break;

  case 28: /* compose: DRUC_INTERSECT  */
#line 153 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_INTERSECT );}
#line 1541 "y.tab.c"
    break;

  case 29: /* compose: DRUC_EXCLUSION  */
#line 154 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_EXCLUSION );}
#line 1547 "y.tab.c"
    break;

  case 30: /* compose: DRUC_INCLUSION  */
#line 155 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_INCLUSION );}
#line 1553 "y.tab.c"
    break;

  case 31: /* defmodif: DRUC_RESIZE  */
#line 158 "./drucompi_y.y"
                             { DrucStructDefineOpCompose( DRUC_COMPOSE_RESIZE    );}
#line 1559 "y.tab.c"
    break;

  case 32: /* $@9: %empty  */
#line 162 "./drucompi_y.y"
                             { DrucInitUndefineUserLayer ( DrucInputChaine ) ;}
#line 1565 "y.tab.c"
    break;

  case 34: /* $@10: %empty  */
#line 167 "./drucompi_y.y"
                             { DrucInitRegleLayerA ( DrucInputChaine ) ;
                               DrucInitRegleInstruction ( DRUC_INSTR_CARACTERISE ) ;
                               DrucIndexMesure = -1 ;}
#line 1573 "y.tab.c"
    break;

  case 38: /* $@11: %empty  */
#line 181 "./drucompi_y.y"
                             { DrucIndexMesure ++ ;}
#line 1579 "y.tab.c"
    break;

  case 39: /* $@12: %empty  */
#line 182 "./drucompi_y.y"
                             { DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure) ;}
#line 1586 "y.tab.c"
    break;

  case 40: /* $@13: %empty  */
#line 187 "./drucompi_y.y"
                             { DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
#line 1593 "y.tab.c"
    break;

  case 42: /* $@14: %empty  */
#line 192 "./drucompi_y.y"
                             { DrucInitRegleInstruction ( DRUC_INSTR_RELATION ) ;}
#line 1599 "y.tab.c"
    break;

  case 43: /* $@15: %empty  */
#line 193 "./drucompi_y.y"
                             { DrucInitRegleLayerA ( DrucInputChaine ) ;}
#line 1605 "y.tab.c"
    break;

  case 44: /* $@16: %empty  */
#line 195 "./drucompi_y.y"
                             { DrucInitRegleLayerB ( DrucInputChaine ) ;
                               DrucIndexMesure = -1 ; }
#line 1612 "y.tab.c"
    break;

  case 48: /* $@17: %empty  */
#line 208 "./drucompi_y.y"
                             { DrucIndexMesure ++ ;}
#line 1618 "y.tab.c"
    break;

  case 49: /* $@18: %empty  */
#line 209 "./drucompi_y.y"
                             { DrucInitRegleNumero ( DrucInputEntier,
                                                     DrucIndexMesure ) ;}
#line 1625 "y.tab.c"
    break;

  case 50: /* $@19: %empty  */
#line 215 "./drucompi_y.y"
                             { DrucInitRegleValeur ( RprTranslateParam ( DrucInputFloat ),
                                                     DrucIndexMesure );}
#line 1632 "y.tab.c"
    break;

  case 52: /* config: DRUC_DISTANCE  */
#line 220 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_DISTANCE,
                                                      DrucIndexMesure );}
#line 1639 "y.tab.c"
    break;

  case 53: /* config: DRUC_INTERSECT  */
#line 222 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_INTERSECTION,
                                                      DrucIndexMesure );}
#line 1646 "y.tab.c"
    break;

  case 54: /* config: DRUC_EXTENSION  */
#line 224 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_EXTENSION,
                                                      DrucIndexMesure );}
#line 1653 "y.tab.c"
    break;

  case 55: /* config: DRUC_INCLUSION  */
#line 226 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_INCLUSION,
                                                      DrucIndexMesure );}
#line 1660 "y.tab.c"
    break;

  case 56: /* config: DRUC_ENVELOPPE  */
#line 228 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_ENVELOPPE,
                                                      DrucIndexMesure );}
#line 1667 "y.tab.c"
    break;

  case 57: /* config: DRUC_MARGE  */
#line 230 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_MARGE,
                                                      DrucIndexMesure );}
#line 1674 "y.tab.c"
    break;

  case 58: /* config: DRUC_CROIX  */
#line 232 "./drucompi_y.y"
                             { DrucInitRegleRelation( DRUC_RELATION_CROIX,
                                                      DrucIndexMesure );}
#line 1681 "y.tab.c"
    break;

  case 59: /* mesure_rel: DRUC_SURFACE_INTER  */
#line 236 "./drucompi_y.y"
                              { DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
#line 1688 "y.tab.c"
    break;

  case 60: /* mesure_rel: DRUC_LONG_INTER  */
#line 238 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
#line 1695 "y.tab.c"
    break;

  case 61: /* mesure_rel: DRUC_LARGE_INTER  */
#line 240 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
#line 1702 "y.tab.c"
    break;

  case 62: /* mesure_rel: DRUC_PENET_INTER  */
#line 242 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PENETRE_INTER,
                                                    DrucIndexMesure );}
#line 1709 "y.tab.c"
    break;

  case 63: /* mesure_rel: DRUC_PARAL_INTER  */
#line 244 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PARALEL_INTER,
                                                    DrucIndexMesure );}
#line 1716 "y.tab.c"
    break;

  case 64: /* mesure_rel: DRUC_PERPEN_INTER  */
#line 246 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_PERPEND_INTER,
                                                    DrucIndexMesure );}
#line 1723 "y.tab.c"
    break;

  case 65: /* mesure_rel: DRUC_LONGUEUR_MIN  */
#line 248 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MIN,
                                                    DrucIndexMesure );}
#line 1730 "y.tab.c"
    break;

  case 66: /* mesure_rel: DRUC_LONGUEUR_MAX  */
#line 250 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_MAX,
                                                    DrucIndexMesure );}
#line 1737 "y.tab.c"
    break;

  case 67: /* mesure_rel: DRUC_LARGEUR_MIN  */
#line 252 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MIN,
                                                    DrucIndexMesure );}
#line 1744 "y.tab.c"
    break;

  case 68: /* mesure_rel: DRUC_LARGEUR_MAX  */
#line 254 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_MAX,
                                                    DrucIndexMesure );}
#line 1751 "y.tab.c"
    break;

  case 69: /* mesure_rel: DRUC_FRONTALE  */
#line 256 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_FRONTALE,
                                                    DrucIndexMesure );}
#line 1758 "y.tab.c"
    break;

  case 70: /* mesure_rel: DRUC_LATERALE_MIN  */
#line 258 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LATERALE_MIN,
                                                    DrucIndexMesure );}
#line 1765 "y.tab.c"
    break;

  case 71: /* mesure_rel: DRUC_LATERALE_MAX  */
#line 260 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LATERALE_MAX,
                                                    DrucIndexMesure );}
#line 1772 "y.tab.c"
    break;

  case 72: /* mesure_rel: DRUC_SUP  */
#line 262 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_SUP,
                                                    DrucIndexMesure );}
#line 1779 "y.tab.c"
    break;

  case 73: /* mesure_rel: DRUC_INF  */
#line 264 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_INF,
                                                    DrucIndexMesure );}
#line 1786 "y.tab.c"
    break;

  case 74: /* mesure_rel: DRUC_AXIALE  */
#line 266 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_AXIALE,
                                                    DrucIndexMesure );}
#line 1793 "y.tab.c"
    break;

  case 75: /* mesure_rel: DRUC_GEODESIQUE  */
#line 268 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_GEODESIQUE,
                                                    DrucIndexMesure );}
#line 1800 "y.tab.c"
    break;

  case 76: /* mesure: DRUC_SURFACE  */
#line 272 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_SURFACE,
                                                    DrucIndexMesure );}
#line 1807 "y.tab.c"
    break;

  case 77: /* mesure: DRUC_LONGUEUR  */
#line 274 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR,
                                                    DrucIndexMesure );}
#line 1814 "y.tab.c"
    break;

  case 78: /* mesure: DRUC_LARGEUR  */
#line 276 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR,
                                                    DrucIndexMesure );}
#line 1821 "y.tab.c"
    break;

  case 79: /* mesure: DRUC_NOTCH  */
#line 278 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_NOTCH,
                                                    DrucIndexMesure );}
#line 1828 "y.tab.c"
    break;

  case 80: /* mesure: DRUC_SURFACE_INTER  */
#line 280 "./drucompi_y.y"
                               { DrucInitRegleMesure( DRUC_MESURE_SURFACE_INTER,
                                                    DrucIndexMesure );}
#line 1835 "y.tab.c"
    break;

  case 81: /* mesure: DRUC_LONG_INTER  */
#line 282 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LONGUEUR_INTER,
                                                    DrucIndexMesure );}
#line 1842 "y.tab.c"
    break;

  case 82: /* mesure: DRUC_LARGE_INTER  */
#line 284 "./drucompi_y.y"
                             { DrucInitRegleMesure( DRUC_MESURE_LARGEUR_INTER,
                                                    DrucIndexMesure );}
#line 1849 "y.tab.c"
    break;

  case 83: /* compar: DRUC_MIN  */
#line 288 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_MIN,
                                                        DrucIndexMesure );}
#line 1856 "y.tab.c"
    break;

  case 84: /* compar: DRUC_MAX  */
#line 290 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_MAX,
                                                        DrucIndexMesure );}
#line 1863 "y.tab.c"
    break;

  case 85: /* compar: DRUC_INFEQ  */
#line 292 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_INFEQ,
                                                        DrucIndexMesure );}
#line 1870 "y.tab.c"
    break;

  case 86: /* compar: DRUC_SUPEQ  */
#line 294 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_SUPEQ,
                                                        DrucIndexMesure );}
#line 1877 "y.tab.c"
    break;

  case 87: /* compar: '<'  */
#line 296 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_INF,
                                                        DrucIndexMesure );}
#line 1884 "y.tab.c"
    break;

  case 88: /* compar: '>'  */
#line 298 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_SUP,
                                                        DrucIndexMesure );}
#line 1891 "y.tab.c"
    break;

  case 89: /* compar: '='  */
#line 300 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_EQUAL,
                                                        DrucIndexMesure );}
#line 1898 "y.tab.c"
    break;

  case 90: /* compar: DRUC_DIFF  */
#line 302 "./drucompi_y.y"
                             { DrucInitRegleOpCompare ( DRUC_OPERATION_DIFF,
                                                        DrucIndexMesure );}
#line 1905 "y.tab.c"
    break;


#line 1909 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 307 "./drucompi_y.y"

