/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with elpYY_ or elpyy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with elpyy or elpYY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define elpYYBISON 30802

/* Bison version string.  */
#define elpYYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define elpYYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define elpYYPURE 0

/* Push parsers.  */
#define elpYYPUSH 0

/* Pull parsers.  */
#define elpYYPULL 1




/* First part of user prologue.  */
#line 1 "./elp_y.y"

#include "elp.h"

  int  elpyylex  ();
  void elpyyerror();

#line 78 "y.tab.c"

# ifndef elpYY_CAST
#  ifdef __cplusplus
#   define elpYY_CAST(Type, Val) static_cast<Type> (Val)
#   define elpYY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define elpYY_CAST(Type, Val) ((Type) (Val))
#   define elpYY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef elpYY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define elpYY_NULLPTR nullptr
#   else
#    define elpYY_NULLPTR 0
#   endif
#  else
#   define elpYY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef elpYY_elpYY_Y_TAB_H_INCLUDED
# define elpYY_elpYY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef elpYYDEBUG
# define elpYYDEBUG 0
#endif
#if elpYYDEBUG
extern int elpyydebug;
#endif

/* Token kinds.  */
#ifndef elpYYTOKENTYPE
# define elpYYTOKENTYPE
  enum elpyytokentype
  {
    elpYYEMPTY = -2,
    elpYYEOF = 0,                     /* "end of file"  */
    elpYYerror = 256,                 /* error  */
    elpYYUNDEF = 257,                 /* "invalid token"  */
    telpTECNAME = 258,             /* telpTECNAME  */
    telpTECVER = 259,              /* telpTECVER  */
    telpLMLT = 260,                /* telpLMLT  */
    telpWMLT = 261,                /* telpWMLT  */
    telpDLN = 262,                 /* telpDLN  */
    telpDLP = 263,                 /* telpDLP  */
    telpDWN = 264,                 /* telpDWN  */
    telpDWP = 265,                 /* telpDWP  */
    telpDLE = 266,                 /* telpDLE  */
    telpDLD = 267,                 /* telpDLD  */
    telpDWE = 268,                 /* telpDWE  */
    telpDWD = 269,                 /* telpDWD  */
    telpVTN = 270,                 /* telpVTN  */
    telpAN = 271,                  /* telpAN  */
    telpBN = 272,                  /* telpBN  */
    telpRNT = 273,                 /* telpRNT  */
    telpVTP = 274,                 /* telpVTP  */
    telpAP = 275,                  /* telpAP  */
    telpBP = 276,                  /* telpBP  */
    telpRPT = 277,                 /* telpRPT  */
    telp = 278,                    /* telp  */
    telpVDDmax = 279,              /* telpVDDmax  */
    telpVDDdeg = 280,              /* telpVDDdeg  */
    telpVSSdeg = 281,              /* telpVSSdeg  */
    telpVTHR = 282,                /* telpVTHR  */
    telpCGSN = 283,                /* telpCGSN  */
    telpCGPN = 284,                /* telpCGPN  */
    telpCGSP = 285,                /* telpCGSP  */
    telpCGPP = 286,                /* telpCGPP  */
    telpCDSN = 287,                /* telpCDSN  */
    telpCDPN = 288,                /* telpCDPN  */
    telpCDWN = 289,                /* telpCDWN  */
    telpCDSP = 290,                /* telpCDSP  */
    telpCDPP = 291,                /* telpCDPP  */
    telpCDWP = 292,                /* telpCDWP  */
    telpCSSN = 293,                /* telpCSSN  */
    telpCSPN = 294,                /* telpCSPN  */
    telpCSWN = 295,                /* telpCSWN  */
    telpCSSP = 296,                /* telpCSSP  */
    telpCSPP = 297,                /* telpCSPP  */
    telpCSWP = 298,                /* telpCSWP  */
    telpCGDE = 299,                /* telpCGDE  */
    telpCGSE = 300,                /* telpCGSE  */
    telpCGDD = 301,                /* telpCGDD  */
    telpCGSD = 302,                /* telpCGSD  */
    telpESIM = 303,                /* telpESIM  */
    telpMODEL = 304,               /* telpMODEL  */
    telpLEVEL = 305,               /* telpLEVEL  */
    telpACM = 306,                 /* telpACM  */
    telpTEMP = 307,                /* telpTEMP  */
    telpSLOPE = 308,               /* telpSLOPE  */
    telpDOUBLE = 309,              /* telpDOUBLE  */
    telpSTRING = 310               /* telpSTRING  */
  };
  typedef enum elpyytokentype elpyytoken_kind_t;
#endif
/* Token kinds.  */
#define elpYYEMPTY -2
#define elpYYEOF 0
#define elpYYerror 256
#define elpYYUNDEF 257
#define telpTECNAME 258
#define telpTECVER 259
#define telpLMLT 260
#define telpWMLT 261
#define telpDLN 262
#define telpDLP 263
#define telpDWN 264
#define telpDWP 265
#define telpDLE 266
#define telpDLD 267
#define telpDWE 268
#define telpDWD 269
#define telpVTN 270
#define telpAN 271
#define telpBN 272
#define telpRNT 273
#define telpVTP 274
#define telpAP 275
#define telpBP 276
#define telpRPT 277
#define telp 278
#define telpVDDmax 279
#define telpVDDdeg 280
#define telpVSSdeg 281
#define telpVTHR 282
#define telpCGSN 283
#define telpCGPN 284
#define telpCGSP 285
#define telpCGPP 286
#define telpCDSN 287
#define telpCDPN 288
#define telpCDWN 289
#define telpCDSP 290
#define telpCDPP 291
#define telpCDWP 292
#define telpCSSN 293
#define telpCSPN 294
#define telpCSWN 295
#define telpCSSP 296
#define telpCSPP 297
#define telpCSWP 298
#define telpCGDE 299
#define telpCGSE 300
#define telpCGDD 301
#define telpCGSD 302
#define telpESIM 303
#define telpMODEL 304
#define telpLEVEL 305
#define telpACM 306
#define telpTEMP 307
#define telpSLOPE 308
#define telpDOUBLE 309
#define telpSTRING 310

/* Value type.  */
#if ! defined elpYYSTYPE && ! defined elpYYSTYPE_IS_DECLARED
union elpYYSTYPE
{
#line 8 "./elp_y.y"

       double elpdbl    ;
       char   elpstr[50];
       

#line 247 "y.tab.c"

};
typedef union elpYYSTYPE elpYYSTYPE;
# define elpYYSTYPE_IS_TRIVIAL 1
# define elpYYSTYPE_IS_DECLARED 1
#endif


extern elpYYSTYPE elpyylval;


int elpyyparse (void);


#endif /* !elpYY_elpYY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum elpyysymbol_kind_t
{
  elpYYSYMBOL_elpYYEMPTY = -2,
  elpYYSYMBOL_elpYYEOF = 0,                      /* "end of file"  */
  elpYYSYMBOL_elpYYerror = 1,                    /* error  */
  elpYYSYMBOL_elpYYUNDEF = 2,                    /* "invalid token"  */
  elpYYSYMBOL_telpTECNAME = 3,                /* telpTECNAME  */
  elpYYSYMBOL_telpTECVER = 4,                 /* telpTECVER  */
  elpYYSYMBOL_telpLMLT = 5,                   /* telpLMLT  */
  elpYYSYMBOL_telpWMLT = 6,                   /* telpWMLT  */
  elpYYSYMBOL_telpDLN = 7,                    /* telpDLN  */
  elpYYSYMBOL_telpDLP = 8,                    /* telpDLP  */
  elpYYSYMBOL_telpDWN = 9,                    /* telpDWN  */
  elpYYSYMBOL_telpDWP = 10,                   /* telpDWP  */
  elpYYSYMBOL_telpDLE = 11,                   /* telpDLE  */
  elpYYSYMBOL_telpDLD = 12,                   /* telpDLD  */
  elpYYSYMBOL_telpDWE = 13,                   /* telpDWE  */
  elpYYSYMBOL_telpDWD = 14,                   /* telpDWD  */
  elpYYSYMBOL_telpVTN = 15,                   /* telpVTN  */
  elpYYSYMBOL_telpAN = 16,                    /* telpAN  */
  elpYYSYMBOL_telpBN = 17,                    /* telpBN  */
  elpYYSYMBOL_telpRNT = 18,                   /* telpRNT  */
  elpYYSYMBOL_telpVTP = 19,                   /* telpVTP  */
  elpYYSYMBOL_telpAP = 20,                    /* telpAP  */
  elpYYSYMBOL_telpBP = 21,                    /* telpBP  */
  elpYYSYMBOL_telpRPT = 22,                   /* telpRPT  */
  elpYYSYMBOL_telp = 23,                      /* telp  */
  elpYYSYMBOL_telpVDDmax = 24,                /* telpVDDmax  */
  elpYYSYMBOL_telpVDDdeg = 25,                /* telpVDDdeg  */
  elpYYSYMBOL_telpVSSdeg = 26,                /* telpVSSdeg  */
  elpYYSYMBOL_telpVTHR = 27,                  /* telpVTHR  */
  elpYYSYMBOL_telpCGSN = 28,                  /* telpCGSN  */
  elpYYSYMBOL_telpCGPN = 29,                  /* telpCGPN  */
  elpYYSYMBOL_telpCGSP = 30,                  /* telpCGSP  */
  elpYYSYMBOL_telpCGPP = 31,                  /* telpCGPP  */
  elpYYSYMBOL_telpCDSN = 32,                  /* telpCDSN  */
  elpYYSYMBOL_telpCDPN = 33,                  /* telpCDPN  */
  elpYYSYMBOL_telpCDWN = 34,                  /* telpCDWN  */
  elpYYSYMBOL_telpCDSP = 35,                  /* telpCDSP  */
  elpYYSYMBOL_telpCDPP = 36,                  /* telpCDPP  */
  elpYYSYMBOL_telpCDWP = 37,                  /* telpCDWP  */
  elpYYSYMBOL_telpCSSN = 38,                  /* telpCSSN  */
  elpYYSYMBOL_telpCSPN = 39,                  /* telpCSPN  */
  elpYYSYMBOL_telpCSWN = 40,                  /* telpCSWN  */
  elpYYSYMBOL_telpCSSP = 41,                  /* telpCSSP  */
  elpYYSYMBOL_telpCSPP = 42,                  /* telpCSPP  */
  elpYYSYMBOL_telpCSWP = 43,                  /* telpCSWP  */
  elpYYSYMBOL_telpCGDE = 44,                  /* telpCGDE  */
  elpYYSYMBOL_telpCGSE = 45,                  /* telpCGSE  */
  elpYYSYMBOL_telpCGDD = 46,                  /* telpCGDD  */
  elpYYSYMBOL_telpCGSD = 47,                  /* telpCGSD  */
  elpYYSYMBOL_telpESIM = 48,                  /* telpESIM  */
  elpYYSYMBOL_telpMODEL = 49,                 /* telpMODEL  */
  elpYYSYMBOL_telpLEVEL = 50,                 /* telpLEVEL  */
  elpYYSYMBOL_telpACM = 51,                   /* telpACM  */
  elpYYSYMBOL_telpTEMP = 52,                  /* telpTEMP  */
  elpYYSYMBOL_telpSLOPE = 53,                 /* telpSLOPE  */
  elpYYSYMBOL_telpDOUBLE = 54,                /* telpDOUBLE  */
  elpYYSYMBOL_telpSTRING = 55,                /* telpSTRING  */
  elpYYSYMBOL_56_ = 56,                       /* ':'  */
  elpYYSYMBOL_57_ = 57,                       /* '='  */
  elpYYSYMBOL_elpYYACCEPT = 58,                  /* $accept  */
  elpYYSYMBOL_elp = 59,                       /* elp  */
  elpYYSYMBOL_60_1 = 60,                      /* $@1  */
  elpYYSYMBOL_variables = 61,                 /* variables  */
  elpYYSYMBOL_elpvar = 62                     /* elpvar  */
};
typedef enum elpyysymbol_kind_t elpyysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define elpYY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ elpyytype_int8;
#elif defined elpYY_STDINT_H
typedef int_least8_t elpyytype_int8;
#else
typedef signed char elpyytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ elpyytype_int16;
#elif defined elpYY_STDINT_H
typedef int_least16_t elpyytype_int16;
#else
typedef short elpyytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ elpyytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined elpYY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t elpyytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char elpyytype_uint8;
#else
typedef short elpyytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ elpyytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined elpYY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t elpyytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short elpyytype_uint16;
#else
typedef int elpyytype_uint16;
#endif

#ifndef elpYYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define elpYYPTRDIFF_T __PTRDIFF_TYPE__
#  define elpYYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define elpYYPTRDIFF_T ptrdiff_t
#  define elpYYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define elpYYPTRDIFF_T long
#  define elpYYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef elpYYSIZE_T
# ifdef __SIZE_TYPE__
#  define elpYYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define elpYYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define elpYYSIZE_T size_t
# else
#  define elpYYSIZE_T unsigned
# endif
#endif

#define elpYYSIZE_MAXIMUM                                  \
  elpYY_CAST (elpYYPTRDIFF_T,                                 \
           (elpYYPTRDIFF_MAXIMUM < elpYY_CAST (elpYYSIZE_T, -1)  \
            ? elpYYPTRDIFF_MAXIMUM                         \
            : elpYY_CAST (elpYYSIZE_T, -1)))

#define elpYYSIZEOF(X) elpYY_CAST (elpYYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef elpyytype_uint8 elpyy_state_t;

/* State numbers in computations.  */
typedef int elpyy_state_fast_t;

#ifndef elpYY_
# if defined elpYYENABLE_NLS && elpYYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define elpYY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef elpYY_
#  define elpYY_(Msgid) Msgid
# endif
#endif


#ifndef elpYY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define elpYY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define elpYY_ATTRIBUTE_PURE
# endif
#endif

#ifndef elpYY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define elpYY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define elpYY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define elpYY_USE(E) ((void) (E))
#else
# define elpYY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about elpyylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define elpYY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define elpYY_INITIAL_VALUE(Value) Value
#endif
#ifndef elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define elpYY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef elpYY_INITIAL_VALUE
# define elpYY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define elpYY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define elpYY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef elpYY_IGNORE_USELESS_CAST_BEGIN
# define elpYY_IGNORE_USELESS_CAST_BEGIN
# define elpYY_IGNORE_USELESS_CAST_END
#endif


#define elpYY_ASSERT(E) ((void) (0 && (E)))

#if !defined elpyyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef elpYYSTACK_USE_ALLOCA
#  if elpYYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define elpYYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define elpYYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define elpYYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef elpYYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define elpYYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef elpYYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define elpYYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define elpYYSTACK_ALLOC elpYYMALLOC
#  define elpYYSTACK_FREE elpYYFREE
#  ifndef elpYYSTACK_ALLOC_MAXIMUM
#   define elpYYSTACK_ALLOC_MAXIMUM elpYYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined elpYYMALLOC || defined malloc) \
             && (defined elpYYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef elpYYMALLOC
#   define elpYYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (elpYYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef elpYYFREE
#   define elpYYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined elpyyoverflow */

#if (! defined elpyyoverflow \
     && (! defined __cplusplus \
         || (defined elpYYSTYPE_IS_TRIVIAL && elpYYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union elpyyalloc
{
  elpyy_state_t elpyyss_alloc;
  elpYYSTYPE elpyyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define elpYYSTACK_GAP_MAXIMUM (elpYYSIZEOF (union elpyyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define elpYYSTACK_BYTES(N) \
     ((N) * (elpYYSIZEOF (elpyy_state_t) + elpYYSIZEOF (elpYYSTYPE)) \
      + elpYYSTACK_GAP_MAXIMUM)

# define elpYYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables elpYYSIZE and elpYYSTACKSIZE give the old and new number of
   elements in the stack, and elpYYPTR gives the new location of the
   stack.  Advance elpYYPTR to a properly aligned location for the next
   stack.  */
# define elpYYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        elpYYPTRDIFF_T elpyynewbytes;                                         \
        elpYYCOPY (&elpyyptr->Stack_alloc, Stack, elpyysize);                    \
        Stack = &elpyyptr->Stack_alloc;                                    \
        elpyynewbytes = elpyystacksize * elpYYSIZEOF (*Stack) + elpYYSTACK_GAP_MAXIMUM; \
        elpyyptr += elpyynewbytes / elpYYSIZEOF (*elpyyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined elpYYCOPY_NEEDED && elpYYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef elpYYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define elpYYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, elpYY_CAST (elpYYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define elpYYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          elpYYPTRDIFF_T elpyyi;                      \
          for (elpyyi = 0; elpyyi < (Count); elpyyi++)   \
            (Dst)[elpyyi] = (Src)[elpyyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !elpYYCOPY_NEEDED */

/* elpYYFINAL -- State number of the termination state.  */
#define elpYYFINAL  4
/* elpYYLAST -- Last index in elpYYTABLE.  */
#define elpYYLAST   153

/* elpYYNTOKENS -- Number of terminals.  */
#define elpYYNTOKENS  58
/* elpYYNNTS -- Number of nonterminals.  */
#define elpYYNNTS  5
/* elpYYNRULES -- Number of rules.  */
#define elpYYNRULES  53
/* elpYYNSTATES -- Number of states.  */
#define elpYYNSTATES  156

/* elpYYMAXUTOK -- Last valid token kind.  */
#define elpYYMAXUTOK   310


/* elpYYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by elpyylex, with out-of-bounds checking.  */
#define elpYYTRANSLATE(elpYYX)                                \
  (0 <= (elpYYX) && (elpYYX) <= elpYYMAXUTOK                     \
   ? elpYY_CAST (elpyysymbol_kind_t, elpyytranslate[elpYYX])        \
   : elpYYSYMBOL_elpYYUNDEF)

/* elpYYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by elpyylex.  */
static const elpyytype_int8 elpyytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,     2,
       2,    57,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55
};

#if elpYYDEBUG
/* elpYYRLINE[elpYYN] -- Source line where rule number elpYYN was defined.  */
static const elpyytype_int8 elpyyrline[] =
{
       0,    29,    29,    28,    36,    37,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    54,    55,    56,    57,
      58,    59,    60,    61,    64,    65,    66,    67,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    92,    93,
      94,    97,    98,    99
};
#endif

/** Accessing symbol of state STATE.  */
#define elpYY_ACCESSING_SYMBOL(State) elpYY_CAST (elpyysymbol_kind_t, elpyystos[State])

#if elpYYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   elpYYSYMBOL.  No bounds checking.  */
static const char *elpyysymbol_name (elpyysymbol_kind_t elpyysymbol) elpYY_ATTRIBUTE_UNUSED;

/* elpYYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at elpYYNTOKENS, nonterminals.  */
static const char *const elpyytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "telpTECNAME",
  "telpTECVER", "telpLMLT", "telpWMLT", "telpDLN", "telpDLP", "telpDWN",
  "telpDWP", "telpDLE", "telpDLD", "telpDWE", "telpDWD", "telpVTN",
  "telpAN", "telpBN", "telpRNT", "telpVTP", "telpAP", "telpBP", "telpRPT",
  "telp", "telpVDDmax", "telpVDDdeg", "telpVSSdeg", "telpVTHR", "telpCGSN",
  "telpCGPN", "telpCGSP", "telpCGPP", "telpCDSN", "telpCDPN", "telpCDWN",
  "telpCDSP", "telpCDPP", "telpCDWP", "telpCSSN", "telpCSPN", "telpCSWN",
  "telpCSSP", "telpCSPP", "telpCSWP", "telpCGDE", "telpCGSE", "telpCGDD",
  "telpCGSD", "telpESIM", "telpMODEL", "telpLEVEL", "telpACM", "telpTEMP",
  "telpSLOPE", "telpDOUBLE", "telpSTRING", "':'", "'='", "$accept", "elp",
  "$@1", "variables", "elpvar", elpYY_NULLPTR
};

static const char *
elpyysymbol_name (elpyysymbol_kind_t elpyysymbol)
{
  return elpyytname[elpyysymbol];
}
#endif

#define elpYYPACT_NINF (-8)

#define elpyypact_value_is_default(Yyn) \
  ((Yyn) == elpYYPACT_NINF)

#define elpYYTABLE_NINF (-1)

#define elpyytable_value_is_error(Yyn) \
  0

/* elpYYPACT[STATE-NUM] -- Index in elpYYTABLE of the portion describing
   STATE-NUM.  */
static const elpyytype_int8 elpyypact[] =
{
      15,    -7,    50,    -4,    -8,    48,    -3,     0,    -8,    -8,
      -5,    -2,    -1,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -8,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    96,    97,    98,    99,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8
};

/* elpYYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when elpYYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const elpyytype_int8 elpyydefact[] =
{
       0,     0,     0,     0,     1,     0,     0,     0,     2,     4,
       3,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     7,
       8,    10,     9,    11,    12,    14,    13,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    47,    46,    45,
      48,    49,    50,    51,    52,    53
};

/* elpYYPGOTO[NTERM-NUM].  */
static const elpyytype_int8 elpyypgoto[] =
{
      -8,    -8,    -8,    -8,    -8
};

/* elpYYDEFGOTO[NTERM-NUM].  */
static const elpyytype_int8 elpyydefgoto[] =
{
       0,     2,     9,    10,    59
};

/* elpYYTABLE[elpYYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If elpYYTABLE_NINF, syntax error.  */
static const elpyytype_uint8 elpyytable[] =
{
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,     3,
       4,     5,     6,     7,     8,    60,    61,     0,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,     0,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,     0,   150,   151,
     152,   153,   154,   155
};

static const elpyytype_int8 elpyycheck[] =
{
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,     3,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    56,
       0,    55,     4,    56,    54,    57,    57,    -1,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    -1,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    -1,    55,    55,
      54,    54,    54,    54
};

/* elpYYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const elpyytype_int8 elpyystos[] =
{
       0,     3,    59,    56,     0,    55,     4,    56,    54,    60,
      61,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    62,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      55,    55,    54,    54,    54,    54
};

/* elpYYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const elpyytype_int8 elpyyr1[] =
{
       0,    58,    60,    59,    61,    61,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62
};

/* elpYYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const elpyytype_int8 elpyyr2[] =
{
       0,     2,     0,     8,     0,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3
};


enum { elpYYENOMEM = -2 };

#define elpyyerrok         (elpyyerrstatus = 0)
#define elpyyclearin       (elpyychar = elpYYEMPTY)

#define elpYYACCEPT        goto elpyyacceptlab
#define elpYYABORT         goto elpyyabortlab
#define elpYYERROR         goto elpyyerrorlab
#define elpYYNOMEM         goto elpyyexhaustedlab


#define elpYYRECOVERING()  (!!elpyyerrstatus)

#define elpYYBACKUP(Token, Value)                                    \
  do                                                              \
    if (elpyychar == elpYYEMPTY)                                        \
      {                                                           \
        elpyychar = (Token);                                         \
        elpyylval = (Value);                                         \
        elpYYPOPSTACK (elpyylen);                                       \
        elpyystate = *elpyyssp;                                         \
        goto elpyybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        elpyyerror (elpYY_("syntax error: cannot back up")); \
        elpYYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use elpYYerror or elpYYUNDEF. */
#define elpYYERRCODE elpYYUNDEF


/* Enable debugging if requested.  */
#if elpYYDEBUG

# ifndef elpYYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define elpYYFPRINTF fprintf
# endif

# define elpYYDPRINTF(Args)                        \
do {                                            \
  if (elpyydebug)                                  \
    elpYYFPRINTF Args;                             \
} while (0)




# define elpYY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (elpyydebug)                                                            \
    {                                                                     \
      elpYYFPRINTF (stderr, "%s ", Title);                                   \
      elpyy_symbol_print (stderr,                                            \
                  Kind, Value); \
      elpYYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on elpYYO.  |
`-----------------------------------*/

static void
elpyy_symbol_value_print (FILE *elpyyo,
                       elpyysymbol_kind_t elpyykind, elpYYSTYPE const * const elpyyvaluep)
{
  FILE *elpyyoutput = elpyyo;
  elpYY_USE (elpyyoutput);
  if (!elpyyvaluep)
    return;
  elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  elpYY_USE (elpyykind);
  elpYY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on elpYYO.  |
`---------------------------*/

static void
elpyy_symbol_print (FILE *elpyyo,
                 elpyysymbol_kind_t elpyykind, elpYYSTYPE const * const elpyyvaluep)
{
  elpYYFPRINTF (elpyyo, "%s %s (",
             elpyykind < elpYYNTOKENS ? "token" : "nterm", elpyysymbol_name (elpyykind));

  elpyy_symbol_value_print (elpyyo, elpyykind, elpyyvaluep);
  elpYYFPRINTF (elpyyo, ")");
}

/*------------------------------------------------------------------.
| elpyy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
elpyy_stack_print (elpyy_state_t *elpyybottom, elpyy_state_t *elpyytop)
{
  elpYYFPRINTF (stderr, "Stack now");
  for (; elpyybottom <= elpyytop; elpyybottom++)
    {
      int elpyybot = *elpyybottom;
      elpYYFPRINTF (stderr, " %d", elpyybot);
    }
  elpYYFPRINTF (stderr, "\n");
}

# define elpYY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (elpyydebug)                                                  \
    elpyy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the elpYYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
elpyy_reduce_print (elpyy_state_t *elpyyssp, elpYYSTYPE *elpyyvsp,
                 int elpyyrule)
{
  int elpyylno = elpyyrline[elpyyrule];
  int elpyynrhs = elpyyr2[elpyyrule];
  int elpyyi;
  elpYYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             elpyyrule - 1, elpyylno);
  /* The symbols being reduced.  */
  for (elpyyi = 0; elpyyi < elpyynrhs; elpyyi++)
    {
      elpYYFPRINTF (stderr, "   $%d = ", elpyyi + 1);
      elpyy_symbol_print (stderr,
                       elpYY_ACCESSING_SYMBOL (+elpyyssp[elpyyi + 1 - elpyynrhs]),
                       &elpyyvsp[(elpyyi + 1) - (elpyynrhs)]);
      elpYYFPRINTF (stderr, "\n");
    }
}

# define elpYY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (elpyydebug)                          \
    elpyy_reduce_print (elpyyssp, elpyyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int elpyydebug;
#else /* !elpYYDEBUG */
# define elpYYDPRINTF(Args) ((void) 0)
# define elpYY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define elpYY_STACK_PRINT(Bottom, Top)
# define elpYY_REDUCE_PRINT(Rule)
#endif /* !elpYYDEBUG */


/* elpYYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef elpYYINITDEPTH
# define elpYYINITDEPTH 200
#endif

/* elpYYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   elpYYSTACK_ALLOC_MAXIMUM < elpYYSTACK_BYTES (elpYYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef elpYYMAXDEPTH
# define elpYYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
elpyydestruct (const char *elpyymsg,
            elpyysymbol_kind_t elpyykind, elpYYSTYPE *elpyyvaluep)
{
  elpYY_USE (elpyyvaluep);
  if (!elpyymsg)
    elpyymsg = "Deleting";
  elpYY_SYMBOL_PRINT (elpyymsg, elpyykind, elpyyvaluep, elpyylocationp);

  elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  elpYY_USE (elpyykind);
  elpYY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int elpyychar;

/* The semantic value of the lookahead symbol.  */
elpYYSTYPE elpyylval;
/* Number of syntax errors so far.  */
int elpyynerrs;




/*----------.
| elpyyparse.  |
`----------*/

int
elpyyparse (void)
{
    elpyy_state_fast_t elpyystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int elpyyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow elpyyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    elpYYPTRDIFF_T elpyystacksize = elpYYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    elpyy_state_t elpyyssa[elpYYINITDEPTH];
    elpyy_state_t *elpyyss = elpyyssa;
    elpyy_state_t *elpyyssp = elpyyss;

    /* The semantic value stack: array, bottom, top.  */
    elpYYSTYPE elpyyvsa[elpYYINITDEPTH];
    elpYYSTYPE *elpyyvs = elpyyvsa;
    elpYYSTYPE *elpyyvsp = elpyyvs;

  int elpyyn;
  /* The return value of elpyyparse.  */
  int elpyyresult;
  /* Lookahead symbol kind.  */
  elpyysymbol_kind_t elpyytoken = elpYYSYMBOL_elpYYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  elpYYSTYPE elpyyval;



#define elpYYPOPSTACK(N)   (elpyyvsp -= (N), elpyyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int elpyylen = 0;

  elpYYDPRINTF ((stderr, "Starting parse\n"));

  elpyychar = elpYYEMPTY; /* Cause a token to be read.  */

  goto elpyysetstate;


/*------------------------------------------------------------.
| elpyynewstate -- push a new state, which is found in elpyystate.  |
`------------------------------------------------------------*/
elpyynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  elpyyssp++;


/*--------------------------------------------------------------------.
| elpyysetstate -- set current state (the top of the stack) to elpyystate.  |
`--------------------------------------------------------------------*/
elpyysetstate:
  elpYYDPRINTF ((stderr, "Entering state %d\n", elpyystate));
  elpYY_ASSERT (0 <= elpyystate && elpyystate < elpYYNSTATES);
  elpYY_IGNORE_USELESS_CAST_BEGIN
  *elpyyssp = elpYY_CAST (elpyy_state_t, elpyystate);
  elpYY_IGNORE_USELESS_CAST_END
  elpYY_STACK_PRINT (elpyyss, elpyyssp);

  if (elpyyss + elpyystacksize - 1 <= elpyyssp)
#if !defined elpyyoverflow && !defined elpYYSTACK_RELOCATE
    elpYYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      elpYYPTRDIFF_T elpyysize = elpyyssp - elpyyss + 1;

# if defined elpyyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        elpyy_state_t *elpyyss1 = elpyyss;
        elpYYSTYPE *elpyyvs1 = elpyyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if elpyyoverflow is a macro.  */
        elpyyoverflow (elpYY_("memory exhausted"),
                    &elpyyss1, elpyysize * elpYYSIZEOF (*elpyyssp),
                    &elpyyvs1, elpyysize * elpYYSIZEOF (*elpyyvsp),
                    &elpyystacksize);
        elpyyss = elpyyss1;
        elpyyvs = elpyyvs1;
      }
# else /* defined elpYYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (elpYYMAXDEPTH <= elpyystacksize)
        elpYYNOMEM;
      elpyystacksize *= 2;
      if (elpYYMAXDEPTH < elpyystacksize)
        elpyystacksize = elpYYMAXDEPTH;

      {
        elpyy_state_t *elpyyss1 = elpyyss;
        union elpyyalloc *elpyyptr =
          elpYY_CAST (union elpyyalloc *,
                   elpYYSTACK_ALLOC (elpYY_CAST (elpYYSIZE_T, elpYYSTACK_BYTES (elpyystacksize))));
        if (! elpyyptr)
          elpYYNOMEM;
        elpYYSTACK_RELOCATE (elpyyss_alloc, elpyyss);
        elpYYSTACK_RELOCATE (elpyyvs_alloc, elpyyvs);
#  undef elpYYSTACK_RELOCATE
        if (elpyyss1 != elpyyssa)
          elpYYSTACK_FREE (elpyyss1);
      }
# endif

      elpyyssp = elpyyss + elpyysize - 1;
      elpyyvsp = elpyyvs + elpyysize - 1;

      elpYY_IGNORE_USELESS_CAST_BEGIN
      elpYYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  elpYY_CAST (long, elpyystacksize)));
      elpYY_IGNORE_USELESS_CAST_END

      if (elpyyss + elpyystacksize - 1 <= elpyyssp)
        elpYYABORT;
    }
#endif /* !defined elpyyoverflow && !defined elpYYSTACK_RELOCATE */


  if (elpyystate == elpYYFINAL)
    elpYYACCEPT;

  goto elpyybackup;


/*-----------.
| elpyybackup.  |
`-----------*/
elpyybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  elpyyn = elpyypact[elpyystate];
  if (elpyypact_value_is_default (elpyyn))
    goto elpyydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* elpYYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (elpyychar == elpYYEMPTY)
    {
      elpYYDPRINTF ((stderr, "Reading a token\n"));
      elpyychar = elpyylex ();
    }

  if (elpyychar <= elpYYEOF)
    {
      elpyychar = elpYYEOF;
      elpyytoken = elpYYSYMBOL_elpYYEOF;
      elpYYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (elpyychar == elpYYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      elpyychar = elpYYUNDEF;
      elpyytoken = elpYYSYMBOL_elpYYerror;
      goto elpyyerrlab1;
    }
  else
    {
      elpyytoken = elpYYTRANSLATE (elpyychar);
      elpYY_SYMBOL_PRINT ("Next token is", elpyytoken, &elpyylval, &elpyylloc);
    }

  /* If the proper action on seeing token elpYYTOKEN is to reduce or to
     detect an error, take that action.  */
  elpyyn += elpyytoken;
  if (elpyyn < 0 || elpYYLAST < elpyyn || elpyycheck[elpyyn] != elpyytoken)
    goto elpyydefault;
  elpyyn = elpyytable[elpyyn];
  if (elpyyn <= 0)
    {
      if (elpyytable_value_is_error (elpyyn))
        goto elpyyerrlab;
      elpyyn = -elpyyn;
      goto elpyyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (elpyyerrstatus)
    elpyyerrstatus--;

  /* Shift the lookahead token.  */
  elpYY_SYMBOL_PRINT ("Shifting", elpyytoken, &elpyylval, &elpyylloc);
  elpyystate = elpyyn;
  elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++elpyyvsp = elpyylval;
  elpYY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  elpyychar = elpYYEMPTY;
  goto elpyynewstate;


/*-----------------------------------------------------------.
| elpyydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
elpyydefault:
  elpyyn = elpyydefact[elpyystate];
  if (elpyyn == 0)
    goto elpyyerrlab;
  goto elpyyreduce;


/*-----------------------------.
| elpyyreduce -- do a reduction.  |
`-----------------------------*/
elpyyreduce:
  /* elpyyn is the number of a rule to reduce with.  */
  elpyylen = elpyyr2[elpyyn];

  /* If elpYYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets elpYYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to elpYYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that elpYYVAL may be used uninitialized.  */
  elpyyval = elpyyvsp[1-elpyylen];


  elpYY_REDUCE_PRINT (elpyyn);
  switch (elpyyn)
    {
  case 2: /* $@1: %empty  */
#line 29 "./elp_y.y"
                {
                strcpy(elpTechnoName,(elpyyvsp[-3].elpstr)) ;
                elpTechnoVersion = (elpyyvsp[0].elpdbl) ;
                }
#line 1382 "y.tab.c"
    break;

  case 6: /* elpvar: telpLMLT '=' telpDOUBLE  */
#line 42 "./elp_y.y"
                                    {elpShrink[elpLMLT] = (elpyyvsp[0].elpdbl) ;}
#line 1388 "y.tab.c"
    break;

  case 7: /* elpvar: telpWMLT '=' telpDOUBLE  */
#line 43 "./elp_y.y"
                                    {elpShrink[elpWMLT] = (elpyyvsp[0].elpdbl) ;}
#line 1394 "y.tab.c"
    break;

  case 8: /* elpvar: telpDLN '=' telpDOUBLE  */
#line 44 "./elp_y.y"
                                    {elpShrink[elpDLN]  = (elpyyvsp[0].elpdbl) ;}
#line 1400 "y.tab.c"
    break;

  case 9: /* elpvar: telpDWN '=' telpDOUBLE  */
#line 45 "./elp_y.y"
                                    {elpShrink[elpDWN]  = (elpyyvsp[0].elpdbl) ;}
#line 1406 "y.tab.c"
    break;

  case 10: /* elpvar: telpDLP '=' telpDOUBLE  */
#line 46 "./elp_y.y"
                                    {elpShrink[elpDLP]  = (elpyyvsp[0].elpdbl) ;}
#line 1412 "y.tab.c"
    break;

  case 11: /* elpvar: telpDWP '=' telpDOUBLE  */
#line 47 "./elp_y.y"
                                    {elpShrink[elpDWP]  = (elpyyvsp[0].elpdbl) ;}
#line 1418 "y.tab.c"
    break;

  case 12: /* elpvar: telpDLE '=' telpDOUBLE  */
#line 48 "./elp_y.y"
                                    {elpShrink[elpDLE]  = (elpyyvsp[0].elpdbl) ;}
#line 1424 "y.tab.c"
    break;

  case 13: /* elpvar: telpDWE '=' telpDOUBLE  */
#line 49 "./elp_y.y"
                                    {elpShrink[elpDWE]  = (elpyyvsp[0].elpdbl) ;}
#line 1430 "y.tab.c"
    break;

  case 14: /* elpvar: telpDLD '=' telpDOUBLE  */
#line 50 "./elp_y.y"
                                    {elpShrink[elpDLD]  = (elpyyvsp[0].elpdbl) ;}
#line 1436 "y.tab.c"
    break;

  case 15: /* elpvar: telpDWD '=' telpDOUBLE  */
#line 51 "./elp_y.y"
                                    {elpShrink[elpDWD]  = (elpyyvsp[0].elpdbl) ;}
#line 1442 "y.tab.c"
    break;

  case 16: /* elpvar: telpVTN '=' telpDOUBLE  */
#line 54 "./elp_y.y"
                                    {elpModel[elpNMOS][elpVT] = (elpyyvsp[0].elpdbl) ;}
#line 1448 "y.tab.c"
    break;

  case 17: /* elpvar: telpAN '=' telpDOUBLE  */
#line 55 "./elp_y.y"
                                    {elpModel[elpNMOS][elpA]  = (elpyyvsp[0].elpdbl) ;}
#line 1454 "y.tab.c"
    break;

  case 18: /* elpvar: telpBN '=' telpDOUBLE  */
#line 56 "./elp_y.y"
                                    {elpModel[elpNMOS][elpB]  = (elpyyvsp[0].elpdbl) ;}
#line 1460 "y.tab.c"
    break;

  case 19: /* elpvar: telpRNT '=' telpDOUBLE  */
#line 57 "./elp_y.y"
                                    {elpModel[elpNMOS][elpRT] = (elpyyvsp[0].elpdbl) ;}
#line 1466 "y.tab.c"
    break;

  case 20: /* elpvar: telpVTP '=' telpDOUBLE  */
#line 58 "./elp_y.y"
                                    {elpModel[elpPMOS][elpVT] = (elpyyvsp[0].elpdbl) ;}
#line 1472 "y.tab.c"
    break;

  case 21: /* elpvar: telpAP '=' telpDOUBLE  */
#line 59 "./elp_y.y"
                                    {elpModel[elpPMOS][elpA]  = (elpyyvsp[0].elpdbl) ;}
#line 1478 "y.tab.c"
    break;

  case 22: /* elpvar: telpBP '=' telpDOUBLE  */
#line 60 "./elp_y.y"
                                    {elpModel[elpPMOS][elpB]  = (elpyyvsp[0].elpdbl) ;}
#line 1484 "y.tab.c"
    break;

  case 23: /* elpvar: telpRPT '=' telpDOUBLE  */
#line 61 "./elp_y.y"
                                    {elpModel[elpPMOS][elpRT] = (elpyyvsp[0].elpdbl) ;}
#line 1490 "y.tab.c"
    break;

  case 24: /* elpvar: telpVDDmax '=' telpDOUBLE  */
#line 64 "./elp_y.y"
                                      {elpVoltage[elpVDDMAX] = (elpyyvsp[0].elpdbl) ;}
#line 1496 "y.tab.c"
    break;

  case 25: /* elpvar: telpVDDdeg '=' telpDOUBLE  */
#line 65 "./elp_y.y"
                                      {elpVoltage[elpVDDDEG] = (elpyyvsp[0].elpdbl) ;}
#line 1502 "y.tab.c"
    break;

  case 26: /* elpvar: telpVSSdeg '=' telpDOUBLE  */
#line 66 "./elp_y.y"
                                      {elpVoltage[elpVSSDEG] = (elpyyvsp[0].elpdbl) ;}
#line 1508 "y.tab.c"
    break;

  case 27: /* elpvar: telpVTHR '=' telpDOUBLE  */
#line 67 "./elp_y.y"
                                      {elpVoltage[elpVTHR]   = (elpyyvsp[0].elpdbl) ;}
#line 1514 "y.tab.c"
    break;

  case 28: /* elpvar: telpCGSN '=' telpDOUBLE  */
#line 70 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCGS] = (elpyyvsp[0].elpdbl) ;}
#line 1520 "y.tab.c"
    break;

  case 29: /* elpvar: telpCGPN '=' telpDOUBLE  */
#line 71 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCGP] = (elpyyvsp[0].elpdbl) ;}
#line 1526 "y.tab.c"
    break;

  case 30: /* elpvar: telpCGSP '=' telpDOUBLE  */
#line 72 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCGS] = (elpyyvsp[0].elpdbl) ;}
#line 1532 "y.tab.c"
    break;

  case 31: /* elpvar: telpCGPP '=' telpDOUBLE  */
#line 73 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCGP] = (elpyyvsp[0].elpdbl) ;}
#line 1538 "y.tab.c"
    break;

  case 32: /* elpvar: telpCDSN '=' telpDOUBLE  */
#line 74 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCDS] = (elpyyvsp[0].elpdbl) ;}
#line 1544 "y.tab.c"
    break;

  case 33: /* elpvar: telpCDPN '=' telpDOUBLE  */
#line 75 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCDP] = (elpyyvsp[0].elpdbl) ;}
#line 1550 "y.tab.c"
    break;

  case 34: /* elpvar: telpCDWN '=' telpDOUBLE  */
#line 76 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCDW] = (elpyyvsp[0].elpdbl) ;}
#line 1556 "y.tab.c"
    break;

  case 35: /* elpvar: telpCDSP '=' telpDOUBLE  */
#line 77 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCDS] = (elpyyvsp[0].elpdbl) ;}
#line 1562 "y.tab.c"
    break;

  case 36: /* elpvar: telpCDPP '=' telpDOUBLE  */
#line 78 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCDP] = (elpyyvsp[0].elpdbl) ;}
#line 1568 "y.tab.c"
    break;

  case 37: /* elpvar: telpCDWP '=' telpDOUBLE  */
#line 79 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCDW] = (elpyyvsp[0].elpdbl) ;}
#line 1574 "y.tab.c"
    break;

  case 38: /* elpvar: telpCSSN '=' telpDOUBLE  */
#line 80 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCSS] = (elpyyvsp[0].elpdbl) ;}
#line 1580 "y.tab.c"
    break;

  case 39: /* elpvar: telpCSPN '=' telpDOUBLE  */
#line 81 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCSP] = (elpyyvsp[0].elpdbl) ;}
#line 1586 "y.tab.c"
    break;

  case 40: /* elpvar: telpCSWN '=' telpDOUBLE  */
#line 82 "./elp_y.y"
                                      {elpCapa[elpNMOS][elpCSW] = (elpyyvsp[0].elpdbl) ;}
#line 1592 "y.tab.c"
    break;

  case 41: /* elpvar: telpCSSP '=' telpDOUBLE  */
#line 83 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCSS] = (elpyyvsp[0].elpdbl) ;}
#line 1598 "y.tab.c"
    break;

  case 42: /* elpvar: telpCSPP '=' telpDOUBLE  */
#line 84 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCSP] = (elpyyvsp[0].elpdbl) ;}
#line 1604 "y.tab.c"
    break;

  case 43: /* elpvar: telpCSWP '=' telpDOUBLE  */
#line 85 "./elp_y.y"
                                      {elpCapa[elpPMOS][elpCSW] = (elpyyvsp[0].elpdbl) ;}
#line 1610 "y.tab.c"
    break;

  case 44: /* elpvar: telpCGDE '=' telpDOUBLE  */
#line 86 "./elp_y.y"
                                      {elpCapa[elpEMES][elpCSGD] = (elpyyvsp[0].elpdbl) ;}
#line 1616 "y.tab.c"
    break;

  case 45: /* elpvar: telpCGSD '=' telpDOUBLE  */
#line 87 "./elp_y.y"
                                      {elpCapa[elpDMES][elpCSGS] = (elpyyvsp[0].elpdbl) ;}
#line 1622 "y.tab.c"
    break;

  case 46: /* elpvar: telpCGDD '=' telpDOUBLE  */
#line 88 "./elp_y.y"
                                      {elpCapa[elpDMES][elpCSGD] = (elpyyvsp[0].elpdbl) ;}
#line 1628 "y.tab.c"
    break;

  case 47: /* elpvar: telpCGSE '=' telpDOUBLE  */
#line 89 "./elp_y.y"
                                      {elpCapa[elpEMES][elpCSGS] = (elpyyvsp[0].elpdbl) ;}
#line 1634 "y.tab.c"
    break;

  case 48: /* elpvar: telpESIM '=' telpSTRING  */
#line 92 "./elp_y.y"
                                      {strcpy(elpEsimName,(elpyyvsp[0].elpstr))       ;}
#line 1640 "y.tab.c"
    break;

  case 49: /* elpvar: telpMODEL '=' telpSTRING  */
#line 93 "./elp_y.y"
                                      {strcpy(elpModelName,(elpyyvsp[0].elpstr))      ;}
#line 1646 "y.tab.c"
    break;

  case 50: /* elpvar: telpLEVEL '=' telpDOUBLE  */
#line 94 "./elp_y.y"
                                      {elpEsimLevel = (elpyyvsp[0].elpdbl)            ;}
#line 1652 "y.tab.c"
    break;

  case 51: /* elpvar: telpACM '=' telpDOUBLE  */
#line 97 "./elp_y.y"
                                      {elpGeneral[elpACM]   = (elpyyvsp[0].elpdbl) ;}
#line 1658 "y.tab.c"
    break;

  case 52: /* elpvar: telpTEMP '=' telpDOUBLE  */
#line 98 "./elp_y.y"
                                      {elpGeneral[elpTEMP]  = (elpyyvsp[0].elpdbl) ;}
#line 1664 "y.tab.c"
    break;

  case 53: /* elpvar: telpSLOPE '=' telpDOUBLE  */
#line 99 "./elp_y.y"
                                      {elpGeneral[elpSLOPE] = (elpyyvsp[0].elpdbl) ;}
#line 1670 "y.tab.c"
    break;


#line 1674 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter elpyychar, and that requires
     that elpyytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of elpyytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     elpYYABORT, elpYYACCEPT, or elpYYERROR immediately after altering elpyychar or
     if it invokes elpYYBACKUP.  In the case of elpYYABORT or elpYYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of elpYYERROR or elpYYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  elpYY_SYMBOL_PRINT ("-> $$ =", elpYY_CAST (elpyysymbol_kind_t, elpyyr1[elpyyn]), &elpyyval, &elpyyloc);

  elpYYPOPSTACK (elpyylen);
  elpyylen = 0;

  *++elpyyvsp = elpyyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int elpyylhs = elpyyr1[elpyyn] - elpYYNTOKENS;
    const int elpyyi = elpyypgoto[elpyylhs] + *elpyyssp;
    elpyystate = (0 <= elpyyi && elpyyi <= elpYYLAST && elpyycheck[elpyyi] == *elpyyssp
               ? elpyytable[elpyyi]
               : elpyydefgoto[elpyylhs]);
  }

  goto elpyynewstate;


/*--------------------------------------.
| elpyyerrlab -- here on detecting error.  |
`--------------------------------------*/
elpyyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  elpyytoken = elpyychar == elpYYEMPTY ? elpYYSYMBOL_elpYYEMPTY : elpYYTRANSLATE (elpyychar);
  /* If not already recovering from an error, report this error.  */
  if (!elpyyerrstatus)
    {
      ++elpyynerrs;
      elpyyerror (elpYY_("syntax error"));
    }

  if (elpyyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (elpyychar <= elpYYEOF)
        {
          /* Return failure if at end of input.  */
          if (elpyychar == elpYYEOF)
            elpYYABORT;
        }
      else
        {
          elpyydestruct ("Error: discarding",
                      elpyytoken, &elpyylval);
          elpyychar = elpYYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto elpyyerrlab1;


/*---------------------------------------------------.
| elpyyerrorlab -- error raised explicitly by elpYYERROR.  |
`---------------------------------------------------*/
elpyyerrorlab:
  /* Pacify compilers when the user code never invokes elpYYERROR and the
     label elpyyerrorlab therefore never appears in user code.  */
  if (0)
    elpYYERROR;
  ++elpyynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this elpYYERROR.  */
  elpYYPOPSTACK (elpyylen);
  elpyylen = 0;
  elpYY_STACK_PRINT (elpyyss, elpyyssp);
  elpyystate = *elpyyssp;
  goto elpyyerrlab1;


/*-------------------------------------------------------------.
| elpyyerrlab1 -- common code for both syntax error and elpYYERROR.  |
`-------------------------------------------------------------*/
elpyyerrlab1:
  elpyyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      elpyyn = elpyypact[elpyystate];
      if (!elpyypact_value_is_default (elpyyn))
        {
          elpyyn += elpYYSYMBOL_elpYYerror;
          if (0 <= elpyyn && elpyyn <= elpYYLAST && elpyycheck[elpyyn] == elpYYSYMBOL_elpYYerror)
            {
              elpyyn = elpyytable[elpyyn];
              if (0 < elpyyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (elpyyssp == elpyyss)
        elpYYABORT;


      elpyydestruct ("Error: popping",
                  elpYY_ACCESSING_SYMBOL (elpyystate), elpyyvsp);
      elpYYPOPSTACK (1);
      elpyystate = *elpyyssp;
      elpYY_STACK_PRINT (elpyyss, elpyyssp);
    }

  elpYY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++elpyyvsp = elpyylval;
  elpYY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  elpYY_SYMBOL_PRINT ("Shifting", elpYY_ACCESSING_SYMBOL (elpyyn), elpyyvsp, elpyylsp);

  elpyystate = elpyyn;
  goto elpyynewstate;


/*-------------------------------------.
| elpyyacceptlab -- elpYYACCEPT comes here.  |
`-------------------------------------*/
elpyyacceptlab:
  elpyyresult = 0;
  goto elpyyreturnlab;


/*-----------------------------------.
| elpyyabortlab -- elpYYABORT comes here.  |
`-----------------------------------*/
elpyyabortlab:
  elpyyresult = 1;
  goto elpyyreturnlab;


/*-----------------------------------------------------------.
| elpyyexhaustedlab -- elpYYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
elpyyexhaustedlab:
  elpyyerror (elpYY_("memory exhausted"));
  elpyyresult = 2;
  goto elpyyreturnlab;


/*----------------------------------------------------------.
| elpyyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
elpyyreturnlab:
  if (elpyychar != elpYYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      elpyytoken = elpYYTRANSLATE (elpyychar);
      elpyydestruct ("Cleanup: discarding lookahead",
                  elpyytoken, &elpyylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this elpYYABORT or elpYYACCEPT.  */
  elpYYPOPSTACK (elpyylen);
  elpYY_STACK_PRINT (elpyyss, elpyyssp);
  while (elpyyssp != elpyyss)
    {
      elpyydestruct ("Cleanup: popping",
                  elpYY_ACCESSING_SYMBOL (+*elpyyssp), elpyyvsp);
      elpYYPOPSTACK (1);
    }
#ifndef elpyyoverflow
  if (elpyyss != elpyyssa)
    elpYYSTACK_FREE (elpyyss);
#endif

  return elpyyresult;
}

#line 101 "./elp_y.y"


extern char elpyytext[] ;

void elpyyerror()

{
elpError(1001,elpyytext,elpyylineno) ; /* si erreur de syntaxe => erreur 1001 */
}


int elpyywrap() {return 1 ;}

