/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with FBL_Y__ or fbl_y__.  They are
   private implementation details that can be changed or removed.  */

#ifndef FBL_Y__FBL_Y__Y_TAB_H_INCLUDED
# define FBL_Y__FBL_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef FBL_Y_DEBUG
# define FBL_Y_DEBUG 0
#endif
#if FBL_Y_DEBUG
extern int fbl_y_debug;
#endif

/* Token kinds.  */
#ifndef FBL_Y_TOKENTYPE
# define FBL_Y_TOKENTYPE
  enum fbl_y_tokentype
  {
    FBL_Y_EMPTY = -2,
    FBL_Y_EOF = 0,                     /* "end of file"  */
    FBL_Y_error = 256,                 /* error  */
    FBL_Y_UNDEF = 257,                 /* "invalid token"  */
    tok_AND = 258,                 /* tok_AND  */
    Pragma = 259,                  /* Pragma  */
    _BEGIN = 260,                  /* _BEGIN  */
    _END = 261,                    /* _END  */
    _EQSym = 262,                  /* _EQSym  */
    _EXIT = 263,                   /* _EXIT  */
    _FILE = 264,                   /* _FILE  */
    _GESym = 265,                  /* _GESym  */
    _GTSym = 266,                  /* _GTSym  */
    _IN = 267,                     /* _IN  */
    _INOUT = 268,                  /* _INOUT  */
    _LABEL = 269,                  /* _LABEL  */
    _LESym = 270,                  /* _LESym  */
    _LINKAGE = 271,                /* _LINKAGE  */
    _LTSym = 272,                  /* _LTSym  */
    _NAND = 273,                   /* _NAND  */
    _NESym = 274,                  /* _NESym  */
    _NEXT = 275,                   /* _NEXT  */
    _NOR = 276,                    /* _NOR  */
    _NOT = 277,                    /* _NOT  */
    tok_NULL = 278,                /* tok_NULL  */
    _OR = 279,                     /* _OR  */
    _OUT = 280,                    /* _OUT  */
    _XOR = 281,                    /* _XOR  */
    ABS = 282,                     /* ABS  */
    ACCESS = 283,                  /* ACCESS  */
    AFTER = 284,                   /* AFTER  */
    ALIAS = 285,                   /* ALIAS  */
    ALL = 286,                     /* ALL  */
    ARCHITECTURE = 287,            /* ARCHITECTURE  */
    ARRAY = 288,                   /* ARRAY  */
    ASSERT = 289,                  /* ASSERT  */
    ATTRIBUTE = 290,               /* ATTRIBUTE  */
    AbstractLit = 291,             /* AbstractLit  */
    Ampersand = 292,               /* Ampersand  */
    Apostrophe = 293,              /* Apostrophe  */
    Arrow = 294,                   /* Arrow  */
    _BLOCK = 295,                  /* _BLOCK  */
    BODY = 296,                    /* BODY  */
    BUFFER = 297,                  /* BUFFER  */
    BUS = 298,                     /* BUS  */
    Bar = 299,                     /* Bar  */
    BasedInt = 300,                /* BasedInt  */
    BasedReal = 301,               /* BasedReal  */
    BitStringLit = 302,            /* BitStringLit  */
    Box = 303,                     /* Box  */
    CASE = 304,                    /* CASE  */
    COMPONENT = 305,               /* COMPONENT  */
    CONFIGURATION = 306,           /* CONFIGURATION  */
    CONSTANT = 307,                /* CONSTANT  */
    CharacterLit = 308,            /* CharacterLit  */
    Colon = 309,                   /* Colon  */
    Comma = 310,                   /* Comma  */
    DISCONNECT = 311,              /* DISCONNECT  */
    DOWNTO = 312,                  /* DOWNTO  */
    DecimalInt = 313,              /* DecimalInt  */
    DecimalReal = 314,             /* DecimalReal  */
    Dot = 315,                     /* Dot  */
    DoubleStar = 316,              /* DoubleStar  */
    ELSE = 317,                    /* ELSE  */
    ELSIF = 318,                   /* ELSIF  */
    ENTITY = 319,                  /* ENTITY  */
    ERROR = 320,                   /* ERROR  */
    FOR = 321,                     /* FOR  */
    FUNCTION = 322,                /* FUNCTION  */
    GENERATE = 323,                /* GENERATE  */
    GENERIC = 324,                 /* GENERIC  */
    GUARDED = 325,                 /* GUARDED  */
    IF = 326,                      /* IF  */
    IS = 327,                      /* IS  */
    Identifier = 328,              /* Identifier  */
    LIBRARY = 329,                 /* LIBRARY  */
    LOOP = 330,                    /* LOOP  */
    LeftParen = 331,               /* LeftParen  */
    MAP = 332,                     /* MAP  */
    MOD = 333,                     /* MOD  */
    Minus = 334,                   /* Minus  */
    NEW = 335,                     /* NEW  */
    OF = 336,                      /* OF  */
    ON = 337,                      /* ON  */
    OPEN = 338,                    /* OPEN  */
    OTHERS = 339,                  /* OTHERS  */
    _PACKAGE = 340,                /* _PACKAGE  */
    PORT = 341,                    /* PORT  */
    PROCEDURE = 342,               /* PROCEDURE  */
    PROCESS = 343,                 /* PROCESS  */
    Plus = 344,                    /* Plus  */
    RANGE = 345,                   /* RANGE  */
    RECORD = 346,                  /* RECORD  */
    REGISTER = 347,                /* REGISTER  */
    REM = 348,                     /* REM  */
    REPORT = 349,                  /* REPORT  */
    RETURN = 350,                  /* RETURN  */
    RightParen = 351,              /* RightParen  */
    SELECT = 352,                  /* SELECT  */
    SEVERITY = 353,                /* SEVERITY  */
    SIGNAL = 354,                  /* SIGNAL  */
    _STABLE = 355,                 /* _STABLE  */
    _EVENT = 356,                  /* _EVENT  */
    SUBTYPE = 357,                 /* SUBTYPE  */
    Semicolon = 358,               /* Semicolon  */
    Star = 359,                    /* Star  */
    StringLit = 360,               /* StringLit  */
    THEN = 361,                    /* THEN  */
    TO = 362,                      /* TO  */
    TRANSPORT = 363,               /* TRANSPORT  */
    FBHTYPE = 364,                 /* FBHTYPE  */
    UNITS = 365,                   /* UNITS  */
    UNTIL = 366,                   /* UNTIL  */
    USE = 367,                     /* USE  */
    VARIABLE = 368,                /* VARIABLE  */
    VarAsgn = 369,                 /* VarAsgn  */
    WAIT = 370,                    /* WAIT  */
    WARNING = 371,                 /* WARNING  */
    WHEN = 372,                    /* WHEN  */
    WHILE = 373,                   /* WHILE  */
    WITH = 374                     /* WITH  */
  };
  typedef enum fbl_y_tokentype fbl_y_token_kind_t;
#endif
/* Token kinds.  */
#define FBL_Y_EMPTY -2
#define FBL_Y_EOF 0
#define FBL_Y_error 256
#define FBL_Y_UNDEF 257
#define tok_AND 258
#define Pragma 259
#define _BEGIN 260
#define _END 261
#define _EQSym 262
#define _EXIT 263
#define _FILE 264
#define _GESym 265
#define _GTSym 266
#define _IN 267
#define _INOUT 268
#define _LABEL 269
#define _LESym 270
#define _LINKAGE 271
#define _LTSym 272
#define _NAND 273
#define _NESym 274
#define _NEXT 275
#define _NOR 276
#define _NOT 277
#define tok_NULL 278
#define _OR 279
#define _OUT 280
#define _XOR 281
#define ABS 282
#define ACCESS 283
#define AFTER 284
#define ALIAS 285
#define ALL 286
#define ARCHITECTURE 287
#define ARRAY 288
#define ASSERT 289
#define ATTRIBUTE 290
#define AbstractLit 291
#define Ampersand 292
#define Apostrophe 293
#define Arrow 294
#define _BLOCK 295
#define BODY 296
#define BUFFER 297
#define BUS 298
#define Bar 299
#define BasedInt 300
#define BasedReal 301
#define BitStringLit 302
#define Box 303
#define CASE 304
#define COMPONENT 305
#define CONFIGURATION 306
#define CONSTANT 307
#define CharacterLit 308
#define Colon 309
#define Comma 310
#define DISCONNECT 311
#define DOWNTO 312
#define DecimalInt 313
#define DecimalReal 314
#define Dot 315
#define DoubleStar 316
#define ELSE 317
#define ELSIF 318
#define ENTITY 319
#define ERROR 320
#define FOR 321
#define FUNCTION 322
#define GENERATE 323
#define GENERIC 324
#define GUARDED 325
#define IF 326
#define IS 327
#define Identifier 328
#define LIBRARY 329
#define LOOP 330
#define LeftParen 331
#define MAP 332
#define MOD 333
#define Minus 334
#define NEW 335
#define OF 336
#define ON 337
#define OPEN 338
#define OTHERS 339
#define _PACKAGE 340
#define PORT 341
#define PROCEDURE 342
#define PROCESS 343
#define Plus 344
#define RANGE 345
#define RECORD 346
#define REGISTER 347
#define REM 348
#define REPORT 349
#define RETURN 350
#define RightParen 351
#define SELECT 352
#define SEVERITY 353
#define SIGNAL 354
#define _STABLE 355
#define _EVENT 356
#define SUBTYPE 357
#define Semicolon 358
#define Star 359
#define StringLit 360
#define THEN 361
#define TO 362
#define TRANSPORT 363
#define FBHTYPE 364
#define UNITS 365
#define UNTIL 366
#define USE 367
#define VARIABLE 368
#define VarAsgn 369
#define WAIT 370
#define WARNING 371
#define WHEN 372
#define WHILE 373
#define WITH 374

/* Value type.  */
#if ! defined FBL_Y_STYPE && ! defined FBL_Y_STYPE_IS_DECLARED
union FBL_Y_STYPE
{
#line 66 "./fbl_bcomp_y.y"

	long		 valu;
	char		*text;
	struct ptype	*ptyp;
	struct fbpcs	proc;
        struct g_type dble;
        fbl_name  	name;   
	fbl_ablstr	list;
	struct fbtyp 	type;
	

#line 317 "y.tab.h"

};
typedef union FBL_Y_STYPE FBL_Y_STYPE;
# define FBL_Y_STYPE_IS_TRIVIAL 1
# define FBL_Y_STYPE_IS_DECLARED 1
#endif


extern FBL_Y_STYPE fbl_y_lval;


int fbl_y_parse (void);


#endif /* !FBL_Y__FBL_Y__Y_TAB_H_INCLUDED  */
