/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with MGN_ or mgn_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with mgn or MGN, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define MGNBISON 30802

/* Bison version string.  */
#define MGNBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define MGNSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define MGNPURE 0

/* Push parsers.  */
#define MGNPUSH 0

/* Pull parsers.  */
#define MGNPULL 1




/* First part of user prologue.  */
#line 30 "./mg2mbk_y.y"

#include <stdio.h>
#include <string.h>
#include <mut.h>
#include <mph.h>
#define MAXLAYER (LAST_LAYER + 1)

extern void mgnrestart();
extern int mgnlex();
extern void mgnerror();

static phfig_list *mgleaf; /* modgen leaf cell parsed */
static char mbk_layer();
static char *checkinsname();
static char *checkconname();
static char *checkrefname();
static chain_list *pl;
static int Extension[MAXLAYER] = {
	/*	NWELL	 */ 0,
	/*	PWELL	 */ 0,
	/*	NTIE	 */ 1,
	/*	PTIE	 */ 1,
	/*	NDIF	 */ 1,
	/*	PDIF	 */ 1,
	/*	NTRANS */ 0, /* meant for N transistor grid */
	/*	PTRANS */ 0, /* meant for P transistor grid */
	/*	POLY	 */ 1,
	/*	ALU1	 */ 1,
	/*	ALU2	 */ 2,
	/*	ALU3	 */ 2,
	/*	TPOLY	 */ 1,
	/*	TALU1	 */ 1,
	/*	TALU2	 */ 2,
	/*	TALU3	 */ 2 };

#define O_PS_AA 1.5
#define O_AA_PS 2

#ifdef GRIDDED
#define TWO 2
#else
#define TWO 1
#endif

/* note :
   All STRINGs are allocated using mbkstrdup since the pointer to mgntext
   will change when more than a STRING is used in the grammar.
   So all STRINGs are freed once used. */


#line 122 "y.tab.c"

# ifndef MGN_CAST
#  ifdef __cplusplus
#   define MGN_CAST(Type, Val) static_cast<Type> (Val)
#   define MGN_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define MGN_CAST(Type, Val) ((Type) (Val))
#   define MGN_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef MGN_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define MGN_NULLPTR nullptr
#   else
#    define MGN_NULLPTR 0
#   endif
#  else
#   define MGN_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef MGN_MGN_Y_TAB_H_INCLUDED
# define MGN_MGN_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef MGNDEBUG
# define MGNDEBUG 0
#endif
#if MGNDEBUG
extern int mgndebug;
#endif

/* Token kinds.  */
#ifndef MGNTOKENTYPE
# define MGNTOKENTYPE
  enum mgntokentype
  {
    MGNEMPTY = -2,
    MGNEOF = 0,                     /* "end of file"  */
    MGNerror = 256,                 /* error  */
    MGNUNDEF = 257,                 /* "invalid token"  */
    CELL = 258,                    /* CELL  */
    PLACE = 259,                   /* PLACE  */
    TERMINAL = 260,                /* TERMINAL  */
    RA = 261,                      /* RA  */
    STRETCH = 262,                 /* STRETCH  */
    WIRE = 263,                    /* WIRE  */
    MWIDTH = 264,                  /* MWIDTH  */
    HORIZ = 265,                   /* HORIZ  */
    VERTI = 266,                   /* VERTI  */
    MLEFT = 267,                   /* MLEFT  */
    MRIGHT = 268,                  /* MRIGHT  */
    MTOP = 269,                    /* MTOP  */
    MBOTTOM = 270,                 /* MBOTTOM  */
    AT = 271,                      /* AT  */
    MX = 272,                      /* MX  */
    MY = 273,                      /* MY  */
    R = 274,                       /* R  */
    NTR = 275,                     /* NTR  */
    PTR = 276,                     /* PTR  */
    COP = 277,                     /* COP  */
    CON = 278,                     /* CON  */
    COPS = 279,                    /* COPS  */
    COPW = 280,                    /* COPW  */
    CONW = 281,                    /* CONW  */
    PVIA = 282,                    /* PVIA  */
    CXN = 283,                     /* CXN  */
    CXP = 284,                     /* CXP  */
    STRING = 285,                  /* STRING  */
    NUM = 286                      /* NUM  */
  };
  typedef enum mgntokentype mgntoken_kind_t;
#endif
/* Token kinds.  */
#define MGNEMPTY -2
#define MGNEOF 0
#define MGNerror 256
#define MGNUNDEF 257
#define CELL 258
#define PLACE 259
#define TERMINAL 260
#define RA 261
#define STRETCH 262
#define WIRE 263
#define MWIDTH 264
#define HORIZ 265
#define VERTI 266
#define MLEFT 267
#define MRIGHT 268
#define MTOP 269
#define MBOTTOM 270
#define AT 271
#define MX 272
#define MY 273
#define R 274
#define NTR 275
#define PTR 276
#define COP 277
#define CON 278
#define COPS 279
#define COPW 280
#define CONW 281
#define PVIA 282
#define CXN 283
#define CXP 284
#define STRING 285
#define NUM 286

/* Value type.  */
#if ! defined MGNSTYPE && ! defined MGNSTYPE_IS_DECLARED
union MGNSTYPE
{
#line 81 "./mg2mbk_y.y"

	char *s;
	long n;
	struct pxy {
		long x;
		long y;
	} *p;

#line 246 "y.tab.c"

};
typedef union MGNSTYPE MGNSTYPE;
# define MGNSTYPE_IS_TRIVIAL 1
# define MGNSTYPE_IS_DECLARED 1
#endif


extern MGNSTYPE mgnlval;


int mgnparse (void);


#endif /* !MGN_MGN_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum mgnsymbol_kind_t
{
  MGNSYMBOL_MGNEMPTY = -2,
  MGNSYMBOL_MGNEOF = 0,                      /* "end of file"  */
  MGNSYMBOL_MGNerror = 1,                    /* error  */
  MGNSYMBOL_MGNUNDEF = 2,                    /* "invalid token"  */
  MGNSYMBOL_CELL = 3,                       /* CELL  */
  MGNSYMBOL_PLACE = 4,                      /* PLACE  */
  MGNSYMBOL_TERMINAL = 5,                   /* TERMINAL  */
  MGNSYMBOL_RA = 6,                         /* RA  */
  MGNSYMBOL_STRETCH = 7,                    /* STRETCH  */
  MGNSYMBOL_WIRE = 8,                       /* WIRE  */
  MGNSYMBOL_MWIDTH = 9,                     /* MWIDTH  */
  MGNSYMBOL_HORIZ = 10,                     /* HORIZ  */
  MGNSYMBOL_VERTI = 11,                     /* VERTI  */
  MGNSYMBOL_MLEFT = 12,                     /* MLEFT  */
  MGNSYMBOL_MRIGHT = 13,                    /* MRIGHT  */
  MGNSYMBOL_MTOP = 14,                      /* MTOP  */
  MGNSYMBOL_MBOTTOM = 15,                   /* MBOTTOM  */
  MGNSYMBOL_AT = 16,                        /* AT  */
  MGNSYMBOL_MX = 17,                        /* MX  */
  MGNSYMBOL_MY = 18,                        /* MY  */
  MGNSYMBOL_R = 19,                         /* R  */
  MGNSYMBOL_NTR = 20,                       /* NTR  */
  MGNSYMBOL_PTR = 21,                       /* PTR  */
  MGNSYMBOL_COP = 22,                       /* COP  */
  MGNSYMBOL_CON = 23,                       /* CON  */
  MGNSYMBOL_COPS = 24,                      /* COPS  */
  MGNSYMBOL_COPW = 25,                      /* COPW  */
  MGNSYMBOL_CONW = 26,                      /* CONW  */
  MGNSYMBOL_PVIA = 27,                      /* PVIA  */
  MGNSYMBOL_CXN = 28,                       /* CXN  */
  MGNSYMBOL_CXP = 29,                       /* CXP  */
  MGNSYMBOL_STRING = 30,                    /* STRING  */
  MGNSYMBOL_NUM = 31,                       /* NUM  */
  MGNSYMBOL_32_ = 32,                       /* '{'  */
  MGNSYMBOL_33_ = 33,                       /* '}'  */
  MGNSYMBOL_34_ = 34,                       /* '='  */
  MGNSYMBOL_35_ = 35,                       /* ';'  */
  MGNSYMBOL_36_ = 36,                       /* '('  */
  MGNSYMBOL_37_ = 37,                       /* ')'  */
  MGNSYMBOL_38_ = 38,                       /* ','  */
  MGNSYMBOL_MGNACCEPT = 39,                  /* $accept  */
  MGNSYMBOL_design = 40,                    /* design  */
  MGNSYMBOL_cells = 41,                     /* cells  */
  MGNSYMBOL_leafcell = 42,                  /* leafcell  */
  MGNSYMBOL_lines = 43,                     /* lines  */
  MGNSYMBOL_line = 44,                      /* line  */
  MGNSYMBOL_elm = 45,                       /* elm  */
  MGNSYMBOL_46_1 = 46,                      /* $@1  */
  MGNSYMBOL_point = 47,                     /* point  */
  MGNSYMBOL_point_list = 48,                /* point_list  */
  MGNSYMBOL_dir = 49,                       /* dir  */
  MGNSYMBOL_face = 50,                      /* face  */
  MGNSYMBOL_op = 51                         /* op  */
};
typedef enum mgnsymbol_kind_t mgnsymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define MGN_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ mgntype_int8;
#elif defined MGN_STDINT_H
typedef int_least8_t mgntype_int8;
#else
typedef signed char mgntype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ mgntype_int16;
#elif defined MGN_STDINT_H
typedef int_least16_t mgntype_int16;
#else
typedef short mgntype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ mgntype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined MGN_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t mgntype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char mgntype_uint8;
#else
typedef short mgntype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ mgntype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined MGN_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t mgntype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short mgntype_uint16;
#else
typedef int mgntype_uint16;
#endif

#ifndef MGNPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define MGNPTRDIFF_T __PTRDIFF_TYPE__
#  define MGNPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define MGNPTRDIFF_T ptrdiff_t
#  define MGNPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define MGNPTRDIFF_T long
#  define MGNPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef MGNSIZE_T
# ifdef __SIZE_TYPE__
#  define MGNSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define MGNSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define MGNSIZE_T size_t
# else
#  define MGNSIZE_T unsigned
# endif
#endif

#define MGNSIZE_MAXIMUM                                  \
  MGN_CAST (MGNPTRDIFF_T,                                 \
           (MGNPTRDIFF_MAXIMUM < MGN_CAST (MGNSIZE_T, -1)  \
            ? MGNPTRDIFF_MAXIMUM                         \
            : MGN_CAST (MGNSIZE_T, -1)))

#define MGNSIZEOF(X) MGN_CAST (MGNPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef mgntype_uint8 mgn_state_t;

/* State numbers in computations.  */
typedef int mgn_state_fast_t;

#ifndef MGN_
# if defined MGNENABLE_NLS && MGNENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define MGN_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef MGN_
#  define MGN_(Msgid) Msgid
# endif
#endif


#ifndef MGN_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define MGN_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define MGN_ATTRIBUTE_PURE
# endif
#endif

#ifndef MGN_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define MGN_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define MGN_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define MGN_USE(E) ((void) (E))
#else
# define MGN_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about mgnlval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define MGN_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define MGN_INITIAL_VALUE(Value) Value
#endif
#ifndef MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define MGN_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef MGN_INITIAL_VALUE
# define MGN_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define MGN_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define MGN_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef MGN_IGNORE_USELESS_CAST_BEGIN
# define MGN_IGNORE_USELESS_CAST_BEGIN
# define MGN_IGNORE_USELESS_CAST_END
#endif


#define MGN_ASSERT(E) ((void) (0 && (E)))

#if !defined mgnoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef MGNSTACK_USE_ALLOCA
#  if MGNSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define MGNSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define MGNSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define MGNSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef MGNSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define MGNSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef MGNSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define MGNSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define MGNSTACK_ALLOC MGNMALLOC
#  define MGNSTACK_FREE MGNFREE
#  ifndef MGNSTACK_ALLOC_MAXIMUM
#   define MGNSTACK_ALLOC_MAXIMUM MGNSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined MGNMALLOC || defined malloc) \
             && (defined MGNFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef MGNMALLOC
#   define MGNMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (MGNSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef MGNFREE
#   define MGNFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined mgnoverflow */

#if (! defined mgnoverflow \
     && (! defined __cplusplus \
         || (defined MGNSTYPE_IS_TRIVIAL && MGNSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union mgnalloc
{
  mgn_state_t mgnss_alloc;
  MGNSTYPE mgnvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define MGNSTACK_GAP_MAXIMUM (MGNSIZEOF (union mgnalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define MGNSTACK_BYTES(N) \
     ((N) * (MGNSIZEOF (mgn_state_t) + MGNSIZEOF (MGNSTYPE)) \
      + MGNSTACK_GAP_MAXIMUM)

# define MGNCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables MGNSIZE and MGNSTACKSIZE give the old and new number of
   elements in the stack, and MGNPTR gives the new location of the
   stack.  Advance MGNPTR to a properly aligned location for the next
   stack.  */
# define MGNSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        MGNPTRDIFF_T mgnnewbytes;                                         \
        MGNCOPY (&mgnptr->Stack_alloc, Stack, mgnsize);                    \
        Stack = &mgnptr->Stack_alloc;                                    \
        mgnnewbytes = mgnstacksize * MGNSIZEOF (*Stack) + MGNSTACK_GAP_MAXIMUM; \
        mgnptr += mgnnewbytes / MGNSIZEOF (*mgnptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined MGNCOPY_NEEDED && MGNCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef MGNCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define MGNCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, MGN_CAST (MGNSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define MGNCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          MGNPTRDIFF_T mgni;                      \
          for (mgni = 0; mgni < (Count); mgni++)   \
            (Dst)[mgni] = (Src)[mgni];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !MGNCOPY_NEEDED */

/* MGNFINAL -- State number of the termination state.  */
#define MGNFINAL  6
/* MGNLAST -- Last index in MGNTABLE.  */
#define MGNLAST   157

/* MGNNTOKENS -- Number of terminals.  */
#define MGNNTOKENS  39
/* MGNNNTS -- Number of nonterminals.  */
#define MGNNNTS  13
/* MGNNRULES -- Number of rules.  */
#define MGNNRULES  41
/* MGNNSTATES -- Number of states.  */
#define MGNNSTATES  152

/* MGNMAXUTOK -- Last valid token kind.  */
#define MGNMAXUTOK   286


/* MGNTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by mgnlex, with out-of-bounds checking.  */
#define MGNTRANSLATE(MGNX)                                \
  (0 <= (MGNX) && (MGNX) <= MGNMAXUTOK                     \
   ? MGN_CAST (mgnsymbol_kind_t, mgntranslate[MGNX])        \
   : MGNSYMBOL_MGNUNDEF)

/* MGNTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by mgnlex.  */
static const mgntype_int8 mgntranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      36,    37,     2,     2,    38,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    35,
       2,    34,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,    33,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if MGNDEBUG
/* MGNRLINE[MGNN] -- Source line where rule number MGNN was defined.  */
static const mgntype_int16 mgnrline[] =
{
       0,   130,   130,   133,   134,   137,   143,   144,   147,   151,
     161,   164,   175,   185,   212,   212,   258,   288,   318,   323,
     328,   333,   338,   343,   348,   353,   360,   371,   375,   381,
     382,   385,   386,   387,   388,   391,   392,   394,   396,   398,
     405,   412
};
#endif

/** Accessing symbol of state STATE.  */
#define MGN_ACCESSING_SYMBOL(State) MGN_CAST (mgnsymbol_kind_t, mgnstos[State])

#if MGNDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   MGNSYMBOL.  No bounds checking.  */
static const char *mgnsymbol_name (mgnsymbol_kind_t mgnsymbol) MGN_ATTRIBUTE_UNUSED;

/* MGNTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at MGNNTOKENS, nonterminals.  */
static const char *const mgntname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "CELL", "PLACE",
  "TERMINAL", "RA", "STRETCH", "WIRE", "MWIDTH", "HORIZ", "VERTI", "MLEFT",
  "MRIGHT", "MTOP", "MBOTTOM", "AT", "MX", "MY", "R", "NTR", "PTR", "COP",
  "CON", "COPS", "COPW", "CONW", "PVIA", "CXN", "CXP", "STRING", "NUM",
  "'{'", "'}'", "'='", "';'", "'('", "')'", "','", "$accept", "design",
  "cells", "leafcell", "lines", "line", "elm", "$@1", "point",
  "point_list", "dir", "face", "op", MGN_NULLPTR
};

static const char *
mgnsymbol_name (mgnsymbol_kind_t mgnsymbol)
{
  return mgntname[mgnsymbol];
}
#endif

#define MGNPACT_NINF (-55)

#define mgnpact_value_is_default(Yyn) \
  ((Yyn) == MGNPACT_NINF)

#define MGNTABLE_NINF (-1)

#define mgntable_value_is_error(Yyn) \
  0

/* MGNPACT[STATE-NUM] -- Index in MGNTABLE of the portion describing
   STATE-NUM.  */
static const mgntype_int8 mgnpact[] =
{
      24,    25,    54,    24,   -55,    26,   -55,   -55,     8,    27,
      30,    20,    28,   -55,    29,    31,    45,    46,    47,    50,
      52,    53,    55,    56,    37,     8,    38,    40,    41,    48,
      49,    44,    51,    57,    58,    59,    60,    61,    62,    63,
      64,    65,   -55,   -55,   -55,    18,    67,    43,    66,    72,
      68,    69,    74,    74,    74,    74,    74,    74,    74,    74,
      -9,    73,    75,    74,    79,    76,    80,    81,    77,    82,
      83,    84,    85,    86,    87,    88,    89,     3,    71,    96,
      97,   -55,    98,    78,    90,    99,    94,    95,   102,   -55,
     -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,   103,   104,
     -55,   100,   101,    74,    39,   105,    -9,    -9,   -55,   -55,
     -55,    74,     5,   107,   -55,   -55,   108,    74,   121,   123,
     110,   -55,   -55,   -55,   -55,   111,   -55,    74,   112,   114,
     106,   109,   113,   124,   115,    74,   -55,    74,    74,   -55,
     116,    74,   -55,   117,   118,    74,   119,   -55,   -55,   120,
     -55,   -55
};

/* MGNDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when MGNTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const mgntype_int8 mgndefact[] =
{
       0,     0,     0,     2,     3,     0,     1,     4,     0,     0,
       0,     0,     0,    14,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     5,     7,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    37,     0,
       0,     8,     0,     0,     0,     0,     0,     0,     0,    18,
      19,    20,    21,    22,    23,    24,    25,    38,     0,     0,
      39,     0,     0,     0,     0,     0,    35,    35,    26,    40,
      41,     0,     0,     0,    29,    30,     0,     0,     0,     0,
       0,    31,    32,    34,    33,     0,    11,     0,    27,     0,
       0,     0,     0,     0,     0,     0,    15,     0,     0,     9,
       0,     0,    28,     0,     0,     0,     0,    16,    17,     0,
      13,    12
};

/* MGNPGOTO[NTERM-NUM].  */
static const mgntype_int16 mgnpgoto[] =
{
     -55,   -55,   -55,   146,    92,   -55,    42,   -55,   -52,   -51,
     -55,   -55,   -54
};

/* MGNDEFGOTO[NTERM-NUM].  */
static const mgntype_uint8 mgndefgoto[] =
{
       0,     2,     3,     4,    24,    25,    26,    31,   128,   129,
     116,   125,    80
};

/* MGNTABLE[MGNPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If MGNTABLE_NINF, syntax error.  */
static const mgntype_uint8 mgntable[] =
{
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    83,     9,    10,    11,    12,    13,   121,   122,   123,
     124,    97,    98,    10,    11,    12,    13,     1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    60,   114,
     115,   113,   118,   119,     6,     5,    29,    27,     8,   120,
      28,    34,    35,    36,    30,    32,    37,    33,    38,    39,
      42,    40,    41,    44,    45,   134,    62,    46,    47,    48,
      49,    63,    50,     0,   142,   143,   144,    61,    51,   146,
      99,     0,     0,   149,    52,    53,    54,    55,    56,    57,
      58,    59,    65,     0,    64,    68,    66,    67,    81,    82,
      84,    86,    87,   101,    85,    88,   103,    43,     0,    89,
      90,    91,    92,    93,    94,    95,    96,   100,   104,   102,
     105,   106,   107,   108,   109,   110,   111,   130,   112,   131,
     140,   133,   137,   117,   126,   138,   127,   132,   139,     7,
     135,   136,   145,   141,   147,   148,   150,   151
};

static const mgntype_int16 mgncheck[] =
{
      52,    53,    54,    55,    56,    57,    58,    59,    17,    18,
      19,    63,     4,     5,     6,     7,     8,    12,    13,    14,
      15,    18,    19,     5,     6,     7,     8,     3,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    10,
      11,   103,   106,   107,     0,    30,    36,    30,    32,   111,
      30,    16,    16,    16,    36,    36,    16,    36,    16,    16,
      33,    16,    16,    35,    34,   127,     9,    36,    30,    30,
      36,    38,    31,    -1,   135,   137,   138,    45,    31,   141,
      19,    -1,    -1,   145,    36,    36,    36,    36,    36,    36,
      36,    36,    30,    -1,    38,    31,    38,    38,    35,    34,
      31,    31,    31,    16,    38,    38,    38,    25,    -1,    37,
      37,    37,    37,    37,    37,    37,    37,    31,    38,    31,
      31,    37,    37,    31,    31,    31,    36,    16,    37,    16,
      16,    30,    36,    38,    37,    36,    38,    37,    35,     3,
      38,    37,    36,    38,    37,    37,    37,    37
};

/* MGNSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const mgntype_int8 mgnstos[] =
{
       0,     3,    40,    41,    42,    30,     0,    42,    32,     4,
       5,     6,     7,     8,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    43,    44,    45,    30,    30,    36,
      36,    46,    36,    36,    16,    16,    16,    16,    16,    16,
      16,    16,    33,    43,    35,    34,    36,    30,    30,    36,
      31,    31,    36,    36,    36,    36,    36,    36,    36,    36,
      30,    45,     9,    38,    38,    30,    38,    38,    31,    47,
      47,    47,    47,    47,    47,    47,    47,    17,    18,    19,
      51,    35,    34,    47,    31,    38,    31,    31,    38,    37,
      37,    37,    37,    37,    37,    37,    37,    18,    19,    19,
      31,    16,    31,    38,    38,    31,    37,    37,    31,    31,
      31,    36,    37,    47,    10,    11,    49,    38,    51,    51,
      47,    12,    13,    14,    15,    50,    37,    38,    47,    48,
      16,    16,    37,    30,    47,    38,    37,    36,    36,    35,
      16,    38,    48,    47,    47,    36,    47,    37,    37,    47,
      37,    37
};

/* MGNR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const mgntype_int8 mgnr1[] =
{
       0,    39,    40,    41,    41,    42,    43,    43,    44,    44,
      44,    45,    45,    45,    46,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    47,    48,    48,    49,
      49,    50,    50,    50,    50,    51,    51,    51,    51,    51,
      51,    51
};

/* MGNR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const mgntype_int8 mgnr2[] =
{
       0,     2,     1,     1,     2,     5,     1,     2,     5,    10,
       2,     8,    13,    12,     0,     9,    11,    11,     5,     5,
       5,     5,     5,     5,     5,     5,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     2,
       3,     3
};


enum { MGNENOMEM = -2 };

#define mgnerrok         (mgnerrstatus = 0)
#define mgnclearin       (mgnchar = MGNEMPTY)

#define MGNACCEPT        goto mgnacceptlab
#define MGNABORT         goto mgnabortlab
#define MGNERROR         goto mgnerrorlab
#define MGNNOMEM         goto mgnexhaustedlab


#define MGNRECOVERING()  (!!mgnerrstatus)

#define MGNBACKUP(Token, Value)                                    \
  do                                                              \
    if (mgnchar == MGNEMPTY)                                        \
      {                                                           \
        mgnchar = (Token);                                         \
        mgnlval = (Value);                                         \
        MGNPOPSTACK (mgnlen);                                       \
        mgnstate = *mgnssp;                                         \
        goto mgnbackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        mgnerror (MGN_("syntax error: cannot back up")); \
        MGNERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use MGNerror or MGNUNDEF. */
#define MGNERRCODE MGNUNDEF


/* Enable debugging if requested.  */
#if MGNDEBUG

# ifndef MGNFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define MGNFPRINTF fprintf
# endif

# define MGNDPRINTF(Args)                        \
do {                                            \
  if (mgndebug)                                  \
    MGNFPRINTF Args;                             \
} while (0)




# define MGN_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (mgndebug)                                                            \
    {                                                                     \
      MGNFPRINTF (stderr, "%s ", Title);                                   \
      mgn_symbol_print (stderr,                                            \
                  Kind, Value); \
      MGNFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on MGNO.  |
`-----------------------------------*/

static void
mgn_symbol_value_print (FILE *mgno,
                       mgnsymbol_kind_t mgnkind, MGNSTYPE const * const mgnvaluep)
{
  FILE *mgnoutput = mgno;
  MGN_USE (mgnoutput);
  if (!mgnvaluep)
    return;
  MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  MGN_USE (mgnkind);
  MGN_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on MGNO.  |
`---------------------------*/

static void
mgn_symbol_print (FILE *mgno,
                 mgnsymbol_kind_t mgnkind, MGNSTYPE const * const mgnvaluep)
{
  MGNFPRINTF (mgno, "%s %s (",
             mgnkind < MGNNTOKENS ? "token" : "nterm", mgnsymbol_name (mgnkind));

  mgn_symbol_value_print (mgno, mgnkind, mgnvaluep);
  MGNFPRINTF (mgno, ")");
}

/*------------------------------------------------------------------.
| mgn_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
mgn_stack_print (mgn_state_t *mgnbottom, mgn_state_t *mgntop)
{
  MGNFPRINTF (stderr, "Stack now");
  for (; mgnbottom <= mgntop; mgnbottom++)
    {
      int mgnbot = *mgnbottom;
      MGNFPRINTF (stderr, " %d", mgnbot);
    }
  MGNFPRINTF (stderr, "\n");
}

# define MGN_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (mgndebug)                                                  \
    mgn_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the MGNRULE is going to be reduced.  |
`------------------------------------------------*/

static void
mgn_reduce_print (mgn_state_t *mgnssp, MGNSTYPE *mgnvsp,
                 int mgnrule)
{
  int mgnlno = mgnrline[mgnrule];
  int mgnnrhs = mgnr2[mgnrule];
  int mgni;
  MGNFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             mgnrule - 1, mgnlno);
  /* The symbols being reduced.  */
  for (mgni = 0; mgni < mgnnrhs; mgni++)
    {
      MGNFPRINTF (stderr, "   $%d = ", mgni + 1);
      mgn_symbol_print (stderr,
                       MGN_ACCESSING_SYMBOL (+mgnssp[mgni + 1 - mgnnrhs]),
                       &mgnvsp[(mgni + 1) - (mgnnrhs)]);
      MGNFPRINTF (stderr, "\n");
    }
}

# define MGN_REDUCE_PRINT(Rule)          \
do {                                    \
  if (mgndebug)                          \
    mgn_reduce_print (mgnssp, mgnvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int mgndebug;
#else /* !MGNDEBUG */
# define MGNDPRINTF(Args) ((void) 0)
# define MGN_SYMBOL_PRINT(Title, Kind, Value, Location)
# define MGN_STACK_PRINT(Bottom, Top)
# define MGN_REDUCE_PRINT(Rule)
#endif /* !MGNDEBUG */


/* MGNINITDEPTH -- initial size of the parser's stacks.  */
#ifndef MGNINITDEPTH
# define MGNINITDEPTH 200
#endif

/* MGNMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   MGNSTACK_ALLOC_MAXIMUM < MGNSTACK_BYTES (MGNMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef MGNMAXDEPTH
# define MGNMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
mgndestruct (const char *mgnmsg,
            mgnsymbol_kind_t mgnkind, MGNSTYPE *mgnvaluep)
{
  MGN_USE (mgnvaluep);
  if (!mgnmsg)
    mgnmsg = "Deleting";
  MGN_SYMBOL_PRINT (mgnmsg, mgnkind, mgnvaluep, mgnlocationp);

  MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  MGN_USE (mgnkind);
  MGN_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int mgnchar;

/* The semantic value of the lookahead symbol.  */
MGNSTYPE mgnlval;
/* Number of syntax errors so far.  */
int mgnnerrs;




/*----------.
| mgnparse.  |
`----------*/

int
mgnparse (void)
{
    mgn_state_fast_t mgnstate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int mgnerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow mgnoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    MGNPTRDIFF_T mgnstacksize = MGNINITDEPTH;

    /* The state stack: array, bottom, top.  */
    mgn_state_t mgnssa[MGNINITDEPTH];
    mgn_state_t *mgnss = mgnssa;
    mgn_state_t *mgnssp = mgnss;

    /* The semantic value stack: array, bottom, top.  */
    MGNSTYPE mgnvsa[MGNINITDEPTH];
    MGNSTYPE *mgnvs = mgnvsa;
    MGNSTYPE *mgnvsp = mgnvs;

  int mgnn;
  /* The return value of mgnparse.  */
  int mgnresult;
  /* Lookahead symbol kind.  */
  mgnsymbol_kind_t mgntoken = MGNSYMBOL_MGNEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  MGNSTYPE mgnval;



#define MGNPOPSTACK(N)   (mgnvsp -= (N), mgnssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int mgnlen = 0;

  MGNDPRINTF ((stderr, "Starting parse\n"));

  mgnchar = MGNEMPTY; /* Cause a token to be read.  */

  goto mgnsetstate;


/*------------------------------------------------------------.
| mgnnewstate -- push a new state, which is found in mgnstate.  |
`------------------------------------------------------------*/
mgnnewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  mgnssp++;


/*--------------------------------------------------------------------.
| mgnsetstate -- set current state (the top of the stack) to mgnstate.  |
`--------------------------------------------------------------------*/
mgnsetstate:
  MGNDPRINTF ((stderr, "Entering state %d\n", mgnstate));
  MGN_ASSERT (0 <= mgnstate && mgnstate < MGNNSTATES);
  MGN_IGNORE_USELESS_CAST_BEGIN
  *mgnssp = MGN_CAST (mgn_state_t, mgnstate);
  MGN_IGNORE_USELESS_CAST_END
  MGN_STACK_PRINT (mgnss, mgnssp);

  if (mgnss + mgnstacksize - 1 <= mgnssp)
#if !defined mgnoverflow && !defined MGNSTACK_RELOCATE
    MGNNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      MGNPTRDIFF_T mgnsize = mgnssp - mgnss + 1;

# if defined mgnoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        mgn_state_t *mgnss1 = mgnss;
        MGNSTYPE *mgnvs1 = mgnvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if mgnoverflow is a macro.  */
        mgnoverflow (MGN_("memory exhausted"),
                    &mgnss1, mgnsize * MGNSIZEOF (*mgnssp),
                    &mgnvs1, mgnsize * MGNSIZEOF (*mgnvsp),
                    &mgnstacksize);
        mgnss = mgnss1;
        mgnvs = mgnvs1;
      }
# else /* defined MGNSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (MGNMAXDEPTH <= mgnstacksize)
        MGNNOMEM;
      mgnstacksize *= 2;
      if (MGNMAXDEPTH < mgnstacksize)
        mgnstacksize = MGNMAXDEPTH;

      {
        mgn_state_t *mgnss1 = mgnss;
        union mgnalloc *mgnptr =
          MGN_CAST (union mgnalloc *,
                   MGNSTACK_ALLOC (MGN_CAST (MGNSIZE_T, MGNSTACK_BYTES (mgnstacksize))));
        if (! mgnptr)
          MGNNOMEM;
        MGNSTACK_RELOCATE (mgnss_alloc, mgnss);
        MGNSTACK_RELOCATE (mgnvs_alloc, mgnvs);
#  undef MGNSTACK_RELOCATE
        if (mgnss1 != mgnssa)
          MGNSTACK_FREE (mgnss1);
      }
# endif

      mgnssp = mgnss + mgnsize - 1;
      mgnvsp = mgnvs + mgnsize - 1;

      MGN_IGNORE_USELESS_CAST_BEGIN
      MGNDPRINTF ((stderr, "Stack size increased to %ld\n",
                  MGN_CAST (long, mgnstacksize)));
      MGN_IGNORE_USELESS_CAST_END

      if (mgnss + mgnstacksize - 1 <= mgnssp)
        MGNABORT;
    }
#endif /* !defined mgnoverflow && !defined MGNSTACK_RELOCATE */


  if (mgnstate == MGNFINAL)
    MGNACCEPT;

  goto mgnbackup;


/*-----------.
| mgnbackup.  |
`-----------*/
mgnbackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  mgnn = mgnpact[mgnstate];
  if (mgnpact_value_is_default (mgnn))
    goto mgndefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* MGNCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (mgnchar == MGNEMPTY)
    {
      MGNDPRINTF ((stderr, "Reading a token\n"));
      mgnchar = mgnlex ();
    }

  if (mgnchar <= MGNEOF)
    {
      mgnchar = MGNEOF;
      mgntoken = MGNSYMBOL_MGNEOF;
      MGNDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (mgnchar == MGNerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      mgnchar = MGNUNDEF;
      mgntoken = MGNSYMBOL_MGNerror;
      goto mgnerrlab1;
    }
  else
    {
      mgntoken = MGNTRANSLATE (mgnchar);
      MGN_SYMBOL_PRINT ("Next token is", mgntoken, &mgnlval, &mgnlloc);
    }

  /* If the proper action on seeing token MGNTOKEN is to reduce or to
     detect an error, take that action.  */
  mgnn += mgntoken;
  if (mgnn < 0 || MGNLAST < mgnn || mgncheck[mgnn] != mgntoken)
    goto mgndefault;
  mgnn = mgntable[mgnn];
  if (mgnn <= 0)
    {
      if (mgntable_value_is_error (mgnn))
        goto mgnerrlab;
      mgnn = -mgnn;
      goto mgnreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (mgnerrstatus)
    mgnerrstatus--;

  /* Shift the lookahead token.  */
  MGN_SYMBOL_PRINT ("Shifting", mgntoken, &mgnlval, &mgnlloc);
  mgnstate = mgnn;
  MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++mgnvsp = mgnlval;
  MGN_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  mgnchar = MGNEMPTY;
  goto mgnnewstate;


/*-----------------------------------------------------------.
| mgndefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
mgndefault:
  mgnn = mgndefact[mgnstate];
  if (mgnn == 0)
    goto mgnerrlab;
  goto mgnreduce;


/*-----------------------------.
| mgnreduce -- do a reduction.  |
`-----------------------------*/
mgnreduce:
  /* mgnn is the number of a rule to reduce with.  */
  mgnlen = mgnr2[mgnn];

  /* If MGNLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets MGNVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to MGNVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that MGNVAL may be used uninitialized.  */
  mgnval = mgnvsp[1-mgnlen];


  MGN_REDUCE_PRINT (mgnn);
  switch (mgnn)
    {
  case 5: /* leafcell: CELL STRING '{' lines '}'  */
#line 138 "./mg2mbk_y.y"
                {
			mbkfree((mgnvsp[-3].s));
		}
#line 1361 "y.tab.c"
    break;

  case 8: /* line: PLACE STRING '=' elm ';'  */
#line 148 "./mg2mbk_y.y"
                {
			mbkfree((mgnvsp[-3].s));
		}
#line 1369 "y.tab.c"
    break;

  case 9: /* line: PLACE STRING '=' STRING op AT '(' point ')' ';'  */
#line 152 "./mg2mbk_y.y"
                {
			if (!strcmp((mgnvsp[-6].s), "ref_ref") || !strcmp((mgnvsp[-6].s), "ref_con"))
				addphref(mgleaf, (mgnvsp[-6].s), checkrefname((mgnvsp[-8].s)), (mgnvsp[-2].p)->x, (mgnvsp[-2].p)->y);
			else /* unknown internally! */
				addphins(mgleaf, (mgnvsp[-6].s), checkinsname((mgnvsp[-8].s)), (mgnvsp[-5].n), (mgnvsp[-2].p)->x, (mgnvsp[-2].p)->y);
			mbkfree((mgnvsp[-8].s));
			mbkfree((mgnvsp[-6].s));
			mbkfree((mgnvsp[-2].p));
		}
#line 1383 "y.tab.c"
    break;

  case 11: /* elm: RA '(' STRING ',' point ',' point ')'  */
#line 165 "./mg2mbk_y.y"
                {
			if (strncmp((mgnvsp[-5].s), "zd", 2)) {
				fprintf(stderr, "modgen parser warning : ra not for ab box\n");
				/* exit(18); */
			} else
				defab(mgleaf, (mgnvsp[-3].p)->x, (mgnvsp[-1].p)->x, (mgnvsp[-3].p)->y, (mgnvsp[-1].p)->y);
			mbkfree((mgnvsp[-5].s));
			mbkfree((mgnvsp[-3].p));
			mbkfree((mgnvsp[-1].p));
		}
#line 1398 "y.tab.c"
    break;

  case 12: /* elm: TERMINAL STRING '(' MWIDTH '=' NUM ')' face STRING AT '(' point ')'  */
#line 176 "./mg2mbk_y.y"
                {
			if (strcmp((mgnvsp[-11].s), "ul") && strcmp((mgnvsp[-11].s), "ur")
					&& strcmp((mgnvsp[-11].s), "lr") && strcmp((mgnvsp[-11].s), "ll"))
				addphcon(mgleaf, (char)(mgnvsp[-5].n), checkconname((mgnvsp[-11].s)),
							(mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, mbk_layer((mgnvsp[-4].s)), (mgnvsp[-7].n)); 
			mbkfree((mgnvsp[-11].s));
			mbkfree((mgnvsp[-4].s));
			mbkfree((mgnvsp[-1].p));
		}
#line 1412 "y.tab.c"
    break;

  case 13: /* elm: STRETCH '(' STRING ',' NUM ',' dir ',' point ',' point ')'  */
#line 186 "./mg2mbk_y.y"
                {
		char layer = mbk_layer((mgnvsp[-9].s));
		int x1 = (mgnvsp[-3].p)->x, y1 = (mgnvsp[-3].p)->y, x2 = (mgnvsp[-1].p)->x, y2 = (mgnvsp[-1].p)->y;

			mbkfree((mgnvsp[-9].s));
			mbkfree((mgnvsp[-3].p));
			mbkfree((mgnvsp[-1].p));
			if ((mgnvsp[-5].n) == VERTI) {
				if (y2 > y1) {
					y2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
					y1 += Extension[(int)layer] * SCALE_X * TWO / 2;
				} else {
					y2 += Extension[(int)layer] * SCALE_X * TWO / 2;
					y1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
				}
			} else {
				if (x2 > x1) {
					x2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
					x1 += Extension[(int)layer] * SCALE_X * TWO / 2;
				} else {
					x2 += Extension[(int)layer] * SCALE_X * TWO / 2;
					x1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
				}
			}
			addphseg(mgleaf, layer, (mgnvsp[-7].n), x1, y1, x2, y2, NULL);
		}
#line 1443 "y.tab.c"
    break;

  case 14: /* $@1: %empty  */
#line 212 "./mg2mbk_y.y"
                       {pl = NULL;}
#line 1449 "y.tab.c"
    break;

  case 15: /* elm: WIRE $@1 '(' STRING ',' NUM ',' point_list ')'  */
#line 213 "./mg2mbk_y.y"
                {
		chain_list *l;
		int x1, y1, x2, y2;
		char layer = mbk_layer((mgnvsp[-5].s));

			mbkfree((mgnvsp[-5].s));
			/* points in inverted order, but doesn't matter, same algo */
			for (l = pl; l->NEXT; l = l->NEXT) {
				x1 = (int)((struct pxy *)(l->DATA))->x;
				y1 = (int)((struct pxy *)(l->DATA))->y;
				x2 = (int)((struct pxy *)(l->NEXT->DATA))->x;
				y2 = (int)((struct pxy *)(l->NEXT->DATA))->y;
				if (l == pl) { /* last point */
					if (x1 == x2) {
						if (y2 > y1) {
							y1 += Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							y1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					} else {
						if (x2 > x1) {
							x1 += Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							x1 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					}
				}
				if (!l->NEXT->NEXT) { /* first point */
					if (x1 == x2) {
						if (y2 > y1) {
							y2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							y2 += Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					} else {
						if (x2 > x1) {
							x2 -= Extension[(int)layer] * SCALE_X * TWO / 2;
						} else {
							x2 += Extension[(int)layer] * SCALE_X * TWO / 2;
						}
					}
				}
				addphseg(mgleaf, layer, (mgnvsp[-3].n), x1, y1, x2, y2, NULL);
			}
		}
#line 1499 "y.tab.c"
    break;

  case 16: /* elm: NTR '(' NUM ',' NUM ')' op AT '(' point ')'  */
#line 259 "./mg2mbk_y.y"
                { /* bounding box of transistors is knows for idps technology */
		float tx; /* used to compute transistor bbox */
		int x1, y1, x2, y2;

			/* +-----------+ when not placed yet */
			tx = ((float)(mgnvsp[-8].n) / 2 + (float)O_PS_AA * SCALE_X * TWO);

			switch ((char)(mgnvsp[-4].n)) {
				case NOSYM:
				case SYM_X:
				case SYM_Y:
				case SYMXY:
					y2 = y1 = (mgnvsp[-1].p)->y;
					x1 = (mgnvsp[-1].p)->x + tx;
					x2 = (mgnvsp[-1].p)->x - tx;
					addphseg(mgleaf, NTRANS, (mgnvsp[-6].n), x1, y1, x2, y2, NULL);
					break;
				case ROT_P:
				case ROT_M:
				case SY_RP:
				case SY_RM:
					x2 = x1 = (mgnvsp[-1].p)->x;
					y1 = (mgnvsp[-1].p)->y + tx;
					y2 = (mgnvsp[-1].p)->y - tx;
					addphseg(mgleaf, NTRANS, (mgnvsp[-6].n), x1, y1, x2, y2, NULL);
					break;
			}
			mbkfree((mgnvsp[-1].p));
		}
#line 1533 "y.tab.c"
    break;

  case 17: /* elm: PTR '(' NUM ',' NUM ')' op AT '(' point ')'  */
#line 289 "./mg2mbk_y.y"
                { /* bounding box of transistors is knows for idps technology */
		float tx; /* used to compute transistor bbox */
		int x1, y1, x2, y2;

			/* +-----------+ when not placed yet */
			tx = ((float)(mgnvsp[-8].n) / 2 + (float)O_PS_AA * SCALE_X * TWO);

			switch ((char)(mgnvsp[-4].n)) {
				case NOSYM:
				case SYM_X:
				case SYM_Y:
				case SYMXY:
					y2 = y1 = (mgnvsp[-1].p)->y;
					x1 = (mgnvsp[-1].p)->x + tx;
					x2 = (mgnvsp[-1].p)->x - tx;
					addphseg(mgleaf, PTRANS, (mgnvsp[-6].n), x1, y1, x2, y2, NULL);
					break;
				case ROT_P:
				case ROT_M:
				case SY_RP:
				case SY_RM:
					x2 = x1 = (mgnvsp[-1].p)->x;
					y1 = (mgnvsp[-1].p)->y + tx;
					y2 = (mgnvsp[-1].p)->y - tx;
					addphseg(mgleaf, PTRANS, (mgnvsp[-6].n), x1, y1, x2, y2, NULL);
					break;
			}
			mbkfree((mgnvsp[-1].p));
		}
#line 1567 "y.tab.c"
    break;

  case 18: /* elm: COP AT '(' point ')'  */
#line 319 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_DIF_P, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1576 "y.tab.c"
    break;

  case 19: /* elm: CON AT '(' point ')'  */
#line 324 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_DIF_N, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1585 "y.tab.c"
    break;

  case 20: /* elm: COPS AT '(' point ')'  */
#line 329 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_POLY, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1594 "y.tab.c"
    break;

  case 21: /* elm: COPW AT '(' point ')'  */
#line 334 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_BODY_P, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1603 "y.tab.c"
    break;

  case 22: /* elm: CONW AT '(' point ')'  */
#line 339 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_BODY_N, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1612 "y.tab.c"
    break;

  case 23: /* elm: PVIA AT '(' point ')'  */
#line 344 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, CONT_VIA, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1621 "y.tab.c"
    break;

  case 24: /* elm: CXN AT '(' point ')'  */
#line 349 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, C_X_N, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1630 "y.tab.c"
    break;

  case 25: /* elm: CXP AT '(' point ')'  */
#line 354 "./mg2mbk_y.y"
                {
			addphvia(mgleaf, C_X_P, (mgnvsp[-1].p)->x, (mgnvsp[-1].p)->y, 0, 0,NULL);
			mbkfree((mgnvsp[-1].p));
		}
#line 1639 "y.tab.c"
    break;

  case 26: /* point: NUM ',' NUM  */
#line 361 "./mg2mbk_y.y"
                {
		struct pxy *pp;

			pp = (struct pxy *)mbkalloc(sizeof(struct pxy));
			pp->x = (mgnvsp[-2].n);
			pp->y = (mgnvsp[0].n);
			(mgnval.p) = pp;
		}
#line 1652 "y.tab.c"
    break;

  case 27: /* point_list: point  */
#line 372 "./mg2mbk_y.y"
                {
			pl = addchain(pl, (void *)(mgnvsp[0].p));
		}
#line 1660 "y.tab.c"
    break;

  case 28: /* point_list: point ',' point_list  */
#line 376 "./mg2mbk_y.y"
                {
			pl = addchain(pl, (void *)(mgnvsp[-2].p));
		}
#line 1668 "y.tab.c"
    break;

  case 29: /* dir: HORIZ  */
#line 381 "./mg2mbk_y.y"
               {(mgnval.n) = (long)HORIZ;}
#line 1674 "y.tab.c"
    break;

  case 30: /* dir: VERTI  */
#line 382 "./mg2mbk_y.y"
                         {(mgnval.n) = (long)VERTI;}
#line 1680 "y.tab.c"
    break;

  case 31: /* face: MLEFT  */
#line 385 "./mg2mbk_y.y"
                {(mgnval.n) = (long)WEST;}
#line 1686 "y.tab.c"
    break;

  case 32: /* face: MRIGHT  */
#line 386 "./mg2mbk_y.y"
                          {(mgnval.n) = (long)EAST;}
#line 1692 "y.tab.c"
    break;

  case 33: /* face: MBOTTOM  */
#line 387 "./mg2mbk_y.y"
                          {(mgnval.n) = (long)SOUTH;}
#line 1698 "y.tab.c"
    break;

  case 34: /* face: MTOP  */
#line 388 "./mg2mbk_y.y"
                          {(mgnval.n) = (long)NORTH;}
#line 1704 "y.tab.c"
    break;

  case 35: /* op: %empty  */
#line 391 "./mg2mbk_y.y"
        {(mgnval.n) = (long)NOSYM;}
#line 1710 "y.tab.c"
    break;

  case 36: /* op: MX  */
#line 393 "./mg2mbk_y.y"
                {(mgnval.n) = (long)SYM_Y;}
#line 1716 "y.tab.c"
    break;

  case 37: /* op: MY  */
#line 395 "./mg2mbk_y.y"
                {(mgnval.n) = (long)SYM_X;}
#line 1722 "y.tab.c"
    break;

  case 38: /* op: MX MY  */
#line 397 "./mg2mbk_y.y"
                {(mgnval.n) = (long)SYMXY;}
#line 1728 "y.tab.c"
    break;

  case 39: /* op: R NUM  */
#line 399 "./mg2mbk_y.y"
                {
			if ((mgnvsp[0].n) / SCALE_X / TWO == 90)
				(mgnval.n) = (long)ROT_P;
			if ((mgnvsp[0].n) / SCALE_X / TWO == 270)
				(mgnval.n) = (long)ROT_M;
		}
#line 1739 "y.tab.c"
    break;

  case 40: /* op: MX R NUM  */
#line 406 "./mg2mbk_y.y"
                {
			if ((mgnvsp[0].n) / SCALE_X / TWO == 90)
				(mgnval.n) = (long)SY_RM;
			if ((mgnvsp[0].n) / SCALE_X / TWO == 270)
				(mgnval.n) = (long)SY_RP;
		}
#line 1750 "y.tab.c"
    break;

  case 41: /* op: MY R NUM  */
#line 413 "./mg2mbk_y.y"
                {
			if ((mgnvsp[0].n) / SCALE_X / TWO == 90)
				(mgnval.n) = (long)SY_RP;
			if ((mgnvsp[0].n) / SCALE_X / TWO == 270)
				(mgnval.n) = (long)SY_RM;
		}
#line 1761 "y.tab.c"
    break;


#line 1765 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter mgnchar, and that requires
     that mgntoken be updated with the new translation.  We take the
     approach of translating immediately before every use of mgntoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     MGNABORT, MGNACCEPT, or MGNERROR immediately after altering mgnchar or
     if it invokes MGNBACKUP.  In the case of MGNABORT or MGNACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of MGNERROR or MGNBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  MGN_SYMBOL_PRINT ("-> $$ =", MGN_CAST (mgnsymbol_kind_t, mgnr1[mgnn]), &mgnval, &mgnloc);

  MGNPOPSTACK (mgnlen);
  mgnlen = 0;

  *++mgnvsp = mgnval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int mgnlhs = mgnr1[mgnn] - MGNNTOKENS;
    const int mgni = mgnpgoto[mgnlhs] + *mgnssp;
    mgnstate = (0 <= mgni && mgni <= MGNLAST && mgncheck[mgni] == *mgnssp
               ? mgntable[mgni]
               : mgndefgoto[mgnlhs]);
  }

  goto mgnnewstate;


/*--------------------------------------.
| mgnerrlab -- here on detecting error.  |
`--------------------------------------*/
mgnerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  mgntoken = mgnchar == MGNEMPTY ? MGNSYMBOL_MGNEMPTY : MGNTRANSLATE (mgnchar);
  /* If not already recovering from an error, report this error.  */
  if (!mgnerrstatus)
    {
      ++mgnnerrs;
      mgnerror (MGN_("syntax error"));
    }

  if (mgnerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (mgnchar <= MGNEOF)
        {
          /* Return failure if at end of input.  */
          if (mgnchar == MGNEOF)
            MGNABORT;
        }
      else
        {
          mgndestruct ("Error: discarding",
                      mgntoken, &mgnlval);
          mgnchar = MGNEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto mgnerrlab1;


/*---------------------------------------------------.
| mgnerrorlab -- error raised explicitly by MGNERROR.  |
`---------------------------------------------------*/
mgnerrorlab:
  /* Pacify compilers when the user code never invokes MGNERROR and the
     label mgnerrorlab therefore never appears in user code.  */
  if (0)
    MGNERROR;
  ++mgnnerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this MGNERROR.  */
  MGNPOPSTACK (mgnlen);
  mgnlen = 0;
  MGN_STACK_PRINT (mgnss, mgnssp);
  mgnstate = *mgnssp;
  goto mgnerrlab1;


/*-------------------------------------------------------------.
| mgnerrlab1 -- common code for both syntax error and MGNERROR.  |
`-------------------------------------------------------------*/
mgnerrlab1:
  mgnerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      mgnn = mgnpact[mgnstate];
      if (!mgnpact_value_is_default (mgnn))
        {
          mgnn += MGNSYMBOL_MGNerror;
          if (0 <= mgnn && mgnn <= MGNLAST && mgncheck[mgnn] == MGNSYMBOL_MGNerror)
            {
              mgnn = mgntable[mgnn];
              if (0 < mgnn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (mgnssp == mgnss)
        MGNABORT;


      mgndestruct ("Error: popping",
                  MGN_ACCESSING_SYMBOL (mgnstate), mgnvsp);
      MGNPOPSTACK (1);
      mgnstate = *mgnssp;
      MGN_STACK_PRINT (mgnss, mgnssp);
    }

  MGN_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++mgnvsp = mgnlval;
  MGN_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  MGN_SYMBOL_PRINT ("Shifting", MGN_ACCESSING_SYMBOL (mgnn), mgnvsp, mgnlsp);

  mgnstate = mgnn;
  goto mgnnewstate;


/*-------------------------------------.
| mgnacceptlab -- MGNACCEPT comes here.  |
`-------------------------------------*/
mgnacceptlab:
  mgnresult = 0;
  goto mgnreturnlab;


/*-----------------------------------.
| mgnabortlab -- MGNABORT comes here.  |
`-----------------------------------*/
mgnabortlab:
  mgnresult = 1;
  goto mgnreturnlab;


/*-----------------------------------------------------------.
| mgnexhaustedlab -- MGNNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
mgnexhaustedlab:
  mgnerror (MGN_("memory exhausted"));
  mgnresult = 2;
  goto mgnreturnlab;


/*----------------------------------------------------------.
| mgnreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
mgnreturnlab:
  if (mgnchar != MGNEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      mgntoken = MGNTRANSLATE (mgnchar);
      mgndestruct ("Cleanup: discarding lookahead",
                  mgntoken, &mgnlval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this MGNABORT or MGNACCEPT.  */
  MGNPOPSTACK (mgnlen);
  MGN_STACK_PRINT (mgnss, mgnssp);
  while (mgnssp != mgnss)
    {
      mgndestruct ("Cleanup: popping",
                  MGN_ACCESSING_SYMBOL (+*mgnssp), mgnvsp);
      MGNPOPSTACK (1);
    }
#ifndef mgnoverflow
  if (mgnss != mgnssa)
    MGNSTACK_FREE (mgnss);
#endif

  return mgnresult;
}

#line 421 "./mg2mbk_y.y"

char *
	filenameforlex()
{
	return mgleaf->NAME;
}

void
	mgnloadphfig(fig, name, mode)
phfig_list *fig;
char *name;
char mode;
{
extern FILE *mgnin; /* declared in the lex.mgn.c by default */
extern int mgnlineno;
chain_list *c;

	mgleaf = fig;
	if ((mgnin = mbkfopen(name, IN_PH, READ_TEXT)) == NULL) {
		fflush(stdout);
		fprintf(stderr,
			"*** mbk error *** modgen parser failed opening file %s.%s\n",
			name, IN_PH);
		EXIT(1);
	}
	mgnlineno = 0;
	if (mgnparse()) {
		fflush(stdout);
		fprintf(stderr,
			"*** mbk error *** modgen parser failed while reading file %s\n",
			filepath(name, IN_PH));
		EXIT(1);
	}
	(void)fclose(mgnin);
	/* free :
	   temporary space for point list must be freed. */
	for (c = pl; c; c = c->NEXT)
		mbkfree(c->DATA);
	freechain(pl);
	/* not so nice :
	   It would be nice if I'd parse only the necessary stuff when reading
	   the file, but it's a little painful, and would need some checks
	   I can't afford right now. */
	if (mode == 'P') {
	void **ppobj;
	void *next;

		/* delete instances */
		for (ppobj = (void**)&HEAD_PHFIG->PHINS; *ppobj != NULL;) {
			next = (void *)((phins_list *)*ppobj)->NEXT;
			mbkfree((phins_list *)*ppobj);
			*ppobj = next;
		}

		/* delete vias */
		for (ppobj = (void**)&HEAD_PHFIG->PHVIA; *ppobj != NULL;) {
			next = (void *)((phvia_list *)*ppobj)->NEXT;
			mbkfree((phvia_list *)*ppobj);
			*ppobj = next;
		}

		/* delete segments */
		for (ppobj = (void**)&HEAD_PHFIG->PHSEG; *ppobj != NULL;) {
			if (((phseg_list *)*ppobj)->LAYER != TPOLY
					&& ((phseg_list *)*ppobj)->LAYER != TALU1
					&& ((phseg_list *)*ppobj)->LAYER != TALU2
					&& ((phseg_list *)*ppobj)->LAYER != TALU3) {
				next = (void *)((phseg_list *)*ppobj)->NEXT;
				mbkfree((phseg_list *)*ppobj);
				*ppobj = next;
			} else
				ppobj = (void **)&((phseg_list *)*ppobj)->NEXT;
		}
	}
	/* mbk strategy :
	   only one cell per modgen file. */
	fig = HEAD_PHFIG;
}

static char
	mbk_layer(mg_layer)
char *mg_layer;
{
	if (!strcmp(mg_layer, "nw"))
		return NWELL;
	if (!strcmp(mg_layer, "pw"))
		return PWELL;
	if (!strcmp(mg_layer, "xn"))
		return NTIE;
	if (!strcmp(mg_layer, "xp"))
		return PTIE;
	if (!strcmp(mg_layer, "nn"))
		return NDIF;
	if (!strcmp(mg_layer, "pp"))
		return PDIF;
	if (!strcmp(mg_layer, "ps"))
		return POLY;
	if (!strcmp(mg_layer, "m1"))
		return ALU1;
	if (!strcmp(mg_layer, "m2"))
		return ALU2;
	if (!strcmp(mg_layer, "m3"))
		return ALU3;
	if (!strcmp(mg_layer, "am1"))
		return TALU1;
	if (!strcmp(mg_layer, "am2"))
		return TALU2;
	if (!strcmp(mg_layer, "am3"))
		return TALU3;
    return NWELL;
}

/* decode a reference name :
   xxx[?]          -> xxx
   xxx[?][??]      -> xxx ?,
   xxx[?][??][???] -> xxx ?_??.
   I always have added an index since here also two instances can't have
   the same name. */

static char
	*checkrefname(name)
char *name;
{
char *s, *t, *u = NULL;
char one = 0;

   s = t = name;

   while (*t) {
     if (*t == '[') {
       if (!one) {
         *t = ' ';
         u = s;
         one = 1;
       } else if (one == 1) {
         *t = '_';
         u = s;
         one++;
       } else {
         *t = ' ';
         u = s;
       }
     }
     else if (*t == ']') {
       if (*(++t) == '\0') /* ok, it's finished */
         goto end;
       else if (*t == '[') /* multiple array */
         continue;
     }
     *s++ = *t++;
   }
end:
   *s = '\0';
	/* last vectorized value :
	   it shall be skipped since I introduced it while driving the file. */
	if (u)
   	*u = '\0';
   return name;
}

/* decode a connector name :
   in modgen, 'cause we haven't the same conventions, a by me driven
   connector has the forms :
   xxx[?] -> xxx, where ? is a number, because I suffix all connectors that
                  way.
   xxx[??][?] -> xxx[??], because this was previously a vector. */

static char
	*checkconname(name)
char *name;
{
char *s, *t, *u = NULL;

   s = t = name;
   while (*t) {
      if (*t == '[') {
        	*t = ' ';
			u = s; /* last vector at that time */
      } else if (*t == ']') {
         if (*(++t) == '\0') /* ok, it's finished */
            goto end;
         else if (*t == '[') /* multiple array */
            continue;
		}
      *s++ = *t++;
   }
end:
   *s = '\0';
	/* last vectorized value :
	   it shall be skipped since I introduced it while driving the file. */
	if (u)
   	*u = '\0';
   return name;
}

/* decode an instance name :
   in modgen, 'cause we haven't the same conventions, a by me driven
   instance has the forms :
   xxx.corner
	since I arranged to put the corner in such a place that it makes it
   automatically good for mbk, I just forgot about the corner. */

static char
	*checkinsname(name)
char *name;
{
char *s = name;

	s = strrchr(name, '.');
   *s = '\0';
   return name;
}
