/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with MGN_ or mgn_.  They are
   private implementation details that can be changed or removed.  */

#ifndef MGN_MGN_Y_TAB_H_INCLUDED
# define MGN_MGN_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef MGNDEBUG
# define MGNDEBUG 0
#endif
#if MGNDEBUG
extern int mgndebug;
#endif

/* Token kinds.  */
#ifndef MGNTOKENTYPE
# define MGNTOKENTYPE
  enum mgntokentype
  {
    MGNEMPTY = -2,
    MGNEOF = 0,                     /* "end of file"  */
    MGNerror = 256,                 /* error  */
    MGNUNDEF = 257,                 /* "invalid token"  */
    CELL = 258,                    /* CELL  */
    PLACE = 259,                   /* PLACE  */
    TERMINAL = 260,                /* TERMINAL  */
    RA = 261,                      /* RA  */
    STRETCH = 262,                 /* STRETCH  */
    WIRE = 263,                    /* WIRE  */
    MWIDTH = 264,                  /* MWIDTH  */
    HORIZ = 265,                   /* HORIZ  */
    VERTI = 266,                   /* VERTI  */
    MLEFT = 267,                   /* MLEFT  */
    MRIGHT = 268,                  /* MRIGHT  */
    MTOP = 269,                    /* MTOP  */
    MBOTTOM = 270,                 /* MBOTTOM  */
    AT = 271,                      /* AT  */
    MX = 272,                      /* MX  */
    MY = 273,                      /* MY  */
    R = 274,                       /* R  */
    NTR = 275,                     /* NTR  */
    PTR = 276,                     /* PTR  */
    COP = 277,                     /* COP  */
    CON = 278,                     /* CON  */
    COPS = 279,                    /* COPS  */
    COPW = 280,                    /* COPW  */
    CONW = 281,                    /* CONW  */
    PVIA = 282,                    /* PVIA  */
    CXN = 283,                     /* CXN  */
    CXP = 284,                     /* CXP  */
    STRING = 285,                  /* STRING  */
    NUM = 286                      /* NUM  */
  };
  typedef enum mgntokentype mgntoken_kind_t;
#endif
/* Token kinds.  */
#define MGNEMPTY -2
#define MGNEOF 0
#define MGNerror 256
#define MGNUNDEF 257
#define CELL 258
#define PLACE 259
#define TERMINAL 260
#define RA 261
#define STRETCH 262
#define WIRE 263
#define MWIDTH 264
#define HORIZ 265
#define VERTI 266
#define MLEFT 267
#define MRIGHT 268
#define MTOP 269
#define MBOTTOM 270
#define AT 271
#define MX 272
#define MY 273
#define R 274
#define NTR 275
#define PTR 276
#define COP 277
#define CON 278
#define COPS 279
#define COPW 280
#define CONW 281
#define PVIA 282
#define CXN 283
#define CXP 284
#define STRING 285
#define NUM 286

/* Value type.  */
#if ! defined MGNSTYPE && ! defined MGNSTYPE_IS_DECLARED
union MGNSTYPE
{
#line 81 "./mg2mbk_y.y"

	char *s;
	long n;
	struct pxy {
		long x;
		long y;
	} *p;

#line 138 "y.tab.h"

};
typedef union MGNSTYPE MGNSTYPE;
# define MGNSTYPE_IS_TRIVIAL 1
# define MGNSTYPE_IS_DECLARED 1
#endif


extern MGNSTYPE mgnlval;


int mgnparse (void);


#endif /* !MGN_MGN_Y_TAB_H_INCLUDED  */
