/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         DEF_grammarparse
#define yylex           DEF_grammarlex
#define yyerror         DEF_grammarerror
#define yydebug         DEF_grammardebug
#define yynerrs         DEF_grammarnerrs
#define yylval          DEF_grammarlval
#define yychar          DEF_grammarchar

/* First part of user prologue.  */
#line 1 "DEF_grammar_yacc.y"

/*
 * $Author: jpc $
 * $Id: DEF_grammar_yacc.y,v 1.1 2002/04/25 16:16:20 jpc Exp $
 * $Date: 2002/04/25 16:16:20 $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "util_Defs.h"
#include "DEF_actions.h"


  /* Flex substitutions. */
# define        yylex              DEF_grammarlex
# define        yyin               DEF_grammarin
# define        yylineno           DEF_grammarlineno


#define YYDEBUG             1
#define YYERROR_VERBOSE         1

extern int      yylineno;
extern char    *yytext;

extern void     yyerror(char *str);
extern int      yylex(void);


#line 110 "DEF_grammar_yacc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_DEF_GRAMMAR_DEF_GRAMMAR_YACC_H_INCLUDED
# define YY_DEF_GRAMMAR_DEF_GRAMMAR_YACC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int DEF_grammardebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_Number = 258,                /* T_Number  */
    T_Ident = 259,                 /* T_Ident  */
    T_String = 260,                /* T_String  */
    T_History = 261,               /* T_History  */
    T_ALIGN = 262,                 /* T_ALIGN  */
    T_ARRAY = 263,                 /* T_ARRAY  */
    T_ASSERTIONS = 264,            /* T_ASSERTIONS  */
    T_BEGINEXT = 265,              /* T_BEGINEXT  */
    T_BOTTOMLEFT = 266,            /* T_BOTTOMLEFT  */
    T_BUSBITCHARS = 267,           /* T_BUSBITCHARS  */
    T_BY = 268,                    /* T_BY  */
    T_CANNOTOCCUPY = 269,          /* T_CANNOTOCCUPY  */
    T_CANPLACE = 270,              /* T_CANPLACE  */
    T_CAPACITANCE = 271,           /* T_CAPACITANCE  */
    T_COMMONSCANPINS = 272,        /* T_COMMONSCANPINS  */
    T_COMPONENT = 273,             /* T_COMPONENT  */
    T_COMPONENTPIN = 274,          /* T_COMPONENTPIN  */
    T_COMPS = 275,                 /* T_COMPS  */
    T_COMP_GEN = 276,              /* T_COMP_GEN  */
    T_CONSTRAINTS = 277,           /* T_CONSTRAINTS  */
    T_COVER = 278,                 /* T_COVER  */
    T_DEFAULTCAP = 279,            /* T_DEFAULTCAP  */
    T_DESIGN = 280,                /* T_DESIGN  */
    T_DIE_AREA = 281,              /* T_DIE_AREA  */
    T_DIFF = 282,                  /* T_DIFF  */
    T_DIRECTION = 283,             /* T_DIRECTION  */
    T_DISTANCE = 284,              /* T_DISTANCE  */
    T_DIVIDERCHAR = 285,           /* T_DIVIDERCHAR  */
    T_DO = 286,                    /* T_DO  */
    T_DRIVECELL = 287,             /* T_DRIVECELL  */
    T_E = 288,                     /* T_E  */
    T_EEQMASTER = 289,             /* T_EEQMASTER  */
    T_END = 290,                   /* T_END  */
    T_EQUAL = 291,                 /* T_EQUAL  */
    T_ESTCAP = 292,                /* T_ESTCAP  */
    T_FALL = 293,                  /* T_FALL  */
    T_FALLMAX = 294,               /* T_FALLMAX  */
    T_FALLMIN = 295,               /* T_FALLMIN  */
    T_FE = 296,                    /* T_FE  */
    T_FIXED = 297,                 /* T_FIXED  */
    T_FLOATING = 298,              /* T_FLOATING  */
    T_FLOORPLAN = 299,             /* T_FLOORPLAN  */
    T_FN = 300,                    /* T_FN  */
    T_FOREIGN = 301,               /* T_FOREIGN  */
    T_FPC = 302,                   /* T_FPC  */
    T_FROMCLOCKPIN = 303,          /* T_FROMCLOCKPIN  */
    T_FROMCOMPPIN = 304,           /* T_FROMCOMPPIN  */
    T_FROMIOPIN = 305,             /* T_FROMIOPIN  */
    T_FROMPIN = 306,               /* T_FROMPIN  */
    T_FS = 307,                    /* T_FS  */
    T_FW = 308,                    /* T_FW  */
    T_GCELLGRID = 309,             /* T_GCELLGRID  */
    T_GROUP = 310,                 /* T_GROUP  */
    T_GROUPS = 311,                /* T_GROUPS  */
    T_HISTORY = 312,               /* T_HISTORY  */
    T_HOLDFALL = 313,              /* T_HOLDFALL  */
    T_HOLDRISE = 314,              /* T_HOLDRISE  */
    T_HORIZONTAL = 315,            /* T_HORIZONTAL  */
    T_INTEGER = 316,               /* T_INTEGER  */
    T_IOTIMINGS = 317,             /* T_IOTIMINGS  */
    T_LAYER = 318,                 /* T_LAYER  */
    T_MACRO = 319,                 /* T_MACRO  */
    T_MAX = 320,                   /* T_MAX  */
    T_MAXDIST = 321,               /* T_MAXDIST  */
    T_MAXHALFPERIMETER = 322,      /* T_MAXHALFPERIMETER  */
    T_MAXX = 323,                  /* T_MAXX  */
    T_MAXY = 324,                  /* T_MAXY  */
    T_MICRONS = 325,               /* T_MICRONS  */
    T_MIN = 326,                   /* T_MIN  */
    T_MINPINS = 327,               /* T_MINPINS  */
    T_MUSTJOIN = 328,              /* T_MUSTJOIN  */
    T_N = 329,                     /* T_N  */
    T_NAMEMAPSTRING = 330,         /* T_NAMEMAPSTRING  */
    T_NAMESCASESENSITIVE = 331,    /* T_NAMESCASESENSITIVE  */
    T_NET = 332,                   /* T_NET  */
    T_NETS = 333,                  /* T_NETS  */
    T_NEW = 334,                   /* T_NEW  */
    T_NONDEFAULTRULE = 335,        /* T_NONDEFAULTRULE  */
    T_NOSHIELD = 336,              /* T_NOSHIELD  */
    T_ORDERED = 337,               /* T_ORDERED  */
    T_ORIGINAL = 338,              /* T_ORIGINAL  */
    T_PARALLEL = 339,              /* T_PARALLEL  */
    T_PARTITIONS = 340,            /* T_PARTITIONS  */
    T_PATH = 341,                  /* T_PATH  */
    T_PATTERN = 342,               /* T_PATTERN  */
    T_PATTERNNAME = 343,           /* T_PATTERNNAME  */
    T_PIN = 344,                   /* T_PIN  */
    T_PINPROPERTIES = 345,         /* T_PINPROPERTIES  */
    T_PINS = 346,                  /* T_PINS  */
    T_PLACED = 347,                /* T_PLACED  */
    T_PROPERTY = 348,              /* T_PROPERTY  */
    T_PROPERTYDEFINITIONS = 349,   /* T_PROPERTYDEFINITIONS  */
    T_RANGE = 350,                 /* T_RANGE  */
    T_REAL = 351,                  /* T_REAL  */
    T_RECT = 352,                  /* T_RECT  */
    T_REENTRANTPATHS = 353,        /* T_REENTRANTPATHS  */
    T_REGION = 354,                /* T_REGION  */
    T_REGIONS = 355,               /* T_REGIONS  */
    T_RISE = 356,                  /* T_RISE  */
    T_RISEMAX = 357,               /* T_RISEMAX  */
    T_RISEMIN = 358,               /* T_RISEMIN  */
    T_ROUTED = 359,                /* T_ROUTED  */
    T_ROW = 360,                   /* T_ROW  */
    T_ROWS = 361,                  /* T_ROWS  */
    T_S = 362,                     /* T_S  */
    T_SCANCHAINS = 363,            /* T_SCANCHAINS  */
    T_SETUPFALL = 364,             /* T_SETUPFALL  */
    T_SETUPRISE = 365,             /* T_SETUPRISE  */
    T_SHAPE = 366,                 /* T_SHAPE  */
    T_SHIELD = 367,                /* T_SHIELD  */
    T_SHIELDNET = 368,             /* T_SHIELDNET  */
    T_SITE = 369,                  /* T_SITE  */
    T_SLEWRATE = 370,              /* T_SLEWRATE  */
    T_SNET = 371,                  /* T_SNET  */
    T_SNETS = 372,                 /* T_SNETS  */
    T_SOFT = 373,                  /* T_SOFT  */
    T_SOURCE = 374,                /* T_SOURCE  */
    T_SPACING = 375,               /* T_SPACING  */
    T_SPECIAL = 376,               /* T_SPECIAL  */
    T_START = 377,                 /* T_START  */
    T_STEP = 378,                  /* T_STEP  */
    T_STOP = 379,                  /* T_STOP  */
    T_STYLE = 380,                 /* T_STYLE  */
    T_SUBNET = 381,                /* T_SUBNET  */
    T_SUM = 382,                   /* T_SUM  */
    T_SYNTHESIZED = 383,           /* T_SYNTHESIZED  */
    T_TAPER = 384,                 /* T_TAPER  */
    T_TAPERRULE = 385,             /* T_TAPERRULE  */
    T_TECH = 386,                  /* T_TECH  */
    T_THRUPIN = 387,               /* T_THRUPIN  */
    T_TIMINGDISABLES = 388,        /* T_TIMINGDISABLES  */
    T_TOCLOCKPIN = 389,            /* T_TOCLOCKPIN  */
    T_TOCOMPPIN = 390,             /* T_TOCOMPPIN  */
    T_TOIOPIN = 391,               /* T_TOIOPIN  */
    T_TOPIN = 392,                 /* T_TOPIN  */
    T_TOPRIGHT = 393,              /* T_TOPRIGHT  */
    T_TRACKS = 394,                /* T_TRACKS  */
    T_TURNOFF = 395,               /* T_TURNOFF  */
    T_UNITS = 396,                 /* T_UNITS  */
    T_UNPLACED = 397,              /* T_UNPLACED  */
    T_USE = 398,                   /* T_USE  */
    T_VARIABLE = 399,              /* T_VARIABLE  */
    T_VERSION = 400,               /* T_VERSION  */
    T_VERTICAL = 401,              /* T_VERTICAL  */
    T_VIAS = 402,                  /* T_VIAS  */
    T_VOLTAGE = 403,               /* T_VOLTAGE  */
    T_VPIN = 404,                  /* T_VPIN  */
    T_W = 405,                     /* T_W  */
    T_WEIGHT = 406,                /* T_WEIGHT  */
    T_WIDTH = 407,                 /* T_WIDTH  */
    T_WIRECAP = 408,               /* T_WIRECAP  */
    T_WIREDLOGIC = 409,            /* T_WIREDLOGIC  */
    T_XTALK = 410,                 /* T_XTALK  */
    T_INPUT = 411,                 /* T_INPUT  */
    T_OUTPUT = 412,                /* T_OUTPUT  */
    T_INOUT = 413,                 /* T_INOUT  */
    T_FEEDTHRU = 414               /* T_FEEDTHRU  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define T_Number 258
#define T_Ident 259
#define T_String 260
#define T_History 261
#define T_ALIGN 262
#define T_ARRAY 263
#define T_ASSERTIONS 264
#define T_BEGINEXT 265
#define T_BOTTOMLEFT 266
#define T_BUSBITCHARS 267
#define T_BY 268
#define T_CANNOTOCCUPY 269
#define T_CANPLACE 270
#define T_CAPACITANCE 271
#define T_COMMONSCANPINS 272
#define T_COMPONENT 273
#define T_COMPONENTPIN 274
#define T_COMPS 275
#define T_COMP_GEN 276
#define T_CONSTRAINTS 277
#define T_COVER 278
#define T_DEFAULTCAP 279
#define T_DESIGN 280
#define T_DIE_AREA 281
#define T_DIFF 282
#define T_DIRECTION 283
#define T_DISTANCE 284
#define T_DIVIDERCHAR 285
#define T_DO 286
#define T_DRIVECELL 287
#define T_E 288
#define T_EEQMASTER 289
#define T_END 290
#define T_EQUAL 291
#define T_ESTCAP 292
#define T_FALL 293
#define T_FALLMAX 294
#define T_FALLMIN 295
#define T_FE 296
#define T_FIXED 297
#define T_FLOATING 298
#define T_FLOORPLAN 299
#define T_FN 300
#define T_FOREIGN 301
#define T_FPC 302
#define T_FROMCLOCKPIN 303
#define T_FROMCOMPPIN 304
#define T_FROMIOPIN 305
#define T_FROMPIN 306
#define T_FS 307
#define T_FW 308
#define T_GCELLGRID 309
#define T_GROUP 310
#define T_GROUPS 311
#define T_HISTORY 312
#define T_HOLDFALL 313
#define T_HOLDRISE 314
#define T_HORIZONTAL 315
#define T_INTEGER 316
#define T_IOTIMINGS 317
#define T_LAYER 318
#define T_MACRO 319
#define T_MAX 320
#define T_MAXDIST 321
#define T_MAXHALFPERIMETER 322
#define T_MAXX 323
#define T_MAXY 324
#define T_MICRONS 325
#define T_MIN 326
#define T_MINPINS 327
#define T_MUSTJOIN 328
#define T_N 329
#define T_NAMEMAPSTRING 330
#define T_NAMESCASESENSITIVE 331
#define T_NET 332
#define T_NETS 333
#define T_NEW 334
#define T_NONDEFAULTRULE 335
#define T_NOSHIELD 336
#define T_ORDERED 337
#define T_ORIGINAL 338
#define T_PARALLEL 339
#define T_PARTITIONS 340
#define T_PATH 341
#define T_PATTERN 342
#define T_PATTERNNAME 343
#define T_PIN 344
#define T_PINPROPERTIES 345
#define T_PINS 346
#define T_PLACED 347
#define T_PROPERTY 348
#define T_PROPERTYDEFINITIONS 349
#define T_RANGE 350
#define T_REAL 351
#define T_RECT 352
#define T_REENTRANTPATHS 353
#define T_REGION 354
#define T_REGIONS 355
#define T_RISE 356
#define T_RISEMAX 357
#define T_RISEMIN 358
#define T_ROUTED 359
#define T_ROW 360
#define T_ROWS 361
#define T_S 362
#define T_SCANCHAINS 363
#define T_SETUPFALL 364
#define T_SETUPRISE 365
#define T_SHAPE 366
#define T_SHIELD 367
#define T_SHIELDNET 368
#define T_SITE 369
#define T_SLEWRATE 370
#define T_SNET 371
#define T_SNETS 372
#define T_SOFT 373
#define T_SOURCE 374
#define T_SPACING 375
#define T_SPECIAL 376
#define T_START 377
#define T_STEP 378
#define T_STOP 379
#define T_STYLE 380
#define T_SUBNET 381
#define T_SUM 382
#define T_SYNTHESIZED 383
#define T_TAPER 384
#define T_TAPERRULE 385
#define T_TECH 386
#define T_THRUPIN 387
#define T_TIMINGDISABLES 388
#define T_TOCLOCKPIN 389
#define T_TOCOMPPIN 390
#define T_TOIOPIN 391
#define T_TOPIN 392
#define T_TOPRIGHT 393
#define T_TRACKS 394
#define T_TURNOFF 395
#define T_UNITS 396
#define T_UNPLACED 397
#define T_USE 398
#define T_VARIABLE 399
#define T_VERSION 400
#define T_VERTICAL 401
#define T_VIAS 402
#define T_VOLTAGE 403
#define T_VPIN 404
#define T_W 405
#define T_WEIGHT 406
#define T_WIDTH 407
#define T_WIRECAP 408
#define T_WIREDLOGIC 409
#define T_XTALK 410
#define T_INPUT 411
#define T_OUTPUT 412
#define T_INOUT 413
#define T_FEEDTHRU 414

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 33 "DEF_grammar_yacc.y"

    double       n;
    char        *s;
    struct pt   *pt;

#line 487 "DEF_grammar_yacc.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE DEF_grammarlval;


int DEF_grammarparse (void);


#endif /* !YY_DEF_GRAMMAR_DEF_GRAMMAR_YACC_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_Number = 3,                   /* T_Number  */
  YYSYMBOL_T_Ident = 4,                    /* T_Ident  */
  YYSYMBOL_T_String = 5,                   /* T_String  */
  YYSYMBOL_T_History = 6,                  /* T_History  */
  YYSYMBOL_T_ALIGN = 7,                    /* T_ALIGN  */
  YYSYMBOL_T_ARRAY = 8,                    /* T_ARRAY  */
  YYSYMBOL_T_ASSERTIONS = 9,               /* T_ASSERTIONS  */
  YYSYMBOL_T_BEGINEXT = 10,                /* T_BEGINEXT  */
  YYSYMBOL_T_BOTTOMLEFT = 11,              /* T_BOTTOMLEFT  */
  YYSYMBOL_T_BUSBITCHARS = 12,             /* T_BUSBITCHARS  */
  YYSYMBOL_T_BY = 13,                      /* T_BY  */
  YYSYMBOL_T_CANNOTOCCUPY = 14,            /* T_CANNOTOCCUPY  */
  YYSYMBOL_T_CANPLACE = 15,                /* T_CANPLACE  */
  YYSYMBOL_T_CAPACITANCE = 16,             /* T_CAPACITANCE  */
  YYSYMBOL_T_COMMONSCANPINS = 17,          /* T_COMMONSCANPINS  */
  YYSYMBOL_T_COMPONENT = 18,               /* T_COMPONENT  */
  YYSYMBOL_T_COMPONENTPIN = 19,            /* T_COMPONENTPIN  */
  YYSYMBOL_T_COMPS = 20,                   /* T_COMPS  */
  YYSYMBOL_T_COMP_GEN = 21,                /* T_COMP_GEN  */
  YYSYMBOL_T_CONSTRAINTS = 22,             /* T_CONSTRAINTS  */
  YYSYMBOL_T_COVER = 23,                   /* T_COVER  */
  YYSYMBOL_T_DEFAULTCAP = 24,              /* T_DEFAULTCAP  */
  YYSYMBOL_T_DESIGN = 25,                  /* T_DESIGN  */
  YYSYMBOL_T_DIE_AREA = 26,                /* T_DIE_AREA  */
  YYSYMBOL_T_DIFF = 27,                    /* T_DIFF  */
  YYSYMBOL_T_DIRECTION = 28,               /* T_DIRECTION  */
  YYSYMBOL_T_DISTANCE = 29,                /* T_DISTANCE  */
  YYSYMBOL_T_DIVIDERCHAR = 30,             /* T_DIVIDERCHAR  */
  YYSYMBOL_T_DO = 31,                      /* T_DO  */
  YYSYMBOL_T_DRIVECELL = 32,               /* T_DRIVECELL  */
  YYSYMBOL_T_E = 33,                       /* T_E  */
  YYSYMBOL_T_EEQMASTER = 34,               /* T_EEQMASTER  */
  YYSYMBOL_T_END = 35,                     /* T_END  */
  YYSYMBOL_T_EQUAL = 36,                   /* T_EQUAL  */
  YYSYMBOL_T_ESTCAP = 37,                  /* T_ESTCAP  */
  YYSYMBOL_T_FALL = 38,                    /* T_FALL  */
  YYSYMBOL_T_FALLMAX = 39,                 /* T_FALLMAX  */
  YYSYMBOL_T_FALLMIN = 40,                 /* T_FALLMIN  */
  YYSYMBOL_T_FE = 41,                      /* T_FE  */
  YYSYMBOL_T_FIXED = 42,                   /* T_FIXED  */
  YYSYMBOL_T_FLOATING = 43,                /* T_FLOATING  */
  YYSYMBOL_T_FLOORPLAN = 44,               /* T_FLOORPLAN  */
  YYSYMBOL_T_FN = 45,                      /* T_FN  */
  YYSYMBOL_T_FOREIGN = 46,                 /* T_FOREIGN  */
  YYSYMBOL_T_FPC = 47,                     /* T_FPC  */
  YYSYMBOL_T_FROMCLOCKPIN = 48,            /* T_FROMCLOCKPIN  */
  YYSYMBOL_T_FROMCOMPPIN = 49,             /* T_FROMCOMPPIN  */
  YYSYMBOL_T_FROMIOPIN = 50,               /* T_FROMIOPIN  */
  YYSYMBOL_T_FROMPIN = 51,                 /* T_FROMPIN  */
  YYSYMBOL_T_FS = 52,                      /* T_FS  */
  YYSYMBOL_T_FW = 53,                      /* T_FW  */
  YYSYMBOL_T_GCELLGRID = 54,               /* T_GCELLGRID  */
  YYSYMBOL_T_GROUP = 55,                   /* T_GROUP  */
  YYSYMBOL_T_GROUPS = 56,                  /* T_GROUPS  */
  YYSYMBOL_T_HISTORY = 57,                 /* T_HISTORY  */
  YYSYMBOL_T_HOLDFALL = 58,                /* T_HOLDFALL  */
  YYSYMBOL_T_HOLDRISE = 59,                /* T_HOLDRISE  */
  YYSYMBOL_T_HORIZONTAL = 60,              /* T_HORIZONTAL  */
  YYSYMBOL_T_INTEGER = 61,                 /* T_INTEGER  */
  YYSYMBOL_T_IOTIMINGS = 62,               /* T_IOTIMINGS  */
  YYSYMBOL_T_LAYER = 63,                   /* T_LAYER  */
  YYSYMBOL_T_MACRO = 64,                   /* T_MACRO  */
  YYSYMBOL_T_MAX = 65,                     /* T_MAX  */
  YYSYMBOL_T_MAXDIST = 66,                 /* T_MAXDIST  */
  YYSYMBOL_T_MAXHALFPERIMETER = 67,        /* T_MAXHALFPERIMETER  */
  YYSYMBOL_T_MAXX = 68,                    /* T_MAXX  */
  YYSYMBOL_T_MAXY = 69,                    /* T_MAXY  */
  YYSYMBOL_T_MICRONS = 70,                 /* T_MICRONS  */
  YYSYMBOL_T_MIN = 71,                     /* T_MIN  */
  YYSYMBOL_T_MINPINS = 72,                 /* T_MINPINS  */
  YYSYMBOL_T_MUSTJOIN = 73,                /* T_MUSTJOIN  */
  YYSYMBOL_T_N = 74,                       /* T_N  */
  YYSYMBOL_T_NAMEMAPSTRING = 75,           /* T_NAMEMAPSTRING  */
  YYSYMBOL_T_NAMESCASESENSITIVE = 76,      /* T_NAMESCASESENSITIVE  */
  YYSYMBOL_T_NET = 77,                     /* T_NET  */
  YYSYMBOL_T_NETS = 78,                    /* T_NETS  */
  YYSYMBOL_T_NEW = 79,                     /* T_NEW  */
  YYSYMBOL_T_NONDEFAULTRULE = 80,          /* T_NONDEFAULTRULE  */
  YYSYMBOL_T_NOSHIELD = 81,                /* T_NOSHIELD  */
  YYSYMBOL_T_ORDERED = 82,                 /* T_ORDERED  */
  YYSYMBOL_T_ORIGINAL = 83,                /* T_ORIGINAL  */
  YYSYMBOL_T_PARALLEL = 84,                /* T_PARALLEL  */
  YYSYMBOL_T_PARTITIONS = 85,              /* T_PARTITIONS  */
  YYSYMBOL_T_PATH = 86,                    /* T_PATH  */
  YYSYMBOL_T_PATTERN = 87,                 /* T_PATTERN  */
  YYSYMBOL_T_PATTERNNAME = 88,             /* T_PATTERNNAME  */
  YYSYMBOL_T_PIN = 89,                     /* T_PIN  */
  YYSYMBOL_T_PINPROPERTIES = 90,           /* T_PINPROPERTIES  */
  YYSYMBOL_T_PINS = 91,                    /* T_PINS  */
  YYSYMBOL_T_PLACED = 92,                  /* T_PLACED  */
  YYSYMBOL_T_PROPERTY = 93,                /* T_PROPERTY  */
  YYSYMBOL_T_PROPERTYDEFINITIONS = 94,     /* T_PROPERTYDEFINITIONS  */
  YYSYMBOL_T_RANGE = 95,                   /* T_RANGE  */
  YYSYMBOL_T_REAL = 96,                    /* T_REAL  */
  YYSYMBOL_T_RECT = 97,                    /* T_RECT  */
  YYSYMBOL_T_REENTRANTPATHS = 98,          /* T_REENTRANTPATHS  */
  YYSYMBOL_T_REGION = 99,                  /* T_REGION  */
  YYSYMBOL_T_REGIONS = 100,                /* T_REGIONS  */
  YYSYMBOL_T_RISE = 101,                   /* T_RISE  */
  YYSYMBOL_T_RISEMAX = 102,                /* T_RISEMAX  */
  YYSYMBOL_T_RISEMIN = 103,                /* T_RISEMIN  */
  YYSYMBOL_T_ROUTED = 104,                 /* T_ROUTED  */
  YYSYMBOL_T_ROW = 105,                    /* T_ROW  */
  YYSYMBOL_T_ROWS = 106,                   /* T_ROWS  */
  YYSYMBOL_T_S = 107,                      /* T_S  */
  YYSYMBOL_T_SCANCHAINS = 108,             /* T_SCANCHAINS  */
  YYSYMBOL_T_SETUPFALL = 109,              /* T_SETUPFALL  */
  YYSYMBOL_T_SETUPRISE = 110,              /* T_SETUPRISE  */
  YYSYMBOL_T_SHAPE = 111,                  /* T_SHAPE  */
  YYSYMBOL_T_SHIELD = 112,                 /* T_SHIELD  */
  YYSYMBOL_T_SHIELDNET = 113,              /* T_SHIELDNET  */
  YYSYMBOL_T_SITE = 114,                   /* T_SITE  */
  YYSYMBOL_T_SLEWRATE = 115,               /* T_SLEWRATE  */
  YYSYMBOL_T_SNET = 116,                   /* T_SNET  */
  YYSYMBOL_T_SNETS = 117,                  /* T_SNETS  */
  YYSYMBOL_T_SOFT = 118,                   /* T_SOFT  */
  YYSYMBOL_T_SOURCE = 119,                 /* T_SOURCE  */
  YYSYMBOL_T_SPACING = 120,                /* T_SPACING  */
  YYSYMBOL_T_SPECIAL = 121,                /* T_SPECIAL  */
  YYSYMBOL_T_START = 122,                  /* T_START  */
  YYSYMBOL_T_STEP = 123,                   /* T_STEP  */
  YYSYMBOL_T_STOP = 124,                   /* T_STOP  */
  YYSYMBOL_T_STYLE = 125,                  /* T_STYLE  */
  YYSYMBOL_T_SUBNET = 126,                 /* T_SUBNET  */
  YYSYMBOL_T_SUM = 127,                    /* T_SUM  */
  YYSYMBOL_T_SYNTHESIZED = 128,            /* T_SYNTHESIZED  */
  YYSYMBOL_T_TAPER = 129,                  /* T_TAPER  */
  YYSYMBOL_T_TAPERRULE = 130,              /* T_TAPERRULE  */
  YYSYMBOL_T_TECH = 131,                   /* T_TECH  */
  YYSYMBOL_T_THRUPIN = 132,                /* T_THRUPIN  */
  YYSYMBOL_T_TIMINGDISABLES = 133,         /* T_TIMINGDISABLES  */
  YYSYMBOL_T_TOCLOCKPIN = 134,             /* T_TOCLOCKPIN  */
  YYSYMBOL_T_TOCOMPPIN = 135,              /* T_TOCOMPPIN  */
  YYSYMBOL_T_TOIOPIN = 136,                /* T_TOIOPIN  */
  YYSYMBOL_T_TOPIN = 137,                  /* T_TOPIN  */
  YYSYMBOL_T_TOPRIGHT = 138,               /* T_TOPRIGHT  */
  YYSYMBOL_T_TRACKS = 139,                 /* T_TRACKS  */
  YYSYMBOL_T_TURNOFF = 140,                /* T_TURNOFF  */
  YYSYMBOL_T_UNITS = 141,                  /* T_UNITS  */
  YYSYMBOL_T_UNPLACED = 142,               /* T_UNPLACED  */
  YYSYMBOL_T_USE = 143,                    /* T_USE  */
  YYSYMBOL_T_VARIABLE = 144,               /* T_VARIABLE  */
  YYSYMBOL_T_VERSION = 145,                /* T_VERSION  */
  YYSYMBOL_T_VERTICAL = 146,               /* T_VERTICAL  */
  YYSYMBOL_T_VIAS = 147,                   /* T_VIAS  */
  YYSYMBOL_T_VOLTAGE = 148,                /* T_VOLTAGE  */
  YYSYMBOL_T_VPIN = 149,                   /* T_VPIN  */
  YYSYMBOL_T_W = 150,                      /* T_W  */
  YYSYMBOL_T_WEIGHT = 151,                 /* T_WEIGHT  */
  YYSYMBOL_T_WIDTH = 152,                  /* T_WIDTH  */
  YYSYMBOL_T_WIRECAP = 153,                /* T_WIRECAP  */
  YYSYMBOL_T_WIREDLOGIC = 154,             /* T_WIREDLOGIC  */
  YYSYMBOL_T_XTALK = 155,                  /* T_XTALK  */
  YYSYMBOL_T_INPUT = 156,                  /* T_INPUT  */
  YYSYMBOL_T_OUTPUT = 157,                 /* T_OUTPUT  */
  YYSYMBOL_T_INOUT = 158,                  /* T_INOUT  */
  YYSYMBOL_T_FEEDTHRU = 159,               /* T_FEEDTHRU  */
  YYSYMBOL_160_ = 160,                     /* ';'  */
  YYSYMBOL_161_ = 161,                     /* '-'  */
  YYSYMBOL_162_ = 162,                     /* '+'  */
  YYSYMBOL_163_ = 163,                     /* '('  */
  YYSYMBOL_164_ = 164,                     /* ')'  */
  YYSYMBOL_165_ = 165,                     /* '*'  */
  YYSYMBOL_166_ = 166,                     /* ','  */
  YYSYMBOL_YYACCEPT = 167,                 /* $accept  */
  YYSYMBOL_def_file = 168,                 /* def_file  */
  YYSYMBOL_version_stmt = 169,             /* version_stmt  */
  YYSYMBOL_case_sens_stmt = 170,           /* case_sens_stmt  */
  YYSYMBOL_rules = 171,                    /* rules  */
  YYSYMBOL_rule = 172,                     /* rule  */
  YYSYMBOL_design_section = 173,           /* design_section  */
  YYSYMBOL_design_name = 174,              /* design_name  */
  YYSYMBOL_end_design = 175,               /* end_design  */
  YYSYMBOL_tech_name = 176,                /* tech_name  */
  YYSYMBOL_array_name = 177,               /* array_name  */
  YYSYMBOL_floorplan_name = 178,           /* floorplan_name  */
  YYSYMBOL_history = 179,                  /* history  */
  YYSYMBOL_prop_def_section = 180,         /* prop_def_section  */
  YYSYMBOL_property_defs = 181,            /* property_defs  */
  YYSYMBOL_property_def = 182,             /* property_def  */
  YYSYMBOL_property_type_and_val = 183,    /* property_type_and_val  */
  YYSYMBOL_opt_num_val = 184,              /* opt_num_val  */
  YYSYMBOL_units = 185,                    /* units  */
  YYSYMBOL_divider_char = 186,             /* divider_char  */
  YYSYMBOL_bus_bit_chars = 187,            /* bus_bit_chars  */
  YYSYMBOL_site = 188,                     /* site  */
  YYSYMBOL_canplace = 189,                 /* canplace  */
  YYSYMBOL_cannotoccupy = 190,             /* cannotoccupy  */
  YYSYMBOL_orient = 191,                   /* orient  */
  YYSYMBOL_direction = 192,                /* direction  */
  YYSYMBOL_die_area = 193,                 /* die_area  */
  YYSYMBOL_pin_cap_rule = 194,             /* pin_cap_rule  */
  YYSYMBOL_start_def_cap = 195,            /* start_def_cap  */
  YYSYMBOL_pin_caps = 196,                 /* pin_caps  */
  YYSYMBOL_pin_cap = 197,                  /* pin_cap  */
  YYSYMBOL_end_def_cap = 198,              /* end_def_cap  */
  YYSYMBOL_pin_rule = 199,                 /* pin_rule  */
  YYSYMBOL_start_pins = 200,               /* start_pins  */
  YYSYMBOL_pins = 201,                     /* pins  */
  YYSYMBOL_pin = 202,                      /* pin  */
  YYSYMBOL_pin_start = 203,                /* pin_start  */
  YYSYMBOL_pin_options = 204,              /* pin_options  */
  YYSYMBOL_pin_option = 205,               /* pin_option  */
  YYSYMBOL_end_pins = 206,                 /* end_pins  */
  YYSYMBOL_row_rule = 207,                 /* row_rule  */
  YYSYMBOL_row_options = 208,              /* row_options  */
  YYSYMBOL_row_option = 209,               /* row_option  */
  YYSYMBOL_row_prop_list = 210,            /* row_prop_list  */
  YYSYMBOL_row_prop = 211,                 /* row_prop  */
  YYSYMBOL_tracks_rule = 212,              /* tracks_rule  */
  YYSYMBOL_track_start = 213,              /* track_start  */
  YYSYMBOL_track_layer_statement = 214,    /* track_layer_statement  */
  YYSYMBOL_track_layers = 215,             /* track_layers  */
  YYSYMBOL_track_layer = 216,              /* track_layer  */
  YYSYMBOL_gcellgrid = 217,                /* gcellgrid  */
  YYSYMBOL_extension_section = 218,        /* extension_section  */
  YYSYMBOL_extension_stmt = 219,           /* extension_stmt  */
  YYSYMBOL_via_section = 220,              /* via_section  */
  YYSYMBOL_via = 221,                      /* via  */
  YYSYMBOL_via_declarations = 222,         /* via_declarations  */
  YYSYMBOL_via_declaration = 223,          /* via_declaration  */
  YYSYMBOL_via_start = 224,                /* via_start  */
  YYSYMBOL_layer_stmts = 225,              /* layer_stmts  */
  YYSYMBOL_layer_stmt = 226,               /* layer_stmt  */
  YYSYMBOL_pt = 227,                       /* pt  */
  YYSYMBOL_via_end = 228,                  /* via_end  */
  YYSYMBOL_regions_section = 229,          /* regions_section  */
  YYSYMBOL_regions_start = 230,            /* regions_start  */
  YYSYMBOL_regions_stmts = 231,            /* regions_stmts  */
  YYSYMBOL_regions_stmt = 232,             /* regions_stmt  */
  YYSYMBOL_rect_list = 233,                /* rect_list  */
  YYSYMBOL_region_options = 234,           /* region_options  */
  YYSYMBOL_region_option = 235,            /* region_option  */
  YYSYMBOL_region_prop_list = 236,         /* region_prop_list  */
  YYSYMBOL_region_prop = 237,              /* region_prop  */
  YYSYMBOL_comps_section = 238,            /* comps_section  */
  YYSYMBOL_start_comps = 239,              /* start_comps  */
  YYSYMBOL_comps_rule = 240,               /* comps_rule  */
  YYSYMBOL_comp = 241,                     /* comp  */
  YYSYMBOL_comp_start = 242,               /* comp_start  */
  YYSYMBOL_comp_net_list = 243,            /* comp_net_list  */
  YYSYMBOL_comp_options = 244,             /* comp_options  */
  YYSYMBOL_comp_option = 245,              /* comp_option  */
  YYSYMBOL_comp_extension_stmt = 246,      /* comp_extension_stmt  */
  YYSYMBOL_comp_eeq = 247,                 /* comp_eeq  */
  YYSYMBOL_comp_generate = 248,            /* comp_generate  */
  YYSYMBOL_opt_pattern = 249,              /* opt_pattern  */
  YYSYMBOL_comp_source = 250,              /* comp_source  */
  YYSYMBOL_comp_region = 251,              /* comp_region  */
  YYSYMBOL_comp_pnt_list = 252,            /* comp_pnt_list  */
  YYSYMBOL_comp_property = 253,            /* comp_property  */
  YYSYMBOL_comp_prop_list = 254,           /* comp_prop_list  */
  YYSYMBOL_comp_prop = 255,                /* comp_prop  */
  YYSYMBOL_comp_region_start = 256,        /* comp_region_start  */
  YYSYMBOL_comp_foreign = 257,             /* comp_foreign  */
  YYSYMBOL_opt_paren = 258,                /* opt_paren  */
  YYSYMBOL_comp_type = 259,                /* comp_type  */
  YYSYMBOL_placement_status = 260,         /* placement_status  */
  YYSYMBOL_weight = 261,                   /* weight  */
  YYSYMBOL_end_comps = 262,                /* end_comps  */
  YYSYMBOL_nets_section = 263,             /* nets_section  */
  YYSYMBOL_start_nets = 264,               /* start_nets  */
  YYSYMBOL_net_rules = 265,                /* net_rules  */
  YYSYMBOL_one_net = 266,                  /* one_net  */
  YYSYMBOL_net_start = 267,                /* net_start  */
  YYSYMBOL_net_connections = 268,          /* net_connections  */
  YYSYMBOL_net_connection = 269,           /* net_connection  */
  YYSYMBOL_net_conn_start = 270,           /* net_conn_start  */
  YYSYMBOL_net_conn_opt = 271,             /* net_conn_opt  */
  YYSYMBOL_net_options = 272,              /* net_options  */
  YYSYMBOL_net_option = 273,               /* net_option  */
  YYSYMBOL_net_prop_list = 274,            /* net_prop_list  */
  YYSYMBOL_net_prop = 275,                 /* net_prop  */
  YYSYMBOL_vpin_stmt = 276,                /* vpin_stmt  */
  YYSYMBOL_vpin_begin = 277,               /* vpin_begin  */
  YYSYMBOL_vpin_layer_opt = 278,           /* vpin_layer_opt  */
  YYSYMBOL_property_val = 279,             /* property_val  */
  YYSYMBOL_vpin_options = 280,             /* vpin_options  */
  YYSYMBOL_vpin_status = 281,              /* vpin_status  */
  YYSYMBOL_net_type = 282,                 /* net_type  */
  YYSYMBOL_paths = 283,                    /* paths  */
  YYSYMBOL_new_path = 284,                 /* new_path  */
  YYSYMBOL_path = 285,                     /* path  */
  YYSYMBOL_path_start = 286,               /* path_start  */
  YYSYMBOL_path_item_list = 287,           /* path_item_list  */
  YYSYMBOL_path_item = 288,                /* path_item  */
  YYSYMBOL_path_pt = 289,                  /* path_pt  */
  YYSYMBOL_opt_taper = 290,                /* opt_taper  */
  YYSYMBOL_opt_shape = 291,                /* opt_shape  */
  YYSYMBOL_opt_width = 292,                /* opt_width  */
  YYSYMBOL_end_nets = 293,                 /* end_nets  */
  YYSYMBOL_snets_section = 294,            /* snets_section  */
  YYSYMBOL_snet_rules = 295,               /* snet_rules  */
  YYSYMBOL_snet_rule = 296,                /* snet_rule  */
  YYSYMBOL_snet_start = 297,               /* snet_start  */
  YYSYMBOL_snet_connections = 298,         /* snet_connections  */
  YYSYMBOL_snet_connection = 299,          /* snet_connection  */
  YYSYMBOL_snet_conn_start = 300,          /* snet_conn_start  */
  YYSYMBOL_snet_conn_opt = 301,            /* snet_conn_opt  */
  YYSYMBOL_snet_options = 302,             /* snet_options  */
  YYSYMBOL_snet_option = 303,              /* snet_option  */
  YYSYMBOL_snet_other_option = 304,        /* snet_other_option  */
  YYSYMBOL_snet_width = 305,               /* snet_width  */
  YYSYMBOL_snet_voltage = 306,             /* snet_voltage  */
  YYSYMBOL_snet_spacing = 307,             /* snet_spacing  */
  YYSYMBOL_opt_snet_range = 308,           /* opt_snet_range  */
  YYSYMBOL_opt_range = 309,                /* opt_range  */
  YYSYMBOL_start_snets = 310,              /* start_snets  */
  YYSYMBOL_end_snets = 311,                /* end_snets  */
  YYSYMBOL_groups_section = 312,           /* groups_section  */
  YYSYMBOL_groups_start = 313,             /* groups_start  */
  YYSYMBOL_group_rules = 314,              /* group_rules  */
  YYSYMBOL_group_rule = 315,               /* group_rule  */
  YYSYMBOL_start_group = 316,              /* start_group  */
  YYSYMBOL_group_members = 317,            /* group_members  */
  YYSYMBOL_group_member = 318,             /* group_member  */
  YYSYMBOL_group_options = 319,            /* group_options  */
  YYSYMBOL_group_option = 320,             /* group_option  */
  YYSYMBOL_group_region = 321,             /* group_region  */
  YYSYMBOL_group_prop_list = 322,          /* group_prop_list  */
  YYSYMBOL_group_prop = 323,               /* group_prop  */
  YYSYMBOL_group_soft_options = 324,       /* group_soft_options  */
  YYSYMBOL_group_soft_option = 325,        /* group_soft_option  */
  YYSYMBOL_groups_end = 326,               /* groups_end  */
  YYSYMBOL_assertions_section = 327,       /* assertions_section  */
  YYSYMBOL_constraint_section = 328,       /* constraint_section  */
  YYSYMBOL_assertions_start = 329,         /* assertions_start  */
  YYSYMBOL_constraints_start = 330,        /* constraints_start  */
  YYSYMBOL_constraint_rules = 331,         /* constraint_rules  */
  YYSYMBOL_constraint_rule = 332,          /* constraint_rule  */
  YYSYMBOL_operand_rule = 333,             /* operand_rule  */
  YYSYMBOL_operand = 334,                  /* operand  */
  YYSYMBOL_operand_list = 335,             /* operand_list  */
  YYSYMBOL_wiredlogic_rule = 336,          /* wiredlogic_rule  */
  YYSYMBOL_opt_plus = 337,                 /* opt_plus  */
  YYSYMBOL_delay_specs = 338,              /* delay_specs  */
  YYSYMBOL_delay_spec = 339,               /* delay_spec  */
  YYSYMBOL_constraints_end = 340,          /* constraints_end  */
  YYSYMBOL_assertions_end = 341,           /* assertions_end  */
  YYSYMBOL_scanchains_section = 342,       /* scanchains_section  */
  YYSYMBOL_scanchain_start = 343,          /* scanchain_start  */
  YYSYMBOL_scanchain_rules = 344,          /* scanchain_rules  */
  YYSYMBOL_scan_rule = 345,                /* scan_rule  */
  YYSYMBOL_start_scan = 346,               /* start_scan  */
  YYSYMBOL_scan_members = 347,             /* scan_members  */
  YYSYMBOL_opt_pin = 348,                  /* opt_pin  */
  YYSYMBOL_scan_member = 349,              /* scan_member  */
  YYSYMBOL_opt_common_pins = 350,          /* opt_common_pins  */
  YYSYMBOL_floating_inst_list = 351,       /* floating_inst_list  */
  YYSYMBOL_one_floating_inst = 352,        /* one_floating_inst  */
  YYSYMBOL_floating_pins = 353,            /* floating_pins  */
  YYSYMBOL_ordered_inst_list = 354,        /* ordered_inst_list  */
  YYSYMBOL_one_ordered_inst = 355,         /* one_ordered_inst  */
  YYSYMBOL_ordered_pins = 356,             /* ordered_pins  */
  YYSYMBOL_scanchain_end = 357,            /* scanchain_end  */
  YYSYMBOL_iotiming_section = 358,         /* iotiming_section  */
  YYSYMBOL_iotiming_start = 359,           /* iotiming_start  */
  YYSYMBOL_iotiming_rules = 360,           /* iotiming_rules  */
  YYSYMBOL_iotiming_rule = 361,            /* iotiming_rule  */
  YYSYMBOL_start_iotiming = 362,           /* start_iotiming  */
  YYSYMBOL_iotiming_members = 363,         /* iotiming_members  */
  YYSYMBOL_iotiming_member = 364,          /* iotiming_member  */
  YYSYMBOL_risefall = 365,                 /* risefall  */
  YYSYMBOL_iotiming_end = 366,             /* iotiming_end  */
  YYSYMBOL_floorplan_contraints_section = 367, /* floorplan_contraints_section  */
  YYSYMBOL_fp_start = 368,                 /* fp_start  */
  YYSYMBOL_fp_stmts = 369,                 /* fp_stmts  */
  YYSYMBOL_fp_stmt = 370,                  /* fp_stmt  */
  YYSYMBOL_h_or_v = 371,                   /* h_or_v  */
  YYSYMBOL_constraint_type = 372,          /* constraint_type  */
  YYSYMBOL_constrain_what_list = 373,      /* constrain_what_list  */
  YYSYMBOL_constrain_what = 374,           /* constrain_what  */
  YYSYMBOL_row_or_comp_list = 375,         /* row_or_comp_list  */
  YYSYMBOL_row_or_comp = 376,              /* row_or_comp  */
  YYSYMBOL_timingdisables_section = 377,   /* timingdisables_section  */
  YYSYMBOL_timingdisables_start = 378,     /* timingdisables_start  */
  YYSYMBOL_timingdisables_rules = 379,     /* timingdisables_rules  */
  YYSYMBOL_timingdisables_rule = 380,      /* timingdisables_rule  */
  YYSYMBOL_td_macro_option = 381,          /* td_macro_option  */
  YYSYMBOL_timingdisables_end = 382,       /* timingdisables_end  */
  YYSYMBOL_partitions_section = 383,       /* partitions_section  */
  YYSYMBOL_partitions_start = 384,         /* partitions_start  */
  YYSYMBOL_partition_rules = 385,          /* partition_rules  */
  YYSYMBOL_partition_rule = 386,           /* partition_rule  */
  YYSYMBOL_start_partition = 387,          /* start_partition  */
  YYSYMBOL_turnoff = 388,                  /* turnoff  */
  YYSYMBOL_turnoff_setup = 389,            /* turnoff_setup  */
  YYSYMBOL_turnoff_hold = 390,             /* turnoff_hold  */
  YYSYMBOL_partition_members = 391,        /* partition_members  */
  YYSYMBOL_partition_member = 392,         /* partition_member  */
  YYSYMBOL_minmaxpins = 393,               /* minmaxpins  */
  YYSYMBOL_min_or_max_list = 394,          /* min_or_max_list  */
  YYSYMBOL_min_or_max_member = 395,        /* min_or_max_member  */
  YYSYMBOL_pin_list = 396,                 /* pin_list  */
  YYSYMBOL_risefallminmax1_list = 397,     /* risefallminmax1_list  */
  YYSYMBOL_risefallminmax1 = 398,          /* risefallminmax1  */
  YYSYMBOL_risefallminmax2_list = 399,     /* risefallminmax2_list  */
  YYSYMBOL_risefallminmax2 = 400,          /* risefallminmax2  */
  YYSYMBOL_partitions_end = 401,           /* partitions_end  */
  YYSYMBOL_comp_names = 402,               /* comp_names  */
  YYSYMBOL_comp_name = 403,                /* comp_name  */
  YYSYMBOL_subnet_opt_syn = 404,           /* subnet_opt_syn  */
  YYSYMBOL_subnet_options = 405,           /* subnet_options  */
  YYSYMBOL_subnet_option = 406,            /* subnet_option  */
  YYSYMBOL_pin_props_section = 407,        /* pin_props_section  */
  YYSYMBOL_begin_pin_props = 408,          /* begin_pin_props  */
  YYSYMBOL_opt_semi = 409,                 /* opt_semi  */
  YYSYMBOL_end_pin_props = 410,            /* end_pin_props  */
  YYSYMBOL_pin_prop_list = 411,            /* pin_prop_list  */
  YYSYMBOL_pin_prop_terminal = 412,        /* pin_prop_terminal  */
  YYSYMBOL_pin_prop_options = 413,         /* pin_prop_options  */
  YYSYMBOL_pin_prop = 414,                 /* pin_prop  */
  YYSYMBOL_pin_prop_name_value_list = 415, /* pin_prop_name_value_list  */
  YYSYMBOL_pin_prop_name_value = 416       /* pin_prop_name_value  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   855

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  167
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  250
/* YYNRULES -- Number of rules.  */
#define YYNRULES  514
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  986

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   414


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     163,   164,   165,   162,   166,   161,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   160,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    83,    83,    84,    88,    89,    93,    94,    98,    99,
     100,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   144,   148,   152,   156,   160,
     164,   168,   172,   173,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   189,   190,   191,   192,   193,   197,   198,
     202,   206,   210,   214,   218,   222,   226,   227,   228,   229,
     230,   231,   232,   233,   237,   238,   239,   240,   244,   248,
     252,   256,   257,   261,   265,   269,   273,   277,   278,   282,
     286,   290,   291,   295,   296,   297,   298,   299,   300,   304,
     308,   313,   314,   318,   322,   323,   327,   331,   336,   340,
     341,   345,   346,   350,   354,   358,   362,   366,   370,   374,
     375,   379,   383,   387,   388,   392,   393,   394,   398,   399,
     400,   401,   405,   409,   413,   417,   418,   422,   426,   427,
     431,   432,   436,   440,   441,   445,   449,   453,   457,   458,
     462,   466,   470,   471,   472,   476,   477,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   493,   497,   501,   505,
     506,   510,   514,   515,   519,   520,   524,   528,   529,   533,
     537,   541,   545,   546,   550,   554,   555,   556,   557,   561,
     565,   569,   573,   577,   578,   582,   586,   590,   591,   595,
     596,   600,   601,   605,   606,   607,   611,   612,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   635,   636,   640,   644,   648,   652,
     653,   657,   658,   662,   663,   667,   668,   669,   673,   674,
     675,   679,   680,   684,   688,   692,   696,   697,   701,   702,
     706,   707,   708,   709,   710,   711,   712,   713,   717,   718,
     719,   723,   724,   728,   729,   733,   737,   741,   742,   746,
     750,   754,   755,   759,   763,   764,   765,   769,   770,   771,
     775,   776,   780,   781,   782,   783,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   801,   805,   809,
     813,   814,   818,   819,   823,   827,   831,   835,   839,   840,
     844,   848,   852,   853,   857,   861,   862,   866,   867,   868,
     869,   873,   874,   878,   879,   883,   887,   888,   892,   893,
     894,   898,   902,   906,   910,   914,   918,   919,   923,   924,
     928,   932,   933,   934,   935,   939,   940,   944,   948,   949,
     953,   954,   958,   959,   960,   961,   965,   969,   973,   977,
     981,   982,   986,   990,   994,   995,   999,  1000,  1004,  1005,
    1006,  1007,  1008,  1009,  1013,  1014,  1015,  1019,  1020,  1024,
    1028,  1029,  1030,  1034,  1035,  1039,  1043,  1044,  1045,  1049,
    1053,  1057,  1061,  1062,  1066,  1070,  1074,  1075,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1090,  1091,  1095,  1099,
    1103,  1107,  1108,  1112,  1116,  1117,  1121,  1122,  1123,  1124,
    1128,  1129,  1133,  1134,  1138,  1139,  1143,  1144,  1148,  1152,
    1156,  1157,  1161,  1162,  1163,  1164,  1168,  1169,  1173,  1177,
    1181,  1185,  1186,  1190,  1194,  1198,  1199,  1203,  1204,  1205,
    1209,  1210,  1211,  1215,  1216,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1230,  1234,  1235,  1239,  1240,  1244,  1245,  1249,
    1250,  1254,  1255,  1256,  1257,  1261,  1262,  1266,  1267,  1268,
    1269,  1273,  1277,  1278,  1282,  1286,  1287,  1291,  1292,  1296,
    1297,  1301,  1305,  1309,  1310,  1314,  1318,  1319,  1323,  1327,
    1328,  1332,  1336,  1337,  1341
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_Number", "T_Ident",
  "T_String", "T_History", "T_ALIGN", "T_ARRAY", "T_ASSERTIONS",
  "T_BEGINEXT", "T_BOTTOMLEFT", "T_BUSBITCHARS", "T_BY", "T_CANNOTOCCUPY",
  "T_CANPLACE", "T_CAPACITANCE", "T_COMMONSCANPINS", "T_COMPONENT",
  "T_COMPONENTPIN", "T_COMPS", "T_COMP_GEN", "T_CONSTRAINTS", "T_COVER",
  "T_DEFAULTCAP", "T_DESIGN", "T_DIE_AREA", "T_DIFF", "T_DIRECTION",
  "T_DISTANCE", "T_DIVIDERCHAR", "T_DO", "T_DRIVECELL", "T_E",
  "T_EEQMASTER", "T_END", "T_EQUAL", "T_ESTCAP", "T_FALL", "T_FALLMAX",
  "T_FALLMIN", "T_FE", "T_FIXED", "T_FLOATING", "T_FLOORPLAN", "T_FN",
  "T_FOREIGN", "T_FPC", "T_FROMCLOCKPIN", "T_FROMCOMPPIN", "T_FROMIOPIN",
  "T_FROMPIN", "T_FS", "T_FW", "T_GCELLGRID", "T_GROUP", "T_GROUPS",
  "T_HISTORY", "T_HOLDFALL", "T_HOLDRISE", "T_HORIZONTAL", "T_INTEGER",
  "T_IOTIMINGS", "T_LAYER", "T_MACRO", "T_MAX", "T_MAXDIST",
  "T_MAXHALFPERIMETER", "T_MAXX", "T_MAXY", "T_MICRONS", "T_MIN",
  "T_MINPINS", "T_MUSTJOIN", "T_N", "T_NAMEMAPSTRING",
  "T_NAMESCASESENSITIVE", "T_NET", "T_NETS", "T_NEW", "T_NONDEFAULTRULE",
  "T_NOSHIELD", "T_ORDERED", "T_ORIGINAL", "T_PARALLEL", "T_PARTITIONS",
  "T_PATH", "T_PATTERN", "T_PATTERNNAME", "T_PIN", "T_PINPROPERTIES",
  "T_PINS", "T_PLACED", "T_PROPERTY", "T_PROPERTYDEFINITIONS", "T_RANGE",
  "T_REAL", "T_RECT", "T_REENTRANTPATHS", "T_REGION", "T_REGIONS",
  "T_RISE", "T_RISEMAX", "T_RISEMIN", "T_ROUTED", "T_ROW", "T_ROWS", "T_S",
  "T_SCANCHAINS", "T_SETUPFALL", "T_SETUPRISE", "T_SHAPE", "T_SHIELD",
  "T_SHIELDNET", "T_SITE", "T_SLEWRATE", "T_SNET", "T_SNETS", "T_SOFT",
  "T_SOURCE", "T_SPACING", "T_SPECIAL", "T_START", "T_STEP", "T_STOP",
  "T_STYLE", "T_SUBNET", "T_SUM", "T_SYNTHESIZED", "T_TAPER",
  "T_TAPERRULE", "T_TECH", "T_THRUPIN", "T_TIMINGDISABLES", "T_TOCLOCKPIN",
  "T_TOCOMPPIN", "T_TOIOPIN", "T_TOPIN", "T_TOPRIGHT", "T_TRACKS",
  "T_TURNOFF", "T_UNITS", "T_UNPLACED", "T_USE", "T_VARIABLE", "T_VERSION",
  "T_VERTICAL", "T_VIAS", "T_VOLTAGE", "T_VPIN", "T_W", "T_WEIGHT",
  "T_WIDTH", "T_WIRECAP", "T_WIREDLOGIC", "T_XTALK", "T_INPUT", "T_OUTPUT",
  "T_INOUT", "T_FEEDTHRU", "';'", "'-'", "'+'", "'('", "')'", "'*'", "','",
  "$accept", "def_file", "version_stmt", "case_sens_stmt", "rules", "rule",
  "design_section", "design_name", "end_design", "tech_name", "array_name",
  "floorplan_name", "history", "prop_def_section", "property_defs",
  "property_def", "property_type_and_val", "opt_num_val", "units",
  "divider_char", "bus_bit_chars", "site", "canplace", "cannotoccupy",
  "orient", "direction", "die_area", "pin_cap_rule", "start_def_cap",
  "pin_caps", "pin_cap", "end_def_cap", "pin_rule", "start_pins", "pins",
  "pin", "pin_start", "pin_options", "pin_option", "end_pins", "row_rule",
  "row_options", "row_option", "row_prop_list", "row_prop", "tracks_rule",
  "track_start", "track_layer_statement", "track_layers", "track_layer",
  "gcellgrid", "extension_section", "extension_stmt", "via_section", "via",
  "via_declarations", "via_declaration", "via_start", "layer_stmts",
  "layer_stmt", "pt", "via_end", "regions_section", "regions_start",
  "regions_stmts", "regions_stmt", "rect_list", "region_options",
  "region_option", "region_prop_list", "region_prop", "comps_section",
  "start_comps", "comps_rule", "comp", "comp_start", "comp_net_list",
  "comp_options", "comp_option", "comp_extension_stmt", "comp_eeq",
  "comp_generate", "opt_pattern", "comp_source", "comp_region",
  "comp_pnt_list", "comp_property", "comp_prop_list", "comp_prop",
  "comp_region_start", "comp_foreign", "opt_paren", "comp_type",
  "placement_status", "weight", "end_comps", "nets_section", "start_nets",
  "net_rules", "one_net", "net_start", "net_connections", "net_connection",
  "net_conn_start", "net_conn_opt", "net_options", "net_option",
  "net_prop_list", "net_prop", "vpin_stmt", "vpin_begin", "vpin_layer_opt",
  "property_val", "vpin_options", "vpin_status", "net_type", "paths",
  "new_path", "path", "path_start", "path_item_list", "path_item",
  "path_pt", "opt_taper", "opt_shape", "opt_width", "end_nets",
  "snets_section", "snet_rules", "snet_rule", "snet_start",
  "snet_connections", "snet_connection", "snet_conn_start",
  "snet_conn_opt", "snet_options", "snet_option", "snet_other_option",
  "snet_width", "snet_voltage", "snet_spacing", "opt_snet_range",
  "opt_range", "start_snets", "end_snets", "groups_section",
  "groups_start", "group_rules", "group_rule", "start_group",
  "group_members", "group_member", "group_options", "group_option",
  "group_region", "group_prop_list", "group_prop", "group_soft_options",
  "group_soft_option", "groups_end", "assertions_section",
  "constraint_section", "assertions_start", "constraints_start",
  "constraint_rules", "constraint_rule", "operand_rule", "operand",
  "operand_list", "wiredlogic_rule", "opt_plus", "delay_specs",
  "delay_spec", "constraints_end", "assertions_end", "scanchains_section",
  "scanchain_start", "scanchain_rules", "scan_rule", "start_scan",
  "scan_members", "opt_pin", "scan_member", "opt_common_pins",
  "floating_inst_list", "one_floating_inst", "floating_pins",
  "ordered_inst_list", "one_ordered_inst", "ordered_pins", "scanchain_end",
  "iotiming_section", "iotiming_start", "iotiming_rules", "iotiming_rule",
  "start_iotiming", "iotiming_members", "iotiming_member", "risefall",
  "iotiming_end", "floorplan_contraints_section", "fp_start", "fp_stmts",
  "fp_stmt", "h_or_v", "constraint_type", "constrain_what_list",
  "constrain_what", "row_or_comp_list", "row_or_comp",
  "timingdisables_section", "timingdisables_start", "timingdisables_rules",
  "timingdisables_rule", "td_macro_option", "timingdisables_end",
  "partitions_section", "partitions_start", "partition_rules",
  "partition_rule", "start_partition", "turnoff", "turnoff_setup",
  "turnoff_hold", "partition_members", "partition_member", "minmaxpins",
  "min_or_max_list", "min_or_max_member", "pin_list",
  "risefallminmax1_list", "risefallminmax1", "risefallminmax2_list",
  "risefallminmax2", "partitions_end", "comp_names", "comp_name",
  "subnet_opt_syn", "subnet_options", "subnet_option", "pin_props_section",
  "begin_pin_props", "opt_semi", "end_pin_props", "pin_prop_list",
  "pin_prop_terminal", "pin_prop_options", "pin_prop",
  "pin_prop_name_value_list", "pin_prop_name_value", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-785)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-9)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -87,    83,    64,    62,   -67,  -785,    93,   193,  -785,   -54,
    -785,   351,  -785,   112,   122,  -785,   115,   137,   142,   153,
     165,   178,   146,    75,   215,   206,   241,   238,   244,   248,
     256,   253,   262,   270,   278,   279,  -785,   285,   288,   296,
     304,   297,   305,   309,   326,   284,   333,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,   338,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
     188,   208,   209,   376,   377,   224,   227,  -785,   228,     4,
      75,   236,  -785,   249,   267,   397,   272,   274,   275,   277,
     283,   286,   287,   239,   289,   402,   290,   398,   292,   293,
     295,  -785,   346,   298,    56,    -4,   407,    -3,     0,    14,
      28,    34,    35,    48,    50,    55,    61,    65,    68,    72,
      74,  -785,  -785,  -785,   436,   437,  -785,  -785,  -785,     5,
       7,   301,  -785,  -785,  -785,   417,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,   453,   458,   459,   370,   462,   463,
     465,   466,   467,   468,  -785,  -785,   472,  -785,   473,  -785,
    -785,  -785,   474,  -785,   454,   476,  -785,  -785,   389,   477,
    -785,  -785,  -785,   480,   339,   481,  -785,  -785,  -785,   388,
     485,  -785,   471,   489,  -785,  -785,  -785,   416,   491,  -785,
    -785,  -785,   379,   493,  -785,  -785,  -785,   443,   496,  -785,
    -785,  -785,   494,   -12,  -785,  -785,  -785,  -785,   482,  -785,
     394,   501,  -785,  -785,  -785,   444,   344,  -785,  -785,  -785,
     461,   505,  -785,   378,   -18,  -785,  -785,   427,   506,  -785,
    -785,  -785,   423,   510,  -785,  -785,   337,   337,   352,   353,
     354,   355,  -785,   512,    57,    57,    57,  -785,    57,    57,
      57,    57,    57,    57,   517,   337,   361,  -785,   371,  -785,
     363,    92,   400,  -785,  -785,    99,  -785,    75,  -785,   522,
      13,  -785,  -785,   -29,  -785,  -785,   364,  -785,  -785,   524,
    -785,   366,   526,   527,   369,   529,  -785,  -785,  -785,  -785,
     143,  -785,   530,   -13,  -785,   -24,  -785,   531,   532,   380,
     533,  -785,   399,   169,  -785,   534,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,   511,   513,  -785,  -785,  -785,  -785,
     418,   538,   450,   542,   450,   387,   390,   391,   392,   393,
     395,   396,   401,   403,   337,   518,  -785,   545,   483,  -785,
     204,  -785,  -785,    75,   551,  -785,   214,  -785,  -785,    75,
      75,  -785,  -785,  -785,   175,   404,    41,  -785,   189,    12,
    -785,   196,  -785,  -785,   212,    40,  -785,   553,    40,   406,
     223,  -785,   280,  -785,  -785,   554,   555,   559,   560,  -785,
      43,  -785,  -785,  -785,  -785,   268,   561,   -28,  -785,   562,
       1,  -785,  -785,    29,  -785,  -785,  -785,   566,   567,   569,
    -785,   570,   571,  -785,   571,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,   544,   574,   419,   577,  -785,  -785,
     235,  -785,   578,  -785,  -785,  -785,   579,   337,   515,   580,
     582,  -785,    75,   237,  -785,    20,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,    22,  -785,  -785,    75,  -785,    41,
     583,   584,   428,  -785,   117,  -785,  -785,  -785,   528,   585,
     588,   589,   432,  -785,   202,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,    30,  -785,  -785,  -785,   -33,   591,   246,  -785,
     535,  -785,    33,  -785,   433,  -785,  -785,   593,   594,   435,
    -785,  -785,  -785,   597,   598,  -785,  -785,   -60,  -785,   600,
     601,   602,  -785,   469,   603,   604,   451,   452,  -785,  -785,
     132,   606,   609,   610,   611,   612,   613,   263,   605,   607,
     464,   616,  -785,  -785,  -785,   618,   617,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,    75,  -785,  -785,   619,   475,  -785,
      75,  -785,  -785,   536,  -785,   621,   622,   627,  -785,  -785,
     628,   630,  -785,    75,    75,   337,   428,  -785,  -785,    32,
    -785,   470,  -785,   633,  -785,   634,   635,   636,   637,  -785,
    -785,   638,   639,   640,   641,   642,   643,   645,   646,   635,
     647,    75,  -785,  -785,  -785,    38,  -785,   486,   649,   650,
     651,  -785,   652,   653,   654,   655,   656,   658,   659,   660,
     635,  -785,    23,  -785,  -785,    40,   661,  -785,   663,   664,
     665,   666,   667,   668,  -785,   669,   670,   671,   671,  -785,
    -785,  -785,   673,   674,  -785,  -785,  -785,   264,   675,   500,
    -785,  -785,  -785,  -785,  -785,  -785,   676,   677,  -785,   678,
     679,  -785,  -785,   592,  -785,   681,   683,  -785,  -785,   680,
     684,    75,  -785,  -785,   619,  -785,    75,  -785,   685,  -785,
      21,   686,  -785,  -785,  -785,    75,  -785,   499,  -785,  -785,
    -785,  -785,  -785,   543,  -785,   688,  -785,  -785,   690,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,   543,  -785,    75,
    -785,  -785,  -785,  -785,  -785,   690,   635,  -785,   689,  -785,
    -785,  -785,  -785,   692,   543,   693,  -785,    75,  -785,   250,
    -785,  -785,   539,  -785,  -785,  -785,  -785,   694,   490,  -785,
     508,  -785,  -785,  -785,  -785,   697,   698,  -785,    17,  -785,
     699,   700,    44,    49,   240,    44,    49,   240,  -785,   565,
     573,   702,   586,  -785,  -785,  -785,   703,  -785,  -785,   705,
    -785,   706,   425,  -785,  -785,  -785,   635,  -785,  -785,   516,
     425,  -785,   548,    45,   543,   620,  -785,   425,  -785,  -785,
     709,   710,   711,  -785,  -785,   552,   713,  -785,   714,  -785,
    -785,  -785,  -785,  -785,   546,  -785,  -785,   716,   717,   718,
     719,    49,  -785,   720,   721,   722,   723,  -785,  -785,    49,
     724,   726,   727,   608,   729,   425,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,   623,   147,  -785,   731,  -785,   211,  -785,
    -785,  -785,  -785,    75,   730,  -785,  -785,  -785,  -785,  -785,
     564,   732,   733,   575,   575,  -785,  -785,   -15,   736,   737,
     738,   739,  -785,  -785,  -785,  -785,  -785,  -785,   425,  -785,
     741,   742,   743,   744,  -785,   745,  -785,   746,   590,   747,
     748,   635,  -785,   337,   751,   752,   595,   596,    37,  -785,
     754,   755,  -785,  -785,  -785,  -785,  -785,  -785,  -785,   614,
     615,   758,   624,  -785,  -785,     8,  -785,   540,  -785,   543,
    -785,  -785,   759,   599,   625,   760,   761,   763,   764,   765,
    -785,  -785,  -785,  -785,     9,    11,    25,   644,   626,   629,
     766,   767,   631,   632,  -785,  -785,  -785,   271,    15,    16,
      18,    19,  -785,  -785,  -785,  -785,  -785,  -785,   769,   772,
    -785,  -785,  -785,   662,  -785,   648,  -785,   657,  -785,   672,
    -785,   682,  -785,   687,   691,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,   773,   425,  -785,  -785
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     0,     0,     6,     0,     1,     0,     0,     5,     0,
      10,     2,     7,     0,     0,   125,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    11,    27,
       3,    28,    41,    42,    29,    44,    30,    31,    32,    33,
      34,    35,    36,    37,    91,    38,    97,    43,    39,     0,
      40,    13,    12,   129,    22,   145,    14,   158,    15,   203,
      16,   277,    17,   318,    20,    19,   346,   346,    18,   370,
      21,   402,    23,   421,    24,   440,    25,   451,    26,   506,
       0,     0,     0,     0,     0,     0,     0,    90,     0,     0,
       0,     0,    46,     0,     0,     0,     0,     0,     0,     0,
       0,   503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   344,    72,     0,     0,   157,   345,    45,     0,
       0,     0,    71,    49,   420,     0,   317,    50,   401,   202,
     450,   504,   502,    96,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,   144,     0,   369,     0,   314,
      47,   439,     0,   128,     0,     0,    92,    89,     0,     0,
      98,   101,    95,     0,     0,     0,   130,   133,   127,     0,
       0,   146,     0,     0,   159,   162,   156,     0,     0,   204,
     207,   201,     0,     0,   278,   281,   276,     0,     0,   319,
     322,   316,     0,     0,   347,   348,   349,   342,     0,   343,
       0,     0,   371,   374,   368,     0,     0,   403,   406,   400,
       0,     0,   422,     0,     0,   441,   438,     0,     0,   452,
     463,   449,     0,     0,   501,   507,     0,     0,     0,     0,
       0,     0,    88,     0,     0,     0,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    94,     0,   109,
       0,     0,     0,   142,   132,     0,   143,     0,   200,     0,
     165,   275,   206,   216,   315,   280,   290,   341,   321,   325,
     367,     0,     0,     0,     0,     0,   360,   366,   399,   373,
       0,   418,     0,     0,   419,     0,   448,     0,     0,     0,
       0,   491,   455,     0,   505,     0,    77,    81,    80,    82,
      83,    76,    78,    79,     0,     0,   138,   140,   139,   141,
       0,    65,   312,     0,   312,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    70,     0,     0,    99,
       0,   102,   104,     0,     0,   131,     0,   137,   134,     0,
     150,   161,   164,   163,     0,     0,     0,   208,     0,     0,
     282,     0,   324,   323,     0,     0,   351,     0,     0,   358,
       0,   372,     0,   383,   375,     0,     0,     0,     0,   404,
       0,   415,   407,   424,   425,     0,     0,     0,   445,     0,
     457,   454,   453,     0,   471,   464,   509,     0,     0,     0,
      66,     0,    68,    67,    68,    59,    62,    54,    58,    55,
      61,    57,    60,    56,     0,     0,     0,     0,   126,   196,
       0,   195,     0,   197,   103,   198,     0,     0,   119,     0,
       0,   148,     0,     0,   160,     0,   176,   166,   175,   173,
     167,   168,   172,   174,     0,   171,   169,     0,   170,     0,
       0,     0,   213,   205,     0,   233,   217,   228,   239,     0,
       0,     0,   287,   279,     0,   306,   291,   295,   292,   293,
     294,   320,     0,   330,   326,   355,     0,     0,     0,   359,
       0,   350,     0,   361,   384,   387,   393,     0,     0,     0,
     412,   414,   413,     0,     0,   417,   416,     0,   426,     0,
       0,     0,   430,     0,     0,     0,     0,     0,   459,   458,
     460,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,    63,    64,     0,     0,    93,   100,    84,
      85,    86,    87,   105,     0,   106,   108,   121,     0,   136,
       0,   149,   147,     0,   151,     0,     0,     0,   187,   190,
       0,     0,   183,     0,   182,     0,   213,   211,   212,     0,
     214,     0,   249,     0,   248,     0,     0,     0,     0,   234,
     250,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   284,   285,   286,     0,   288,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   333,     0,   336,   354,     0,     0,   353,     0,     0,
       0,     0,     0,     0,   382,   379,   380,   376,   376,   405,
     410,   411,     0,     0,   429,   427,   428,     0,     0,     0,
     447,   444,   443,   462,   461,   456,     0,     0,   479,     0,
       0,   479,   508,     0,   510,     0,     0,   124,   313,     0,
       0,     0,   123,   120,   121,   117,     0,   153,   179,   177,
       0,   186,   181,   199,   184,     0,   194,     0,   215,   209,
     224,   227,   255,   230,   251,   273,   220,   221,   232,   229,
     219,   226,   492,   225,   238,   222,   223,   218,   240,     0,
     289,   283,   302,   299,   300,   305,     0,   298,     0,   304,
     303,   308,   301,     0,   296,   328,   332,     0,   329,   327,
     356,   352,     0,   365,   364,   363,   362,     0,   390,   388,
     396,   394,   377,   378,   381,     0,     0,   423,     0,   431,
       0,     0,     0,     0,   467,     0,     0,   470,   512,     0,
       0,     0,     0,   107,   122,   135,   152,   180,   178,     0,
     192,     0,     0,   188,   185,   210,     0,   252,   274,   271,
       0,   235,   497,   243,   297,   310,   307,     0,   334,   331,
       0,     0,     0,   337,   357,     0,     0,   389,     0,   395,
     409,   408,   434,   434,     0,   446,   473,     0,     0,     0,
       0,   466,   485,     0,     0,     0,     0,   480,   473,   469,
     511,     0,     0,     0,     0,     0,   154,   193,   191,   241,
     242,   189,   253,     0,   268,   236,     0,   493,   231,   247,
     246,   245,   237,     0,     0,   309,   335,   340,   338,   339,
     385,     0,     0,   432,   433,   442,   465,     0,     0,     0,
       0,     0,   486,   484,   482,   483,   481,   468,     0,   513,
       0,     0,     0,     0,   155,     0,   269,     0,     0,     0,
       0,     0,   498,     0,     0,     0,     0,     0,     0,   435,
       0,     0,   477,   474,   490,   488,   489,   487,   514,     0,
       0,     0,     0,   272,   270,     0,   256,   495,   500,   499,
     244,   311,     0,   391,   397,     0,     0,     0,     0,   472,
      75,    74,   111,    73,     0,     0,   254,     0,     0,     0,
       0,     0,     0,     0,   476,   475,   478,     0,     0,     0,
       0,     0,   258,   257,   259,   496,   494,   386,     0,     0,
     437,   436,   110,     0,   112,     0,   260,     0,   262,     0,
     261,     0,   263,     0,     0,   114,   264,   266,   265,   267,
     392,   398,   113,     0,   115,   116
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,   139,   314,  -785,  -785,
    -785,  -785,  -785,  -785,  -265,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,    84,  -785,
    -785,  -785,  -286,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -110,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,   405,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,   299,   194,  -785,  -785,   158,  -785,  -785,
    -785,  -785,  -784,  -785,  -785,  -491,  -605,  -785,    -5,  -785,
    -785,  -785,  -154,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,   429,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,   704,  -785,  -785,  -232,   408,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,   138,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -670,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,   -26,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,   -43,  -785,  -785,  -785,
     121,  -785,    31,  -769,  -785,  -785,  -785,  -785,  -785,  -785,
    -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785,  -785
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,     7,    11,    47,    48,    49,    50,    51,
      52,    53,    54,    55,   123,   184,   355,   553,    56,    57,
      58,    59,    60,    61,   344,   563,    62,    63,    64,   134,
     196,   197,    65,    66,   135,   200,   201,   291,   371,   202,
      67,   947,   964,   982,   984,    68,    69,   568,   683,   684,
      70,    71,   590,    72,    73,   137,   206,   207,   295,   378,
     110,   208,    74,    75,   138,   211,   380,   463,   574,   776,
     836,    76,    77,   139,   214,   215,   300,   384,   467,   468,
     469,   470,   778,   471,   472,   584,   473,   691,   783,   474,
     475,   781,   476,   373,   478,   216,    78,    79,   140,   219,
     220,   303,   387,   482,   591,   388,   486,   708,   791,   487,
     488,   611,   841,   852,   853,   609,   703,   787,   704,   705,
     936,   953,   916,   888,   844,   789,   221,    80,   141,   224,
     225,   306,   390,   492,   617,   391,   496,   497,   498,   499,
     500,   855,   432,    81,   226,    82,    83,   142,   229,   230,
     309,   393,   394,   504,   738,   735,   798,   739,   803,   231,
      84,    85,    86,    87,   143,   234,   235,   505,   506,   236,
     510,   400,   513,   239,   237,    88,    89,   145,   242,   243,
     320,   753,   404,   644,   645,   749,   807,   646,   751,   809,
     244,    90,    91,   146,   247,   248,   323,   412,   527,   249,
      92,    93,   147,   252,   415,   532,   657,   759,   863,   899,
      94,    95,   148,   255,   536,   256,    96,    97,   149,   259,
     260,   421,   540,   665,   333,   425,   866,   867,   903,   929,
     764,   827,   821,   822,   261,   792,   847,   938,   848,   892,
      98,    99,   172,   264,   150,   265,   547,   674,   830,   879
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     161,   316,   345,   630,   717,   372,   845,   159,   268,   377,
     270,   934,   948,   856,   950,   311,   489,   382,   965,   967,
     365,   969,   971,   534,   779,   734,   582,   736,   812,   952,
     448,   198,   204,   327,   403,   209,   413,   411,   406,   448,
     448,   575,   448,   449,   385,   480,   328,   424,   448,   212,
     900,   884,   872,   448,   576,   652,   901,   925,     1,   523,
     872,   351,   451,   217,     5,   312,   577,   311,   849,   222,
     227,   407,   639,   640,   313,   524,   902,   541,   542,   543,
     329,   525,   525,   232,   653,   238,     4,   850,   817,   818,
     240,   194,   816,     8,   908,   828,   245,     9,   466,   444,
     250,   490,   485,   253,   535,   495,    12,   257,   503,   262,
     538,   539,   453,   578,   330,   314,   100,   312,   352,   579,
     102,   794,   414,   631,   408,   101,   313,   448,   195,   632,
     481,   634,   353,   635,   386,   641,   642,   851,     6,   580,
     592,   103,   315,   926,   526,   526,   104,   409,   633,   410,
     108,   819,   820,   354,   593,   813,   105,   199,   205,   594,
     698,   210,   455,   544,   545,   546,   720,   314,   106,   160,
     269,   581,   271,   935,   949,   213,   951,   491,   383,   966,
     968,   107,   970,   972,   109,   109,   109,   379,   915,   218,
     663,   664,   566,    -8,    10,   223,   228,   595,   596,   985,
     597,    -8,    -8,    -8,   598,    -8,   616,    -8,    -8,   233,
     599,   233,   448,    -8,   448,    -8,   241,    -8,    -8,    -8,
     111,   600,   246,    -8,   448,   592,   251,   449,    -8,   254,
     601,   112,   450,   258,   592,   263,   602,    -8,   109,   618,
      -8,   114,   603,   604,   594,   113,   451,    -8,   115,    -8,
      -8,   116,   369,   594,   370,    -8,   118,   174,   175,   375,
     605,   376,   117,   457,   176,   119,   606,   452,   607,   461,
     462,    -8,   608,   120,   177,   528,   886,   887,    -8,   823,
     824,   121,   122,    -8,    -8,   619,   919,    -8,   124,   620,
     448,   890,   125,    -8,   178,   621,   453,   514,    -8,   126,
     128,    -8,   459,   401,   529,   402,   600,    -8,   127,   129,
      -8,   460,   130,   132,   622,   600,   179,   800,   801,   802,
     696,   623,   624,   515,    -8,   454,    -8,   625,   180,   422,
     131,   423,    -8,   530,    -8,   464,   133,   465,   181,   531,
      -8,   136,   825,   826,   182,   626,   455,   456,   151,   483,
     627,   484,   571,   628,   629,   183,   493,   891,   494,    13,
      14,    15,   516,    16,   583,    17,    18,   585,   152,   153,
     336,    19,   501,    20,   502,    21,    22,    23,   337,   154,
     155,    24,   338,   511,   156,   512,    25,   157,   158,   339,
     340,   559,   560,   561,   562,    26,   162,   572,    27,   573,
     165,   188,   517,   740,   518,    28,   186,    29,    30,   163,
     637,   341,   635,    31,   356,   357,   192,   358,   359,   360,
     361,   362,   363,   672,   757,   673,   758,   164,   839,    32,
     840,   962,   166,   963,   167,   168,    33,   169,   203,   266,
     267,    34,    35,   170,   342,    36,   171,   173,   273,   185,
     187,    37,   189,   190,   681,   191,    38,   274,   193,    39,
     686,   272,   275,   276,   277,    40,   278,   279,    41,   280,
     281,   282,   283,   694,   695,   284,   285,   286,   287,   288,
     289,   290,    42,   292,    43,   294,   293,   343,   296,   297,
      44,   298,    45,   299,   301,   302,   304,   305,    46,   307,
     308,   719,   318,   310,   317,   319,   321,   322,   324,   325,
     332,   326,   331,   334,   335,   350,   346,   347,   348,   349,
     364,   366,   737,   374,   367,   368,   381,   389,   392,   395,
     396,   397,   398,   399,   405,   416,   417,   419,   426,   420,
     418,   429,   427,   430,   428,   431,   433,   435,   446,   445,
     436,   437,   438,   439,   458,   440,   441,   507,   519,   520,
     447,   442,   521,   443,   522,   533,   537,   479,   509,   548,
     549,   773,   550,   551,   552,   555,   775,   556,   567,   557,
     780,   558,   564,   565,   569,   784,   570,   587,   588,   612,
     589,   610,   613,   614,   615,   636,   643,   647,   648,   649,
     650,   638,   651,   654,   655,   656,   658,   659,   660,   793,
     666,   661,   662,   667,   668,   669,   670,   671,   675,   678,
     676,   679,   786,   682,   677,   688,   689,   799,   920,   687,
     680,   690,   692,   693,   699,   685,   700,   761,   701,   702,
     706,   707,   709,   710,   711,   712,   713,   714,   715,   716,
     721,   718,   722,   806,   723,   724,   726,   727,   728,   729,
     730,   731,   732,   785,   733,   741,   742,   743,   744,   745,
     746,   808,   747,   748,   750,   752,   755,   756,   843,   760,
     762,   763,   765,   766,   769,   768,   770,   772,   831,   777,
     782,   788,   795,   771,   790,   796,   832,   797,   805,   804,
     810,   811,   937,   814,   815,   833,   865,   835,   837,   834,
     838,   846,   857,   858,   859,   854,   860,   861,   862,   868,
     869,   870,   871,   873,   874,   875,   876,   895,   878,   880,
     881,   882,   883,   894,   885,   889,   896,   897,   898,   904,
     905,   906,   907,   893,   909,   910,   911,   912,   554,   913,
     914,   917,   918,   915,   921,   975,   922,   927,   928,   923,
     924,   932,   940,   939,   942,   943,   944,   945,   774,   946,
     958,   959,   955,   973,   930,   931,   974,   983,   586,   725,
     697,   842,   954,   434,   933,   877,   754,   864,   941,   477,
     956,   144,   767,   957,     0,   960,   961,   829,     0,     0,
       0,     0,     0,     0,     0,     0,   508,     0,     0,     0,
       0,     0,   976,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   978,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   979,     0,     0,     0,
       0,   980,     0,     0,     0,   981
};

static const yytype_int16 yycheck[] =
{
     110,   233,   267,   494,   609,   291,   790,     3,     3,   295,
       3,     3,     3,   797,     3,    27,     4,     4,     3,     3,
     285,     3,     3,    51,     3,   630,     4,     4,    11,     4,
      10,    35,    35,    51,   320,    35,    60,   323,    51,    10,
      10,    21,    10,    23,    73,     4,    64,   333,    10,    35,
      65,   835,   821,    10,    34,   115,    71,    20,   145,    16,
     829,     4,    42,    35,     0,    77,    46,    27,    23,    35,
      35,    84,    39,    40,    86,    32,    91,    48,    49,    50,
      98,    38,    38,    35,   144,    35,     3,    42,    39,    40,
      35,    35,   762,   160,   878,   765,    35,     4,   384,   364,
      35,    89,   388,    35,   132,   391,   160,    35,   394,    35,
     109,   110,    92,    93,   132,   127,     4,    77,    61,    99,
       5,   726,   146,    93,   137,     3,    86,    10,    72,    99,
      89,   164,    75,   166,   163,   102,   103,    92,    76,   119,
      23,     4,   154,   106,   101,   101,     4,   160,   118,   162,
       4,   102,   103,    96,    37,   138,     3,   161,   161,    42,
     128,   161,   142,   134,   135,   136,   128,   127,     3,   165,
     165,   151,   165,   165,   165,   161,   165,   165,   165,   164,
     164,     3,   164,   164,   163,   163,   163,   297,   163,   161,
      58,    59,   457,     0,     1,   161,   161,    80,    81,   983,
      83,     8,     9,    10,    87,    12,   492,    14,    15,   161,
      93,   161,    10,    20,    10,    22,   161,    24,    25,    26,
       5,   104,   161,    30,    10,    23,   161,    23,    35,   161,
     113,    25,    28,   161,    23,   161,   119,    44,   163,    37,
      47,     3,   125,   126,    42,     4,    42,    54,     4,    56,
      57,     3,   160,    42,   162,    62,     3,    18,    19,   160,
     143,   162,     6,   373,    25,     3,   149,    63,   151,   379,
     380,    78,   155,     3,    35,     7,   129,   130,    85,    39,
      40,     3,     3,    90,    91,    83,   891,    94,     3,    87,
      10,    80,     4,   100,    55,    93,    92,    17,   105,     3,
       3,   108,    88,   160,    36,   162,   104,   114,     4,     4,
     117,    97,     3,    29,   112,   104,    77,    67,    68,    69,
     585,   119,   120,    43,   131,   121,   133,   125,    89,   160,
       4,   162,   139,    65,   141,   160,     3,   162,    99,    71,
     147,     3,   102,   103,   105,   143,   142,   143,   160,   160,
     148,   162,   462,   151,   152,   116,   160,   848,   162,     8,
       9,    10,    82,    12,   474,    14,    15,   477,   160,   160,
      33,    20,   160,    22,   162,    24,    25,    26,    41,     3,
       3,    30,    45,   160,   160,   162,    35,   160,   160,    52,
      53,   156,   157,   158,   159,    44,   160,   160,    47,   162,
       3,     3,   122,   635,   124,    54,     4,    56,    57,   160,
     164,    74,   166,    62,   275,   276,    70,   278,   279,   280,
     281,   282,   283,   160,   160,   162,   162,   160,     3,    78,
       5,   160,   160,   162,   160,   160,    85,   160,    31,     3,
       3,    90,    91,   160,   107,    94,   160,   160,    31,   160,
     160,   100,   160,   160,   564,   160,   105,     4,   160,   108,
     570,   160,     4,     4,    94,   114,     4,     4,   117,     4,
       4,     4,     4,   583,   584,     3,     3,     3,    24,     3,
      91,     4,   131,     3,   133,     4,   147,   150,   100,     4,
     139,    20,   141,     4,    78,     4,   117,     4,   147,    56,
       4,   611,   108,     9,    22,     4,    62,   163,    47,     4,
       4,   133,    85,    90,     4,     3,   164,   164,   164,   164,
       3,   160,   632,   123,   153,   162,     4,   163,     4,   163,
       4,     4,   163,     4,     4,     4,     4,     4,     4,   140,
     160,   123,    31,     5,    31,    95,     4,   160,     3,    31,
     160,   160,   160,   160,     3,   160,   160,     4,     4,     4,
      77,   160,     3,   160,     4,     4,     4,   163,   162,     3,
       3,   681,     3,     3,     3,    31,   686,     3,    63,   160,
     690,     4,     4,     4,     4,   695,     4,     4,     4,     4,
     162,    63,     4,     4,   162,     4,   163,     4,     4,   164,
       3,    66,     4,     3,     3,     3,   137,     4,     4,   719,
       4,   160,   160,     4,     4,     4,     4,     4,    13,     3,
      13,     3,    79,     4,   160,     4,     4,   737,   893,    93,
      13,     4,     4,     3,   164,   160,     3,   137,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     3,     3,
     164,     4,     3,   163,     4,     4,     4,     4,     4,     4,
       4,     3,     3,   164,     4,     4,     3,     3,     3,     3,
       3,   163,     4,     4,     4,     4,     3,     3,   162,     4,
       4,     4,     4,     4,     3,    93,     3,     3,   123,     4,
       4,     3,     3,    13,     4,     3,   123,     4,     4,   160,
       3,     3,   162,     4,     4,     3,   160,     4,     3,   123,
       4,   163,     3,     3,     3,    95,   164,     4,     4,     3,
       3,     3,     3,     3,     3,     3,     3,   163,     4,     3,
       3,   123,     3,     3,   111,     4,     4,     4,   163,     3,
       3,     3,     3,   853,     3,     3,     3,     3,   434,     4,
       4,     4,     4,   163,     3,    93,     4,     3,     3,   164,
     164,     3,   163,     4,     4,     4,     3,     3,   684,     4,
       4,     4,   128,     4,   160,   160,     4,     4,   479,   621,
     586,   786,   936,   354,   160,   828,   648,   813,   163,   384,
     164,    87,   671,   164,    -1,   164,   164,   766,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      -1,   164,    -1,    -1,    -1,   164
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   145,   168,   169,     3,     0,    76,   170,   160,     4,
       1,   171,   160,     8,     9,    10,    12,    14,    15,    20,
      22,    24,    25,    26,    30,    35,    44,    47,    54,    56,
      57,    62,    78,    85,    90,    91,    94,   100,   105,   108,
     114,   117,   131,   133,   139,   141,   147,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   185,   186,   187,   188,
     189,   190,   193,   194,   195,   199,   200,   207,   212,   213,
     217,   218,   220,   221,   229,   230,   238,   239,   263,   264,
     294,   310,   312,   313,   327,   328,   329,   330,   342,   343,
     358,   359,   367,   368,   377,   378,   383,   384,   407,   408,
       4,     3,     5,     4,     4,     3,     3,     3,     4,   163,
     227,     5,    25,     4,     3,     4,     3,     6,     3,     3,
       3,     3,     3,   181,     3,     4,     3,     4,     3,     4,
       3,     4,    29,     3,   196,   201,     3,   222,   231,   240,
     265,   295,   314,   331,   331,   344,   360,   369,   379,   385,
     411,   160,   160,   160,     3,     3,   160,   160,   160,     3,
     165,   227,   160,   160,   160,     3,   160,   160,   160,   160,
     160,   160,   409,   160,    18,    19,    25,    35,    55,    77,
      89,    99,   105,   116,   182,   160,     4,   160,     3,   160,
     160,   160,    70,   160,    35,    72,   197,   198,    35,   161,
     202,   203,   206,    31,    35,   161,   223,   224,   228,    35,
     161,   232,    35,   161,   241,   242,   262,    35,   161,   266,
     267,   293,    35,   161,   296,   297,   311,    35,   161,   315,
     316,   326,    35,   161,   332,   333,   336,   341,    35,   340,
      35,   161,   345,   346,   357,    35,   161,   361,   362,   366,
      35,   161,   370,    35,   161,   380,   382,    35,   161,   386,
     387,   401,    35,   161,   410,   412,     3,     3,     3,   165,
       3,   165,   160,    31,     4,     4,     4,    94,     4,     4,
       4,     4,     4,     4,     3,     3,     3,    24,     3,    91,
       4,   204,     3,   147,     4,   225,   100,     4,    20,     4,
     243,    78,     4,   268,   117,     4,   298,    56,     4,   317,
       9,    27,    77,    86,   127,   154,   334,    22,   108,     4,
     347,    62,   163,   363,    47,     4,   133,    51,    64,    98,
     132,    85,     4,   391,    90,     4,    33,    41,    45,    52,
      53,    74,   107,   150,   191,   191,   164,   164,   164,   164,
       3,     4,    61,    75,    96,   183,   183,   183,   183,   183,
     183,   183,   183,   183,     3,   191,   160,   153,   162,   160,
     162,   205,   219,   260,   123,   160,   162,   219,   226,   227,
     233,     4,     4,   165,   244,    73,   163,   269,   272,   163,
     299,   302,     4,   318,   319,   163,     4,     4,   163,     4,
     338,   160,   162,   219,   349,     4,    51,    84,   137,   160,
     162,   219,   364,    60,   146,   371,     4,     4,   160,     4,
     140,   388,   160,   162,   219,   392,     4,    31,    31,   123,
       5,    95,   309,     4,   309,   160,   160,   160,   160,   160,
     160,   160,   160,   160,   191,    31,     3,    77,    10,    23,
      28,    42,    63,    92,   121,   142,   143,   227,     3,    88,
      97,   227,   227,   234,   160,   162,   219,   245,   246,   247,
     248,   250,   251,   253,   256,   257,   259,   260,   261,   163,
       4,    89,   270,   160,   162,   219,   273,   276,   277,     4,
      89,   165,   300,   160,   162,   219,   303,   304,   305,   306,
     307,   160,   162,   219,   320,   334,   335,     4,   335,   162,
     337,   160,   162,   339,    17,    43,    82,   122,   124,     4,
       4,     3,     4,    16,    32,    38,   101,   365,     7,    36,
      65,    71,   372,     4,    51,   132,   381,     4,   109,   110,
     389,    48,    49,    50,   134,   135,   136,   413,     3,     3,
       3,     3,     3,   184,   184,    31,     3,   160,     4,   156,
     157,   158,   159,   192,     4,     4,   191,    63,   214,     4,
       4,   227,   160,   162,   235,    21,    34,    46,    93,    99,
     119,   151,     4,   227,   252,   227,   270,     4,     4,   162,
     219,   271,    23,    37,    42,    80,    81,    83,    87,    93,
     104,   113,   119,   125,   126,   143,   149,   151,   155,   282,
      63,   278,     4,     4,     4,   162,   219,   301,    37,    83,
      87,    93,   112,   119,   120,   125,   143,   148,   151,   152,
     282,    93,    99,   118,   164,   166,     4,   164,    66,    39,
      40,   102,   103,   163,   350,   351,   354,     4,     4,   164,
       3,     4,   115,   144,     3,     3,     3,   373,   137,     4,
       4,   160,   160,    58,    59,   390,     4,     4,     4,     4,
       4,     4,   160,   162,   414,    13,    13,   160,     3,     3,
      13,   227,     4,   215,   216,   160,   227,    93,     4,     4,
       4,   254,     4,     3,   227,   227,   191,   271,   128,   164,
       3,     4,     4,   283,   285,   286,     4,     4,   274,     4,
       4,     4,     4,     4,     4,     3,     3,   283,     4,   227,
     128,   164,     3,     4,     4,   274,     4,     4,     4,     4,
       4,     3,     3,     4,   283,   322,     4,   227,   321,   324,
     334,     4,     3,     3,     3,     3,     3,     4,     4,   352,
       4,   355,     4,   348,   348,     3,     3,   160,   162,   374,
       4,   137,     4,     4,   397,     4,     4,   397,    93,     3,
       3,    13,     3,   227,   215,   227,   236,     4,   249,     3,
     227,   258,     4,   255,   227,   164,    79,   284,     3,   292,
       4,   275,   402,   227,   283,     3,     3,     4,   323,   227,
      67,    68,    69,   325,   160,     4,   163,   353,   163,   356,
       3,     3,    11,   138,     4,     4,   365,    39,    40,   102,
     103,   399,   400,    39,    40,   102,   103,   398,   365,   399,
     415,   123,   123,     3,   123,     4,   237,     3,     4,     3,
       5,   279,   285,   162,   291,   279,   163,   403,   405,    23,
      42,    92,   280,   281,    95,   308,   279,     3,     3,     3,
     164,     4,     4,   375,   375,   160,   393,   394,     3,     3,
       3,     3,   400,     3,     3,     3,     3,   393,     4,   416,
       3,     3,   123,     3,   279,   111,   129,   130,   290,     4,
      80,   282,   406,   227,     3,   163,     4,     4,   163,   376,
      65,    71,    91,   395,     3,     3,     3,     3,   279,     3,
       3,     3,     3,     4,     4,   163,   289,     4,     4,   283,
     191,     3,     4,   164,   164,    20,   106,     3,     3,   396,
     160,   160,     3,   160,     3,   165,   287,   162,   404,     4,
     163,   163,     4,     4,     3,     3,     4,   208,     3,   165,
       3,   165,     4,   288,   289,   128,   164,   164,     4,     4,
     164,   164,   160,   162,   209,     3,   164,     3,   164,     3,
     164,     3,   164,     4,     4,    93,   164,   164,   164,   164,
     164,   164,   210,     4,   211,   279
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   167,   168,   168,   169,   169,   170,   170,   171,   171,
     171,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   181,   182,   182,   182,   182,   182,   182,
     182,   182,   182,   183,   183,   183,   183,   183,   184,   184,
     185,   186,   187,   188,   189,   190,   191,   191,   191,   191,
     191,   191,   191,   191,   192,   192,   192,   192,   193,   194,
     195,   196,   196,   197,   198,   199,   200,   201,   201,   202,
     203,   204,   204,   205,   205,   205,   205,   205,   205,   206,
     207,   208,   208,   209,   210,   210,   211,   212,   213,   214,
     214,   215,   215,   216,   217,   218,   219,   220,   221,   222,
     222,   223,   224,   225,   225,   226,   226,   226,   227,   227,
     227,   227,   228,   229,   230,   231,   231,   232,   233,   233,
     234,   234,   235,   236,   236,   237,   238,   239,   240,   240,
     241,   242,   243,   243,   243,   244,   244,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   246,   247,   248,   249,
     249,   250,   251,   251,   252,   252,   253,   254,   254,   255,
     256,   257,   258,   258,   259,   260,   260,   260,   260,   261,
     262,   263,   264,   265,   265,   266,   267,   268,   268,   269,
     269,   270,   270,   271,   271,   271,   272,   272,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   274,   274,   275,   276,   277,   278,
     278,   279,   279,   280,   280,   281,   281,   281,   282,   282,
     282,   283,   283,   284,   285,   286,   287,   287,   288,   288,
     289,   289,   289,   289,   289,   289,   289,   289,   290,   290,
     290,   291,   291,   292,   292,   293,   294,   295,   295,   296,
     297,   298,   298,   299,   300,   300,   300,   301,   301,   301,
     302,   302,   303,   303,   303,   303,   304,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,   305,   306,   307,
     308,   308,   309,   309,   310,   311,   312,   313,   314,   314,
     315,   316,   317,   317,   318,   319,   319,   320,   320,   320,
     320,   321,   321,   322,   322,   323,   324,   324,   325,   325,
     325,   326,   327,   328,   329,   330,   331,   331,   332,   332,
     333,   334,   334,   334,   334,   335,   335,   336,   337,   337,
     338,   338,   339,   339,   339,   339,   340,   341,   342,   343,
     344,   344,   345,   346,   347,   347,   348,   348,   349,   349,
     349,   349,   349,   349,   350,   350,   350,   351,   351,   352,
     353,   353,   353,   354,   354,   355,   356,   356,   356,   357,
     358,   359,   360,   360,   361,   362,   363,   363,   364,   364,
     364,   364,   364,   364,   364,   364,   365,   365,   366,   367,
     368,   369,   369,   370,   371,   371,   372,   372,   372,   372,
     373,   373,   374,   374,   375,   375,   376,   376,   377,   378,
     379,   379,   380,   380,   380,   380,   381,   381,   382,   383,
     384,   385,   385,   386,   387,   388,   388,   389,   389,   389,
     390,   390,   390,   391,   391,   392,   392,   392,   392,   392,
     392,   392,   393,   394,   394,   395,   395,   396,   396,   397,
     397,   398,   398,   398,   398,   399,   399,   400,   400,   400,
     400,   401,   402,   402,   403,   404,   404,   405,   405,   406,
     406,   407,   408,   409,   409,   410,   411,   411,   412,   413,
     413,   414,   415,   415,   416
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     4,     0,     3,     0,     3,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     3,     3,     3,
       3,     4,     0,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     3,     3,     1,     2,     2,     0,     1,
       5,     3,     3,    13,    13,    13,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       2,     0,     2,     5,     2,     3,     3,     0,     2,     3,
       5,     0,     2,     2,     1,     3,     3,     5,     3,     2,
      15,     0,     2,     3,     0,     2,     2,     8,     2,     0,
       2,     0,     2,     1,     8,     1,     2,     3,     3,     0,
       2,     3,     2,     0,     2,     5,     3,     1,     4,     4,
       4,     4,     2,     4,     3,     0,     2,     5,     2,     3,
       0,     2,     3,     0,     2,     2,     3,     3,     0,     2,
       4,     3,     0,     2,     2,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     0,
       1,     3,     2,     2,     2,     3,     3,     0,     2,     2,
       2,     5,     1,     2,     3,     2,     2,     2,     2,     3,
       2,     3,     3,     0,     2,     4,     2,     0,     2,     4,
       5,     2,     2,     0,     1,     2,     0,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       3,     5,     3,     1,     0,     2,     2,     5,     3,     0,
       2,     1,     1,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     6,     1,     0,     2,     1,     1,
       4,     4,     4,     4,     5,     5,     5,     5,     0,     1,
       2,     0,     3,     0,     1,     2,     3,     0,     2,     4,
       2,     0,     2,     4,     2,     2,     2,     0,     1,     2,
       0,     2,     1,     1,     1,     1,     3,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     4,     3,     5,
       0,     3,     0,     3,     3,     2,     3,     3,     0,     2,
       4,     2,     0,     2,     1,     0,     2,     3,     3,     3,
       1,     2,     1,     0,     2,     2,     0,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     0,     2,     1,     1,
       4,     2,     5,     4,     4,     1,     3,     7,     0,     1,
       0,     2,     3,     3,     3,     3,     2,     2,     3,     3,
       0,     2,     3,     2,     0,     2,     0,     1,     4,     3,
       3,     4,     3,     1,     0,     4,     8,     0,     2,     2,
       0,     4,     8,     0,     2,     2,     0,     4,     8,     2,
       3,     3,     0,     2,     3,     5,     0,     2,     5,     5,
       3,     3,     2,     2,     2,     1,     1,     1,     2,     4,
       3,     0,     2,     6,     1,     1,     1,     2,     2,     2,
       0,     2,     3,     3,     0,     2,     4,     4,     3,     3,
       0,     2,     8,     5,     5,     3,     4,     2,     2,     3,
       3,     0,     2,     3,     3,     0,     3,     0,     1,     1,
       0,     1,     1,     0,     2,     6,     5,     4,     6,     5,
       4,     1,     3,     0,     2,     3,     3,     0,     2,     0,
       2,     2,     2,     2,     2,     1,     2,     3,     3,     3,
       3,     2,     0,     2,     5,     0,     2,     0,     2,     2,
       2,     3,     3,     0,     1,     2,     0,     2,     5,     0,
       2,     3,     0,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 45: /* design_name: T_DESIGN T_Ident ';'  */
#line 144 "DEF_grammar_yacc.y"
                                            { def_design_name((yyvsp[-1].s)); }
#line 2639 "DEF_grammar_yacc.c"
    break;

  case 46: /* end_design: T_END T_DESIGN  */
#line 148 "DEF_grammar_yacc.y"
                                            { def_end_design(); }
#line 2645 "DEF_grammar_yacc.c"
    break;

  case 47: /* tech_name: T_TECH T_Ident ';'  */
#line 152 "DEF_grammar_yacc.y"
                                            { def_tech_name((yyvsp[-1].s)); }
#line 2651 "DEF_grammar_yacc.c"
    break;

  case 63: /* property_type_and_val: T_INTEGER opt_range opt_num_val  */
#line 189 "DEF_grammar_yacc.y"
                                                     {}
#line 2657 "DEF_grammar_yacc.c"
    break;

  case 64: /* property_type_and_val: T_REAL opt_range opt_num_val  */
#line 190 "DEF_grammar_yacc.y"
                                                      {}
#line 2663 "DEF_grammar_yacc.c"
    break;

  case 65: /* property_type_and_val: T_Ident  */
#line 191 "DEF_grammar_yacc.y"
                                         {}
#line 2669 "DEF_grammar_yacc.c"
    break;

  case 66: /* property_type_and_val: T_Ident T_String  */
#line 192 "DEF_grammar_yacc.y"
                                              {}
#line 2675 "DEF_grammar_yacc.c"
    break;

  case 67: /* property_type_and_val: T_NAMEMAPSTRING T_Ident  */
#line 193 "DEF_grammar_yacc.y"
                                                 {}
#line 2681 "DEF_grammar_yacc.c"
    break;

  case 68: /* opt_num_val: %empty  */
#line 197 "DEF_grammar_yacc.y"
                                             {}
#line 2687 "DEF_grammar_yacc.c"
    break;

  case 69: /* opt_num_val: T_Number  */
#line 198 "DEF_grammar_yacc.y"
                                          {}
#line 2693 "DEF_grammar_yacc.c"
    break;

  case 70: /* units: T_UNITS T_DISTANCE T_MICRONS T_Number ';'  */
#line 202 "DEF_grammar_yacc.y"
                                                { def_units ((yyvsp[-1].n)); }
#line 2699 "DEF_grammar_yacc.c"
    break;

  case 76: /* orient: T_N  */
#line 226 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_N; }
#line 2705 "DEF_grammar_yacc.c"
    break;

  case 77: /* orient: T_E  */
#line 227 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_E; }
#line 2711 "DEF_grammar_yacc.c"
    break;

  case 78: /* orient: T_S  */
#line 228 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_S; }
#line 2717 "DEF_grammar_yacc.c"
    break;

  case 79: /* orient: T_W  */
#line 229 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_W; }
#line 2723 "DEF_grammar_yacc.c"
    break;

  case 80: /* orient: T_FN  */
#line 230 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_FN; }
#line 2729 "DEF_grammar_yacc.c"
    break;

  case 81: /* orient: T_FE  */
#line 231 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_FE; }
#line 2735 "DEF_grammar_yacc.c"
    break;

  case 82: /* orient: T_FS  */
#line 232 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_FS; }
#line 2741 "DEF_grammar_yacc.c"
    break;

  case 83: /* orient: T_FW  */
#line 233 "DEF_grammar_yacc.y"
            {  (yyval.n) = DEF_FW; }
#line 2747 "DEF_grammar_yacc.c"
    break;

  case 84: /* direction: T_INPUT  */
#line 237 "DEF_grammar_yacc.y"
                 { (yyval.n) = DEF_INPUT; }
#line 2753 "DEF_grammar_yacc.c"
    break;

  case 85: /* direction: T_OUTPUT  */
#line 238 "DEF_grammar_yacc.y"
                 { (yyval.n) = DEF_OUTPUT; }
#line 2759 "DEF_grammar_yacc.c"
    break;

  case 86: /* direction: T_INOUT  */
#line 239 "DEF_grammar_yacc.y"
                 { (yyval.n) = DEF_INOUT; }
#line 2765 "DEF_grammar_yacc.c"
    break;

  case 87: /* direction: T_FEEDTHRU  */
#line 240 "DEF_grammar_yacc.y"
                 { (yyval.n) = DEF_FEEDTHRU; }
#line 2771 "DEF_grammar_yacc.c"
    break;

  case 88: /* die_area: T_DIE_AREA pt pt ';'  */
#line 244 "DEF_grammar_yacc.y"
                             { def_die_area ((yyvsp[-2].pt), (yyvsp[-1].pt)); }
#line 2777 "DEF_grammar_yacc.c"
    break;

  case 96: /* start_pins: T_PINS T_Number ';'  */
#line 273 "DEF_grammar_yacc.y"
                             { def_start_pins((yyvsp[-1].n)); }
#line 2783 "DEF_grammar_yacc.c"
    break;

  case 99: /* pin: pin_start pin_options ';'  */
#line 282 "DEF_grammar_yacc.y"
                                   { def_pin_options (); }
#line 2789 "DEF_grammar_yacc.c"
    break;

  case 100: /* pin_start: '-' T_Ident '+' T_NET T_Ident  */
#line 286 "DEF_grammar_yacc.y"
                                       { def_pin_start((yyvsp[-3].s), (yyvsp[0].s)); }
#line 2795 "DEF_grammar_yacc.c"
    break;

  case 105: /* pin_option: '+' T_DIRECTION direction  */
#line 297 "DEF_grammar_yacc.y"
                                    { def_pin_option_direction ((yyvsp[0].n)); }
#line 2801 "DEF_grammar_yacc.c"
    break;

  case 107: /* pin_option: '+' T_LAYER T_Ident pt pt  */
#line 299 "DEF_grammar_yacc.y"
                                    { def_pin_option_layer ((yyvsp[-2].s), (yyvsp[-1].pt), (yyvsp[0].pt)); }
#line 2807 "DEF_grammar_yacc.c"
    break;

  case 108: /* pin_option: placement_status pt orient  */
#line 300 "DEF_grammar_yacc.y"
                                    { def_pin_option_place ((yyvsp[-1].pt), (yyvsp[0].n)); }
#line 2813 "DEF_grammar_yacc.c"
    break;

  case 109: /* end_pins: T_END T_PINS  */
#line 304 "DEF_grammar_yacc.y"
                      { def_end_pins(); }
#line 2819 "DEF_grammar_yacc.c"
    break;

  case 110: /* row_rule: T_ROW T_Ident T_Ident T_Number T_Number orient T_DO T_Number T_BY T_Number T_STEP T_Number T_Number row_options ';'  */
#line 309 "DEF_grammar_yacc.y"
      { def_row_rule ((yyvsp[-13].s), (yyvsp[-12].s), (yyvsp[-11].n), (yyvsp[-10].n), (yyvsp[-9].n), (yyvsp[-7].n), (yyvsp[-5].n), (yyvsp[-3].n), (yyvsp[-2].n)); }
#line 2825 "DEF_grammar_yacc.c"
    break;

  case 116: /* row_prop: T_Ident property_val  */
#line 327 "DEF_grammar_yacc.y"
                                                  {}
#line 2831 "DEF_grammar_yacc.c"
    break;

  case 117: /* tracks_rule: track_start T_Number T_DO T_Number T_STEP T_Number track_layer_statement ';'  */
#line 332 "DEF_grammar_yacc.y"
      { def_track_rule ((yyvsp[-7].s), (yyvsp[-6].n), (yyvsp[-4].n), (yyvsp[-2].n), (yyvsp[-1].s)); }
#line 2837 "DEF_grammar_yacc.c"
    break;

  case 118: /* track_start: T_TRACKS T_Ident  */
#line 336 "DEF_grammar_yacc.y"
                          { (yyval.s) = (yyvsp[0].s); }
#line 2843 "DEF_grammar_yacc.c"
    break;

  case 119: /* track_layer_statement: %empty  */
#line 340 "DEF_grammar_yacc.y"
                           { (yyval.s) = ""; }
#line 2849 "DEF_grammar_yacc.c"
    break;

  case 120: /* track_layer_statement: T_LAYER track_layers  */
#line 341 "DEF_grammar_yacc.y"
                           { (yyval.s) = (yyvsp[0].s); }
#line 2855 "DEF_grammar_yacc.c"
    break;

  case 121: /* track_layers: %empty  */
#line 345 "DEF_grammar_yacc.y"
                                { (yyval.s) = ""; }
#line 2861 "DEF_grammar_yacc.c"
    break;

  case 122: /* track_layers: track_layer track_layers  */
#line 346 "DEF_grammar_yacc.y"
                                { (yyval.s) = def_track_layers ((yyvsp[-1].s), (yyvsp[0].s)); }
#line 2867 "DEF_grammar_yacc.c"
    break;

  case 123: /* track_layer: T_Ident  */
#line 350 "DEF_grammar_yacc.y"
               { (yyval.s) = (yyvsp[0].s); }
#line 2873 "DEF_grammar_yacc.c"
    break;

  case 128: /* via: T_VIAS T_Number ';'  */
#line 370 "DEF_grammar_yacc.y"
                           { def_start_vias ((yyvsp[-1].n)); }
#line 2879 "DEF_grammar_yacc.c"
    break;

  case 131: /* via_declaration: via_start layer_stmts ';'  */
#line 379 "DEF_grammar_yacc.y"
                                { def_via_end (); }
#line 2885 "DEF_grammar_yacc.c"
    break;

  case 132: /* via_start: '-' T_Ident  */
#line 383 "DEF_grammar_yacc.y"
                   { def_via_start ((yyvsp[0].s)); }
#line 2891 "DEF_grammar_yacc.c"
    break;

  case 135: /* layer_stmt: '+' T_RECT T_Ident pt pt  */
#line 392 "DEF_grammar_yacc.y"
                                 { def_via_stmt_rect ((yyvsp[-2].s), (yyvsp[-1].pt), (yyvsp[0].pt)); }
#line 2897 "DEF_grammar_yacc.c"
    break;

  case 136: /* layer_stmt: '+' T_PATTERNNAME T_Ident  */
#line 393 "DEF_grammar_yacc.y"
                                 { def_via_stmt_pattern ((yyvsp[0].s)); }
#line 2903 "DEF_grammar_yacc.c"
    break;

  case 138: /* pt: '(' T_Number T_Number ')'  */
#line 398 "DEF_grammar_yacc.y"
                                 { (yyval.pt) = def_alloc_pt (   (yyvsp[-2].n)   ,    (yyvsp[-1].n)   ); }
#line 2909 "DEF_grammar_yacc.c"
    break;

  case 139: /* pt: '(' '*' T_Number ')'  */
#line 399 "DEF_grammar_yacc.y"
                                 { (yyval.pt) = def_alloc_pt (HUGE_VAL,    (yyvsp[-1].n)   ); }
#line 2915 "DEF_grammar_yacc.c"
    break;

  case 140: /* pt: '(' T_Number '*' ')'  */
#line 400 "DEF_grammar_yacc.y"
                                 { (yyval.pt) = def_alloc_pt  (  (yyvsp[-2].n)   , HUGE_VAL); }
#line 2921 "DEF_grammar_yacc.c"
    break;

  case 141: /* pt: '(' '*' '*' ')'  */
#line 401 "DEF_grammar_yacc.y"
                                 { (yyval.pt) = def_alloc_pt (HUGE_VAL, HUGE_VAL); }
#line 2927 "DEF_grammar_yacc.c"
    break;

  case 142: /* via_end: T_END T_VIAS  */
#line 405 "DEF_grammar_yacc.y"
                    { def_end_vias (); }
#line 2933 "DEF_grammar_yacc.c"
    break;

  case 148: /* rect_list: pt pt  */
#line 426 "DEF_grammar_yacc.y"
                      { }
#line 2939 "DEF_grammar_yacc.c"
    break;

  case 149: /* rect_list: rect_list pt pt  */
#line 427 "DEF_grammar_yacc.y"
                      { }
#line 2945 "DEF_grammar_yacc.c"
    break;

  case 155: /* region_prop: T_Ident property_val  */
#line 445 "DEF_grammar_yacc.y"
                                                  {}
#line 2951 "DEF_grammar_yacc.c"
    break;

  case 157: /* start_comps: T_COMPS T_Number ';'  */
#line 453 "DEF_grammar_yacc.y"
                                                  { def_start_comps((yyvsp[-1].n)); }
#line 2957 "DEF_grammar_yacc.c"
    break;

  case 161: /* comp_start: '-' T_Ident T_Ident  */
#line 466 "DEF_grammar_yacc.y"
                                                 { def_comp_start((yyvsp[-1].s), (yyvsp[0].s)); }
#line 2963 "DEF_grammar_yacc.c"
    break;

  case 162: /* comp_net_list: %empty  */
#line 470 "DEF_grammar_yacc.y"
                                             {}
#line 2969 "DEF_grammar_yacc.c"
    break;

  case 163: /* comp_net_list: comp_net_list '*'  */
#line 471 "DEF_grammar_yacc.y"
                                               { def_comp_net_list("*"); }
#line 2975 "DEF_grammar_yacc.c"
    break;

  case 164: /* comp_net_list: comp_net_list T_Ident  */
#line 472 "DEF_grammar_yacc.y"
                                                   { def_comp_net_list((yyvsp[0].s)); }
#line 2981 "DEF_grammar_yacc.c"
    break;

  case 179: /* opt_pattern: %empty  */
#line 505 "DEF_grammar_yacc.y"
                                             {}
#line 2987 "DEF_grammar_yacc.c"
    break;

  case 180: /* opt_pattern: T_Ident  */
#line 506 "DEF_grammar_yacc.y"
                                         {}
#line 2993 "DEF_grammar_yacc.c"
    break;

  case 184: /* comp_pnt_list: pt pt  */
#line 519 "DEF_grammar_yacc.y"
                          { }
#line 2999 "DEF_grammar_yacc.c"
    break;

  case 185: /* comp_pnt_list: comp_pnt_list pt pt  */
#line 520 "DEF_grammar_yacc.y"
                          { }
#line 3005 "DEF_grammar_yacc.c"
    break;

  case 189: /* comp_prop: T_Ident property_val  */
#line 533 "DEF_grammar_yacc.y"
                                                  {}
#line 3011 "DEF_grammar_yacc.c"
    break;

  case 192: /* opt_paren: pt  */
#line 545 "DEF_grammar_yacc.y"
                                        {}
#line 3017 "DEF_grammar_yacc.c"
    break;

  case 193: /* opt_paren: T_Number T_Number  */
#line 546 "DEF_grammar_yacc.y"
                                               {}
#line 3023 "DEF_grammar_yacc.c"
    break;

  case 194: /* comp_type: placement_status pt orient  */
#line 550 "DEF_grammar_yacc.y"
                                 { def_comp_type ((yyvsp[-1].pt), (yyvsp[0].n)); }
#line 3029 "DEF_grammar_yacc.c"
    break;

  case 200: /* end_comps: T_END T_COMPS  */
#line 565 "DEF_grammar_yacc.y"
                                               { def_end_comps(); }
#line 3035 "DEF_grammar_yacc.c"
    break;

  case 202: /* start_nets: T_NETS T_Number ';'  */
#line 573 "DEF_grammar_yacc.y"
                                                 { def_start_nets((yyvsp[-1].n)); }
#line 3041 "DEF_grammar_yacc.c"
    break;

  case 206: /* net_start: '-' T_Ident  */
#line 586 "DEF_grammar_yacc.y"
                                             { def_net_start((yyvsp[0].s)); }
#line 3047 "DEF_grammar_yacc.c"
    break;

  case 211: /* net_conn_start: T_Ident T_Ident  */
#line 600 "DEF_grammar_yacc.y"
                                             { def_net_conn_start((yyvsp[-1].s), (yyvsp[0].s)); }
#line 3053 "DEF_grammar_yacc.c"
    break;

  case 212: /* net_conn_start: T_PIN T_Ident  */
#line 601 "DEF_grammar_yacc.y"
                                               { def_net_conn_start("PIN", (yyvsp[0].s)); }
#line 3059 "DEF_grammar_yacc.c"
    break;

  case 215: /* net_conn_opt: '+' T_SYNTHESIZED  */
#line 607 "DEF_grammar_yacc.y"
                                               { def_net_conn_opt_synthesized(); }
#line 3065 "DEF_grammar_yacc.c"
    break;

  case 236: /* net_prop: T_Ident property_val  */
#line 640 "DEF_grammar_yacc.y"
                                                  {}
#line 3071 "DEF_grammar_yacc.c"
    break;

  case 241: /* property_val: T_Number  */
#line 657 "DEF_grammar_yacc.y"
                                          {}
#line 3077 "DEF_grammar_yacc.c"
    break;

  case 242: /* property_val: T_String  */
#line 658 "DEF_grammar_yacc.y"
                                          {}
#line 3083 "DEF_grammar_yacc.c"
    break;

  case 255: /* path_start: T_Ident  */
#line 692 "DEF_grammar_yacc.y"
               { def_path_start ((yyvsp[0].s)); }
#line 3089 "DEF_grammar_yacc.c"
    break;

  case 258: /* path_item: T_Ident  */
#line 701 "DEF_grammar_yacc.y"
                                          { def_path_item_via ((yyvsp[0].s)); }
#line 3095 "DEF_grammar_yacc.c"
    break;

  case 260: /* path_pt: '(' T_Number T_Number ')'  */
#line 706 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (   (yyvsp[-2].n)   ,    (yyvsp[-1].n)   )); }
#line 3101 "DEF_grammar_yacc.c"
    break;

  case 261: /* path_pt: '(' '*' T_Number ')'  */
#line 707 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (HUGE_VAL,    (yyvsp[-1].n)   )); }
#line 3107 "DEF_grammar_yacc.c"
    break;

  case 262: /* path_pt: '(' T_Number '*' ')'  */
#line 708 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (   (yyvsp[-2].n)   , HUGE_VAL)); }
#line 3113 "DEF_grammar_yacc.c"
    break;

  case 263: /* path_pt: '(' '*' '*' ')'  */
#line 709 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (HUGE_VAL, HUGE_VAL)); }
#line 3119 "DEF_grammar_yacc.c"
    break;

  case 264: /* path_pt: '(' T_Number T_Number T_Number ')'  */
#line 710 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (   (yyvsp[-3].n)   ,    (yyvsp[-2].n)   )); }
#line 3125 "DEF_grammar_yacc.c"
    break;

  case 265: /* path_pt: '(' '*' T_Number T_Number ')'  */
#line 711 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (HUGE_VAL,    (yyvsp[-2].n)   )); }
#line 3131 "DEF_grammar_yacc.c"
    break;

  case 266: /* path_pt: '(' T_Number '*' T_Number ')'  */
#line 712 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (   (yyvsp[-3].n)   , HUGE_VAL)); }
#line 3137 "DEF_grammar_yacc.c"
    break;

  case 267: /* path_pt: '(' '*' '*' T_Number ')'  */
#line 713 "DEF_grammar_yacc.y"
                                          { def_path_item_pt (def_alloc_pt (HUGE_VAL, HUGE_VAL)); }
#line 3143 "DEF_grammar_yacc.c"
    break;

  case 273: /* opt_width: %empty  */
#line 728 "DEF_grammar_yacc.y"
                   {}
#line 3149 "DEF_grammar_yacc.c"
    break;

  case 274: /* opt_width: T_Number  */
#line 729 "DEF_grammar_yacc.y"
                   { def_opt_width ((yyvsp[0].n)); }
#line 3155 "DEF_grammar_yacc.c"
    break;

  case 275: /* end_nets: T_END T_NETS  */
#line 733 "DEF_grammar_yacc.y"
                                              { def_end_nets(); }
#line 3161 "DEF_grammar_yacc.c"
    break;

  case 280: /* snet_start: '-' T_Ident  */
#line 750 "DEF_grammar_yacc.y"
                   { def_snet_start((yyvsp[0].s)); }
#line 3167 "DEF_grammar_yacc.c"
    break;

  case 284: /* snet_conn_start: T_Ident T_Ident  */
#line 763 "DEF_grammar_yacc.y"
                       { def_snet_conn_start((yyvsp[-1].s), (yyvsp[0].s)); }
#line 3173 "DEF_grammar_yacc.c"
    break;

  case 285: /* snet_conn_start: T_PIN T_Ident  */
#line 764 "DEF_grammar_yacc.y"
                       { def_snet_conn_start("PIN", (yyvsp[0].s)); }
#line 3179 "DEF_grammar_yacc.c"
    break;

  case 286: /* snet_conn_start: '*' T_Ident  */
#line 765 "DEF_grammar_yacc.y"
                       { def_snet_conn_start("PIN", (yyvsp[0].s)); }
#line 3185 "DEF_grammar_yacc.c"
    break;

  case 289: /* snet_conn_opt: '+' T_SYNTHESIZED  */
#line 771 "DEF_grammar_yacc.y"
                         { def_snet_conn_opt_synthesized(); }
#line 3191 "DEF_grammar_yacc.c"
    break;

  case 314: /* start_snets: T_SNETS T_Number ';'  */
#line 823 "DEF_grammar_yacc.y"
                                                  { def_start_snets((yyvsp[-1].n)); }
#line 3197 "DEF_grammar_yacc.c"
    break;

  case 315: /* end_snets: T_END T_SNETS  */
#line 827 "DEF_grammar_yacc.y"
                                               { def_end_snets(); }
#line 3203 "DEF_grammar_yacc.c"
    break;

  case 324: /* group_member: T_Ident  */
#line 857 "DEF_grammar_yacc.y"
                                 {}
#line 3209 "DEF_grammar_yacc.c"
    break;

  case 331: /* group_region: pt pt  */
#line 873 "DEF_grammar_yacc.y"
                                   {}
#line 3215 "DEF_grammar_yacc.c"
    break;

  case 332: /* group_region: T_Ident  */
#line 874 "DEF_grammar_yacc.y"
                                 {}
#line 3221 "DEF_grammar_yacc.c"
    break;

  case 335: /* group_prop: T_Ident property_val  */
#line 883 "DEF_grammar_yacc.y"
                                          {}
#line 3227 "DEF_grammar_yacc.c"
    break;

  case 376: /* opt_pin: %empty  */
#line 999 "DEF_grammar_yacc.y"
                                     {}
#line 3233 "DEF_grammar_yacc.c"
    break;

  case 377: /* opt_pin: T_Ident  */
#line 1000 "DEF_grammar_yacc.y"
                                 {}
#line 3239 "DEF_grammar_yacc.c"
    break;

  case 389: /* one_floating_inst: T_Ident floating_pins  */
#line 1024 "DEF_grammar_yacc.y"
                                           {}
#line 3245 "DEF_grammar_yacc.c"
    break;

  case 395: /* one_ordered_inst: T_Ident ordered_pins  */
#line 1039 "DEF_grammar_yacc.y"
                                          {}
#line 3251 "DEF_grammar_yacc.c"
    break;

  case 514: /* pin_prop_name_value: T_Ident property_val  */
#line 1341 "DEF_grammar_yacc.y"
                                          {}
#line 3257 "DEF_grammar_yacc.c"
    break;


#line 3261 "DEF_grammar_yacc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1344 "DEF_grammar_yacc.y"


void
yyerror(char *str)
{
  def_parse_error(str);
}

